<!-- Logo -->
<div align="center">
  <img src="./docs/src/assets/logo.png" alt="QuantumToolbox.jl logo" width="150">
</div>

# QuantumToolbox.jl

<!-- Current admin team (in chronological order) -->
[A. Mercurio](https://github.com/albertomercurio)
and [Y.-T. Huang](https://github.com/ytdHuang).

<!-- Table of Badges -->
| **Release**       | [![Release][release-img]][release-url] [![License][license-img]][license-url] [![Downloads-total][download-tot-img]][download-url] [![Downloads-monthly][download-mon-img]][download-url] [![Cite][cite-img]][cite-url] |
|:-----------------:|:-------------|
| **Runtests**      | [![Runtests][runtests-img]][runtests-url] [![Buildkite][buildkite-img]][buildkite-url] [![Coverage][codecov-img]][codecov-url] |
| **Code Quality**  | [![Code Quality][code-quality-img]][code-quality-url] [![Aqua QA][aqua-img]][aqua-url] [![JET][jet-img]][jet-url] [![code style: runic][runic-img]][runic-url] |
| **Documentation** | [![Doc-Stable][docs-stable-img]][docs-stable-url] [![Doc-Dev][docs-develop-img]][docs-develop-url] |
| **Benchmark** | [![Benchmarks][benchmark-img]][benchmark-url] |
| **Community** | [![Zulip][zulip-img]][zulip-url] [![QuTiP-discussion][QuTiP-discussion-img]][QuTiP-discussion-url] |
| **Support** | [![Unitary Fund](https://img.shields.io/badge/Supported%20By-UNITARY%20FUND-brightgreen.svg?style=for-the-badge)](https://unitary.fund) |

[release-img]: https://img.shields.io/github/release/qutip/QuantumToolbox.jl.svg
[release-url]: https://github.com/qutip/QuantumToolbox.jl/releases

[license-img]: https://img.shields.io/badge/license-New%20BSD-blue.svg
[license-url]: https://opensource.org/licenses/BSD-3-Clause

[download-tot-img]: https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Ftotal_downloads%2FQuantumToolbox&query=total_requests&label=Downloads%20%7C%20total
[download-mon-img]: https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FQuantumToolbox&query=total_requests&label=Downloads%20%7C%20monthly
[download-url]: https://juliapkgstats.com/pkg/QuantumToolbox

[cite-img]: https://img.shields.io/badge/cite-Quantum_9%2C_1866_(2025)-blue
[cite-url]: https://doi.org/10.22331/q-2025-09-29-1866

[runtests-img]: https://github.com/qutip/QuantumToolbox.jl/actions/workflows/CI.yml/badge.svg?branch=main
[runtests-url]: https://github.com/qutip/QuantumToolbox.jl/actions/workflows/CI.yml?query=branch%3Amain

[buildkite-img]: https://badge.buildkite.com/e5ecf03a0e6830993924d63263477c7938d3320d2d6151900f.svg?branch=main
[buildkite-url]: https://buildkite.com/julialang/quantumtoolbox-dot-jl

[codecov-img]: https://codecov.io/gh/qutip/QuantumToolbox.jl/branch/main/graph/badge.svg
[codecov-url]: https://codecov.io/gh/qutip/QuantumToolbox.jl

[code-quality-img]: https://github.com/qutip/QuantumToolbox.jl/actions/workflows/Code-Quality.yml/badge.svg 
[code-quality-url]: https://github.com/qutip/QuantumToolbox.jl/actions/workflows/Code-Quality.yml

[aqua-img]: https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg
[aqua-url]: https://github.com/JuliaTesting/Aqua.jl

[jet-img]: https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a
[jet-url]: https://github.com/aviatesk/JET.jl

[runic-img]: https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black
[runic-url]: https://github.com/fredrikekre/Runic.jl

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://qutip.github.io/QuantumToolbox.jl/stable
[docs-develop-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-develop-url]: https://qutip.github.io/QuantumToolbox.jl/dev

[benchmark-img]: https://github.com/qutip/QuantumToolbox.jl/actions/workflows/Benchmarks.yml/badge.svg?branch=main
[benchmark-url]: https://qutip.org/QuantumToolbox.jl/benchmarks/

[zulip-img]: https://img.shields.io/badge/Zulip%20Chat-join-6f73af.svg
[zulip-url]: https://quantumtoolbox-jl.zulipchat.com/#narrow/stream/General

[QuTip-discussion-img]: https://img.shields.io/badge/QuTiP%20discussion%20group-join-6f73af.svg
[QuTip-discussion-url]: https://groups.google.com/g/qutip

## Introduction

[QuantumToolbox.jl](https://github.com/qutip/QuantumToolbox.jl) is a cutting-edge [`Julia`](https://julialang.org/) package designed for quantum physics simulations, closely emulating the popular Python [`QuTiP`](https://github.com/qutip/qutip) package. It uniquely combines the simplicity and power of [`Julia`](https://julialang.org/) with advanced features like GPU acceleration and distributed computing, making simulation of quantum systems more accessible and efficient.

*With this package, moving from Python to Julia for quantum physics simulations has never been easier*, due to the similar syntax and functionalities.

## Features

`QuantumToolbox.jl` is equipped with a robust set of features:

- **Quantum State and Operator Manipulation:** Easily handle quantum states and operators with a rich set of tools, with the same functionalities as `QuTiP`.
- **Dynamical Evolution:** Advanced solvers for time evolution of quantum systems, thanks to the powerful [`DifferentialEquations.jl`](https://github.com/SciML/DifferentialEquations.jl) package.
- **GPU Computing:** Leverage GPU resources for high-performance computing. Simulate quantum dynamics directly on the GPU with the same syntax as the CPU case.
- **Distributed Computing:** Distribute the computation over multiple nodes (e.g., a cluster). For example, you can run hundreds of quantum trajectories in parallel on a cluster, with, again, the same syntax as the simple case. See [here](https://qutip.org/QuantumToolbox.jl/stable/users_guide/cluster) for more information.
- **Differentiable Programming:** Enable gradient-based optimization for quantum algorithms. Compute gradients of quantum dynamics with respect to their parameters using automatic differentiation. See [here](https://qutip.org/QuantumToolbox.jl/stable/users_guide/autodiff) for more information.
- **Easy Extension:** Easily extend the package, taking advantage of the `Julia` language features, like multiple dispatch and metaprogramming.

## Installation
    
> [!NOTE]
> `QuantumToolbox.jl` requires `Julia 1.10+`.

To install `QuantumToolbox.jl`, run the following commands inside Julia's interactive session (also known as REPL):
```julia
using Pkg
Pkg.add("QuantumToolbox")
```
Alternatively, this can also be done in `Julia`'s [Pkg REPL](https://julialang.github.io/Pkg.jl/v1/getting-started/) by pressing the key `]` in the REPL to use the package mode, and then type the following command:
```julia-repl
(1.10) pkg> add QuantumToolbox
```
More information about `Julia`'s package manager can be found at [`Pkg.jl`](https://julialang.github.io/Pkg.jl/v1/).

To load the package and check the version information, use either `QuantumToolbox.versioninfo()` or `QuantumToolbox.about()`, namely
```julia
using QuantumToolbox
QuantumToolbox.versioninfo()
QuantumToolbox.about()
```

## Brief Example

We now provide a brief example to demonstrate the similarity between [`QuantumToolbox.jl`](https://github.com/qutip/QuantumToolbox.jl) and [`QuTiP`](https://github.com/qutip/qutip).

Let's consider a quantum harmonic oscillator with a Hamiltonian given by:

$$
\hat{H} = \omega \hat{a}^\dagger \hat{a}
$$

where $\hat{a}$ and $\hat{a}^\dagger$ are the annihilation and creation operators, respectively. We can define the Hamiltonian as follows:

```julia
using QuantumToolbox

N = 20 # cutoff of the Hilbert space dimension
ω = 1.0 # frequency of the harmonic oscillator

a = destroy(N) # annihilation operator

H = ω * a' * a
```

We now introduce some losses in a thermal environment, described by the Lindblad master equation:

$$
\frac{d \hat{\rho}}{dt} = -i [\hat{H}, \hat{\rho}] + \gamma \mathcal{D}[\hat{a}] \hat{\rho}
$$

where $\hat{\rho}$ is the density matrix, $\gamma$ is the damping rate, and $\mathcal{D}[\hat{a}]$ is the Lindblad dissipator, defined as:

$$
\mathcal{D}[\hat{a}]\hat{\rho} = \hat{a}\hat{\rho}\hat{a}^\dagger - \frac{1}{2}\hat{a}^\dagger\hat{a}\hat{\rho} - \frac{1}{2}\hat{\rho}\hat{a}^\dagger\hat{a}
$$

We now compute the time evolution of the system using the `mesolve` function, starting from the initial state $\ket{\psi (0)} = \ket{3}$:

```julia
γ = 0.1 # damping rate

ψ0 = fock(N, 3) # initial state

tlist = range(0, 10, 100) # time list

c_ops = [sqrt(γ) * a]
e_ops = [a' * a]

sol = mesolve(H, ψ0, tlist, c_ops, e_ops = e_ops)
```

We can extract the expectation value of the number operator $\hat{a}^\dagger \hat{a}$ with the command `sol.expect`, and the states with the command `sol.states`.

### Support for GPU calculation

We can easily pass the computation to the GPU, by simply passing all the `Qobj`s to the GPU:

```julia
using QuantumToolbox
using CUDA
CUDA.allowscalar(false) # Avoid unexpected scalar indexing

a_gpu = cu(destroy(N)) # The only difference in the code is the cu() function

H_gpu = ω * a_gpu' * a_gpu

ψ0_gpu = cu(fock(N, 3))

c_ops = [sqrt(γ) * a_gpu]
e_ops = [a_gpu' * a_gpu]

sol = mesolve(H_gpu, ψ0_gpu, tlist, c_ops, e_ops = e_ops)
```

## Performance comparison with other packages

Here we provide a brief performance comparison between `QuantumToolbox.jl` and other popular quantum physics simulation packages, such as [`QuTiP`](https://github.com/qutip/qutip) (Python), [`dynamiqs`](https://github.com/dynamiqs/dynamiqs) (Python - JAX) and [`QuantumOptics.jl`](https://github.com/qojulia/QuantumOptics.jl) (Julia). We clearly show that `QuantumToolbox.jl` is the fastest package among the four. A detailed code is available [here](https://github.com/albertomercurio/QuantumToolbox.jl-Paper-Figures/blob/main/src/benchmarks/benchmarks.jl).

![](https://raw.githubusercontent.com/albertomercurio/QuantumToolbox.jl-Paper-Figures/refs/heads/main/figures/benchmarks.svg)

## Contributing to QuantumToolbox.jl

You are most welcome to contribute to `QuantumToolbox.jl` development by forking this repository and sending pull requests (PRs), or filing bug reports at the issues page.

Contributors and users for `QuantumToolbox.jl` are invited to [![Zulip][zulip-img]][zulip-url] for questions, development discussions, and community updates.

You can also help out with users' questions, or discuss proposed changes for the entire QuTiP organization in the [![QuTiP-discussion][QuTiP-discussion-img]][QuTiP-discussion-url].

For more information about contribution, including technical advice, please see the [Contributing to Quantum Toolbox in Julia](https://qutip.org/QuantumToolbox.jl/stable/resources/contributing).

## Cite `QuantumToolbox.jl`
If you like `QuantumToolbox.jl`, we would appreciate it if you starred the repository in order to help us increase its visibility. Furthermore, if you find the framework useful in your research, we would be grateful if you could cite our publication [ [Quantum 9, 1866 (2025)](https://doi.org/10.22331/q-2025-09-29-1866)  ] using the following bibtex entry:

```bib
@article{QuantumToolbox.jl2025,
  title = {Quantum{T}oolbox.jl: {A}n efficient {J}ulia framework for simulating open quantum systems},
  author = {Mercurio, Alberto and Huang, Yi-Te and Cai, Li-Xun and Chen, Yueh-Nan and Savona, Vincenzo and Nori, Franco},
  journal = {{Quantum}},
  issn = {2521-327X},
  publisher = {{Verein zur F{\"{o}}rderung des Open Access Publizierens in den Quantenwissenschaften}},
  volume = {9},
  pages = {1866},
  month = sep,
  year = {2025},
  doi = {10.22331/q-2025-09-29-1866},
  url = {https://doi.org/10.22331/q-2025-09-29-1866}
}
```

## Acknowledgements

### Fundings

`QuantumToolbox.jl` is supported by the [Unitary Fund](https://unitary.fund), a grant program for quantum technology projects.

<div align="center">
  <a href="https://unitary.fund" target="about:blank">
    <img src="https://raw.githubusercontent.com/unitaryfund/unitary.fund/refs/heads/main/src/assets/svg/logo.svg" alt="Unitary Fund logo" width="200">
  </a>
</div>

`QuantumToolbox.jl` is partially supported by

<div align="center">
  <a href="https://www.epfl.ch" target="about:blank"><img src="docs/src/assets/org-logo/EPFL.svg" style="margin:5px;" alt="EPFL logo" width="200"></a> 
  <a href="https://www.epfl.ch/research/domains/quantum-center" target="about:blank"><img src="docs/src/assets/org-logo/EPFL-QSE.svg" style="margin:5px;" alt="EPFL QSE logo" width="200"></a> 

  <a href="https://www.ncku.edu.tw" target="about:blank"><img src="docs/src/assets/org-logo/NCKU.png" style="margin:5px;" alt="NCKU logo" width="250"></a> 
  <a href="https://qfort.ncku.edu.tw" target="about:blank"><img src="docs/src/assets/org-logo/QFort.png" style="margin:5px;" alt="QFort logo" width="250"></a> 
  <a href="https://www.nstc.gov.tw" target="about:blank"><img src="docs/src/assets/org-logo/NSTC.png" style="margin:5px;" alt="NSTC logo" width="250"></a> 

  <a href="https://dml.riken.jp" target="about:blank"><img src="docs/src/assets/org-logo/RIKEN.png" style="margin:5px;" alt="RIKEN logo" width="200"></a> 
  <a href="https://rqc.riken.jp" target="about:blank"><img src="docs/src/assets/org-logo/RIKEN-RQC.svg" style="margin:5px;" alt="RIKEN RQC logo" width="200"></a>
  <a href="https://www.jst.go.jp/moonshot" target="about:blank"><img src="docs/src/assets/org-logo/JST-Moonshot.png" style="margin:5px;" alt="JST Moonshot logo" width="200"></a>
</div>

### Other Acknowledgements

We are also grateful to the [Zulip](https://zulip.com) team for providing a free chat service for open-source projects.

<div align="center">
  <a href="https://zulip.com" target="about:blank">
    <img src="https://zulip.com/static/images/logo/zulip-org-logo.svg" alt="Zulip logo" width="200">
  </a>
</div>

# How to build documentation and start Vitepress site locally ?

## Working Directory
All the commands should be run under the root folder of the package: `/path/to/QuantumToolbox.jl/`

The document pages will be generated in the directory: `/path/to/QuantumToolbox.jl/docs/build/1/` (which is ignored by git).

## Method 1: Run with `make` command
Run the following command to instantiate and build the documentation:
> [!NOTE]
> You need to install `Node.js` and `npm` first.
```shell
make docs
```

Run the following command to start a local Vitepress site:
```shell
make vitepress
```
This will start a local Vitepress site of documentation at [http://localhost:5173](http://localhost:5173) in your computer.

## Method 2: Run commands manually

### Build Pkg
Run the following command:
```shell
julia --project=docs -e 'using Pkg; Pkg.develop(PackageSpec(path=pwd())); Pkg.instantiate()'
```
> **_NOTE:_** `Pkg.develop(PackageSpec(path=pwd()))` adds the local version of `QuantumToolbox` as dev-dependency instead of pulling from the registered version.

### Build Documentation
Run the following command:
> [!NOTE]
> You need to install `Node.js` and `npm` first.
```shell
julia --project=docs docs/make.jl
```

### Start a local Vitepress site
Run the following command:
```shell
npm --prefix docs run docs:dev
```
This will start a local Vitepress site of documentation at [http://localhost:5173](http://localhost:5173) in your computer.

#=
Functions for calculating metrics (distance measures) between states and operators.
=#

export fidelity
export tracedist, hilbert_dist, hellinger_dist
export bures_dist, bures_angle

@doc raw"""
    fidelity(ρ::QuantumObject, σ::QuantumObject)

Calculate the fidelity of two [`QuantumObject`](@ref):
``F(\hat{\rho}, \hat{\sigma}) = \textrm{Tr} \sqrt{\sqrt{\hat{\rho}} \hat{\sigma} \sqrt{\hat{\rho}}}``

Here, the definition is from [Nielsen-Chuang2011](@citet). It is the square root of the fidelity defined in [Jozsa1994](@citet).

Note that `ρ` and `σ` must be either [`Ket`](@ref) or [`Operator`](@ref).
"""
function fidelity(ρ::QuantumObject{Operator}, σ::QuantumObject{Operator})
    check_dimensions(ρ, σ)
    sqrt_ρ = sqrt(ρ)
    eigval = abs.(eigvals(sqrt_ρ * σ * sqrt_ρ))
    return sum(sqrt, eigval)
end
fidelity(ρ::QuantumObject{Operator}, ψ::QuantumObject{Ket}) = sqrt(abs(expect(ρ, ψ))) # check_dimensions in expect
fidelity(ψ::QuantumObject{Ket}, σ::QuantumObject{Operator}) = fidelity(σ, ψ)
fidelity(ψ::QuantumObject{Ket}, ϕ::QuantumObject{Ket}) = abs(dot(ψ, ϕ)) # check_dimensions in dot

@doc raw"""
    tracedist(ρ::QuantumObject, σ::QuantumObject)

Calculates the [trace distance](https://en.wikipedia.org/wiki/Trace_distance) between two [`QuantumObject`](@ref):
``T(\hat{\rho}, \hat{\sigma}) = \frac{1}{2} \lVert \hat{\rho} - \hat{\sigma} \rVert_1``

Note that `ρ` and `σ` must be either [`Ket`](@ref) or [`Operator`](@ref).
"""
tracedist(
    ρ::QuantumObject{ObjType1},
    σ::QuantumObject{ObjType2},
) where {ObjType1 <: Union{Ket, Operator}, ObjType2 <: Union{Ket, Operator}} = norm(ket2dm(ρ) - ket2dm(σ), 1) / 2 # check_dimensions in :(-)

@doc raw"""
    hilbert_dist(ρ::QuantumObject, σ::QuantumObject)

Calculates the Hilbert-Schmidt distance between two [`QuantumObject`](@ref):
``D_{HS}(\hat{\rho}, \hat{\sigma}) = \textrm{Tr}\left[\hat{A}^\dagger \hat{A}\right]``, where ``\hat{A} = \hat{\rho} - \hat{\sigma}``.

Note that `ρ` and `σ` must be either [`Ket`](@ref) or [`Operator`](@ref).

# References
- [Vedral-Plenio1998](@citet)
"""
function hilbert_dist(
        ρ::QuantumObject{ObjType1},
        σ::QuantumObject{ObjType2},
    ) where {ObjType1 <: Union{Ket, Operator}, ObjType2 <: Union{Ket, Operator}}
    A = ket2dm(ρ) - ket2dm(σ) # check_dimensions in :(-)
    return tr(A' * A)
end

@doc raw"""
    hellinger_dist(ρ::QuantumObject, σ::QuantumObject)

Calculates the [Hellinger distance](https://en.wikipedia.org/wiki/Hellinger_distance) between two [`QuantumObject`](@ref):
``D_H(\hat{\rho}, \hat{\sigma}) = \sqrt{2 - 2 \textrm{Tr}\left(\sqrt{\hat{\rho}}\sqrt{\hat{\sigma}}\right)}``

Note that `ρ` and `σ` must be either [`Ket`](@ref) or [`Operator`](@ref).

# References
- [Spehner2017](@citet)
"""
function hellinger_dist(
        ρ::QuantumObject{ObjType1},
        σ::QuantumObject{ObjType2},
    ) where {ObjType1 <: Union{Ket, Operator}, ObjType2 <: Union{Ket, Operator}}
    # check dimensions first
    ρ_dm = ket2dm(ρ)
    σ_dm = ket2dm(σ)
    check_dimensions(ρ_dm, σ_dm)

    # Ket (pure state) doesn't need to do square root
    sqrt_ρ = isket(ρ) ? ρ_dm : sqrt(ρ_dm)
    sqrt_σ = isket(σ) ? σ_dm : sqrt(σ_dm)

    # `max` is to avoid numerical instabilities
    # it happens when ρ = σ, sum(eigvals) might be slightly larger than 1
    return sqrt(2.0 * max(0.0, 1.0 - sum(real, eigvals(sqrt_ρ * sqrt_σ))))
end

@doc raw"""
    bures_dist(ρ::QuantumObject, σ::QuantumObject)

Calculate the [Bures distance](https://en.wikipedia.org/wiki/Bures_metric) between two [`QuantumObject`](@ref):
``D_B(\hat{\rho}, \hat{\sigma}) = \sqrt{2 \left(1 - F(\hat{\rho}, \hat{\sigma}) \right)}``

Here, the definition of [`fidelity`](@ref) ``F`` is from [Nielsen-Chuang2011](@citet). It is the square root of the fidelity defined in [Jozsa1994](@citet).

Note that `ρ` and `σ` must be either [`Ket`](@ref) or [`Operator`](@ref).
"""
bures_dist(ρ::QuantumObject, σ::QuantumObject) = sqrt(2 * (1 - fidelity(ρ, σ))) # check_dimensions in fidelity

@doc raw"""
    bures_angle(ρ::QuantumObject, σ::QuantumObject)

Calculate the [Bures angle](https://en.wikipedia.org/wiki/Bures_metric) between two [`QuantumObject`](@ref):
``D_A(\hat{\rho}, \hat{\sigma}) = \arccos\left(F(\hat{\rho}, \hat{\sigma})\right)``

Here, the definition of [`fidelity`](@ref) ``F`` is from [Nielsen-Chuang2011](@citet). It is the square root of the fidelity defined in [Jozsa1994](@citet).

Note that `ρ` and `σ` must be either [`Ket`](@ref) or [`Operator`](@ref).
"""
bures_angle(ρ::QuantumObject, σ::QuantumObject) = acos(fidelity(ρ, σ)) # check_dimensions in fidelity

export smesolveProblem, smesolveEnsembleProblem, smesolve

_smesolve_generate_state(u, dims, ::Val{false}) = QuantumObject(vec2mat(u), type = Operator(), dims = dims)
_smesolve_generate_state(u, dims, ::Val{true}) = QuantumObject(u, type = OperatorKet(), dims = dims)

function _smesolve_update_coeff(u, p, t, op_vec)
    return 2 * real(dot(op_vec, u)) #this is Tr[Sn * ρ + ρ * Sn']
end

_smesolve_ScalarOperator(op_vec) =
    ScalarOperator(one(eltype(op_vec)), (a, u, p, t) -> -_smesolve_update_coeff(u, p, t, op_vec))

@doc raw"""
    smesolveProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject,
        tlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        sc_ops::Union{Nothing,AbstractVector,Tuple,AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        progress_bar::Union{Val,Bool} = Val(true),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    )

Generate the SDEProblem for the Stochastic Master Equation time evolution of an open quantum system. This is defined by the following stochastic differential equation:
    
```math
d \rho (t) = -i [\hat{H}, \rho(t)] dt + \sum_i \mathcal{D}[\hat{C}_i] \rho(t) dt + \sum_n \mathcal{D}[\hat{S}_n] \rho(t) dt + \sum_n \mathcal{H}[\hat{S}_n] \rho(t) dW_n(t),
```

where

```math
\mathcal{D}[\hat{O}] \rho = \hat{O} \rho \hat{O}^\dagger - \frac{1}{2} \{\hat{O}^\dagger \hat{O}, \rho\},
```

is the Lindblad superoperator, and

```math
\mathcal{H}[\hat{O}] \rho = \hat{O} \rho + \rho \hat{O}^\dagger - \mathrm{Tr}[\hat{O} \rho + \rho \hat{O}^\dagger] \rho,
```

Above, ``\hat{C}_i`` represent the collapse operators related to pure dissipation, while ``\hat{S}_n`` are the stochastic collapse operators. The ``dW_n(t)`` term is the real Wiener increment associated to ``\hat{S}_n``. See [Wiseman2009Quantum](@cite) for more details.

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``. It can be either a [`Ket`](@ref), [`Operator`](@ref) or [`OperatorKet`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `c_ops`: List of collapse operators ``\{\hat{C}_i\}_i``. It can be either a `Vector` or a `Tuple`.
- `sc_ops`: List of stochastic collapse operators ``\{\hat{S}_n\}_n``. It can be either a `Vector`, a `Tuple` or a [`AbstractQuantumObject`](@ref). It is recommended to use the last case when only one operator is provided.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: `NullParameters` of parameters to pass to the solver.
- `rng`: Random number generator for reproducibility.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `store_measurement`: Whether to store the measurement expectation values. Default is `Val(false)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-2` and `abstol=1e-2`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

!!! tip "Performance Tip"
    When `sc_ops` contains only a single operator, it is recommended to pass only that operator as the argument. This ensures that the stochastic noise is diagonal, making the simulation faster.

# Returns

- `prob`: The [`TimeEvolutionProblem`](@ref) containing the `SDEProblem` for the Stochastic Master Equation time evolution.
"""
function smesolveProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        sc_ops::Union{Nothing, AbstractVector, Tuple, AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        progress_bar::Union{Val, Bool} = Val(true),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    ) where {StateOpType <: Union{Ket, Operator, OperatorKet}}
    haskey(kwargs, :save_idxs) &&
        throw(ArgumentError("The keyword argument \"save_idxs\" is not supported in QuantumToolbox."))

    isnothing(sc_ops) &&
        throw(ArgumentError("The list of stochastic collapse operators must be provided. Use mesolveProblem instead."))
    sc_ops_list = _make_c_ops_list(sc_ops) # If it is an AbstractQuantumObject but we need to iterate
    sc_ops_isa_Qobj = sc_ops isa AbstractQuantumObject # We can avoid using non-diagonal noise if sc_ops is just an AbstractQuantumObject

    L_evo = _mesolve_make_L_QobjEvo(H, c_ops) + _mesolve_make_L_QobjEvo(nothing, sc_ops_list)
    # Check Hilbert space compatibility using multiplication dimensions

    check_mul_dimensions(L_evo, ψ0)
    dims = L_evo.dimensions

    T = _complex_float_type(Base.promote_eltype(L_evo, ψ0))
    ρ0 = if isoperket(ψ0) # Convert it to dense vector with complex element type
        to_dense(T, copy(ψ0.data))
    else
        to_dense(T, mat2vec(ket2dm(ψ0).data))
    end

    sc_ops_evo_data = map(get_data ∘ QobjEvo, sc_ops_list)

    K = cache_operator(get_data(L_evo), ρ0)

    Id_op = IdentityOperator(get_liouville_size(dims)[1])
    D_l = map(sc_ops_evo_data) do op
        # TODO: # Currently, we are assuming a time-independent MatrixOperator
        # Also, the u state may become non-hermitian, so Tr[Sn * ρ + ρ * Sn'] != real(Tr[Sn * ρ]) / 2
        op_vec = mat2vec(adjoint(op.A))
        return AddedOperator(_spre(op), _spost(op'), _smesolve_ScalarOperator(op_vec) * Id_op)
    end
    D = DiffusionOperator(D_l)

    tlist = _check_tlist(tlist, _float_type(T))

    kwargs2 = _merge_saveat(tlist, e_ops, default_sde_solver_options(T); kwargs...)
    kwargs3 = _merge_tstops(kwargs2, isconstant(K), tlist)
    kwargs4 = _generate_stochastic_kwargs(
        e_ops,
        sc_ops_list,
        makeVal(progress_bar),
        tlist,
        makeVal(store_measurement),
        kwargs3,
        SaveFuncSMESolve,
    )

    tspan = (tlist[1], tlist[end])
    noise = _make_noise(tspan[1], sc_ops, makeVal(store_measurement), rng)
    noise_rate_prototype = sc_ops_isa_Qobj ? nothing : similar(ρ0, length(ρ0), length(sc_ops_list))
    prob = SDEProblem{true}(
        K,
        D,
        ρ0,
        tspan,
        params;
        noise_rate_prototype = noise_rate_prototype,
        noise = noise,
        kwargs4...,
    )

    return TimeEvolutionProblem(prob, tlist, ψ0.type, dims, (isoperket = Val(isoperket(ψ0)),))
end

@doc raw"""
    smesolveEnsembleProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject,
        tlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        sc_ops::Union{Nothing,AbstractVector,Tuple,AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple,Nothing} = nothing,
        progress_bar::Union{Val,Bool} = Val(true),
        store_measurement::Union{Val,Bool} = Val(false),
        kwargs...,
    )

Generate the SDEProblem for the Stochastic Master Equation time evolution of an open quantum system. This is defined by the following stochastic differential equation:
    
```math
d \rho (t) = -i [\hat{H}, \rho(t)] dt + \sum_i \mathcal{D}[\hat{C}_i] \rho(t) dt + \sum_n \mathcal{D}[\hat{S}_n] \rho(t) dt + \sum_n \mathcal{H}[\hat{S}_n] \rho(t) dW_n(t),
```

where

```math
\mathcal{D}[\hat{O}] \rho = \hat{O} \rho \hat{O}^\dagger - \frac{1}{2} \{\hat{O}^\dagger \hat{O}, \rho\},
```

is the Lindblad superoperator, and

```math
\mathcal{H}[\hat{O}] \rho = \hat{O} \rho + \rho \hat{O}^\dagger - \mathrm{Tr}[\hat{O} \rho + \rho \hat{O}^\dagger] \rho,
```

Above, ``\hat{C}_i`` represent the collapse operators related to pure dissipation, while ``\hat{S}_n`` are the stochastic collapse operators. The ``dW_n(t)`` term is the real Wiener increment associated to ``\hat{S}_n``. See [Wiseman2009Quantum](@cite) for more details.

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``. It can be either a [`Ket`](@ref), [`Operator`](@ref) or [`OperatorKet`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `c_ops`: List of collapse operators ``\{\hat{C}_i\}_i``. It can be either a `Vector` or a `Tuple`.
- `sc_ops`: List of stochastic collapse operators ``\{\hat{S}_n\}_n``. It can be either a `Vector`, a `Tuple` or a [`AbstractQuantumObject`](@ref). It is recommended to use the last case when only one operator is provided.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: `NullParameters` of parameters to pass to the solver.
- `rng`: Random number generator for reproducibility.
- `ntraj`: Number of trajectories to use. Default is `500`.
- `ensemblealg`: Ensemble method to use. Default to `EnsembleThreads()`.
- `prob_func`: Function to use for generating the SDEProblem.
- `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `store_measurement`: Whether to store the measurement expectation values. Default is `Val(false)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-2` and `abstol=1e-2`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

!!! tip "Performance Tip"
    When `sc_ops` contains only a single operator, it is recommended to pass only that operator as the argument. This ensures that the stochastic noise is diagonal, making the simulation faster.

# Returns

- `prob`: The [`TimeEvolutionProblem`](@ref) containing the Ensemble `SDEProblem` for the Stochastic Master Equation time evolution.
"""
function smesolveEnsembleProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        sc_ops::Union{Nothing, AbstractVector, Tuple, AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        progress_bar::Union{Val, Bool} = Val(true),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    ) where {StateOpType <: Union{Ket, Operator, OperatorKet}}
    _prob_func =
        isnothing(prob_func) ?
        _ensemble_dispatch_prob_func(
            rng,
            ntraj,
            tlist,
            _stochastic_prob_func;
            sc_ops = sc_ops,
            store_measurement = makeVal(store_measurement),
        ) : prob_func
    _output_func =
        output_func isa Nothing ?
        _ensemble_dispatch_output_func(
            ensemblealg,
            progress_bar,
            ntraj,
            _standard_output_func;
            progr_desc = "[smesolve] ",
        ) : output_func

    prob_sme = smesolveProblem(
        H,
        ψ0,
        tlist,
        c_ops,
        sc_ops;
        e_ops = e_ops,
        params = params,
        rng = rng,
        progress_bar = Val(false),
        store_measurement = makeVal(store_measurement),
        kwargs...,
    )

    ensemble_prob = TimeEvolutionProblem(
        EnsembleProblem(prob_sme, prob_func = _prob_func, output_func = _output_func[1], safetycopy = true),
        prob_sme.times,
        prob_sme.states_type,
        prob_sme.dimensions,
        merge(prob_sme.kwargs, (progr = _output_func[2], channel = _output_func[3])),
    )

    return ensemble_prob
end

@doc raw"""
    smesolve(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject,
        tlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        sc_ops::Union{Nothing,AbstractVector,Tuple,AbstractQuantumObject} = nothing;
        alg::Union{Nothing,AbstractSDEAlgorithm} = nothing,
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple,Nothing} = nothing,
        progress_bar::Union{Val,Bool} = Val(true),
        keep_runs_results::Union{Val,Bool} = Val(false),
        store_measurement::Union{Val,Bool} = Val(false),
        kwargs...,
    )

Stochastic Master Equation time evolution of an open quantum system. This is defined by the following stochastic differential equation:
    
```math
d \rho (t) = -i [\hat{H}, \rho(t)] dt + \sum_i \mathcal{D}[\hat{C}_i] \rho(t) dt + \sum_n \mathcal{D}[\hat{S}_n] \rho(t) dt + \sum_n \mathcal{H}[\hat{S}_n] \rho(t) dW_n(t),
```

where

```math
\mathcal{D}[\hat{O}] \rho = \hat{O} \rho \hat{O}^\dagger - \frac{1}{2} \{\hat{O}^\dagger \hat{O}, \rho\},
```

is the Lindblad superoperator, and

```math
\mathcal{H}[\hat{O}] \rho = \hat{O} \rho + \rho \hat{O}^\dagger - \mathrm{Tr}[\hat{O} \rho + \rho \hat{O}^\dagger] \rho,
```

Above, ``\hat{C}_i`` represent the collapse operators related to pure dissipation, while ``\hat{S}_n`` are the stochastic co operators. The ``dW_n(t)`` term is the real Wiener increment associated to ``\hat{S}_n``. See [Wiseman2009Quantum](@cite) for more details.

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``. It can be either a [`Ket`](@ref), [`Operator`](@ref) or [`OperatorKet`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `c_ops`: List of collapse operators ``\{\hat{C}_i\}_i``. It can be either a `Vector` or a `Tuple`.
- `sc_ops`: List of stochastic collapse operators ``\{\hat{S}_n\}_n``. It can be either a `Vector`, a `Tuple` or a [`AbstractQuantumObject`](@ref). It is recommended to use the last case when only one operator is provided.
- `alg`: The algorithm to use for the stochastic differential equation. Default is `SRIW1()` if `sc_ops` is an [`AbstractQuantumObject`](@ref) (diagonal noise), and `SRA2()` otherwise (non-diagonal noise).
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: `NullParameters` of parameters to pass to the solver.
- `rng`: Random number generator for reproducibility.
- `ntraj`: Number of trajectories to use. Default is `500`.
- `ensemblealg`: Ensemble method to use. Default to `EnsembleThreads()`.
- `prob_func`: Function to use for generating the SDEProblem.
- `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `keep_runs_results`: Whether to save the results of each trajectory. Default to `Val(false)`.
- `store_measurement`: Whether to store the measurement expectation values. Default is `Val(false)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-2` and `abstol=1e-2`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

!!! tip "Performance Tip"
    When `sc_ops` contains only a single operator, it is recommended to pass only that operator as the argument. This ensures that the stochastic noise is diagonal, making the simulation faster.

# Returns

- `sol::TimeEvolutionStochasticSol`: The solution of the time evolution. See [`TimeEvolutionStochasticSol`](@ref).
"""
function smesolve(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        sc_ops::Union{Nothing, AbstractVector, Tuple, AbstractQuantumObject} = nothing;
        alg::Union{Nothing, AbstractSDEAlgorithm} = nothing,
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        progress_bar::Union{Val, Bool} = Val(true),
        keep_runs_results::Union{Val, Bool} = Val(false),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    ) where {StateOpType <: Union{Ket, Operator, OperatorKet}}
    ensemble_prob = smesolveEnsembleProblem(
        H,
        ψ0,
        tlist,
        c_ops,
        sc_ops;
        e_ops = e_ops,
        params = params,
        rng = rng,
        ntraj = ntraj,
        ensemblealg = ensemblealg,
        prob_func = prob_func,
        output_func = output_func,
        progress_bar = progress_bar,
        store_measurement = makeVal(store_measurement),
        kwargs...,
    )

    sc_ops_isa_Qobj = sc_ops isa AbstractQuantumObject # We can avoid using non-diagonal noise if sc_ops is just an AbstractQuantumObject

    if isnothing(alg)
        alg = sc_ops_isa_Qobj ? SRIW1() : SRA2()
    end

    return smesolve(ensemble_prob, alg, ntraj, ensemblealg, makeVal(keep_runs_results))
end

function smesolve(
        ens_prob::TimeEvolutionProblem,
        alg::AbstractSDEAlgorithm = SRA2(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        keep_runs_results = Val(false),
    )
    sol = _ensemble_dispatch_solve(ens_prob, alg, ensemblealg, ntraj)

    _sol_1 = sol[:, 1]
    _expvals_sol_1 = _get_expvals(_sol_1, SaveFuncMESolve)
    _m_expvals_sol_1 = _get_m_expvals(_sol_1, SaveFuncSMESolve)

    dims = ens_prob.dimensions.to
    _expvals_all =
        _expvals_sol_1 isa Nothing ? nothing : map(i -> _get_expvals(sol[:, i], SaveFuncMESolve), eachindex(sol))
    expvals_all = _expvals_all isa Nothing ? nothing : stack(_expvals_all, dims = 2) # Stack on dimension 2 to align with QuTiP

    # stack to transform Vector{Vector{QuantumObject}} -> Matrix{QuantumObject}
    states_all = stack(
        map(i -> _smesolve_generate_state.(sol[:, i].u, Ref(dims), ens_prob.kwargs.isoperket), eachindex(sol)),
        dims = 1,
    )

    _m_expvals =
        _m_expvals_sol_1 isa Nothing ? nothing : map(i -> _get_m_expvals(sol[:, i], SaveFuncSMESolve), eachindex(sol))
    m_expvals = _m_expvals isa Nothing ? nothing : stack(_m_expvals, dims = 2) # Stack on dimension 2 to align with QuTiP

    kwargs = NamedTuple(_sol_1.prob.kwargs) # Convert to NamedTuple for Zygote.jl compatibility

    return TimeEvolutionStochasticSol(
        ntraj,
        ens_prob.times,
        _sol_1.t,
        _store_multitraj_states(states_all, keep_runs_results),
        _store_multitraj_expect(expvals_all, keep_runs_results),
        m_expvals, # Measurement expectation values
        sol.converged,
        _sol_1.alg,
        kwargs.abstol,
        kwargs.reltol,
    )
end

export BlockDiagonalForm, block_diagonal_form

@doc raw"""
    struct BlockDiagonalForm

A type for storing a block-diagonal form of a matrix.

# Fields
- `B::DT`: The block-diagonal matrix. It can be a sparse matrix or a [`QuantumObject`](@ref).
- `P::DT`: The permutation matrix. It can be a sparse matrix or a [`QuantumObject`](@ref).
- `blocks::AbstractVector`: The blocks of the block-diagonal matrix.
- `block_sizes::AbstractVector`: The sizes of the blocks.
"""
struct BlockDiagonalForm{DT, BT <: AbstractVector, BST <: AbstractVector}
    B::DT
    P::DT
    blocks::BT
    block_sizes::BST
end

function block_diagonal_form(A::MT) where {MT <: AbstractSparseMatrix}
    n = LinearAlgebra.checksquare(A)

    G = DiGraph(abs.(A))
    idxs_list = connected_components(G)
    block_sizes = length.(idxs_list)

    P = MT(sparse(1:n, reduce(vcat, idxs_list), ones(n), n, n))

    blocks = map(eachindex(idxs_list)) do i
        m = block_sizes[i]
        idxs = idxs_list[i]
        P_i = MT(sparse(1:m, idxs, ones(m), m, n))
        return P_i * A * P_i'
    end

    B = P * A * P'

    return BlockDiagonalForm(B, P, blocks, block_sizes)
end

@doc raw"""
    block_diagonal_form(A::QuantumObject)

Return the block-diagonal form of a [`QuantumObject`](@ref). This is very useful in the presence of symmetries.

# Arguments
- `A::QuantumObject`: The quantum object.

# Returns
The [`BlockDiagonalForm`](@ref) of `A`.
"""
function block_diagonal_form(A::QuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}}
    bdf = block_diagonal_form(A.data)
    B = QuantumObject(bdf.B, type = A.type, dims = A.dimensions)
    P = QuantumObject(bdf.P, type = A.type, dims = A.dimensions)
    return BlockDiagonalForm(B, P, bdf.blocks, bdf.block_sizes)
end

function benchmark_dsf!(SUITE)
    F = 2
    Δ = 0.25
    κ = 1
    U = 0.01
    J = 0.5
    tlist = LinRange(0, 15, 300)

    N = 5
    a1 = kron(destroy(N), qeye(N))
    a2 = kron(qeye(N), destroy(N))
    function H_dsf(op_list, p)
        Δ = p.Δ
        F = p.F
        U = p.U
        J = p.J
        a1, a2 = op_list
        return Δ * a1' * a1 +
            Δ * a2' * a2 +
            U * a1'^2 * a1^2 +
            U * a2'^2 * a2^2 +
            F * (a1 + a1') +
            J * (a1' * a2 + a1 * a2')
    end
    function c_ops_dsf(op_list, p)
        κ = p.κ
        a1, a2 = op_list
        return [√κ * a1, √κ * a2]
    end
    function e_ops_dsf(op_list, p)
        a1, a2 = op_list
        return [a1' * a1, a2' * a2]
    end
    op_list = [a1, a2]
    ψ0 = kron(fock(N, 0), fock(N, 0))
    α0 = 1.5
    α0_l = [α0, α0]
    dsf_params = (Δ = Δ, F = F, κ = κ, U = U, J = J)

    SUITE["Time Evolution"]["Dynamical Shifted Fock"]["mesolve"] = @benchmarkable dsf_mesolve(
        $H_dsf,
        $ψ0,
        $tlist,
        $c_ops_dsf,
        $op_list,
        $α0_l,
        $dsf_params,
        e_ops = $e_ops_dsf,
        progress_bar = Val(false),
    )

    SUITE["Time Evolution"]["Dynamical Shifted Fock"]["mcsolve"]["Serial"] = @benchmarkable dsf_mcsolve(
        $H_dsf,
        $ψ0,
        $tlist,
        $c_ops_dsf,
        $op_list,
        $α0_l,
        $dsf_params,
        ntraj = 100,
        e_ops = $e_ops_dsf,
        progress_bar = Val(false),
        ensemblealg = EnsembleSerial(),
    )

    SUITE["Time Evolution"]["Dynamical Shifted Fock"]["mcsolve"]["Multithreaded"] = @benchmarkable dsf_mcsolve(
        $H_dsf,
        $ψ0,
        $tlist,
        $c_ops_dsf,
        $op_list,
        $α0_l,
        $dsf_params,
        ntraj = 100,
        e_ops = $e_ops_dsf,
        progress_bar = Val(false),
        ensemblealg = EnsembleThreads(),
    )

    return nothing
end

@testset "Code quality" verbose = true begin
    @testset "Aqua.jl" begin
        Aqua.test_all(QuantumToolbox; ambiguities = false, unbound_args = false)
    end

    @testset "JET.jl" begin
        JET.test_package(QuantumToolbox; target_modules = (QuantumToolbox,), ignore_missing_comparison = true)
    end
end

export lr_mesolve, lr_mesolveProblem, TimeEvolutionLRSol

@doc raw"""
    struct TimeEvolutionLRSol

A structure storing the results and some information from solving low-rank master equation time evolution.

# Fields (Attributes)

- `times::AbstractVector`: The list of time points at which the expectation values are calculated during the evolution.
- `times_states::AbstractVector`: The list of time points at which the states are stored during the evolution.
- `states::Vector{QuantumObject}`: The list of result states corresponding to each time point in `times_states`.
- `expect::Matrix`: The expectation values corresponding to each time point in `times`.
- `fexpect::Matrix`: The function values corresponding to each time point in `times`.
- `retcode`: The return code from the solver.
- `alg`: The algorithm which is used during the solving process.
- `abstol::Real`: The absolute tolerance which is used during the solving process.
- `reltol::Real`: The relative tolerance which is used during the solving process.
- `z::Vector{QuantumObject}`: The `z`` matrix of the low-rank algorithm at each time point.
- `B::Vector{QuantumObject}`: The `B` matrix of the low-rank algorithm at each time point.
"""
struct TimeEvolutionLRSol{
        TT1 <: AbstractVector{<:Real},
        TT2 <: AbstractVector{<:Real},
        TS <: AbstractVector,
        TE <: Matrix{ComplexF64},
        RetT <: Enum,
        AlgT <: AbstractODEAlgorithm,
        TolT <: Real,
        TSZB <: AbstractVector,
        TM <: Vector{<:Integer},
    }
    times::TT1
    times_states::TT2
    states::TS
    expect::TE
    fexpect::TE
    retcode::RetT
    alg::AlgT
    abstol::TolT
    reltol::TolT
    z::TSZB
    B::TSZB
    M::TM
end

lr_mesolve_options_default = (
    alg = DP5(),
    progress = true,
    err_max = 0.0,
    p0 = 0.0,
    atol_inv = 1.0e-4,
    M_max = typemax(Int),
    compute_Si = true,
    is_dynamical = false,
    adj_condition = "variational",
    Δt = 0.0,
)

#=
                   ADDITIONAL FUNCTIONS
=#

select(x::Real, xarr::AbstractArray, retval = false) = retval ? xarr[argmin(abs.(x .- xarr))] : argmin(abs.(x .- xarr))

#=
    _pinv_smooth!(A, T1, T2; atol::Real=0.0, rtol::Real=(eps(real(float(oneunit(T))))*min(size(A)...))*iszero(atol)) where T

Computes the pseudo-inverse of a matrix A, and stores it in T1. If T2 is provided, it is used as a temporary matrix.
The algorithm is based on the SVD decomposition of A, and is taken from the Julia package LinearAlgebra.
The difference with respect to the original function is that the cutoff is done with a smooth function instead of a step function.

# Arguments

  - `A::AbstractMatrix`: The matrix to be inverted.
  - `T1::AbstractMatrix`: The matrix where the pseudo-inverse is stored.
  - `T2::AbstractMatrix`: A temporary matrix.
  - `atol::Real`: The absolute tolerance.
  - `rtol::Real`: The relative tolerance.
=#
function _pinv_smooth!(
        A::AbstractMatrix{T},
        T1::AbstractMatrix{T},
        T2::AbstractMatrix{T};
        atol::Real = 0.0,
        rtol::Real = (eps(real(float(oneunit(T)))) * min(size(A)...)) * iszero(atol),
    ) where {T}
    if isdiag(A)
        idxA = diagind(A)
        diagA = view(A, idxA)
        maxabsA = maximum(abs, diagA)
        λ = max(rtol * maxabsA, atol)
        return Matrix(Diagonal(pinv.(diagA) .* 1 ./ (1 .+ (λ ./ real(diagA)) .^ 6)))
    end

    SVD = svd(A)
    λ = max(rtol * maximum(SVD.S), atol)
    SVD.S .= pinv.(SVD.S) .* 1 ./ (1 .+ (λ ./ SVD.S) .^ 6)
    mul!(T2, Diagonal(SVD.S), SVD.U')
    return mul!(T1, SVD.Vt', T2)
end

#=
    _calculate_expectation!(p,z,B,idx)

Calculates the expectation values and function values of the operators and functions in p.e_ops and p.f_ops, respectively, and stores them in p.expvals and p.funvals.
The function is called by the callback _save_affect_lr_mesolve!.

# Arguments

  - `p::NamedTuple`: The parameters of the problem.
  - `z::AbstractMatrix`: The z matrix of the low-rank algorithm.
  - `B::AbstractMatrix`: The B matrix of the low-rank algorithm.
  - `idx::Integer`: The index of the current time step.
=#
function _calculate_expectation!(p, z, B, idx)
    e_ops = p.e_ops
    f_ops = p.f_ops
    expvals = p.expvals
    funvals = p.funvals
    p.Ml[idx] = p.M

    #Expectation values
    Oz = p.A0
    zOz = p.temp_MM
    @inbounds for (i, e) in enumerate(e_ops)
        mul!(Oz, e, z)
        mul!(zOz, z', Oz)
        expvals[i, idx] = dot(B, zOz)
    end

    #Function values
    return @inbounds for (i, f) in enumerate(f_ops)
        funvals[i, idx] = f(p, z, B)
    end
end

#=
                    SAVING FUNCTIONS
=#

function _periodicsave_func(integrator)
    ip = integrator.p
    ip.u_save .= integrator.u
    ip.scalars[2] = integrator.t
    return u_modified!(integrator, false)
end

_save_control_lr_mesolve(u, t, integrator) = t in integrator.p.times

function _save_affect_lr_mesolve!(integrator)
    ip = integrator.p
    N, M = ip.N, ip.M
    idx = select(integrator.t, ip.times)

    @views z = reshape(integrator.u[1:(N * M)], N, M)
    @views B = reshape(integrator.u[(N * M + 1):end], M, M)
    _calculate_expectation!(ip, z, B, idx)

    if integrator.p.opt.progress
        print("\rProgress: $(round(Int, 100 * idx / length(ip.times)))%")
        flush(stdout)
    end
    return u_modified!(integrator, false)
end

#=
                 CALLBACK FUNCTIONS
=#

#=
    _adjM_condition_ratio(u, t, integrator)

Condition for the dynamical rank adjustment based on the ratio between the smallest and largest eigenvalues of the density matrix.
The spectrum of the density matrix is calculated efficiently using the properties of the SVD decomposition of the matrix.

# Arguments

  - `u::AbstractVector`: The current state of the system.
  - `t::Real`: The current time.
  - `integrator::ODEIntegrator`: The integrator of the problem.
=#
function _adjM_condition_ratio(u, t, integrator)
    ip = integrator.p
    opt = ip.opt
    N, M = ip.N, ip.M

    C = ip.A0
    σ = ip.temp_MM
    @views z = reshape(u[1:(N * M)], N, M)
    @views B = reshape(u[(N * M + 1):end], M, M)
    mul!(C, z, sqrt(B))
    mul!(σ, C', C)
    p = abs.(eigvals(σ))
    err = p[1] / p[end]

    return (err >= opt.err_max && M < N && M < opt.M_max)
end

#=
    _adjM_condition_variational(u, t, integrator)

Condition for the dynamical rank adjustment based on the leakage out of the low-rank manifold.

# Arguments

  - `u::AbstractVector`: The current state of the system.
  - `t::Real`: The current time.
  - `integrator::ODEIntegrator`: The integrator of the problem.
=#
function _adjM_condition_variational(u, t, integrator)
    ip = integrator.p
    opt = ip.opt
    N, M = ip.N, ip.M
    err = abs(ip.scalars[1] * sqrt(ip.M))

    return (err >= opt.err_max && M < N && M < opt.M_max)
end

#=
    _adjM_affect!(integrator)

Affect function for the dynamical rank adjustment. It increases the rank of the low-rank manifold by one, and updates the matrices accordingly.
If Δt>0, it rewinds the integrator to the previous time step.

# Arguments

  - `integrator::ODEIntegrator`: The integrator of the problem.
=#
function _adjM_affect!(integrator)
    ip = integrator.p
    opt = ip.opt
    Δt = opt.Δt
    N, M = ip.N, ip.M

    @views begin
        z = Δt > 0 ? reshape(ip.u_save[1:(N * M)], N, M) : reshape(integrator.u[1:(N * M)], N, M)
        B = Δt > 0 ? reshape(ip.u_save[(N * M + 1):end], M, M) : reshape(integrator.u[(N * M + 1):end], M, M)
        ψ = ip.L_tilde[:, 1]
        normalize!(ψ)

        z = hcat(z, ψ)
        B = cat(B, opt.p0, dims = (1, 2))
        resize!(integrator, length(z) + length(B))
        integrator.u[1:length(z)] .= z[:]
        integrator.u[(length(z) + 1):end] .= B[:]
    end

    integrator.p = merge(
        integrator.p,
        (
            M = ip.M + 1,
            L_tilde = similar(z),
            A0 = similar(z),
            Bi = similar(B),
            L = similar(B),
            temp_MM = similar(B),
            S = similar(B),
            Si = similar(B),
        ),
    )
    mul!(integrator.p.S, z', z)
    !(opt.compute_Si) && (
        integrator.p.Si .=
            _pinv_smooth!(Hermitian(integrator.p.S), integrator.temp_MM, integrator.L, atol = opt.atol_inv)
    )

    return if Δt > 0
        integrator.p = merge(integrator.p, (u_save = copy(integrator.u),))
        t0 = ip.scalars[2]
        reinit!(integrator, integrator.u; t0 = t0, erase_sol = false)

        if length(integrator.sol.t) > 1
            idx = findlast(integrator.sol.t .<= t0)
            resize!(integrator.sol.t, idx)
            resize!(integrator.sol.u, idx)
            integrator.saveiter = idx
        end
    end
end

#=
             DYNAMICAL EVOLUTION EQUATIONS
=#

#=
    dBdz!(du, u, p, t)

Dynamical evolution equations for the low-rank manifold. The function is called by the ODEProblem.

# Arguments

  - `du::AbstractVector`: The derivative of the state vector.
  - `u::AbstractVector`: The state vector.
  - `p::NamedTuple`: The parameters of the problem.
  - `t::Real`: The current time.
=#
function dBdz!(du, u, p, t)
    #NxN
    H, Γ = p.H, p.Γ
    #NxM
    L_tilde, A0 = p.L_tilde, p.A0
    #MxM
    Bi, L, temp_MM, S, Si = p.Bi, p.L, p.temp_MM, p.S, p.Si

    #Get z, B, dz, and dB by reshaping u
    N, M = p.N, p.M
    opt = p.opt

    @views z = reshape(u[1:(N * M)], N, M)
    @views dz = reshape(du[1:(N * M)], N, M)
    @views B = reshape(u[(N * M + 1):end], M, M)
    @views dB = reshape(du[(N * M + 1):end], M, M)

    #Assign A0 and S
    mul!(S, z', z)
    B .= (B + B') / 2
    mul!(temp_MM, S, B)
    B .= B ./ tr(temp_MM)
    mul!(A0, z, B)

    # Calculate inverse
    opt.compute_Si && (Si .= _pinv_smooth!(Hermitian(S), temp_MM, L, atol = opt.atol_inv))
    Bi .= _pinv_smooth!(Hermitian(B), temp_MM, L, atol = opt.atol_inv)

    # Calculate the effective Hamiltonian part of L_tilde
    H(dz, A0, nothing, p.params, t)
    mul!(L_tilde, dz, S)
    mul!(L, dz', z)
    mul!(L_tilde, z, L, +1im, -1im)

    # Calculate the jump operators part of L_tilde
    @inbounds for Γi in Γ
        Γi(dz, z, nothing, p.params, t)
        mul!(L, dz', z)
        mul!(temp_MM, B, L)
        mul!(L_tilde, dz, temp_MM, 1, 1)
    end

    # Calculate L
    mul!(L, z', L_tilde)
    mul!(temp_MM, Si, L)
    p.scalars[1] = real(tr(temp_MM) / M)

    # Calculate dz
    mul!(L_tilde, z, temp_MM, -1, 1) #Ltilde is now (Ltilde - z*Si*L)
    mul!(dB, Si, Bi)
    mul!(dz, L_tilde, dB)

    # Calculate dB
    mul!(dB, temp_MM, Si)
    temp_MM .= Si
    lmul!(p.scalars[1], temp_MM)
    return dB .-= temp_MM
end

#=
                  OUTPUT GENNERATION
=#

get_z(u::AbstractArray{T}, N::Integer, M::Integer) where {T} = reshape(view(u, 1:(M * N)), N, M)

get_B(u::AbstractArray{T}, N::Integer, M::Integer) where {T} = reshape(view(u, (M * N + 1):length(u)), M, M)

#=
                    PROBLEM FORMULATION
=#

@doc raw"""
    lr_mesolveProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        z::AbstractArray{T,2},
        B::AbstractArray{T,2},
        tlist::AbstractVector,
        c_ops::Union{AbstractVector,Tuple}=();
        e_ops::Union{AbstractVector,Tuple}=(),
        f_ops::Union{AbstractVector,Tuple}=(),
        opt::NamedTuple = lr_mesolve_options_default,
        kwargs...,
    )

Formulates the ODEproblem for the low-rank time evolution of the system. The function is called by [`lr_mesolve`](@ref). For more information about the low-rank master equation, see [gravina2024adaptive](@cite).

# Arguments
- `H::Union{AbstractQuantumObject{Operator}, Tuple}`: The Hamiltonian of the system. Time dependent Hamiltonians can be provided as in [`mesolve`](@ref).
- `z::AbstractArray`: The initial z matrix of the low-rank algorithm.
- `B::AbstractArray`: The initial B matrix of the low-rank algorithm.
- `tlist::AbstractVector`: The time steps at which the expectation values and function values are calculated.
- `c_ops::Union{AbstractVector,Tuple}`: The list of the collapse operators.
- `e_ops::Union{AbstractVector,Tuple}`: The list of the operators for which the expectation values are calculated.
- `f_ops::Union{AbstractVector,Tuple}`: The list of the functions for which the function values are calculated.
- `opt::NamedTuple`: The options of the low-rank master equation.
- `kwargs`: Additional keyword arguments.
"""
function lr_mesolveProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        z::AbstractArray{T, 2},
        B::AbstractArray{T, 2},
        tlist::AbstractVector,
        c_ops::Union{AbstractVector, Tuple} = ();
        e_ops::Union{AbstractVector, Tuple} = (),
        f_ops::Union{AbstractVector, Tuple} = (),
        opt::NamedTuple = lr_mesolve_options_default,
        params = nothing,
        kwargs...,
    ) where {T}

    # Formulation of problem
    H_eff_evo = _mcsolve_make_Heff_QobjEvo(H, c_ops)
    H = cache_operator(get_data(H_eff_evo), z)
    c_ops = get_data.(cache_operator.(QuantumObjectEvolution.(c_ops), Ref(z)))

    Hdims = H_eff_evo.dimensions

    e_ops = get_data.(e_ops)

    t_l = _check_tlist(tlist, _float_type(H))

    # Initialization of Arrays
    expvals = Array{ComplexF64}(undef, length(e_ops), length(t_l))
    funvals = Array{ComplexF64}(undef, length(f_ops), length(t_l))
    Ml = Array{Int64}(undef, length(t_l))

    opt = merge(lr_mesolve_options_default, opt)
    if opt.err_max > 0
        opt = merge(opt, (is_dynamical = true,))
    end

    # Initialization of parameters. Scalars represents in order: Tr(S^{-1}L), t0
    p = (
        N = size(z, 1),
        M = size(z, 2),
        H = H,
        Γ = c_ops,
        e_ops = e_ops,
        f_ops = f_ops,
        opt = opt,
        times = t_l,
        expvals = expvals,
        funvals = funvals,
        Ml = Ml,
        L_tilde = similar(z),
        A0 = similar(z),
        Bi = similar(B),
        L = similar(B),
        temp_MM = similar(B),
        S = similar(B),
        Si = similar(B),
        u_save = vcat(vec(z), vec(B)),
        scalars = [0.0, t_l[1]],
        Hdims = Hdims,
        params = params,
    )

    mul!(p.S, z', z)
    p.Si .= pinv(Hermitian(p.S), atol = opt.atol_inv)

    # Initialization of ODEProblem's kwargs
    default_values = (default_ode_solver_options(T)..., saveat = [t_l[end]])
    kwargs2 = merge(default_values, kwargs)

    # Initialization of Callbacks
    if !isempty(e_ops) || !isempty(f_ops)
        _calculate_expectation!(p, z, B, 1)
        cb_save = DiscreteCallback(_save_control_lr_mesolve, _save_affect_lr_mesolve!, save_positions = (false, false))
        kwargs2 = merge(
            kwargs2,
            haskey(kwargs2, :callback) ? Dict(:callback => CallbackSet(cb_save, kwargs2[:callback])) :
                Dict(:callback => cb_save),
        )
    end

    if opt.is_dynamical
        if opt.Δt > 0
            cb_periodicsave =
                PeriodicCallback(_periodicsave_func, opt.Δt, final_affect = true, save_positions = (false, false))
            kwargs2 = merge(
                kwargs2,
                haskey(kwargs2, :callback) ? Dict(:callback => CallbackSet(cb_periodicsave, kwargs2[:callback])) :
                    Dict(:callback => cb_periodicsave),
            )
        end

        if opt.adj_condition == "variational"
            adj_condition_function = _adjM_condition_variational
        elseif opt.adj_condition == "ratio"
            adj_condition_function = _adjM_condition_ratio
        else
            error("adj_condition must be either 'variational' or 'ratio'")
        end
        cb_adjM = DiscreteCallback(adj_condition_function, _adjM_affect!, save_positions = (false, false))
        kwargs2 = merge(
            kwargs2,
            haskey(kwargs2, :callback) ? Dict(:callback => CallbackSet(cb_adjM, kwargs2[:callback])) :
                Dict(:callback => cb_adjM),
        )
    end

    # Initialization of ODEProblem
    tspan = (t_l[1], t_l[end])
    return ODEProblem{true}(dBdz!, p.u_save, tspan, p; kwargs2...)
end

@doc raw"""
    lr_mesolve(
        H::QuantumObject{Operator},
        z::AbstractArray{T,2},
        B::AbstractArray{T,2},
        tlist::AbstractVector,
        c_ops::Union{AbstractVector,Tuple}=();
        e_ops::Union{AbstractVector,Tuple}=(),
        f_ops::Union{AbstractVector,Tuple}=(),
        opt::NamedTuple = lr_mesolve_options_default,
        kwargs...,
    )

Time evolution of an open quantum system using the low-rank master equation. For more information about the low-rank master equation, see [gravina2024adaptive](@cite).

# Arguments
- `H::QuantumObject`: The Hamiltonian of the system.
- `z::AbstractArray`: The initial z matrix of the low-rank algorithm.
- `B::AbstractArray`: The initial B matrix of the low-rank algorithm.
- `tlist::AbstractVector`: The time steps at which the expectation values and function values are calculated.
- `c_ops::Union{AbstractVector,Tuple}`: The list of the collapse operators.
- `e_ops::Union{AbstractVector,Tuple}`: The list of the operators for which the expectation values are calculated.
- `f_ops::Union{AbstractVector,Tuple}`: The list of the functions for which the function values are calculated.
- `opt::NamedTuple`: The options of the low-rank master equation.
- `kwargs`: Additional keyword arguments.
"""
function lr_mesolve(
        H::QuantumObject{Operator},
        z::AbstractArray{T2, 2},
        B::AbstractArray{T2, 2},
        tlist::AbstractVector,
        c_ops::Union{AbstractVector, Tuple} = ();
        e_ops::Union{AbstractVector, Tuple} = (),
        f_ops::Union{AbstractVector, Tuple} = (),
        opt::NamedTuple = lr_mesolve_options_default,
        kwargs...,
    ) where {T2}
    prob = lr_mesolveProblem(H, z, B, tlist, c_ops; e_ops = e_ops, f_ops = f_ops, opt = opt, kwargs...)
    return lr_mesolve(prob; kwargs...)
end

function lr_mesolve(prob::ODEProblem; kwargs...)
    sol = solve(prob, prob.p.opt.alg, tstops = prob.p.times)
    prob.p.opt.progress && print("\n")

    N = prob.p.N
    Ll = length.(sol.u)
    Ml = @. Int((sqrt(N^2 + 4 * Ll) - N) / 2)

    Bt = map(x -> get_B(x[1], N, x[2]), zip(sol.u, Ml))
    zt = map(x -> get_z(x[1], N, x[2]), zip(sol.u, Ml))
    ρt = map(x -> Qobj(x[1] * x[2] * x[1]', type = Operator(), dims = prob.p.Hdims), zip(zt, Bt))

    return TimeEvolutionLRSol(
        prob.p.times,
        sol.t,
        ρt,
        prob.p.expvals,
        prob.p.funvals,
        sol.retcode,
        prob.p.opt.alg,
        sol.prob.kwargs[:abstol],
        sol.prob.kwargs[:reltol],
        zt,
        Bt,
        Ml,
    )
end

@testitem "Bloch-Redfield tensor sec_cutoff" begin
    N = 5
    H = num(N)
    a = destroy(N)
    A_op = a + a'
    spectra(x) = (x > 0) * 0.5
    for sec_cutoff in [0, 0.1, 1, 3, -1]
        R = bloch_redfield_tensor(H, ((A_op, spectra),), [a^2], sec_cutoff = sec_cutoff, fock_basis = Val(true))
        R_eig, evecs =
            bloch_redfield_tensor(H, ((A_op, spectra),), [a^2], sec_cutoff = sec_cutoff, fock_basis = Val(false))
        @test isa(R, QuantumObject)
        @test isa(R_eig, QuantumObject)
        @test isa(evecs, QuantumObject)

        state = rand_dm(N) |> mat2vec
        fock_computed = R * state
        eig_computed = (sprepost(evecs, evecs') * R_eig * sprepost(evecs', evecs)) * state
        @test isapprox(fock_computed, eig_computed, atol = 1.0e-15)
    end
end

@testitem "Compare brterm and Lindblad" begin
    N = 5
    H = num(N)
    a = destroy(N) + destroy(N)^2 / 2
    A_op = a + a'
    spectra(x) = one(x) * (x > 0)

    # this test applies for limited cutoff
    lindblad = lindblad_dissipator(a)
    computation = brterm(H, A_op, spectra, sec_cutoff = 1.5, fock_basis = Val(true))
    @test isapprox(lindblad, computation, atol = 1.0e-15)
end

@testitem "brterm basis" begin
    using SparseArrays: issparse

    N = 5
    H = num(N)
    a = destroy(N) + destroy(N)^2 / 2
    A_op = a + a'
    spectra(x) = one(x) * (x > 0)

    for sec_cutoff in [0, 0.1, 1, 3, -1]
        R = brterm(H, A_op, spectra, sec_cutoff = sec_cutoff, fock_basis = Val(true))
        R_eig, evecs = brterm(H, A_op, spectra, sec_cutoff = sec_cutoff, fock_basis = Val(false))
        @test isa(R, QuantumObject)
        @test isa(R_eig, QuantumObject)
        @test isa(evecs, QuantumObject)
        @test issparse(R_eig)

        state = rand_dm(N) |> mat2vec
        fock_computed = R * state
        eig_computed = (sprepost(evecs, evecs') * R_eig * sprepost(evecs', evecs)) * state
        @test isapprox(fock_computed, eig_computed, atol = 1.0e-15)
    end
end

@testitem "brterm sprectra function" begin
    using SparseArrays: issparse

    f(x) = exp(x) / 10
    function g(x)
        nbar = n_thermal(abs(x), 1)
        if x > 0
            return nbar
        elseif x < 0
            return 1 + nbar
        else
            return 0.0
        end
    end

    spectra_list = (
        x -> one(x) * (x > 0),  # positive frequency filter
        x -> one(x), # no filter
        f, # smooth filter
        g, # thermal field
    )

    N = 5
    H = num(N)
    a = destroy(N) + destroy(N)^2 / 2
    A_op = a + a'
    for spectra in spectra_list
        R = brterm(H, A_op, spectra, sec_cutoff = 0.1, fock_basis = Val(true))
        R_eig, evecs = brterm(H, A_op, spectra, sec_cutoff = 0.1, fock_basis = Val(false))
        @test isa(R, QuantumObject)
        @test isa(R_eig, QuantumObject)
        @test isa(evecs, QuantumObject)
        @test issparse(R_eig)

        state = rand_dm(N) |> mat2vec
        fock_computed = R * state
        eig_computed = (sprepost(evecs, evecs') * R_eig * sprepost(evecs', evecs)) * state
        @test isapprox(fock_computed, eig_computed, atol = 1.0e-15)
    end
end

@testitem "simple qubit system" begin
    pauli_vectors = [sigmax(), sigmay(), sigmaz()]
    γ = 0.25
    spectra(x) = γ * (x >= 0)
    _m_c_op = √γ * sigmam()
    _z_c_op = √γ * sigmaz()
    _x_a_op = (sigmax(), spectra)

    arg_sets =
        (([_m_c_op], nothing, [_x_a_op]), ([_m_c_op], [_m_c_op], nothing), ([_m_c_op, _z_c_op], [_z_c_op], [_x_a_op]))

    δ = 0
    ϵ = 0.5 * 2π
    e_ops = pauli_vectors
    H = δ * 0.5 * sigmax() + ϵ * 0.5 * sigmaz()
    ψ0 = unit(2basis(2, 0) + basis(2, 1))
    tlist = LinRange(0, 10, 100)

    for (me_c_ops, brme_c_ops, brme_a_ops) in arg_sets
        me = mesolve(H, ψ0, tlist, me_c_ops, e_ops = e_ops, progress_bar = Val(false))
        brme = brmesolve(H, ψ0, tlist, brme_a_ops, brme_c_ops, e_ops = e_ops, progress_bar = Val(false))

        # mesolve and brmesolve should be exactly the same for these cases
        @test me.expect == brme.expect
    end
end

#=
Entropy related functions and some entanglement measures.
=#

export entropy_vn, entropy_relative, entropy_linear, entropy_mutual, entropy_conditional
export entanglement, concurrence

@doc raw"""
    entropy_vn(ρ::QuantumObject; base::Int=0, tol::Real=1e-15)

Calculates the [Von Neumann entropy](https://en.wikipedia.org/wiki/Von_Neumann_entropy) ``S = - \textrm{Tr} \left[ \hat{\rho} \log \left( \hat{\rho} \right) \right]``, where ``\hat{\rho}`` is the density matrix of the system.

# Notes

- `ρ` is the quantum state, can be either a [`Ket`](@ref) or an [`Operator`](@ref).
- `base` specifies the base of the logarithm to use, and when using the default value `0`, the natural logarithm is used.
- `tol` describes the absolute tolerance for detecting the zero-valued eigenvalues of the density matrix ``\hat{\rho}``.

# Examples

Pure state:
```jldoctest
julia> ψ = fock(2,0)

Quantum Object:   type=Ket()   dims=([2], [1])   size=(2,)
2-element Vector{ComplexF64}:
 1.0 + 0.0im
 0.0 + 0.0im

julia> entropy_vn(ψ, base=2)
-0.0
```

Mixed state:
```jldoctest
julia> ρ = maximally_mixed_dm(2)

Quantum Object:   type=Operator()   dims=([2], [2])   size=(2, 2)   ishermitian=true
2×2 Matrix{ComplexF64}:
 0.5+0.0im  0.0+0.0im
 0.0+0.0im  0.5+0.0im

julia> entropy_vn(ρ, base=2)
1.0
```
"""
function entropy_vn(ρ::QuantumObject{ObjType}; base::Int = 0, tol::Real = 1.0e-15) where {ObjType <: Union{Ket, Operator}}
    T = eltype(ρ)
    vals = eigenenergies(ket2dm(ρ))
    indexes = findall(x -> abs(x) > tol, vals)
    length(indexes) == 0 && return zero(real(T))
    nzvals = vals[indexes]
    logvals = base != 0 ? log.(base, Complex.(nzvals)) : log.(Complex.(nzvals))
    return -real(mapreduce(*, +, nzvals, logvals))
end

@doc raw"""
    entropy_relative(ρ::QuantumObject, σ::QuantumObject; base::Int=0, tol::Real=1e-15)

Calculates the [quantum relative entropy](https://en.wikipedia.org/wiki/Quantum_relative_entropy) of ``\hat{\rho}`` with respect to ``\hat{\sigma}``: ``D(\hat{\rho}||\hat{\sigma}) = \textrm{Tr} \left[ \hat{\rho} \log \left( \hat{\rho} \right) \right] - \textrm{Tr} \left[ \hat{\rho} \log \left( \hat{\sigma} \right) \right]``.

# Notes

- `ρ` is a quantum state, can be either a [`Ket`](@ref) or an [`Operator`](@ref).
- `σ` is a quantum state, can be either a [`Ket`](@ref) or an [`Operator`](@ref).
- `base` specifies the base of the logarithm to use, and when using the default value `0`, the natural logarithm is used.
- `tol` describes the absolute tolerance for detecting the zero-valued eigenvalues of the density matrix ``\hat{\rho}``.

# References
- [Nielsen-Chuang2011; section 11.3.1, page 511](@citet)
"""
function entropy_relative(
        ρ::QuantumObject{ObjType1},
        σ::QuantumObject{ObjType2};
        base::Int = 0,
        tol::Real = 1.0e-15,
    ) where {ObjType1 <: Union{Ket, Operator}, ObjType2 <: Union{Ket, Operator}}
    ρ_dm = ket2dm(ρ)
    σ_dm = ket2dm(σ)
    check_dimensions(ρ_dm, σ_dm)

    # the logic of this code follows the detail given in the reference of the docstring
    # consider the eigen decompositions:
    #   ρ = Σ_i p_i |i⟩⟨i|
    #   σ = Σ_j q_j |j⟩⟨j|
    ρ_result = eigenstates(ρ_dm)
    σ_result = eigenstates(σ_dm)

    # make sure all p_i and q_j are real
    any(p_i -> imag(p_i) >= tol, ρ_result.values) && error("Input `ρ` has non-real eigenvalues.")
    any(q_j -> imag(q_j) >= tol, σ_result.values) && error("Input `σ` has non-real eigenvalues.")
    p = real(ρ_result.values)
    q = real(σ_result.values)
    Uρ = ρ_result.vectors
    Uσ = σ_result.vectors

    # create P_ij matrix (all elements should be real)
    P = abs2.(Uρ' * Uσ) # this equals to ⟨i|j⟩⟨j|i⟩

    # return +∞ if kernel of σ overlaps with support of ρ, i.e., supp(p) ⊆ supp(q)
    # That is, if σ is not full rank, S(ρ||σ) = +∞
    # note that, one special case is that S(ρ||σ) = 0 (if ρ == σ)
    ((transpose(p .>= tol) * (P .>= tol) * (q .< tol)) == 0) || return Inf

    # Avoid -∞ from log(0), these terms will be multiplied by zero later anyway
    replace!(q_j -> abs(q_j) < tol ? 1 : q_j, q)
    p_vals = filter(p_i -> abs(p_i) >= tol, p)

    if base == 0
        log_p = log.(p_vals)
        log_q = log.(q)
    else
        log_p = log.(base, p_vals)
        log_q = log.(base, q)
    end

    # the relative entropy is guaranteed to be ≥ 0
    # so we calculate the value to 0 to avoid small violations of the lower bound.
    return max(0.0, dot(p_vals, log_p) - dot(p, P, log_q)) # use 0.0 to make sure it always return value in Float-type
end

@doc raw"""
    entropy_linear(ρ::QuantumObject)

Calculates the quantum linear entropy ``S_L = 1 - \textrm{Tr} \left[ \hat{\rho}^2 \right]``, where ``\hat{\rho}`` is the density matrix of the system.

Note that `ρ` can be either a [`Ket`](@ref) or an [`Operator`](@ref).
"""
entropy_linear(ρ::QuantumObject{ObjType}) where {ObjType <: Union{Ket, Operator}} = 1.0 - purity(ρ) # use 1.0 to make sure it always return value in Float-type

@doc raw"""
    entropy_mutual(ρAB::QuantumObject, selA, selB; kwargs...)

Calculates the [quantum mutual information](https://en.wikipedia.org/wiki/Quantum_mutual_information) ``I(A:B) = S(\hat{\rho}_A) + S(\hat{\rho}_B) - S(\hat{\rho}_{AB})`` between subsystems ``A`` and ``B``.

Here, ``S`` is the [Von Neumann entropy](https://en.wikipedia.org/wiki/Von_Neumann_entropy), ``\hat{\rho}_{AB}`` is the density matrix of the entire system, ``\hat{\rho}_A = \textrm{Tr}_B \left[ \hat{\rho}_{AB} \right]``, ``\hat{\rho}_B = \textrm{Tr}_A \left[ \hat{\rho}_{AB} \right]``.

# Notes

- `ρAB` can be either a [`Ket`](@ref) or an [`Operator`](@ref).
- `selA` specifies the indices of the sub-system `A` in `ρAB.dimensions`. See also [`ptrace`](@ref).
- `selB` specifies the indices of the sub-system `B` in `ρAB.dimensions`. See also [`ptrace`](@ref).
- `kwargs` are the keyword arguments for calculating Von Neumann entropy. See also [`entropy_vn`](@ref).
"""
function entropy_mutual(
        ρAB::QuantumObject{ObjType, <:AbstractDimensions{N, N}},
        selA::Union{Int, AbstractVector{Int}, Tuple},
        selB::Union{Int, AbstractVector{Int}, Tuple};
        kwargs...,
    ) where {ObjType <: Union{Ket, Operator}, N}
    # check if selA and selB matches the dimensions of ρAB
    sel_A_B = (selA..., selB...)
    (length(sel_A_B) != N) && throw(
        ArgumentError(
            "The indices in `selA = $(selA)` and `selB = $(selB)` does not match the given QuantumObject which has $N sub-systems",
        ),
    )
    allunique(sel_A_B) || throw(ArgumentError("Duplicate selection indices in `selA = $(selA)` and `selB = $(selB)`"))

    ρA = ptrace(ρAB, selA)
    ρB = ptrace(ρAB, selB)
    return entropy_vn(ρA; kwargs...) + entropy_vn(ρB; kwargs...) - entropy_vn(ρAB; kwargs...)
end

@doc raw"""
    entropy_conditional(ρAB::QuantumObject, selB; kwargs...)

Calculates the [conditional quantum entropy](https://en.wikipedia.org/wiki/Conditional_quantum_entropy) with respect to sub-system ``B``: ``S(A|B) = S(\hat{\rho}_{AB}) - S(\hat{\rho}_{B})``.

Here, ``S`` is the [Von Neumann entropy](https://en.wikipedia.org/wiki/Von_Neumann_entropy), ``\hat{\rho}_{AB}`` is the density matrix of the entire system, and ``\hat{\rho}_B = \textrm{Tr}_A \left[ \hat{\rho}_{AB} \right]``.

# Notes

- `ρAB` can be either a [`Ket`](@ref) or an [`Operator`](@ref).
- `selB` specifies the indices of the sub-system `B` in `ρAB.dimensions`. See also [`ptrace`](@ref).
- `kwargs` are the keyword arguments for calculating Von Neumann entropy. See also [`entropy_vn`](@ref).
"""
entropy_conditional(
    ρAB::QuantumObject{ObjType, <:AbstractDimensions{N, N}},
    selB::Union{Int, AbstractVector{Int}, Tuple};
    kwargs...,
) where {ObjType <: Union{Ket, Operator}, N} = entropy_vn(ρAB; kwargs...) - entropy_vn(ptrace(ρAB, selB); kwargs...)

@doc raw"""
    entanglement(ρ::QuantumObject, sel; kwargs...)

Calculates the [entanglement entropy](https://en.wikipedia.org/wiki/Entropy_of_entanglement) by doing the partial trace of `ρ`, selecting only the dimensions with the indices contained in the `sel` vector, and then use the Von Neumann entropy [`entropy_vn`](@ref).

# Notes

- `ρ` can be either a [`Ket`](@ref) or an [`Operator`](@ref). But should be a pure state.
- `sel` specifies the indices of the remaining sub-system. See also [`ptrace`](@ref).
- `kwargs` are the keyword arguments for calculating Von Neumann entropy. See also [`entropy_vn`](@ref).
"""
function entanglement(
        ρ::QuantumObject{OpType},
        sel::Union{Int, AbstractVector{Int}, Tuple},
        kwargs...,
    ) where {OpType <: Union{Ket, Operator}}
    p = purity(ρ)
    isapprox(p, 1; atol = 1.0e-2) || throw(
        ArgumentError(
            "The entanglement entropy only works for normalized pure state, the purity of the given state: $(p) ≉ 1",
        ),
    )

    ρ_tr = ptrace(ρ, sel)
    val = entropy_vn(ρ_tr; kwargs...)
    return max(0.0, val)  # use 0.0 to make sure it always return value in Float-type
end

@doc raw"""
    concurrence(ρ::QuantumObject)

Calculate the [concurrence](https://en.wikipedia.org/wiki/Concurrence_(quantum_computing)) for a two-qubit state.

# Notes

- `ρ` can be either a [`Ket`](@ref) or an [`Operator`](@ref).

# References

- [Hill-Wootters1997](@citet)
"""
function concurrence(ρ::QuantumObject{OpType}) where {OpType <: Union{Ket, Operator}}
    two_qubit_dims = (HilbertSpace(2), HilbertSpace(2))
    is_two_qubit = (isket(ρ) || isendomorphism(ρ.dimensions)) && ρ.dimensions.to == two_qubit_dims
    is_two_qubit || throw(
        ArgumentError(
            "The `concurrence` only works for a two-qubit state, invalid dims = $(_get_dims_string(ρ.dimensions)).",
        ),
    )

    ρ_mat = ket2dm(ρ).data
    σyσy = tensor(sigmay(), sigmay()).data
    ρ_tilde = σyσy * conj(ρ_mat) * σyσy

    # We use the alternative way to calculate concurrence (more efficient):
    # calculate the square root of each eigenvalue (in decreasing order) of the non-Hermitian matrix ρ * ρ̃.
    # Note: we use abs() to avoid problems with sqrt for very small negative numbers due to numerical precision.
    λ = sqrt.(abs.(real(eigvals(ρ_mat * ρ_tilde; sortby = x -> -real(x)))))

    return max(zero(λ[1]), λ[1] - λ[2] - λ[3] - λ[4])
end

#= 
All boolean functions for checking the data or type in `QuantumObject`
=#

export isket, isbra, isoper, isoperbra, isoperket, issuper
export isunitary

@doc raw"""
    isbra(A)

Checks if the [`QuantumObject`](@ref) `A` is a [`Bra`](@ref). Default case returns `false` for any other inputs.
"""
isbra(A::QuantumObject{Bra}) = true
isbra(A) = false # default case

@doc raw"""
    isket(A)

Checks if the [`QuantumObject`](@ref) `A` is a [`Ket`](@ref). Default case returns `false` for any other inputs.
"""
isket(A::QuantumObject{Ket}) = true
isket(A) = false # default case

@doc raw"""
    isoper(A)

Checks if the [`AbstractQuantumObject`](@ref) `A` is a [`Operator`](@ref). Default case returns `false` for any other inputs.
"""
isoper(A::AbstractQuantumObject{Operator}) = true
isoper(A) = false # default case

@doc raw"""
    isoperbra(A)

Checks if the [`QuantumObject`](@ref) `A` is a [`OperatorBra`](@ref). Default case returns `false` for any other inputs.
"""
isoperbra(A::QuantumObject{OperatorBra}) = true
isoperbra(A) = false # default case

@doc raw"""
    isoperket(A)

Checks if the [`QuantumObject`](@ref) `A` is a [`OperatorKet`](@ref). Default case returns `false` for any other inputs.
"""
isoperket(A::QuantumObject{OperatorKet}) = true
isoperket(A) = false # default case

@doc raw"""
    issuper(A)

Checks if the [`AbstractQuantumObject`](@ref) `A` is a [`SuperOperator`](@ref). Default case returns `false` for any other inputs.
"""
issuper(A::AbstractQuantumObject{<:SuperOperatorType}) = true
issuper(A) = false # default case

@doc raw"""
    ishermitian(A::AbstractQuantumObject)
    isherm(A::AbstractQuantumObject)

Test whether the [`AbstractQuantumObject`](@ref) is Hermitian.

!!! note
    `isherm` is a synonym of `ishermitian`.
"""
LinearAlgebra.ishermitian(A::AbstractQuantumObject) = ishermitian(A.data)

@doc raw"""
    issymmetric(A::AbstractQuantumObject)

Test whether the [`AbstractQuantumObject`](@ref) is symmetric.
"""
LinearAlgebra.issymmetric(A::AbstractQuantumObject) = issymmetric(A.data)

@doc raw"""
    isposdef(A::AbstractQuantumObject)

Test whether the [`AbstractQuantumObject`](@ref) is positive definite (and Hermitian) by trying to perform a Cholesky factorization of `A`.
"""
LinearAlgebra.isposdef(A::AbstractQuantumObject) = isposdef(A.data)

@doc raw"""
    isunitary(U::QuantumObject; kwargs...)

Test whether the [`QuantumObject`](@ref) ``U`` is unitary operator. This function calls `Base.isapprox` to test whether ``U U^\dagger`` is approximately equal to identity operator.

Note that all the keyword arguments will be passed to `Base.isapprox`.
"""
isunitary(U::QuantumObject; kwargs...) = isoper(U) ? isapprox(U.data * U.data', Eye(size(U, 1)); kwargs...) : false

@doc raw"""
    issparse(U::QuantumObject)

Test whether the [`QuantumObject`](@ref) ``U`` is sparse operator. This function calls `SparseArrays.issparse`.
"""
SparseArrays.issparse(A::AbstractQuantumObject) = issparse(A.data)

@doc raw"""
    SciMLOperators.iscached(A::AbstractQuantumObject)

Test whether the [`AbstractQuantumObject`](@ref) `A` has preallocated caches for inplace evaluations.
"""
SciMLOperators.iscached(A::AbstractQuantumObject) = iscached(A.data)

@doc raw"""
    SciMLOperators.isconstant(A::AbstractQuantumObject)

Test whether the [`AbstractQuantumObject`](@ref) `A` is constant in time. For a [`QuantumObject`](@ref), this function returns `true`, while for a [`QuantumObjectEvolution`](@ref), this function returns `true` if the operator is constant in time.
"""
SciMLOperators.isconstant(A::AbstractQuantumObject) = isconstant(A.data)

function benchmark_timeevolution!(SUITE)
    ωc = 1
    ωq = 1
    g = 0.1
    ωd = 0.99
    F = 0.07

    Δc = ωc - ωd
    Δq = ωq - ωd

    # Operators definition
    N = 20 # cutoff for the cavity Hilbert space
    a = tensor(destroy(N), qeye(2))
    σm = tensor(qeye(N), sigmam())
    σz = tensor(qeye(N), sigmaz())

    # Hamiltonian
    H = Δc * a' * a + Δq * σz / 2 + g * (a' * σm + a * σm') + F * (a + a')

    e_ops = [a' * a, σz]

    # Initial state
    ψ0 = tensor(coherent(N, 0), fock(2, 1))

    ## sesolve ##

    tlist = range(0, 2π * 10 / g, 1000)

    SUITE["Time Evolution"]["time-independent"]["sesolve"] =
        @benchmarkable sesolve($H, $ψ0, $tlist, e_ops = $e_ops, progress_bar = Val(false))

    ## mesolve ##

    nth = 0.01
    γ = 0.05
    c_ops = [sqrt(γ * (nth + 1)) * a, sqrt(γ * nth) * a', sqrt(γ) * σm]

    tlist = range(0, 10 / γ, 100)

    SUITE["Time Evolution"]["time-independent"]["mesolve"] =
        @benchmarkable mesolve($H, $ψ0, $tlist, $c_ops, e_ops = $e_ops, progress_bar = Val(false))

    ## mcsolve ##

    SUITE["Time Evolution"]["time-independent"]["mcsolve"]["Serial"] = @benchmarkable mcsolve(
        $H,
        $ψ0,
        $tlist,
        $c_ops,
        ntraj = 100,
        e_ops = $e_ops,
        progress_bar = Val(false),
        ensemblealg = EnsembleSerial(),
    )
    SUITE["Time Evolution"]["time-independent"]["mcsolve"]["Multithreaded"] = @benchmarkable mcsolve(
        $H,
        $ψ0,
        $tlist,
        $c_ops,
        ntraj = 100,
        e_ops = $e_ops,
        progress_bar = Val(false),
        ensemblealg = EnsembleThreads(),
    )

    ## Time-dependent evolutions ##

    # Hamiltonian in the lab frame (without drive frame transformation)
    H_lab = ωc * a' * a + ωq / 2 * σz + g * (a' * σm + a * σm')

    # Define time-dependent drive terms
    coef1(p, t) = p.F * exp(1im * p.ωd * t)
    coef2(p, t) = p.F * exp(-1im * p.ωd * t)
    p = (F = F, ωd = ωd)

    # Time-dependent Hamiltonian as tuple (lab frame with drive)
    H_td = (H_lab, (a, coef1), (a', coef2))

    # Time-dependent Hamiltonian as QobjEvo
    H_td2 = QobjEvo(H_td)

    # Time-dependent Liouvillian
    L_td = liouvillian(H_td2)

    tlist_td = range(0, 10 / γ, 100)

    ## sesolve (time-dependent) ##

    SUITE["Time Evolution"]["time-dependent"]["sesolve"]["Tuple"] =
        @benchmarkable sesolve($H_td, $ψ0, $tlist_td, e_ops = $e_ops, progress_bar = Val(false), params = $p)

    SUITE["Time Evolution"]["time-dependent"]["sesolve"]["QobjEvo"] =
        @benchmarkable sesolve($H_td2, $ψ0, $tlist_td, e_ops = $e_ops, progress_bar = Val(false), params = $p)

    ## mesolve (time-dependent) ##

    SUITE["Time Evolution"]["time-dependent"]["mesolve"]["Tuple"] =
        @benchmarkable mesolve($H_td, $ψ0, $tlist_td, $c_ops, e_ops = $e_ops, progress_bar = Val(false), params = $p)

    SUITE["Time Evolution"]["time-dependent"]["mesolve"]["QobjEvo"] =
        @benchmarkable mesolve($H_td2, $ψ0, $tlist_td, $c_ops, e_ops = $e_ops, progress_bar = Val(false), params = $p)

    SUITE["Time Evolution"]["time-dependent"]["mesolve"]["Liouvillian"] =
        @benchmarkable mesolve($L_td, $ψ0, $tlist_td, $c_ops, e_ops = $e_ops, progress_bar = Val(false), params = $p)

    ## mcsolve (time-dependent) ##

    SUITE["Time Evolution"]["time-dependent"]["mcsolve"]["Tuple"]["Serial"] = @benchmarkable mcsolve(
        $H_td,
        $ψ0,
        $tlist_td,
        $c_ops,
        ntraj = 100,
        e_ops = $e_ops,
        progress_bar = Val(false),
        params = $p,
        ensemblealg = EnsembleSerial(),
    )

    SUITE["Time Evolution"]["time-dependent"]["mcsolve"]["Tuple"]["Multithreaded"] = @benchmarkable mcsolve(
        $H_td,
        $ψ0,
        $tlist_td,
        $c_ops,
        ntraj = 100,
        e_ops = $e_ops,
        progress_bar = Val(false),
        params = $p,
        ensemblealg = EnsembleThreads(),
    )

    SUITE["Time Evolution"]["time-dependent"]["mcsolve"]["QobjEvo"]["Serial"] = @benchmarkable mcsolve(
        $H_td2,
        $ψ0,
        $tlist_td,
        $c_ops,
        ntraj = 100,
        e_ops = $e_ops,
        progress_bar = Val(false),
        params = $p,
        ensemblealg = EnsembleSerial(),
    )

    SUITE["Time Evolution"]["time-dependent"]["mcsolve"]["QobjEvo"]["Multithreaded"] = @benchmarkable mcsolve(
        $H_td2,
        $ψ0,
        $tlist_td,
        $c_ops,
        ntraj = 100,
        e_ops = $e_ops,
        progress_bar = Val(false),
        params = $p,
        ensemblealg = EnsembleThreads(),
    )

    return nothing
end

@testitem "Wigner" begin
    α = 0.5 + 0.8im
    ψ = coherent(30, α)
    ρ = to_sparse(ket2dm(ψ), 1.0e-6)
    xvec = LinRange(-3, 3, 300)
    yvec = LinRange(-3, 3, 300)

    wig = wigner(ψ, xvec, yvec, method = WignerLaguerre(tol = 1.0e-6))
    wig2 = wigner(ρ, xvec, yvec, method = WignerLaguerre(parallel = false))
    wig3 = wigner(ρ, xvec, yvec, method = WignerLaguerre(parallel = true))
    wig4 = wigner(ψ, xvec, yvec, method = WignerClenshaw())

    @test sqrt(sum(abs.(wig2 .- wig)) / length(wig)) < 1.0e-3
    @test sqrt(sum(abs.(wig3 .- wig)) / length(wig)) < 1.0e-3
    @test sqrt(sum(abs.(wig4 .- wig)) / length(wig)) < 1.0e-3

    X, Y = meshgrid(xvec, yvec)
    wig_tmp1 = gaussian.(xvec / √2, real(α), 1 / 2)
    wig_tmp2 = gaussian.(yvec / √2, imag(α), 1 / 2)
    wig2 = maximum(wig) * reshape(kron(wig_tmp1, wig_tmp2), 300, 300)

    @test sqrt(sum(abs.(wig2 .- wig)) / length(wig)) < 0.1

    @testset "Type Inference (wigner)" begin
        @inferred wigner(ψ, xvec, yvec, method = WignerLaguerre(tol = 1.0e-6))
        @inferred wigner(ρ, xvec, yvec, method = WignerLaguerre(parallel = false))
        @inferred wigner(ρ, xvec, yvec, method = WignerLaguerre(parallel = true))
        @inferred wigner(ψ, xvec, yvec, method = WignerClenshaw())
    end
end

export dfd_mesolve, dsf_mesolve, dsf_mcsolve

### DYNAMICAL FOCK DIMENSION ###

function _reduce_dims(
        QO::AbstractArray{T},
        dims::Union{SVector{N, DT}, MVector{N, DT}},
        sel,
        reduce,
    ) where {T, N, DT <: Integer}
    n_d = length(dims)
    dims_new = zero(dims)
    dims_new[sel] .= reduce
    @. dims_new = dims - dims_new

    if n_d == 1
        ρmat = similar(QO, dims_new[1], dims_new[1])
        copyto!(ρmat, view(QO, 1:dims_new[1], 1:dims_new[1]))
    else
        ρmat = reshape(QO, reverse(vcat(dims, dims))...)
        ρmat2 = similar(QO, reverse(vcat(dims_new, dims_new))...)
        copyto!(ρmat2, view(ρmat, reverse!(repeat([1:n for n in dims_new], 2))...))
        ρmat = reshape(ρmat2, prod(dims_new), prod(dims_new))
    end

    return ρmat
end

function _increase_dims(
        QO::AbstractArray{T},
        dims::Union{SVector{N, DT}, MVector{N, DT}},
        sel,
        increase,
    ) where {T, N, DT <: Integer}
    n_d = length(dims)
    dims_new = MVector(zero(dims)) # Mutable SVector
    dims_new[sel] .= increase
    @. dims_new = dims + dims_new

    if n_d == 1
        ρmat = similar(QO, dims_new[1], dims_new[1])
        fill!(selectdim(ρmat, 1, (dims[1] + 1):dims_new[1]), 0)
        fill!(selectdim(ρmat, 2, (dims[1] + 1):dims_new[1]), 0)
        copyto!(view(ρmat, 1:dims[1], 1:dims[1]), QO)
    else
        ρmat2 = similar(QO, reverse(vcat(dims_new, dims_new))...)
        ρmat = reshape(QO, reverse(vcat(dims, dims))...)
        for i in eachindex(sel)
            fill!(selectdim(ρmat2, n_d - sel[i] + 1, (dims[sel[i]] + 1):dims_new[sel[i]]), 0)
            fill!(selectdim(ρmat2, 2 * n_d - sel[i] + 1, (dims[sel[i]] + 1):dims_new[sel[i]]), 0)
        end
        copyto!(view(ρmat2, reverse!(repeat([1:n for n in dims], 2))...), ρmat)
        ρmat = reshape(ρmat2, prod(dims_new), prod(dims_new))
    end

    return ρmat
end

_dfd_set_pillow(dim)::Int = min(max(round(Int, 0.02 * dim), 1), 20)

function _DFDIncreaseReduceCondition(u, t, integrator)
    params = integrator.p
    dim_list = params.dim_list
    maxdims = params.maxdims
    tol_list = params.tol_list
    increase_list = params.increase_list
    reduce_list = params.reduce_list
    pillow_list = params.pillow_list
    dfd_ρt_cache = params.dfd_ρt_cache

    # I need this cache because I can't reshape directly the integrator.u
    copyto!(dfd_ρt_cache, u)

    @inbounds for i in eachindex(dim_list)
        maxdim_i = maxdims[i]
        dim_i = dim_list[i]
        pillow_i = pillow_list[i]
        if dim_i < maxdim_i && dim_i > 2 && maxdim_i != 0
            ρi = _ptrace_oper(vec2mat(dfd_ρt_cache), dim_list, SVector(i))[1]
            @views res = norm(ρi[diagind(ρi)[(end - pillow_i):end]], 1) * sqrt(dim_i) / pillow_i
            if res > tol_list[i]
                increase_list[i] = true
            elseif res < tol_list[i] * 1.0e-2 && dim_i > 3
                reduce_list[i] = true
            end
        end
    end
    return any(increase_list) || any(reduce_list)
end

function _DFDIncreaseReduceAffect!(integrator)
    params = integrator.p
    H = params.H_fun
    c_ops = params.c_ops_fun
    e_ops = params.e_ops_fun
    dim_list = params.dim_list
    increase_list = params.increase_list
    reduce_list = params.reduce_list
    pillow_list = params.pillow_list
    dim_list_evo_times = params.dim_list_evo_times
    dim_list_evo = params.dim_list_evo
    dfd_ρt_cache = params.dfd_ρt_cache
    dfd_params = params.dfd_params

    ρt = vec2mat(dfd_ρt_cache)

    pillow_increase = pillow_list[increase_list] # TODO: This returns a Vector. Find a way to return an SVector or NTuple
    pillow_reduce = pillow_list[reduce_list]
    dim_increase = findall(increase_list) # TODO: This returns a Vector. Find a way to return an SVector or NTuple
    dim_reduce = findall(reduce_list)

    if length(dim_increase) > 0
        ρt = _increase_dims(ρt, dim_list, dim_increase, pillow_increase)
        dim_list[dim_increase] .+= pillow_increase
    end
    if length(dim_reduce) > 0
        ρt = _reduce_dims(ρt, dim_list, dim_reduce, pillow_reduce)
        dim_list[dim_reduce] .-= pillow_reduce
    end

    @. pillow_list = _dfd_set_pillow(dim_list)
    fill!(increase_list, false)
    fill!(reduce_list, false)
    push!(dim_list_evo_times, integrator.t)
    push!(dim_list_evo, copy(dim_list))

    e_ops2 = map(op -> mat2vec(get_data(op)'), e_ops(dim_list, dfd_params))
    L = liouvillian(H(dim_list, dfd_params), c_ops(dim_list, dfd_params)).data

    resize!(integrator, size(L, 1))
    copyto!(integrator.u, mat2vec(ρt))
    # By doing this, we are assuming that the system is time-independent and f is a MatrixOperator
    integrator.f = ODEFunction{true, FullSpecialize}(MatrixOperator(L))
    integrator.p = merge(params, (dfd_ρt_cache = similar(integrator.u),))
    _mesolve_callbacks_new_e_ops!(integrator, e_ops2)

    return nothing
end

function dfd_mesolveProblem(
        H::Function,
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Function,
        maxdims::Vector{T2},
        dfd_params::NamedTuple = NamedTuple();
        e_ops::Function = (dim_list) -> Vector{Vector{eltype(ψ0)}}([]),
        params::NamedTuple = NamedTuple(),
        tol_list::Vector{<:Number} = fill(1.0e-8, length(maxdims)),
        kwargs...,
    ) where {T2 <: Integer, StateOpType <: Union{Ket, Operator}}
    length(ψ0.dimensions.to) != length(maxdims) &&
        throw(DimensionMismatch("`dim_list` and `maxdims` do not have the same dimension."))

    # Use the "to" dimensions for the dim_list (Hilbert space dimensions)
    dim_list = MVector(dimensions_to_dims(ψ0.dimensions.to))
    H₀ = H(dim_list, dfd_params)
    c_ops₀ = c_ops(dim_list, dfd_params)
    e_ops₀ = e_ops(dim_list, dfd_params)

    dim_list_evo_times = [0.0]
    dim_list_evo = [copy(dim_list)]
    reduce_list = MVector(ntuple(i -> false, Val(length(dim_list))))
    increase_list = MVector(ntuple(i -> false, Val(length(dim_list))))
    pillow_list = _dfd_set_pillow.(dim_list)

    params2 = merge(
        params,
        (
            H_fun = H,
            c_ops_fun = c_ops,
            e_ops_fun = e_ops,
            dim_list = dim_list,
            maxdims = maxdims,
            tol_list = tol_list,
            reduce_list = reduce_list,
            increase_list = increase_list,
            pillow_list = pillow_list,
            dim_list_evo_times = dim_list_evo_times,
            dim_list_evo = dim_list_evo,
            dfd_ρt_cache = similar(ψ0.data, length(ψ0.data)^2),
            dfd_params = dfd_params,
        ),
    )

    cb_dfd = DiscreteCallback(_DFDIncreaseReduceCondition, _DFDIncreaseReduceAffect!, save_positions = (false, false))
    kwargs2 = (; kwargs...)
    kwargs2 =
        haskey(kwargs2, :callback) ? merge(kwargs2, (callback = CallbackSet(cb_dfd, kwargs2.callback),)) :
        merge(kwargs2, (callback = cb_dfd,))

    return mesolveProblem(H₀, ψ0, tlist, c_ops₀; e_ops = e_ops₀, params = params2, kwargs2...)
end

@doc raw"""
    dfd_mesolve(H::Function, ψ0::QuantumObject,
        tlist::AbstractVector, c_ops::Function, maxdims::AbstractVector,
        dfd_params::NamedTuple=NamedTuple();
        alg::AbstractODEAlgorithm=DP5(),
        e_ops::Function=(dim_list) -> Vector{Vector{T1}}([]),
        params::NamedTuple=NamedTuple(),
        tol_list::Vector{<:Number}=fill(1e-8, length(maxdims)),
        kwargs...)

Time evolution of an open quantum system using master equation, dynamically changing the dimension of the Hilbert subspaces.

# Notes
- For more details about `alg` please refer to [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/)
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)
"""
function dfd_mesolve(
        H::Function,
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Function,
        maxdims::Vector{T2},
        dfd_params::NamedTuple = NamedTuple();
        alg::AbstractODEAlgorithm = DP5(),
        e_ops::Function = (dim_list) -> Vector{Vector{eltype(ψ0)}}([]),
        params::NamedTuple = NamedTuple(),
        tol_list::Vector{<:Number} = fill(1.0e-8, length(maxdims)),
        kwargs...,
    ) where {T2 <: Integer, StateOpType <: Union{Ket, Operator}}
    dfd_prob = dfd_mesolveProblem(
        H,
        ψ0,
        tlist,
        c_ops,
        maxdims,
        dfd_params;
        e_ops = e_ops,
        params = params,
        tol_list = tol_list,
        kwargs...,
    )

    sol = solve(dfd_prob.prob, alg)

    ρt = map(eachindex(sol.t)) do i
        idx = findfirst(>=(sol.t[i]), sol.prob.p.dim_list_evo_times)
        idx2 = isnothing(idx) ? length(sol.prob.p.dim_list_evo) : (idx == 1 ? 1 : idx - 1)

        return QuantumObject(vec2mat(sol.u[i]), type = Operator(), dims = sol.prob.p.dim_list_evo[idx2])
    end

    return TimeEvolutionSol(
        dfd_prob.times,
        sol.t,
        ρt,
        _get_expvals(sol, SaveFuncMESolve),
        sol.retcode,
        sol.alg,
        sol.prob.kwargs[:abstol],
        sol.prob.kwargs[:reltol],
    )
end

# Dynamical Shifted Fock mesolve

function _DSF_mesolve_Condition(u, t, integrator)
    internal_params = integrator.p
    op_l_vec = internal_params.op_l_vec
    δα_list = internal_params.δα_list

    condition = false
    @inbounds for i in eachindex(δα_list)
        op_vec = op_l_vec[i]
        δα = δα_list[i]
        Δα = dot(op_vec, u)
        if δα < abs(Δα)
            condition = true
        end
    end
    return condition
end

function _DSF_mesolve_Affect!(integrator)
    internal_params = integrator.p
    op_list = internal_params.op_list
    op_l_vec = internal_params.op_l_vec
    αt_list = internal_params.αt_list
    δα_list = internal_params.δα_list
    H = internal_params.H_fun
    c_ops = internal_params.c_ops_fun
    e_ops = internal_params.e_ops_fun
    dsf_cache = internal_params.dsf_cache
    dsf_params = internal_params.dsf_params
    expv_cache = internal_params.expv_cache
    dsf_displace_cache_full = internal_params.dsf_displace_cache_full

    op_l_length = length(op_list)

    for i in eachindex(op_list)
        # op = op_list[i]
        op_vec = op_l_vec[i]
        αt = αt_list[i]
        δα = δα_list[i]
        Δα = dot(op_vec, integrator.u)

        if δα < abs(Δα)
            # Dᵢ = exp(Δα*op' - conj(Δα)*op)
            # copyto!(dsf_cache, integrator.u)
            # mul!(integrator.u, sprepost(Dᵢ', Dᵢ).data, dsf_cache)

            # This is equivalent to the code above, assuming that transpose(op) = adjoint(op)
            # Aᵢ = kron(Δα * op.data - conj(Δα) * op.data', dsf_identity) + kron(dsf_identity, conj(Δα) * op.data - Δα * op.data')

            # @. dsf_displace_cache_full[i] = Δα * dsf_displace_cache_left[i] - conj(Δα) * dsf_displace_cache_left_dag[i] + conj(Δα) * dsf_displace_cache_right[i] - Δα * dsf_displace_cache_right_dag[i]
            # Aᵢ = dsf_displace_cache_full[i]

            # dsf_cache .= integrator.u
            # arnoldi!(expv_cache, Aᵢ, dsf_cache)
            # expv!(integrator.u, expv_cache, one(αt), dsf_cache)

            dsf_displace_cache_full.ops[i].λ.val = Δα
            dsf_displace_cache_full.ops[i + op_l_length].λ.val = -conj(Δα)
            dsf_displace_cache_full.ops[i + 2 * op_l_length].λ.val = conj(Δα)
            dsf_displace_cache_full.ops[i + 3 * op_l_length].λ.val = -Δα

            αt_list[i] += Δα
        else
            dsf_displace_cache_full.ops[i].λ.val = 0
            dsf_displace_cache_full.ops[i + op_l_length].λ.val = 0
            dsf_displace_cache_full.ops[i + 2 * op_l_length].λ.val = 0
            dsf_displace_cache_full.ops[i + 3 * op_l_length].λ.val = 0
        end
    end

    copyto!(dsf_cache, integrator.u)
    arnoldi!(expv_cache, dsf_displace_cache_full, dsf_cache)
    expv!(integrator.u, expv_cache, 1, dsf_cache)

    op_l2 = op_list .+ αt_list
    e_ops2 = e_ops(op_l2, dsf_params)
    _mesolve_callbacks_new_e_ops!(integrator, [_generate_mesolve_e_op(op) for op in e_ops2])

    # By doing this, we are assuming that all the arguments of ODEFunction are the default ones
    integrator.f =
        ODEFunction{true, FullSpecialize}(_mesolve_make_L_QobjEvo(H(op_l2, dsf_params), c_ops(op_l2, dsf_params)).data)
    return u_modified!(integrator, true)
end

function dsf_mesolveProblem(
        H::Function,
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Function,
        op_list::Union{AbstractVector, Tuple},
        α0_l::Vector{<:Number} = zeros(length(op_list)),
        dsf_params::NamedTuple = NamedTuple();
        e_ops::Function = (op_list, p) -> (),
        params::NamedTuple = NamedTuple(),
        δα_list::Vector{<:Real} = fill(0.2, length(op_list)),
        krylov_dim::Int = max(6, min(10, cld(length(ket2dm(ψ0).data), 4))),
        kwargs...,
    ) where {StateOpType <: Union{Ket, Operator}}
    op_list = deepcopy(op_list)
    H₀ = H(op_list .+ α0_l, dsf_params)
    c_ops₀ = c_ops(op_list .+ α0_l, dsf_params)
    e_ops₀ = e_ops(op_list .+ α0_l, dsf_params)

    T = eltype(ψ0)

    αt_list = convert(Vector{T}, α0_l)
    op_l_vec = map(op -> mat2vec(get_data(op)'), op_list)

    dsf_identity = Eye(get_size(H₀.dimensions)[1])

    # Create the Krylov subspace just for initialize
    expv_cache = arnoldi(kron(dsf_identity, dsf_identity), mat2vec(ket2dm(ψ0).data), krylov_dim)

    dsf_displace_cache_left = sum(op -> ScalarOperator(one(T)) * MatrixOperator(kron(op.data, dsf_identity)), op_list)
    dsf_displace_cache_left_dag =
        sum(op -> ScalarOperator(one(T)) * MatrixOperator(kron(sparse(op.data'), dsf_identity)), op_list)
    dsf_displace_cache_right = sum(op -> ScalarOperator(one(T)) * MatrixOperator(kron(dsf_identity, op.data)), op_list)
    dsf_displace_cache_right_dag =
        sum(op -> ScalarOperator(one(T)) * MatrixOperator(kron(dsf_identity, sparse(op.data'))), op_list)
    dsf_displace_cache_full =
        dsf_displace_cache_left + dsf_displace_cache_left_dag + dsf_displace_cache_right + dsf_displace_cache_right_dag

    params2 = merge(
        params,
        (
            H_fun = H,
            c_ops_fun = c_ops,
            e_ops_fun = e_ops,
            op_list = op_list,
            op_l_vec = op_l_vec,
            αt_list = αt_list,
            δα_list = δα_list,
            dsf_cache = similar(ψ0.data, length(ψ0.data)^2),
            expv_cache = expv_cache,
            dsf_params = dsf_params,
            dsf_displace_cache_full = dsf_displace_cache_full,
        ),
    )

    cb_dsf = DiscreteCallback(_DSF_mesolve_Condition, _DSF_mesolve_Affect!, save_positions = (false, false))
    kwargs2 = (; kwargs...)
    kwargs2 =
        haskey(kwargs2, :callback) ? merge(kwargs2, (callback = CallbackSet(cb_dsf, kwargs2.callback),)) :
        merge(kwargs2, (callback = cb_dsf,))

    return mesolveProblem(H₀, ψ0, tlist, c_ops₀; e_ops = e_ops₀, params = params2, kwargs2...)
end

@doc raw"""
    dsf_mesolve(H::Function,
        ψ0::QuantumObject,
        tlist::AbstractVector, c_ops::Function,
        op_list::Vector{TOl},
        α0_l::Vector{<:Number}=zeros(length(op_list)),
        dsf_params::NamedTuple=NamedTuple();
        alg::AbstractODEAlgorithm=DP5(),
        e_ops::Function=(op_list,p) -> Vector{TOl}([]),
        params::NamedTuple=NamedTuple(),
        δα_list::Vector{<:Number}=fill(0.2, length(op_list)),
        krylov_dim::Int=max(6, min(10, cld(length(ket2dm(ψ0).data), 4))),
        kwargs...)

Time evolution of an open quantum system using master equation and the Dynamical Shifted Fock algorithm.

# Notes
- For more details about `alg` please refer to [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/)
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)
"""
function dsf_mesolve(
        H::Function,
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        c_ops::Function,
        op_list::Union{AbstractVector, Tuple},
        α0_l::Vector{<:Number} = zeros(length(op_list)),
        dsf_params::NamedTuple = NamedTuple();
        alg::AbstractODEAlgorithm = DP5(),
        e_ops::Function = (op_list, p) -> (),
        params::NamedTuple = NamedTuple(),
        δα_list::Vector{<:Real} = fill(0.2, length(op_list)),
        krylov_dim::Int = max(6, min(10, cld(length(ket2dm(ψ0).data), 4))),
        kwargs...,
    ) where {StateOpType <: Union{Ket, Operator}}
    dsf_prob = dsf_mesolveProblem(
        H,
        ψ0,
        tlist,
        c_ops,
        op_list,
        α0_l,
        dsf_params;
        e_ops = e_ops,
        params = params,
        δα_list = δα_list,
        krylov_dim = krylov_dim,
        kwargs...,
    )

    return mesolve(dsf_prob, alg)
end

function dsf_mesolve(
        H::Function,
        ψ0::QuantumObject{StateOpType},
        tlist::AbstractVector,
        op_list::Union{AbstractVector, Tuple},
        α0_l::Vector{<:Number} = zeros(length(op_list)),
        dsf_params::NamedTuple = NamedTuple();
        alg::AbstractODEAlgorithm = DP5(),
        e_ops::Function = (op_list, p) -> (),
        params::NamedTuple = NamedTuple(),
        δα_list::Vector{<:Real} = fill(0.2, length(op_list)),
        krylov_dim::Int = max(6, min(10, cld(length(ket2dm(ψ0).data), 4))),
        kwargs...,
    ) where {StateOpType <: Union{Ket, Operator}}
    c_ops = op_list -> ()
    return dsf_mesolve(
        H,
        ψ0,
        tlist,
        c_ops,
        op_list,
        α0_l,
        dsf_params;
        alg = alg,
        e_ops = e_ops,
        params = params,
        δα_list = δα_list,
        krylov_dim = krylov_dim,
        kwargs...,
    )
end

# Dynamical Shifted Fock mcsolve

function _DSF_mcsolve_Condition(u, t, integrator)
    params = integrator.p
    op_list = params.op_list
    δα_list = params.δα_list

    ψt = u

    condition = false
    @inbounds for i in eachindex(op_list)
        op = op_list[i]
        δα = δα_list[i]
        Δα = dot(ψt, op.data, ψt) / dot(ψt, ψt)
        if δα < abs(Δα)
            condition = true
        end
    end
    return condition
end

function _DSF_mcsolve_Affect!(integrator)
    params = integrator.p
    op_list = params.op_list
    αt_list = params.αt_list
    δα_list = params.δα_list
    H = params.H_fun
    c_ops = params.c_ops_fun
    e_ops = params.e_ops_fun
    ψt = params.dsf_cache1
    dsf_cache = params.dsf_cache2
    expv_cache = params.expv_cache
    dsf_params = params.dsf_params
    dsf_displace_cache_full = params.dsf_displace_cache_full

    # e_ops0 = params.e_ops
    # c_ops0 = params.c_ops

    e_ops0 = _get_e_ops(integrator, SaveFuncMCSolve)
    c_ops0, c_ops0_herm = _mcsolve_get_c_ops(integrator)

    copyto!(ψt, integrator.u)
    normalize!(ψt)

    op_l_length = length(op_list)

    for i in eachindex(op_list)
        op = op_list[i]
        αt = αt_list[i]
        δα = δα_list[i]
        Δα = dot(ψt, op.data, ψt)

        if δα < abs(Δα)
            # Dᵢ = exp(Δα*op' - conj(Δα)*op)
            # dsf_cache .= integrator.u
            # mul!(integrator.u, Dᵢ.data', dsf_cache)

            # Aᵢ = -Δα*op.data' + conj(Δα)*op.data
            # dsf_cache .= integrator.u
            # arnoldi!(expv_cache, Aᵢ, dsf_cache)
            # expv!(integrator.u, expv_cache, one(αt), dsf_cache)

            dsf_displace_cache_full.ops[i].λ.val = conj(Δα)
            dsf_displace_cache_full.ops[i + op_l_length].λ.val = -Δα

            αt_list[i] += Δα
        else
            dsf_displace_cache_full.ops[i].λ.val = 0
            dsf_displace_cache_full.ops[i + op_l_length].λ.val = 0
        end
    end

    copyto!(dsf_cache, integrator.u)
    arnoldi!(expv_cache, dsf_displace_cache_full, dsf_cache)
    expv!(integrator.u, expv_cache, 1, dsf_cache)

    op_l2 = op_list .+ αt_list
    e_ops2 = e_ops(op_l2, dsf_params)
    c_ops2 = c_ops(op_l2, dsf_params)

    ## By copying the data, we are assuming that the variables are Vectors and not Tuple
    @. e_ops0 = get_data(e_ops2)
    @. c_ops0 = get_data(c_ops2)
    c_ops0_herm .= map(op -> op' * op, c_ops0)

    H_nh = convert(eltype(ψt), 0.5im) * sum(c_ops0_herm)
    # By doing this, we are assuming that the system is time-independent and f is a ScaledOperator
    # of the form -1im * (H - H_nh)
    copyto!(integrator.f.f.L, H(op_l2, dsf_params).data - H_nh)
    return u_modified!(integrator, true)
end

function _dsf_mcsolve_prob_func(prob, i, repeat)
    params = prob.p

    prm = merge(
        params,
        (
            αt_list = copy(params.αt_list),
            dsf_cache1 = similar(params.dsf_cache1),
            dsf_cache2 = similar(params.dsf_cache2),
            expv_cache = copy(params.expv_cache),
            dsf_displace_cache_full = deepcopy(params.dsf_displace_cache_full), # This brutally copies also the MatrixOperators, and it is inefficient.
        ),
    )

    f = deepcopy(prob.f.f)

    # We need to deepcopy the callbacks because they contain the c_ops and e_ops, which are modified in the affect function. They also contain all the cache variables needed for mcsolve.
    cb = deepcopy(prob.kwargs[:callback])

    return remake(prob, f = f, p = prm, callback = cb)
end

function dsf_mcsolveEnsembleProblem(
        H::Function,
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Function,
        op_list::Union{AbstractVector, Tuple},
        α0_l::Vector{<:Number} = zeros(length(op_list)),
        dsf_params::NamedTuple = NamedTuple();
        e_ops::Function = (op_list, p) -> (),
        params::NamedTuple = NamedTuple(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        δα_list::Vector{<:Real} = fill(0.2, length(op_list)),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        krylov_dim::Int = min(5, cld(length(ψ0.data), 3)),
        progress_bar::Union{Bool, Val} = Val(true),
        kwargs...,
    ) where {TJC <: LindbladJumpCallbackType}
    op_list = deepcopy(op_list)
    H₀ = H(op_list .+ α0_l, dsf_params)
    c_ops₀ = c_ops(op_list .+ α0_l, dsf_params)
    e_ops₀ = e_ops(op_list .+ α0_l, dsf_params)

    T = eltype(ψ0)

    αt_list = convert(Vector{T}, α0_l)
    expv_cache = arnoldi(H₀.data, ψ0.data, krylov_dim)

    dsf_displace_cache = sum(op -> ScalarOperator(one(T)) * MatrixOperator(op.data), op_list)
    dsf_displace_cache_dag = sum(op -> ScalarOperator(one(T)) * MatrixOperator(sparse(op.data')), op_list)
    dsf_displace_cache_full = dsf_displace_cache + dsf_displace_cache_dag

    params2 = merge(
        params,
        (
            H_fun = H,
            c_ops_fun = c_ops,
            e_ops_fun = e_ops,
            op_list = op_list,
            αt_list = αt_list,
            δα_list = δα_list,
            dsf_cache1 = similar(ψ0.data),
            dsf_cache2 = similar(ψ0.data),
            expv_cache = expv_cache,
            dsf_params = dsf_params,
            dsf_displace_cache_full = dsf_displace_cache_full,
        ),
    )

    cb_dsf = DiscreteCallback(_DSF_mcsolve_Condition, _DSF_mcsolve_Affect!, save_positions = (false, false))
    kwargs2 = (; kwargs...)
    kwargs2 =
        haskey(kwargs2, :callback) ? merge(kwargs2, (callback = CallbackSet(cb_dsf, kwargs2.callback),)) :
        merge(kwargs2, (callback = cb_dsf,))

    return mcsolveEnsembleProblem(
        H₀,
        ψ0,
        tlist,
        c_ops₀;
        e_ops = e_ops₀,
        params = params2,
        ntraj = ntraj,
        ensemblealg = ensemblealg,
        jump_callback = jump_callback,
        prob_func = _dsf_mcsolve_prob_func,
        progress_bar = progress_bar,
        kwargs2...,
    )
end

@doc raw"""
    dsf_mcsolve(H::Function,
        ψ0::QuantumObject,
        tlist::AbstractVector, c_ops::Function,
        op_list::Vector{TOl},
        α0_l::Vector{<:Number}=zeros(length(op_list)),
        dsf_params::NamedTuple=NamedTuple();
        alg::AbstractODEAlgorithm=DP5(),
        e_ops::Function=(op_list,p) -> Vector{TOl}([]),
        params::NamedTuple=NamedTuple(),
        δα_list::Vector{<:Real}=fill(0.2, length(op_list)),
        ntraj::Int=500,
        ensemblealg::EnsembleAlgorithm=EnsembleThreads(),
        jump_callback::LindbladJumpCallbackType=ContinuousLindbladJumpCallback(),
        krylov_dim::Int=max(6, min(10, cld(length(ket2dm(ψ0).data), 4))),
        progress_bar::Union{Bool,Val} = Val(true)
        kwargs...)

Time evolution of a quantum system using the Monte Carlo wave function method and the Dynamical Shifted Fock algorithm.

# Notes
- For more details about `alg` please refer to [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/)
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)
"""
function dsf_mcsolve(
        H::Function,
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Function,
        op_list::Union{AbstractVector, Tuple},
        α0_l::Vector{<:Number} = zeros(length(op_list)),
        dsf_params::NamedTuple = NamedTuple();
        alg::AbstractODEAlgorithm = DP5(),
        e_ops::Function = (op_list, p) -> (),
        params::NamedTuple = NamedTuple(),
        δα_list::Vector{<:Real} = fill(0.2, length(op_list)),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        krylov_dim::Int = min(5, cld(length(ψ0.data), 3)),
        progress_bar::Union{Bool, Val} = Val(true),
        kwargs...,
    ) where {TJC <: LindbladJumpCallbackType}
    ens_prob_mc = dsf_mcsolveEnsembleProblem(
        H,
        ψ0,
        tlist,
        c_ops,
        op_list,
        α0_l,
        dsf_params;
        alg = alg,
        e_ops = e_ops,
        params = params,
        ntraj = ntraj,
        ensemblealg = ensemblealg,
        δα_list = δα_list,
        jump_callback = jump_callback,
        krylov_dim = krylov_dim,
        progress_bar = progress_bar,
        kwargs...,
    )

    return mcsolve(ens_prob_mc, alg, ntraj, ensemblealg)
end

#=
Helper functions for the mesolve callbacks.
=#

struct SaveFuncMESolve{TE, PT <: Union{Nothing, Progress}, IT, TEXPV <: Union{Nothing, AbstractMatrix}} <: AbstractSaveFunc
    e_ops::TE
    progr::PT
    iter::IT
    expvals::TEXPV
end

(f::SaveFuncMESolve)(u, t, integrator) = _save_func_mesolve(u, integrator, f.e_ops, f.progr, f.iter, f.expvals)
(f::SaveFuncMESolve{Nothing})(u, t, integrator) = _save_func(integrator, f.progr)

_get_e_ops_data(e_ops, ::Type{SaveFuncMESolve}) = [_generate_mesolve_e_op(op) for op in e_ops] # Broadcasting generates type instabilities on Julia v1.10

_get_progress_desc(::Type{SaveFuncMESolve}) = "[mesolve] "

##

# When e_ops is a list of operators
function _save_func_mesolve(u, integrator, e_ops, progr, iter, expvals)
    # This is equivalent to tr(op * ρ), when both are matrices.
    # The advantage of using this convention is that We don't need
    # to reshape u to make it a matrix, but we reshape the e_ops once.

    for (i, op) in enumerate(e_ops)
        @inbounds expvals[i, iter[]] = dot(op, u)
    end
    iter[] += 1

    return _save_func(integrator, progr)
end

function _mesolve_callbacks_new_e_ops!(integrator::AbstractODEIntegrator, e_ops)
    cb = _get_save_callback(integrator, SaveFuncMESolve)
    if cb isa Nothing
        return nothing
    else
        cb.affect!.func.e_ops .= e_ops # Only works if e_ops is a Vector of operators
        return nothing
    end
end

_generate_mesolve_e_op(op) = mat2vec(adjoint(get_data(op)))

export plot_fock_distribution

@doc raw"""
    plot_fock_distribution(
        ρ::QuantumObject{SType};
        library::Union{Val, Symbol} = Val(:Makie),
        kwargs...
    ) where {SType<:Union{Ket,Operator}}

Plot the [Fock state](https://en.wikipedia.org/wiki/Fock_state) distribution of `ρ`. 
    
The `library` keyword argument specifies the plotting library to use, defaulting to [`Makie`](https://github.com/MakieOrg/Makie.jl). 

# Arguments
- `ρ::QuantumObject`: The quantum state for which to plot the Fock state distribution.
- `library::Union{Val,Symbol}`: The plotting library to use. Default is `Val(:Makie)`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function. See the documentation for the specific plotting library for more information.

!!! note "Import library first"
    The plotting libraries must first be imported before using them with this function.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `Val(:Makie)` instead of `:Makie` as the plotting library. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
plot_fock_distribution(
    ρ::QuantumObject{SType};
    library::Union{Val, Symbol} = Val(:Makie),
    kwargs...,
) where {SType <: Union{Bra, Ket, Operator}} = plot_fock_distribution(makeVal(library), ρ; kwargs...)

plot_fock_distribution(::Val{T}, ρ::QuantumObject{SType}; kwargs...) where {T, SType <: Union{Bra, Ket, Operator}} =
    throw(ArgumentError("The specified plotting library $T is not available. Try running `using $T` first."))

export Lattice, multisite_operator, DissipativeIsing

@doc raw"""
    Lattice

A Julia constructor for a lattice object. The lattice object is used to define the geometry of the lattice. `Nx` and `Ny` are the number of sites in the x and y directions, respectively. `N` is the total number of sites. `lin_idx` is a `LinearIndices` object and `car_idx` is a `CartesianIndices` object, and they are used to efficiently select sites on the lattice.
"""
Base.@kwdef struct Lattice{TN <: Integer, TLI <: LinearIndices, TCI <: CartesianIndices}
    Nx::TN
    Ny::TN
    N::TN = Nx * Ny
    lin_idx::TLI = LinearIndices((Nx, Ny))
    car_idx::TCI = CartesianIndices((Nx, Ny))
end

#Definition of many-body operators
@doc raw"""
    multisite_operator(dims::Union{AbstractVector, Tuple}, pairs::Pair{<:Integer,<:QuantumObject}...)

A Julia function for generating a multi-site operator ``\\hat{O} = \\hat{O}_i \\hat{O}_j \\cdots \\hat{O}_k``. The function takes a vector of dimensions `dims` and a list of pairs `pairs` where the first element of the pair is the site index and the second element is the operator acting on that site.

# Arguments
- `dims::Union{AbstractVector, Tuple}`: A vector of dimensions of the lattice.
- `pairs::Pair{<:Integer,<:QuantumObject}...`: A list of pairs where the first element of the pair is the site index and the second element is the operator acting on that site.
    
# Returns
`QuantumObject`: A `QuantumObject` representing the multi-site operator.

# Example
```jldoctest
julia> op = multisite_operator(Val(8), 5=>sigmax(), 7=>sigmaz());

julia> op.dims
([2, 2, 2, 2, 2, 2, 2, 2], [2, 2, 2, 2, 2, 2, 2, 2])
```
"""
function multisite_operator(dims::Union{AbstractVector, Tuple}, pairs::Pair{<:Integer, <:QuantumObject}...)
    sites_unsorted = collect(first.(pairs))
    idxs = sortperm(sites_unsorted)
    _sites = sites_unsorted[idxs]
    _ops = collect(last.(pairs))[idxs]
    _dims = collect(dims) # Use this instead of a Tuple, to avoid type instability when indexing on a slice

    sites, ops = _get_unique_sites_ops(_sites, _ops)

    _dims[sites] == [op.dimensions.to[1].size for op in ops] || throw(ArgumentError("The dimensions of the operators do not match the dimensions of the lattice."))

    data = kron(Eye(prod(_dims[1:(sites[1] - 1)])), ops[1].data)
    for i in 2:length(sites)
        data = kron(data, Eye(prod(_dims[(sites[i - 1] + 1):(sites[i] - 1)])), ops[i].data)
    end
    data = kron(data, Eye(prod(_dims[(sites[end] + 1):end])))

    return QuantumObject(data; type = Operator(), dims = dims)
end
function multisite_operator(N::Union{Integer, Val}, pairs::Pair{<:Integer, <:QuantumObject}...)
    dims = ntuple(j -> 2, makeVal(N))

    return multisite_operator(dims, pairs...)
end
function multisite_operator(latt::Lattice, pairs::Pair{<:Integer, <:QuantumObject}...)
    return multisite_operator(makeVal(latt.N), pairs...)
end

#Definition of nearest-neighbour sites on lattice
periodic_boundary_conditions(i::Integer, N::Integer) = 1 + (i - 1 + N) % N
open_boundary_conditions(i::Integer, N::Integer) = (i >= 1 && i <= N)
periodic_boundary_conditions(i::Vector{Int}, N::Integer) = periodic_boundary_conditions.(i, N)
open_boundary_conditions(i::Vector{Int}, N::Integer) = filter(x -> open_boundary_conditions(x, N), i)

function nearest_neighbor(i::CartesianIndex, latt::Lattice, ::Val{:periodic_bc}; order::Integer = 1)
    row = periodic_boundary_conditions([i[1] + order, i[1] - order], latt.Nx)
    col = periodic_boundary_conditions([i[2] + order, i[2] - order], latt.Ny)
    return vcat([CartesianIndex(r, i[2]) for r in row], [CartesianIndex(i[1], c) for c in col])
end

function nearest_neighbor(i::CartesianIndex, latt::Lattice, ::Val{:open_bc}; order::Integer = 1)
    row = periodic_boundary_conditions([i[1] + order, i[1] - order], latt.Nx)
    col = periodic_boundary_conditions([i[2] + order, i[2] - order], latt.Ny)
    return vcat([CartesianIndex(r, i[2]) for r in row], [CartesianIndex(i[1], c) for c in col])
end

@doc """
    DissipativeIsing(Jx::Real, Jy::Real, Jz::Real, hx::Real, hy::Real, hz::Real, γ::Real, latt::Lattice; boundary_condition::Union{Symbol, Val} = Val(:periodic_bc), order::Integer = 1)

A Julia constructor for a dissipative Ising model. The function returns the Hamiltonian

```math
\\hat{H} = \\frac{J_x}{2} \\sum_{\\langle i, j \\rangle} \\hat{\\sigma}_i^x \\hat{\\sigma}_j^x + \\frac{J_y}{2} \\sum_{\\langle i, j \\rangle} \\hat{\\sigma}_i^y \\hat{\\sigma}_j^y + \\frac{J_z}{2} \\sum_{\\langle i, j \\rangle} \\hat{\\sigma}_i^z \\hat{\\sigma}_j^z + h_x \\sum_i \\hat{\\sigma}_i^x
```

and the collapse operators

```math
\\hat{c}_i = \\sqrt{\\gamma} \\hat{\\sigma}_i^-
```

# Arguments
- `Jx::Real`: The coupling constant in the x-direction.
- `Jy::Real`: The coupling constant in the y-direction.
- `Jz::Real`: The coupling constant in the z-direction.
- `hx::Real`: The magnetic field in the x-direction.
- `hy::Real`: The magnetic field in the y-direction.
- `hz::Real`: The magnetic field in the z-direction.
- `γ::Real`: The local dissipation rate.
- `latt::Lattice`: A [`Lattice`](@ref) object that defines the geometry of the lattice.
- `boundary_condition::Union{Symbol, Val}`: The boundary conditions of the lattice. The possible inputs are `periodic_bc` and `open_bc`, for periodic or open boundary conditions, respectively. The default value is `Val(:periodic_bc)`.
- `order::Integer`: The order of the nearest-neighbour sites. The default value is 1.
"""
function DissipativeIsing(
        Jx::Real,
        Jy::Real,
        Jz::Real,
        hx::Real,
        hy::Real,
        hz::Real,
        γ::Real,
        latt::Lattice;
        boundary_condition::Union{Symbol, Val} = Val(:periodic_bc),
        order::Integer = 1,
    )
    S = [multisite_operator(latt, i => sigmam()) for i in 1:latt.N]
    c_ops = sqrt(γ) .* S

    op_sum(S, i::CartesianIndex) =
        S[latt.lin_idx[i]] * sum(S[latt.lin_idx[nearest_neighbor(i, latt, makeVal(boundary_condition); order = order)]])

    H = 0
    if (Jx != 0 || hx != 0)
        S = [multisite_operator(latt, i => sigmax()) for i in 1:latt.N]
        H += Jx / 2 * mapreduce(i -> op_sum(S, i), +, latt.car_idx) #/2 because we are double counting
        H += hx * sum(S)
    end
    if (Jy != 0 || hy != 0)
        S = [multisite_operator(latt, i => sigmay()) for i in 1:latt.N]
        H += Jy / 2 * mapreduce(i -> op_sum(S, i), +, latt.car_idx)
        H += hy * sum(S)
    end
    if (Jz != 0 || hz != 0)
        S = [multisite_operator(latt, i => sigmaz()) for i in 1:latt.N]
        H += Jz / 2 * mapreduce(i -> op_sum(S, i), +, latt.car_idx)
        H += hz * sum(S)
    end
    return H, c_ops
end

function _get_unique_sites_ops(sites, ops)
    unique_sites = unique(sites)
    unique_ops = map(i -> prod(ops[findall(==(i), sites)]), unique_sites)

    return unique_sites, unique_ops
end

@testitem "Utilities" begin

    # citation bibtex
    io_buffer = IOBuffer()
    QuantumToolbox.cite(io_buffer)
    captured_output = String(take!(io_buffer))
    @test captured_output ==
        """@article{QuantumToolbox.jl2025,\n""" *
        """  title = {Quantum{T}oolbox.jl: {A}n efficient {J}ulia framework for simulating open quantum systems},\n""" *
        """  author = {Mercurio, Alberto and Huang, Yi-Te and Cai, Li-Xun and Chen, Yueh-Nan and Savona, Vincenzo and Nori, Franco},\n""" *
        """  journal = {{Quantum}},\n""" *
        """  issn = {2521-327X},\n""" *
        """  publisher = {{Verein zur F{\\"{o}}rderung des Open Access Publizierens in den Quantenwissenschaften}},\n""" *
        """  volume = {9},\n""" *
        """  pages = {1866},\n""" *
        """  month = sep,\n""" *
        """  year = {2025},\n""" *
        """  doi = {10.22331/q-2025-09-29-1866},\n""" *
        """  url = {https://doi.org/10.22331/q-2025-09-29-1866}\n""" *
        """}\n"""

    @testset "n_thermal" begin
        ω1 = rand(Float64)
        ω2 = rand(Float64)
        @test n_thermal(0, ω2) == 0.0
        @test n_thermal(ω1, 0) == 0.0
        @test n_thermal(ω1, -ω2) == 0.0
        @test n_thermal(ω1, ω2) == 1 / (exp(ω1 / ω2) - 1)
        @test typeof(n_thermal(Int32(2), Int32(3))) == Float32
        @test typeof(n_thermal(Float32(2), Float32(3))) == Float32
        @test typeof(n_thermal(Int64(2), Int32(3))) == Float64
        @test typeof(n_thermal(Int32(2), Int64(3))) == Float64
        @test typeof(n_thermal(Float64(2), Float32(3))) == Float64
        @test typeof(n_thermal(Float32(2), Float64(3))) == Float64
    end

    @testset "CODATA Physical Constants" begin
        c = PhysicalConstants.c
        h = PhysicalConstants.h
        ħ = PhysicalConstants.ħ
        μ0 = PhysicalConstants.μ0
        ϵ0 = PhysicalConstants.ϵ0

        @test h / ħ ≈ 2 * π
        @test μ0 / (4.0e-7 * π) ≈ 1.0
        @test c^2 * μ0 * ϵ0 ≈ 1.0
    end

    @testset "convert unit" begin
        V = 100 * rand(Float64)
        _unit_list = [:J, :eV, :meV, :MHz, :GHz, :K, :mK]
        for origin in _unit_list
            for middle in _unit_list
                for target in _unit_list
                    V_middle = convert_unit(V, origin, middle)
                    V_target = convert_unit(V_middle, middle, target)
                    V_origin = convert_unit(V_target, target, origin)
                    @test V ≈ V_origin
                end
            end
        end
        @test_throws ArgumentError convert_unit(V, :bad_unit, :J)
        @test_throws ArgumentError convert_unit(V, :J, :bad_unit)
    end

    @testset "Type Inference" begin
        v1 = rand(Float64)
        @inferred n_thermal(v1, Int32(123))

        _unit_list = [:J, :eV, :meV, :GHz, :mK]
        for u1 in _unit_list
            for u2 in _unit_list
                @inferred convert_unit(v1, u1, u2)
            end
        end
    end
end

#=
This file defines the QuantumObject (Qobj) structure.
It also implements the fundamental functions in Julia standard library:
    - Base: show, real, imag, Vector, Matrix
    - SparseArrays: sparse, nnz, nonzeros, rowvals, droptol!, dropzeros, dropzeros!, SparseVector, SparseMatrixCSC
    - SciMLOperators: cache_operator
=#

export QuantumObject

@doc raw"""
    struct QuantumObject{ObjType<:QuantumObjectType,DimType<:AbstractDimensions,DataType<:AbstractArray} <: AbstractQuantumObject{ObjType,DimType,DataType}
        data::DataType
        type::ObjType
        dimensions::DimType
    end

Julia structure representing any time-independent quantum objects. For time-dependent cases, see [`QuantumObjectEvolution`](@ref).

!!! note "`dims` property"
    For a given `H::QuantumObject`, `H.dims` or `getproperty(H, :dims)` returns its `dimensions` in the type of integer-vector.

# Examples

```jldoctest
julia> a = destroy(20)

Quantum Object:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 19 stored entries:
⎡⠈⠢⡀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠈⠢⡀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠈⠢⡀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠈⠢⡀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠈⠢⎦

julia> a isa QuantumObject
true

julia> a.dims
([20], [20])

julia> a.dimensions
ProductDimensions{1, 1, Tuple{HilbertSpace}, Tuple{HilbertSpace}}((HilbertSpace(20),), (HilbertSpace(20),))
```
"""
struct QuantumObject{ObjType <: QuantumObjectType, DimType <: AbstractDimensions, DataType <: AbstractArray} <:
    AbstractQuantumObject{ObjType, DimType, DataType}
    data::DataType
    type::ObjType
    dimensions::DimType

    function QuantumObject(data::DT, type, dims) where {DT <: AbstractArray}
        dimensions = _gen_dimensions(type, dims)

        ObjType = _check_type(type)

        _check_QuantumObject(type, dimensions, size(data, 1), size(data, 2))

        return new{ObjType, typeof(dimensions), DT}(data, type, dimensions)
    end
end

@doc raw"""
    Qobj(A::AbstractArray; type = nothing, dims = nothing)
    QuantumObject(A::AbstractArray; type = nothing, dims = nothing)

Generate [`QuantumObject`](@ref) with a given `A::AbstractArray` and specified `type::QuantumObjectType` and `dims`.

!!! note
    `Qobj` is a synonym of `QuantumObject`.
"""
function QuantumObject(A::AbstractMatrix{T}; type = nothing, dims = nothing) where {T}
    _check_type(type)

    if type isa Nothing
        type = (size(A, 1) == 1 && size(A, 2) > 1) ? Bra() : Operator() # default type
    elseif !(type isa Operator) && !(type isa SuperOperator) && !(type isa Bra) && !(type isa OperatorBra)
        throw(
            ArgumentError(
                "The argument type must be Operator(), SuperOperator(), Bra() or OperatorBra() if the input array is a matrix.",
            ),
        )
    end

    if isnothing(dims)
        if type isa Bra
            dims = (size(A, 2),)
        elseif type isa OperatorBra
            dims = (isqrt(size(A, 2)),)
        elseif type isa Operator
            dims = ((size(A, 1),), (size(A, 2),))
        elseif type isa SuperOperator
            dims = ((isqrt(size(A, 1)),), (isqrt(size(A, 2)),))
        end
    end

    return QuantumObject(A, type, dims)
end

function QuantumObject(A::AbstractVector{T}; type = nothing, dims = nothing) where {T}
    _check_type(type)
    if type isa Nothing
        type = Ket() # default type
    elseif !(type isa Ket) && !(type isa OperatorKet)
        throw(ArgumentError("The argument type must be Ket() or OperatorKet() if the input array is a vector."))
    end

    if isnothing(dims)
        if type isa Ket
            dims = (size(A, 1),)
        elseif type isa OperatorKet
            dims = (isqrt(size(A, 1)),)
        end
    end

    return QuantumObject(A, type, dims)
end

function QuantumObject(A::AbstractArray{T, N}; type = nothing, dims = nothing) where {T, N}
    throw(DimensionMismatch("The array with size $(size(A)) is not compatible with vector or matrix."))
end

function QuantumObject(A::QuantumObject; type = A.type, dims = A.dimensions)
    dimensions = _gen_dimensions(type, dims)
    _check_type(type)
    _check_QuantumObject(type, dimensions, size(A.data, 1), size(A.data, 2))
    return QuantumObject(copy(A.data), type, dimensions)
end

function Base.show(
        io::IO,
        QO::QuantumObject{OpType},
    ) where {OpType <: Union{Bra, Ket, OperatorBra, OperatorKet, SuperOperator}}
    op_data = QO.data
    println(
        io,
        "\nQuantum Object:   type=",
        QO.type,
        "   dims=",
        QO.dims,
        "   size=",
        size(op_data),
    )
    return show(io, MIME("text/plain"), op_data)
end

function Base.show(io::IO, QO::QuantumObject)
    op_data = QO.data
    println(
        io,
        "\nQuantum Object:   type=",
        QO.type,
        "   dims=",
        QO.dims,
        "   size=",
        size(op_data),
        "   ishermitian=",
        ishermitian(op_data),
    )
    return show(io, MIME("text/plain"), op_data)
end

Base.real(x::QuantumObject) = QuantumObject(real(x.data), x.type, x.dimensions)
Base.imag(x::QuantumObject) = QuantumObject(imag(x.data), x.type, x.dimensions)

SparseArrays.sparse(A::QuantumObject) = QuantumObject(sparse(A.data), A.type, A.dimensions)
SparseArrays.nnz(A::QuantumObject) = nnz(A.data)
SparseArrays.nonzeros(A::QuantumObject) = nonzeros(A.data)
SparseArrays.rowvals(A::QuantumObject) = rowvals(A.data)
SparseArrays.droptol!(A::QuantumObject, tol::Real) = (droptol!(A.data, tol); return A)
SparseArrays.dropzeros(A::QuantumObject) = QuantumObject(dropzeros(A.data), A.type, A.dimensions)
SparseArrays.dropzeros!(A::QuantumObject) = (dropzeros!(A.data); return A)

@doc raw"""
    SciMLOperators.cached_operator(L::AbstractQuantumObject, u)

Allocate caches for [`AbstractQuantumObject`](@ref) `L` for in-place evaluation with `u`-like input vectors.

Here, `u` can be in either the following types:
- `AbstractVector`
- [`Ket`](@ref)-type [`QuantumObject`](@ref) (if `L` is an [`Operator`](@ref))
- [`OperatorKet`](@ref)-type [`QuantumObject`](@ref) (if `L` is a [`SuperOperator`](@ref))
"""
SciMLOperators.cache_operator(
    L::AbstractQuantumObject{OpType},
    u::AbstractVector,
) where {OpType <: Union{Operator, SuperOperator}} =
    get_typename_wrapper(L)(cache_operator(L.data, to_dense(similar(u))), L.type, L.dimensions)

function SciMLOperators.cache_operator(
        L::AbstractQuantumObject{OpType},
        u::QuantumObject{SType},
    ) where {OpType <: Union{Operator, SuperOperator}, SType <: Union{Ket, OperatorKet}}
    check_mul_dimensions(L, u)

    if isoper(L) && isoperket(u)
        throw(ArgumentError("The input state `u` must be a Ket if `L` is an Operator."))
    elseif issuper(L) && isket(u)
        throw(ArgumentError("The input state `u` must be an OperatorKet if `L` is a SuperOperator."))
    end
    return cache_operator(L, u.data)
end

# data type conversions
Base.Vector(A::QuantumObject) = QuantumObject(Vector(A.data), A.type, A.dimensions)
Base.Vector{T}(A::QuantumObject) where {T <: Number} = QuantumObject(Vector{T}(A.data), A.type, A.dimensions)
Base.Matrix(A::QuantumObject) = QuantumObject(Matrix(A.data), A.type, A.dimensions)
Base.Matrix{T}(A::QuantumObject) where {T <: Number} = QuantumObject(Matrix{T}(A.data), A.type, A.dimensions)
SparseArrays.SparseVector(A::QuantumObject) = QuantumObject(SparseVector(A.data), A.type, A.dimensions)
SparseArrays.SparseVector{T}(A::QuantumObject) where {T <: Number} =
    QuantumObject(SparseVector{T}(A.data), A.type, A.dimensions)
SparseArrays.SparseMatrixCSC(A::QuantumObject) = QuantumObject(SparseMatrixCSC(A.data), A.type, A.dimensions)
SparseArrays.SparseMatrixCSC{T}(A::QuantumObject) where {T <: Number} =
    QuantumObject(SparseMatrixCSC{T}(A.data), A.type, A.dimensions)

#=  
This file defines the AbstractQuantumObject structure, all the type structures for AbstractQuantumObject, and fundamental functions in Julia standard library:  
    - Base: show, length, size, copy, eltype, getindex, setindex!, isequal, :(==), isapprox  
=#

export AbstractQuantumObject
export QuantumObjectType, SuperOperatorType, Bra, Ket, Operator, OperatorBra, OperatorKet, SuperOperator

@doc raw"""
    abstract type AbstractQuantumObject{ObjType,DimType,DataType}

Abstract type for all quantum objects like [`QuantumObject`](@ref) and [`QuantumObjectEvolution`](@ref).

# Example
```jldoctest
julia> sigmax() isa AbstractQuantumObject
true
```
"""
abstract type AbstractQuantumObject{ObjType, DimType, DataType} end

abstract type QuantumObjectType end

abstract type SuperOperatorType <: QuantumObjectType end

@doc raw"""
    Bra <: QuantumObjectType

Constructor representing a bra state ``\langle\psi|``.
"""
struct Bra <: QuantumObjectType end

Base.show(io::IO, ::Bra) = print(io, "Bra()")

@doc raw"""
    Ket <: QuantumObjectType

Constructor representing a ket state ``|\psi\rangle``.
"""
struct Ket <: QuantumObjectType end

Base.show(io::IO, ::Ket) = print(io, "Ket()")

@doc raw"""
    Operator <: QuantumObjectType

Constructor representing an operator ``\hat{O}``.
"""
struct Operator <: QuantumObjectType end

Base.show(io::IO, ::Operator) = print(io, "Operator()")

@doc raw"""
    SuperOperator <: SuperOperatorType

Constructor representing a super-operator ``\hat{\mathcal{O}}`` acting on vectorized density operator matrices.
"""
struct SuperOperator <: SuperOperatorType end

Base.show(io::IO, ::SuperOperator) = print(io, "SuperOperator()")

@doc raw"""
    OperatorBra <: QuantumObjectType

Constructor representing a bra state in the [`SuperOperator`](@ref) formalism ``\langle\!\langle\rho|``.
"""
struct OperatorBra <: QuantumObjectType end

Base.show(io::IO, ::OperatorBra) = print(io, "OperatorBra()")

@doc raw"""
    OperatorKet <: QuantumObjectType

Constructor representing a ket state in the [`SuperOperator`](@ref) formalism ``|\rho\rangle\!\rangle``.
"""
struct OperatorKet <: QuantumObjectType end

Base.show(io::IO, ::OperatorKet) = print(io, "OperatorKet()")

@doc raw"""
    size(A::AbstractQuantumObject)
    size(A::AbstractQuantumObject, idx::Int)
    shape(A::AbstractQuantumObject)
    shape(A::AbstractQuantumObject, idx::Int)

Returns a tuple containing each dimensions of the array in the [`AbstractQuantumObject`](@ref).

Optionally, you can specify an index (`idx`) to just get the corresponding dimension of the array.

!!! note
    `shape` is a synonym of `size`.
"""
Base.size(A::AbstractQuantumObject) = size(A.data)
Base.size(A::AbstractQuantumObject, idx::Int) = size(A.data, idx)

Base.copy(A::AbstractQuantumObject) = get_typename_wrapper(A)(copy(A.data), A.type, A.dimensions)

Base.getindex(A::AbstractQuantumObject, inds...) = getindex(A.data, inds...)
Base.setindex!(A::AbstractQuantumObject, val, inds...) = setindex!(A.data, val, inds...)

@doc raw"""
    eltype(A::AbstractQuantumObject)

Returns the elements type of the matrix or vector corresponding to the [`AbstractQuantumObject`](@ref) `A`.
"""
Base.eltype(A::AbstractQuantumObject) = eltype(A.data)

@doc raw"""
    length(A::AbstractQuantumObject)

Returns the length of the matrix or vector corresponding to the [`AbstractQuantumObject`](@ref) `A`.
"""
Base.length(A::AbstractQuantumObject) = length(A.data)

Base.isequal(A::AbstractQuantumObject, B::AbstractQuantumObject) =
    isequal(A.type, B.type) && isequal(A.dimensions, B.dimensions) && isequal(A.data, B.data)
Base.isapprox(A::AbstractQuantumObject, B::AbstractQuantumObject; kwargs...) =
    isequal(A.type, B.type) && isequal(A.dimensions, B.dimensions) && isapprox(A.data, B.data; kwargs...)
Base.:(==)(A::AbstractQuantumObject, B::AbstractQuantumObject) =
    (A.type == B.type) && (A.dimensions == B.dimensions) && (A.data == B.data)

function check_dimensions(dimensions_list::NTuple{N, AbstractDimensions}) where {N}
    allequal(dimensions_list) ||
        throw(DimensionMismatch("The quantum objects should have the same Hilbert `dimensions`."))
    return nothing
end

function check_dimensions(Qobj_tuple::NTuple{N, AbstractQuantumObject}) where {N}
    dimensions_list = map(A -> A.dimensions, Qobj_tuple)
    allequal(dimensions_list) ||
        throw(DimensionMismatch("The quantum objects should have the same Hilbert `dimensions`."))
    return nothing
end
check_dimensions(A::AbstractQuantumObject...) = check_dimensions(A)

function _check_QuantumObject(::Ket, dimensions::ProductDimensions, m::Int, n::Int)
    (n != 1) && throw(DimensionMismatch(("The size $((m, n)) of the array is not compatible with Ket")))
    obj_size = get_hilbert_size(dimensions)
    (obj_size == (m, n)) || throw(
        DimensionMismatch("Ket with dims = $(_get_dims_string(dimensions)) does not fit the array size = $((m, n))."),
    )
    return nothing
end

function _check_QuantumObject(::Bra, dimensions::ProductDimensions, m::Int, n::Int)
    (m != 1) && throw(DimensionMismatch(("The size $((m, n)) of the array is not compatible with Bra")))
    obj_size = get_hilbert_size(dimensions)
    (obj_size == (m, n)) || throw(
        DimensionMismatch("Bra with dims = $(_get_dims_string(dimensions)) does not fit the array size = $((m, n))."),
    )
    return nothing
end

function _check_QuantumObject(::Operator, dimensions::ProductDimensions, m::Int, n::Int)
    obj_size = get_hilbert_size(dimensions)
    (obj_size == (m, n)) || throw(
        DimensionMismatch(
            "Operator with dims = $(_get_dims_string(dimensions)) does not fit the array size = $((m, n)).",
        ),
    )
    return nothing
end

function _check_QuantumObject(::SuperOperator, dimensions::ProductDimensions, m::Int, n::Int)
    obj_size = get_liouville_size(dimensions)
    (obj_size == (m, n)) || throw(
        DimensionMismatch(
            "SuperOperator with dims = $(_get_dims_string(dimensions)) does not fit the array size = $((m, n)).",
        ),
    )
    return nothing
end

function _check_QuantumObject(::OperatorKet, dimensions::ProductDimensions, m::Int, n::Int)
    (n != 1) && throw(DimensionMismatch(("The size $((m, n)) of the array is not compatible with OperatorKet")))
    obj_size = get_liouville_size(dimensions)
    (obj_size == (m, n)) || throw(
        DimensionMismatch(
            "OperatorKet with dims = $(_get_dims_string(dimensions)) does not fit the array size = $((m, n)).",
        ),
    )
    return nothing
end

function _check_QuantumObject(::OperatorBra, dimensions::ProductDimensions, m::Int, n::Int)
    (m != 1) && throw(DimensionMismatch(("The size $((m, n)) of the array is not compatible with OperatorBra")))
    obj_size = get_liouville_size(dimensions)
    (obj_size == (m, n)) || throw(
        DimensionMismatch(
            "OperatorBra with dims = $(_get_dims_string(dimensions)) does not fit the array size = $((m, n)).",
        ),
    )
    return nothing
end

_check_type(::T) where {T <: Union{Nothing, <:QuantumObjectType}} = T
_check_type(::Type{T}) where {T} =
    throw(ArgumentError("The argument `$T` is not valid. You may probably want to use `$T()` instead."))
_check_type(t) = throw(ArgumentError("The argument $t is not valid. It should be a subtype of `QuantumObjectType`."))

function Base.getproperty(A::AbstractQuantumObject, key::Symbol)
    # a comment here to avoid bad render by JuliaFormatter
    if key === :dims
        return dimensions_to_dims(getfield(A, :dimensions))
    else
        return getfield(A, key)
    end
end

_gen_dimensions(type::QuantumObjectType, dims::AbstractDimensions) = dims
function _gen_dimensions(::ObjType, dims::Union{T, AbstractVector{T}, NTuple{N, T}}) where {ObjType <: QuantumObjectType, T <: Union{<:Integer, <:AbstractSpace}, N}
    raw_dimensions = ProductDimensions(dims)
    if ObjType <: Union{Ket, OperatorKet}
        return ProductDimensions(raw_dimensions.to, hilbertspace_one_list(raw_dimensions.to))
    elseif ObjType <: Union{Bra, OperatorBra}
        return ProductDimensions(hilbertspace_one_list(raw_dimensions.from), raw_dimensions.from)
    else
        return raw_dimensions
    end
end
_gen_dimensions(type::QuantumObjectType, dims::Union{AbstractVector{T}, NTuple{N, T}}) where {T <: Union{AbstractVector, NTuple}, N} =
    ProductDimensions(dims)
_gen_dimensions(type, dims) = throw(ArgumentError("The argument `dims` with value $dims is not valid for object type $type."))

# functions for getting Float or Complex element type
_float_type(A::AbstractQuantumObject) = _float_type(eltype(A))
_complex_float_type(A::AbstractQuantumObject) = _complex_float_type(eltype(A))

@doc raw"""
    plot_wigner(
        library::Val{:Makie},
        state::QuantumObject{OpType};
        xvec::Union{Nothing,AbstractVector} = nothing,
        yvec::Union{Nothing,AbstractVector} = nothing,
        g::Real = √2,
        method::WignerSolver = WignerClenshaw(),
        projection::Union{Val,Symbol} = Val(:two_dim),
        location::Union{GridPosition,Nothing} = nothing,
        colorbar::Bool = false,
        kwargs...
    ) where {OpType}

Plot the [Wigner quasipropability distribution](https://en.wikipedia.org/wiki/Wigner_quasiprobability_distribution) of `state` using the [`Makie`](https://github.com/MakieOrg/Makie.jl) plotting library.

# Arguments
- `library::Val{:Makie}`: The plotting library to use.
- `state::QuantumObject`: The quantum state for which the Wigner function is calculated. It can be either a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `xvec::AbstractVector`: The x-coordinates of the phase space grid. Defaults to a linear range from -7.5 to 7.5 with 200 points.
- `yvec::AbstractVector`: The y-coordinates of the phase space grid. Defaults to a linear range from -7.5 to 7.5 with 200 points.
- `g::Real`: The scaling factor related to the value of ``\hbar`` in the commutation relation ``[x, y] = i \hbar`` via ``\hbar=2/g^2``.
- `method::WignerSolver`: The method used to calculate the Wigner function. It can be either `WignerLaguerre()` or `WignerClenshaw()`, with `WignerClenshaw()` as default. The `WignerLaguerre` method has the optional `parallel` and `tol` parameters, with default values `true` and `1e-14`, respectively.
- `projection::Union{Val,Symbol}`: Whether to plot the Wigner function in 2D or 3D. It can be either `Val(:two_dim)` or `Val(:three_dim)`, with `Val(:two_dim)` as default.
- `location::Union{GridPosition,Nothing}`: The location of the plot in the layout. If `nothing`, the plot is created in a new figure. Default is `nothing`.
- `colorbar::Bool`: Whether to include a colorbar in the plot. Default is `false`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function. 

# Returns
- `fig`: The figure object.
- `ax`: The axis object.
- `hm`: Either the heatmap or surface object, depending on the projection.

!!! note "Import library first"
    [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) must first be imported before using this function. This can be done by importing one of the available backends, such as [`CairoMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/CairoMakie), [`GLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/GLMakie), or [`WGLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/WGLMakie).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `Val(:two_dim)` and `Val(:three_dim)` instead of `:two_dim` and `:three_dim`, respectively. Also, specify the library as `Val(:Makie)` See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function QuantumToolbox.plot_wigner(
        library::Val{:Makie},
        state::QuantumObject{OpType};
        xvec::Union{Nothing, AbstractVector} = LinRange(-7.5, 7.5, 200),
        yvec::Union{Nothing, AbstractVector} = LinRange(-7.5, 7.5, 200),
        g::Real = √2,
        method::WignerSolver = WignerClenshaw(),
        projection::Union{Val, Symbol} = Val(:two_dim),
        location::Union{GridPosition, Nothing} = nothing,
        colorbar::Bool = false,
        kwargs...,
    ) where {OpType <: Union{Bra, Ket, Operator}}
    QuantumToolbox.getVal(projection) == :two_dim ||
        QuantumToolbox.getVal(projection) == :three_dim ||
        throw(ArgumentError("Unsupported projection: $projection"))

    return _plot_wigner(
        library,
        state,
        xvec,
        yvec,
        QuantumToolbox.makeVal(projection),
        g,
        method,
        location,
        colorbar;
        kwargs...,
    )
end

function _plot_wigner(
        ::Val{:Makie},
        state::QuantumObject{OpType},
        xvec::AbstractVector,
        yvec::AbstractVector,
        projection::Val{:two_dim},
        g::Real,
        method::WignerSolver,
        location::Union{GridPosition, Nothing},
        colorbar::Bool;
        kwargs...,
    ) where {OpType <: Union{Bra, Ket, Operator}}
    fig, location = _getFigAndLocation(location)

    lyt = GridLayout(location)

    ax = Axis(lyt[1, 1])

    wig = wigner(state, xvec, yvec; g = g, method = method)
    wlim = maximum(abs, wig)

    kwargs = merge(Dict(:colormap => Reverse(:RdBu), :colorrange => (-wlim, wlim)), kwargs)
    hm = heatmap!(ax, xvec, yvec, transpose(wig); kwargs...)

    if colorbar
        Colorbar(lyt[1, 2], hm)
    end

    ax.xlabel = L"\textrm{Re}(\alpha)"
    ax.ylabel = L"\textrm{Im}(\alpha)"
    return fig, ax, hm
end

function _plot_wigner(
        ::Val{:Makie},
        state::QuantumObject{OpType},
        xvec::AbstractVector,
        yvec::AbstractVector,
        projection::Val{:three_dim},
        g::Real,
        method::WignerSolver,
        location::Union{GridPosition, Nothing},
        colorbar::Bool;
        kwargs...,
    ) where {OpType <: Union{Bra, Ket, Operator}}
    fig, location = _getFigAndLocation(location)

    lyt = GridLayout(location)

    ax = Axis3(lyt[1, 1], azimuth = 1.775pi, elevation = pi / 16, protrusions = (30, 90, 30, 30), viewmode = :stretch)

    wig = wigner(state, xvec, yvec; g = g, method = method)
    wlim = maximum(abs, wig)

    kwargs = merge(Dict(:colormap => :RdBu, :colorrange => (-wlim, wlim)), kwargs)
    surf = surface!(ax, xvec, yvec, transpose(wig); kwargs...)

    if colorbar
        Colorbar(lyt[1, 2], surf)
    end

    ax.xlabel = L"\textrm{Re}(\alpha)"
    ax.ylabel = L"\textrm{Im}(\alpha)"
    ax.zlabel = "Wigner function"
    return fig, ax, surf
end

#=
Functions which manipulates QuantumObject
=#

export ket2dm
export expect, variance
export to_dense, to_sparse
export vec2mat, mat2vec

@doc raw"""
    ket2dm(ψ::QuantumObject)

Transform the ket state ``\ket{\psi}`` into a pure density matrix ``\hat{\rho} = |\psi\rangle\langle\psi|``.
"""
ket2dm(ψ::QuantumObject{Ket}) = ψ * ψ'

ket2dm(ρ::QuantumObject{Operator}) = ρ

@doc raw"""
    expect(O::Union{AbstractQuantumObject,Vector{AbstractQuantumObject}}, ψ::Union{QuantumObject,Vector{QuantumObject}})

Expectation value of the [`Operator`](@ref) `O` with the state `ψ`. The state can be a [`Ket`](@ref), [`Bra`](@ref) or [`Operator`](@ref).

If `ψ` is a [`Ket`](@ref) or [`Bra`](@ref), the function calculates ``\langle\psi|\hat{O}|\psi\rangle``.

If `ψ` is a density matrix ([`Operator`](@ref)), the function calculates ``\textrm{Tr} \left[ \hat{O} \hat{\psi} \right]``

The function returns a real number if `O` is of `Hermitian` type or `Symmetric` type, and returns a complex number otherwise. You can make an operator `O` hermitian by using `Hermitian(O)`.

!!! note "List of observables and states"
    The observable `O` and state `ψ` can be given as a list of [`QuantumObject`](@ref), it returns a list of expectation values. If both of them are given as a list, it returns a `Matrix` of expectation values.

# Examples

```jldoctest
julia> ψ1 = 1 / √2 * (fock(10,2) + fock(10,4));

julia> ψ2 = coherent(10, 0.6 + 0.8im);

julia> a = destroy(10);

julia> expect(a' * a, ψ1) |> round
3.0 + 0.0im

julia> expect(Hermitian(a' * a), ψ1) |> round
3.0

julia> round.(expect([a' * a, a' + a, a], [ψ1, ψ2]), digits = 1)
3×2 Matrix{ComplexF64}:
 3.0+0.0im  1.0+0.0im
 0.0+0.0im  1.2-0.0im
 0.0+0.0im  0.6+0.8im
```
"""
expect(O::AbstractQuantumObject{Operator}, ψ::QuantumObject{Ket}) = dot(ψ, O, ψ) # check_mul_dimensions in dot
expect(O::AbstractQuantumObject{Operator}, ψ::QuantumObject{Bra}) = expect(O, ψ')
expect(O::QuantumObject{Operator}, ρ::QuantumObject{Operator}) = tr(O * ρ) # check_mul_dimensions in :(*)
expect(
    O::QuantumObject{Operator, DimsType, <:Union{<:Hermitian{TF}, <:Symmetric{TR}}},
    ψ::QuantumObject{Ket},
) where {DimsType <: AbstractDimensions, TF <: Number, TR <: Real} = real(dot(ψ, O, ψ)) # check_mul_dimensions in dot
expect(
    O::QuantumObject{Operator, DimsType, <:Union{<:Hermitian{TF}, <:Symmetric{TR}}},
    ψ::QuantumObject{Bra},
) where {DimsType <: AbstractDimensions, TF <: Number, TR <: Real} = real(expect(O, ψ'))
expect(
    O::QuantumObject{Operator, DimsType, <:Union{<:Hermitian{TF}, <:Symmetric{TR}}},
    ρ::QuantumObject{Operator},
) where {DimsType <: AbstractDimensions, TF <: Number, TR <: Real} = real(tr(O * ρ)) # check_mul_dimensions in :(*)
expect(
    O::AbstractVector{<:AbstractQuantumObject{Operator, DimsType, <:Union{<:Hermitian{TF}, <:Symmetric{TR}}}},
    ρ::QuantumObject,
) where {DimsType <: AbstractDimensions, TF <: Number, TR <: Real} = expect.(O, Ref(ρ))
function expect(O::AbstractVector{<:AbstractQuantumObject{Operator}}, ρ::QuantumObject)
    result = Vector{ComplexF64}(undef, length(O))
    result .= expect.(O, Ref(ρ))
    return result
end
expect(O::AbstractQuantumObject{Operator}, ρ::AbstractVector{<:QuantumObject}) = expect.(Ref(O), ρ)
function expect(
        O::AbstractVector{<:AbstractQuantumObject{Operator, DimsType, <:Union{<:Hermitian{TF}, <:Symmetric{TR}}}},
        ρ::AbstractVector{<:QuantumObject},
    ) where {DimsType <: AbstractDimensions, TF <: Number, TR <: Real}
    N_ops = length(O)
    result = Matrix{Float64}(undef, N_ops, length(ρ))
    for i in 1:N_ops
        result[i, :] .= expect.(Ref(O[i]), ρ)
    end
    return result
end
function expect(O::AbstractVector{<:AbstractQuantumObject{Operator}}, ρ::AbstractVector{<:QuantumObject})
    N_ops = length(O)
    result = Matrix{ComplexF64}(undef, N_ops, length(ρ))
    for i in 1:N_ops
        result[i, :] .= expect.(Ref(O[i]), ρ)
    end
    return result
end

@doc raw"""
    variance(O::QuantumObject, ψ::Union{QuantumObject,Vector{QuantumObject}})

Variance of the [`Operator`](@ref) `O`: ``\langle\hat{O}^2\rangle - \langle\hat{O}\rangle^2``,

where ``\langle\hat{O}\rangle`` is the expectation value of `O` with the state `ψ` (see also [`expect`](@ref)), and the state `ψ` can be a [`Ket`](@ref), [`Bra`](@ref) or [`Operator`](@ref).

The function returns a real number if `O` is hermitian, and returns a complex number otherwise.

Note that `ψ` can also be given as a list of [`QuantumObject`](@ref), it returns a list of expectation values.
"""
variance(O::QuantumObject{Operator}, ψ::QuantumObject) = expect(O^2, ψ) - expect(O, ψ)^2
variance(O::QuantumObject{Operator}, ψ::Vector{<:QuantumObject}) = expect(O^2, ψ) .- expect(O, ψ) .^ 2

@doc raw"""
    to_dense(A::QuantumObject)

Converts a sparse QuantumObject to a dense QuantumObject.
"""
to_dense(A::QuantumObject) = QuantumObject(to_dense(A.data), A.type, A.dimensions)
to_dense(A::MT) where {MT <: AbstractSparseArray} = Array(A)
to_dense(A::MT) where {MT <: AbstractArray} = A
to_dense(A::Diagonal) = diagm(A.diag)

to_dense(::Type{T}, A::AbstractSparseArray) where {T <: Number} = Array{T}(A)
to_dense(::Type{T1}, A::AbstractArray{T2}) where {T1 <: Number, T2 <: Number} = Array{T1}(A)
to_dense(::Type{T}, A::AbstractArray{T}) where {T <: Number} = A
to_dense(::Type{T}, A::Diagonal{T}) where {T <: Number} = diagm(A.diag)

function to_dense(::Type{M}) where {M <: Union{Diagonal, SparseMatrixCSC}}
    T = M
    par = T.parameters
    npar = length(par)
    (2 == npar) || error("Type $M is not supported.")
    return Matrix{par[1]}
end

to_dense(::Type{M}) where {M <: AbstractMatrix} = M

@doc raw"""
    to_sparse(A::QuantumObject, tol::Real = settings.tidyup_tol)

Converts a dense QuantumObject to a sparse QuantumObject by removing elements with absolute values smaller than `tol`.
"""
to_sparse(A::QuantumObject, tol::Real = settings.tidyup_tol) = QuantumObject(to_sparse(A.data, tol), A.type, A.dimensions)
function to_sparse(A::MT, tol::Real = settings.tidyup_tol) where {MT <: AbstractMatrix}
    idxs = findall(@. abs(A) > tol)
    row_indices = getindex.(idxs, 1)
    col_indices = getindex.(idxs, 2)
    vals = getindex(A, idxs)
    return sparse(row_indices, col_indices, vals, size(A)...)
end
function to_sparse(A::VT, tol::Real = settings.tidyup_tol) where {VT <: AbstractVector}
    idxs = findall(@. abs(A) > tol)
    vals = getindex(A, idxs)
    return sparsevec(idxs, vals, length(A))
end

to_sparse_if_needed(::Val{needed}, A::Union{QuantumObject, AbstractArray}, tol::Real = settings.tidyup_tol) where {needed} =
    needed ? to_sparse(A, tol) : A

@doc raw"""
    kron(A::AbstractQuantumObject, B::AbstractQuantumObject, ...)
    tensor(A::AbstractQuantumObject, B::AbstractQuantumObject, ...)
    ⊗(A::AbstractQuantumObject, B::AbstractQuantumObject, ...)
    A ⊗ B

Returns the [Kronecker product](https://en.wikipedia.org/wiki/Kronecker_product) ``\hat{A} \otimes \hat{B} \otimes \cdots``.

!!! note
    `tensor` and `⊗` (where `⊗` can be typed by tab-completing `\otimes` in the REPL) are synonyms of `kron`.

# Examples

```jldoctest
julia> a = destroy(20)

Quantum Object:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 19 stored entries:
⎡⠈⠢⡀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠈⠢⡀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠈⠢⡀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠈⠢⡀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠈⠢⎦

julia> O = kron(a, a);

julia> size(a), size(O)
((20, 20), (400, 400))

julia> a.dims, O.dims
(([20], [20]), ([20, 20], [20, 20]))
```
"""
function Base.kron(
        A::AbstractQuantumObject{OpType},
        B::AbstractQuantumObject{OpType},
    ) where {OpType <: Union{Ket, Bra, Operator}}
    QType = promote_op_type(A, B)
    _lazy_tensor_warning(A.data, B.data)
    return QType(
        kron(A.data, B.data),
        A.type,
        ProductDimensions(
            (A.dimensions.to..., B.dimensions.to...),
            (A.dimensions.from..., B.dimensions.from...),
        ),
    )
end

# if A and B are different type (must return Operator)
for AOpType in (:Ket, :Bra, :Operator)
    for BOpType in (:Ket, :Bra, :Operator)
        if (AOpType != BOpType)
            @eval begin
                function Base.kron(A::AbstractQuantumObject{$AOpType}, B::AbstractQuantumObject{$BOpType})
                    QType = promote_op_type(A, B)
                    _lazy_tensor_warning(A.data, B.data)
                    return QType(
                        kron(A.data, B.data),
                        Operator(),
                        ProductDimensions(
                            (A.dimensions.to..., B.dimensions.to...),
                            (A.dimensions.from..., B.dimensions.from...),
                        ),
                    )
                end
            end
        end
    end
end

Base.kron(A::AbstractQuantumObject) = A
function Base.kron(A::Vector{<:AbstractQuantumObject})
    @warn "`tensor(A)` or `kron(A)` with `A` is a `Vector` can hurt performance. Try to use `tensor(A...)` or `kron(A...)` instead."
    return kron(A...)
end

@doc raw"""
    vec2mat(A::AbstractVector)

Converts a vector to a matrix.
"""
function vec2mat(A::AbstractVector)
    newsize = isqrt(length(A))
    return reshape(A, newsize, newsize)
end

@doc raw"""
    vec2mat(A::QuantumObject)
    vector_to_operator(A::QuantumObject)

Convert a quantum object from vector ([`OperatorKet`](@ref)-type) to matrix ([`Operator`](@ref)-type)

!!! note
    `vector_to_operator` is a synonym of `vec2mat`.
"""
vec2mat(A::QuantumObject{OperatorKet}) = QuantumObject(vec2mat(A.data), Operator(), A.dimensions.to)

@doc raw"""
    mat2vec(A::QuantumObject)
    operator_to_vector(A::QuantumObject)

Convert a quantum object from matrix ([`Operator`](@ref)-type) to vector ([`OperatorKet`](@ref)-type)

!!! note
    `operator_to_vector` is a synonym of `mat2vec`.
"""
function mat2vec(A::QuantumObject{Operator})
    isendomorphism(A.dimensions) || throw(ArgumentError("mat2vec requires a square Operator (same to and from dimensions)."))
    return QuantumObject(mat2vec(A.data), OperatorKet(), A.dimensions.to)
end

@doc raw"""
    mat2vec(A::AbstractMatrix)

Converts a matrix to a vector.
"""
mat2vec(A::MT) where {MT <: AbstractMatrix} = vec(A) # reshape(A, :)
function mat2vec(A::MT) where {MT <: AbstractSparseMatrix}
    i, j, v = findnz(A)
    return sparsevec(i .+ (j .- 1) .* size(A, 1), v, prod(size(A)))
end
for op in (:Transpose, :Adjoint)
    @eval mat2vec(A::$op{T, <:AbstractSparseMatrix}) where {T <: Number} = mat2vec(sparse(A))
    @eval mat2vec(A::$op{T, MT}) where {T <: Number, MT <: AbstractMatrix} = mat2vec(MT(A))
end

function mat2vec(::Type{M}) where {M <: DenseMatrix}
    T = hasproperty(M, :body) ? M.body : M
    par = T.parameters
    npar = length(par)
    (2 ≤ npar ≤ 3) || error("Type $M is not supported.")
    if npar == 2
        S = T.name.wrapper{par[1], 1}
    else
        S = T.name.wrapper{par[1], 1, par[3]}
    end
    return S
end

function mat2vec(::Type{M}) where {M <: SparseMatrixCSC}
    T = M
    par = T.parameters
    npar = length(par)
    (2 == npar) || error("Type $M is not supported.")
    return SparseVector{par[1], par[2]}
end

function mat2vec(::Type{M}) where {M <: Union{Adjoint{<:Number, <:SparseMatrixCSC}, Transpose{<:Number, <:SparseMatrixCSC}}}
    T = M.parameters[2]
    par = T.parameters
    npar = length(par)
    (2 == npar) || error("Type $M is not supported.")
    return SparseVector{par[1], par[2]}
end

@testitem "Block Diagonal Form" begin
    # Block Diagonal Form
    N = 20
    Δ = 0
    G = 5
    tg = 0
    θ = atan(tg)
    U = sin(θ)
    κ2 = cos(θ)
    κϕ = 1.0e-3
    nth = 0.0

    a = destroy(N)
    ad = create(N)
    H = -Δ * ad * a + G / 2 * (ad^2 + a^2) + U / 2 * (ad^2 * a^2)
    c_ops = [√(κ2) * a^2, √(κϕ) * ad * a]
    L = liouvillian(H, c_ops)

    bdf = block_diagonal_form(L)
    L_bd = bdf.B
    block_sizes = bdf.block_sizes
    blocks = bdf.blocks

    @test size(L_bd) == size(L)
    @test length(block_sizes) == 4
    @test length(blocks) == 4
    @test sum(block_sizes .== 100) == 4

    @testset "Type Inference (block_diagonal_form)" begin
        @inferred block_diagonal_form(L)
    end
end

module QuantumToolboxChainRulesCoreExt

using LinearAlgebra
import QuantumToolbox: QuantumObject
import ChainRulesCore: rrule, NoTangent, Tangent

function rrule(::Type{QuantumObject}, data, type, dimensions)
    obj = QuantumObject(data, type, dimensions)
    f_pullback(Δobj) = (NoTangent(), Δobj.data, NoTangent(), NoTangent())
    f_pullback(Δobj_data::AbstractArray) = (NoTangent(), Δobj_data, NoTangent(), NoTangent())
    return obj, f_pullback
end

end

@doc raw"""
    plot_fock_distribution(
        library::Val{:Makie},
        ρ::QuantumObject{SType};
        fock_numbers::Union{Nothing, AbstractVector} = nothing,
        unit_y_range::Bool = true,
        location::Union{GridPosition,Nothing} = nothing,
        kwargs...
    ) where {SType<:Union{Ket,Operator}}

Plot the [Fock state](https://en.wikipedia.org/wiki/Fock_state) distribution of `ρ`. 

# Arguments
- `library::Val{:Makie}`: The plotting library to use.
- `ρ::QuantumObject`: The quantum state for which the Fock state distribution is to be plotted. It can be either a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `location::Union{GridPosition,Nothing}`: The location of the plot in the layout. If `nothing`, the plot is created in a new figure. Default is `nothing`.
- `fock_numbers::Union{Nothing, AbstractVector}`: list of x ticklabels to represent fock numbers, default is `nothing`.
- `unit_y_range::Bool`: Set y-axis limits [0, 1] or not, default is `true`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function. 

# Returns
- `fig`: The figure object.
- `ax`: The axis object.
- `bp`: The barplot object.

!!! note "Import library first"
    [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) must first be imported before using this function. This can be done by importing one of the available backends, such as [`CairoMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/CairoMakie), [`GLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/GLMakie), or [`WGLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/WGLMakie).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `Val(:two_dim)` and `Val(:three_dim)` instead of `:two_dim` and `:three_dim`, respectively. Also, specify the library as `Val(:Makie)` See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function QuantumToolbox.plot_fock_distribution(
        library::Val{:Makie},
        ρ::QuantumObject{SType};
        fock_numbers::Union{Nothing, AbstractVector} = nothing,
        unit_y_range::Bool = true,
        location::Union{GridPosition, Nothing} = nothing,
        kwargs...,
    ) where {SType <: Union{Bra, Ket, Operator}}
    return _plot_fock_distribution(
        library,
        ρ;
        fock_numbers = fock_numbers,
        unit_y_range = unit_y_range,
        location = location,
        kwargs...,
    )
end

function _plot_fock_distribution(
        ::Val{:Makie},
        ρ::QuantumObject{SType};
        fock_numbers::Union{Nothing, AbstractVector} = nothing,
        unit_y_range::Bool = true,
        location::Union{GridPosition, Nothing} = nothing,
        kwargs...,
    ) where {SType <: Union{Bra, Ket, Operator}}
    ρ = ket2dm(ρ)
    D = get_size(ρ.dimensions)[1]
    isapprox(tr(ρ), 1, atol = 1.0e-4) || (@warn "The input ρ should be normalized.")

    # handle x ticks
    xvec = 0:(D - 1)
    fock_numbers = isnothing(fock_numbers) ? string.(collect(xvec)) : fock_numbers
    length(fock_numbers) == D ||
        throw(ArgumentError("Length of fock_numbers ($(length(fock_numbers))) does not match the total dimension: $D"))

    # handle limits
    # -0.5 originates from the half width of bar
    limits = unit_y_range ? (-0.5, D - 0.5, 0, 1) : (-0.5, D - 0.5, nothing, nothing)

    fig, location = _getFigAndLocation(location)
    lyt = GridLayout(location)
    ax = Axis(
        lyt[1, 1];
        xticks = (xvec, fock_numbers),
        xlabel = "Fock number",
        ylabel = "Occupation probability",
        limits = limits,
    )

    bp = barplot!(ax, xvec, real(diag(ρ)); kwargs...)

    return fig, ax, bp
end

#=
Eigen solvers and results for QuantumObject
=#

export EigsolveResult
export eigenenergies, eigenstates, eigsolve
export eigsolve_al

@doc raw"""
    struct EigsolveResult

A struct containing the eigenvalues, the eigenvectors, and some information from the solver

# Fields (Attributes)
- `values::AbstractVector`: the eigenvalues
- `vectors::AbstractMatrix`: the transformation matrix (eigenvectors)
- `type::Union{Nothing,QuantumObjectType}`: the type of [`QuantumObject`](@ref), or `nothing` means solving eigen equation for general matrix
- `dimensions::Union{Nothing,Dimensions}`: the `dimensions` of [`QuantumObject`](@ref), or `nothing` means solving eigen equation for general matrix
- `iter::Int`: the number of iteration during the solving process
- `numops::Int` : number of times the linear map was applied in krylov methods
- `converged::Bool`: Whether the result is converged

!!! note "`dims` property"
    For a given `res::EigsolveResult`, `res.dims` or `getproperty(res, :dims)` returns its `dimensions` in the type of integer-vector.

# Examples
One can obtain the eigenvalues and the corresponding [`QuantumObject`](@ref)-type eigenvectors by:
```jldoctest
julia> result = eigenstates(sigmax())
EigsolveResult:   type=Operator()   dims=([2], [2])
values:
2-element Vector{Float64}:
 -1.0
  1.0
vectors:
2×2 Matrix{ComplexF64}:
 -0.707107+0.0im  0.707107+0.0im
  0.707107+0.0im  0.707107+0.0im

julia> λ, ψ, U = result;

julia> λ # eigenvalues
2-element Vector{Float64}:
 -1.0
  1.0

julia> ψ # eigenvectors
2-element Vector{QuantumObject{Ket, Dimensions{Space, Space}, Vector{ComplexF64}}}:

Quantum Object:   type=Ket()   dims=([2], [1])   size=(2,)
2-element Vector{ComplexF64}:
 -0.7071067811865475 + 0.0im
  0.7071067811865475 + 0.0im

Quantum Object:   type=Ket()   dims=([2], [1])   size=(2,)
2-element Vector{ComplexF64}:
 0.7071067811865475 + 0.0im
 0.7071067811865475 + 0.0im

julia> U # the transformation matrix
2×2 Matrix{ComplexF64}:
 -0.707107+0.0im  0.707107+0.0im
  0.707107+0.0im  0.707107+0.0im
```
"""
struct EigsolveResult{
        T1 <: AbstractVector{<:Number},
        T2 <: AbstractMatrix{<:Number},
        ObjType <: Union{Nothing, Operator, SuperOperator},
        DimType <: Union{Nothing, Dimensions},
    }
    values::T1
    vectors::T2
    type::ObjType
    dimensions::DimType
    iter::Int
    numops::Int
    converged::Bool
end

function Base.getproperty(res::EigsolveResult, key::Symbol)
    # a comment here to avoid bad render by JuliaFormatter
    if key === :dims
        return dimensions_to_dims(getfield(res, :dimensions))
    else
        return getfield(res, key)
    end
end

Base.iterate(res::EigsolveResult) = (res.values, Val(:vector_list))
Base.iterate(res::EigsolveResult{T1, T2, Nothing}, ::Val{:vector_list}) where {T1, T2} =
    ([res.vectors[:, k] for k in 1:length(res.values)], Val(:vectors))
Base.iterate(res::EigsolveResult{T1, T2, Operator}, ::Val{:vector_list}) where {T1, T2} =
    ([QuantumObject(res.vectors[:, k], Ket(), Dimensions(res.dimensions.to, Space(1))) for k in 1:length(res.values)], Val(:vectors))
Base.iterate(res::EigsolveResult{T1, T2, SuperOperator}, ::Val{:vector_list}) where {T1, T2} =
    ([QuantumObject(res.vectors[:, k], OperatorKet(), Dimensions(res.dimensions.to, Space(1))) for k in 1:length(res.values)], Val(:vectors))
Base.iterate(res::EigsolveResult, ::Val{:vectors}) = (res.vectors, Val(:done))
Base.iterate(res::EigsolveResult, ::Val{:done}) = nothing

function Base.show(io::IO, res::EigsolveResult)
    println(io, "EigsolveResult:   type=", res.type, "   dims=", _get_dims_string(res.dimensions))
    println(io, "values:")
    show(io, MIME("text/plain"), res.values)
    print(io, "\n")
    println(io, "vectors:")
    return show(io, MIME("text/plain"), res.vectors)
end

struct ArnoldiLindbladIntegratorMap{T, TS, TI} <: AbstractLinearMap{T, TS}
    elty::Type{T}
    size::TS
    integrator::TI
end

function LinearAlgebra.mul!(y::AbstractVector, A::ArnoldiLindbladIntegratorMap, x::AbstractVector)
    reinit!(A.integrator, x)
    solve!(A.integrator)
    return copyto!(y, A.integrator.u)
end

struct EigsolveInverseMap{T, TS, TI} <: AbstractLinearMap{T, TS}
    elty::Type{T}
    size::TS
    linsolve::TI
end

function LinearAlgebra.mul!(y::AbstractVector, A::EigsolveInverseMap, x::AbstractVector)
    A.linsolve.b .= x
    return copyto!(y, solve!(A.linsolve).u)
end

function _update_schur_eigs!(Hₘ, Uₘ, Uₘᵥ, f, k, β, sorted_vals, sortby, rev)
    copyto!(Uₘ, Hₘ)
    F = schur!(Uₘ)

    values = F.values
    sortperm!(sorted_vals, values, by = sortby, rev = rev)

    select = fill(false, length(values))
    @inbounds for j in 1:k
        select[sorted_vals[j]] = true
    end

    ordschur!(F, select)

    copyto!(Hₘ, F.T)
    copyto!(Uₘ, F.Z)
    mul!(f, Uₘᵥ, β)

    return nothing
end

# Pure Julia implementation of computing right eigenvectors from Schur form
# Instead of using LAPACK.trevc!('R', 'A', select, Tₘ)
function _schur_right_eigenvectors(Tₘ::AbstractMatrix, k::Integer)
    n = size(Tₘ, 1)
    vecs = zeros(eltype(Tₘ), n, k)

    @inbounds for col in 1:k
        vec = view(vecs, :, col)
        vec[col] = one(eltype(Tₘ))
        λ = Tₘ[col, col]

        for row in (col - 1):-1:1
            acc = zero(eltype(Tₘ))
            for inner in (row + 1):col
                acc += Tₘ[row, inner] * vec[inner]
            end
            denom = Tₘ[row, row] - λ
            vec[row] = if abs(denom) <= eps(typeof(abs(λ))) * max(one(typeof(abs(λ))), abs(λ))
                zero(eltype(Tₘ))
            else
                -acc / denom
            end
        end

        normalize!(vec)
    end

    return vecs
end

function _eigsolve(
        A,
        b::AbstractVector{T},
        type::ObjType,
        dimensions::Union{Nothing, Dimensions},
        k::Int = 1,
        m::Int = max(20, 2 * k + 1);
        tol::Real = 1.0e-8,
        maxiter::Int = 200,
        sortby::Function = abs2,
        rev = true,
    ) where {T <: Number, ObjType <: Union{Nothing, Operator, SuperOperator}}
    n = size(A, 2)
    V = similar(b, n, m + 1)
    H = zeros(T, m + 1, m)

    arnoldi_init!(A, b, V, H)

    for i in 2:m
        β = arnoldi_step!(A, V, H, i)
        if β < tol && i > k
            m = i # happy breakdown
            break
        end
    end

    f = ones(eltype(A), m)

    Vₘ = view(V, :, 1:m)
    Hₘ = view(H, 1:m, 1:m)
    qₘ = view(V, :, m + 1)
    βeₘ = view(H, m + 1, 1:m)
    β = real(H[m + 1, m])
    Uₘ = one(Hₘ)

    Uₘᵥ = view(Uₘ, m, 1:m)

    cache0 = similar(b, m, m)
    cache1 = similar(b, size(V, 1), m)
    cache2 = similar(H, m)
    sorted_vals = Array{Int}(undef, m)

    V₁ₖ = view(V, :, 1:k)
    Vₖ₊₁ = view(V, :, k + 1)
    Hₖ₊₁₁ₖ = view(H, k + 1, 1:k)
    cache1₁ₖ = view(cache1, :, 1:k)
    cache2₁ₖ = view(cache2, 1:k)

    M = typeof(cache0)

    _update_schur_eigs!(Hₘ, Uₘ, Uₘᵥ, f, k, β, sorted_vals, sortby, rev)

    numops = m
    iter = 0
    while iter < maxiter && count(x -> abs(x) < tol, f) < k && β > tol
        # println( A * Vₘ * Uₘ ≈ Vₘ * Uₘ * M(Tₘ) + qₘ * M(transpose(βeₘ)) * Uₘ )     # SHOULD BE TRUE

        copyto!(cache0, Uₘ)
        mul!(cache1, Vₘ, cache0)
        copyto!(V₁ₖ, cache1₁ₖ)
        copyto!(Vₖ₊₁, qₘ)
        mul!(cache2, transpose(Uₘ), βeₘ) # transpose(βeₘ) * Uₘ
        copyto!(Hₖ₊₁₁ₖ, cache2₁ₖ)

        # println( A * view(V, :, 1:k) ≈ view(V, :, 1:k) * M(view(H, 1:k, 1:k)) + qₘ * M(transpose(view(transpose(βeₘ) * Uₘ, 1:k))) )     # SHOULD BE TRUE

        for j in (k + 1):m
            β = arnoldi_step!(A, V, H, j)
            if β < tol
                numops += j - k - 1
                break
            end
        end

        # println( A * Vₘ ≈ Vₘ * M(Hₘ) + qₘ * M(transpose(βeₘ)) )     # SHOULD BE TRUE

        _update_schur_eigs!(Hₘ, Uₘ, Uₘᵥ, f, k, β, sorted_vals, sortby, rev)

        numops += m - k - 1
        iter += 1
    end

    Tₘ = Hₘ
    vals = diag(view(Tₘ, 1:k, 1:k))
    VR = _schur_right_eigenvectors(Tₘ, k)
    mul!(cache1₁ₖ, Vₘ, M(Uₘ * VR))

    # Order the eigenvalues and eigenvectors
    idxs = sortperm(vals, by = sortby, rev = rev)
    vals = vals[idxs]
    vecs = cache1₁ₖ[:, idxs]

    settings.auto_tidyup && tidyup!(vecs)

    return EigsolveResult(vals, vecs, type, dimensions, iter, numops, (iter < maxiter))
end

@doc raw"""
    eigsolve(A::QuantumObject; 
        v0::Union{Nothing,AbstractVector}=nothing, 
        sigma::Union{Nothing, Number}=nothing,
        eigvals::Int = 1,
        krylovdim::Int = max(20, 2*k+1),
        tol::Real = 1e-8,
        maxiter::Int = 200,
        solver::Union{Nothing, SciMLLinearSolveAlgorithm} = nothing,
        sortby::Function = abs2,
        rev::Bool = true,
        kwargs...)

Solve for the eigenvalues and eigenvectors of a matrix `A` using the Arnoldi method.

# Arguments
- `A::QuantumObject`: the [`QuantumObject`](@ref) to solve eigenvalues and eigenvectors.
- `v0::Union{Nothing,AbstractVector}`: the initial vector for the Arnoldi method. Default is a random vector.
- `sigma::Union{Nothing, Number}`: the shift for the eigenvalue problem. Default is `nothing`.
- `eigvals::Int`: the number of eigenvalues to compute. Default is `1`.
- `krylovdim::Int`: the dimension of the Krylov subspace. Default is `max(20, 2*k+1)`.
- `tol::Real`: the tolerance for the Arnoldi method. Default is `1e-8`.
- `maxiter::Int`: the maximum number of iterations for the Arnoldi method. Default is `200`.
- `solver::Union{Nothing, SciMLLinearSolveAlgorithm}`: the linear solver algorithm. Default is `nothing`.
- `sortby::Function`: the function to sort eigenvalues. Default is `abs2`.
- `rev::Bool`: whether to sort in descending order. Default is `true`.
- `kwargs`: Additional keyword arguments passed to the solver.

# Notes
- For more details about `solver` and extra `kwargs`, please refer to [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/)

# Returns
- `EigsolveResult`: A struct containing the eigenvalues, the eigenvectors, and some information about the eigsolver
"""
function eigsolve(
        A::QuantumObject;
        v0::Union{Nothing, AbstractVector} = nothing,
        sigma::Union{Nothing, Number} = nothing,
        eigvals::Int = 1,
        krylovdim::Int = max(20, 2 * eigvals + 1),
        tol::Real = 1.0e-8,
        maxiter::Int = 200,
        solver::Union{Nothing, SciMLLinearSolveAlgorithm} = nothing,
        sortby::Function = abs2,
        rev::Bool = true,
        kwargs...,
    )
    return eigsolve(
        A.data;
        v0 = v0,
        type = A.type,
        dimensions = A.dimensions,
        sigma = sigma,
        eigvals = eigvals,
        krylovdim = krylovdim,
        tol = tol,
        maxiter = maxiter,
        solver = solver,
        sortby = sortby,
        rev = rev,
        kwargs...,
    )
end

function eigsolve(
        A;
        v0::Union{Nothing, AbstractVector} = nothing,
        type::Union{Nothing, Operator, SuperOperator} = nothing,
        dimensions = nothing,
        sigma::Union{Nothing, Number} = nothing,
        eigvals::Int = 1,
        krylovdim::Int = max(20, 2 * eigvals + 1),
        tol::Real = 1.0e-8,
        maxiter::Int = 200,
        solver::Union{Nothing, SciMLLinearSolveAlgorithm} = nothing,
        sortby::Function = abs2,
        rev::Bool = true,
        kwargs...,
    )
    T = eltype(A)
    isnothing(v0) && (v0 = normalize!(rand(T, size(A, 1))))

    if isnothing(sigma)
        res = _eigsolve(
            A,
            v0,
            type,
            dimensions,
            eigvals,
            krylovdim,
            tol = tol,
            maxiter = maxiter,
            sortby = sortby,
            rev = rev,
        )
        vals = res.values
    else
        Aₛ = A - sigma * I

        kwargs2 = (; kwargs...)

        !haskey(kwargs2, :abstol) && (kwargs2 = merge(kwargs2, (abstol = tol * 1.0e-6,)))
        !haskey(kwargs2, :reltol) && (kwargs2 = merge(kwargs2, (reltol = tol * 1.0e-6,)))
        !haskey(kwargs2, :assumptions) && (kwargs2 = merge(kwargs2, (assumptions = OperatorAssumptions(true),)))

        prob = LinearProblem{true}(Aₛ, v0)

        linsolve = if isnothing(solver)
            if typeof(A) <: SparseMatrixCSC && isprimitivetype(T)
                init(prob, UMFPACKFactorization(); kwargs2...)
            else
                init(prob; kwargs2...)
            end
        else
            init(prob, solver; kwargs2...)
        end

        Amap = EigsolveInverseMap(T, size(A), linsolve)

        res = _eigsolve(
            Amap,
            v0,
            type,
            dimensions,
            eigvals,
            krylovdim,
            tol = tol,
            maxiter = maxiter,
            sortby = sortby,
            rev = rev,
        )
        vals = @. (1 + sigma * res.values) / res.values
    end

    vecs = res.vectors
    settings.auto_tidyup && tidyup!(vecs)

    return EigsolveResult(vals, vecs, res.type, res.dimensions, res.iter, res.numops, res.converged)
end

@doc raw"""
    eigsolve_al(
        H::AbstractQuantumObject{HOpType},
        T::Real,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing;
        alg::AbstractODEAlgorithm = DP5(),
        params = NullParameters(),
        ρ0::Union{Nothing,QuantumObject{SOpType}} = nothing,
        eigvals::Int = 1,
        krylovdim::Int = max(20, 2 * eigvals + 1),
        maxiter::Int = 200,
        eigstol::Real = 1e-8,
        liouvillian_eigs::Union{Val,Bool} = Val(false),
        sortby::Function = abs2,
        rev::Bool = true,
        kwargs...,
    )

Solve the eigenvalue problem for a Liouvillian superoperator ``\mathcal{L}`` (or Hamiltonian ``\hat{H}``) using the Arnoldi-Lindblad method.

This method finds eigenvalues and eigenvectors of the time-ordered propagator ``\mathcal{G}(T) = \mathcal{T} e^{\int_0^T \mathcal{L}(t) dt}`` by iteratively applying time evolution to build a Krylov subspace. For closed systems (when `c_ops` is `nothing` and `H` is an [`Operator`](@ref)), it instead solves for the unitary propagator ``\hat{U}(T) = \mathcal{T} e^{-i \int_0^T \hat{H}(t) dt}``.

# Arguments
- `H`: The Hamiltonian (or directly the Liouvillian) of the system. It can be either a [`QuantumObject`](@ref) or a [`QuantumObjectEvolution`](@ref).
- `T`: The time at which to evaluate the time evolution propagator.
- `c_ops`: A vector of collapse operators. Default is `nothing`, meaning the system is closed.
- `alg`: The differential equation solver algorithm. Default is `DP5()`.
- `params`: Parameters to pass to the solver. This argument is usually expressed as a `NamedTuple` or `AbstractVector` of parameters. For more advanced usage, any custom struct can be used.
- `ρ0`: The initial state. If not specified, a random initial state is used (a random [`Ket`](@ref) for closed systems or a random [`OperatorKet`](@ref) for open systems). The initial state type should match the system type.
- `eigvals`: The number of eigenvalues to compute.
- `krylovdim`: The dimension of the Krylov subspace.
- `maxiter`: The maximum number of iterations for the eigsolver.
- `eigstol`: The tolerance for the eigsolver.
- `liouvillian_eigs`: If `Val(true)`, return the eigenvalues of the Liouvillian (or Hamiltonian) obtained via ``\lambda = \log(\mu) / T`` where ``\mu`` are the propagator eigenvalues. If `Val(false)` (default), return the propagator eigenvalues directly. Using non-`Val` types might lead to type instabilities.
- `sortby::Function`: The function to sort eigenvalues. Default is `abs2`.
- `rev::Bool`: Whether to sort in descending order. Default is `true`.
- `kwargs`: Additional keyword arguments passed to the differential equation solver.

# Notes
- For closed systems (`c_ops = nothing` with `H` as an [`Operator`](@ref)), the method internally uses [`sesolve`](@ref) via [`mesolveProblem`](@ref).
- For open systems, the method uses [`mesolve`](@ref) internally.
- For more details about `alg`, please refer to [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/).
- For more details about `kwargs`, please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `eigsolve_al(...; liouvillian_eigs=Val(liouvillian_eigs))` instead of `eigsolve_al(...; liouvillian_eigs=liouvillian_eigs)`. See the [related Section](@ref doc:Type-Stability) about type stability for more details.

# Returns
- `EigsolveResult`: A struct containing the eigenvalues, the eigenvectors, and some information about the eigsolver. See also [`EigsolveResult`](@ref).

# References
- [Minganti-Huybrechts2022](@citet)
"""
function eigsolve_al(
        H::AbstractQuantumObject{HOpType},
        T::Real,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        alg::AbstractODEAlgorithm = DP5(),
        params = NullParameters(),
        ρ0::Union{Nothing, QuantumObject{SOpType}} = nothing,
        eigvals::Int = 1,
        krylovdim::Int = max(20, 2 * eigvals + 1),
        maxiter::Int = 200,
        eigstol::Real = 1.0e-8,
        liouvillian_eigs::Union{Val, Bool} = Val(false),
        sortby::Function = abs2,
        rev::Bool = true,
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, SOpType <: Union{Ket, OperatorKet}}
    is_unitary_evo = isoper(H) && isnothing(c_ops)
    L = is_unitary_evo ? H : liouvillian(H, c_ops)

    # Generate random initial state if not provided
    Te = eltype(H)
    ρ0_vec = if isnothing(ρ0)
        is_unitary_evo ? rand_ket(Te, Dimensions(H.dimensions.to, Space(1))) : mat2vec(rand_dm(Te, L.dimensions.to.op_dims))
    else
        ρ0
    end

    prob = mesolveProblem(L, ρ0_vec, [zero(T), T]; params = params, progress_bar = Val(false), kwargs...)
    integrator = init(prob.prob, alg)

    Lmap = ArnoldiLindbladIntegratorMap(Te, size(prob.prob.f.f), integrator)

    res_type = is_unitary_evo ? Operator() : SuperOperator()
    res = _eigsolve(
        Lmap,
        ρ0_vec.data,
        res_type,
        L.dimensions,
        eigvals,
        krylovdim,
        maxiter = maxiter,
        tol = eigstol,
        sortby = sortby,
        rev = rev,
    )

    vecs = res.vectors
    vals = if getVal(liouvillian_eigs)
        log.(complex.(res.values)) ./ T
    else
        res.values
    end

    settings.auto_tidyup && tidyup!(vecs)

    return EigsolveResult(vals, vecs, res.type, res.dimensions, res.iter, res.numops, res.converged)
end

@doc raw"""
    LinearAlgebra.eigen(A::QuantumObject; kwargs...)

Calculates the eigenvalues and eigenvectors of the [`QuantumObject`](@ref) `A` using
the Julia [LinearAlgebra](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/) package.

```jldoctest
julia> a = destroy(5);

julia> H = a + a';

julia> using LinearAlgebra;

julia> E, ψ = eigen(H); # eigenvalues and eigenvectors

julia> round.(E, digits = 5)
5-element Vector{Float64}:
 -2.85697
 -1.35563
  0.0
  1.35563
  2.85697

julia> expect(H, ψ[1]) ≈ E[1]
true
```
"""
function LinearAlgebra.eigen(A::QuantumObject{OpType}; kwargs...) where {OpType <: Union{Operator, SuperOperator}}
    # This creates a weak Union type on CPU. See https://github.com/JuliaLang/LinearAlgebra.jl/issues/1498
    F = eigen(to_dense(A.data); kwargs...)

    E = F.values
    U = F.vectors
    settings.auto_tidyup && tidyup!(U)

    return EigsolveResult(E, U, A.type, A.dimensions, 0, 0, true)
end

@doc raw"""
    LinearAlgebra.eigvals(A::QuantumObject; kwargs...)

Same as [`eigen(A::QuantumObject; kwargs...)`](@ref) but for only the eigenvalues.
"""
LinearAlgebra.eigvals(A::QuantumObject{OpType}; kwargs...) where {OpType <: Union{Operator, SuperOperator}} =
    eigvals(to_dense(A.data); kwargs...)

@doc raw"""
    eigenenergies(A::QuantumObject; sparse::Union{Bool,Val}=Val(false), kwargs...)

Calculate the eigenenergies

# Arguments
- `A::QuantumObject`: the [`QuantumObject`](@ref) to solve eigenvalues
- `sparse::Union{Bool,Val}`: if `false` call [`eigvals(A::QuantumObject; kwargs...)`](@ref), otherwise call [`eigsolve`](@ref). Default to `Val(false)`.
- `kwargs`: Additional keyword arguments passed to the solver. If `sparse=true`, the keyword arguments are passed to [`eigsolve`](@ref), otherwise to [`eigen`](@ref).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `eigenenergies(A; sparse=Val(sparse))` instead of `eigenenergies(A; sparse=sparse)`. See the [related Section](@ref doc:Type-Stability) about type stability for more details.

# Returns
- `::Vector{<:Number}`: a list of eigenvalues
"""
function eigenenergies(
        A::QuantumObject{OpType};
        sparse::Union{Bool, Val} = Val(false),
        kwargs...,
    ) where {OpType <: Union{Operator, SuperOperator}}
    if getVal(sparse)
        return eigsolve(A; kwargs...).values
    else
        return eigvals(A; kwargs...)
    end
end

@doc raw"""
    eigenstates(A::QuantumObject; sparse::Union{Bool,Val}=Val(false), kwargs...)

Calculate the eigenvalues and corresponding eigenvectors

# Arguments
- `A::QuantumObject`: the [`QuantumObject`](@ref) to solve eigenvalues and eigenvectors
- `sparse::Union{Bool,Val}`: if `false` call [`eigen(A::QuantumObject; kwargs...)`](@ref), otherwise call [`eigsolve`](@ref). Default to `Val(false)`.
- `kwargs`: Additional keyword arguments passed to the solver. If `sparse=true`, the keyword arguments are passed to [`eigsolve`](@ref), otherwise to [`eigen`](@ref).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `eigenstates(A; sparse=Val(sparse))` instead of `eigenstates(A; sparse=sparse)`. See the [related Section](@ref doc:Type-Stability) about type stability for more details.

# Returns
- `::EigsolveResult`: containing the eigenvalues, the eigenvectors, and some information from the solver. see also [`EigsolveResult`](@ref)
"""
function eigenstates(
        A::QuantumObject{OpType};
        sparse::Union{Bool, Val} = Val(false),
        kwargs...,
    ) where {OpType <: Union{Operator, SuperOperator}}
    if getVal(sparse)
        return eigsolve(A; kwargs...)
    else
        return eigen(A; kwargs...)
    end
end

#=
Helper functions for the mcsolve callbacks.
=#

struct SaveFuncMCSolve{TE, IT, TEXPV} <: AbstractSaveFunc
    e_ops::TE
    iter::IT
    expvals::TEXPV
end

(f::SaveFuncMCSolve)(u, t, integrator) = _save_func_mcsolve(u, integrator, f.e_ops, f.iter, f.expvals)

_get_save_callback_idx(cb, ::Type{SaveFuncMCSolve}) = _mcsolve_has_continuous_jump(cb) ? 1 : 2

##
struct LindbladJump{
        T1,
        T2,
        RNGType <: AbstractRNG,
        RandT,
        CT <: AbstractVector,
        WT <: AbstractVector,
        JTT <: AbstractVector,
        JWT <: AbstractVector,
        JTWIT,
    }
    c_ops::T1
    c_ops_herm::T2
    traj_rng::RNGType
    random_n::RandT
    cache_mc::CT
    weights_mc::WT
    cumsum_weights_mc::WT
    col_times::JTT
    col_which::JWT
    col_times_which_idx::JTWIT
end

(f::LindbladJump)(integrator) = _lindblad_jump_affect!(
    integrator,
    f.c_ops,
    f.c_ops_herm,
    f.traj_rng,
    f.random_n,
    f.cache_mc,
    f.weights_mc,
    f.cumsum_weights_mc,
    f.col_times,
    f.col_which,
    f.col_times_which_idx,
)

##

function _save_func_mcsolve(u, integrator, e_ops, iter, expvals)
    cache_mc = _mc_get_jump_callback(integrator).affect!.cache_mc

    copyto!(cache_mc, u)
    normalize!(cache_mc)
    ψ = cache_mc
    _expect = op -> dot(ψ, op, ψ)
    @. expvals[:, iter[]] = _expect(e_ops)
    iter[] += 1

    u_modified!(integrator, false)
    return nothing
end

function _generate_mcsolve_kwargs(ψ0, T, e_ops, tlist, c_ops, jump_callback, rng, kwargs)
    c_ops_data = get_data.(c_ops)
    c_ops_herm_data = map(op -> op' * op, c_ops_data)

    cache_mc = similar(ψ0.data, T)
    weights_mc = Vector{Float64}(undef, length(c_ops))
    cumsum_weights_mc = similar(weights_mc)

    col_times = Vector{Float64}(undef, COL_TIMES_WHICH_INIT_SIZE)
    col_which = Vector{Int}(undef, COL_TIMES_WHICH_INIT_SIZE)
    col_times_which_idx = Ref(1)

    random_n = Ref(rand(rng))

    _affect! = LindbladJump(
        c_ops_data,
        c_ops_herm_data,
        rng,
        random_n,
        cache_mc,
        weights_mc,
        cumsum_weights_mc,
        col_times,
        col_which,
        col_times_which_idx,
    )

    if jump_callback isa DiscreteLindbladJumpCallback
        cb1 = DiscreteCallback(_mcsolve_discrete_condition, _affect!, save_positions = (false, false))
    else
        cb1 = ContinuousCallback(
            _mcsolve_continuous_condition,
            _affect!,
            nothing,
            interp_points = jump_callback.interp_points,
            save_positions = (false, false),
        )
    end

    if e_ops isa Nothing
        # We are implicitly saying that we don't have a `Progress`
        kwargs2 = _merge_kwargs_with_callback(kwargs, cb1)
    else
        expvals = Array{ComplexF64}(undef, length(e_ops), length(tlist))

        _save_func = SaveFuncMCSolve(get_data.(e_ops), Ref(1), expvals)
        cb2 = FunctionCallingCallback(_save_func, funcat = tlist)
        kwargs2 = _merge_kwargs_with_callback(kwargs, CallbackSet(cb1, cb2))
    end
    return kwargs2
end

function _lindblad_jump_affect!(
        integrator,
        c_ops,
        c_ops_herm,
        traj_rng,
        random_n,
        cache_mc,
        weights_mc,
        cumsum_weights_mc,
        col_times,
        col_which,
        col_times_which_idx,
    )
    ψ = integrator.u

    @inbounds for i in eachindex(weights_mc)
        weights_mc[i] = real(dot(ψ, c_ops_herm[i], ψ))
    end
    cumsum!(cumsum_weights_mc, weights_mc)
    r = rand(traj_rng) * sum(weights_mc)
    collapse_idx = getindex(1:length(weights_mc), findfirst(>(r), cumsum_weights_mc))
    mul!(cache_mc, c_ops[collapse_idx], ψ)
    normalize!(cache_mc)
    copyto!(integrator.u, cache_mc)

    random_n[] = rand(traj_rng)

    idx = col_times_which_idx[]
    @inbounds col_times[idx] = integrator.t
    @inbounds col_which[idx] = collapse_idx
    col_times_which_idx[] += 1
    if col_times_which_idx[] > length(col_times)
        resize!(col_times, length(col_times) + COL_TIMES_WHICH_INIT_SIZE)
        resize!(col_which, length(col_which) + COL_TIMES_WHICH_INIT_SIZE)
    end
    u_modified!(integrator, true)
    return nothing
end

_mcsolve_continuous_condition(u, t, integrator) =
    @inbounds _mc_get_jump_callback(integrator).affect!.random_n[] - real(dot(u, u))

_mcsolve_discrete_condition(u, t, integrator) =
    @inbounds real(dot(u, u)) < _mc_get_jump_callback(integrator).affect!.random_n[]

##

function _mc_get_jump_callback(sol::AbstractODESolution)
    kwargs = NamedTuple(sol.prob.kwargs) # Convert to NamedTuple to support Zygote.jl
    return _mc_get_jump_callback(kwargs.callback) # There is always the Jump callback
end
_mc_get_jump_callback(integrator::AbstractODEIntegrator) = _mc_get_jump_callback(integrator.opts.callback)
_mc_get_jump_callback(cb::CallbackSet) =
if _mcsolve_has_continuous_jump(cb)
    return cb.continuous_callbacks[1]
else
    return cb.discrete_callbacks[1]
end
_mc_get_jump_callback(cb::ContinuousCallback) = cb
_mc_get_jump_callback(cb::DiscreteCallback) = cb

##

#=
    With this function we extract the c_ops and c_ops_herm from the LindbladJump `affect!` function of the callback of the integrator.
    This callback can be a DiscreteLindbladJumpCallback or a ContinuousLindbladJumpCallback.
=#
function _mcsolve_get_c_ops(integrator::AbstractODEIntegrator)
    cb = _mc_get_jump_callback(integrator)
    if cb isa Nothing
        return nothing
    else
        return cb.affect!.c_ops, cb.affect!.c_ops_herm
    end
end

#=
    _mcsolve_initialize_callbacks(prob, tlist)

Return the same callbacks of the `prob`, but with the `iter` variable reinitialized to 1 and the `expvals` variable reinitialized to a new matrix.
=#
function _mcsolve_initialize_callbacks(prob, tlist, traj_rng)
    cb = prob.kwargs[:callback]
    return _mcsolve_initialize_callbacks(cb, tlist, traj_rng)
end
function _mcsolve_initialize_callbacks(cb::CallbackSet, tlist, traj_rng)
    cb_continuous = cb.continuous_callbacks
    cb_discrete = cb.discrete_callbacks

    if _mcsolve_has_continuous_jump(cb)
        idx = 1
        if cb_discrete[idx].affect!.func isa SaveFuncMCSolve
            e_ops = cb_discrete[idx].affect!.func.e_ops
            expvals = similar(cb_discrete[idx].affect!.func.expvals)
            _save_func = SaveFuncMCSolve(e_ops, Ref(1), expvals)
            cb_save = (FunctionCallingCallback(_save_func, funcat = tlist),)
        else
            cb_save = ()
        end

        _jump_affect! = _similar_affect!(cb_continuous[1].affect!, traj_rng)
        cb_jump = _modify_field(cb_continuous[1], :affect!, _jump_affect!)

        return CallbackSet((cb_jump, cb_continuous[2:end]...), (cb_save..., cb_discrete[2:end]...))
    else
        idx = 2
        if cb_discrete[idx].affect!.func isa SaveFuncMCSolve
            e_ops = cb_discrete[idx].affect!.func.e_ops
            expvals = similar(cb_discrete[idx].affect!.func.expvals)
            _save_func = SaveFuncMCSolve(e_ops, Ref(1), expvals)
            cb_save = (FunctionCallingCallback(_save_func, funcat = tlist),)
        else
            cb_save = ()
        end

        _jump_affect! = _similar_affect!(cb_discrete[1].affect!, traj_rng)
        cb_jump = _modify_field(cb_discrete[1], :affect!, _jump_affect!)

        return CallbackSet(cb_continuous, (cb_jump, cb_save..., cb_discrete[3:end]...))
    end
end
function _mcsolve_initialize_callbacks(cb::CBT, tlist, traj_rng) where {CBT <: Union{ContinuousCallback, DiscreteCallback}}
    _jump_affect! = _similar_affect!(cb.affect!, traj_rng)
    return _modify_field(cb, :affect!, _jump_affect!)
end

#=
    _similar_affect!

Return a new LindbladJump with the same fields as the input LindbladJump but with new memory.
=#
function _similar_affect!(affect::LindbladJump, traj_rng)
    random_n = Ref(rand(traj_rng))
    cache_mc = similar(affect.cache_mc)
    weights_mc = similar(affect.weights_mc)
    cumsum_weights_mc = similar(affect.cumsum_weights_mc)
    col_times = similar(affect.col_times)
    col_which = similar(affect.col_which)
    col_times_which_idx = Ref(1)

    return LindbladJump(
        affect.c_ops,
        affect.c_ops_herm,
        traj_rng,
        random_n,
        cache_mc,
        weights_mc,
        cumsum_weights_mc,
        col_times,
        col_which,
        col_times_which_idx,
    )
end

Base.@constprop :aggressive function _modify_field(obj::T, field_name::Symbol, field_val) where {T}
    # Create a NamedTuple of fields, deepcopying only the selected ones
    fields = (name != field_name ? (getfield(obj, name)) : field_val for name in fieldnames(T))
    # Reconstruct the struct with the updated fields
    return Base.typename(T).wrapper(fields...)
end

_mcsolve_has_continuous_jump(cb::CallbackSet) =
    (length(cb.continuous_callbacks) > 0) && (cb.continuous_callbacks[1].affect! isa LindbladJump)
_mcsolve_has_continuous_jump(cb::ContinuousCallback) = true
_mcsolve_has_continuous_jump(cb::DiscreteCallback) = false

function H_dfd2(dims, p)
    Δ = p.Δ
    F = p.F
    J = p.J
    a = tensor(destroy(dims[1]), qeye(dims[2]))
    b = tensor(qeye(dims[1]), destroy(dims[2]))
    return Δ * a' * a + F * (a + a') + Δ * b' * b + J * (a' * b + a * b')
end
function c_ops_dfd2(dims, p)
    κ = p.κ
    a = tensor(destroy(dims[1]), qeye(dims[2]))
    b = tensor(qeye(dims[1]), destroy(dims[2]))
    return [√κ * a, √κ * b]
end
function e_ops_dfd2(dims, p)
    a = tensor(destroy(dims[1]), qeye(dims[2]))
    b = tensor(qeye(dims[1]), destroy(dims[2]))
    return [a' * a, b' * b]
end

function benchmark_dfd!(SUITE)
    F, Δ, κ, J = 1, 0.25, 1, 0.05
    maxdims = [50, 50]

    ψ0 = tensor(fock(3, 0), fock(20, 15))
    dfd_params = (Δ = Δ, F = F, κ = κ, J = J)

    tlist = range(0, 15 / κ, 100)

    SUITE["Time Evolution"]["Dynamical Fock Dimension"] = @benchmarkable dfd_mesolve(
        H_dfd2,
        $ψ0,
        $tlist,
        c_ops_dfd2,
        $maxdims,
        $dfd_params,
        e_ops = e_ops_dfd2,
        progress_bar = false,
    )

    return nothing
end

@doc raw"""
    matrix_heatmap(
        library::Val{:Makie},
        M::Union{QuantumObject,AbstractMatrix};
        method::Union{Symbol,Val} = Val(:real),
        xbasis::Union{Nothing,AbstractVector} = nothing,
        ybasis::Union{Nothing,AbstractVector} = nothing,
        limits::Union{Nothing,Tuple{Real,Real}} = nothing,
        show_grid::Bool = true,
        grid_alpha::Real = 0.5,
        xlabel_top::Bool = true,
        colorbar::Bool = true,
        colorbar_label::Union{Nothing,AbstractString} = nothing,
        colormap = :RdBu,
        colorrange::Union{Nothing,Tuple{Real,Real}} = nothing,
        location::Union{GridPosition,Nothing} = nothing,
        kwargs...,
    )

Plot a heatmap for the elements of matrix `M`.

# Arguments
- `library::Val{:Makie}`: The plotting library to use.
- `M::Union{QuantumObject,AbstractMatrix}`: The [`QuantumObject`](@ref) or `AbstractMatrix` for which to be plotted. If it is a [`QuantumObject`](@ref), tt can be either a [`Operator`](@ref) or [`SuperOperator`](@ref).
- `method::Union{Symbol,Val}`: Method to use for plotting the matrix elements. Can be either `:real`, `:imag`, `:abs`, or `:angle`. Default is `Val(:real)`.
- `xbasis::Union{Nothing,AbstractVector}`: List of `x`-ticklabels. If `nothing`, the labels of computational basis will be automatically created. Default is `nothing`.
- `ybasis::Union{Nothing,AbstractVector}`: List of `y`-ticklabels. If `nothing`, the labels of computational basis will be automatically created. Default is `nothing`.
- `limits::Union{Nothing,Tuple{Real,Real}}`: The `z`-axis limits `(z_min, z_max)`. If `nothing`, the limits will be automatically decided. Default is `nothing`.
- `show_grid::Bool`: Whether to show the grid. Default is `true`.
- `grid_alpha::Real`: Transparency of the grid. Default is `0.5`.
- `xlabel_top::Bool`: Whether to place the `x`-ticklabels on top. Default is `true`.
- `colorbar::Bool`: Whether to show the color bar. Default is `true`.
- `colorbar_label::Union{Nothing,AbstractString}`: Label of color bar. If nothing, it will automatically use the string of `method`. Default is `nothing`.
- `colormap`: The color map to use when plotting. Default is `:RdBu`.
- `colorrange::Union{Nothing,Tuple{Real,Real}}`: The color bar limits `(min, max)`. If nothing, it will automatically use (`z`-axis) `limits`. Default is `nothing`.
- `location::Union{GridPosition,Nothing}`: The location of the plot in the layout. If `nothing`, the plot is created in a new figure. Default is `nothing`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function.

# Returns
- `fig`: The figure object.
- `ax`: The axis object.
- `hm`: The heatmap object.

!!! note "Import library first"
    [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) must first be imported before using this function. This can be done by importing one of the available backends, such as [`CairoMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/CairoMakie), [`GLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/GLMakie), or [`WGLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/WGLMakie).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `method = Val(:real)`, `Val(:imag)`, `Val(:abs)`, and `Val(:angle)` instead of `:real`, `:imag`, `:abs`, and `:angle`, respectively. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function QuantumToolbox.matrix_heatmap(
        library::Val{:Makie},
        M::Union{QuantumObject{QT}, AbstractMatrix{MT}};
        method::Union{Symbol, Val} = Val(:real),
        xbasis::Union{Nothing, AbstractVector} = nothing,
        ybasis::Union{Nothing, AbstractVector} = nothing,
        limits::Union{Nothing, Tuple{Real, Real}} = nothing,
        show_grid::Bool = true,
        grid_alpha::Real = 0.5,
        xlabel_top::Bool = true,
        colorbar::Bool = true,
        colorbar_label::Union{Nothing, AbstractString} = nothing,
        colormap = :RdBu,
        colorrange::Union{Nothing, Tuple{Real, Real}} = nothing,
        location::Union{GridPosition, Nothing} = nothing,
        kwargs...,
    ) where {QT <: Union{Operator, SuperOperator}, MT <: Number}
    fig, location = _getFigAndLocation(location)
    lyt = GridLayout(location)

    # generate x, y, and z data
    # y-axis means row, x-axis means column
    Ny, Nx = size(M)
    xdata = 0:(Nx - 1)   # computational basis
    ydata = 0:(Ny - 1)   # computational basis
    zdata = _handle_matrix_plot_data(M, makeVal(method))

    # handle x and y ticks
    xbasis = isnothing(xbasis) ? _gen_default_bra_labels(M, xdata) : xbasis
    ybasis = isnothing(ybasis) ? _gen_default_ket_labels(M, ydata) : ybasis
    length(xbasis) == Nx || throw(ArgumentError("Length of xbasis ($(length(xbasis))) does not match matrix size: $Nx"))
    length(ybasis) == Ny || throw(ArgumentError("Length of ybasis ($(length(ybasis))) does not match matrix size: $Ny"))
    xticks = (xdata, xbasis)
    yticks = (ydata, ybasis)

    # handle z-axis limits and colorrange
    if isnothing(limits)
        # find the maximum absolute value of zdata (z_max) and set the default limit as: (-z_max, +z_max)
        # this makes the center of color bar represent 0, so the heatmap becomes clearer, and more transparent if we use colormap = :RdBu
        z_max = maximum(abs, zdata)
        limits = (-z_max, z_max)
    end
    colorrange = isnothing(colorrange) ? limits : colorrange

    # handle axis keyword arguments
    axis_kwargs = (
        aspect = Nx / Ny, # this ratio makes the elements always be squared size (even in non-squared matrix cases)
        xticks = xticks,
        yticks = yticks,
        yreversed = true,
        xlabelvisible = false,
        ylabelvisible = false,
        xticksvisible = false,
        yticksvisible = false,
        xgridvisible = false,
        ygridvisible = false,
        xminorticksvisible = false,
        yminorticksvisible = false,
    )

    # handle grid
    if show_grid
        # in order to show the grid at the edge of the squares, we use minorticks and minorgrid
        # note that the position of "ticks" is the center of each square (matrix element), and the length of each square is 1
        # so the half width of square is 0.5, and the grid position (minor ticks) should be given as: [0.5, 1.5, 2.5, ...]
        axis_kwargs = merge(
            axis_kwargs,
            (
                xminorgridvisible = true,
                yminorgridvisible = true,
                xminorgridcolor = (:black, grid_alpha),
                yminorgridcolor = (:black, grid_alpha),
                xminorticks = 0.5:(Nx - 0.5),
                yminorticks = 0.5:(Ny - 0.5),
            ),
        )
    end

    # handle x-axis position
    xaxisposition = xlabel_top ? :top : :bottom

    # create axis
    ax = Axis(lyt[1, 1]; xaxisposition = xaxisposition, axis_kwargs...)

    # plot heatmap
    hm = heatmap!(ax, xdata, ydata, zdata; colormap = colormap, colorrange = colorrange, kwargs...)

    # translate is required since the heatmap will be on top of the grid
    # thus, we move the heatmap to z = -100
    show_grid && translate!(hm, 0, 0, -100)

    # handle color bar
    if colorbar
        label = isnothing(colorbar_label) ? string(getVal(method)) : colorbar_label
        Colorbar(lyt[1, 2], hm, label = label)
    end

    return fig, ax, hm
end

@doc raw"""
    matrix_histogram(
        library::Val{:Makie},
        M::Union{QuantumObject,AbstractMatrix};
        method::Union{Symbol,Val} = Val(:real),
        xbasis::Union{Nothing,AbstractVector}=nothing,
        ybasis::Union{Nothing,AbstractVector}=nothing,
        limits::Union{Nothing,Tuple{Real,Real}}=nothing,
        xreversed::Bool = true,
        yreversed::Bool = false,
        azimuth::Real = -60,
        elevation::Real = 45,
        bars_spacing::Real = 0.2,
        shading::Bool = true,
        colorbar::Bool = true,
        colorbar_label::Union{Nothing,AbstractString} = nothing,
        colormap = :viridis,
        colorrange::Union{Nothing,Tuple{Real,Real}} = nothing,
        location::Union{GridPosition,Nothing} = nothing,
        kwargs...,
    )

Plot a 3D histogram for the elements of matrix `M`.

# Arguments
- `library::Val{:Makie}`: The plotting library to use.
- `M::Union{QuantumObject,AbstractMatrix}`: The [`QuantumObject`](@ref) or `AbstractMatrix` for which to be plotted. If it is a [`QuantumObject`](@ref), tt can be either a [`Operator`](@ref) or [`SuperOperator`](@ref).
- `method::Union{Symbol,Val}`: Method to use for plotting the matrix elements. Can be either `:real`, `:imag`, `:abs`, or `:angle`. Default is `Val(:real)`.
- `xbasis::Union{Nothing,AbstractVector}`: List of `x`-ticklabels. If `nothing`, the labels of computational basis will be automatically created. Default is `nothing`.
- `ybasis::Union{Nothing,AbstractVector}`: List of `y`-ticklabels. If `nothing`, the labels of computational basis will be automatically created. Default is `nothing`.
- `limits::Union{Nothing,Tuple{Real,Real}}`: The `z`-axis limits `(z_min, z_max)`. If `nothing`, the limits will be automatically decided. Default is `nothing`.
- `xreversed::Bool`: Whether to reverse the `x`-axis. Default is `true`.
- `yreversed::Bool`: Whether to reverse the `y`-axis. Default is `false`.
- `azimuth::Real`: The azimuthal viewing angle (in degrees). Default is `-60`.
- `elevation::Real`: The elevation viewing angle (in degrees). Default is `45`.
- `bars_spacing::Real`: Spacing between bars. Default is `0.2`.
- `shading::Bool`: Whether to shade the dark sides of the bars. Note that the shading is relative to plot's source of light. Default to `true`.
- `colorbar::Bool`: Whether to show the color bar. Default is `true`.
- `colorbar_label::Union{Nothing,AbstractString}`: Label of color bar. If nothing, it will automatically use the string of `method`. Default is `nothing`.
- `colormap`: The color map to use when plotting. Default is `:viridis`.
- `colorrange::Union{Nothing,Tuple{Real,Real}}`: The color bar limits `(min, max)`. If nothing, it will automatically use (`z`-axis) `limits`. Default is `nothing`.
- `location::Union{GridPosition,Nothing}`: The location of the plot in the layout. If `nothing`, the plot is created in a new figure. Default is `nothing`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function.

# Returns
- `fig`: The figure object.
- `ax`: The axis object.
- `ms`: The meshscatter object.

!!! note "Import library first"
    [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) must first be imported before using this function. This can be done by importing one of the available backends, such as [`CairoMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/CairoMakie), [`GLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/GLMakie), or [`WGLMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/WGLMakie).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `method = Val(:real)`, `Val(:imag)`, `Val(:abs)`, and `Val(:angle)` instead of `:real`, `:imag`, `:abs`, and `:angle`, respectively. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function QuantumToolbox.matrix_histogram(
        library::Val{:Makie},
        M::Union{QuantumObject{QT}, AbstractMatrix{MT}};
        method::Union{Symbol, Val} = Val(:real),
        xbasis::Union{Nothing, AbstractVector} = nothing,
        ybasis::Union{Nothing, AbstractVector} = nothing,
        limits::Union{Nothing, Tuple{Real, Real}} = nothing,
        xreversed::Bool = true,
        yreversed::Bool = false,
        azimuth::Real = -60,
        elevation::Real = 45,
        bars_spacing::Real = 0.2,
        shading::Bool = true,
        colorbar::Bool = true,
        colorbar_label::Union{Nothing, AbstractString} = nothing,
        colormap = :viridis,
        colorrange::Union{Nothing, Tuple{Real, Real}} = nothing,
        location::Union{GridPosition, Nothing} = nothing,
        kwargs...,
    ) where {QT <: Union{Operator, SuperOperator}, MT <: Number}
    fig, location = _getFigAndLocation(location)
    lyt = GridLayout(location)

    # generate x and y data
    # y-axis means row, x-axis means column
    Ny, Nx = size(M)
    xdata = 0:(Nx - 1)   # computational basis
    ydata = 0:(Ny - 1)   # computational basis

    # generate z data
    ## z0 mean the origin of all bars
    ## the matrix data (zdata) will be handled by scaling each marker size in meshscatter! later
    z0 = zeros(Nx, Ny)
    zdata = vec(_handle_matrix_plot_data(M, makeVal(method)))

    # handle x and y ticks
    xbasis = isnothing(xbasis) ? _gen_default_bra_labels(M, xdata) : xbasis
    ybasis = isnothing(ybasis) ? _gen_default_ket_labels(M, ydata) : ybasis
    length(xbasis) == Nx || throw(ArgumentError("Length of xbasis ($(length(xbasis))) does not match matrix size: $Nx"))
    length(ybasis) == Ny || throw(ArgumentError("Length of ybasis ($(length(ybasis))) does not match matrix size: $Ny"))
    xticks = (xdata, xbasis)
    yticks = (ydata, ybasis)

    # handle z-axis limits and colorrange
    if isnothing(limits)
        z_min = minimum(zdata)
        z_max = maximum(zdata)

        # must include 0 between the interval: [z_min, z_max]
        z_min = z_min > 0 ? 0 : z_min
        z_max = z_max < 0 ? 0 : z_max
        limits = (z_min, z_max)
    end
    colorrange = isnothing(colorrange) ? limits : colorrange

    # handle bar's edge length in x and y directions
    (0 ≤ bars_spacing ≤ 1) ||
        throw(ArgumentError("Invalid keyword argument bars_spacing = $(bars_spacing), should be: 0 ≤ bars_spacing ≤ 1"))
    bar_edge_length = 1 - bars_spacing

    # create 3D axis
    ax = Axis3(
        lyt[1, 1];
        aspect = (Nx / Ny, 1, 0.5), # this ratio makes the elements always be squared size (even in non-squared matrix cases)
        limits = ((-0.5, Nx - 0.5), (-0.5, Ny - 0.5), limits), # -0.5 in x and y originates from the half width of bar
        azimuth = deg2rad(azimuth),
        elevation = deg2rad(elevation),
        xticks = xticks,
        yticks = yticks,
        xreversed = xreversed,
        yreversed = yreversed,
        xlabelvisible = false,
        ylabelvisible = false,
        zlabelvisible = false,
        xticksvisible = false,
        yticksvisible = false,
        xgridvisible = false,
        ygridvisible = false,
    )

    # plot meshscatter
    ms = meshscatter!(
        ax,
        xdata,
        ydata,
        z0;
        marker = Rect3f((-0.5, -0.5, 0), (1, 1, 1)), # corner position of the bar (x=-0.5,y=-0.5,z=0); original width (1,1,1)
        markersize = Vec3f.(bar_edge_length, bar_edge_length, zdata), # scale the size of the marker
        shading = shading,
        backlight = 1, # this makes shading better when zdata contains exact zero values
        color = zdata,
        colormap = colormap,
        colorrange = colorrange,
        kwargs...,
    )

    # handle color bar
    if colorbar
        label = isnothing(colorbar_label) ? string(getVal(method)) : colorbar_label
        Colorbar(lyt[1, 2], ms, label = label)
    end

    return fig, ax, ms
end

using QuantumToolbox
using Documenter
using DocumenterVitepress
using DocumenterCitations
using Changelog

# Load of packages required to compile the extension documentation
using CairoMakie

doctest_setup = quote
    using LinearAlgebra
    using SparseArrays
    using QuantumToolbox
end
DocMeta.setdocmeta!(QuantumToolbox, :DocTestSetup, doctest_setup; recursive = true)

# some options for `makedocs`
const DRAFT = get(ENV, "DRAFT", false) == "true"  # `DRAFT   = true`  disables cell evaluation
const DOCTEST = get(ENV, "DOCTEST", true) == true # `DOCTEST = false` skips doc tests

# generate bibliography
bib = CitationBibliography(
    joinpath(@__DIR__, "src", "resources", "bibliography.bib"),
    style = :authoryear,
)

# generate changelog
Changelog.generate(
    Changelog.Documenter(),
    joinpath(@__DIR__, "..", "CHANGELOG.md"),
    joinpath(@__DIR__, "src", "resources", "changelog.md");
    repo = "qutip/QuantumToolbox.jl",
)

const PAGES = [
    "Home" => "index.md",
    "Getting Started" => [
        "Brief Example" => "getting_started/brief_example.md",
        # "Key differences from QuTiP" => "getting_started/qutip_differences.md",
        "The Importance of Type-Stability" => "getting_started/type_stability.md",
        "Example: Create QuantumToolbox.jl Logo" => "getting_started/logo.md",
        "Cite QuantumToolbox.jl" => "getting_started/cite.md",
    ],
    "Users Guide" => [
        "Basic Operations on Quantum Objects" => [
            "Quantum Objects (Qobj)" => "users_guide/QuantumObject/QuantumObject.md",
            "Functions operating on Qobj" => "users_guide/QuantumObject/QuantumObject_functions.md",
        ],
        "Manipulating States and Operators" => "users_guide/states_and_operators.md",
        "Tensor Products and Partial Traces" => "users_guide/tensor.md",
        "Time Evolution and Dynamics" => [
            "Introduction" => "users_guide/time_evolution/intro.md",
            "Time Evolution Solutions" => "users_guide/time_evolution/solution.md",
            "Schrödinger Equation Solver" => "users_guide/time_evolution/sesolve.md",
            "Lindblad Master Equation Solver" => "users_guide/time_evolution/mesolve.md",
            "Monte Carlo Solver" => "users_guide/time_evolution/mcsolve.md",
            "Stochastic Solver" => "users_guide/time_evolution/stochastic.md",
            "Solving Problems with Time-dependent Hamiltonians" => "users_guide/time_evolution/time_dependent.md",
            "Bloch-Redfield master equation" => "users_guide/time_evolution/brmesolve.md",
            "Computing propagators" => "users_guide/time_evolution/propagator.md",
        ],
        "Automatic Differentiation" => "users_guide/autodiff.md",
        "Intensive parallelization on a Cluster" => "users_guide/cluster.md",
        "Hierarchical Equations of Motion" => "users_guide/HEOM.md",
        "Solving for Steady-State Solutions" => "users_guide/steadystate.md",
        "Two-time correlation functions" => "users_guide/two_time_corr_func.md",
        "Plotting on the Bloch Sphere" => "users_guide/plotting_the_bloch_sphere.md",
        "Visualization of quantum states and operators" => "users_guide/visualization.md",
        "QuantumToolbox Settings" => "users_guide/settings.md",
        "Extensions" => [
            "Extension for CUDA.jl" => "users_guide/extensions/cuda.md",
            "Extension for the Makie.jl ecosystem" => "users_guide/extensions/makie.md",
        ],
    ],
    "Resources" => [
        "API" => "resources/api.md",
        "Bibliography" => "resources/bibliography.md",
        "ChangeLog" => "resources/changelog.md",
        "Contributing to QuantumToolbox.jl" => "resources/contributing.md",
        "Acknowledgements" => "resources/acknowledgements.md",
    ],
]

makedocs(;
    modules = [
        QuantumToolbox,
        Base.get_extension(QuantumToolbox, :QuantumToolboxMakieExt),
    ],
    authors = "Alberto Mercurio and Yi-Te Huang",
    repo = Remotes.GitHub("qutip", "QuantumToolbox.jl"),
    sitename = "QuantumToolbox.jl",
    pages = PAGES,
    format = DocumenterVitepress.MarkdownVitepress(
        repo = "github.com/qutip/QuantumToolbox.jl",
        devbranch = "main",
        devurl = "dev",
    ),
    draft = DRAFT,
    doctest = DOCTEST,
    plugins = [bib],
)

DocumenterVitepress.deploydocs(;
    repo = "github.com/qutip/QuantumToolbox.jl",
    target = joinpath(@__DIR__, "build"),
    devbranch = "main",
    branch = "gh-pages",
    push_preview = true,
)

export mcsolveProblem, mcsolveEnsembleProblem, mcsolve
export ContinuousLindbladJumpCallback, DiscreteLindbladJumpCallback

function _mcsolve_prob_func(prob, i, repeat, global_rng, seeds, tlist)
    seed = seeds[i]
    traj_rng = typeof(global_rng)()
    seed!(traj_rng, seed)

    f = deepcopy(prob.f.f)
    cb = _mcsolve_initialize_callbacks(prob, tlist, traj_rng)

    return remake(prob, f = f, callback = cb)
end

# Standard output function
function _mcsolve_output_func(sol, i)
    idx = _mc_get_jump_callback(sol).affect!.col_times_which_idx[]
    resize!(_mc_get_jump_callback(sol).affect!.col_times, idx - 1)
    resize!(_mc_get_jump_callback(sol).affect!.col_which, idx - 1)
    return (sol, false)
end

function _normalize_state!(u, dims, normalize_states)
    getVal(normalize_states) && normalize!(u)
    return QuantumObject(u, Ket(), dims)
end

function _mcsolve_make_Heff_QobjEvo(H::QuantumObject, c_ops)
    c_ops isa Nothing && return QuantumObjectEvolution(H)
    return QuantumObjectEvolution(H - 1im * mapreduce(op -> op' * op, +, c_ops) / 2)
end
function _mcsolve_make_Heff_QobjEvo(H::Tuple, c_ops)
    c_ops isa Nothing && return QuantumObjectEvolution(H)
    return QuantumObjectEvolution((H..., -1im * sum(op -> op' * op, c_ops) / 2))
end
function _mcsolve_make_Heff_QobjEvo(H::QuantumObjectEvolution, c_ops)
    c_ops isa Nothing && return H
    return H + QuantumObjectEvolution(sum(op -> -1im * op' * op / 2, c_ops))
end

@doc raw"""
    mcsolveProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        kwargs...,
    )

Generate the ODEProblem for a single trajectory of the Monte Carlo wave function time evolution of an open quantum system.

Given a system Hamiltonian ``\hat{H}`` and a list of collapse (jump) operators ``\{\hat{C}_n\}_n``, the evolution of the state ``|\psi(t)\rangle`` is governed by the Schrodinger equation:

```math
\frac{\partial}{\partial t} |\psi(t)\rangle= -i \hat{H}_{\textrm{eff}} |\psi(t)\rangle
```

with a non-Hermitian effective Hamiltonian:

```math
\hat{H}_{\textrm{eff}} = \hat{H} - \frac{i}{2} \sum_n \hat{C}_n^\dagger \hat{C}_n.
```

To the first-order of the wave function in a small time ``\delta t``, the strictly negative non-Hermitian portion in ``\hat{H}_{\textrm{eff}}`` gives rise to a reduction in the norm of the wave function, namely

```math
\langle \psi(t+\delta t) | \psi(t+\delta t) \rangle = 1 - \delta p,
```

where 

```math
\delta p = \delta t \sum_n \langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle
```

is the corresponding quantum jump probability.

If the environmental measurements register a quantum jump, the wave function undergoes a jump into a state defined by projecting ``|\psi(t)\rangle`` using the collapse operator ``\hat{C}_n`` corresponding to the measurement, namely

```math
| \psi(t+\delta t) \rangle = \frac{\hat{C}_n |\psi(t)\rangle}{ \sqrt{\langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle} }
```

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``.
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `c_ops`: List of collapse operators ``\{\hat{C}_n\}_n``. It can be either a `Vector` or a `Tuple`.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: Parameters to pass to the solver. This argument is usually expressed as a `NamedTuple` or `AbstractVector` of parameters. For more advanced usage, any custom struct can be used.
- `rng`: Random number generator for reproducibility.
- `jump_callback`: The Jump Callback type: Discrete or Continuous. The default is `ContinuousLindbladJumpCallback()`, which is more precise.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-6` and `abstol=1e-8`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

# Returns

- `prob`: The [`TimeEvolutionProblem`](@ref) containing the `ODEProblem` for the Monte Carlo wave function time evolution.
"""
function mcsolveProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        kwargs...,
    ) where {TJC <: LindbladJumpCallbackType}
    haskey(kwargs, :save_idxs) &&
        throw(ArgumentError("The keyword argument \"save_idxs\" is not supported in QuantumToolbox."))

    c_ops isa Nothing &&
        throw(ArgumentError("The list of collapse operators must be provided. Use sesolveProblem instead."))

    H_eff_evo = _mcsolve_make_Heff_QobjEvo(H, c_ops)

    T = _complex_float_type(Base.promote_eltype(H_eff_evo, ψ0))

    tlist = _check_tlist(tlist, _float_type(T))

    # We disable the progress bar of the sesolveProblem because we use a global progress bar for all the trajectories
    default_values = (default_ode_solver_options(T)..., progress_bar = Val(false))
    kwargs2 = _merge_saveat(tlist, e_ops, default_values; kwargs...)
    kwargs3 = _generate_mcsolve_kwargs(ψ0, T, e_ops, tlist, c_ops, jump_callback, rng, kwargs2)

    return sesolveProblem(H_eff_evo, ψ0, tlist; params = params, kwargs3...)
end

@doc raw"""
    mcsolveEnsembleProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        progress_bar::Union{Val,Bool} = Val(true),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple,Nothing} = nothing,
        kwargs...,
    )

Generate the `EnsembleProblem` of `ODEProblem`s for the ensemble of trajectories of the Monte Carlo wave function time evolution of an open quantum system.

Given a system Hamiltonian ``\hat{H}`` and a list of collapse (jump) operators ``\{\hat{C}_n\}_n``, the evolution of the state ``|\psi(t)\rangle`` is governed by the Schrodinger equation:

```math
\frac{\partial}{\partial t} |\psi(t)\rangle= -i \hat{H}_{\textrm{eff}} |\psi(t)\rangle
```

with a non-Hermitian effective Hamiltonian:

```math
\hat{H}_{\textrm{eff}} = \hat{H} - \frac{i}{2} \sum_n \hat{C}_n^\dagger \hat{C}_n.
```

To the first-order of the wave function in a small time ``\delta t``, the strictly negative non-Hermitian portion in ``\hat{H}_{\textrm{eff}}`` gives rise to a reduction in the norm of the wave function, namely

```math
\langle \psi(t+\delta t) | \psi(t+\delta t) \rangle = 1 - \delta p,
```

where 

```math
\delta p = \delta t \sum_n \langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle
```

is the corresponding quantum jump probability.

If the environmental measurements register a quantum jump, the wave function undergoes a jump into a state defined by projecting ``|\psi(t)\rangle`` using the collapse operator ``\hat{C}_n`` corresponding to the measurement, namely

```math
| \psi(t+\delta t) \rangle = \frac{\hat{C}_n |\psi(t)\rangle}{ \sqrt{\langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle} }
```

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``.
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `c_ops`: List of collapse operators ``\{\hat{C}_n\}_n``. It can be either a `Vector` or a `Tuple`.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: Parameters to pass to the solver. This argument is usually expressed as a `NamedTuple` or `AbstractVector` of parameters. For more advanced usage, any custom struct can be used.
- `rng`: Random number generator for reproducibility.
- `ntraj`: Number of trajectories to use.
- `ensemblealg`: Ensemble algorithm to use. Default to `EnsembleThreads()`.
- `jump_callback`: The Jump Callback type: Discrete or Continuous. The default is `ContinuousLindbladJumpCallback()`, which is more precise.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `prob_func`: Function to use for generating the ODEProblem.
- `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-6` and `abstol=1e-8`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

# Returns

- `prob`: The [`TimeEvolutionProblem`](@ref) containing the Ensemble `ODEProblem` for the Monte Carlo wave function time evolution.
"""
function mcsolveEnsembleProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        progress_bar::Union{Val, Bool} = Val(true),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        kwargs...,
    ) where {TJC <: LindbladJumpCallbackType}
    _prob_func = isnothing(prob_func) ? _ensemble_dispatch_prob_func(rng, ntraj, tlist, _mcsolve_prob_func) : prob_func
    _output_func =
        output_func isa Nothing ?
        _ensemble_dispatch_output_func(
            ensemblealg,
            progress_bar,
            ntraj,
            _mcsolve_output_func;
            progr_desc = "[mcsolve] ",
        ) : output_func

    prob_mc = mcsolveProblem(
        H,
        ψ0,
        tlist,
        c_ops;
        e_ops = e_ops,
        params = params,
        rng = rng,
        jump_callback = jump_callback,
        kwargs...,
    )

    ensemble_prob = TimeEvolutionProblem(
        EnsembleProblem(prob_mc.prob, prob_func = _prob_func, output_func = _output_func[1], safetycopy = false),
        prob_mc.times,
        prob_mc.states_type,
        prob_mc.dimensions,
        (progr = _output_func[2], channel = _output_func[3]),
    )

    return ensemble_prob
end

@doc raw"""
    mcsolve(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing;
        alg::AbstractODEAlgorithm = DP5(),
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        progress_bar::Union{Val,Bool} = Val(true),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple,Nothing} = nothing,
        keep_runs_results::Union{Val,Bool} = Val(false),
        normalize_states::Union{Val,Bool} = Val(true),
        kwargs...,
    )

Time evolution of an open quantum system using quantum trajectories.

Given a system Hamiltonian ``\hat{H}`` and a list of collapse (jump) operators ``\{\hat{C}_n\}_n``, the evolution of the state ``|\psi(t)\rangle`` is governed by the Schrodinger equation:

```math
\frac{\partial}{\partial t} |\psi(t)\rangle= -i \hat{H}_{\textrm{eff}} |\psi(t)\rangle
```

with a non-Hermitian effective Hamiltonian:

```math
\hat{H}_{\textrm{eff}} = \hat{H} - \frac{i}{2} \sum_n \hat{C}_n^\dagger \hat{C}_n.
```

To the first-order of the wave function in a small time ``\delta t``, the strictly negative non-Hermitian portion in ``\hat{H}_{\textrm{eff}}`` gives rise to a reduction in the norm of the wave function, namely

```math
\langle \psi(t+\delta t) | \psi(t+\delta t) \rangle = 1 - \delta p,
```

where 

```math
\delta p = \delta t \sum_n \langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle
```

is the corresponding quantum jump probability.

If the environmental measurements register a quantum jump, the wave function undergoes a jump into a state defined by projecting ``|\psi(t)\rangle`` using the collapse operator ``\hat{C}_n`` corresponding to the measurement, namely

```math
| \psi(t+\delta t) \rangle = \frac{\hat{C}_n |\psi(t)\rangle}{ \sqrt{\langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle} }
```

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``.
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `c_ops`: List of collapse operators ``\{\hat{C}_n\}_n``. It can be either a `Vector` or a `Tuple`.
- `alg`: The algorithm to use for the ODE solver. Default to `DP5()`.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: Parameters to pass to the solver. This argument is usually expressed as a `NamedTuple` or `AbstractVector` of parameters. For more advanced usage, any custom struct can be used.
- `rng`: Random number generator for reproducibility.
- `ntraj`: Number of trajectories to use.
- `ensemblealg`: Ensemble algorithm to use. Default to `EnsembleThreads()`.
- `jump_callback`: The Jump Callback type: Discrete or Continuous. The default is `ContinuousLindbladJumpCallback()`, which is more precise.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `prob_func`: Function to use for generating the ODEProblem.
- `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
- `keep_runs_results`: Whether to save the results of each trajectory. Default to `Val(false)`.
- `normalize_states`: Whether to normalize the states. Default to `Val(true)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- `ensemblealg` can be one of `EnsembleThreads()`, `EnsembleSerial()`, `EnsembleDistributed()`
- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-6` and `abstol=1e-8`.
- For more details about `alg` please refer to [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/)
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

# Returns

- `sol::TimeEvolutionMCSol`: The solution of the time evolution. See also [`TimeEvolutionMCSol`](@ref).
"""
function mcsolve(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        alg::AbstractODEAlgorithm = DP5(),
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        jump_callback::TJC = ContinuousLindbladJumpCallback(),
        progress_bar::Union{Val, Bool} = Val(true),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        keep_runs_results::Union{Val, Bool} = Val(false),
        normalize_states::Union{Val, Bool} = Val(true),
        kwargs...,
    ) where {TJC <: LindbladJumpCallbackType}
    ens_prob_mc = mcsolveEnsembleProblem(
        H,
        ψ0,
        tlist,
        c_ops;
        alg = alg,
        e_ops = e_ops,
        params = params,
        rng = rng,
        ntraj = ntraj,
        ensemblealg = ensemblealg,
        jump_callback = jump_callback,
        progress_bar = progress_bar,
        prob_func = prob_func,
        output_func = output_func,
        kwargs...,
    )

    return mcsolve(ens_prob_mc, alg, ntraj, ensemblealg, makeVal(keep_runs_results), normalize_states)
end

function mcsolve(
        ens_prob_mc::TimeEvolutionProblem,
        alg::AbstractODEAlgorithm = DP5(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        keep_runs_results = Val(false),
        normalize_states = Val(true),
    )
    sol = _ensemble_dispatch_solve(ens_prob_mc, alg, ensemblealg, ntraj)

    dims = ens_prob_mc.dimensions.to
    _sol_1 = sol[:, 1]
    _expvals_sol_1 = _get_expvals(_sol_1, SaveFuncMCSolve)

    _expvals_all =
        _expvals_sol_1 isa Nothing ? nothing : map(i -> _get_expvals(sol[:, i], SaveFuncMCSolve), eachindex(sol))
    expvals_all = _expvals_all isa Nothing ? nothing : stack(_expvals_all, dims = 2) # Stack on dimension 2 to align with QuTiP

    # stack to transform Vector{Vector{QuantumObject}} -> Matrix{QuantumObject}
    states_all = stack(map(i -> _normalize_state!.(sol[:, i].u, Ref(dims), normalize_states), eachindex(sol)), dims = 1)

    col_times = map(i -> _mc_get_jump_callback(sol[:, i]).affect!.col_times, eachindex(sol))
    col_which = map(i -> _mc_get_jump_callback(sol[:, i]).affect!.col_which, eachindex(sol))

    kwargs = NamedTuple(_sol_1.prob.kwargs) # Convert to NamedTuple for Zygote.jl compatibility

    return TimeEvolutionMCSol(
        ntraj,
        ens_prob_mc.times,
        _sol_1.t,
        _store_multitraj_states(states_all, keep_runs_results),
        _store_multitraj_expect(expvals_all, keep_runs_results),
        col_times,
        col_which,
        sol.converged,
        _sol_1.alg,
        kwargs.abstol,
        kwargs.reltol,
    )
end

export negativity, partial_transpose

@doc raw"""
    negativity(ρ::QuantumObject, subsys::Int; logarithmic::Bool=false)

Compute the [negativity](https://en.wikipedia.org/wiki/Negativity_(quantum_mechanics)) ``N(\hat{\rho}) = \frac{\Vert \hat{\rho}^{\Gamma}\Vert_1 - 1}{2}``  
where ``\hat{\rho}^{\Gamma}`` is the partial transpose of ``\hat{\rho}`` with respect to the subsystem,  
and ``\Vert \hat{X} \Vert_1=\textrm{Tr}\sqrt{\hat{X}^\dagger \hat{X}}`` is the trace norm.

# Arguments
- `ρ::QuantumObject`: The density matrix (`ρ.type` must be [`Operator`](@ref)).
- `subsys::Int`: an index that indicates which subsystem to compute the negativity for.
- `logarithmic::Bool`: choose whether to calculate logarithmic negativity or not. Default as `false`

# Returns
- `N::Real`: The value of negativity.

# Examples

```jldoctest
julia> Ψ = bell_state(0, 0)

Quantum Object:   type=Ket()   dims=([2, 2], [1, 1])   size=(4,)
4-element Vector{ComplexF64}:
 0.7071067811865475 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
 0.7071067811865475 + 0.0im

julia> ρ = ket2dm(Ψ)

Quantum Object:   type=Operator()   dims=([2, 2], [2, 2])   size=(4, 4)   ishermitian=true
4×4 Matrix{ComplexF64}:
 0.5+0.0im  0.0+0.0im  0.0+0.0im  0.5+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.5+0.0im  0.0+0.0im  0.0+0.0im  0.5+0.0im

julia> round(negativity(ρ, 2), digits=2)
0.5
```
"""
function negativity(ρ::QuantumObject, subsys::Int; logarithmic::Bool = false)
    mask = fill(false, length(ρ.dimensions))
    try
        mask[subsys] = true
    catch
        throw(ArgumentError("Invalid index of subsys: $subsys"))
    end

    ρ_pt = partial_transpose(ρ, mask)
    tr_norm = norm(ρ_pt, 1) # trace norm

    if logarithmic
        return log2(tr_norm)
    else
        return (tr_norm - 1) / 2
    end
end

@doc raw"""
    partial_transpose(ρ::QuantumObject, mask::Vector{Bool})

Return the partial transpose of a density matrix ``\rho``, where `mask` is an array/vector with length that equals the length of `ρ.dims`. The elements in `mask` are boolean (`true` or `false`) which indicates whether or not the corresponding subsystem should be transposed.

# Arguments
- `ρ::QuantumObject`: The density matrix (`ρ.type` must be [`Operator`](@ref)).
- `mask::Vector{Bool}`: A boolean vector selects which subsystems should be transposed.

# Returns
- `ρ_pt::QuantumObject`: The density matrix with the selected subsystems transposed.
"""
function partial_transpose(ρ::QuantumObject{Operator}, mask::Vector{Bool})
    any(s -> s isa EnrSpace, ρ.dimensions.to) && throw(ArgumentError("partial_transpose does not support EnrSpace"))

    (length(mask) != length(ρ.dimensions)) &&
        throw(ArgumentError("The length of \`mask\` should be equal to the length of \`ρ.dims\`."))

    # TODO: Extend partial_transpose to non-endomorphism dimensions
    !isendomorphism(ρ.dimensions) &&
        throw(ArgumentError("Invalid partial transpose for dims = $(_get_dims_string(ρ.dimensions))"))

    return _partial_transpose(ρ, mask)
end

# for dense matrices
function _partial_transpose(ρ::QuantumObject{Operator}, mask::Vector{Bool})
    nsys = length(mask)
    mask2 = reverse([mask[s] ? 2 : 1 for s in 1:nsys])
    # mask2 has elements with values equal to 1 or 2
    #   1 - the subsystem (in reversed order) don't need to be transposed
    #   2 - the subsystem (in reversed order) need to be transposed

    dims_rev = reverse(dimensions_to_dims(ρ.dimensions.to))
    pt_dims = reshape(Vector(1:(2 * nsys)), (nsys, 2))
    pt_idx = [
        [pt_dims[n, mask2[n]] for n in 1:nsys]   # origin   value in mask2
        [pt_dims[n, 3 - mask2[n]] for n in 1:nsys] # opposite value in mask2 (1 -> 2, and 2 -> 1)
    ]
    return QuantumObject(
        reshape(permutedims(reshape(ρ.data, (dims_rev..., dims_rev...)), pt_idx), size(ρ)),
        Operator(),
        ρ.dimensions,
    )
end

# for sparse matrices
function _partial_transpose(
        ρ::QuantumObject{Operator, DimsType, <:AbstractSparseArray},
        mask::Vector{Bool},
    ) where {DimsType <: AbstractDimensions}
    M, N = size(ρ)
    dims_rev = reverse(Tuple(dimensions_to_dims(ρ.dimensions.to)))
    mask_rev = reverse(mask)
    colptr = ρ.data.colptr
    rowval = ρ.data.rowval
    nzval = ρ.data.nzval
    len = length(nzval)

    # for partial transposed data
    I_pt = Vector{Int}(undef, len)
    J_pt = Vector{Int}(undef, len)
    V_pt = Vector{eltype(ρ)}(undef, len)

    n = 0
    for j in 1:(length(colptr) - 1)
        for p in colptr[j]:(colptr[j + 1] - 1)
            n += 1
            i = rowval[p]
            if i == j
                I_pt[n] = i
                J_pt[n] = j
            else
                ket_pt = [Base._ind2sub(dims_rev, i)...]
                bra_pt = [Base._ind2sub(dims_rev, j)...]
                for sys in findall(m -> m, mask_rev)
                    @inbounds ket_pt[sys], bra_pt[sys] = bra_pt[sys], ket_pt[sys]
                end
                I_pt[n] = Base._sub2ind(dims_rev, ket_pt...)
                J_pt[n] = Base._sub2ind(dims_rev, bra_pt...)
            end
            V_pt[n] = nzval[p]
        end
    end

    return QuantumObject(sparse(I_pt, J_pt, V_pt, M, N), Operator(), ρ.dimensions)
end

#=
Command line output of information on QuantumToolbox, dependencies, and system information
=#

@doc raw"""
    QuantumToolbox.versioninfo(io::IO=stdout)

Command line output of information on QuantumToolbox, dependencies, and system information, same as [`QuantumToolbox.about`](@ref).
"""
function versioninfo(io::IO = stdout)
    # print introduction
    println(
        io,
        "\n",
        " QuantumToolbox.jl: Quantum Toolbox in Julia\n",
        "≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡≡\n",
        "Copyright © QuTiP team 2022 and later.\n",
        "Current admin team:\n",
        "    Alberto Mercurio and Yi-Te Huang\n",
    )

    # print package information
    pkg_tuple = (
        QuantumToolbox,
        SciMLOperators,
        LinearSolve,
        OrdinaryDiffEqCore,
    )
    pkginfo(io; pkgs = pkg_tuple)

    # print System information
    sysinfo(io)

    # print citation information
    println(
        io,
        "+---------------------------------------------------+\n",
        "| Please cite QuantumToolbox.jl in your publication |\n",
        "+---------------------------------------------------+\n",
        "For your convenience, a bibtex reference can be easily generated using `QuantumToolbox.cite()`.\n",
    )
    return nothing
end

@doc raw"""
    QuantumToolbox.pkginfo(io::IO=stdout; pkgs::NTuple{N, Module} = (QuantumToolbox,))

Command line output of version numbers for given tuple of packages: `pkgs`. Default to `(QuantumToolbox,)`.
"""
function pkginfo(io::IO = stdout; pkgs::NTuple{N, Module} = (QuantumToolbox,)) where {N}
    pkg_ver_list = map(pkgversion, pkgs)
    maxLen = max(5, maximum(length ∘ string, pkgs)) # maximum string length of package names (5 refer to "Julia")

    print(
        io,
        "Package information:\n",
        "====================================\n",
    )
    println(io, rpad("Julia", maxLen, " "), " Ver. ", VERSION) # print Julia version first
    for (pkg, pkg_ver) in zip(pkgs, pkg_ver_list)
        println(io, rpad(pkg, maxLen, " "), " Ver. ", pkg_ver)
    end
    print(io, "\n")
    return nothing
end

@doc raw"""
    QuantumToolbox.sysinfo(io::IO=stdout)

Command line output of system information.
"""
function sysinfo(io::IO = stdout)
    cpu = Sys.cpu_info()
    BLAS_info = BLAS.get_config().loaded_libs[1]
    Sys.iswindows() ? OS_name = "Windows" : Sys.isapple() ? OS_name = "macOS" : OS_name = Sys.KERNEL

    println(
        io,
        "System information:\n",
        "====================================\n",
        """OS       : $(OS_name) ($(Sys.MACHINE))\n""",
        """CPU      : $(length(cpu)) × $(cpu[1].model)\n""",
        """Memory   : $(round(Sys.total_memory() / 2^30, digits = 3)) GB\n""",
        """WORD_SIZE: $(Sys.WORD_SIZE)\n""",
        """LIBM     : $(Base.libm_name)\n""",
        """LLVM     : libLLVM-$(Base.libllvm_version) ($(Sys.JIT), $(Sys.CPU_NAME))\n""",
        """BLAS     : $(basename(BLAS_info.libname)) ($(BLAS_info.interface))\n""",
        """Threads  : $(Threads.nthreads()) (on $(Sys.CPU_THREADS) virtual cores)\n""",
    )
    return nothing
end

@doc raw"""
    QuantumToolbox.about(io::IO=stdout)

Command line output of information on QuantumToolbox, dependencies, and system information, same as [`QuantumToolbox.versioninfo`](@ref).
"""
about(io::IO = stdout) = versioninfo(io)

@doc raw"""
    QuantumToolbox.cite(io::IO = stdout)

Command line output of citation information and bibtex generator for `QuantumToolbox.jl`.
"""
function cite(io::IO = stdout)
    citation = raw"""
    @article{QuantumToolbox.jl2025,
      title = {Quantum{T}oolbox.jl: {A}n efficient {J}ulia framework for simulating open quantum systems},
      author = {Mercurio, Alberto and Huang, Yi-Te and Cai, Li-Xun and Chen, Yueh-Nan and Savona, Vincenzo and Nori, Franco},
      journal = {{Quantum}},
      issn = {2521-327X},
      publisher = {{Verein zur F{\\"{o}}rderung des Open Access Publizierens in den Quantenwissenschaften}},
      volume = {9},
      pages = {1866},
      month = sep,
      year = {2025},
      doi = {10.22331/q-2025-09-29-1866},
      url = {https://doi.org/10.22331/q-2025-09-29-1866}
    }
    """
    return print(io, citation)
end

#=
This file defines the excitation number restricted space structure.
=#

export EnrSpace, enr_state_dictionaries
export enr_fock, enr_thermal_dm, enr_destroy, enr_identity

@doc raw"""
    struct EnrSpace{N} <: AbstractSpace
        size::Int
        dims::NTuple{N,Int}
        n_excitations::Int
        state2idx::Dict{SVector{N,Int},Int}
        idx2state::Dict{Int,SVector{N,Int}}
    end

A structure that describes an excitation number restricted (ENR) state space, where `N` is the number of sub-systems.

# Fields

- `size`: Number of states in the excitation number restricted state space
- `dims`: A list of the number of states in each sub-system
- `n_excitations`: Maximum number of excitations
- `state2idx`: A dictionary for looking up a state index from a state (`SVector`)
- `idx2state`: A dictionary for looking up state (`SVector`) from a state index

# Functions

With this `EnrSpace`, one can use the following functions to construct states or operators in the excitation number restricted (ENR) space:

- [`enr_fock`](@ref)
- [`enr_thermal_dm`](@ref)
- [`enr_destroy`](@ref)
- [`enr_identity`](@ref)

# Example

To construct an `EnrSpace`, we only need to specify the `dims` and `n_excitations`, namely

```jldoctest
julia> dims = (2, 2, 3);

julia> n_excitations = 3;

julia> EnrSpace(dims, n_excitations)
EnrSpace([2, 2, 3], 3)
```

!!! warning "Beware of type-stability!"
    It is highly recommended to use `EnrSpace(dims, n_excitations)` with `dims` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
struct EnrSpace{N} <: AbstractSpace
    size::Int
    dims::SVector{N, Int}
    n_excitations::Int
    state2idx::Dict{SVector{N, Int}, Int}
    idx2state::Dict{Int, SVector{N, Int}}

    function EnrSpace(dims::Union{AbstractVector{T}, NTuple{N, T}}, n_excitations::Int) where {T <: Integer, N}
        # all arguments will be checked in `enr_state_dictionaries`
        size, state2idx, idx2state = enr_state_dictionaries(dims, n_excitations)

        L = length(dims)
        return new{L}(size, SVector{L}(dims), n_excitations, state2idx, idx2state)
    end
end

function Base.show(io::IO, s::EnrSpace)
    print(io, "EnrSpace($(s.dims), $(s.n_excitations))")
    return nothing
end

Base.length(::EnrSpace{N}) where {N} = N

Base.:(==)(s_enr1::EnrSpace, s_enr2::EnrSpace) = (s_enr1.size == s_enr2.size) && (s_enr1.dims == s_enr2.dims)

dimensions_to_dims(s_enr::EnrSpace) = s_enr.dims

get_hilbert_size(s_enr::EnrSpace) = s_enr.size
get_liouville_size(s_enr::EnrSpace) = s_enr.size^2

@doc raw"""
    enr_state_dictionaries(dims, n_excitations)

Return the number of states, and lookup-dictionaries for translating a state (`SVector`) to a state index, and vice versa, for a system with a given number of components and maximum number of excitations.

# Arguments
- `dims::Union{AbstractVector,Tuple}`: A list of the number of states in each sub-system
- `n_excitations::Int`: Maximum number of excitations

# Returns
- `nstates`: Number of states
- `state2idx`: A dictionary for looking up a state index from a state (`SVector`)
- `idx2state`: A dictionary for looking up state (`SVector`) from a state index
"""
function enr_state_dictionaries(dims::Union{AbstractVector{T}, NTuple{N, T}}, n_excitations::Int) where {T <: Integer, N}
    # argument checks
    _non_static_array_warning("dims", dims)
    L = length(dims)
    (L > 0) || throw(DomainError(dims, "The argument dims must be of non-zero length"))
    all(>=(1), dims) || throw(DomainError(dims, "All the elements of dims must be non-zero integers (≥ 1)"))
    (n_excitations > 0) ||
        throw(DomainError(n_excitations, "The argument n_excitations must be a non-zero integer (≥ 1)"))

    nvec = zeros(Int, L) # Vector
    nexc = 0

    # in the following, all `nvec` (Vector) will first be converted (copied) to SVector and then push to `result`
    result = SVector{L, Int}[nvec]
    while true
        idx = L
        nvec[end] += 1
        nexc += 1
        (nvec[idx] < dims[idx]) && push!(result, nvec)
        while (nexc == n_excitations) || (nvec[idx] == dims[idx])
            idx -= 1

            # if idx < 1, break while-loop and return
            if idx < 1
                enr_size = length(result)
                return (enr_size, Dict(zip(result, 1:enr_size)), Dict(zip(1:enr_size, result)))
            end

            nexc -= nvec[idx + 1] - 1
            nvec[idx + 1] = 0
            nvec[idx] += 1
            (nvec[idx] < dims[idx]) && push!(result, nvec)
        end
    end
    return
end

@doc raw"""
    enr_fock([T::Type=ComplexF64,] dims::Union{AbstractVector,Tuple}, n_excitations::Int, state::AbstractVector; sparse::Union{Bool,Val}=Val(false))
    enr_fock([T::Type=ComplexF64,] s_enr::EnrSpace, state::AbstractVector; sparse::Union{Bool,Val}=Val(false))

Generate the Fock state representation ([`Ket`](@ref)) in an excitation number restricted state space ([`EnrSpace`](@ref)) with element type `T = ComplexF64` (default).

The arguments `dims` and `n_excitations` are used to generate [`EnrSpace`](@ref).

The `state` argument is a list of integers that specifies the state (in the number basis representation) for which to generate the Fock state representation.

!!! warning "Beware of type-stability!"
    It is highly recommended to use `enr_fock(dims, n_excitations, state)` with `dims` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function enr_fock(
        ::Type{T},
        dims::Union{AbstractVector{Td}, NTuple{N, Td}},
        n_excitations::Int,
        state::AbstractVector{Td};
        sparse::Union{Bool, Val} = Val(false),
    ) where {T <: Number, Td <: Integer, N}
    s_enr = EnrSpace(dims, n_excitations)
    return enr_fock(T, s_enr, state; sparse)
end
function enr_fock(::Type{T}, s_enr::EnrSpace, state::AbstractVector{Td}; sparse::Union{Bool, Val} = Val(false)) where {T <: Number, Td <: Integer}
    if getVal(sparse)
        array = sparsevec([s_enr.state2idx[[state...]]], [one(T)], s_enr.size)
    else
        j = s_enr.state2idx[state]
        z0 = zero(T)
        array = [i == j ? one(T) : z0 for i in 1:(s_enr.size)]
    end

    return QuantumObject(array, Ket(), s_enr)
end
enr_fock(dims::Union{AbstractVector{Td}, NTuple{N, Td}}, n_excitations::Int, state::AbstractVector{Td}; sparse::Union{Bool, Val} = Val(false)) where {Td <: Integer, N} =
    enr_fock(ComplexF64, dims, n_excitations, state; sparse)
enr_fock(s_enr::EnrSpace, state::AbstractVector{Td}; sparse::Union{Bool, Val} = Val(false)) where {Td <: Integer} = enr_fock(ComplexF64, s_enr, state; sparse)

@doc raw"""
    enr_thermal_dm(dims::Union{AbstractVector,Tuple}, n_excitations::Int, n::Union{Real,AbstractVector}; sparse::Union{Bool,Val}=Val(false))
    enr_thermal_dm(s_enr::EnrSpace, n::Union{Real,AbstractVector}; sparse::Union{Bool,Val}=Val(false))

Generate the thermal state (density [`Operator`](@ref)) in an excitation number restricted state space ([`EnrSpace`](@ref)) with element type same as `n`.

The arguments `dims` and `n_excitations` are used to generate [`EnrSpace`](@ref).

The argument `n` is a list that specifies the expectation values for number of particles in each sub-system. If `n` is specified as a real number, it will apply to each sub-system.

!!! warning "Beware of type-stability!"
    It is highly recommended to use `enr_thermal_dm(dims, n_excitations, n)` with `dims` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function enr_thermal_dm(
        dims::Union{AbstractVector{T1}, NTuple{N, T1}},
        n_excitations::Int,
        n::Union{T2, AbstractVector{T2}};
        sparse::Union{Bool, Val} = Val(false),
    ) where {T1 <: Integer, T2 <: Real, N}
    s_enr = EnrSpace(dims, n_excitations)
    return enr_thermal_dm(s_enr, n; sparse)
end
function enr_thermal_dm(
        s_enr::EnrSpace{N},
        n::Union{T, AbstractVector{T}};
        sparse::Union{Bool, Val} = Val(false),
    ) where {N, T <: Real}
    if n isa Real
        nvec = fill(n, N)
    else
        (length(n) == N) || throw(ArgumentError("The length of the vector `n` should be the same as `dims`."))
        nvec = n
    end

    D = s_enr.size
    idx2state = s_enr.idx2state

    β = @. log(1 + 1 / nvec) # here makes element type become float
    P = [
        prod(_Boltzmann_weight(β[k], n_excite) for (k, n_excite) in pairs(idx2state[idx])) for idx in 1:D
    ]
    P /= sum(P)
    if getVal(sparse)
        return QuantumObject(spdiagm(0 => P), Operator(), s_enr)
    else
        return QuantumObject(diagm(0 => P), Operator(), s_enr)
    end
end

@doc raw"""
    enr_destroy([T::Type=ComplexF64,] dims::Union{AbstractVector,Tuple}, n_excitations::Int)
    enr_destroy([T::Type=ComplexF64,] s_enr::EnrSpace)

Generate a `Tuple` of annihilation operators for each sub-system in an excitation number restricted state space ([`EnrSpace`](@ref)) with element type `T = ComplexF64` (default). Thus, the return `Tuple` will have the same length as `dims`.

The arguments `dims` and `n_excitations` are used to generate [`EnrSpace`](@ref).

!!! warning "Beware of type-stability!"
    It is highly recommended to use `enr_destroy(dims, n_excitations)` with `dims` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function enr_destroy(::Type{T}, dims::Union{AbstractVector{Td}, NTuple{N, Td}}, n_excitations::Int) where {T <: FloatOrComplex, Td <: Integer, N}
    s_enr = EnrSpace(dims, n_excitations)
    return enr_destroy(T, s_enr)
end
function enr_destroy(::Type{T}, s_enr::EnrSpace{N}) where {T <: FloatOrComplex, N}
    D = s_enr.size
    idx2state = s_enr.idx2state
    state2idx = s_enr.state2idx

    I_list = [Int64[] for _ in 1:N]
    J_list = [Int64[] for _ in 1:N]
    V_list = [T[] for _ in 1:N]

    for (n1, state1) in idx2state
        for (idx, s) in pairs(state1)
            # if s > 0, the annihilation operator of mode idx has a non-zero
            # entry with one less excitation in mode idx in the final state
            if s > 0
                state2 = Vector(state1)
                state2[idx] -= 1
                n2 = state2idx[state2]
                push!(I_list[idx], n2)
                push!(J_list[idx], n1)
                push!(V_list[idx], sqrt(T(s)))
            end
        end
    end

    return ntuple(i -> QuantumObject(sparse(I_list[i], J_list[i], V_list[i], D, D), Operator(), s_enr), Val(N))
end
enr_destroy(dims::Union{AbstractVector{Td}, NTuple{N, Td}}, n_excitations::Int) where {Td <: Integer, N} = enr_destroy(ComplexF64, dims, n_excitations)
enr_destroy(s_enr::EnrSpace{N}) where {N} = enr_destroy(ComplexF64, s_enr)

@doc raw"""
    enr_identity([T::Type=ComplexF64,] dims::Union{AbstractVector,Tuple}, n_excitations::Int)
    enr_identity([T::Type=ComplexF64,] s_enr::EnrSpace)

Generate the identity operator in an excitation number restricted state space ([`EnrSpace`](@ref)) with element type `T = ComplexF64` (default).

The arguments `dims` and `n_excitations` are used to generate [`EnrSpace`](@ref).

!!! warning "Beware of type-stability!"
    It is highly recommended to use `enr_identity(dims, n_excitations)` with `dims` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function enr_identity(::Type{T}, dims::Union{AbstractVector{Td}, NTuple{N, Td}}, n_excitations::Int) where {T <: Number, Td <: Integer, N}
    s_enr = EnrSpace(dims, n_excitations)
    return enr_identity(T, s_enr)
end
enr_identity(::Type{T}, s_enr::EnrSpace) where {T <: Number} = QuantumObject(Diagonal(ones(T, s_enr.size)), Operator(), s_enr)
enr_identity(dims::Union{AbstractVector{Td}, NTuple{N, Td}}, n_excitations::Int) where {Td <: Integer, N} = enr_identity(ComplexF64, dims, n_excitations)
enr_identity(s_enr::EnrSpace) = enr_identity(ComplexF64, s_enr)

function _render_bloch_makie(bloch_vec::Vector{Float64}; location = nothing, kwargs...)
    b = Bloch()
    add_vectors!(b, bloch_vec)
    fig, location = _getFigAndLocation(location)
    fig, ax = render(b; location = location, kwargs...)
    return fig, ax
end

@doc raw"""
    render(b::Bloch; location=nothing)

Render the Bloch sphere visualization from the given [`Bloch`](@ref) object `b`.

# Arguments

- `b::Bloch`: The Bloch sphere object containing states, vectors, and settings to visualize.
- `location::Union{GridPosition,LScene,Nothing}`: The location of the plot in the layout, or `Makie.LScene`. Default is `nothing`.


# Returns

- A tuple `(fig, lscene)` where `fig` is the figure object and `lscene` is the LScene object used for plotting. These can be further manipulated or saved by the user.

# Notes

The keyword argument `location` can be in the either type: 

- `Nothing` (default): Create a new figure and plot the Bloch sphere.
- `GridPosition`: Plot the Bloch sphere in the specified location of the plot in the layout.
- `LScene`: Update the existing Bloch sphere using new data and settings in `b::Bloch` without creating new `Figure` and `LScene` (efficient for drawing animation).
"""
function QuantumToolbox.render(b::Bloch; location = nothing)
    fig, lscene = _setup_bloch_plot!(location)
    _setup_bloch_camara!(b, lscene)
    _draw_bloch_sphere!(b, lscene)
    _add_labels!(b, lscene)

    # plot data fields in Bloch
    _plot_vectors!(b, lscene)
    _plot_lines!(b, lscene)
    _plot_arcs!(b, lscene)
    _plot_points!(b, lscene) # plot points at the end so that they will be on the very top (front) figure layer.

    return fig, lscene
end

raw"""
    _setup_bloch_plot!(location) -> (fig, lscene)

Initialize the Figure and LScene for Bloch sphere visualization.

# Arguments
- `location`: Figure layout position specification, or directly `Makie.LScene` for updating Bloch sphere.

# Returns
- `fig`: Created Makie figure
- `lscene`: Configured LScene object
"""
function _setup_bloch_plot!(location)
    fig, location = _getFigAndLocation(location)
    lscene = LScene(location, show_axis = false, scenekw = (clear = true,))
    return fig, lscene
end

function _setup_bloch_plot!(lscene::LScene)
    # this function only removes all existing Plots in lscene
    # it is useful for users to just update Bloch sphere without creating new figure and lscene (efficient for drawing animation)
    fig = lscene.parent
    empty!(lscene.scene.plots)
    return fig, lscene
end

raw"""
    _setup_bloch_camara!(b::Bloch, lscene)

Setup the distance and view angle of the camara.
"""
function _setup_bloch_camara!(b::Bloch, lscene)
    length(b.view) == 2 || throw(ArgumentError("The length of `Bloch.view` must be 2."))
    cam3d!(lscene.scene, center = false)
    cam = cameracontrols(lscene)
    cam.fov[] = 12 # Set field of view to 12 degrees
    dist = 12      # Set distance from the camera to the Bloch sphere
    update_cam!(lscene.scene, cam, deg2rad(b.view[1]), deg2rad(b.view[2]), dist)
    return nothing
end

raw"""
    _draw_bloch_sphere!(b::Bloch, lscene)

Draw the translucent sphere, axes, and reference circles representing the Bloch sphere surface.
"""
function _draw_bloch_sphere!(b::Bloch, lscene)
    radius = 1.0f0
    sphere_mesh = Sphere(Point3f(0), radius)
    mesh!(
        lscene,
        sphere_mesh;
        color = b.sphere_color,
        alpha = b.sphere_alpha,
        shading = NoShading,
        transparency = true,
        rasterize = 3,
    )

    # X, Y, and Z axes
    axes = [
        [Point3f(1.0, 0, 0), Point3f(-1.0, 0, 0)],  # X-axis
        [Point3f(0, 1.0, 0), Point3f(0, -1.0, 0)],  # Y-axis
        [Point3f(0, 0, 1.0), Point3f(0, 0, -1.0)],  # Z-axis
    ]
    for points in axes
        lines!(lscene, points; color = b.frame_color)
    end

    # highlight circles for XY and XZ planes
    φ = range(0, 2π, length = 100)
    lines!(lscene, [Point3f(cos(φi), sin(φi), 0) for φi in φ]; color = b.frame_color, linewidth = b.frame_width) # XY
    lines!(lscene, [Point3f(cos(φi), 0, sin(φi)) for φi in φ]; color = b.frame_color, linewidth = b.frame_width) # XZ

    # other curves of longitude (with polar angle φ and azimuthal angle θ)
    φ_curve = range(0, 2π, 600)
    θ_vals = [1, 2, 3] * π / 4
    for θi in θ_vals
        x_line = radius * sin.(φ_curve) .* cos(θi)
        y_line = radius * sin.(φ_curve) .* sin(θi)
        z_line = radius * cos.(φ_curve)
        lines!(lscene, x_line, y_line, z_line; color = b.frame_color, alpha = b.frame_alpha, linewidth = b.frame_width)
    end

    # other curves of latitude (with polar angle φ and azimuthal angle θ)
    φ_vals = [1, 3] * π / 4  # missing `2` because XY plane has already be handled above
    θ_curve = range(0, 2π, 600)
    for ϕ in φ_vals
        x_ring = radius * sin(ϕ) .* cos.(θ_curve)
        y_ring = radius * sin(ϕ) .* sin.(θ_curve)
        z_ring = fill(radius * cos(ϕ), length(θ_curve))
        lines!(lscene, x_ring, y_ring, z_ring; color = b.frame_color, alpha = b.frame_alpha, linewidth = b.frame_width)
    end
    return nothing
end

raw"""
    _add_labels!(b::Bloch, lscene)

Add axis labels and state labels to the Bloch sphere.

# Arguments
- `lscene`: LScene object for text placement

Positions standard labels `(x, y, |0⟩, |1⟩)` at appropriate locations.
"""
function _add_labels!(b::Bloch, lscene)
    length(b.xlabel) == 2 || throw(ArgumentError("The length of `Bloch.xlabel` must be 2."))
    length(b.ylabel) == 2 || throw(ArgumentError("The length of `Bloch.ylabel` must be 2."))
    length(b.zlabel) == 2 || throw(ArgumentError("The length of `Bloch.zlabel` must be 2."))
    length(b.xlpos) == 2 || throw(ArgumentError("The length of `Bloch.xlpos` must be 2."))
    length(b.ylpos) == 2 || throw(ArgumentError("The length of `Bloch.ylpos` must be 2."))
    length(b.zlpos) == 2 || throw(ArgumentError("The length of `Bloch.zlpos` must be 2."))

    label_color = parse(RGBf, b.font_color)
    label_size = b.font_size

    (b.xlabel[1] == "") || text!(
        lscene,
        b.xlabel[1],
        position = Point3f(b.xlpos[1], 0, 0),
        color = label_color,
        fontsize = label_size,
        align = (:center, :center),
    )
    (b.xlabel[2] == "") || text!(
        lscene,
        b.xlabel[2],
        position = Point3f(b.xlpos[2], 0, 0),
        color = label_color,
        fontsize = label_size,
        align = (:center, :center),
    )
    (b.ylabel[1] == "") || text!(
        lscene,
        b.ylabel[1],
        position = Point3f(0, b.ylpos[1], 0),
        color = label_color,
        fontsize = label_size,
        align = (:center, :center),
    )
    (b.ylabel[2] == "") || text!(
        lscene,
        b.ylabel[2],
        position = Point3f(0, b.ylpos[2], 0),
        color = label_color,
        fontsize = label_size,
        align = (:center, :center),
    )
    (b.zlabel[1] == "") || text!(
        lscene,
        b.zlabel[1],
        position = Point3f(0, 0, b.zlpos[1]),
        color = label_color,
        fontsize = label_size,
        align = (:center, :center),
    )
    (b.zlabel[2] == "") || text!(
        lscene,
        b.zlabel[2],
        position = Point3f(0, 0, b.zlpos[2]),
        color = label_color,
        fontsize = label_size,
        align = (:center, :center),
    )
    return nothing
end

raw"""
    _plot_points!(b::Bloch, lscene)

Plot all quantum state points on the Bloch sphere.

# Arguments
- `b::Bloch`: Contains point data and styling information
- `lscene`: LScene object for plotting

Handles both scatter points and line traces based on style specifications.
"""
function _plot_points!(b::Bloch, lscene)
    isempty(b.points) && return nothing
    for k in 1:length(b.points)
        pts = b.points[k]
        style = b.point_style[k]
        alpha = b.point_alpha[k]
        marker = b.point_marker[mod1(k, length(b.point_marker))]
        N = size(pts, 2)

        raw_x = pts[1, :]
        raw_y = pts[2, :]
        raw_z = pts[3, :]

        ds = vec(sqrt.(sum(abs2, pts; dims = 1)))
        if !all(isapprox.(ds, ds[1]; rtol = 1.0e-12))
            indperm = sortperm(ds)
        else
            indperm = collect(1:N)
        end
        this_color = b.point_color[k]
        if style == :m
            defaults = b.point_default_color
            L = length(defaults)
            times = ceil(Int, N / L)
            big_colors = repeat(b.point_default_color, times)[1:N]
            big_colors = big_colors[indperm]
            colors = big_colors
        else
            if this_color === nothing
                defaults = b.point_default_color
                colors = defaults[mod1(k, length(defaults))]
            else
                colors = this_color
            end
        end
        if style in (:s, :m)
            scatter!(
                lscene,
                raw_x[indperm],
                raw_y[indperm],
                raw_z[indperm];
                color = colors,
                markersize = b.point_size[mod1(k, length(b.point_size))],
                marker = marker,
                transparency = alpha < 1.0,
                alpha = alpha,
                strokewidth = 0.0,
            )

        elseif style == :l
            c = isa(colors, Vector) ? colors[1] : colors
            lines!(lscene, raw_x, raw_y, raw_z; color = c, transparency = alpha < 1.0, alpha = alpha)
        end
    end
    return nothing
end

raw"""
    _plot_lines!(b::Bloch, lscene)

Draw all connecting lines between points on the Bloch sphere.

# Arguments
- `b::Bloch`: Contains line data and formatting
- `lscene`: LScene object for drawing

Processes line style specifications and color mappings.
"""
function _plot_lines!(b::Bloch, lscene)
    isempty(b.lines) && return nothing
    color_map =
        Dict("k" => :black, "r" => :red, "g" => :green, "b" => :blue, "c" => :cyan, "m" => :magenta, "y" => :yellow)
    for (line, fmt) in b.lines
        x, y, z = line
        color_char = first(fmt)
        color = get(color_map, color_char, :black)
        linestyle = if occursin("--", fmt)
            :dash
        elseif occursin(":", fmt)
            :dot
        elseif occursin("-.", fmt)
            :dashdot
        else
            :solid
        end
        lines!(lscene, x, y, z; color = color, linestyle = linestyle)
    end
    return nothing
end

raw"""
    _plot_arcs!(b::Bloch, lscene)

Draw circular arcs connecting points on the Bloch sphere surface.

# Arguments
- `b::Bloch`: Contains arc data points
- `lscene`: LScene object for drawing

Calculates great circle arcs between specified points.
"""
function _plot_arcs!(b::Bloch, lscene)
    isempty(b.arcs) && return nothing
    for arc_pts in b.arcs
        length(arc_pts) >= 2 || continue
        v1 = normalize(arc_pts[1])
        v2 = normalize(arc_pts[end])
        n = normalize(cross(v1, v2))
        θ = acos(clamp(dot(v1, v2), -1.0, 1.0))
        if length(arc_pts) == 3
            vm = normalize(arc_pts[2])
            dot(cross(v1, vm), n) < 0 && (θ -= 2π)
        end
        t_range = range(0, θ, length = 100)
        arc_points = [Point3f(v1 * cos(t) + cross(n, v1) * sin(t)) for t in t_range]
        lines!(lscene, arc_points; color = "blue", linestyle = :solid)
    end
    return nothing
end

raw"""
    _plot_vectors!(b::Bloch, lscene)

Draw vectors from origin representing quantum states.

# Arguments
- `b::Bloch`: Contains vector data
- `lscene`: LScene object for drawing

Scales vectors appropriately and adds `3D` arrow markers.
"""
function _plot_vectors!(b::Bloch, lscene)
    isempty(b.vectors) && return nothing

    for (i, v) in enumerate(b.vectors)
        color = get(b.vector_color, i, RGBAf(0.2, 0.5, 0.8, 0.9))

        arrows3d!(
            lscene,
            Point3f(0),
            Point3f(v),
            color = color,
            shaftradius = b.vector_width,
            tiplength = b.vector_tiplength,
            tipradius = b.vector_tipradius,
            rasterize = 3,
        )
    end
    return nothing
end

@doc raw"""
    plot_bloch(::Val{:Makie}, state::QuantumObject; kwargs...)

Plot a pure quantum state on the Bloch sphere using the `Makie` backend.

# Arguments
- `state::QuantumObject{<:Union{Ket,Bra}}`: The quantum state ([`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref)) to be visualized.
- `kwargs...`: Additional keyword arguments passed to the plotting function. See the documentation of [`Makie.jl`](https://docs.makie.org/stable/) for more information.

!!! note "Internal function"
    This is the `Makie`-specific implementation called by the main `plot_bloch` function.
"""
function QuantumToolbox.plot_bloch(
        ::Val{:Makie},
        state::QuantumObject{OpType};
        kwargs...,
    ) where {OpType <: Union{Ket, Bra, Operator}}
    bloch_vec = _state_to_bloch(state)
    return _render_bloch_makie(bloch_vec; kwargs...)
end

export TimeEvolutionSol
export TimeEvolutionMultiTrajSol, TimeEvolutionMCSol, TimeEvolutionStochasticSol
export average_states, average_expect, std_expect

export liouvillian_floquet

default_ode_solver_options(::Type{T}) where {T} = (abstol = _float_type(T)(1.0e-8), reltol = _float_type(T)(1.0e-6), save_everystep = false, save_end = true)
default_sde_solver_options(::Type{T}) where {T} = (abstol = _float_type(T)(1.0e-3), reltol = _float_type(T)(2.0e-3), save_everystep = false, save_end = true)
const COL_TIMES_WHICH_INIT_SIZE = 200

abstract type TimeEvolutionMultiTrajSol{Tstates, Texpect} end

@doc raw"""
    struct TimeEvolutionProblem

A Julia constructor for handling the `ODEProblem` of the time evolution of quantum systems.

# Fields (Attributes)

- `prob::AbstractSciMLProblem`: The `ODEProblem` of the time evolution.
- `times::AbstractVector`: The time list of the evolution.
- `states_type::QuantumObjectType`: The type of the quantum states during the evolution (e.g., [`Ket`](@ref), [`Operator`](@ref), [`OperatorKet`](@ref), or [`SuperOperator`](@ref)).
- `dimensions::Dimensions`: The dimensions of the Hilbert space.
- `kwargs::KWT`: Generic keyword arguments.

!!! note "`dims` property"
    For a given `prob::TimeEvolutionProblem`, `prob.dims` or `getproperty(prob, :dims)` returns its `dimensions` in the type of integer-vector.
"""
struct TimeEvolutionProblem{
        ST <: QuantumObjectType,
        DT <: Dimensions,
        PT <: AbstractSciMLProblem,
        TT <: AbstractVector,
        KWT,
    }
    prob::PT
    times::TT
    states_type::ST
    dimensions::DT
    kwargs::KWT
end

function Base.getproperty(prob::TimeEvolutionProblem, key::Symbol)
    # a comment here to avoid bad render by JuliaFormatter
    if key === :dims
        return dimensions_to_dims(getfield(prob, :dimensions))
    else
        return getfield(prob, key)
    end
end

TimeEvolutionProblem(prob, times, states_type, dims) = TimeEvolutionProblem(prob, times, states_type, dims, nothing)

raw"""
A helper function to `check_mul_dimensions` and also generate the new type and dimensions for solutions
"""
function _handle_init_state_and_sol_type_dims(H::AbstractQuantumObject{Operator}, ψ0::QuantumObject{Tψ}) where {Tψ <: Union{Ket, Operator}}
    !isendomorphic(H.dimensions) && _non_endomorphic_dims_error("Hamiltonian or Liouvillian for time evolution solvers", H.dimensions)
    check_mul_dimensions(H, ψ0)

    T = _complex_float_type(Base.promote_eltype(H, ψ0))
    return T, to_dense(T, ψ0.data), ψ0.type, ψ0.dimensions
end
function _handle_init_state_and_sol_type_dims(H::AbstractQuantumObject{SuperOperator}, ψ0::QuantumObject{Tψ}) where {Tψ <: Union{Ket, Operator}}
    !isendomorphic(H.dimensions) && _non_endomorphic_dims_error("Hamiltonian or Liouvillian for time evolution solvers", H.dimensions)
    ρ0 = ket2dm(ψ0)
    ρ0_vec = mat2vec(ρ0)
    check_mul_dimensions(H, ρ0_vec)

    T = _complex_float_type(Base.promote_eltype(H, ψ0))
    return T, to_dense(T, ρ0_vec.data), Operator(), ρ0.dimensions
end
function _handle_init_state_and_sol_type_dims(H::AbstractQuantumObject{SuperOperator}, ψ0::QuantumObject{Tψ}) where {Tψ <: Union{OperatorKet, SuperOperator}}
    !isendomorphic(H.dimensions) && _non_endomorphic_dims_error("Hamiltonian or Liouvillian for time evolution solvers", H.dimensions)
    check_mul_dimensions(H, ψ0)

    T = _complex_float_type(Base.promote_eltype(H, ψ0))
    return T, to_dense(T, ψ0.data), ψ0.type, ψ0.dimensions
end

@doc raw"""
    struct TimeEvolutionSol

A structure storing the results and some information from solving time evolution.

# Fields (Attributes)

- `times::AbstractVector`: The list of time points at which the expectation values are calculated during the evolution.
- `times_states::AbstractVector`: The list of time points at which the states are stored during the evolution.
- `states::Vector{QuantumObject}`: The list of result states corresponding to each time point in `times_states`.
- `expect::Union{AbstractMatrix,Nothing}`: The expectation values corresponding to each time point in `times`.
- `retcode`: The return code from the solver.
- `alg`: The algorithm which is used during the solving process.
- `abstol::Real`: The absolute tolerance which is used during the solving process.
- `reltol::Real`: The relative tolerance which is used during the solving process.
"""
struct TimeEvolutionSol{
        TT1 <: AbstractVector{<:Real},
        TT2 <: AbstractVector{<:Real},
        TS <: AbstractVector,
        TE <: Union{AbstractMatrix, Nothing},
        RETT <: Enum,
        AlgT <: AbstractODEAlgorithm,
        TolT <: Real,
    }
    times::TT1
    times_states::TT2
    states::TS
    expect::TE
    retcode::RETT
    alg::AlgT
    abstol::TolT
    reltol::TolT
end

function Base.show(io::IO, sol::TimeEvolutionSol)
    print(io, "Solution of time evolution\n")
    print(io, "(return code: $(sol.retcode))\n")
    print(io, "--------------------------\n")
    print(io, "num_states = $(length(sol.states))\n")
    if sol.expect isa Nothing
        print(io, "num_expect = 0\n")
    else
        print(io, "num_expect = $(size(sol.expect, 1))\n")
    end
    print(io, "ODE alg.: $(sol.alg)\n")
    print(io, "abstol = $(sol.abstol)\n")
    print(io, "reltol = $(sol.reltol)\n")
    return nothing
end

@doc raw"""
    struct TimeEvolutionMCSol <: TimeEvolutionMultiTrajSol

A structure storing the results and some information from solving quantum trajectories of the Monte Carlo wave function time evolution.

# Fields (Attributes)

- `ntraj::Int`: Number of trajectories
- `times::AbstractVector`: The list of time points at which the expectation values are calculated during the evolution.
- `times_states::AbstractVector`: The list of time points at which the states are stored during the evolution.
- `states::AbstractVecOrMat`: The list of result states in each trajectory and each time point in `times_states`.
- `expect::Union{AbstractArray,Nothing}`: The expectation values corresponding to each trajectory and each time point in `times`.
- `col_times::Vector{Vector{Real}}`: The time records of every quantum jump occurred in each trajectory.
- `col_which::Vector{Vector{Int}}`: The indices of which collapse operator was responsible for each quantum jump in `col_times`.
- `converged::Bool`: Whether the solution is converged or not.
- `alg`: The algorithm which is used during the solving process.
- `abstol::Real`: The absolute tolerance which is used during the solving process.
- `reltol::Real`: The relative tolerance which is used during the solving process.

# Notes

When the keyword argument `keep_runs_results` is passed as `Val(false)` to a multi-trajectory solver, the `states` and `expect` fields store only the average results (averaged over all trajectories). The results can be accessed by the following index-order:

- `sol.states[time_idx]`
- `sol.expect[e_op,time_idx]`

If the keyword argument `keep_runs_results = Val(true)`, the results for each trajectory and each time are stored, and the index-order of the elements in fields `states` and `expect` are:

- `sol.states[trajectory,time_idx]`
- `sol.expect[e_op,trajectory,time_idx]`

We also provide the following functions for statistical analysis of multi-trajectory solutions:

- [`average_states`](@ref)
- [`average_expect`](@ref)
- [`std_expect`](@ref)
"""
struct TimeEvolutionMCSol{
        TT1 <: AbstractVector{<:Real},
        TT2 <: AbstractVector{<:Real},
        TS <: AbstractVecOrMat,
        TE <: Union{AbstractArray, Nothing},
        TJT <: Vector{<:Vector{<:Real}},
        TJW <: Vector{<:Vector{<:Integer}},
        AlgT <: AbstractODEAlgorithm,
        TolT <: Real,
    } <: TimeEvolutionMultiTrajSol{TS, TE}
    ntraj::Int
    times::TT1
    times_states::TT2
    states::TS
    expect::TE
    col_times::TJT
    col_which::TJW
    converged::Bool
    alg::AlgT
    abstol::TolT
    reltol::TolT
end

function Base.show(io::IO, sol::TimeEvolutionMCSol)
    print(io, "Solution of quantum trajectories\n")
    print(io, "(converged: $(sol.converged))\n")
    print(io, "--------------------------------\n")
    print(io, "num_trajectories = $(sol.ntraj)\n")
    print(io, "num_states = $(size(sol.states, ndims(sol.states)))\n") # get the size of last dimension
    if sol.expect isa Nothing
        print(io, "num_expect = 0\n")
    else
        print(io, "num_expect = $(size(sol.expect, 1))\n")
    end
    print(io, "ODE alg.: $(sol.alg)\n")
    print(io, "abstol = $(sol.abstol)\n")
    print(io, "reltol = $(sol.reltol)\n")
    return nothing
end

@doc raw"""
    struct TimeEvolutionStochasticSol

A structure storing the results and some information from solving trajectories of the Stochastic time evolution.

# Fields (Attributes)

- `ntraj::Int`: Number of trajectories
- `times::AbstractVector`: The list of time points at which the expectation values are calculated during the evolution.
- `times_states::AbstractVector`: The list of time points at which the states are stored during the evolution.
- `states::AbstractVecOrMat`: The list of result states in each trajectory and each time point in `times_states`.
- `expect::Union{AbstractArray,Nothing}`: The expectation values corresponding to each trajectory and each time point in `times`.
- `converged::Bool`: Whether the solution is converged or not.
- `alg`: The algorithm which is used during the solving process.
- `abstol::Real`: The absolute tolerance which is used during the solving process.
- `reltol::Real`: The relative tolerance which is used during the solving process.

# Notes

When the keyword argument `keep_runs_results` is passed as `Val(false)` to a multi-trajectory solver, the `states` and `expect` fields store only the average results (averaged over all trajectories). The results can be accessed by the following index-order:

- `sol.states[time_idx]`
- `sol.expect[e_op,time_idx]`

If the keyword argument `keep_runs_results = Val(true)`, the results for each trajectory and each time are stored, and the index-order of the elements in fields `states` and `expect` are:

- `sol.states[trajectory,time_idx]`
- `sol.expect[e_op,trajectory,time_idx]`

We also provide the following functions for statistical analysis of multi-trajectory solutions:

- [`average_states`](@ref)
- [`average_expect`](@ref)
- [`std_expect`](@ref)
"""
struct TimeEvolutionStochasticSol{
        TT1 <: AbstractVector{<:Real},
        TT2 <: AbstractVector{<:Real},
        TS <: AbstractVecOrMat,
        TE <: Union{AbstractArray, Nothing},
        TEM <: Union{AbstractArray, Nothing},
        AlgT <: AbstractSDEAlgorithm,
        TolT <: Real,
    } <: TimeEvolutionMultiTrajSol{TS, TE}
    ntraj::Int
    times::TT1
    times_states::TT2
    states::TS
    expect::TE
    measurement::TEM
    converged::Bool
    alg::AlgT
    abstol::TolT
    reltol::TolT
end

function Base.show(io::IO, sol::TimeEvolutionStochasticSol)
    print(io, "Solution of stochastic quantum trajectories\n")
    print(io, "(converged: $(sol.converged))\n")
    print(io, "--------------------------------\n")
    print(io, "num_trajectories = $(sol.ntraj)\n")
    print(io, "num_states = $(size(sol.states, ndims(sol.states)))\n") # get the size of last dimension
    if sol.expect isa Nothing
        print(io, "num_expect = 0\n")
    else
        print(io, "num_expect = $(size(sol.expect, 1))\n")
    end
    print(io, "SDE alg.: $(sol.alg)\n")
    print(io, "abstol = $(sol.abstol)\n")
    print(io, "reltol = $(sol.reltol)\n")
    return nothing
end

@doc raw"""
    average_states(sol::TimeEvolutionMultiTrajSol)

Return the trajectory-averaged result states (as density [`Operator`](@ref)) at each time point.
"""
average_states(sol::TimeEvolutionMultiTrajSol{<:Matrix{<:QuantumObject}}) = _average_traj_states(sol.states)
average_states(sol::TimeEvolutionMultiTrajSol{<:Vector{<:QuantumObject}}) = sol.states  # this case should already be averaged over all trajectories

# TODO: Check if broadcasting division ./ size(states, 1) is type stable
_average_traj_states(states::Matrix{<:QuantumObject{Ket}}) =
    map(x -> x / size(states, 1), dropdims(sum(ket2dm, states, dims = 1), dims = 1))
_average_traj_states(states::Matrix{<:QuantumObject{ObjType}}) where {ObjType <: Union{Operator, OperatorKet}} =
    map(x -> x / size(states, 1), dropdims(sum(states, dims = 1), dims = 1))

@doc raw"""
    average_expect(sol::TimeEvolutionMultiTrajSol)

Return the trajectory-averaged expectation values at each time point.
"""
average_expect(sol::TimeEvolutionMultiTrajSol{TS, Array{T, 3}}) where {TS, T <: Number} = _average_traj_expect(sol.expect)
average_expect(sol::TimeEvolutionMultiTrajSol{TS, Matrix{T}}) where {TS, T <: Number} = sol.expect  # this case should already be averaged over all trajectories
average_expect(::TimeEvolutionMultiTrajSol{TS, Nothing}) where {TS} = nothing

_average_traj_expect(expvals::Array{T, 3}) where {T <: Number} =
    dropdims(sum(expvals, dims = 2), dims = 2) ./ size(expvals, 2)

# these are used in multi-trajectory solvers before returning solutions
_store_multitraj_states(states::Matrix{<:QuantumObject}, keep_runs_results::Val{false}) = _average_traj_states(states)
_store_multitraj_states(states::Matrix{<:QuantumObject}, keep_runs_results::Val{true}) = states
_store_multitraj_expect(expvals::Array{T, 3}, keep_runs_results::Val{false}) where {T <: Number} =
    _average_traj_expect(expvals)
_store_multitraj_expect(expvals::Array{T, 3}, keep_runs_results::Val{true}) where {T <: Number} = expvals
_store_multitraj_expect(expvals::Nothing, keep_runs_results) = nothing

@doc raw"""
    std_expect(sol::TimeEvolutionMultiTrajSol)

Return the trajectory-wise standard deviation of the expectation values at each time point.
"""
function std_expect(sol::TimeEvolutionMultiTrajSol{TS, Array{T, 3}}) where {TS, T <: Number}
    # the following standard deviation (std) is defined as the square-root of variance instead of pseudo-variance
    # i.e., it is equivalent to (even for complex expectation values):
    #    dropdims(
    #        sqrt.(mean(abs2.(sol.expect), dims = 2) .- abs2.(mean(sol.expect, dims = 2))),
    #        dims = 2
    #    )
    # [this should be included in the runtest]
    return dropdims(std(sol.expect, corrected = false, dims = 2), dims = 2)
end
std_expect(::TimeEvolutionMultiTrajSol{TS, Matrix{T}}) where {TS, T <: Number} = throw(
    ArgumentError(
        "Can not compute the standard deviation without the expectation values of each trajectory. Try to specify keyword argument `keep_runs_results=Val(true)` to the solver.",
    ),
)
std_expect(::TimeEvolutionMultiTrajSol{TS, Nothing}) where {TS} = nothing

#######################################
#=
    Callbacks for Monte Carlo quantum trajectories
=#

abstract type LindbladJumpCallbackType end

struct ContinuousLindbladJumpCallback <: LindbladJumpCallbackType
    interp_points::Int
end

struct DiscreteLindbladJumpCallback <: LindbladJumpCallbackType end

ContinuousLindbladJumpCallback(; interp_points::Int = 10) = ContinuousLindbladJumpCallback(interp_points)

function _check_tlist(tlist, T::Type)
    tlist2 = convert(Vector{T}, tlist) # Convert it to support GPUs and avoid type instabilities for OrdinaryDiffEq.jl

    # Check if the list of times is not empty
    isempty(tlist2) && throw(ArgumentError("The time list must not be empty."))
    # Check if the list of times is sorted
    issorted(tlist2) || throw(ArgumentError("The time list must be sorted."))
    # Check if the list of times is unique
    allunique(tlist2) || throw(ArgumentError("The time list must be unique."))

    return tlist2
end

#######################################

_make_c_ops_list(c_ops) = c_ops
_make_c_ops_list(c_ops::AbstractQuantumObject) = (c_ops,)

function _merge_saveat(tlist, e_ops, default_options; kwargs...)
    is_empty_e_ops = isnothing(e_ops) ? true : isempty(e_ops)
    saveat = is_empty_e_ops ? tlist : [tlist[end]]
    default_values = (default_options..., saveat = saveat)
    kwargs2 = merge(default_values, kwargs)

    # DifferentialEquations.jl has this weird save_end setting
    # So we need to do this to make sure it's consistent
    haskey(kwargs, :save_end) && return kwargs2
    isempty(kwargs2.saveat) && return kwargs2

    save_end = tlist[end] in kwargs2.saveat
    return merge(kwargs2, (save_end = save_end,))
end

#######################################
#=
Helpers for handling output of ensemble problems.
This is very useful especially for dispatching which method to use to update the progress bar.
=#

# Output function with progress bar update
function _ensemble_output_func_progress(sol, i, progr, output_func)
    next!(progr)
    return output_func(sol, i)
end

# Output function with distributed channel update for progress bar
function _ensemble_output_func_distributed(sol, i, channel, output_func)
    put!(channel, true)
    return output_func(sol, i)
end

function _ensemble_dispatch_output_func(
        ::ET,
        progress_bar,
        ntraj,
        output_func;
        progr_desc = "Progress: ",
    ) where {ET <: Union{EnsembleSerial, EnsembleThreads}}
    if getVal(progress_bar)
        progr = Progress(ntraj; enabled = getVal(progress_bar), desc = progr_desc, settings.ProgressMeterKWARGS...)
        f = (sol, i) -> _ensemble_output_func_progress(sol, i, progr, output_func)
        return (f, progr, nothing)
    else
        return (output_func, nothing, nothing)
    end
end
function _ensemble_dispatch_output_func(
        ::ET,
        progress_bar,
        ntraj,
        output_func;
        progr_desc = "Progress... ",
    ) where {ET <: Union{EnsembleSplitThreads, EnsembleDistributed}}
    if getVal(progress_bar)
        progr = Progress(ntraj; enabled = getVal(progress_bar), desc = progr_desc, settings.ProgressMeterKWARGS...)
        progr_channel::RemoteChannel{Channel{Bool}} = RemoteChannel(() -> Channel{Bool}(1))

        f = (sol, i) -> _ensemble_output_func_distributed(sol, i, progr_channel, output_func)
        return (f, progr, progr_channel)
    else
        return (output_func, nothing, nothing)
    end
end

function _ensemble_dispatch_prob_func(rng, ntraj, tlist, prob_func; kwargs...)
    seeds = map(i -> rand(rng, UInt64), 1:ntraj)
    return (prob, i, repeat) -> prob_func(prob, i, repeat, rng, seeds, tlist; kwargs...)
end

function _ensemble_dispatch_solve(
        ens_prob::TimeEvolutionProblem,
        alg::Union{<:AbstractODEAlgorithm, <:AbstractSDEAlgorithm},
        ensemblealg::ET,
        ntraj::Int,
    ) where {ET <: Union{EnsembleSplitThreads, EnsembleDistributed}}
    sol = nothing

    @sync begin
        @async while take!(ens_prob.kwargs.channel)
            next!(ens_prob.kwargs.progr)
        end

        @async begin
            sol = solve(ens_prob.prob, alg, ensemblealg, trajectories = ntraj)
            put!(ens_prob.kwargs.channel, false)
        end
    end

    return sol
end
function _ensemble_dispatch_solve(
        ens_prob::TimeEvolutionProblem,
        alg::Union{<:AbstractODEAlgorithm, <:AbstractSDEAlgorithm},
        ensemblealg,
        ntraj::Int,
    )
    sol = solve(ens_prob.prob, alg, ensemblealg, trajectories = ntraj)
    return sol
end

# For mapped solvers
function _se_me_map_prob_func(prob, i, repeat, iter)
    f = deepcopy(prob.f.f)
    u0 = iter[i][1]
    p = iter[i][2:end]
    if haskey(prob.kwargs, :callback)
        return remake(prob, f = f, u0 = u0, p = p, callback = deepcopy(prob.kwargs[:callback]))
    else
        return remake(prob, f = f, u0 = u0, p = p)
    end
end

#######################################
#=
 Stochastic funcs
=#
function _stochastic_prob_func(prob, i, repeat, rng, seeds, tlist; kwargs...)
    seed = seeds[i]
    traj_rng = typeof(rng)()
    seed!(traj_rng, seed)

    sc_ops = kwargs[:sc_ops]
    store_measurement = kwargs[:store_measurement]
    noise = _make_noise(prob.prob.tspan[1], sc_ops, store_measurement, traj_rng)

    return remake(prob.prob, noise = noise, seed = seed)
end

# Standard output function which does nothing (used for mapped and stochastic solvers)
_standard_output_func(sol, i) = (sol, false)

#= 
    Define diagonal or non-diagonal noise depending on the type of `sc_ops`.
    If `sc_ops` is a `AbstractQuantumObject`, we avoid using the non-diagonal noise.
=#
function _make_noise(t0, sc_ops, store_measurement::Val, rng)
    noise = RealWienerProcess!(
        t0,
        zeros(length(sc_ops)),
        zeros(length(sc_ops)),
        save_everystep = getVal(store_measurement),
        rng = rng,
    )

    return noise
end
function _make_noise(t0, sc_ops::AbstractQuantumObject, store_measurement::Val, rng)
    noise = RealWienerProcess(t0, 0.0, 0.0, save_everystep = getVal(store_measurement), rng = rng)

    return noise
end

#=
    struct DiffusionOperator

A struct to represent the diffusion operator. This is used to perform the diffusion process on N different Wiener processes.
=#
struct DiffusionOperator{T, OpType <: Union{Tuple{Vararg{AbstractSciMLOperator}}, AbstractVector{<:AbstractSciMLOperator}}}
    ops::OpType
    function DiffusionOperator(ops::OpType) where {OpType}
        T = mapreduce(eltype, promote_type, ops)
        return new{T, OpType}(ops)
    end
end

@generated function (L::DiffusionOperator{T, OpType} where {T, OpType <: Tuple})(w, v, p, t)
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    return quote
        M = length(v)
        S = (size(w, 1), size(w, 2)) # This supports also `w` as a `Vector`
        (S[1] == M && S[2] == $N) || throw(DimensionMismatch("The size of the output vector is incorrect."))
        Base.@nexprs $N i -> begin
            L.ops[i](@view(w[:, i]), v, v, p, t)
        end
        return w
    end
end

function (L::DiffusionOperator{T, OpType} where {T, OpType <: AbstractVector})(w, v, p, t)
    N = length(L.ops)
    M = length(v)
    S = (size(w, 1), size(w, 2)) # This supports also `w` as a `Vector`
    (S[1] == M && S[2] == N) || throw(DimensionMismatch("The size of the output vector is incorrect."))

    for i in Base.OneTo(N)
        L.ops[i](@view(w[:, i]), v, v, p, t)
    end
    return w
end

#######################################

function liouvillian_floquet(
        L₀::QuantumObject{SuperOperator},
        Lₚ::QuantumObject{SuperOperator},
        Lₘ::QuantumObject{SuperOperator},
        ω::Real;
        n_max::Int = 3,
        tol::Real = 1.0e-15,
    )
    check_dimensions(L₀, Lₚ, Lₘ)
    return _liouvillian_floquet(L₀, Lₚ, Lₘ, ω, n_max, tol)
end

function liouvillian_floquet(
        H::QuantumObject{OpType1},
        Hₚ::QuantumObject{OpType2},
        Hₘ::QuantumObject{OpType3},
        ω::Real,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        n_max::Int = 3,
        tol::Real = 1.0e-15,
    ) where {
        OpType1 <: Union{Operator, SuperOperator},
        OpType2 <: Union{Operator, SuperOperator},
        OpType3 <: Union{Operator, SuperOperator},
    }
    L₀ = liouvillian(H, c_ops)
    (L₀ isa QuantumObject) || throw(ArgumentError("liouvillian_floquet only supports (time-independent) QuantumObject in c_ops"))
    return liouvillian_floquet(L₀, liouvillian(Hₚ), liouvillian(Hₘ), ω, n_max = n_max, tol = tol)
end

function _liouvillian_floquet(
        L₀::QuantumObject{SuperOperator},
        Lₚ::QuantumObject{SuperOperator},
        Lₘ::QuantumObject{SuperOperator},
        ω::Real,
        n_max::Int,
        tol::Real,
    )
    L_0 = L₀.data
    L_p = Lₚ.data
    L_m = Lₘ.data
    L_p_dense = to_dense(Lₚ.data)
    L_m_dense = to_dense(Lₘ.data)

    S = -(L_0 - 1im * n_max * ω * I) \ L_p_dense
    T = -(L_0 + 1im * n_max * ω * I) \ L_m_dense

    for n_i in (n_max - 1):-1:1
        S = -(L_0 - 1im * n_i * ω * I + L_m * S) \ L_p_dense
        T = -(L_0 + 1im * n_i * ω * I + L_p * T) \ L_m_dense
    end

    tol == 0 && return QuantumObject(L_0 + L_m * S + L_p * T, SuperOperator(), L₀.dimensions)
    return QuantumObject(to_sparse(L_0 + L_m * S + L_p * T, tol), SuperOperator(), L₀.dimensions)
end

@testitem "States and Operators" begin
    import QuantumToolbox: position, momentum
    using LinearAlgebra
    using SparseArrays

    @testset "zero state" begin
        v1 = zero_ket(4)
        v2 = zero_ket((2, 2))
        @test size(v1) == (4,)
        @test size(v2) == (4,)
        @test v1.data == v2.data
        @test v1 != v2
        @test isket(v1)
        @test isket(v2)
        @test v1.dims == ([4], [1])
        @test v2.dims == ([2, 2], [1, 1])
    end

    @testset "fock state" begin
        # fock, basis, and fock_dm
        @test fock_dm(4; dims = (2, 2), sparse = Val(true)) ≈ ket2dm(basis(4; dims = (2, 2)))
        @test_throws DimensionMismatch fock(4; dims = 2)
        @test_throws ArgumentError fock(4, 4)
    end

    @testset "coherent state" begin
        # coherent and coherent_dm
        N = 4
        α = 0.25im
        ψα = coherent(N, α)
        ρα = coherent_dm(N, α)
        @test isket(ψα)
        @test isoper(ρα)
        @test ket2dm(ψα) ≈ ρα
        @test tr(ρα) ≈ 1.0
    end

    @testset "thermal state" begin
        N = 5

        # extreme cases
        ρTd0 = thermal_dm(N, 0.0)
        ρTs0 = thermal_dm(N, 0.0; sparse = Val(true))
        ρTd∞ = thermal_dm(N, Inf)
        ρTs∞ = thermal_dm(N, Inf; sparse = Val(true))
        @test tr(ρTd0) ≈ tr(ρTs0) ≈ tr(ρTd∞) ≈ tr(ρTs∞) ≈ 1.0
        @test ρTd0 ≈ ρTs0 ≈ fock_dm(N, 0)
        @test ρTd∞ ≈ ρTs∞ ≈ maximally_mixed_dm(N)

        # general case (also test BigFloat)
        ρTd = thermal_dm(N, big(0.123))
        ρTs = thermal_dm(N, big(0.123); sparse = Val(true))
        @test isoper(ρTd)
        @test ρTd.dims == ([N], [N])
        @test tr(ρTd) ≈ tr(ρTs) ≈ 1.0
        @test diag(ρTd) ≈ Float64[
            0.8904859864731106,
            0.09753319353178326,
            0.010682620484781245,
            0.0011700465891612583,
            0.00012815292116369966,
        ]
        @test ρTs.data isa AbstractSparseMatrix
        @test ρTd ≈ ρTs
    end

    @testset "maximally mixed state" begin
        ρ1 = maximally_mixed_dm(4)
        ρ2 = maximally_mixed_dm((2, 2))
        @test size(ρ1) == (4, 4)
        @test size(ρ2) == (4, 4)
        @test tr(ρ1) ≈ 1.0
        @test ρ1.data == ρ2.data
        @test ρ1 != ρ2
        @test isoper(ρ1)
        @test isoper(ρ2)
        @test ρ1.dims == ([4], [4])
        @test ρ2.dims == ([2, 2], [2, 2])
        @test entropy_vn(ρ1, base = 2) ≈ log(2, 4)
    end

    @testset "random state" begin
        # rand_ket and rand_dm
        ψ = rand_ket(10)
        ρ_AB = rand_dm((2, 2))
        ρ_A = ptrace(ρ_AB, 1)
        ρ_B = ptrace(ρ_AB, 2)
        rank = 5
        ρ_low_rank = rand_dm(10, rank = rank)
        eig_val = eigenenergies(ρ_low_rank)
        @test ψ' * ψ ≈ 1.0
        @test tr(ρ_AB) ≈ 1.0
        @test tr(ρ_A) ≈ 1.0
        @test tr(ρ_B) ≈ 1.0
        @test tr(ρ_low_rank) ≈ 1.0
        @test isposdef(ρ_AB) == true
        @test ishermitian(ρ_AB) == true
        @test ishermitian(ρ_A) == true
        @test ishermitian(ρ_B) == true
        @test ishermitian(ρ_low_rank) == true
        @test all(eigenenergies(ρ_AB) .>= 0)
        @test all(eigenenergies(ρ_A) .>= 0)
        @test all(eigenenergies(ρ_B) .>= 0)
        @test all(isapprox.(eig_val[1:rank], 0.0, atol = 1.0e-10))
        @test all(eig_val[(rank + 1):10] .>= 0)
        @test_throws DomainError rand_dm(4, rank = rank)
        @test_throws DomainError rand_dm(4, rank = 0)
    end

    @testset "entanglement states" begin
        # bell_state, singlet_state, triplet_states, w_state, and ghz_state
        e0 = basis(2, 0)
        e1 = basis(2, 1)
        d0 = basis(3, 0)
        d1 = basis(3, 1)
        d2 = basis(3, 2)
        B00 = (e0 ⊗ e0 + e1 ⊗ e1) / √2
        B01 = (e0 ⊗ e0 - e1 ⊗ e1) / √2
        B10 = (e0 ⊗ e1 + e1 ⊗ e0) / √2
        B11 = (e0 ⊗ e1 - e1 ⊗ e0) / √2
        S = singlet_state()
        T = triplet_states()
        @test bell_state(0, 0) == B00 == ghz_state(2)
        @test bell_state(0, 1) == B01
        @test bell_state(1, 0) == B10 == T[2] == w_state(2)
        @test bell_state(1, 1) == B11 == S
        @test T[1] == e1 ⊗ e1
        @test T[3] == e0 ⊗ e0
        @test w_state(3) == (e0 ⊗ e0 ⊗ e1 + e0 ⊗ e1 ⊗ e0 + e1 ⊗ e0 ⊗ e0) / √3
        @test ghz_state(3) == (e0 ⊗ e0 ⊗ e0 + e1 ⊗ e1 ⊗ e1) / √2
        @test ghz_state(3; d = 3) == (d0 ⊗ d0 ⊗ d0 + d1 ⊗ d1 ⊗ d1 + d2 ⊗ d2 ⊗ d2) / √3
        @test_throws ArgumentError bell_state(0, 2)
        @test_throws ArgumentError bell_state(3, 1)
        @test_throws ArgumentError bell_state(2, 3)
        @test_throws ArgumentError w_state(1)
        @test_throws ArgumentError ghz_state(1)
        @test_throws ArgumentError ghz_state(2; d = 1)
    end

    @testset "bosonic operators" begin
        # destroy, create, num, position, momentum
        n = 10
        i, j = rand(0:(n - 1), 2)
        a = destroy(n)
        ad = create(n)
        N = num(n)
        x = position(n)
        p = momentum(n)
        Pij = projection(n, i, j)
        @test isoper(x)
        @test isoper(p)
        @test a.dims == ad.dims == N.dims == x.dims == p.dims == ([n], [n])
        @test eigenenergies(ad * a) ≈ 0:(n - 1)
        @test commutator(N, a) ≈ -a
        @test commutator(N, ad) ≈ ad
        @test all(diag(commutator(x, p))[1:(n - 1)] .≈ 1.0im)
        @test fock(n, i) == Pij * fock(n, j)
        @test_throws ArgumentError projection(n, n, 0)
        @test_throws ArgumentError projection(n, 0, n)
    end

    @testset "displacement and squeezing operators" begin
        N = 10
        α = rand(ComplexF64)
        z = rand(ComplexF64)
        II = qeye(N)
        D = displace(N, α)
        S = squeeze(N, z)
        @test D * D' ≈ II
        @test S * S' ≈ II
    end

    @testset "phase" begin
        # verify Equation (33) in:
        # Michael Martin Nieto, QUANTUM PHASE AND QUANTUM PHASE OPERATORS: Some Physics and Some History
        s = 10
        ϕ0 = 2 * π * rand()
        II = qeye(s + 1)
        ket = [basis(s + 1, i) for i in 0:s]
        SUM = Qobj(zeros(ComplexF64, s + 1, s + 1))
        for j in 0:s
            for k in 0:s
                (j != k) && (
                    SUM +=
                        (exp(1im * (j - k) * ϕ0) / (exp(1im * (j - k) * 2 * π / (s + 1)) - 1)) * ket[j + 1] * ket[k + 1]'
                )
            end
        end
        @test isapprox((ϕ0 + s * π / (s + 1)) * II + (2 * π / (s + 1)) * SUM, phase(s + 1, ϕ0); atol = 1.0e-8)
    end

    @testset "tunneling" begin
        @test tunneling(10, 2) == tunneling(10, 2; sparse = Val(true))
        @test_throws ArgumentError tunneling(10, 0)
    end

    @testset "quantum Fourier transform" begin
        N = 9
        dims = (3, 3)
        ω = exp(2.0im * π / N)
        x = Qobj(rand(ComplexF64, N))
        ψx = basis(N, 0; dims = dims)
        ψk = unit(Qobj(ones(ComplexF64, N); dims = dims))
        F_9 = qft(N)
        F_3_3 = qft(dims)
        y = F_9 * x
        for k in 0:(N - 1)
            nk = collect(0:(N - 1)) * k
            @test y[k + 1] ≈ sum(x.data .* (ω .^ nk)) / sqrt(N)
        end
        @test ψk ≈ F_3_3 * ψx
        @test ψx ≈ F_3_3' * ψk
    end

    @testset "random unitary" begin
        U1 = rand_unitary(20)
        U2 = rand_unitary(20, :exp)
        U3 = rand_unitary((5, 5))
        U4 = rand_unitary((5, 5), :exp)
        @test isunitary(U1)
        @test isunitary(U2)
        @test isunitary(U3)
        @test isunitary(U4)
        @test U1.dims == U2.dims == ([20], [20])
        @test U3.dims == U4.dims == ([5, 5], [5, 5])

        @test_throws ArgumentError rand_unitary(20, :wrong)
    end

    @testset "Spin-j operators" begin
        # Pauli matrices and general Spin-j operators
        J0 = Qobj(spdiagm(0 => [0.0im]))
        Jx, Jy, Jz = spin_J_set(0.5)
        Sx = sigmax()
        Sy = sigmay()
        Sz = sigmaz()
        @test spin_Jx(0) == spin_Jy(0) == spin_Jz(0) == spin_Jp(0) == spin_Jm(0) == J0
        @test Sx ≈ 2 * spin_Jx(0.5) ≈ 2 * Jx ≈ Qobj(sparse([0.0im 1; 1 0]))
        @test Sy ≈ 2 * spin_Jy(0.5) ≈ 2 * Jy ≈ Qobj(sparse([0.0im -1im; 1im 0]))
        @test Sz ≈ 2 * spin_Jz(0.5) ≈ 2 * Jz ≈ Qobj(sparse([1 0.0im; 0 -1]))
        @test sigmap() ≈ spin_Jp(0.5) ≈ Qobj(sparse([0.0im 1; 0 0]))
        @test sigmam() ≈ spin_Jm(0.5) ≈ Qobj(sparse([0.0im 0; 1 0]))
        @test isunitary(Sx)
        @test isunitary(Sy)
        @test isunitary(Sz)
        for which in [:x, :y, :z, :+, :-]
            @test jmat(2.5, which).dims == ([6], [6]) # 2.5 * 2 + 1 = 6

            for j_wrong in [-1, 8.7]  # Invalid j
                @test_throws ArgumentError jmat(j_wrong, which)
            end
        end
        @test_throws ArgumentError jmat(0.5, :wrong)

        # test commutation relations for general Spin-j operators
        # the negative signs follow the rule of Levi-Civita symbol (ϵ_ijk)
        j = 2
        Jx, Jy, Jz = spin_J_set(j)
        @test commutator(Jx, Jy) ≈ 1im * Jz
        @test commutator(Jy, Jz) ≈ 1im * Jx
        @test commutator(Jz, Jx) ≈ 1im * Jy
        @test commutator(Jx, Jz) ≈ -1im * Jy
        @test commutator(Jy, Jx) ≈ -1im * Jz
        @test commutator(Jz, Jy) ≈ -1im * Jx
    end

    @testset "spin state" begin
        j = 3.5
        Jz = spin_Jz(j)
        for m in (-j):1:j
            ψm = spin_state(j, m)
            @test Jz * ψm ≈ m * ψm  # check eigenvalue
        end
        @test_throws ArgumentError spin_state(8.7, 8.7)
        @test_throws ArgumentError spin_state(-1, 0)
        @test_throws ArgumentError spin_state(2.5, 2)
        @test_throws ArgumentError spin_state(2.5, 3.5)
        @test_throws ArgumentError spin_state(2.5, -3.5)
    end

    @testset "spin coherent state" begin
        # spin-half (state in Bloch sphere)
        s = 0.5
        θ = π * rand()
        ϕ = 2 * π * rand()
        @test spin_coherent(s, θ, ϕ) ≈ cos(θ / 2) * basis(2, 0) + exp(1im * ϕ) * sin(θ / 2) * basis(2, 1)

        # also verify the equation in:
        # Robert Jones, Spin Coherent States and Statistical Physics, page 3
        s = 1.5
        θ1 = π * rand()
        θ2 = π * rand()
        ϕ1 = 2 * π * rand()
        ϕ2 = 2 * π * rand()
        γ = rand()
        Sz = spin_Jz(s)
        n1 = spin_coherent(s, θ1, ϕ1)
        n2 = spin_coherent(s, θ2, ϕ2)
        @test dot(n1, n2) ≈ (cos(θ1 / 2) * cos(θ2 / 2) + exp(1im * (ϕ2 - ϕ1)) * sin(θ1 / 2) * sin(θ2 / 2))^(2 * s)
        @test dot(n1, exp(-γ * Sz), n2) ≈
            (
            exp(-γ / 2) * cos(θ1 / 2) * cos(θ2 / 2) + exp(1im * (ϕ2 - ϕ1) + γ / 2) * sin(θ1 / 2) * sin(θ2 / 2)
        )^(2 * s)

        # test commutation relations for fermionic creation and annihilation operators
        sites = 4
        SIZE = 2^sites
        dims = ntuple(i -> 2, Val(sites))
        Q_iden = Qobj(sparse((1.0 + 0.0im) * I, SIZE, SIZE); dims = dims)
        Q_zero = Qobj(spzeros(ComplexF64, SIZE, SIZE); dims = dims)
        for i in 1:sites
            d_i = fdestroy(sites, i)
            @test d_i' ≈ fcreate(sites, i)

            for j in 1:sites
                d_j = fdestroy(sites, j)

                if i == j
                    @test commutator(d_i, d_j'; anti = true) ≈ Q_iden
                else
                    @test commutator(d_i, d_j'; anti = true) ≈ Q_zero
                end
                @test commutator(d_i', d_j'; anti = true) ≈ Q_zero
                @test commutator(d_i, d_j; anti = true) ≈ Q_zero
            end
        end
        zero = zero_ket((2, 2))
        vac = tensor(basis(2, 0), basis(2, 0))
        d1 = sigmap() ⊗ qeye(2)
        d2 = sigmaz() ⊗ sigmap()
        @test d1 * vac == zero
        @test d2 * vac == zero
        @test d1' * vac == tensor(basis(2, 1), basis(2, 0))
        @test d2' * vac == tensor(basis(2, 0), basis(2, 1))
        @test d1' * d2' * vac == tensor(basis(2, 1), basis(2, 1))
        @test d1' * d1' * d2' * vac == zero
        @test d2' * d1' * d2' * vac == zero
        @test_throws ArgumentError fdestroy(0, 0)
        @test_throws ArgumentError fdestroy(sites, 0)
        @test_throws ArgumentError fdestroy(sites, sites + 1)
    end

    @testset "identity operator" begin
        I_op1 = qeye(4)
        I_op2 = qeye(4, dims = (2, 2))
        I_su1 = qeye(4, type = SuperOperator())
        I_su2 = qeye(4, type = SuperOperator(), dims = 2)
        @test isunitary(I_op1) == true
        @test isunitary(I_op2) == true
        @test isunitary(I_su1) == false
        @test isunitary(I_su2) == false
        @test I_op1.data == I_op2.data == I_su1.data == I_su2.data
        @test (I_op1 == I_op2) == false
        @test (I_op1 == I_su1) == false
        @test (I_op1 == I_su2) == false
        @test (I_op2 == I_su1) == false
        @test (I_op2 == I_su2) == false
        @test (I_su1 == I_su2) == true
        @test_throws DimensionMismatch qeye(4, dims = 2)
        @test_throws DimensionMismatch qeye(2, type = SuperOperator())
        @test_throws DimensionMismatch qeye(4, type = SuperOperator(), dims = (2, 2))
    end

    @testset "superoperators" begin
        # spre, spost, and sprepost
        Xs = sigmax()
        Xd = to_dense(Xs)
        A_wrong1 = Qobj(rand(4, 4), dims = 4)
        A_wrong2 = Qobj(rand(4, 4), dims = (2, 2))
        A_wrong3 = Qobj(rand(3, 3))
        @test !issparse(spre(Xd))
        @test issparse(spre(Xs))
        @test !issparse(spost(Xd))
        @test issparse(spost(Xs))
        @test !issparse(sprepost(Xd, Xd))
        @test issparse(sprepost(Xs, Xs))
        if VERSION >= v"1.11" # kron(::SparseMatrixCSC, ::DenseMatrix) returns DenseArray in Julia 1.10
            @test issparse(sprepost(Xs, Xd))
        end
        @test issparse(sprepost(Xd, Xs))
        @test_throws DimensionMismatch sprepost(A_wrong1, A_wrong2)
        @test_throws DimensionMismatch sprepost(A_wrong1, A_wrong3)
    end

    @testset "Type Inference (States)" begin
        @inferred zero_ket(4)
        @inferred zero_ket((2, 2))

        @inferred fock(4, 1, dims = (2, 2), sparse = Val(true))
        @inferred fock(4, 1, dims = (2, 2), sparse = Val(false))
        @inferred basis(4, 1, dims = (2, 2))

        @inferred coherent(5, 0.25im)

        @inferred rand_ket(10)
        @inferred rand_ket((2, 5))

        @inferred fock_dm(4; dims = (2, 2), sparse = Val(true))
        @inferred fock_dm(4; dims = (2, 2), sparse = Val(false))

        @inferred coherent_dm(5, 0.25im)

        @inferred thermal_dm(10, 0.123)
        @inferred thermal_dm(10, 0.123; sparse = Val(true))

        @inferred maximally_mixed_dm(4)
        @inferred maximally_mixed_dm((2, 2))

        @inferred rand_dm((2, 2))
        @inferred rand_dm(10, rank = 5)

        @inferred spin_state(3.5, 1.5)
        @inferred spin_coherent(0.5, π, 2π)

        @inferred bell_state(Val(0), Val(0))
        @inferred bell_state(Val(0), Val(1))
        @inferred bell_state(Val(1), Val(0))
        @inferred bell_state(Val(1), Val(1))
        @inferred singlet_state()
        @inferred triplet_states()
        @inferred w_state(Val(2))

        @inferred ghz_state(Val(2))
        @inferred ghz_state(Val(3))
        @inferred ghz_state(Val(3); d = 3)
    end

    @testset "Type Inference (Operators)" begin
        @inferred rand_unitary(10, Val(:haar))
        @inferred rand_unitary(10, Val(:exp))

        a = destroy(20)
        a_d = create(20)
        @inferred commutator(a, a_d)

        @inferred destroy(20)
        @inferred create(20)
        @inferred num(20)
        @inferred displace(20, 0.5 + 0.5im)
        @inferred squeeze(20, 0.5 + 0.5im)
        @inferred position(20)
        @inferred momentum(20)

        @inferred phase(20, 0.5)

        @inferred jmat(2.5)
        @inferred jmat(2.5, Val(:x))
        @inferred jmat(2.5, Val(:y))
        @inferred jmat(2.5, Val(:z))

        @inferred sigmap()
        @inferred sigmam()
        @inferred sigmax()
        @inferred sigmay()
        @inferred sigmaz()

        @inferred eye(20)

        @inferred fdestroy(Val(10), 4)
        @inferred fcreate(Val(10), 4)

        @inferred projection(20, 5, 3)

        @inferred tunneling(20, 1, sparse = Val(false))
        @inferred tunneling(20, 1, sparse = Val(true))

        @inferred qft(20)
        @inferred qft((2, 10))
    end

    @testset "Element types" begin
        N = 2
        float_type_list = [Float32, BigFloat]
        for FT in float_type_list
            CT = Complex{FT}

            # states
            @test CT == eltype(zero_ket(CT, N))
            @test CT == eltype(fock(CT, N, 0; sparse = Val(true)))
            @test CT == eltype(fock(CT, N, 0; sparse = Val(false)))
            @test FT == eltype(coherent(N, rand(FT)))
            @test CT == eltype(coherent(N, rand(CT)))
            @test CT == eltype(rand_ket(CT, N))
            @test CT == eltype(fock_dm(CT, N, 0; sparse = Val(true)))
            @test CT == eltype(fock_dm(CT, N, 0; sparse = Val(false)))
            @test FT == eltype(coherent_dm(N, rand(FT)))
            @test CT == eltype(coherent_dm(N, rand(CT)))
            @test FT == eltype(thermal_dm(N, rand(FT); sparse = Val(true)))
            @test FT == eltype(thermal_dm(N, rand(FT); sparse = Val(false)))
            @test CT == eltype(maximally_mixed_dm(CT, N))
            @test CT == eltype(rand_dm(CT, N))
            @test CT == eltype(spin_state(CT, 0.5, 0.5))
            @test CT == eltype(spin_coherent(0.5, rand(FT), rand(FT)))
            @test CT == eltype(bell_state(CT, 0, 0))
            @test CT == eltype(singlet_state(CT))
            @test all(==(CT), eltype.(triplet_states(CT)))
            @test CT == eltype(w_state(CT, N))
            @test CT == eltype(ghz_state(CT, N))

            # operators
            @test CT == eltype(rand_unitary(CT, N, Val(:haar)))
            @test CT == eltype(rand_unitary(CT, N, Val(:exp)))
            @test CT == eltype(spin_Jx(CT, 0.5))
            @test CT == eltype(spin_Jy(CT, 0.5))
            @test CT == eltype(spin_Jz(CT, 0.5))
            @test CT == eltype(spin_Jm(CT, 0.5))
            @test CT == eltype(spin_Jp(CT, 0.5))
            @test all(==(CT), eltype.(spin_J_set(CT, 0.5)))
            @test CT == eltype(sigmam(CT))
            @test CT == eltype(sigmap(CT))
            @test CT == eltype(sigmax(CT))
            @test CT == eltype(sigmay(CT))
            @test CT == eltype(sigmaz(CT))
            @test CT == eltype(destroy(CT, N))
            @test CT == eltype(create(CT, N))
            @test CT == eltype(eye(CT, N))
            @test CT == eltype(projection(CT, N, 0, 0))
            @test FT == eltype(displace(N, rand(FT)))
            @test CT == eltype(displace(N, rand(CT)))
            @test FT == eltype(squeeze(N, rand(FT)))
            @test CT == eltype(squeeze(N, rand(CT)))
            @test CT == eltype(num(CT, N))
            @test CT == eltype(phase(N, rand(FT)))
            @test CT == eltype(position(CT, N))
            @test CT == eltype(momentum(CT, N))
            @test CT == eltype(fdestroy(CT, N, 1))
            @test CT == eltype(fcreate(CT, N, 1))
            @test CT == eltype(tunneling(CT, N))
            @test CT == eltype(qft(CT, N))
        end

        # check default parameter to be Int64 (1)
        @test Float64 == eltype(coherent(N, 1))
        @test Float64 == eltype(coherent_dm(N, 1))
        @test Float64 == eltype(thermal_dm(N, 1; sparse = Val(true)))
        @test Float64 == eltype(thermal_dm(N, 1; sparse = Val(false)))
        @test Float64 == eltype(displace(N, 1))
        @test Float64 == eltype(squeeze(N, 1))
        @test ComplexF64 == eltype(phase(N)) # since default ϕ0 = 0 (also Int64)
    end
end

@testmodule TESetup begin
    using QuantumToolbox
    using Random

    # Global definition of the system
    N = 10
    a = kron(destroy(N), qeye(2))
    σm = kron(qeye(N), sigmam())
    σz = qeye(N) ⊗ sigmaz()

    g = 0.01
    ωc = 1
    ωq = 0.99
    γ = 0.1
    nth = 0.001

    # Jaynes-Cummings Hamiltonian
    H = ωc * a' * a + ωq / 2 * σz + g * (a' * σm + a * σm')
    ψ0 = kron(fock(N, 0), fock(2, 0))

    e_ops = [a' * a, σz]
    c_ops = [sqrt(γ * (1 + nth)) * a, sqrt(γ * nth) * a', sqrt(γ * (1 + nth)) * σm, sqrt(γ * nth) * σm']

    sme_η = 0.7 # Efficiency of the homodyne detector for smesolve
    c_ops_sme = [sqrt(1 - sme_η) * op for op in c_ops]
    sc_ops_sme = [sqrt(sme_η) * op for op in c_ops]

    # The following definition is to test the case of `sc_ops` as an `AbstractQuantumObject`
    c_ops_sme2 = c_ops[2:end]
    sc_ops_sme2 = c_ops[1]

    ψ0_int = Qobj(round.(Int, real.(ψ0.data)), dims = ψ0.dims) # Used for testing the type inference

    ψ_wrong = kron(fock(N - 1, 0), fock(2, 0))

    rng = MersenneTwister(12)

    # QobjEvo
    ωd = 1.02
    F = 0.05
    coef1(p, t) = p.F * exp(1im * p.ωd * t)
    coef2(p, t) = p.F * exp(-1im * p.ωd * t)
    p = (F = F, ωd = ωd)
    H_td = (H, (a, coef1), (a', coef2))
    H_td2 = QobjEvo(H_td)
    L_td = liouvillian(H_td2)

    # time list and saveat
    tlist = range(0, 10 / γ, 100)
    saveat_idxs = 50:90
    saveat = tlist[saveat_idxs]

    # time list for testing exceptions
    tlist1 = Float64[]
    tlist2 = [0, 0.2, 0.1]
    tlist3 = [0, 0.1, 0.1, 0.2]

    # mesolve solution used for comparing results from mcsolve, ssesolve, and smesolve with mesolve
    prob_me = mesolveProblem(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
    sol_me = mesolve(prob_me)
end

@testitem "sesolve" setup = [TESetup] begin
    using SciMLOperators
    import SciMLOperators: ScaledOperator

    # Get parameters from TESetup to simplify the code
    H = TESetup.H
    ψ0 = TESetup.ψ0
    e_ops = TESetup.e_ops

    tlist = range(0, 20 * 2π / TESetup.g, 1000)
    saveat_idxs = 500:900
    saveat = tlist[saveat_idxs]

    prob = sesolveProblem(H, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false))
    sol = sesolve(prob)
    sol2 = sesolve(H, ψ0, tlist, progress_bar = Val(false))
    sol3 = sesolve(H, ψ0, tlist, e_ops = e_ops, saveat = saveat, progress_bar = Val(false))

    ## Analytical solution for the expectation value of a' * a
    Ω_rabi = sqrt(TESetup.g^2 + ((TESetup.ωc - TESetup.ωq) / 2)^2)
    amp_rabi = TESetup.g^2 / Ω_rabi^2
    ##

    @test prob.prob.f.f isa ScaledOperator
    @test !haskey(prob.prob.kwargs, :tstops) # tstops should not exist for time-independent cases
    @test sum(abs.(sol.expect[1, :] .- amp_rabi .* sin.(Ω_rabi * tlist) .^ 2)) / length(tlist) < 0.1
    @test length(sol.times) == length(tlist)
    @test length(sol.times_states) == 1
    @test length(sol.states) == 1
    @test size(sol.expect) == (length(e_ops), length(tlist))
    @test length(sol2.times) == length(tlist)
    @test length(sol2.times_states) == length(tlist)
    @test length(sol2.states) == length(tlist)
    @test sol2.expect === nothing
    @test length(sol3.times) == length(tlist)
    @test length(sol3.times_states) == length(saveat)
    @test length(sol3.states) == length(saveat)
    @test size(sol3.expect) == (length(e_ops), length(tlist))
    @test sol.expect[1, saveat_idxs] ≈ expect(e_ops[1], sol3.states) atol = 1.0e-6

    sol_string = sprint((t, s) -> show(t, "text/plain", s), sol)
    @test sol_string ==
        "Solution of time evolution\n" *
        "(return code: $(sol.retcode))\n" *
        "--------------------------\n" *
        "num_states = $(length(sol.states))\n" *
        "num_expect = $(size(sol.expect, 1))\n" *
        "ODE alg.: $(sol.alg)\n" *
        "abstol = $(sol.abstol)\n" *
        "reltol = $(sol.reltol)\n"

    sol_string2 = sprint((t, s) -> show(t, "text/plain", s), sol2)
    @test sol_string2 ==
        "Solution of time evolution\n" *
        "(return code: $(sol2.retcode))\n" *
        "--------------------------\n" *
        "num_states = $(length(sol2.states))\n" *
        "num_expect = 0\n" *
        "ODE alg.: $(sol2.alg)\n" *
        "abstol = $(sol2.abstol)\n" *
        "reltol = $(sol2.reltol)\n"

    @test_throws ArgumentError sesolve(H, ψ0, TESetup.tlist1, progress_bar = Val(false))
    @test_throws ArgumentError sesolve(H, ψ0, TESetup.tlist2, progress_bar = Val(false))
    @test_throws ArgumentError sesolve(H, ψ0, TESetup.tlist3, progress_bar = Val(false))
    @test_throws ArgumentError sesolve(H, ψ0, tlist, save_idxs = [1, 2], progress_bar = Val(false))
    @test_throws DimensionMismatch sesolve(H, TESetup.ψ_wrong, tlist, progress_bar = Val(false))

    @testset "Memory Allocations" begin
        allocs_tot = @allocations sesolve(H, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false)) # Warm-up
        allocs_tot = @allocations sesolve(H, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false))
        @test allocs_tot < 110

        allocs_tot = @allocations sesolve(H, ψ0, tlist, saveat = [tlist[end]], progress_bar = Val(false)) # Warm-up
        allocs_tot = @allocations sesolve(H, ψ0, tlist, saveat = [tlist[end]], progress_bar = Val(false))
        @test allocs_tot < 95
    end

    @testset "Type Inference sesolve" begin
        @inferred sesolveProblem(H, ψ0, tlist, progress_bar = Val(false))
        @inferred sesolveProblem(H, ψ0, [0, 10], progress_bar = Val(false))
        @inferred sesolveProblem(H, TESetup.ψ0_int, tlist, progress_bar = Val(false))
        @inferred sesolve(H, ψ0, tlist, e_ops = e_ops, progress_bar = Val(true)) # test progress bar
        @inferred sesolve(H, ψ0, tlist, progress_bar = Val(false))
        @inferred sesolve(H, ψ0, tlist, e_ops = e_ops, saveat = saveat, progress_bar = Val(false))
        @inferred sesolve(H, ψ0, tlist, e_ops = (TESetup.a' * TESetup.a, TESetup.a'), progress_bar = Val(false)) # We test the type inference for Tuple of different types
    end
end

@testitem "sesolve_map" setup = [TESetup] begin

    # Get parameters from TESetup to simplify the code
    N = TESetup.N
    a = TESetup.a
    σz = TESetup.σz
    σm = TESetup.σm
    e_ops = TESetup.e_ops

    g = 0.01

    ψ_0_e = tensor(fock(N, 0), basis(2, 0))
    ψ_1_g = tensor(fock(N, 1), basis(2, 1))

    ψ0_list = [ψ_0_e, ψ_1_g]
    ωc_list = [1, 1.01, 1.02]
    ωq_list = [0.96, 0.97, 0.98, 0.99]

    tlist = range(0, 20 * 2π / g, 1000)

    ωc_fun(p, t) = p[1]
    ωq_fun(p, t) = p[2]
    H = QobjEvo(a' * a, ωc_fun) + QobjEvo(σz / 2, ωq_fun) + g * (a' * σm + a * σm')

    sols0 = sesolve_map(TESetup.H, ψ0_list, tlist; e_ops = e_ops, progress_bar = Val(false)) # no params
    sols1 = sesolve_map(H, ψ_0_e, tlist; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))
    sols2 = sesolve_map(H, ψ0_list, tlist; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))
    @test size(sols0) == (2,)
    @test sols0 isa Vector{<:TimeEvolutionSol}
    @test size(sols1) == (1, 3, 4)
    @test sols1 isa Array{<:TimeEvolutionSol}
    @test size(sols2) == (2, 3, 4)
    @test sols2 isa Array{<:TimeEvolutionSol}
    for (i, ωc) in enumerate(ωc_list)
        for (j, ωq) in enumerate(ωq_list)
            sol_0_e = sols2[1, i, j]
            sol_1_g = sols2[2, i, j]

            ## Analytical solution for the expectation value of a' * a
            Ω_rabi = sqrt(g^2 + ((ωc - ωq) / 2)^2)
            amp_rabi = g^2 / Ω_rabi^2

            @test sol_0_e.expect[1, :] ≈ amp_rabi .* sin.(Ω_rabi * tlist) .^ 2 atol = 1.0e-2
            @test sol_1_g.expect[1, :] ≈ 1 .- amp_rabi .* sin.(Ω_rabi * tlist) .^ 2 atol = 1.0e-2
        end
    end

    @testset "Type Inference sesolve_map" begin
        @inferred sesolve_map(TESetup.H, ψ0_list, tlist; e_ops = e_ops, progress_bar = Val(true)) # no params, test progress bar
        @inferred sesolve_map(H, ψ0_list, tlist; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))
    end
end

@testitem "mesolve" setup = [TESetup] begin
    using SciMLOperators

    # Get parameters from TESetup to simplify the code
    H = TESetup.H
    ψ0 = TESetup.ψ0
    tlist = TESetup.tlist
    c_ops = TESetup.c_ops
    e_ops = TESetup.e_ops
    saveat = TESetup.saveat
    sol_me = TESetup.sol_me

    sol_me2 = mesolve(H, ψ0, tlist, c_ops, progress_bar = Val(false))
    sol_me3 = mesolve(H, ψ0, tlist, c_ops, e_ops = e_ops, saveat = saveat, progress_bar = Val(false))

    # For testing the `OperatorKet` input
    sol_me4 = mesolve(H, operator_to_vector(ket2dm(ψ0)), tlist, c_ops, saveat = saveat, progress_bar = Val(false))

    # Redirect to `sesolve`
    sol_me5 = mesolve(H, ψ0, tlist, progress_bar = Val(false))

    @test TESetup.prob_me.prob.f.f isa MatrixOperator
    @test !haskey(TESetup.prob_me.prob.kwargs, :tstops) # tstops should not exist for time-independent cases
    @test isket(sol_me5.states[1])
    @test length(sol_me.times) == length(tlist)
    @test length(sol_me.times_states) == 1
    @test length(sol_me.states) == 1
    @test size(sol_me.expect) == (length(e_ops), length(tlist))
    @test length(sol_me2.times) == length(tlist)
    @test length(sol_me2.times_states) == length(tlist)
    @test length(sol_me2.states) == length(tlist)
    @test sol_me2.expect === nothing
    @test length(sol_me3.times) == length(tlist)
    @test length(sol_me3.times_states) == length(saveat)
    @test length(sol_me3.states) == length(saveat)
    @test size(sol_me3.expect) == (length(e_ops), length(tlist))
    @test sol_me3.expect[1, TESetup.saveat_idxs] ≈ expect(e_ops[1], sol_me3.states) atol = 1.0e-6
    @test all([sol_me3.states[i] ≈ vector_to_operator(sol_me4.states[i]) for i in eachindex(saveat)])

    sol_me_string = sprint((t, s) -> show(t, "text/plain", s), sol_me)
    @test sol_me_string ==
        "Solution of time evolution\n" *
        "(return code: $(sol_me.retcode))\n" *
        "--------------------------\n" *
        "num_states = $(length(sol_me.states))\n" *
        "num_expect = $(size(sol_me.expect, 1))\n" *
        "ODE alg.: $(sol_me.alg)\n" *
        "abstol = $(sol_me.abstol)\n" *
        "reltol = $(sol_me.reltol)\n"

    @test_throws ArgumentError mesolve(H, ψ0, TESetup.tlist1, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError mesolve(H, ψ0, TESetup.tlist2, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError mesolve(H, ψ0, TESetup.tlist3, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError mesolve(H, ψ0, tlist, c_ops, save_idxs = [1, 2], progress_bar = Val(false))
    @test_throws DimensionMismatch mesolve(H, TESetup.ψ_wrong, tlist, c_ops, progress_bar = Val(false))

    @testset "Memory Allocations (mesolve)" begin
        a = TESetup.a
        p = TESetup.p

        # We predefine the Liouvillian to avoid to count the allocations of the liouvillian function
        L = liouvillian(H, c_ops)
        L_td = QobjEvo((liouvillian(H, c_ops), (liouvillian(a), TESetup.coef1), (liouvillian(a'), TESetup.coef2)))

        allocs_tot = @allocations mesolve(L, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false)) # Warm-up
        allocs_tot = @allocations mesolve(L, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false))
        @test allocs_tot < 180

        allocs_tot = @allocations mesolve(L, ψ0, tlist, saveat = [tlist[end]], progress_bar = Val(false)) # Warm-up
        allocs_tot = @allocations mesolve(L, ψ0, tlist, saveat = [tlist[end]], progress_bar = Val(false))
        @test allocs_tot < 110

        allocs_tot = @allocations mesolve(L_td, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false), params = p) # Warm-up
        allocs_tot = @allocations mesolve(L_td, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false), params = p)
        @test allocs_tot < 180

        allocs_tot = @allocations mesolve(L_td, ψ0, tlist, progress_bar = Val(false), saveat = [tlist[end]], params = p) # Warm-up
        allocs_tot = @allocations mesolve(L_td, ψ0, tlist, progress_bar = Val(false), saveat = [tlist[end]], params = p)
        @test allocs_tot < 110
    end

    @testset "Type Inference (mesolve)" begin
        a = TESetup.a
        p = TESetup.p

        coef(p, t) = exp(-t)
        ad_t = QobjEvo(a', coef)
        @inferred mesolveProblem(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
        @inferred mesolveProblem(H, ψ0, [0, 10], c_ops, e_ops = e_ops, progress_bar = Val(false))
        @inferred mesolveProblem(H, TESetup.ψ0_int, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
        @inferred mesolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(true)) # also test progress bar
        @inferred mesolve(H, ψ0, tlist, c_ops, progress_bar = Val(false))
        @inferred mesolve(H, ψ0, tlist, c_ops, e_ops = e_ops, saveat = tlist, progress_bar = Val(false))
        @inferred mesolve(H, ψ0, tlist, (a, ad_t), e_ops = (a' * a, a'), progress_bar = Val(false)) # We test the type inference for Tuple
        @inferred mesolve(TESetup.H_td, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p)
        @inferred mesolve(TESetup.H_td2, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p)
        @inferred mesolve(TESetup.L_td, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p)
    end
end

@testitem "mesolve_map" setup = [TESetup] begin

    # Get parameters from TESetup to simplify the code
    N = TESetup.N
    a = TESetup.a
    σz = TESetup.σz
    σm = TESetup.σm
    ψ0 = TESetup.ψ0
    c_ops = TESetup.c_ops
    e_ops = TESetup.e_ops
    γ = TESetup.γ
    nth = TESetup.nth

    g = 0.01

    ψ_0_e = tensor(fock(N, 0), basis(2, 0))
    ψ_1_g = tensor(fock(N, 1), basis(2, 1))

    ψ0_list = [ψ_0_e, ψ_1_g]
    ωc_list = [1, 1.01, 1.02]
    ωq_list = [0.96, 0.97, 0.98, 0.99]

    tlist = range(0, 10 / γ, 100)

    ωc_fun(p, t) = p[1]
    ωq_fun(p, t) = p[2]
    H = QobjEvo(a' * a, ωc_fun) + QobjEvo(σz / 2, ωq_fun) + g * (a' * σm + a * σm')

    # Test with multiple initial states but no params
    sols0 = mesolve_map(TESetup.H, ψ0_list, tlist, c_ops; e_ops = e_ops, progress_bar = Val(false))
    # Test with single initial state
    sols1 = mesolve_map(H, ψ_0_e, tlist, c_ops; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))
    # Test with multiple initial states
    sols2 = mesolve_map(H, ψ0_list, tlist, c_ops; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))

    # Test redirect to sesolve_map when c_ops is nothing
    sols3 = mesolve_map(H, ψ0_list, tlist; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))

    @test size(sols0) == (2,)
    @test sols0 isa Vector{<:TimeEvolutionSol}
    @test size(sols1) == (1, 3, 4)
    @test sols1 isa Array{<:TimeEvolutionSol}
    @test size(sols2) == (2, 3, 4)
    @test sols2 isa Array{<:TimeEvolutionSol}
    @test size(sols3) == (2, 3, 4)
    @test sols3 isa Array{<:TimeEvolutionSol}

    # Verify that solutions make physical sense
    for (i, ωc) in enumerate(ωc_list)
        for (j, ωq) in enumerate(ωq_list)
            sol_0_e = sols2[1, i, j]
            sol_1_g = sols2[2, i, j]

            # Check that expectation values are bounded and physical (take real part for physical observables)
            @test all(x -> real(x) >= -1.0e-4, sol_0_e.expect[1, :]) # a'a should be non-negative (with small tolerance)
            @test all(x -> real(x) >= -1.0e-4, sol_1_g.expect[1, :])
        end
    end

    # Test with OperatorKet input
    ρ0 = operator_to_vector(ket2dm(ψ_0_e))
    ρ0_list = [operator_to_vector(ket2dm(ψ_0_e)), operator_to_vector(ket2dm(ψ_1_g))]
    sols4 = mesolve_map(H, ρ0_list, tlist, c_ops; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))

    @test size(sols4) == (2, 3, 4)
    @test all(isoperket.(getfield.(sols4, :states) .|> first))

    # Test with Operator input (density matrix)
    dm0_list = [ket2dm(ψ_0_e), ket2dm(ψ_1_g)]
    sols5 =
        mesolve_map(H, dm0_list, tlist, c_ops; e_ops = e_ops, params = (ωc_list, ωq_list), progress_bar = Val(false))

    @test size(sols5) == (2, 3, 4)
    @test sols5 isa Array{<:TimeEvolutionSol}

    @testset "Type Inference mesolve_map" begin
        @inferred mesolve_map(TESetup.H, ψ0_list, tlist, c_ops; e_ops = e_ops, progress_bar = Val(true)) # no params, but test progress bar
        @inferred mesolve_map(
            H,
            ψ0_list,
            tlist,
            c_ops;
            e_ops = e_ops,
            params = (ωc_list, ωq_list),
            progress_bar = Val(false),
        )
    end
end

@testitem "mcsolve" setup = [TESetup] begin
    using SciMLOperators
    import SciMLOperators: ScaledOperator
    using Statistics

    # Get parameters from TESetup to simplify the code
    H = TESetup.H
    ψ0 = TESetup.ψ0
    tlist = TESetup.tlist
    c_ops = TESetup.c_ops
    e_ops = TESetup.e_ops
    saveat = TESetup.saveat
    saveat_idxs = TESetup.saveat_idxs
    sol_me = TESetup.sol_me

    prob_mc = mcsolveProblem(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
    sol_mc = mcsolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
    sol_mc2 = mcsolve(
        H,
        ψ0,
        tlist,
        c_ops,
        e_ops = e_ops,
        progress_bar = Val(false),
        jump_callback = DiscreteLindbladJumpCallback(),
    )
    sol_mc3 = mcsolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), keep_runs_results = Val(true))
    sol_mc_states =
        mcsolve(H, ψ0, tlist, c_ops, saveat = saveat, progress_bar = Val(false), keep_runs_results = Val(true))
    sol_mc_states2 = mcsolve(
        H,
        ψ0,
        tlist,
        c_ops,
        saveat = saveat,
        progress_bar = Val(false),
        jump_callback = DiscreteLindbladJumpCallback(),
        keep_runs_results = Val(true),
    )

    # also test function average_states
    # average the states from all trajectories, and then calculate the expectation value
    expect_mc_states_mean = expect.(Ref(e_ops[1]), average_states(sol_mc_states))
    expect_mc_states_mean2 = expect.(Ref(e_ops[1]), average_states(sol_mc_states2))

    @test prob_mc.prob.f.f isa ScaledOperator
    @test !haskey(prob_mc.prob.kwargs, :tstops) # tstops should not exist for time-independent cases
    @test sum(abs, sol_mc.expect .- sol_me.expect) / length(tlist) < 0.1
    @test sum(abs, sol_mc2.expect .- sol_me.expect) / length(tlist) < 0.1
    @test sum(abs, average_expect(sol_mc3) .- sol_me.expect) / length(tlist) < 0.1
    @test sum(abs, expect_mc_states_mean .- vec(sol_me.expect[1, saveat_idxs])) / length(tlist) < 0.1
    @test sum(abs, expect_mc_states_mean2 .- vec(sol_me.expect[1, saveat_idxs])) / length(tlist) < 0.1
    @test length(sol_mc.times) == length(tlist)
    @test length(sol_mc.times_states) == 1
    @test size(sol_mc.expect) == (length(e_ops), length(tlist))
    @test size(sol_mc.states) == (1,)
    @test length(sol_mc3.times) == length(tlist)
    @test length(sol_mc3.times_states) == 1
    @test size(sol_mc3.expect) == (length(e_ops), 500, length(tlist)) # ntraj = 500
    @test size(sol_mc3.states) == (500, 1) # ntraj = 500
    @test length(sol_mc_states.times) == length(tlist)
    @test length(sol_mc_states.times_states) == length(saveat)
    @test size(sol_mc_states.states) == (500, length(saveat)) # ntraj = 500
    @test sol_mc_states.expect === nothing

    sol_mc_string = sprint((t, s) -> show(t, "text/plain", s), sol_mc)
    sol_mc_string_states = sprint((t, s) -> show(t, "text/plain", s), sol_mc_states)
    @test sol_mc_string ==
        "Solution of quantum trajectories\n" *
        "(converged: $(sol_mc.converged))\n" *
        "--------------------------------\n" *
        "num_trajectories = $(sol_mc.ntraj)\n" *
        "num_states = $(size(sol_mc.states, ndims(sol_mc.states)))\n" *
        "num_expect = $(size(sol_mc.expect, 1))\n" *
        "ODE alg.: $(sol_mc.alg)\n" *
        "abstol = $(sol_mc.abstol)\n" *
        "reltol = $(sol_mc.reltol)\n"
    @test sol_mc_string_states ==
        "Solution of quantum trajectories\n" *
        "(converged: $(sol_mc_states.converged))\n" *
        "--------------------------------\n" *
        "num_trajectories = $(sol_mc_states.ntraj)\n" *
        "num_states = $(size(sol_mc_states.states, ndims(sol_mc_states.states)))\n" *
        "num_expect = 0\n" *
        "ODE alg.: $(sol_mc_states.alg)\n" *
        "abstol = $(sol_mc_states.abstol)\n" *
        "reltol = $(sol_mc_states.reltol)\n"

    @test_throws ArgumentError mcsolve(H, ψ0, TESetup.tlist1, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError mcsolve(H, ψ0, TESetup.tlist2, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError mcsolve(H, ψ0, TESetup.tlist3, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError mcsolve(H, ψ0, tlist, c_ops, save_idxs = [1, 2], progress_bar = Val(false))
    @test_throws DimensionMismatch mcsolve(H, TESetup.ψ_wrong, tlist, c_ops, progress_bar = Val(false))

    # test average_states, average_expect, and std_expect
    expvals_all = sol_mc3.expect[:, :, 2:end] # ignore testing initial time point since its standard deviation is a very small value (basically zero)
    stdvals = std_expect(sol_mc3)
    @test average_states(sol_mc) == sol_mc.states
    @test average_expect(sol_mc) == sol_mc.expect
    @test size(stdvals) == (length(e_ops), length(tlist))
    @test all(
        isapprox.(
            stdvals[:, 2:end], # ignore testing initial time point since its standard deviation is a very small value (basically zero)
            dropdims(sqrt.(mean(abs2.(expvals_all), dims = 2) .- abs2.(mean(expvals_all, dims = 2))), dims = 2);
            atol = 1.0e-6,
        ),
    )
    @test average_expect(sol_mc_states) === nothing
    @test std_expect(sol_mc_states) === nothing
    @test_throws ArgumentError std_expect(sol_mc)

    @testset "Memory Allocations (mcsolve)" begin
        ntraj = 100
        for keep_runs_results in (Val(false), Val(true))
            n1 = QuantumToolbox.getVal(keep_runs_results) ? 120 : 140
            n2 = QuantumToolbox.getVal(keep_runs_results) ? 110 : 130

            allocs_tot = @allocations mcsolve(
                H,
                ψ0,
                tlist,
                c_ops,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = Val(true),
            ) # Warm-up
            allocs_tot = @allocations mcsolve(
                H,
                ψ0,
                tlist,
                c_ops,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = Val(true),
            )
            @test allocs_tot < n1 * ntraj + 600 # 150 allocations per trajectory + 600 for initialization

            allocs_tot = @allocations mcsolve(
                H,
                ψ0,
                tlist,
                c_ops,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = Val(true),
            ) # Warm-up
            allocs_tot = @allocations mcsolve(
                H,
                ψ0,
                tlist,
                c_ops,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = Val(true),
            )
            @test allocs_tot < n2 * ntraj + 300 # 100 allocations per trajectory + 300 for initialization
        end
    end

    @testset "Type Inference (mcsolve)" begin
        a = TESetup.a
        rng = TESetup.rng

        @inferred mcsolveEnsembleProblem(
            H,
            ψ0,
            tlist,
            c_ops,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred mcsolve(H, ψ0, tlist, c_ops, ntraj = 5, e_ops = e_ops, progress_bar = Val(false), rng = rng)
        @inferred mcsolve(H, ψ0, tlist, c_ops, ntraj = 5, progress_bar = Val(true), rng = rng) # test progress bar
        @inferred mcsolve(H, ψ0, [0, 10], c_ops, ntraj = 5, progress_bar = Val(false), rng = rng)
        @inferred mcsolve(H, TESetup.ψ0_int, tlist, c_ops, ntraj = 5, progress_bar = Val(false), rng = rng)
        @inferred mcsolve(H, ψ0, tlist, (a, a'), e_ops = (a' * a, a'), ntraj = 5, progress_bar = Val(false), rng = rng) # We test the type inference for Tuple of different types
        @inferred mcsolve(
            TESetup.H_td,
            ψ0,
            tlist,
            c_ops,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            params = TESetup.p,
            rng = rng,
        )
    end
end

@testitem "ssesolve" setup = [TESetup] begin
    # Get parameters from TESetup to simplify the code
    H = TESetup.H
    ψ0 = TESetup.ψ0
    tlist = TESetup.tlist
    c_ops = TESetup.c_ops
    e_ops = TESetup.e_ops
    sol_me = TESetup.sol_me

    sol_sse = ssesolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
    sol_sse2 = ssesolve(
        H,
        ψ0,
        tlist,
        c_ops,
        e_ops = e_ops,
        ntraj = 20,
        progress_bar = Val(false),
        store_measurement = Val(true),
    )

    @test sum(abs, sol_sse.expect .- sol_me.expect) / length(tlist) < 0.1
    @test length(sol_sse.times) == length(tlist)
    @test length(sol_sse.times_states) == 1
    @test size(sol_sse.states) == (1,) # ntraj = 500 but keep_runs_results = Val(false)
    @test size(sol_sse.expect) == (length(e_ops), length(tlist))
    @test isnothing(sol_sse.measurement)
    @test size(sol_sse2.measurement) == (length(c_ops), 20, length(tlist) - 1)

    sol_sse_string = sprint((t, s) -> show(t, "text/plain", s), sol_sse)
    @test sol_sse_string ==
        "Solution of stochastic quantum trajectories\n" *
        "(converged: $(sol_sse.converged))\n" *
        "--------------------------------\n" *
        "num_trajectories = $(sol_sse.ntraj)\n" *
        "num_states = $(size(sol_sse.states, ndims(sol_sse.states)))\n" *
        "num_expect = $(size(sol_sse.expect, 1))\n" *
        "SDE alg.: $(sol_sse.alg)\n" *
        "abstol = $(sol_sse.abstol)\n" *
        "reltol = $(sol_sse.reltol)\n"

    @test_throws ArgumentError ssesolve(H, ψ0, TESetup.tlist1, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError ssesolve(H, ψ0, TESetup.tlist2, c_ops, progress_bar = Val(false))
    @test_throws ArgumentError ssesolve(H, ψ0, TESetup.tlist3, c_ops, progress_bar = Val(false))

    @testset "Memory Allocations (ssesolve)" begin
        ntraj = 100
        for keep_runs_results in (Val(false), Val(true))
            n1 = QuantumToolbox.getVal(keep_runs_results) ? 1100 : 1120
            n2 = QuantumToolbox.getVal(keep_runs_results) ? 1000 : 1020

            allocs_tot = @allocations ssesolve(
                H,
                ψ0,
                tlist,
                c_ops,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            ) # Warm-up
            allocs_tot = @allocations ssesolve(
                H,
                ψ0,
                tlist,
                c_ops,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            )
            @test allocs_tot < n1 * ntraj + 400 # TODO: Fix this high number of allocations

            allocs_tot = @allocations ssesolve(
                H,
                ψ0,
                tlist,
                c_ops,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            ) # Warm-up
            allocs_tot = @allocations ssesolve(
                H,
                ψ0,
                tlist,
                c_ops,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            )
            @test allocs_tot < n2 * ntraj + 300 # TODO: Fix this high number of allocations
        end
    end

    @testset "Type Inference (ssesolve)" begin
        a = TESetup.a
        rng = TESetup.rng
        p = TESetup.p

        c_ops_tuple = Tuple(c_ops) # To avoid type instability, we must have a Tuple instead of a Vector
        @inferred ssesolveEnsembleProblem(
            H,
            ψ0,
            tlist,
            c_ops_tuple,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred ssesolve(H, ψ0, tlist, c_ops_tuple, ntraj = 5, e_ops = e_ops, progress_bar = Val(false), rng = rng)
        @inferred ssesolve(H, ψ0, tlist, c_ops_tuple, ntraj = 5, progress_bar = Val(true), rng = rng) # test progress bar
        @inferred ssesolve(H, ψ0, [0, 10], c_ops_tuple, ntraj = 5, progress_bar = Val(false), rng = rng)
        @inferred ssesolve(H, TESetup.ψ0_int, tlist, c_ops_tuple, ntraj = 5, progress_bar = Val(false), rng = rng)
        @inferred ssesolve(
            H,
            ψ0,
            tlist,
            c_ops_tuple,
            ntraj = 5,
            e_ops = (a' * a, a'),
            progress_bar = Val(false),
            rng = rng,
        ) # We test the type inference for Tuple of different types
        @inferred ssesolve(
            TESetup.H_td,
            ψ0,
            tlist,
            c_ops_tuple,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            params = p,
            rng = rng,
        )
    end
end

@testitem "smesolve" setup = [TESetup] begin
    using Random

    # Get parameters from TESetup to simplify the code
    H = TESetup.H
    ψ0 = TESetup.ψ0
    tlist = TESetup.tlist
    c_ops_sme = TESetup.c_ops_sme
    sc_ops_sme = TESetup.sc_ops_sme
    c_ops_sme2 = TESetup.c_ops_sme2
    sc_ops_sme2 = TESetup.sc_ops_sme2
    e_ops = TESetup.e_ops
    sol_me = TESetup.sol_me
    saveat = TESetup.saveat

    sol_sme = smesolve(H, ψ0, tlist, c_ops_sme, sc_ops_sme, e_ops = e_ops, progress_bar = Val(false))
    sol_sme2 = smesolve(
        H,
        ψ0,
        tlist,
        c_ops_sme,
        sc_ops_sme,
        e_ops = e_ops,
        ntraj = 20,
        progress_bar = Val(false),
        store_measurement = Val(true),
    )
    sol_sme3 = smesolve(H, ψ0, tlist, c_ops_sme2, sc_ops_sme2, e_ops = e_ops, progress_bar = Val(false))

    # For testing the `OperatorKet` input
    sol_sme4 = smesolve(
        H,
        ψ0,
        tlist,
        c_ops_sme,
        sc_ops_sme,
        saveat = saveat,
        ntraj = 10,
        progress_bar = Val(false),
        rng = MersenneTwister(12),
    )
    sol_sme5 = smesolve(
        H,
        operator_to_vector(ket2dm(ψ0)),
        tlist,
        c_ops_sme,
        sc_ops_sme,
        saveat = saveat,
        ntraj = 10,
        progress_bar = Val(false),
        rng = MersenneTwister(12),
    )

    @test sum(abs, sol_sme.expect .- sol_me.expect) / length(tlist) < 0.1
    @test sum(abs, sol_sme3.expect .- sol_me.expect) / length(tlist) < 0.1
    @test length(sol_sme.times) == length(tlist)
    @test length(sol_sme.times_states) == 1
    @test size(sol_sme.states) == (1,) # ntraj = 500 but keep_runs_results = Val(false)
    @test size(sol_sme.expect) == (length(e_ops), length(tlist))
    @test isnothing(sol_sme.measurement)
    @test size(sol_sme2.measurement) == (length(sc_ops_sme), 20, length(tlist) - 1)
    @test all([sol_sme4.states[i] ≈ vector_to_operator(sol_sme5.states[i]) for i in eachindex(saveat)])

    sol_sme_string = sprint((t, s) -> show(t, "text/plain", s), sol_sme)
    @test sol_sme_string ==
        "Solution of stochastic quantum trajectories\n" *
        "(converged: $(sol_sme.converged))\n" *
        "--------------------------------\n" *
        "num_trajectories = $(sol_sme.ntraj)\n" *
        "num_states = $(size(sol_sme.states, ndims(sol_sme.states)))\n" *
        "num_expect = $(size(sol_sme.expect, 1))\n" *
        "SDE alg.: $(sol_sme.alg)\n" *
        "abstol = $(sol_sme.abstol)\n" *
        "reltol = $(sol_sme.reltol)\n"

    @test_throws ArgumentError smesolve(H, ψ0, TESetup.tlist1, c_ops_sme, sc_ops_sme, progress_bar = Val(false))
    @test_throws ArgumentError smesolve(H, ψ0, TESetup.tlist2, c_ops_sme, sc_ops_sme, progress_bar = Val(false))
    @test_throws ArgumentError smesolve(H, ψ0, TESetup.tlist3, c_ops_sme, sc_ops_sme, progress_bar = Val(false))

    @testset "Memory Allocations (smesolve)" begin
        ntraj = 100
        for keep_runs_results in (Val(false), Val(true))
            n1 = QuantumToolbox.getVal(keep_runs_results) ? 1100 : 1120
            n2 = QuantumToolbox.getVal(keep_runs_results) ? 1000 : 1020
            n3 = QuantumToolbox.getVal(keep_runs_results) ? 600 : 620
            n4 = QuantumToolbox.getVal(keep_runs_results) ? 550 : 570

            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme,
                sc_ops_sme,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            ) # Warm-up
            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme,
                sc_ops_sme,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            )
            @test allocs_tot < n1 * ntraj + 2300 # TODO: Fix this high number of allocations

            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme,
                sc_ops_sme,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            ) # Warm-up
            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme,
                sc_ops_sme,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            )
            @test allocs_tot < n2 * ntraj + 1500 # TODO: Fix this high number of allocations

            # Diagonal Noise Case
            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme2,
                sc_ops_sme2,
                e_ops = e_ops,
                ntraj = ntraj,
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            ) # Warm-up
            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme2,
                sc_ops_sme2,
                e_ops = e_ops,
                ntraj = 1,
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            )
            @test allocs_tot < n3 * ntraj + 1400 # TODO: Fix this high number of allocations

            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme2,
                sc_ops_sme2,
                ntraj = ntraj,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            ) # Warm-up
            allocs_tot = @allocations smesolve(
                H,
                ψ0,
                tlist,
                c_ops_sme2,
                sc_ops_sme2,
                ntraj = 1,
                saveat = [tlist[end]],
                progress_bar = Val(false),
                keep_runs_results = keep_runs_results,
            )
            @test allocs_tot < n4 * ntraj + 1000 # TODO: Fix this high number of allocations
        end
    end

    @testset "Type Inference (smesolve)" begin
        a = TESetup.a
        rng = TESetup.rng

        # To avoid type instability, we must have a Tuple instead of a Vector
        c_ops_sme_tuple = Tuple(c_ops_sme)
        sc_ops_sme_tuple = Tuple(sc_ops_sme)
        c_ops_sme2_tuple = Tuple(c_ops_sme2)
        sc_ops_sme2_tuple = sc_ops_sme2 # This is an `AbstractQuantumObject`
        @inferred smesolveEnsembleProblem(
            H,
            ψ0,
            tlist,
            c_ops_sme_tuple,
            sc_ops_sme_tuple,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred smesolve(
            H,
            ψ0,
            tlist,
            c_ops_sme_tuple,
            sc_ops_sme_tuple,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred smesolve(
            H,
            ψ0,
            tlist,
            c_ops_sme2_tuple,
            sc_ops_sme2_tuple,
            ntraj = 5,
            e_ops = e_ops,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred smesolve(
            H,
            ψ0,
            tlist,
            c_ops_sme_tuple,
            sc_ops_sme_tuple,
            ntraj = 5,
            progress_bar = Val(true),
            rng = rng,
        ) # test progress bar
        @inferred smesolve(
            H,
            ψ0,
            [0, 10],
            c_ops_sme_tuple,
            sc_ops_sme_tuple,
            ntraj = 5,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred smesolve(
            H,
            TESetup.ψ0_int,
            tlist,
            c_ops_sme_tuple,
            sc_ops_sme_tuple,
            ntraj = 5,
            progress_bar = Val(false),
            rng = rng,
        )
        @inferred smesolve(
            H,
            ψ0,
            tlist,
            c_ops_sme_tuple,
            sc_ops_sme_tuple,
            ntraj = 5,
            e_ops = (a' * a, a'),
            progress_bar = Val(false),
            rng = rng,
        ) # We test the type inference for Tuple of different types
    end
end

@testitem "Time-dependent Hamiltonian" setup = [TESetup] begin
    # Get parameters from TESetup to simplify the code
    ωd = TESetup.ωd
    F = TESetup.F
    a = TESetup.a
    σz = TESetup.σz
    H = TESetup.H
    H_td = TESetup.H_td
    H_td2 = TESetup.H_td2
    L_td = TESetup.L_td
    ψ0 = TESetup.ψ0
    c_ops = TESetup.c_ops
    e_ops = TESetup.e_ops
    p = TESetup.p
    rng = TESetup.rng

    # ssesolve is slow to be run on CI. It is not removed from the test because it may be useful for testing in more powerful machines.

    # Time Evolution in the drive frame

    H_dr_fr = H - ωd * a' * a - ωd * σz / 2 + F * (a + a')

    tlist = range(0, 10 / TESetup.γ, 1000)

    sol_se = sesolve(H_dr_fr, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false))
    sol_me = mesolve(H_dr_fr, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false))
    sol_mc = mcsolve(H_dr_fr, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), rng = rng)
    # sol_sse = ssesolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), rng = rng)

    # Time Evolution in the lab frame

    sol_se_td = sesolve(H_td, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false), params = p)
    sol_me_td = mesolve(H_td, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p)
    sol_mc_td = mcsolve(H_td, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p, rng = rng)
    # sol_sse_td = ssesolve(H_td, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p, rng = rng)

    @test sol_se.expect ≈ sol_se_td.expect atol = 1.0e-6 * length(tlist)
    @test sol_me.expect ≈ sol_me_td.expect atol = 1.0e-6 * length(tlist)
    @test sol_mc.expect ≈ sol_mc_td.expect atol = 1.0e-2 * length(tlist)
    # @test sol_sse.expect ≈ sol_sse_td.expect atol = 1e-2 * length(tlist)

    sol_se_td2 = sesolve(H_td2, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false), params = p)
    sol_me_td2 = mesolve(L_td, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p)
    sol_mc_td2 = mcsolve(H_td2, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p, rng = rng)
    # sol_sse_td2 =
    # ssesolve(H_td2, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), params = p, rng = rng)

    @test sol_se.expect ≈ sol_se_td2.expect atol = 1.0e-6 * length(tlist)
    @test sol_me.expect ≈ sol_me_td2.expect atol = 1.0e-6 * length(tlist)
    @test sol_mc.expect ≈ sol_mc_td2.expect atol = 1.0e-2 * length(tlist)
    # @test sol_sse.expect ≈ sol_sse_td2.expect atol = 1e-2 * length(tlist)

    # test assume_hermitian = Val(false)
    L_td_non_herm = liouvillian(H_td2, c_ops, assume_hermitian = Val(false))
    sol_me_td3 = mesolve(L_td_non_herm, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false), params = p)
    @test sol_me.expect ≈ sol_me_td3.expect atol = 1.0e-6 * length(tlist)
end

@testitem "mcsolve, ssesolve and smesolve reproducibility" setup = [TESetup] begin
    using Random

    # Get parameters from TESetup to simplify the code
    H = TESetup.H
    ψ0 = TESetup.ψ0
    tlist = TESetup.tlist
    c_ops = TESetup.c_ops
    c_ops_sme = TESetup.c_ops_sme
    sc_ops_sme = TESetup.sc_ops_sme
    e_ops = TESetup.e_ops
    rng = TESetup.rng

    rng = MersenneTwister(1234)
    sol_mc1 =
        mcsolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), rng = rng, keep_runs_results = Val(true))
    rng = MersenneTwister(1234)
    sol_sse1 = ssesolve(
        H,
        ψ0,
        tlist,
        c_ops,
        ntraj = 50,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )
    rng = MersenneTwister(1234)
    sol_sme1 = smesolve(
        H,
        ψ0,
        tlist,
        c_ops_sme,
        sc_ops_sme,
        ntraj = 50,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )

    rng = MersenneTwister(1234)
    sol_mc2 =
        mcsolve(H, ψ0, tlist, c_ops, e_ops = e_ops, progress_bar = Val(false), rng = rng, keep_runs_results = Val(true))
    rng = MersenneTwister(1234)
    sol_sse2 = ssesolve(
        H,
        ψ0,
        tlist,
        c_ops,
        ntraj = 50,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )
    rng = MersenneTwister(1234)
    sol_sme2 = smesolve(
        H,
        ψ0,
        tlist,
        c_ops_sme,
        sc_ops_sme,
        ntraj = 50,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )

    rng = MersenneTwister(1234)
    sol_mc3 = mcsolve(
        H,
        ψ0,
        tlist,
        c_ops,
        ntraj = 510,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )
    rng = MersenneTwister(1234)
    sol_sse3 = ssesolve(
        H,
        ψ0,
        tlist,
        c_ops,
        ntraj = 60,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )
    rng = MersenneTwister(1234)
    sol_sme3 = smesolve(
        H,
        ψ0,
        tlist,
        c_ops_sme,
        sc_ops_sme,
        ntraj = 60,
        e_ops = e_ops,
        progress_bar = Val(false),
        rng = rng,
        keep_runs_results = Val(true),
    )

    @test sol_mc1.expect ≈ sol_mc2.expect atol = 1.0e-10
    @test sol_mc1.col_times ≈ sol_mc2.col_times atol = 1.0e-10
    @test sol_mc1.col_which ≈ sol_mc2.col_which atol = 1.0e-10

    @test sol_mc1.expect ≈ sol_mc3.expect[:, 1:500, :] atol = 1.0e-10

    @test sol_sse1.expect ≈ sol_sse2.expect atol = 1.0e-10

    @test sol_sse1.expect ≈ sol_sse3.expect[:, 1:50, :] atol = 1.0e-10

    @test sol_sme1.expect ≈ sol_sme2.expect atol = 1.0e-10

    @test sol_sme1.expect ≈ sol_sme3.expect[:, 1:50, :] atol = 1.0e-10
end

@testitem "Example: Two qubit model" begin
    sp1 = kron(sigmap(), qeye(2))
    sm1 = sp1'
    sx1 = sm1 + sp1
    sy1 = 1im * (sm1 - sp1)
    sz1 = sp1 * sm1 - sm1 * sp1
    sp2 = kron(qeye(2), sigmap())
    sm2 = sp2'
    sx2 = sm2 + sp2
    sy2 = 1im * (sm2 - sp2)
    sz2 = sp2 * sm2 - sm2 * sp2
    ωq1, ωq2 = 1, 1
    γ1, γ2 = 0.05, 0.1
    H = 0.5 * ωq1 * sz1 + 0.5 * ωq2 * sz2
    c_ops = [sqrt(γ1) * sm1, sqrt(γ2) * sm2]
    psi0_1 = normalize(fock(2, 0) + fock(2, 1))
    psi0_2 = normalize(fock(2, 0) + fock(2, 1))
    psi0 = kron(psi0_1, psi0_2)
    t_l = LinRange(0, 20 / γ1, 1000)
    sol_me = mesolve(H, psi0, t_l, c_ops, e_ops = [sp1 * sm1, sp2 * sm2], progress_bar = false) # Here we don't put Val(false) because we want to test the support for Bool type
    sol_mc = mcsolve(H, psi0, t_l, c_ops, e_ops = [sp1 * sm1, sp2 * sm2], progress_bar = Val(false))
    @test sum(abs.(sol_mc.expect[1:2, :] .- sol_me.expect[1:2, :])) / length(t_l) < 0.1
    @test expect(sp1 * sm1, sol_me.states[end]) ≈ expect(sigmap() * sigmam(), ptrace(sol_me.states[end], 1))
end

@testitem "Example: Qubit driven by two sequential cosine pulses" begin
    # settings of pulses
    A1 = rand() # Rabi amplitude of pulse 1
    A2 = rand() # Rabi amplitude of pulse 2
    t1 = 0 # starting time of pulse 1
    t2 = 100 # starting time of pulse 2
    T = 10 # duration of each pulse
    pulse1(p, t) = ((t1 <= t) && (t <= t1 + T)) ? (0.5 * p.A1 * π / T) * (1 - cos(2π * (t - t1) / T)) : 0
    pulse2(p, t) = ((t2 <= t) && (t <= t2 + T)) ? (0.5 * p.A2 * π / T) * (1 - cos(2π * (t - t2) / T)) : 0

    # time‐dependent Hamiltonian
    σy = sigmay()
    H = QobjEvo(σy, pulse1) + QobjEvo(σy, pulse2)

    # initial state
    ψ0 = basis(2, 0)
    ρ0 = ket2dm(ψ0) # to force using mesolve

    # sesolve & mesolve
    tlist = range(0.0, stop = 140.0, length = 10000) # don't change tlist, to check the second pulse contribute correctly under 'tstops=tlist' setting
    e_ops = [sigmax(), sigmaz()]
    params = (A1 = A1, A2 = A2)
    prob_se = sesolveProblem(H, ψ0, tlist; e_ops = e_ops, params = params, progress_bar = Val(false))
    prob_me = mesolveProblem(H, ρ0, tlist; e_ops = e_ops, params = params, progress_bar = Val(false))
    sol_se = sesolve(prob_se)
    sol_me = mesolve(prob_me)

    # analytic solution
    function θ(t, t_start, A)
        # a dummy comment to avoid julia formatter
        if t < t_start
            return 0
        elseif (t_start <= t) && (t <= t_start + T)
            return (A * π / T) * (t - t_start - (T * sin(2π * (t - t_start) / T) / (2π)))
        else
            return A * π
        end
    end
    θlist = θ.(tlist, t1, A1) + θ.(tlist, t2, A2)
    X_analytic = sin.(θlist)
    Z_analytic = cos.(θlist)

    @test prob_se.prob.kwargs[:tstops] == tlist # tstops should be equal to tlist for time-dependent cases
    @test prob_me.prob.kwargs[:tstops] == tlist # tstops should be equal to tlist for time-dependent cases
    @test all(isapprox.(X_analytic, sol_se.expect[1, :]; atol = 1.0e-6))
    @test all(isapprox.(X_analytic, sol_me.expect[1, :]; atol = 1.0e-6))
    @test all(isapprox.(Z_analytic, sol_se.expect[2, :]; atol = 1.0e-6))
    @test all(isapprox.(Z_analytic, sol_me.expect[2, :]; atol = 1.0e-6))
end

@testitem "ComposedOperator support in time evolution" begin
    N = 10  # number of basis states
    a = destroy(N)
    H = a' * a

    ψ0 = basis(N, 9)  # initial state

    γ0 = 0.5
    γ1(p, t) = sqrt(p[1] * exp(-t))
    c_ops_1 = [QobjEvo(2a, γ1)] # This generates a ScaledOperator internally
    c_ops_2 = [QobjEvo(a, γ1) + QobjEvo(a, γ1)] # This generates a ComposedOperator internally

    e_ops = [a' * a]

    tlist = range(0, 10, 100)
    params = [γ0]
    sol_1 = mesolve(H, ψ0, tlist, c_ops_1, e_ops = e_ops; progress_bar = Val(false), params = params, saveat = tlist)
    sol_2 = mesolve(H, ψ0, tlist, c_ops_2, e_ops = e_ops; progress_bar = Val(false), params = params, saveat = tlist)

    @test sol_1.expect[1, :] ≈ sol_2.expect[1, :] atol = 1.0e-10
    @test all(x -> isapprox(x[1].data, x[2].data; atol = 1.0e-10), zip(sol_1.states, sol_2.states))
end

#=
Functions for generating (common) quantum super-operators.
=#

export spre, spost, sprepost, liouvillian, lindblad_dissipator

# intrinsic functions for super-operators
## keep these because they take AbstractMatrix as input and ensure the output is sparse matrix
_spre(A::AbstractMatrix{T}) where {T} = kron(Eye{T}(size(A, 1)), A)
_spost(B::AbstractMatrix{T}) where {T} = kron(transpose(B), Eye{T}(size(B, 1)))
_spost(B::Adjoint{T, <:AbstractMatrix}) where {T} = kron(conj(parent(B)), Eye{T}(size(parent(B), 1))) # avoiding nested Transpose{Adjoint} wrapper
_sprepost(A::AbstractMatrix, B::AbstractMatrix) = kron(transpose(B), A)
_sprepost(A::AbstractMatrix, B::Adjoint) = kron(conj(parent(B)), A) # avoiding nested Transpose{Adjoint} wrapper
_sprepost(A, B) = _spre(A) * _spost(B) # for any other input types

## if input is AbstractSciMLOperator
## some of them are optimized to speed things up
## the rest of the SciMLOperators will just use lazy tensor (and prompt a warning)
_spre(A::MatrixOperator) = MatrixOperator(_spre(A.A))
_spre(A::ScaledOperator) = ScaledOperator(A.λ, _spre(A.L))
_spre(A::AddedOperator) = AddedOperator(map(op -> _spre(op), A.ops))
_spre(A::ComposedOperator) = ComposedOperator(map(_spre, A.ops), nothing)
function _spre(A::AbstractSciMLOperator{T}) where {T}
    Id = Eye{T}(size(A, 1))
    _lazy_tensor_warning(Id, A)
    return kron(Id, A)
end

_spost(B::MatrixOperator) = MatrixOperator(_spost(B.A))
_spost(B::ScaledOperator) = ScaledOperator(B.λ, _spost(B.L))
_spost(B::AddedOperator) = AddedOperator(map(op -> _spost(op), B.ops))
_spost(B::ComposedOperator) = ComposedOperator(map(_spost, reverse(B.ops)), nothing)
function _spost(B::AbstractSciMLOperator{T}) where {T}
    B_T = transpose(B)
    Id = Eye{T}(size(B, 1))
    _lazy_tensor_warning(B_T, Id)
    return kron(B_T, Id)
end

## intrinsic liouvillian
function _liouvillian(
        H::MT,
        ::Val{assume_hermitian},
    ) where {MT <: Union{AbstractMatrix, AbstractSciMLOperator}, assume_hermitian}
    H_spre = _spre(H)
    H_spost = assume_hermitian ? _spost(H) : _spost(H')
    return -1im * (H_spre - H_spost)
end
function _liouvillian(H::MatrixOperator, assume_hermitian::Val)
    isconstant(H) ||
        throw(ArgumentError("The given Hamiltonian for constructing Liouvillian must be constant MatrixOperator."))
    return MatrixOperator(_liouvillian(H.A, assume_hermitian))
end
_liouvillian(H::ScaledOperator, assume_hermitian::Val{true}) = ScaledOperator(H.λ, _liouvillian(H.L, assume_hermitian))
_liouvillian(H::AddedOperator, assume_hermitian::Val) =
    AddedOperator(map(op -> _liouvillian(op, assume_hermitian), H.ops))

# intrinsic lindblad_dissipator
function _lindblad_dissipator(O::MT) where {MT <: Union{AbstractMatrix, AbstractSciMLOperator}}
    Od_O = O' * O
    return _sprepost(O, O') - (_spre(Od_O) + _spost(Od_O)) / 2
end
function _lindblad_dissipator(O::MatrixOperator)
    _O = O.A
    Od_O = _O' * _O
    return MatrixOperator(_sprepost(_O, _O') - (_spre(Od_O) + _spost(Od_O)) / 2)
end
function _lindblad_dissipator(O::ScaledOperator)
    λc_λ = conj(O.λ) * O.λ
    return ScaledOperator(λc_λ, _lindblad_dissipator(O.L))
end

@doc raw"""
    spre(A::AbstractQuantumObject)

Returns the [`SuperOperator`](@ref) form of `A` acting on the left of the density matrix operator: ``\mathcal{O} \left(\hat{A}\right) \left[ \hat{\rho} \right] = \hat{A} \hat{\rho}``.

Since the density matrix is vectorized in [`OperatorKet`](@ref) form: ``|\hat{\rho}\rangle\!\rangle``, this [`SuperOperator`](@ref) is always a matrix ``\hat{\mathbb{1}} \otimes \hat{A}``, namely 

```math
\mathcal{O} \left(\hat{A}\right) \left[ \hat{\rho} \right] = \hat{\mathbb{1}} \otimes \hat{A} ~ |\hat{\rho}\rangle\!\rangle
```
(see the section in documentation: [Superoperators and Vectorized Operators](@ref doc:Superoperators-and-Vectorized-Operators) for more details)

See also [`spost`](@ref) and [`sprepost`](@ref).
"""
function spre(A::AbstractQuantumObject{Operator})
    Lspace = LiouvilleSpace(A.dimensions)
    return get_typename_wrapper(A)(_spre(A.data), SuperOperator(), Dimensions(Lspace, Lspace))
end

@doc raw"""
    spost(B::AbstractQuantumObject)

Returns the [`SuperOperator`](@ref) form of `B` acting on the right of the density matrix operator: ``\mathcal{O} \left(\hat{B}\right) \left[ \hat{\rho} \right] = \hat{\rho} \hat{B}``.

Since the density matrix is vectorized in [`OperatorKet`](@ref) form: ``|\hat{\rho}\rangle\!\rangle``, this [`SuperOperator`](@ref) is always a matrix ``\hat{B}^T \otimes \hat{\mathbb{1}}``, namely

```math
\mathcal{O} \left(\hat{B}\right) \left[ \hat{\rho} \right] = \hat{B}^T \otimes \hat{\mathbb{1}} ~ |\hat{\rho}\rangle\!\rangle
```
(see the section in documentation: [Superoperators and Vectorized Operators](@ref doc:Superoperators-and-Vectorized-Operators) for more details)

See also [`spre`](@ref) and [`sprepost`](@ref).
"""
function spost(B::AbstractQuantumObject{Operator})
    Lspace = LiouvilleSpace(B.dimensions)
    return get_typename_wrapper(B)(_spost(B.data), SuperOperator(), Dimensions(Lspace, Lspace))
end

@doc raw"""
    sprepost(A::AbstractQuantumObject, B::AbstractQuantumObject)

Returns the [`SuperOperator`](@ref) form of `A` and `B` acting on the left and right of the density matrix operator, respectively: ``\mathcal{O} \left( \hat{A}, \hat{B} \right) \left[ \hat{\rho} \right] = \hat{A} \hat{\rho} \hat{B}``.

Since the density matrix is vectorized in [`OperatorKet`](@ref) form: ``|\hat{\rho}\rangle\!\rangle``, this [`SuperOperator`](@ref) is always a matrix ``\hat{B}^T \otimes \hat{A}``, namely

```math
\mathcal{O} \left(\hat{A}, \hat{B}\right) \left[ \hat{\rho} \right] = \hat{B}^T \otimes \hat{A} ~ |\hat{\rho}\rangle\!\rangle = \textrm{spre}(\hat{A}) * \textrm{spost}(\hat{B}) ~ |\hat{\rho}\rangle\!\rangle
```
(see the section in documentation: [Superoperators and Vectorized Operators](@ref doc:Superoperators-and-Vectorized-Operators) for more details)

See also [`spre`](@ref) and [`spost`](@ref).
"""
function sprepost(A::AbstractQuantumObject{Operator}, B::AbstractQuantumObject{Operator})
    check_dimensions(A, B)
    Lspace = LiouvilleSpace(A.dimensions)
    return promote_op_type(A, B)(_sprepost(A.data, B.data), SuperOperator(), Dimensions(Lspace, Lspace))
end

@doc raw"""
    lindblad_dissipator(O::AbstractQuantumObject)

Returns the Lindblad [`SuperOperator`](@ref) defined as

```math
\mathcal{D} \left( \hat{O} \right) \left[ \hat{\rho} \right] = \frac{1}{2} \left( 2 \hat{O} \hat{\rho} \hat{O}^\dagger - 
\hat{O}^\dagger \hat{O} \hat{\rho} - \hat{\rho} \hat{O}^\dagger \hat{O} \right)
```

See also [`spre`](@ref), [`spost`](@ref), and [`sprepost`](@ref).
"""
function lindblad_dissipator(O::AbstractQuantumObject{Operator})
    Lspace = LiouvilleSpace(O.dimensions)
    return get_typename_wrapper(O)(_lindblad_dissipator(O.data), SuperOperator(), Dimensions(Lspace, Lspace))
end

# It is already a SuperOperator
lindblad_dissipator(O::AbstractQuantumObject{SuperOperator}) = O

@doc raw"""
    liouvillian(
        H::AbstractQuantumObject,
        c_ops::Union{Nothing,AbstractVector,Tuple}=nothing;
        assume_hermitian::Union{Bool,Val} = Val(true),
    )

Construct the Liouvillian [`SuperOperator`](@ref) for a system Hamiltonian ``\hat{H}`` and a set of collapse operators ``\{\hat{C}_n\}_n``.

By default, when the Hamiltonian `H` is assumed to be Hermitian [`assume_hermitian = Val(true)` or `true`], the Liouvillian [`SuperOperator`](@ref) is defined as :

```math
\mathcal{L} [\cdot] = -i\left(\hat{H}[\cdot] - [\cdot]\hat{H}\right) + \sum_n \mathcal{D}(\hat{C}_n) [\cdot],
```

otherwise [`assume_hermitian = Val(false)` or `false`],

```math
\mathcal{L} [\cdot] = -i\left(\hat{H}[\cdot] - [\cdot]\hat{H}^\dagger\right) + \sum_n \mathcal{D}(\hat{C}_n) [\cdot],
```

where 

```math
\mathcal{D}(\hat{C}_n) [\cdot] = \hat{C}_n [\cdot] \hat{C}_n^\dagger - \frac{1}{2} \hat{C}_n^\dagger \hat{C}_n [\cdot] - \frac{1}{2} [\cdot] \hat{C}_n^\dagger \hat{C}_n
```

See also [`spre`](@ref), [`spost`](@ref), and [`lindblad_dissipator`](@ref).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `assume_hermitian = Val(true)` instead of `assume_hermitian = true`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function liouvillian(
        H::AbstractQuantumObject{OpType},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        assume_hermitian::Union{Bool, Val} = Val(true),
    ) where {OpType <: Union{Operator, SuperOperator}}
    L = liouvillian(H; assume_hermitian = assume_hermitian)
    if !isnothing(c_ops)
        return L + _sum_lindblad_dissipators(c_ops)
    end
    return L
end

liouvillian(H::Nothing, c_ops::Union{AbstractVector, Tuple}; kwargs...) = _sum_lindblad_dissipators(c_ops)

liouvillian(H::Nothing, c_ops::Nothing; kwargs...) = 0

function liouvillian(H::AbstractQuantumObject{Operator}; assume_hermitian::Union{Bool, Val} = Val(true))
    Lspace = LiouvilleSpace(H.dimensions)
    return get_typename_wrapper(H)(_liouvillian(H.data, makeVal(assume_hermitian)), SuperOperator(), Dimensions(Lspace, Lspace))
end

liouvillian(H::AbstractQuantumObject{SuperOperator}; kwargs...) = H
_sum_lindblad_dissipators(c_ops::Nothing) = 0

_sum_lindblad_dissipators(c_ops::AbstractVector) = sum(op -> lindblad_dissipator(op), c_ops; init = 0)

# Help the compiler to unroll the sum at compile time
@generated function _sum_lindblad_dissipators(c_ops::Tuple)
    N = length(c_ops.parameters)
    if N == 0
        return :(0)
    end
    ex = :(lindblad_dissipator(c_ops[1]))
    for i in 2:N
        ex = :($ex + lindblad_dissipator(c_ops[$i]))
    end
    return ex
end

#=
Functions for generating (common) quantum states.
=#

export zero_ket, fock, coherent, rand_ket
export fock_dm, coherent_dm, thermal_dm, maximally_mixed_dm, rand_dm
export spin_state, spin_coherent
export bell_state, singlet_state, triplet_states, w_state, ghz_state

@doc raw"""
    zero_ket([T::Type=ComplexF64,] dimensions)

Returns a zero [`Ket`](@ref) vector with given argument `dimensions` and element type `T = ComplexF64` (default).

The `dimensions` can be either the following types:
- `dimensions::Int`: Number of basis states in the Hilbert space.
- `dimensions::Union{Dimensions,AbstractVector{Int}, Tuple}`: list of dimensions representing the each number of basis in the subsystems.

!!! warning "Beware of type-stability!"
    It is highly recommended to use `zero_ket(dimensions)` with `dimensions` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
zero_ket(::Type{T}, dimensions::Int) where {T <: Number} = QuantumObject(zeros(T, dimensions), Ket(), dimensions)
zero_ket(::Type{T}, dimensions::Union{Dimensions, AbstractVecOrTuple{Int}}) where {T <: Number} =
    QuantumObject(zeros(T, get_size(dimensions)[1]), Ket(), dimensions)
zero_ket(dimensions::Union{Int, Dimensions, AbstractVecOrTuple{Int}}) = zero_ket(ComplexF64, dimensions)

@doc raw"""
    fock([T::Type=ComplexF64,] N::Int, j::Int=0; dims::Union{Int,AbstractVector{Int},Tuple}=N, sparse::Union{Bool,Val}=Val(false))
    basis([T::Type=ComplexF64,] N::Int, j::Int=0; dims::Union{Int,AbstractVector{Int},Tuple}=N, sparse::Union{Bool,Val}=Val(false))

Generates a fock state ``\ket{\psi}`` of dimension `N` with element type `T = ComplexF64` (default).

It is also possible to specify the list of dimensions `dims` if different subsystems are present.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `fock(N, j, dims=dims, sparse=Val(sparse))` instead of `fock(N, j, dims=dims, sparse=sparse)`. Consider also to use `dims` as a `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) instead of `Vector`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.

!!! note
    `basis(N, j; dims = dims, sparse = sparse)` is a synonym of `fock(N, j; dims = dims, sparse = sparse)`.
"""
function fock(::Type{T}, N::Int, j::Int = 0; dims::Union{Int, AbstractVecOrTuple{Int}} = N, sparse::Union{Bool, Val} = Val(false)) where {T <: Number}
    (0 <= j < N) || throw(ArgumentError("Invalid argument j, must satisfy: 0 ≤ j ≤ N-1"))
    if getVal(sparse)
        array = sparsevec([j + 1], [one(T)], N)
    else
        z0 = zero(T)
        array = [i == (j + 1) ? one(T) : z0 for i in 1:N]
    end
    return QuantumObject(array; type = Ket(), dims = dims)
end
fock(N::Int, j::Int = 0; dims::Union{Int, AbstractVecOrTuple{Int}} = N, sparse::Union{Bool, Val} = Val(false)) = fock(ComplexF64, N, j; dims, sparse)

@doc raw"""
    coherent(N::Int, α::Number)

Generates a [coherent state](https://en.wikipedia.org/wiki/Coherent_state) ``|\alpha\rangle`` with element precision same as `α`. The coherent state is defined as an eigenvector of the bosonic annihilation operator ``\hat{a} |\alpha\rangle = \alpha |\alpha\rangle``.

This state is constructed via the displacement operator [`displace`](@ref) and zero-fock state [`fock`](@ref): ``|\alpha\rangle = \hat{D}(\alpha) |0\rangle``
"""
coherent(N::Int, α::T) where {T <: Number} = displace(N, α) * fock(T, N, 0)

@doc raw"""
    rand_ket([T::Type=ComplexF64,] dimensions; rng::AbstractRNG=default_rng())

Generate a random normalized [`Ket`](@ref) vector with given argument `dimensions` and element type `T = ComplexF64` (default).

The `dimensions` can be either the following types:
- `dimensions::Int`: Number of basis states in the Hilbert space.
- `dimensions::Union{Dimensions,AbstractVector{Int},Tuple}`: list of dimensions representing the each number of basis in the subsystems.

The random number generator can be specified via the keyword argument `rng`.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `rand_ket(dimensions)` with `dimensions` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
rand_ket(::Type{T}, dimensions::Int; rng::AbstractRNG = default_rng()) where {T <: Complex} = rand_ket(T, SVector(dimensions); rng)
function rand_ket(::Type{T}, dimensions::Union{Dimensions, AbstractVecOrTuple{Int}}; rng::AbstractRNG = default_rng()) where {T <: Complex}
    N = get_size(dimensions)[1]
    ψ = rand(rng, T, N) .- (one(T) / 2 + one(T) * im / 2)
    return QuantumObject(normalize!(ψ); type = Ket(), dims = dimensions)
end
rand_ket(dimensions::Union{Int, Dimensions, AbstractVecOrTuple{Int}}; rng::AbstractRNG = default_rng()) = rand_ket(ComplexF64, dimensions; rng)

@doc raw"""
    fock_dm([T::Type=ComplexF64,] N::Int, j::Int=0; dims::Union{Int,AbstractVector{Int},Tuple}=N, sparse::Union{Bool,Val}=Val(false))

Density matrix representation of a Fock state with element type `T = ComplexF64` (default).

Constructed via outer product of [`fock`](@ref).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `fock_dm(N, j, dims=dims, sparse=Val(sparse))` instead of `fock_dm(N, j, dims=dims, sparse=sparse)`. Consider also to use `dims` as a `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) instead of `Vector`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function fock_dm(
        ::Type{T},
        N::Int,
        j::Int = 0;
        dims::Union{Int, AbstractVecOrTuple{Int}} = N,
        sparse::Union{Bool, Val} = Val(false),
    ) where {T <: Number}
    ψ = fock(T, N, j; dims, sparse)
    return ket2dm(ψ)
end
fock_dm(N::Int, j::Int = 0; dims::Union{Int, AbstractVecOrTuple{Int}} = N, sparse::Union{Bool, Val} = Val(false)) = fock_dm(ComplexF64, N, j; dims, sparse)

@doc raw"""
    coherent_dm(N::Int, α::Number)

Density matrix representation of a [coherent state](https://en.wikipedia.org/wiki/Coherent_state) with element precision same as `α`.

Constructed via outer product of [`coherent`](@ref).
"""
coherent_dm(N::Int, α::T) where {T <: Number} = ket2dm(coherent(N, α))

@doc raw"""
    thermal_dm(N::Int, n::Real; sparse::Union{Bool,Val}=Val(false))

Density matrix for a thermal state (generating thermal state probabilities) with element precision same as `n` and the following arguments:
- `N::Int`: Number of basis states in the Hilbert space
- `n::Real`: Expectation value for number of particles in the thermal state.
- `sparse::Union{Bool,Val}`: If `true`, return a sparse matrix representation.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `thermal_dm(N, n, sparse=Val(sparse))` instead of `thermal_dm(N, n, sparse=sparse)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function thermal_dm(N::Int, n::T; sparse::Union{Bool, Val} = Val(false)) where {T <: Real}
    β = log(1 + 1 / n) # here promotes element type to float
    P = [_Boltzmann_weight(β, j) for j in 0:(N - 1)]
    P /= sum(P)
    if getVal(sparse)
        return QuantumObject(spdiagm(0 => P), Operator(), N)
    else
        return QuantumObject(diagm(0 => P), Operator(), N)
    end
end

@doc raw"""
    maximally_mixed_dm([T::Type=ComplexF64,] dimensions)

Returns the maximally mixed density matrix with given argument `dimensions` and element type `T = ComplexF64` (default).

The `dimensions` can be either the following types:
- `dimensions::Int`: Number of basis states in the Hilbert space.
- `dimensions::Union{Dimensions,AbstractVector{Int},Tuple}`: list of dimensions representing the each number of basis in the subsystems.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `maximally_mixed_dm(dimensions)` with `dimensions` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
maximally_mixed_dm(::Type{T}, dimensions::Int) where {T <: FloatOrComplex} =
    QuantumObject(diagm(0 => fill(1 / T(dimensions), dimensions))::Matrix{T}, Operator(), SVector(dimensions)) # TODO: remove `::Matrix{T}` if JET.jl fix https://github.com/aviatesk/JET.jl/issues/790
function maximally_mixed_dm(::Type{T}, dimensions::Union{Dimensions, AbstractVecOrTuple{Int}}) where {T <: FloatOrComplex}
    N = get_size(dimensions)[1]
    return QuantumObject(diagm(0 => fill(1 / T(N), N)), Operator(), dimensions)
end
maximally_mixed_dm(dimensions::Union{Int, Dimensions, AbstractVecOrTuple{Int}}) = maximally_mixed_dm(ComplexF64, dimensions)

@doc raw"""
    rand_dm([T::Type=ComplexF64,] dimensions; rank::Int=get_size(dimensions)[1], rng::AbstractRNG=default_rng())

Generate a random density matrix from Ginibre ensemble with given argument `dimensions`, `rank`, and element type `T = ComplexF64` (default), ensuring that it is positive semi-definite and trace equals to `1`.

The `dimensions` can be either the following types:
- `dimensions::Int`: Number of basis states in the Hilbert space.
- `dimensions::Union{Dimensions,AbstractVector{Int},Tuple}`: list of dimensions representing the each number of basis in the subsystems.

The keyword arguments:
- `rank = get_size(dimensions)[1]` (full rank).
- `rng = default_rng()` (random number generator).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `rand_dm(dimensions; rank=rank)` with `dimensions` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) instead of `Vector`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.

# References
- [J. Ginibre, Statistical ensembles of complex, quaternion, and real matrices, Journal of Mathematical Physics 6.3 (1965): 440-449](https://doi.org/10.1063/1.1704292)
- [K. Życzkowski, et al., Generating random density matrices, Journal of Mathematical Physics 52, 062201 (2011)](http://dx.doi.org/10.1063/1.3595693)
"""
rand_dm(::Type{T}, dimensions::Int; rank::Int = dimensions, rng::AbstractRNG = default_rng()) where {T <: Complex} =
    rand_dm(T, SVector(dimensions); rank, rng)
function rand_dm(
        ::Type{T},
        dimensions::Union{Dimensions, AbstractVecOrTuple{Int}};
        rank::Int = get_size(dimensions)[1],
        rng::AbstractRNG = default_rng(),
    ) where {T <: Complex}
    N = get_size(dimensions)[1]
    (rank < 1) && throw(DomainError(rank, "The argument rank must be larger than 1."))
    (rank > N) && throw(DomainError(rank, "The argument rank cannot exceed dimensions."))

    X = _Ginibre_ensemble(rng, T, N, rank)
    ρ = X * X'
    ρ /= tr(ρ)
    return QuantumObject(ρ; type = Operator(), dims = dimensions)
end
rand_dm(dimensions::Union{Int, Dimensions, AbstractVecOrTuple{Int}}; rank::Int = get_size(dimensions)[1], rng::AbstractRNG = default_rng()) =
    rand_dm(ComplexF64, dimensions; rank, rng)

@doc raw"""
    spin_state([T::Type=ComplexF64,] j::Real, m::Real)

Generate the spin state: ``|j, m\rangle`` with element type `T = ComplexF64` (default).

The eigenstate of the Spin-`j` ``\hat{S}_z`` operator with eigenvalue `m`, where where `j` is the spin quantum number and can be a non-negative integer or half-integer

See also [`jmat`](@ref).
"""
function spin_state(::Type{T}, j::Real, m::Real) where {T <: Number}
    J = 2 * j + 1
    ((floor(J) != J) || (j < 0)) &&
        throw(ArgumentError("The spin quantum number (j) must be a non-negative integer or half-integer."))

    Δ = j - m
    ((floor(Δ) != Δ) || (Δ < 0)) &&
        throw(ArgumentError("Invalid eigenvalue m: (j - m) must be a non-negative integer."))
    (m < (-j)) && throw(ArgumentError("Invalid eigenvalue m, must satisfy: -j ≤ m ≤ j"))

    return fock(T, Int(J), Int(Δ))
end
spin_state(j::Real, m::Real) = spin_state(ComplexF64, j, m)

@doc raw"""
    spin_coherent(j::Real, θ::Real, ϕ::Real)

Generate the coherent spin state (rotation of the ``|j, j\rangle`` state) with element precision is promoted by `θ` and `ϕ`, namely

```math
|\theta, \phi \rangle = \hat{R}(\theta, \phi) |j, j\rangle
```

where the rotation operator is defined as

```math
\hat{R}(\theta, \phi) = \exp \left( \frac{\theta}{2} (\hat{S}_- e^{i\phi} - \hat{S}_+ e^{-i\phi}) \right)
```

and ``\hat{S}_\pm`` are plus and minus Spin-`j` operators, respectively.

# Arguments
- `j::Real`: The spin quantum number and can be a non-negative integer or half-integer
- `θ::Real`: rotation angle from z-axis
- `ϕ::Real`: rotation angle from x-axis

See also [`jmat`](@ref) and [`spin_state`](@ref).

# Reference
- [Robert Jones, Spin Coherent States and Statistical Physics](https://web.mit.edu/8.334/www/grades/projects/projects19/JonesRobert.pdf)
"""
function spin_coherent(j::Real, θ::Tθ, ϕ::Tϕ) where {Tθ <: Real, Tϕ <: Real}
    T = Base.promote_type(Tθ, Tϕ)
    iϕ = T(ϕ) * im # here promotes the final element type to Complex{T}
    Sm = jmat(T, j, Val(:-))
    return exp((T(θ) / 2) * (Sm * exp(iϕ) - Sm' * exp(-iϕ))) * spin_state(T, j, j)
end

@doc raw"""
    bell_state([T::Type=ComplexF64,] x::Union{Int}, z::Union{Int})

Return the [Bell state](https://en.wikipedia.org/wiki/Bell_state) with element type `T = ComplexF64` (default), depending on the arguments `(x, z)`:
- `(0, 0)`: ``| \Phi^+ \rangle = ( |00\rangle + |11\rangle ) / \sqrt{2}``
- `(0, 1)`: ``| \Phi^- \rangle = ( |00\rangle - |11\rangle ) / \sqrt{2}``
- `(1, 0)`: ``| \Psi^+ \rangle = ( |01\rangle + |10\rangle ) / \sqrt{2}``
- `(1, 1)`: ``| \Psi^- \rangle = ( |01\rangle - |10\rangle ) / \sqrt{2}``

Here, `x = 1` (`z = 1`) means applying Pauli-``X`` ( Pauli-``Z``) unitary transformation on ``| \Phi^+ \rangle``.

# Example

```jldoctest
julia> real(bell_state(0, 0))

Quantum Object:   type=Ket()   dims=([2, 2], [1])   size=(4,)
4-element Vector{Float64}:
 0.7071067811865475
 0.0
 0.0
 0.7071067811865475

julia> real(bell_state(Val(1), Val(0)))

Quantum Object:   type=Ket()   dims=([2, 2], [1])   size=(4,)
4-element Vector{Float64}:
 0.0
 0.7071067811865475
 0.7071067811865475
 0.0
```

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `bell_state(Val(x), Val(z))` instead of `bell_state(x, z)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) for more details.
"""
bell_state(::Type{T}, x::Int, z::Int) where {T <: FloatOrComplex} = bell_state(T, Val(x), Val(z))
bell_state(::Type{T}, ::Val{0}, ::Val{0}) where {T <: FloatOrComplex} = QuantumObject(T[1, 0, 0, 1] / sqrt(T(2)), Ket(), (2, 2))
bell_state(::Type{T}, ::Val{0}, ::Val{1}) where {T <: FloatOrComplex} = QuantumObject(T[1, 0, 0, -1] / sqrt(T(2)), Ket(), (2, 2))
bell_state(::Type{T}, ::Val{1}, ::Val{0}) where {T <: FloatOrComplex} = QuantumObject(T[0, 1, 1, 0] / sqrt(T(2)), Ket(), (2, 2))
bell_state(::Type{T}, ::Val{1}, ::Val{1}) where {T <: FloatOrComplex} = QuantumObject(T[0, 1, -1, 0] / sqrt(T(2)), Ket(), (2, 2))
bell_state(::Type{T}, ::Val{T1}, ::Val{T2}) where {T <: FloatOrComplex, T1, T2} = throw(ArgumentError("Invalid Bell state: $(T1), $(T2)"))
bell_state(x::Union{Int, Val}, z::Union{Int, Val}) = bell_state(ComplexF64, x, z)

@doc raw"""
    singlet_state([T::Type=ComplexF64])

Return the two particle singlet state with element type `T = ComplexF64` (default): ``\frac{1}{\sqrt{2}} ( |01\rangle - |10\rangle )``
"""
singlet_state(::Type{T}) where {T <: FloatOrComplex} = QuantumObject(T[0, 1, -1, 0] / sqrt(T(2)), Ket(), (2, 2))
singlet_state() = singlet_state(ComplexF64)

@doc raw"""
    triplet_states([T::Type=ComplexF64])

Return a list of the two particle triplet states with element type `T = ComplexF64` (default): 

- ``|11\rangle``
- ``( |01\rangle + |10\rangle ) / \sqrt{2}``
- ``|00\rangle``
"""
function triplet_states(::Type{T}) where {T <: FloatOrComplex}
    return QuantumObject[
        QuantumObject(T[0, 0, 0, 1], Ket(), (2, 2)),
        QuantumObject(T[0, 1, 1, 0] / sqrt(T(2)), Ket(), (2, 2)),
        QuantumObject(T[1, 0, 0, 0], Ket(), (2, 2)),
    ]
end
triplet_states() = triplet_states(ComplexF64)

@doc raw"""
    w_state([T::Type=ComplexF64,] n::Union{Int,Val})

Returns the `n`-qubit [W-state](https://en.wikipedia.org/wiki/W_state) with element type `T = ComplexF64` (default):

```math
\frac{1}{\sqrt{n}} \left( |100...0\rangle + |010...0\rangle + \cdots + |00...01\rangle \right)
```

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `w_state(Val(n))` instead of `w_state(n)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) for more details.
"""
function w_state(::Type{T}, ::Val{n}) where {T <: FloatOrComplex, n}
    (n >= 2) || throw(ArgumentError("Invalid argument n, must satisfy: n ≥ 2"))

    nzind = 2 .^ (0:(n - 1)) .+ 1
    nzval = fill(1 / sqrt(T(n)), n)
    data = zeros(T, 2^n)
    @inbounds data[nzind] .= nzval
    return QuantumObject(data, Ket(), ntuple(x -> 2, Val(n)))
end
w_state(::Type{T}, n::Int) where {T <: FloatOrComplex} = w_state(T, Val(n))
w_state(n::Union{Int, Val}) = w_state(ComplexF64, n)

@doc raw"""
    ghz_state([T::Type=ComplexF64,] n::Union{Int,Val}; d::Int=2)

Returns the generalized `n`-qudit [Greenberger–Horne–Zeilinger (GHZ) state](https://en.wikipedia.org/wiki/Greenberger%E2%80%93Horne%E2%80%93Zeilinger_state) with element type `T = ComplexF64` (default):

```math
\frac{1}{\sqrt{d}} \sum_{i=0}^{d-1} | i \rangle \otimes \cdots \otimes | i \rangle
```

Here, `d` specifies the dimension of each qudit. Default to `d=2` (qubit).

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `ghz_state(Val(n))` instead of `ghz_state(n)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) for more details.
"""
function ghz_state(::Type{T}, ::Val{n}; d::Int = 2) where {T <: FloatOrComplex, n}
    (n >= 2) || throw(ArgumentError("Invalid argument n, must satisfy: n ≥ 2"))
    (d >= 2) || throw(ArgumentError("Invalid argument d, must satisfy: d ≥ 2"))

    nzind = collect((0:(d - 1)) .* Int((d^n - 1) / (d - 1)) .+ 1)
    nzval = fill(1 / sqrt(T(d)), d)
    data = zeros(T, d^n)
    @inbounds data[nzind] .= nzval
    return QuantumObject(data, Ket(), ntuple(x -> d, Val(n)))
end
ghz_state(::Type{T}, n::Int; d::Int = 2) where {T <: FloatOrComplex} = ghz_state(T, Val(n); d)
ghz_state(n::Union{Int, Val}; d::Int = 2) = ghz_state(ComplexF64, n; d)

export correlation_3op_2t, correlation_3op_1t, correlation_2op_2t, correlation_2op_1t

function _check_correlation_time_list(tlist::AbstractVector)
    any(t -> t == 0, tlist) ||
        throw(ArgumentError("The time list for calculating correlation function must contain the element `0`"))
    all(>=(0), tlist) ||
        throw(ArgumentError("All the elements in the time list for calculating correlation function must be positive."))
    return nothing
end

@doc raw"""
    correlation_3op_2t(H::AbstractQuantumObject,
        ψ0::Union{Nothing,QuantumObject},
        tlist::AbstractVector,
        τlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple},
        A::QuantumObject,
        B::QuantumObject,
        C::QuantumObject;
        kwargs...)

Returns the two-time correlation function of three operators ``\hat{A}``, ``\hat{B}`` and ``\hat{C}``: ``\left\langle \hat{A}(t) \hat{B}(t + \tau) \hat{C}(t) \right\rangle`` for a given initial state ``|\psi_0\rangle``.

If the initial state `ψ0` is given as `nothing`, then the [`steadystate`](@ref) will be used as the initial state. Note that this is only implemented if `H` is constant ([`QuantumObject`](@ref)).
"""
function correlation_3op_2t(
        H::AbstractQuantumObject{HOpType},
        ψ0::Union{Nothing, QuantumObject{StateOpType}},
        tlist::AbstractVector,
        τlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple},
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        C::QuantumObject{Operator};
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    # check tlist and τlist
    _check_correlation_time_list(tlist)
    _check_correlation_time_list(τlist)

    L = liouvillian(H, c_ops)
    if ψ0 isa Nothing
        ψ0 = steadystate(L)
    end

    # check the dimensions of Operator A, B, C, and ψ0
    # the dimension validity of L and ψ0 will be checked in mesolve
    check_mul_dimensions(A, ψ0)
    check_dimensions(A, B, C)

    kwargs2 = merge((saveat = collect(tlist),), (; kwargs...))

    # generate OperatorKet first, so sol.states will store OperatorKet (skip redundant reshaping)
    # note that doesn't need to do the first mesolve if tlist == [0] (for 2op_1t and 3op_1t cases)
    ρ0_vec = mat2vec(ket2dm(ψ0))
    ρt_list = (tlist == [0]) ? [ρ0_vec] : mesolve(L, ρ0_vec, tlist; kwargs2...).states

    C_A = sprepost(C, A)
    corr = map((t, ρt) -> mesolve(L, C_A * ρt, τlist .+ t, e_ops = [B]; kwargs...).expect[1, :], tlist, ρt_list)

    # make the output correlation Matrix align with QuTiP
    # 1st dimension corresponds to tlist
    # 2nd dimension corresponds to τlist
    return reduce(vcat, transpose.(corr))
end

@doc raw"""
    correlation_3op_1t(H::AbstractQuantumObject,
        ψ0::Union{Nothing,QuantumObject},
        τlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple},
        A::QuantumObject,
        B::QuantumObject,
        C::QuantumObject;
        kwargs...)

Returns the two-time correlation function (with only one time coordinate ``\tau``) of three operators ``\hat{A}``, ``\hat{B}`` and ``\hat{C}``: ``\left\langle \hat{A}(0) \hat{B}(\tau) \hat{C}(0) \right\rangle`` for a given initial state ``|\psi_0\rangle``.

If the initial state `ψ0` is given as `nothing`, then the [`steadystate`](@ref) will be used as the initial state. Note that this is only implemented if `H` is constant ([`QuantumObject`](@ref)).
"""
function correlation_3op_1t(
        H::AbstractQuantumObject{HOpType},
        ψ0::Union{Nothing, QuantumObject{StateOpType}},
        τlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple},
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        C::QuantumObject{Operator};
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    corr = correlation_3op_2t(H, ψ0, [0], τlist, c_ops, A, B, C; kwargs...)

    return corr[1, :] # 1 means tlist[1] = 0
end

@doc raw"""
    correlation_2op_2t(H::AbstractQuantumObject,
        ψ0::Union{Nothing,QuantumObject},
        tlist::AbstractVector,
        τlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple},
        A::QuantumObject,
        B::QuantumObject;
        reverse::Bool=false,
        kwargs...)

Returns the two-time correlation function of two operators ``\hat{A}`` and ``\hat{B}`` : ``\left\langle \hat{A}(t + \tau) \hat{B}(t) \right\rangle`` for a given initial state ``|\psi_0\rangle``.

If the initial state `ψ0` is given as `nothing`, then the [`steadystate`](@ref) will be used as the initial state. Note that this is only implemented if `H` is constant ([`QuantumObject`](@ref)).

When `reverse=true`, the correlation function is calculated as ``\left\langle \hat{A}(t) \hat{B}(t + \tau) \right\rangle``.
"""
function correlation_2op_2t(
        H::AbstractQuantumObject{HOpType},
        ψ0::Union{Nothing, QuantumObject{StateOpType}},
        tlist::AbstractVector,
        τlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple},
        A::QuantumObject{Operator},
        B::QuantumObject{Operator};
        reverse::Bool = false,
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    C = eye(get_size(A.dimensions)[1], type = Operator(), dims = A.dims) # same as qeye_like(A), use A instead of H (cause H might be SuperOperator)
    if reverse
        corr = correlation_3op_2t(H, ψ0, tlist, τlist, c_ops, A, B, C; kwargs...)
    else
        corr = correlation_3op_2t(H, ψ0, tlist, τlist, c_ops, C, A, B; kwargs...)
    end

    return corr
end

@doc raw"""
    correlation_2op_1t(H::AbstractQuantumObject,
        ψ0::Union{Nothing,QuantumObject},
        τlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple},
        A::QuantumObject,
        B::QuantumObject;
        reverse::Bool=false,
        kwargs...)

Returns the two-time correlation function (with only one time coordinate ``\tau``) of two operators ``\hat{A}`` and ``\hat{B}`` : ``\left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle`` for a given initial state ``|\psi_0\rangle``.

If the initial state `ψ0` is given as `nothing`, then the [`steadystate`](@ref) will be used as the initial state. Note that this is only implemented if `H` is constant ([`QuantumObject`](@ref)).

When `reverse=true`, the correlation function is calculated as ``\left\langle \hat{A}(0) \hat{B}(\tau) \right\rangle``.
"""
function correlation_2op_1t(
        H::AbstractQuantumObject{HOpType},
        ψ0::Union{Nothing, QuantumObject{StateOpType}},
        τlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple},
        A::QuantumObject{Operator},
        B::QuantumObject{Operator};
        reverse::Bool = false,
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    corr = correlation_2op_2t(H, ψ0, [0], τlist, c_ops, A, B; reverse = reverse, kwargs...)

    return corr[1, :] # 1 means tlist[1] = 0
end

@testitem "entropy" begin
    base = 2
    λ = rand()
    ψ = rand_ket(10)
    ρ1 = rand_dm(10)
    ρ2 = rand_dm(10)
    σ1 = rand_dm(10)
    σ2 = rand_dm(10)

    dims = (2, 3)
    ρAB = rand_dm((dims..., dims...))
    selA = (1, 2)
    selB = (3, 4)
    ρA = ptrace(ρAB, selA)
    ρB = ptrace(ρAB, selB)
    nA = nB = prod(dims)
    IA = qeye(nA, dims = dims)
    IB = qeye(nB, dims = dims)

    # quantum relative entropy
    @test entropy_relative(ρ1, ψ) == Inf
    @test entropy_relative(ρ1, rand_dm(10, rank = 9)) == Inf
    @test entropy_relative(ψ, ψ) + 1 ≈ 1
    @test entropy_relative(λ * ρ1 + (1 - λ) * ρ2, λ * σ1 + (1 - λ) * σ2) <=
        λ * entropy_relative(ρ1, σ1) + (1 - λ) * entropy_relative(ρ2, σ2) # joint convexity

    # relations between different entropies
    @test entropy_relative(ρA, IA / nA) ≈ log(nA) - entropy_vn(ρA)
    @test entropy_relative(ρB, IB / nB; base = base) ≈ log(base, nB) - entropy_vn(ρB; base = base)
    @test entropy_relative(ρAB, tensor(ρA, ρB)) ≈ entropy_mutual(ρAB, selA, selB)
    @test entropy_relative(ρAB, tensor(ρA, ρB)) ≈ entropy_mutual(ρAB, selA, selB)
    @test entropy_relative(ρAB, tensor(ρA, IB / nB)) ≈ log(nB) - entropy_conditional(ρAB, selA)
    @test entropy_linear(ρ1) == 1 - purity(ρ1)

    ρ_wrong = Qobj(rand(ComplexF64, 10, 10))
    @test_throws ErrorException entropy_relative(ρ1, ρ_wrong)
    @test_throws ErrorException entropy_relative(ρ_wrong, ρ1)
    @test_throws ArgumentError entropy_mutual(ρAB, 1, 3)
    @test_throws ArgumentError entropy_mutual(ρAB, 1, (3, 4))
    @test_throws ArgumentError entropy_mutual(ρAB, (1, 2), 3)
    @test_throws ArgumentError entropy_mutual(ρAB, (1, 2), (1, 3))

    if VERSION >= v"1.11" # eigen is type unstable on v1.10
        @testset "Type Stability (entropy)" begin
            @inferred entropy_vn(ρ1)
            @inferred entropy_vn(ρ1, base = base)
            @inferred entropy_relative(ρ1, ψ)
            @inferred entropy_relative(ρ1, σ1, base = base)
            @inferred entropy_linear(ρ1)
            @inferred entropy_mutual(ρAB, selA, selB)
            @inferred entropy_conditional(ρAB, selA)
        end
    end
end

@testitem "entanglement and concurrence" begin
    # bell state
    ψb = bell_state(Val(1), Val(0))
    ρb = ket2dm(ψb)
    @test entanglement(ψb, 1) / log(2) ≈ 1
    @test entanglement(ρb, 1) / log(2) ≈ 1
    @test concurrence(ψb) ≈ 1
    @test concurrence(ρb) ≈ 1

    # separable pure state
    ψs = kron(rand_ket(2), rand_ket(2))
    @test entanglement(ψs, 1) + 1 ≈ 1
    @test entanglement(ψs, 2) + 1 ≈ 1
    @test concurrence(ψs) + 1 ≈ 1

    # this only works for "pure" two-qubit states
    ψr = rand_ket((2, 2)) # might be an entangled two-qubit state
    val = concurrence(ψr)
    @test isapprox(val, sqrt(2 * entropy_linear(ptrace(ψr, 1))); atol = 1.0e-5) # √(2 * (1 - Tr(ρA^2)))
    @test isapprox(val, sqrt(2 * entropy_linear(ptrace(ψr, 2))); atol = 1.0e-5) # √(2 * (1 - Tr(ρB^2)))

    @test_throws ArgumentError entanglement(rand_dm((2, 2)), 1)
    @test_throws ArgumentError concurrence(rand_dm((2, 3)))
    @test_throws ArgumentError concurrence(rand_dm(4))

    @testset "Type Stability (entanglement)" begin
        @inferred entanglement(ψb, 1)
        @inferred entanglement(ρb, 1)
    end

    @testset "Type Stability (concurrence)" begin
        @inferred concurrence(ψb)
        @inferred concurrence(ρb)
    end
end

@testitem "trace and Hilbert-Schmidt distance" begin
    ψz0 = basis(2, 0)
    ψz1 = basis(2, 1)
    ρz0 = to_sparse(ket2dm(ψz0))
    ρz1 = to_sparse(ket2dm(ψz1))
    ψx0 = sqrt(0.5) * (basis(2, 0) + basis(2, 1))
    @test tracedist(ψz0, ψx0) ≈ sqrt(0.5)
    @test tracedist(ρz0, ψz1) ≈ 1.0
    @test tracedist(ψz1, ρz0) ≈ 1.0
    @test tracedist(ρz0, ρz1) ≈ 1.0

    ψ = rand_ket(10)
    ϕ = rand_ket(10)
    @test isapprox(tracedist(ψ, ϕ)^2, hilbert_dist(ψ, ϕ) / 2; atol = 1.0e-6)

    @testset "Type Inference (trace distance)" begin
        @inferred tracedist(ψz0, ψx0)
        @inferred tracedist(ρz0, ψz1)
        @inferred tracedist(ψz1, ρz0)
        @inferred tracedist(ρz0, ρz1)
    end

    @testset "Type Inference (Hilbert-Schmidt distance)" begin
        @inferred hilbert_dist(ψz0, ψx0)
        @inferred hilbert_dist(ρz0, ψz1)
        @inferred hilbert_dist(ψz1, ρz0)
        @inferred hilbert_dist(ρz0, ρz1)
    end
end

@testitem "fidelity, Bures metric, and Hellinger distance" begin
    M0 = rand_dm(5)
    ψ1 = rand_ket(5)
    ψ2 = rand_ket(5)
    M1 = ket2dm(ψ1)
    b00 = bell_state(Val(0), Val(0))
    b01 = bell_state(Val(0), Val(1))
    @test isapprox(fidelity(M0, M1), fidelity(ψ1, M0); atol = 1.0e-6)
    @test isapprox(fidelity(ψ1, ψ2), fidelity(ket2dm(ψ1), ket2dm(ψ2)); atol = 1.0e-6)
    @test isapprox(fidelity(b00, b00), 1; atol = 1.0e-6)
    @test isapprox(bures_dist(b00, b00) + 1, 1; atol = 1.0e-6)
    @test isapprox(bures_angle(b00, b00) + 1, 1; atol = 1.0e-6)
    @test isapprox(hellinger_dist(b00, b00) + 1, 1; atol = 1.0e-6)
    @test isapprox(fidelity(b00, b01) + 1, 1; atol = 1.0e-6)
    @test isapprox(bures_dist(b00, b01), √2; atol = 1.0e-6)
    @test isapprox(bures_angle(b00, b01), π / 2; atol = 1.0e-6)
    @test isapprox(hellinger_dist(b00, b01), √2; atol = 1.0e-6)

    # some relations between Bures and Hellinger dintances
    # together with some monotonicity under tensor products
    # [see arXiv:1611.03449 (2017); section 4.2]
    ρA = rand_dm(5)
    ρB = rand_dm(6)
    ρAB = tensor(ρA, ρB)
    σA = rand_dm(5)
    σB = rand_dm(6)
    σAB = tensor(σA, σB)
    d_Bu_A = bures_dist(ρA, σA)
    d_Bu_AB = bures_dist(ρAB, σAB)
    d_He_A = hellinger_dist(ρA, σA)
    d_He_AB = hellinger_dist(ρAB, σAB)
    @test isapprox(fidelity(ρAB, σAB), fidelity(ρA, σA) * fidelity(ρB, σB); atol = 1.0e-6)
    @test d_He_AB >= d_Bu_AB
    @test d_Bu_AB >= d_Bu_A
    @test isapprox(bures_dist(ρAB, tensor(σA, ρB)), d_Bu_A; atol = 1.0e-6)
    @test d_He_AB >= d_He_A
    @test isapprox(hellinger_dist(ρAB, tensor(σA, ρB)), d_He_A; atol = 1.0e-6)

    @testset "Type Inference (fidelity)" begin
        @inferred fidelity(M0, M1)
        @inferred fidelity(ψ1, M0)
        @inferred fidelity(ψ1, ψ2)
    end

    @testset "Type Inference (Hellinger distance)" begin
        @inferred hellinger_dist(M0, M1)
        @inferred hellinger_dist(ψ1, M0)
        @inferred hellinger_dist(ψ1, ψ2)
    end

    @testset "Type Inference (Bures metric)" begin
        @inferred bures_dist(M0, M1)
        @inferred bures_dist(ψ1, M0)
        @inferred bures_dist(ψ1, ψ2)
        @inferred bures_angle(M0, M1)
        @inferred bures_angle(ψ1, M0)
        @inferred bures_angle(ψ1, ψ2)
    end
end

raw"""
    _getFigAndLocation(location::Nothing)
    
    Create a new figure and return it, together with the GridPosition object pointing to the first cell.

    # Arguments
    - `location::Nothing`

    # Returns
    - `fig`: The figure object.
    - `location`: The GridPosition object pointing to the first cell.
"""
function _getFigAndLocation(location::Nothing)
    fig = Figure()
    return fig, fig[1, 1]
end

raw"""
    _getFigAndLocation(location::GridPosition)
    
    Compute which figure does the location belong to and return it, together with the location itself.

    # Arguments
    - `location::GridPosition`

    # Returns
    - `fig`: The figure object.
    - `location`: The GridPosition object.
"""
function _getFigAndLocation(location::GridPosition)
    fig = _figFromChildren(location.layout)
    return fig, location
end

raw"""
    _figFromChildren(children::GridLayout)

    Recursively find the figure object from the children layout.

    # Arguments
    - `children::GridLayout`

    # Returns
    - Union{Nothing, Figure, GridLayout}: The children's parent object.
"""
_figFromChildren(children) = _figFromChildren(children.parent)

raw"""
    _figFromChildren(fig::Figure)

    Return the figure object

    # Arguments
    - `fig::Figure`

    # Returns
    - `fig`: The figure object.
"""
_figFromChildren(fig::Figure) = fig

raw"""
    _figFromChildren(::Nothing)

    Throw an error if no figure has been found.

    # Arguments
    - `::Nothing`

    # Throws
    - `ArgumentError`: If no figure has been found.
"""
_figFromChildren(::Nothing) = throw(ArgumentError("No Figure has been found at the top of the layout hierarchy."))

#=
Arithmetic and Attributes for QuantumObject
    - extend most of the useful functions in LinearAlgebra for QuantumObject
    - export most of the attribute functions in "Python Qobj class"
=#

export proj, ptrace, purity
export tidyup, tidyup!
export get_data, get_coherence

#    Broadcasting
Base.broadcastable(x::QuantumObject) = x.data
for op in (:(+), :(-), :(*), :(/), :(^))
    @eval begin
        function Base.Broadcast.broadcasted(::typeof($op), x::QuantumObject, y::QuantumObject)
            return QuantumObject(broadcast($op, x.data, y.data), x.type, x.dimensions)
        end

        function Base.Broadcast.broadcasted(::typeof($op), x::QuantumObject, y::Number)
            return QuantumObject(broadcast($op, x.data, y), x.type, x.dimensions)
        end

        function Base.Broadcast.broadcasted(::typeof($op), x::Number, y::QuantumObject)
            return QuantumObject(broadcast($op, x, y.data), y.type, y.dimensions)
        end

        function Base.Broadcast.broadcasted(::typeof($op), x::QuantumObject, y::AbstractArray)
            return QuantumObject(broadcast($op, x.data, y), x.type, x.dimensions)
        end

        function Base.Broadcast.broadcasted(::typeof($op), x::AbstractArray, y::QuantumObject)
            return QuantumObject(broadcast($op, x, y.data), y.type, y.dimensions)
        end
    end
end

for op in (:(+), :(-), :(*))
    @eval begin
        function Base.$op(A::AbstractQuantumObject, B::AbstractQuantumObject)
            check_dimensions(A, B)
            QType = promote_op_type(A, B)
            return QType($(op)(A.data, B.data), A.type, A.dimensions)
        end
        Base.$op(A::AbstractQuantumObject) = get_typename_wrapper(A)($(op)(A.data), A.type, A.dimensions)

        Base.$op(n::T, A::AbstractQuantumObject) where {T <: Number} =
            get_typename_wrapper(A)($(op)(n * I, A.data), A.type, A.dimensions)
        Base.$op(A::AbstractQuantumObject, n::T) where {T <: Number} =
            get_typename_wrapper(A)($(op)(A.data, n * I), A.type, A.dimensions)
    end
end

function check_mul_dimensions(A::AbstractQuantumObject, B::AbstractQuantumObject)
    (A.dimensions.from != B.dimensions.to) && throw(
        DimensionMismatch(
            "The quantum object with dims = $(A.dims) can not multiply a quantum object with dims = $(B.dims) on the right-hand side.",
        ),
    )
    return nothing
end

function Base.:(*)(A::AbstractQuantumObject{Operator}, B::AbstractQuantumObject{Operator})
    check_mul_dimensions(A, B)
    QType = promote_op_type(A, B)
    return QType(A.data * B.data, Operator(), ProductDimensions(A.dimensions.to, B.dimensions.from))
end

function Base.:(*)(A::AbstractQuantumObject{Operator}, B::QuantumObject{Ket})
    check_mul_dimensions(A, B)
    return QuantumObject(A.data * B.data, Ket(), ProductDimensions(A.dimensions.to, B.dimensions.from))
end
function Base.:(*)(A::QuantumObject{Bra}, B::AbstractQuantumObject{Operator})
    check_mul_dimensions(A, B)
    return QuantumObject(A.data * B.data, Bra(), ProductDimensions(A.dimensions.to, B.dimensions.from))
end
function Base.:(*)(A::QuantumObject{Ket}, B::QuantumObject{Bra})
    check_mul_dimensions(A, B)
    return QuantumObject(A.data * B.data, Operator(), ProductDimensions(A.dimensions.to, B.dimensions.from))
end
function Base.:(*)(A::QuantumObject{Bra}, B::QuantumObject{Ket})
    check_mul_dimensions(A, B)
    return A.data * B.data
end
function Base.:(*)(A::AbstractQuantumObject{SuperOperator}, B::QuantumObject{Operator})
    check_mul_dimensions(A, B)
    return QuantumObject(vec2mat(A.data * mat2vec(B.data)), Operator(), A.dimensions.to)
end
function Base.:(*)(A::QuantumObject{OperatorBra}, B::QuantumObject{OperatorKet})
    check_mul_dimensions(A, B)
    return A.data * B.data
end
function Base.:(*)(A::AbstractQuantumObject{SuperOperator}, B::QuantumObject{OperatorKet})
    check_mul_dimensions(A, B)
    return QuantumObject(A.data * B.data, OperatorKet(), A.dimensions.to)
end
function Base.:(*)(A::QuantumObject{OperatorBra}, B::AbstractQuantumObject{SuperOperator})
    check_mul_dimensions(A, B)
    return QuantumObject(A.data * B.data, OperatorBra(), B.dimensions.from)
end

Base.:(^)(A::QuantumObject, n::T) where {T <: Number} = QuantumObject(^(A.data, n), A.type, A.dimensions)
Base.:(/)(A::AbstractQuantumObject, n::T) where {T <: Number} = get_typename_wrapper(A)(A.data / n, A.type, A.dimensions)

@doc raw"""
    A ⋅ B
    dot(A::QuantumObject, B::QuantumObject)

Compute the dot product between two [`QuantumObject`](@ref): ``\langle A | B \rangle``

Note that `A` and `B` should be [`Ket`](@ref) or [`OperatorKet`](@ref)

!!! note
    `A ⋅ B` (where `⋅` can be typed by tab-completing `\cdot` in the REPL) is a synonym of `dot(A, B)`.
"""
function LinearAlgebra.dot(A::QuantumObject{OpType}, B::QuantumObject{OpType}) where {OpType <: Union{Ket, OperatorKet}}
    check_dimensions(A, B)
    return LinearAlgebra.dot(A.data, B.data)
end

@doc raw"""
    dot(i::QuantumObject, A::AbstractQuantumObject j::QuantumObject)
    matrix_element(i::QuantumObject, A::AbstractQuantumObject j::QuantumObject)

Compute the generalized dot product `dot(i, A*j)` between a [`AbstractQuantumObject`](@ref) and two [`QuantumObject`](@ref) (`i` and `j`), namely ``\langle i | \hat{A} | j \rangle``.

Supports the following inputs:
- `A` is in the type of [`Operator`](@ref), with `i` and `j` are both [`Ket`](@ref).
- `A` is in the type of [`SuperOperator`](@ref), with `i` and `j` are both [`OperatorKet`](@ref)

!!! note
    `matrix_element(i, A, j)` is a synonym of `dot(i, A, j)`.
"""
function LinearAlgebra.dot(i::QuantumObject{Ket}, A::AbstractQuantumObject{Operator}, j::QuantumObject{Ket})
    check_mul_dimensions(i', A)
    check_mul_dimensions(A, j)
    return LinearAlgebra.dot(i.data, A.data, j.data)
end
function LinearAlgebra.dot(
        i::QuantumObject{OperatorKet},
        A::AbstractQuantumObject{SuperOperator},
        j::QuantumObject{OperatorKet},
    )
    check_mul_dimensions(i', A)
    check_mul_dimensions(A, j)
    return LinearAlgebra.dot(i.data, A.data, j.data)
end

@doc raw"""
    zero(A::AbstractQuantumObject)

Return a similar [`AbstractQuantumObject`](@ref) with `dims` and `type` are same as `A`, but `data` is a zero-array.
"""
Base.zero(A::AbstractQuantumObject) = get_typename_wrapper(A)(zero(A.data), A.type, A.dimensions)

@doc raw"""
    one(A::AbstractQuantumObject)

Return a similar [`AbstractQuantumObject`](@ref) with `dims` and `type` are same as `A`, but `data` is an identity matrix.

Note that `A` must be [`Operator`](@ref) or [`SuperOperator`](@ref).
"""
Base.one(A::AbstractQuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} =
    get_typename_wrapper(A)(one(A.data), A.type, A.dimensions)

@doc raw"""
    conj(A::AbstractQuantumObject)

Return the element-wise complex conjugation of the [`AbstractQuantumObject`](@ref).
"""
Base.conj(A::AbstractQuantumObject) = get_typename_wrapper(A)(conj(A.data), A.type, A.dimensions)

@doc raw"""
    transpose(A::AbstractQuantumObject)

Lazy matrix transpose of the [`AbstractQuantumObject`](@ref).
"""
Base.transpose(A::AbstractQuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} =
    get_typename_wrapper(A)(transpose(A.data), A.type, transpose(A.dimensions))

@doc raw"""
    A'
    adjoint(A::AbstractQuantumObject)
    dag(A::AbstractQuantumObject)

Lazy adjoint (conjugate transposition) of the [`AbstractQuantumObject`](@ref)

!!! note
    `A'` and `dag(A)` are synonyms of `adjoint(A)`.
"""
Base.adjoint(A::AbstractQuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} =
    get_typename_wrapper(A)(adjoint(A.data), A.type, adjoint(A.dimensions))
Base.adjoint(A::QuantumObject{Ket}) = QuantumObject(adjoint(A.data), Bra(), adjoint(A.dimensions))
Base.adjoint(A::QuantumObject{Bra}) = QuantumObject(adjoint(A.data), Ket(), adjoint(A.dimensions))
Base.adjoint(A::QuantumObject{OperatorKet}) = QuantumObject(adjoint(A.data), OperatorBra(), adjoint(A.dimensions))
Base.adjoint(A::QuantumObject{OperatorBra}) = QuantumObject(adjoint(A.data), OperatorKet(), adjoint(A.dimensions))

@doc raw"""
    inv(A::AbstractQuantumObject)

Matrix inverse of the [`AbstractQuantumObject`](@ref). If `A` is a [`QuantumObjectEvolution`](@ref), the inverse is computed at the last computed time.
"""
LinearAlgebra.inv(A::AbstractQuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} =
    QuantumObject(sparse(inv(Matrix(A.data))), A.type, A.dimensions)

LinearAlgebra.Hermitian(A::QuantumObject{OpType}, uplo::Symbol = :U) where {OpType <: Union{Operator, SuperOperator}} =
    QuantumObject(Hermitian(A.data, uplo), A.type, A.dimensions)

@doc raw"""
    tr(A::QuantumObject)

Returns the trace of [`QuantumObject`](@ref).

Note that this function only supports for [`Operator`](@ref) and [`SuperOperator`](@ref)

# Examples

```jldoctest
julia> a = destroy(20)

Quantum Object:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 19 stored entries:
⎡⠈⠢⡀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠈⠢⡀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠈⠢⡀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠈⠢⡀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠈⠢⎦

julia> tr(a' * a)
190.0 + 0.0im
```
"""
LinearAlgebra.tr(A::QuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} = tr(A.data)
LinearAlgebra.tr(
    A::QuantumObject{OpType, DimsType, <:Union{<:Hermitian{TF}, Symmetric{TR}}},
) where {OpType <: Operator, DimsType, TF <: Number, TR <: Real} = real(tr(A.data))

@doc raw"""
    svdvals(A::QuantumObject)

Return the singular values of a [`QuantumObject`](@ref) in descending order
"""
LinearAlgebra.svdvals(A::QuantumObject) = svdvals(to_dense(A.data))

@doc raw"""
    norm(A::QuantumObject, p::Real)

Return the standard vector `p`-norm or [Schatten](https://en.wikipedia.org/wiki/Schatten_norm) `p`-norm of a [`QuantumObject`](@ref) depending on the type of `A`:

- If `A` is either [`Ket`](@ref), [`Bra`](@ref), [`OperatorKet`](@ref), or [`OperatorBra`](@ref), returns the standard vector `p`-norm (default `p=2`) of `A`.
- If `A` is either [`Operator`](@ref) or [`SuperOperator`](@ref), returns [Schatten](https://en.wikipedia.org/wiki/Schatten_norm) `p`-norm (default `p=1`) of `A`.

# Examples

```jldoctest
julia> ψ = fock(10, 2)

Quantum Object:   type=Ket()   dims=([10], [1])   size=(10,)
10-element Vector{ComplexF64}:
 0.0 + 0.0im
 0.0 + 0.0im
 1.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im

julia> norm(ψ)
1.0
```
"""
LinearAlgebra.norm(A::QuantumObject{OpType}, p::Real = 2) where {OpType <: Union{Ket, Bra, OperatorKet, OperatorBra}} =
    norm(A.data, p)
function LinearAlgebra.norm(A::QuantumObject{OpType}, p::Real = 1) where {OpType <: Union{Operator, SuperOperator}}
    p == 2.0 && return norm(A.data, 2)
    return norm(svdvals(A), p)
end

@doc raw"""
    normalize(A::QuantumObject, p::Real)
    unit(A::QuantumObject, p::Real)

Return normalized [`QuantumObject`](@ref) so that its `p`-norm equals to unity, i.e. `norm(A, p) == 1`.

Support for the following types of [`QuantumObject`](@ref):
- If `A` is [`Ket`](@ref) or [`Bra`](@ref), default `p = 2`
- If `A` is [`Operator`](@ref), default `p = 1`

!!! note
    `unit` is a synonym of `normalize`.

Also, see [`norm`](@ref) about its definition for different types of [`QuantumObject`](@ref).
"""
LinearAlgebra.normalize(A::QuantumObject{ObjType}, p::Real = 2) where {ObjType <: Union{Ket, Bra}} =
    QuantumObject(A.data / norm(A, p), A.type, A.dimensions)
LinearAlgebra.normalize(A::QuantumObject{Operator}, p::Real = 1) =
    QuantumObject(A.data / norm(A, p), A.type, A.dimensions)

@doc raw"""
    normalize!(A::QuantumObject, p::Real)

Normalize [`QuantumObject`](@ref) in-place so that its `p`-norm equals to unity, i.e. `norm(A, p) == 1`.

Support for the following types of [`QuantumObject`](@ref):
- If `A` is [`Ket`](@ref) or [`Bra`](@ref), default `p = 2`
- If `A` is [`Operator`](@ref), default `p = 1`

Also, see [`norm`](@ref) about its definition for different types of [`QuantumObject`](@ref).
"""
LinearAlgebra.normalize!(A::QuantumObject{ObjType}, p::Real = 2) where {ObjType <: Union{Ket, Bra}} =
    (rmul!(A.data, 1 / norm(A, p)); A)
LinearAlgebra.normalize!(A::QuantumObject{Operator}, p::Real = 1) = (rmul!(A.data, 1 / norm(A, p)); A)

LinearAlgebra.triu!(A::QuantumObject{OpType}, k::Integer = 0) where {OpType <: Union{Operator, SuperOperator}} =
    (triu!(A.data, k); A)
LinearAlgebra.tril!(A::QuantumObject{OpType}, k::Integer = 0) where {OpType <: Union{Operator, SuperOperator}} =
    (tril!(A.data, k); A)
LinearAlgebra.triu(A::QuantumObject{OpType}, k::Integer = 0) where {OpType <: Union{Operator, SuperOperator}} =
    QuantumObject(triu(A.data, k), A.type, A.dimensions)
LinearAlgebra.tril(A::QuantumObject{OpType}, k::Integer = 0) where {OpType <: Union{Operator, SuperOperator}} =
    QuantumObject(tril(A.data, k), A.type, A.dimensions)

LinearAlgebra.lmul!(a::Number, B::QuantumObject) = (lmul!(a, B.data); B)
LinearAlgebra.rmul!(B::QuantumObject, a::Number) = (rmul!(B.data, a); B)

@inline LinearAlgebra.mul!(y::AbstractVector{T}, A::QuantumObject, x, α, β) where {T} = mul!(y, A.data, x, α, β)

@doc raw"""
    √(A)
    sqrt(A::QuantumObject)

Matrix square root of [`QuantumObject`](@ref)

!!! note
    `√(A)` (where `√` can be typed by tab-completing `\sqrt` in the REPL) is a synonym of `sqrt(A)`.
"""
Base.sqrt(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} = QuantumObject(sqrt(to_dense(A.data)), A.type, A.dimensions)

@doc raw"""
    log(A::QuantumObject)

Matrix logarithm of [`QuantumObject`](@ref)

Note that this function only supports for [`Operator`](@ref) and [`SuperOperator`](@ref)
"""
Base.log(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} =
    QuantumObject(log(to_dense(A.data)), A.type, A.dimensions)

@doc raw"""
    exp(A::QuantumObject)

Matrix exponential of [`QuantumObject`](@ref)

Note that this function only supports for [`Operator`](@ref) and [`SuperOperator`](@ref)
"""
Base.exp(A::QuantumObject{ObjType, DimsType, <:AbstractMatrix}) where {ObjType <: Union{Operator, SuperOperator}, DimsType} =
    QuantumObject(to_sparse(exp(A.data)), A.type, A.dimensions)
Base.exp(
    A::QuantumObject{ObjType, DimsType, <:AbstractSparseMatrix},
) where {ObjType <: Union{Operator, SuperOperator}, DimsType} = QuantumObject(_spexp(A.data), A.type, A.dimensions)

function _spexp(A::SparseMatrixCSC{T, M}; threshold = 1.0e-14, nonzero_tol = 1.0e-20) where {T <: Number, M <: Int}
    m = checksquare(A) # Throws exception if not square

    mat_norm = norm(A, Inf)
    mat_norm == 0 && return sparse(T(1) * I, m, m)
    scaling_factor = nextpow(2, mat_norm) # Native routine, faster
    A = A ./ scaling_factor
    delta = 1

    P = spdiagm(0 => ones(T, m))
    next_term = P
    n = 1

    while delta > threshold
        next_term *= A / n
        if nnz(next_term) / length(next_term) > 0.25
            tidyup!(next_term, nonzero_tol)
        end
        delta = norm(next_term, Inf)
        P += next_term
        n += 1
    end
    for n in 1:log2(scaling_factor)
        P = P * P
        if nnz(P) / length(P) > 0.25
            tidyup!(P, nonzero_tol)
        end
    end
    return P
end

@doc raw"""
    sin(A::QuantumObject)

Matrix sine of [`QuantumObject`](@ref), defined as

``\sin \left( \hat{A} \right) = \frac{e^{i \hat{A}} - e^{-i \hat{A}}}{2 i}``

Note that this function only supports for [`Operator`](@ref) and [`SuperOperator`](@ref)
"""
Base.sin(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} =
    (exp(1im * A) - exp(-1im * A)) / 2im

@doc raw"""
    cos(A::QuantumObject)

Matrix cosine of [`QuantumObject`](@ref), defined as

``\cos \left( \hat{A} \right) = \frac{e^{i \hat{A}} + e^{-i \hat{A}}}{2}``

Note that this function only supports for [`Operator`](@ref) and [`SuperOperator`](@ref)
"""
Base.cos(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} = (exp(1im * A) + exp(-1im * A)) / 2

@doc raw"""
    diag(A::QuantumObject, k::Int=0)

Return the `k`-th diagonal elements of a matrix-type [`QuantumObject`](@ref)

Note that this function only supports for [`Operator`](@ref) and [`SuperOperator`](@ref)
"""
LinearAlgebra.diag(A::QuantumObject{ObjType}, k::Int = 0) where {ObjType <: Union{Operator, SuperOperator}} =
    diag(A.data, k)

@doc raw"""
    proj(ψ::QuantumObject)

Return the projector for a [`Ket`](@ref) or [`Bra`](@ref) type of [`QuantumObject`](@ref)
"""
proj(ψ::QuantumObject{Ket}) = ψ * ψ'
proj(ψ::QuantumObject{Bra}) = ψ' * ψ

@doc raw"""
    ptrace(QO::QuantumObject, sel)

[Partial trace](https://en.wikipedia.org/wiki/Partial_trace) of a quantum state `QO` leaving only the dimensions with the indices present in the `sel` vector.

Note that this function will always return [`Operator`](@ref). No matter the input [`QuantumObject`](@ref) is a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).

# Examples

Two qubits in the state ``\ket{\psi} = \ket{e,g}``:
```jldoctest
julia> ψ = kron(fock(2,0), fock(2,1))

Quantum Object:   type=Ket()   dims=([2, 2], [1, 1])   size=(4,)
4-element Vector{ComplexF64}:
 0.0 + 0.0im
 1.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im

julia> ptrace(ψ, 2)

Quantum Object:   type=Operator()   dims=([2], [2])   size=(2, 2)   ishermitian=true
2×2 Matrix{ComplexF64}:
 0.0+0.0im  0.0+0.0im
 0.0+0.0im  1.0+0.0im
```

or in an entangled state ``\ket{\psi} = \frac{1}{\sqrt{2}} \left( \ket{e,e} + \ket{g,g} \right)``:
```jldoctest
julia> ψ = 1 / √2 * (kron(fock(2,0), fock(2,0)) + kron(fock(2,1), fock(2,1)))

Quantum Object:   type=Ket()   dims=([2, 2], [1, 1])   size=(4,)
4-element Vector{ComplexF64}:
 0.7071067811865475 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
 0.7071067811865475 + 0.0im

julia> ptrace(ψ, 1)

Quantum Object:   type=Operator()   dims=([2], [2])   size=(2, 2)   ishermitian=true
2×2 Matrix{ComplexF64}:
 0.5+0.0im  0.0+0.0im
 0.0+0.0im  0.5+0.0im
```
"""
function ptrace(QO::QuantumObject{Ket}, sel::Union{AbstractVector{Int}, Tuple})
    any(s -> s isa EnrSpace, QO.dimensions.to) && throw(ArgumentError("ptrace does not support EnrSpace"))

    _non_static_array_warning("sel", sel)

    if length(sel) == 0 # return full trace for empty sel
        return tr(ket2dm(QO))
    else
        n_d = length(QO.dimensions)

        (any(>(n_d), sel) || any(<(1), sel)) && throw(
            ArgumentError("Invalid indices in `sel`: $(sel), the given QuantumObject only have $(n_d) sub-systems"),
        )
        allunique(sel) || throw(ArgumentError("Duplicate selection indices in `sel`: $(sel)"))
        (n_d == 1) && return ket2dm(QO) # ptrace should always return Operator
    end

    _sort_sel = sort(SVector{length(sel), Int}(sel))
    dims = dimensions_to_dims(QO.dimensions.to)
    ρtr, dkeep = _ptrace_ket(QO.data, dims, _sort_sel)
    return QuantumObject(ρtr, type = Operator(), dims = ProductDimensions(dkeep))
end

ptrace(QO::QuantumObject{Bra}, sel::Union{AbstractVector{Int}, Tuple}) = ptrace(QO', sel)

function ptrace(QO::QuantumObject{Operator}, sel::Union{AbstractVector{Int}, Tuple})
    any(s -> s isa EnrSpace, QO.dimensions.to) && throw(ArgumentError("ptrace does not support EnrSpace"))

    # TODO: support for special cases when some of the subsystems have same `to` and `from` space
    !isendomorphism(QO.dimensions) &&
        throw(ArgumentError("Invalid partial trace for dims = $(_get_dims_string(QO.dimensions))"))

    _non_static_array_warning("sel", sel)

    if length(sel) == 0 # return full trace for empty sel
        return tr(QO)
    else
        n_d = length(QO.dimensions)

        (any(>(n_d), sel) || any(<(1), sel)) && throw(
            ArgumentError("Invalid indices in `sel`: $(sel), the given QuantumObject only have $(n_d) sub-systems"),
        )
        allunique(sel) || throw(ArgumentError("Duplicate selection indices in `sel`: $(sel)"))
        (n_d == 1) && return QO
    end

    dims = dimensions_to_dims(QO.dimensions.to)
    _sort_sel = sort(SVector{length(sel), Int}(sel))
    ρtr, dkeep = _ptrace_oper(QO.data, dims, _sort_sel)
    return QuantumObject(ρtr, type = Operator(), dims = ProductDimensions(dkeep))
end
ptrace(QO::QuantumObject, sel::Int) = ptrace(QO, SVector(sel))

function _ptrace_ket(QO::AbstractArray, dims::Union{SVector, MVector}, sel)
    n_d = length(dims)

    n_d == 1 && return QO, dims

    qtrace = filter(i -> i ∉ sel, 1:n_d)
    dkeep = dims[sel]
    dtrace = dims[qtrace]
    n_t = length(dtrace)

    # Concatenate qtrace and sel without losing the length information
    # Tuple(qtrace..., sel...)
    qtrace_sel = ntuple(Val(n_d)) do i
        if i <= n_t
            @inbounds qtrace[i]
        else
            @inbounds sel[i - n_t]
        end
    end

    vmat = reshape(QO, reverse(dims)...)
    topermute = reverse(n_d + 1 .- qtrace_sel)
    vmat = permutedims(vmat, topermute) # TODO: use PermutedDimsArray when Julia v1.11.0 is released
    vmat = reshape(vmat, prod(dkeep), prod(dtrace))

    return vmat * vmat', dkeep
end

function _ptrace_oper(QO::AbstractArray, dims::Union{SVector, MVector}, sel)
    n_d = length(dims)

    n_d == 1 && return QO, dims

    qtrace = filter(i -> i ∉ sel, 1:n_d)
    dkeep = dims[sel]
    dtrace = dims[qtrace]
    n_k = length(dkeep)
    n_t = length(dtrace)
    _2_n_t = 2 * n_t

    # Concatenate qtrace and sel without losing the length information
    # Tuple(qtrace..., sel...)
    qtrace_sel = ntuple(Val(2 * n_d)) do i
        if i <= n_t
            @inbounds qtrace[i]
        elseif i <= _2_n_t
            @inbounds qtrace[i - n_t] + n_d
        elseif i <= _2_n_t + n_k
            @inbounds sel[i - _2_n_t]
        else
            @inbounds sel[i - _2_n_t - n_k] + n_d
        end
    end

    ρmat = reshape(QO, reverse(vcat(dims, dims))...)
    topermute = reverse(2 * n_d + 1 .- qtrace_sel)
    ρmat = permutedims(ρmat, topermute) # TODO: use PermutedDimsArray when Julia v1.11.0 is released
    ρmat = reshape(ρmat, prod(dkeep), prod(dkeep), prod(dtrace), prod(dtrace))
    res = _map_trace(ρmat)

    return res, dkeep
end

_map_trace(A::AbstractArray{T, 4}) where {T} = map(tr, eachslice(A, dims = (1, 2)))

@doc raw"""
    purity(ρ::QuantumObject)

Calculate the purity of a [`QuantumObject`](@ref): ``\textrm{Tr}(\rho^2)``

Note that this function only supports for [`Ket`](@ref), [`Bra`](@ref), and [`Operator`](@ref)
"""
purity(ρ::QuantumObject{ObjType}) where {ObjType <: Union{Ket, Bra}} = sum(abs2, ρ.data)
purity(ρ::QuantumObject{Operator}) = real(tr(ρ.data^2))

@doc raw"""
    tidyup(A::QuantumObject, tol::Real=settings.tidyup_tol)

Given a [`QuantumObject`](@ref) `A`, check the real and imaginary parts of each element separately. Remove the real or imaginary value if its absolute value is less than `tol`.
"""
tidyup(A::QuantumObject, tol::T = settings.tidyup_tol) where {T <: Real} =
    QuantumObject(tidyup(A.data, tol), A.type, A.dimensions)
tidyup(A::AbstractArray, tol::T2 = settings.tidyup_tol) where {T2 <: Real} = tidyup!(copy(A), tol)

@doc raw"""
    tidyup!(A::QuantumObject, tol::Real=settings.tidyup_tol)

Given a [`QuantumObject`](@ref) `A`, check the real and imaginary parts of each element separately. Remove the real or imaginary value if its absolute value is less than `tol`.

Note that this function is an in-place version of [`tidyup`](@ref).
"""
tidyup!(A::QuantumObject, tol::T = settings.tidyup_tol) where {T <: Real} = (tidyup!(A.data, tol); A)
function tidyup!(A::AbstractSparseArray, tol::T2 = settings.tidyup_tol) where {T2 <: Real}
    tidyup!(nonzeros(A), tol) # tidyup A.nzval in-place (also support for CUDA sparse arrays)
    return dropzeros!(A)
end
tidyup!(A::AbstractArray{T}, tol::T2 = settings.tidyup_tol) where {T <: Real, T2 <: Real} = @. A = T(abs(A) > tol) * A
tidyup!(A::AbstractArray{T}, tol::T2 = settings.tidyup_tol) where {T, T2 <: Real} =
    @. A = T(abs(real(A)) > tol) * real(A) + 1im * T(abs(imag(A)) > tol) * imag(A)

@doc raw"""
    get_data(A::AbstractQuantumObject)

Returns the data of a [`AbstractQuantumObject`](@ref).
"""
get_data(A::AbstractQuantumObject) = getfield(A, :data)

@doc raw"""
    get_coherence(ψ::QuantumObject)

Get the coherence value ``\alpha`` by measuring the expectation value of the destruction operator ``\hat{a}`` on a state ``\ket{\psi}`` or a density matrix ``\hat{\rho}``.

It returns both ``\alpha`` and the corresponding state with the coherence removed: ``\ket{\delta_\alpha} = \exp ( \alpha^* \hat{a} - \alpha \hat{a}^\dagger ) \ket{\psi}`` for a pure state, and ``\hat{\rho_\alpha} = \exp ( \alpha^* \hat{a} - \alpha \hat{a}^\dagger ) \hat{\rho} \exp ( -\bar{\alpha} \hat{a} + \alpha \hat{a}^\dagger )`` for a density matrix. These states correspond to the quantum fluctuations around the coherent state ``\ket{\alpha}`` or ``|\alpha\rangle\langle\alpha|``.
"""
function get_coherence(ψ::QuantumObject{Ket})
    a = destroy(get_hilbert_size(ψ.dimensions)[1])
    α = expect(a, ψ)
    D = exp(α * a' - conj(α) * a)

    return α, D' * ψ
end

function get_coherence(ρ::QuantumObject{Operator})
    a = destroy(get_hilbert_size(ρ.dimensions)[1])
    α = expect(a, ρ)
    D = exp(α * a' - conj(α) * a)

    return α, D' * ρ * D
end

@doc raw"""
    permute(A::QuantumObject, order::Union{AbstractVector{Int},Tuple})

Permute the tensor structure of a [`QuantumObject`](@ref) `A` according to the specified `order` list

Note that this method currently works for [`Ket`](@ref), [`Bra`](@ref), and [`Operator`](@ref) types of [`QuantumObject`](@ref).

# Examples

If `order = [2, 1, 3]`, the Hilbert space structure will be re-arranged: ``\mathcal{H}_1 \otimes \mathcal{H}_2 \otimes \mathcal{H}_3 \rightarrow \mathcal{H}_2 \otimes \mathcal{H}_1 \otimes \mathcal{H}_3``.

```jldoctest
julia> ψ1 = fock(2, 0);

julia> ψ2 = fock(3, 1);

julia> ψ3 = fock(4, 2);

julia> ψ_123 = tensor(ψ1, ψ2, ψ3);

julia> permute(ψ_123, (2, 1, 3)) ≈ tensor(ψ2, ψ1, ψ3)
true
```

!!! warning "Beware of type-stability!"
    It is highly recommended to use `permute(A, order)` with `order` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function SparseArrays.permute(
        A::QuantumObject{ObjType},
        order::Union{AbstractVector{Int}, Tuple},
    ) where {ObjType <: Union{Ket, Bra, Operator}}
    any(s -> s isa EnrSpace, A.dimensions.to) && throw(ArgumentError("permute does not support EnrSpace"))

    (length(order) != length(A.dimensions)) &&
        throw(ArgumentError("The order list must have the same length as the number of subsystems (A.dims)"))

    !isperm(order) && throw(ArgumentError("$(order) is not a valid permutation of the subsystems (A.dims)"))

    _non_static_array_warning("order", order)

    order_svector = SVector{length(order), Int}(order) # convert it to SVector for performance

    # obtain the arguments: dims for reshape; perm for PermutedDimsArray
    dims, perm = _dims_and_perm(A.type, A.dimensions, order_svector, length(order_svector))

    order_dimensions = _order_dimensions(A.type, A.dimensions, order_svector)

    return QuantumObject(reshape(permutedims(reshape(A.data, dims...), Tuple(perm)), size(A)), A.type, order_dimensions)
end

_dims_and_perm(::Ket, dimensions::ProductDimensions, order::AbstractVector{Int}, L::Int) =
    reverse(dimensions_to_dims(dimensions.to)), reverse((L + 1) .- order)

_dims_and_perm(::Bra, dimensions::ProductDimensions, order::AbstractVector{Int}, L::Int) =
    reverse(dimensions_to_dims(dimensions.from)), reverse((L + 1) .- order)

_dims_and_perm(::Operator, dimensions::ProductDimensions, order::AbstractVector{Int}, L::Int) =
    reverse(vcat(dimensions_to_dims(dimensions.from), dimensions_to_dims(dimensions.to))), reverse((2 * L + 1) .- vcat(order, order .+ L))

_order_dimensions(::Ket, dimensions::ProductDimensions, order::AbstractVector{Int}) =
    ProductDimensions(dimensions.to[order], dimensions.from)  # from is one-list, keep as is
_order_dimensions(::Bra, dimensions::ProductDimensions, order::AbstractVector{Int}) =
    ProductDimensions(dimensions.to, dimensions.from[order])  # to is one-list, keep as is
_order_dimensions(::Operator, dimensions::ProductDimensions, order::AbstractVector{Int}) =
    ProductDimensions(dimensions.to[order], dimensions.from[order])

@testitem "Propagator (by solvers)" begin
    ϵ0 = 1.0 * 2π
    Ω = 0.8 * 2π
    H = (ϵ0 / 2) * sigmaz() + (Ω / 2) * sigmax()
    L = liouvillian(H)
    ψ0 = basis(2, 0)
    ρ0 = mat2vec(ket2dm(ψ0))

    Δt = π / 5
    tlist = 0:Δt:(2π)
    ψt = sesolve(H, ψ0, tlist; progress_bar = Val(false)).states[2:end] # ignore the initial state
    ρt = mesolve(H, ρ0, tlist; progress_bar = Val(false)).states[2:end] # ignore the initial state
    U_se = sesolve(H, qeye_like(H), [0, Δt]; progress_bar = Val(false)).states[end]
    U_me = mesolve(L, qeye_like(L), [0, Δt]; progress_bar = Val(false)).states[end]

    for n in 1:(length(tlist) - 1)
        @test isapprox(U_se^n * ψ0, ψt[n]; atol = 1.0e-5)
        @test isapprox(U_me^n * ρ0, ρt[n]; atol = 1.0e-5)
    end
end

using QuantumToolbox
# CarioMakie is imported in the following script

QuantumToolbox.about()

@testset "Makie Extension" verbose = true begin
    ψ = normalize(coherent(50, 5.0) + coherent(50, -5.0))
    xvec = yvec = -15.0:0.1:15.0
    wig = transpose(wigner(ψ, xvec, yvec))

    a = tensor(destroy(5), qeye(2))
    σm = tensor(qeye(5), destroy(2))
    sx = tensor(qeye(5), sigmax())
    H = a' * a + sx - 0.5 * (a * σm' + a' * σm)
    L = liouvillian(H)

    # Makie unload errors
    @test_throws ArgumentError plot_wigner(ψ; library = :Makie, xvec = xvec, yvec = yvec)
    @test_throws ArgumentError plot_fock_distribution(ψ; library = :Makie)
    @test_throws ArgumentError plot_bloch(ψ; library = :Makie)
    @test_throws ArgumentError matrix_heatmap(H; library = :Makie)
    @test_throws ArgumentError matrix_histogram(H; library = :Makie)

    using Makie

    #############################################
    # plot_wigner
    fig, ax, hm =
        plot_wigner(ψ; library = Val(:Makie), xvec = xvec, yvec = yvec, projection = Val(:two_dim), colorbar = true)
    @test fig isa Figure
    @test ax isa Axis
    @test hm isa Heatmap
    @test all(isapprox.(hm[3].value.x, wig, atol = 1.0e-6))

    fig, ax, surf =
        plot_wigner(ψ; library = Val(:Makie), xvec = xvec, yvec = yvec, projection = Val(:three_dim), colorbar = true)
    @test fig isa Figure
    @test ax isa Axis3
    @test surf isa Surface
    @test all(isapprox.(surf[3].value.x, wig, atol = 1.0e-6))

    fig = Figure()
    pos = fig[2, 3]
    fig1, ax, hm = plot_wigner(
        ψ;
        library = Val(:Makie),
        xvec = xvec,
        yvec = yvec,
        projection = Val(:two_dim),
        colorbar = true,
        location = pos,
    )
    @test fig1 === fig
    @test fig[2, 3].layout.content[1].content[1, 1].layout.content[1].content === ax

    fig = Figure()
    pos = fig[2, 3]
    fig1, ax, surf = plot_wigner(
        ψ;
        library = Val(:Makie),
        xvec = xvec,
        yvec = yvec,
        projection = Val(:three_dim),
        colorbar = true,
        location = pos,
    )
    @test fig1 === fig
    @test fig[2, 3].layout.content[1].content[1, 1].layout.content[1].content === ax

    #############################################
    # plot_fock_distribution
    fig = Figure()
    pos = fig[2, 3]
    fig1, ax = plot_fock_distribution(ψ; library = Val(:Makie), location = pos)
    @test fig1 === fig
    @test fig[2, 3].layout.content[1].content[1, 1].layout.content[1].content === ax

    fig = Figure()
    pos = fig[2, 3]
    fig1, ax = @test_logs (:warn,) plot_fock_distribution(ψ * 2; library = Val(:Makie), location = pos)

    #############################################
    # matrix_heatmap and matrix_histogram
    for op in (H, L)
        for method in (Val(:real), Val(:imag), Val(:abs), Val(:angle))
            fig, ax, hm = matrix_heatmap(op; method = method)
            @test fig isa Figure
            @test ax isa Axis
            @test hm isa Heatmap

            fig, ax, ms = matrix_histogram(op; method = method)
            @test fig isa Figure
            @test ax isa Axis3
            @test ms isa MeshScatter
        end
    end
    @test_throws ArgumentError matrix_heatmap(H; method = Val(:wrong))
    @test_throws ArgumentError matrix_histogram(H; method = Val(:wrong))

    fig = Figure()
    pos = fig[2, 3]
    fig1, ax = matrix_heatmap(H; library = Val(:Makie), location = pos)
    @test fig1 === fig
    @test fig[2, 3].layout.content[1].content[1, 1].layout.content[1].content === ax

    fig = Figure()
    pos = fig[2, 3]
    fig1, ax = matrix_histogram(H; library = Val(:Makie), location = pos)
    @test fig1 === fig
    @test fig[2, 3].layout.content[1].content[1, 1].layout.content[1].content === ax
end

@testset "Makie Bloch sphere" begin
    ρ = 0.7 * ket2dm(basis(2, 0)) + 0.3 * ket2dm(basis(2, 1))
    fig, lscene = plot_bloch(ρ)
    @test fig isa Figure
    @test lscene isa LScene

    ψ = (basis(2, 0) + basis(2, 1)) / √2
    fig, lscene = plot_bloch(ψ)
    @test fig isa Figure
    @test lscene isa LScene

    ϕ = dag(ψ)
    fig, lscene = plot_bloch(ϕ)
    @test fig isa Figure
    @test lscene isa LScene

    fig = Figure()
    ax = Axis(fig[1, 1])
    pos = fig[1, 2]
    fig1, lscene = plot_bloch(ψ; location = pos)
    @test fig1 === fig

    b = Bloch()
    add_points!(b, [0.0, 0.0, 1.0])
    @test length(b.points) == 1
    @test b.points[1] ≈ [0.0, 0.0, 1.0]

    pts = [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0]]
    add_points!(b, hcat(pts...))
    @test length(b.points) == 2
    @test b.points[2] ≈ hcat(pts...)
    @test_throws ArgumentError add_points!(b, [1 2 3 4])
    @test_throws ArgumentError add_points!(b, pts; meth = :wrong)

    b = Bloch()
    add_vectors!(b, [1.0, 1.0, 0.0])
    @test length(b.vectors) == 1
    @test isapprox(norm(b.vectors[1]), √2)

    vecs = [[0.0, 0.0, 1.0], [1.0, 0.0, 0.0]]
    add_vectors!(b, vecs)
    @test length(b.vectors) == 3
    @test isapprox(norm(b.vectors[2]), 1.0)
    @test isapprox(norm(b.vectors[3]), 1.0)

    vec_correct = [1, 0, 0]
    vec_wrong = [1, 0]
    b = Bloch()
    add_line!(b, [0, 0, 0], [1, 0, 0])
    @test length(b.lines) == 1
    @test b.lines[1][1][3] ≈ [0.0, 0.0]
    @test_throws ArgumentError add_line!(b, vec_wrong, vec_correct)
    @test_throws ArgumentError add_line!(b, vec_correct, vec_wrong)

    add_arc!(b, [0, 0, 1], [0, 1, 0], [1, 0, 0])
    @test length(b.arcs) == 1
    @test b.arcs[1][3] == [1.0, 0.0, 0.0]
    @test_throws ArgumentError add_arc!(b, vec_wrong, vec_correct)
    @test_throws ArgumentError add_arc!(b, vec_correct, vec_wrong)
    @test_throws ArgumentError add_arc!(b, vec_wrong, vec_correct, vec_correct)
    @test_throws ArgumentError add_arc!(b, vec_correct, vec_wrong, vec_correct)
    @test_throws ArgumentError add_arc!(b, vec_correct, vec_correct, vec_wrong)

    b = Bloch()
    add_points!(b, [0.0, 0.0, 1.0])
    add_vectors!(b, [1.0, 0.0, 0.0])
    add_line!(b, [0, 0, 0], [1, 0, 0])
    add_arc!(b, [0, 1, 0], [0, 0, 1], [1, 0, 0])
    clear!(b)
    @test isempty(b.points)
    @test isempty(b.vectors)
    @test isempty(b.lines)
    @test isempty(b.arcs)

    b = Bloch()
    add_points!(b, hcat([1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]))
    add_vectors!(b, [[1, 1, 0], [0, 1, 1]])
    add_line!(b, [0, 0, 0], [1, 1, 1])
    add_arc!(b, [1, 0, 0], [0, 1, 0], [0, 0, 1])
    try
        fig, lscene = render(b)
        @test !isnothing(fig)
        @test !isnothing(lscene)
    catch e
        @test false
        @info "Render threw unexpected error" exception = e
    end

    b = Bloch()
    ψ₁ = normalize(basis(2, 0) + basis(2, 1))
    ψ₂ = normalize(basis(2, 0) - im * basis(2, 1))
    add_line!(b, ψ₁, ψ₂; fmt = "r--")
    try
        fig, lscene = render(b)
        @test !isnothing(fig)
        @test !isnothing(lscene)
    catch e
        @test false
        @info "Render threw unexpected error" exception = e
    end

    # test `state to Bloch vector` conversion and `add_states!` function
    b = Bloch()
    Pauli_Ops = [sigmax(), sigmay(), sigmaz()]
    ψ = rand_ket(2)
    ρ = rand_dm(2)
    states = [ψ, ρ]
    x = basis(2, 0) + basis(2, 1)             # unnormalized Ket
    ρ1 = 0.3 * rand_dm(2) + 0.4 * rand_dm(2)  # unnormalized density operator
    ρ2 = Qobj(rand(ComplexF64, 2, 2))         # unnormalized and non-Hermitian Operator
    add_states!(b, states, kind = :vector)
    add_states!(b, states, kind = :point)
    @test length(b.vectors) == 2
    @test length(b.points) == 1
    @test all(expect(Pauli_Ops, ψ) .≈ (b.vectors[1]))
    @test all(expect(Pauli_Ops, ρ) .≈ (b.vectors[2]))
    @test all([b.vectors[j][k] ≈ b.points[1][k, j] for j in (1, 2) for k in (1, 2, 3)])
    @test_logs (:warn,) (:warn,) (:warn,) (:warn,) add_states!(b, [x, ρ1, ρ2])
    @test length(b.vectors) == 5
    @test_throws ArgumentError add_states!(b, states, kind = :wrong)

    th = range(0, 2π; length = 20)
    xp = cos.(th)
    yp = sin.(th)
    zp = zeros(20)
    pnts = [xp, yp, zp]
    pnts = Matrix(hcat(xp, yp, zp)')
    add_points!(b, pnts)
    vec = [[1, 0, 0], [0, 1, 0], [0, 0, 1]]
    add_vectors!(b, vec)
    add_line!(b, [1, 0, 0], [0, 1, 0])
    add_arc!(b, [1, 0, 0], [0, 1, 0], [0, 0, 1])
    try
        fig, lscene = render(b)
        @test !isnothing(fig)
        @test !isnothing(lscene)
    catch e
        @test false
        @info "Render threw unexpected error" exception = e
    end

    b = Bloch()
    ψ₁ = normalize(basis(2, 0) + basis(2, 1))
    ψ₂ = normalize(basis(2, 0) - im * basis(2, 1))
    ψ₃ = basis(2, 0)
    add_line!(b, ψ₁, ψ₂; fmt = "r--")
    add_arc!(b, ψ₁, ψ₂)
    add_arc!(b, ψ₂, ψ₃, ψ₁)
    add_states!(b, [ψ₂, ψ₃], kind = :point, meth = :l)
    try
        fig, lscene = render(b)
        @test !isnothing(fig)
        @test !isnothing(lscene)
    catch e
        @test false
        @info "Render threw unexpected error" exception = e
    end

    # if render location is given as lscene, should return the same Figure and LScene
    b = Bloch()
    fig1, lscene1 = render(b)
    add_states!(b, ψ₁)
    fig2, lscene2 = render(b, location = lscene1)
    @test fig2 === fig1
    @test lscene2 === lscene1
end

export sesolveProblem, sesolve, sesolve_map

_sesolve_make_U_QobjEvo(H) = -1im * QuantumObjectEvolution(H, type = Operator())

function _gen_sesolve_solution(sol, prob::TimeEvolutionProblem{ST}) where {ST <: Union{Ket, Operator}}
    ψt = map(ϕ -> QuantumObject(ϕ, type = prob.states_type, dims = prob.dimensions.to), sol.u)

    kwargs = NamedTuple(sol.prob.kwargs) # Convert to NamedTuple for Zygote.jl compatibility

    return TimeEvolutionSol(
        prob.times,
        sol.t,
        ψt,
        _get_expvals(sol, SaveFuncSESolve),
        sol.retcode,
        sol.alg,
        kwargs.abstol,
        kwargs.reltol,
    )
end

@doc raw"""
    sesolveProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        progress_bar::Union{Val,Bool} = Val(true),
        inplace::Union{Val,Bool} = Val(true),
        kwargs...,
    )

Generate the ODEProblem for the Schrödinger time evolution of a quantum system:

```math
\frac{\partial}{\partial t} |\psi(t)\rangle = -i \hat{H} |\psi(t)\rangle
```

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``. It can be either a [`Ket`](@ref) or a [`Operator`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: Parameters to pass to the solver. This argument is usually expressed as a `NamedTuple` or `AbstractVector` of parameters. For more advanced usage, any custom struct can be used.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `inplace`: Whether to use the inplace version of the ODEProblem. The default is `Val(true)`. It is recommended to use `Val(true)` for better performance, but it is sometimes necessary to use `Val(false)`, for example when performing automatic differentiation using [Zygote.jl](https://github.com/FluxML/Zygote.jl).
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The initial state `ψ0` can also be [`Operator`](@ref). This is useful for simulating many states simultaneously or calculating propagator. For example, `ψ0` can be given as `qeye_like(H)` (an identity [`Operator`](@ref) matrix).
- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-6` and `abstol=1e-8`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

# Returns

- `prob`: The [`TimeEvolutionProblem`](@ref) containing the `ODEProblem` for the Schrödinger time evolution of the system.
"""
function sesolveProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{ST},
        tlist::AbstractVector;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        progress_bar::Union{Val, Bool} = Val(true),
        inplace::Union{Val, Bool} = Val(true),
        kwargs...,
    ) where {ST <: Union{Ket, Operator}}
    haskey(kwargs, :save_idxs) &&
        throw(ArgumentError("The keyword argument \"save_idxs\" is not supported in QuantumToolbox."))

    states_type = ψ0.type

    H_evo = _sesolve_make_U_QobjEvo(H) # Multiply by -i
    isoper(H_evo) || throw(ArgumentError("The Hamiltonian must be an Operator."))

    check_mul_dimensions(H_evo, ψ0)

    T = _complex_float_type(Base.promote_eltype(H_evo, ψ0))
    ψ0_vec = to_dense(T, get_data(ψ0)) # Convert it to dense vector with complex element type
    U = cache_operator(H_evo.data, ψ0_vec)

    tlist = _check_tlist(tlist, _float_type(T))

    kwargs2 = _merge_saveat(tlist, e_ops, default_ode_solver_options(T); kwargs...)
    kwargs3 = _merge_tstops(kwargs2, isconstant(U), tlist)
    kwargs4 = _generate_se_me_kwargs(e_ops, makeVal(progress_bar), tlist, kwargs3, SaveFuncSESolve)

    tspan = (tlist[1], tlist[end])

    prob = ODEProblem{getVal(inplace), FullSpecialize}(U, ψ0_vec, tspan, params; kwargs4...)

    return TimeEvolutionProblem(prob, tlist, states_type, H_evo.dimensions)
end

@doc raw"""
    sesolve(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector;
        alg::AbstractODEAlgorithm = Vern7(lazy=false),
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        progress_bar::Union{Val,Bool} = Val(true),
        inplace::Union{Val,Bool} = Val(true),
        kwargs...,
    )

Time evolution of a closed quantum system using the Schrödinger equation:

```math
\frac{\partial}{\partial t} |\psi(t)\rangle = -i \hat{H} |\psi(t)\rangle
```

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``. It can be either a [`Ket`](@ref) or a [`Operator`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `alg`: The algorithm for the ODE solver. The default is `Vern7(lazy=false)`.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: Parameters to pass to the solver. This argument is usually expressed as a `NamedTuple` or `AbstractVector` of parameters. For more advanced usage, any custom struct can be used.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `inplace`: Whether to use the inplace version of the ODEProblem. The default is `Val(true)`. It is recommended to use `Val(true)` for better performance, but it is sometimes necessary to use `Val(false)`, for example when performing automatic differentiation using [Zygote.jl](https://github.com/FluxML/Zygote.jl).
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The initial state `ψ0` can also be [`Operator`](@ref). This is useful for simulating many states simultaneously or calculating propagator. For example, `ψ0` can be given as `qeye_like(H)` (an identity [`Operator`](@ref) matrix).
- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-6` and `abstol=1e-8`.
- For more details about `alg` please refer to [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/)
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

# Returns

- `sol::TimeEvolutionSol`: The solution of the time evolution. See also [`TimeEvolutionSol`](@ref)
"""
function sesolve(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{ST},
        tlist::AbstractVector;
        alg::AbstractODEAlgorithm = Vern7(lazy = false),
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        progress_bar::Union{Val, Bool} = Val(true),
        inplace::Union{Val, Bool} = Val(true),
        kwargs...,
    ) where {ST <: Union{Ket, Operator}}

    # Move sensealg argument to solve for Enzyme.jl support.
    # TODO: Remove it when https://github.com/SciML/SciMLSensitivity.jl/issues/1225 is fixed.
    sensealg = get(kwargs, :sensealg, nothing)
    kwargs_filtered = isnothing(sensealg) ? kwargs : Base.structdiff((; kwargs...), (sensealg = sensealg,))

    prob = sesolveProblem(
        H,
        ψ0,
        tlist;
        e_ops = e_ops,
        params = params,
        progress_bar = progress_bar,
        inplace = inplace,
        kwargs_filtered...,
    )

    # TODO: Remove it when https://github.com/SciML/SciMLSensitivity.jl/issues/1225 is fixed.
    if isnothing(sensealg)
        return sesolve(prob, alg)
    else
        return sesolve(prob, alg; sensealg = sensealg)
    end
end

function sesolve(prob::TimeEvolutionProblem, alg::AbstractODEAlgorithm = Vern7(lazy = false); kwargs...)
    sol = solve(prob.prob, alg; kwargs...)

    return _gen_sesolve_solution(sol, prob)
end

@doc raw"""
    sesolve_map(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::Union{QuantumObject{Ket},AbstractVector{<:QuantumObject{Ket}}},
        tlist::AbstractVector;
        alg::AbstractODEAlgorithm = Vern7(lazy=false),
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params::Union{NullParameters,Tuple} = NullParameters(),
        progress_bar::Union{Val,Bool} = Val(true),
        kwargs...,
    )

Solve the Schrödinger equation for multiple initial states and parameter sets using ensemble simulation.

This function computes the time evolution for all combinations (Cartesian product) of initial states and parameter sets, solving the Schrödinger equation (see [`sesolve`](@ref)):

```math
\frac{\partial}{\partial t} |\psi(t)\rangle = -i \hat{H} |\psi(t)\rangle
```

for each combination in the ensemble.

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state(s) of the system. Can be a single [`QuantumObject`](@ref) or a `Vector` of initial states. It can be either a [`Ket`](@ref) or [`Operator`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `alg`: The algorithm for the ODE solver. The default is `Vern7(lazy=false)`.
- `ensemblealg`: Ensemble algorithm to use for parallel computation. Default is `EnsembleThreads()`.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: A `Tuple` of parameter sets. Each element should be an `AbstractVector` representing the sweep range for that parameter. The function will solve for all combinations of initial states and parameter sets.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The initial state `ψ0` can also be [`Operator`](@ref). This is useful for simulating many states simultaneously or calculating propagator. For example, `ψ0` can be given as `qeye_like(H)` (an identity [`Operator`](@ref) matrix).
- The function returns an array of solutions with dimensions matching the Cartesian product of initial states and parameter sets.
- If `ψ0` is a vector of `m` states and `params = (p1, p2, ...)` where `p1` has length `n1`, `p2` has length `n2`, etc., the output will be of size `(m, n1, n2, ...)`.
- See [`sesolve`](@ref) for more details.

# Returns

- An array of [`TimeEvolutionSol`](@ref) objects with dimensions `(length(ψ0), length(params[1]), length(params[2]), ...)`.
"""
function sesolve_map(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::AbstractVector{<:QuantumObject{ST}},
        tlist::AbstractVector;
        alg::AbstractODEAlgorithm = Vern7(lazy = false),
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params::Union{NullParameters, Tuple} = NullParameters(),
        progress_bar::Union{Val, Bool} = Val(true),
        kwargs...,
    ) where {ST <: Union{Ket, Operator}}
    # mapping initial states and parameters

    ψ0 = map(to_dense, ψ0) # Convert all initial states to dense vectors

    ψ0_iter = map(state -> to_dense(_complex_float_type(eltype(state)), copy(state.data)), ψ0)
    if params isa NullParameters
        iter = collect(Iterators.product(ψ0_iter, [params])) |> vec # convert nx1 Matrix into Vector
    else
        iter = collect(Iterators.product(ψ0_iter, params...))
    end

    # we disable the progress bar of the sesolveProblem because we use a global progress bar for all the trajectories
    prob = sesolveProblem(
        H,
        first(ψ0),
        tlist;
        e_ops = e_ops,
        params = first(iter)[2:end],
        progress_bar = Val(false),
        kwargs...,
    )

    return sesolve_map(prob, iter, alg, ensemblealg; progress_bar = progress_bar)
end
sesolve_map(
    H::Union{AbstractQuantumObject{Operator}, Tuple},
    ψ0::QuantumObject{ST},
    tlist::AbstractVector;
    kwargs...,
) where {ST <: Union{Ket, Operator}} = sesolve_map(H, [ψ0], tlist; kwargs...)

# this method is for advanced usage
# User can define their own iterator structure, prob_func and output_func
#   - `prob_func`: Function to use for generating the ODEProblem.
#   - `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
#
# Return: An array of TimeEvolutionSol objects with the size same as the given iter.
function sesolve_map(
        prob::TimeEvolutionProblem{ST, <:AbstractDimensions, <:ODEProblem},
        iter::AbstractArray,
        alg::AbstractODEAlgorithm = Vern7(lazy = false),
        ensemblealg::EnsembleAlgorithm = EnsembleThreads();
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        progress_bar::Union{Val, Bool} = Val(true),
    ) where {ST <: Union{Ket, Operator}}
    # generate ensemble problem
    ntraj = length(iter)
    _prob_func = isnothing(prob_func) ? (prob, i, repeat) -> _se_me_map_prob_func(prob, i, repeat, iter) : prob_func
    _output_func =
        isnothing(output_func) ?
        _ensemble_dispatch_output_func(
            ensemblealg,
            progress_bar,
            ntraj,
            _standard_output_func;
            progr_desc = "[sesolve_map] ",
        ) : output_func
    ens_prob = TimeEvolutionProblem(
        EnsembleProblem(prob.prob, prob_func = _prob_func, output_func = _output_func[1], safetycopy = false),
        prob.times,
        prob.states_type,
        prob.dimensions,
        (progr = _output_func[2], channel = _output_func[3]),
    )

    sol = _ensemble_dispatch_solve(ens_prob, alg, ensemblealg, ntraj)

    # handle solution and make it become an Array of TimeEvolutionSol
    sol_vec = [_gen_sesolve_solution(sol[:, i], prob) for i in eachindex(sol)] # map is type unstable
    return reshape(sol_vec, size(iter))
end

#=
This file defines the Hilbert space structure.
=#

export AbstractSpace, HilbertSpace

@doc raw"""
    abstract type AbstractSpace

Abstract type for all Hilbert and Liouville space structures.
"""
abstract type AbstractSpace end

@doc raw"""
    struct HilbertSpace <: AbstractSpace
        size::Int
    end

A structure that describes a single Hilbert space with size = `size`.
"""
struct HilbertSpace <: AbstractSpace
    size::Int

    function HilbertSpace(size::Int)
        (size < 1) && throw(DomainError(size, "The size of `HilbertSpace` must be positive integer (≥ 1)."))
        return new(size)
    end
end

Base.length(s::HilbertSpace) = 1

dimensions_to_dims(s::HilbertSpace) = SVector{1, Int}(s.size)

get_hilbert_size(s::HilbertSpace) = s.size
get_liouville_size(s::HilbertSpace) = s.size^2

# this creates a list of HilbertSpace(1), it is used to generate `from` for Ket, and `to` for Bra
hilbertspace_one_list(dimensions::NTuple{N, AbstractSpace}) where {N} =
    ntuple(i -> HilbertSpace(1), Val(sum(length, dimensions)))

@testitem "Dynamical Shifted Fock" begin
    F = 3
    Δ = 0.25
    κ = 1
    U = 0.01

    tlist = LinRange(0, 25, 300)

    # Single cavity case
    N0 = 100
    a0 = destroy(N0)
    H0 = Δ * a0' * a0 + F * (a0 + a0') + U * a0'^2 * a0^2
    c_ops0 = [√(κ) * a0]

    α0 = 1.5
    ρ0 = coherent(N0, α0)
    sol0 = mesolve(H0, ρ0, tlist, c_ops0, e_ops = [a0' * a0, a0], progress_bar = Val(false))

    N = 5
    a = destroy(N)
    function H_dsf(op_list, p)
        Δ = p.Δ
        F = p.F
        U = p.U
        a = op_list[1]
        return Δ * a' * a + F * (a + a') + U * a'^2 * a^2
    end
    function c_ops_dsf(op_list, p)
        κ = p.κ
        a = op_list[1]
        return [√κ * a]
    end
    function e_ops_dsf(op_list, p)
        a = op_list[1]
        return [a' * a, a]
    end
    op_list = [a]
    ψ0 = fock(N, 0)
    α0_l = [α0]
    dsf_params = (Δ = Δ, F = F, κ = κ, U = U)

    sol_dsf_me = dsf_mesolve(
        H_dsf,
        ψ0,
        tlist,
        c_ops_dsf,
        op_list,
        α0_l,
        dsf_params,
        e_ops = e_ops_dsf,
        progress_bar = Val(false),
    )
    sol_dsf_mc = dsf_mcsolve(
        H_dsf,
        ψ0,
        tlist,
        c_ops_dsf,
        op_list,
        α0_l,
        dsf_params,
        e_ops = e_ops_dsf,
        progress_bar = Val(false),
    )
    val_ss = abs2(sol0.expect[1, end])
    @test sum(abs2.(sol0.expect[1, :] .- sol_dsf_me.expect[1, :])) / (val_ss * length(tlist)) < 0.1
    @test sum(abs2.(sol0.expect[1, :] .- sol_dsf_mc.expect[1, :])) / (val_ss * length(tlist)) < 0.1

    # Two cavities case
    F = 2
    Δ = 0.25
    κ = 1
    U = 0.01
    J = 0.5
    tlist = LinRange(0, 15, 300)

    N0 = 20
    a10 = kron(destroy(N0), qeye(N0))
    a20 = kron(qeye(N0), destroy(N0))
    H0 =
        Δ * a10' * a10 +
        Δ * a20' * a20 +
        U * a10'^2 * a10^2 +
        U * a20'^2 * a20^2 +
        F * (a10 + a10') +
        J * (a10' * a20 + a10 * a20')
    c_ops0 = [√κ * a10, √κ * a20]

    ρ0 = kron(coherent(N0, α0), coherent(N0, α0))
    sol0 = mesolve(H0, ρ0, tlist, c_ops0, e_ops = [a10' * a10, a20' * a20], progress_bar = Val(false))

    N = 5
    a1 = kron(destroy(N), qeye(N))
    a2 = kron(qeye(N), destroy(N))
    function H_dsf2(op_list, p)
        Δ = p.Δ
        F = p.F
        U = p.U
        J = p.J
        a1, a2 = op_list
        return Δ * a1' * a1 +
            Δ * a2' * a2 +
            U * a1'^2 * a1^2 +
            U * a2'^2 * a2^2 +
            F * (a1 + a1') +
            J * (a1' * a2 + a1 * a2')
    end
    function c_ops_dsf2(op_list, p)
        κ = p.κ
        a1, a2 = op_list
        return [√κ * a1, √κ * a2]
    end
    function e_ops_dsf2(op_list, p)
        a1, a2 = op_list
        return [a1' * a1, a2' * a2]
    end
    op_list = [a1, a2]
    ψ0 = kron(fock(N, 0), fock(N, 0))
    α0_l = [α0, α0]
    dsf_params = (Δ = Δ, F = F, κ = κ, U = U, J = J)

    sol_dsf_me = dsf_mesolve(
        H_dsf2,
        ψ0,
        tlist,
        c_ops_dsf2,
        op_list,
        α0_l,
        dsf_params,
        e_ops = e_ops_dsf2,
        progress_bar = Val(false),
    )
    sol_dsf_mc = dsf_mcsolve(
        H_dsf2,
        ψ0,
        tlist,
        c_ops_dsf2,
        op_list,
        α0_l,
        dsf_params,
        e_ops = e_ops_dsf2,
        progress_bar = Val(false),
    )

    val_ss = abs2(sol0.expect[1, end])
    @test sum(abs2.(sol0.expect[1, :] .- sol_dsf_me.expect[1, :])) / (val_ss * length(tlist)) < 0.6
    @test sum(abs2.(sol0.expect[1, :] .- sol_dsf_mc.expect[1, :])) / (val_ss * length(tlist)) < 0.6
    @test sum(abs2.(sol0.expect[2, :] .- sol_dsf_me.expect[2, :])) / (val_ss * length(tlist)) < 0.6
    @test sum(abs2.(sol0.expect[2, :] .- sol_dsf_mc.expect[2, :])) / (val_ss * length(tlist)) < 0.6
end

module QuantumToolbox

## Standard Julia libraries
using LinearAlgebra
using SparseArrays

import Base: AbstractVecOrTuple
import Distributed: RemoteChannel
import LinearAlgebra: checksquare
import Pkg
import Random: AbstractRNG, default_rng, seed!
import Statistics: mean, std

## SciML packages (for QobjEvo, OrdinaryDiffEq, and LinearSolve)
import SciMLBase:
    solve,
    solve!,
    init,
    reinit!,
    remake,
    u_modified!,
    NullParameters,
    LinearProblem,
    ODEFunction,
    SDEFunction,
    ODEProblem,
    SDEProblem,
    EnsembleProblem,
    EnsembleAlgorithm,
    EnsembleSerial,
    EnsembleThreads,
    EnsembleSplitThreads,
    EnsembleDistributed,
    FullSpecialize,
    CallbackSet,
    ContinuousCallback,
    DiscreteCallback,
    AbstractSciMLProblem,
    AbstractODEIntegrator,
    AbstractODEAlgorithm,
    AbstractODESolution,
    AbstractSDEAlgorithm
import StochasticDiffEqHighOrder: SRA2, SRIW1
import SciMLOperators:
    cache_operator,
    iscached,
    isconstant,
    SciMLOperators,
    AbstractSciMLOperator,
    MatrixOperator,
    ScalarOperator,
    ScaledOperator,
    AddedOperator,
    ComposedOperator,
    IdentityOperator,
    update_coefficients!,
    concretize
import LinearSolve:
    LinearSolve, SciMLLinearSolveAlgorithm, KrylovJL_MINRES, KrylovJL_GMRES, UMFPACKFactorization, LUFactorization, OperatorAssumptions
import DiffEqCallbacks: PeriodicCallback, FunctionCallingCallback, FunctionCallingAffect, TerminateSteadyState
import OrdinaryDiffEqCore
import OrdinaryDiffEqVerner: Vern7
import OrdinaryDiffEqLowOrderRK: DP5
import DiffEqNoiseProcess: RealWienerProcess!, RealWienerProcess

## other dependencies (in alphabetical order)
import ArrayInterface: allowed_getindex, allowed_setindex!
import FFTW: fft, ifft, fftfreq, fftshift
import FillArrays: Eye
import Graphs: connected_components, DiGraph
import IncompleteLU: ilu
import LaTeXStrings: @L_str
import ProgressMeter: Progress, next!
import SpecialFunctions: loggamma
import StaticArraysCore: SVector, MVector

# Export functions from the other modules

## LinearAlgebra
export ishermitian, issymmetric, isposdef, dot, tr, svdvals, norm, normalize, normalize!, diag, Hermitian, Symmetric

## SparseArrays
export permute

## SciMLOperators
export cache_operator, iscached, isconstant

# Source files

## Utility
include("settings.jl")
include("utilities.jl")
include("versioninfo.jl")
include("linear_maps.jl")

## Quantum Object
include("qobj/dimensions.jl")
include("qobj/energy_restricted.jl")
include("qobj/quantum_object_base.jl")
include("qobj/quantum_object.jl")
include("qobj/quantum_object_evo.jl")
include("qobj/boolean_functions.jl")
include("qobj/arithmetic_and_attributes.jl")
include("qobj/eigsolve.jl")
include("qobj/functions.jl")
include("qobj/states.jl")
include("qobj/operators.jl")
include("qobj/superoperators.jl")
include("qobj/synonyms.jl")
include("qobj/block_diagonal_form.jl")

## time evolution
include("time_evolution/time_evolution.jl")
include("time_evolution/callback_helpers/callback_helpers.jl")
include("time_evolution/callback_helpers/sesolve_callback_helpers.jl")
include("time_evolution/callback_helpers/mesolve_callback_helpers.jl")
include("time_evolution/callback_helpers/mcsolve_callback_helpers.jl")
include("time_evolution/callback_helpers/ssesolve_callback_helpers.jl")
include("time_evolution/callback_helpers/smesolve_callback_helpers.jl")
include("time_evolution/mesolve.jl")
include("time_evolution/brmesolve.jl")
include("time_evolution/lr_mesolve.jl")
include("time_evolution/sesolve.jl")
include("time_evolution/mcsolve.jl")
include("time_evolution/ssesolve.jl")
include("time_evolution/smesolve.jl")
include("time_evolution/liouvillian_dressed_nonsecular.jl")
include("time_evolution/time_evolution_dynamical.jl")

## Other functionalities
include("correlations.jl")
include("wigner.jl")
include("spin_lattice.jl")
include("arnoldi.jl")
include("entropy.jl")
include("metrics.jl")
include("negativity.jl")
include("steadystate.jl")
include("spectrum.jl")

## Visualization
include("visualization/bloch_sphere.jl")
include("visualization/fock_distribution.jl")
include("visualization/matrix.jl")
include("visualization/wigner.jl")

## deprecated functions
include("deprecated.jl")

end

@testitem "Quantum Objects" begin
    using LinearAlgebra
    using SparseArrays
    using StaticArraysCore

    # ArgumentError: type is incompatible with vector or matrix
    @testset "ArgumentError" begin
        a = rand(ComplexF64, 2)
        for t in (Operator(), SuperOperator(), Bra(), OperatorBra())
            @test_throws ArgumentError Qobj(a, type = t)
        end
        a = rand(ComplexF64, 2, 2)
        @test_throws ArgumentError Qobj(a, type = Ket())
        @test_throws ArgumentError Qobj(a, type = OperatorKet())
    end

    # DimensionMismatch: incompatible between size of array and type
    @testset "DimensionMismatch" begin
        a = rand(ComplexF64, 3, 2)
        # Bra requires row vector (1xN), DimensionMismatch when dimensions don't match array size
        @test_throws DimensionMismatch Qobj(a, type = Bra())
        # OperatorBra requires row vector, DimensionMismatch when dimensions don't match array size
        @test_throws DimensionMismatch Qobj(a, type = OperatorBra())

        a = rand(ComplexF64, 4, 1, 2) # although the first two dimensions (4x1) are compatible with Ket/OperatorKet, the last dimension causes DimensionMismatch
        for t in (nothing, Ket(), Bra(), Operator(), SuperOperator(), OperatorBra(), OperatorKet())
            @test_throws DimensionMismatch Qobj(a, type = t)
        end

        # Note: (1,2) and (2,1) matrices are now allowed as non-square Operators / SuperOperators
        # (1,2) becomes a valid Operator / SuperOperator with to=(1,), from=(2,)
        a12 = rand(ComplexF64, 1, 2)
        @test Qobj(a12, type = Operator()).dimensions == Dimensions(Space(1), Space(2))
        @test Qobj(a12, type = SuperOperator(), dims = ((1,), (2,))).dimensions == Dimensions(Space(1), Space(2))

        # (2,1) becomes a valid Operator / SuperOperator with to=(2,), from=(1,)
        a21 = rand(ComplexF64, 2, 1)
        @test Qobj(a21, type = Operator()).dimensions == Dimensions(Space(2), Space(1))
        @test Qobj(a21, type = SuperOperator(), dims = ((2,), (1,))).dimensions == Dimensions(Space(2), Space(1))

        # check non-square dimensions work for all types
        @test Qobj(rand(ComplexF64, 2), type = Ket(), dims = ((2,), (1,))).dimensions.to == Space(2)
        @test Qobj(rand(ComplexF64, 1, 2), type = Bra(), dims = ((1,), (2,))).dimensions.from == Space(2)
        @test Qobj(rand(ComplexF64, 4, 9), type = SuperOperator(), dims = ((4,), (9,))).dimensions.to == Space(4)
        @test Qobj(rand(ComplexF64, 4), type = OperatorKet(), dims = ((4,), (1,))).dimensions.to == Space(4)
        @test Qobj(rand(ComplexF64, 1, 4), type = OperatorBra(), dims = ((1,), (4,))).dimensions.from == Space(4)
    end

    # unsupported type of dims
    @testset "unsupported dims" begin
        @test_throws ArgumentError Qobj(rand(2, 2), dims = 2.0)
        @test_throws ArgumentError Qobj(rand(2, 2), dims = 2.0 + 0.0im)
        @test_throws ArgumentError Qobj(rand(2, 2), dims = ((((2,),), ((2,),)), (((2,),), ((2,),)))) # 4-level nested tuple
        @test_throws DomainError Qobj(rand(2, 2), dims = 0)
        @test_throws DomainError Qobj(rand(2, 2), dims = (2, -2))
        @test_logs (
            :warn,
            "The argument dims should be a Tuple or a StaticVector for better performance. Try to use `dims = (2, 2)` instead of `dims = [2, 2]`. Alternatively, you can do `import QuantumToolbox: SVector` and use `dims = SVector(2, 2)`.",
        ) Qobj(rand(4, 4), dims = [2, 2])
    end

    @testset "TensorSpace" begin
        N = 2
        s = Space(2)
        t2 = TensorSpace(s, s)
        t3 = TensorSpace(s, s, s)
        t4 = TensorSpace(s, s, s, s)
        @test TensorSpace(s) == s # don't wrap with TensorSpace if there is only one space
        @test kron(s, s) == t2
        @test kron(s, t2) == kron(t2, s) == t3
        @test kron(t2, t2) == t4
        @test_throws DomainError TensorSpace()
    end

    @testset "Ket and Bra" begin
        N = 10
        a = rand(ComplexF64, 10)
        # @test_logs (:warn, "The norm of the input data is not one.") QuantumObject(a)
        @test_throws DimensionMismatch Qobj(a, dims = 2)
        @test_throws DimensionMismatch Qobj(a', dims = 2)
        a2 = Qobj(a')
        a3 = Qobj(a)
        @test dag(a3) == a2 # Here we are also testing the dag function
        @test isket(a2) == false
        @test isbra(a2) == true
        @test isoper(a2) == false
        @test issuper(a2) == false
        @test isoperket(a2) == false
        @test isoperbra(a2) == false
        @test isunitary(a2) == false
        @test isket(a3) == true
        @test isbra(a3) == false
        @test isoper(a3) == false
        @test issuper(a3) == false
        @test isoperket(a3) == false
        @test isoperbra(a3) == false
        @test isunitary(a3) == false
        @test Qobj(a3) == a3
        @test !(Qobj(a3) === a3)
    end

    @testset "Operator and SuperOperator" begin
        N = 10
        A = Qobj(rand(ComplexF64, N, N))
        B = Qobj(rand(ComplexF64, N, N))
        ρ = rand_dm(N) # random density matrix
        @test mat2vec(A * ρ * B) ≈ spre(A) * spost(B) * mat2vec(ρ) ≈ sprepost(A, B) * mat2vec(ρ) # we must make sure this equality holds !

        a = sprand(ComplexF64, 100, 100, 0.1)
        a2 = Qobj(a)
        a3 = Qobj(a, type = SuperOperator())
        a4 = Qobj(sprand(ComplexF64, 100, 10, 0.1)) # non-square Dimensions
        a5 = QuantumObject(rand(ComplexF64, 2 * 3 * 4, 5), dims = ((2, 3, 4), (5,)))
        @test isket(a2) == false
        @test isbra(a2) == false
        @test isoper(a2) == true
        @test issuper(a2) == false
        @test isoperket(a2) == false
        @test isoperbra(a2) == false
        @test iscached(a2) == true
        @test isconstant(a2) == true
        @test isunitary(a2) == false
        @test a2.dims == ([100], [100])
        @test isket(a3) == false
        @test isbra(a3) == false
        @test isoper(a3) == false
        @test issuper(a3) == true
        @test isoperket(a3) == false
        @test isoperbra(a3) == false
        @test iscached(a3) == true
        @test isconstant(a3) == true
        @test isunitary(a3) == false
        @test a3.dims == (([10], [10]), ([10], [10]))
        @test a3 == Qobj(a, type = SuperOperator(), dims = LiouvilleSpace(Dimensions(Space(N), Space(N)))) # also test if `dims = LiouvilleSpace` works
        @test isket(a4) == false
        @test isbra(a4) == false
        @test isoper(a4) == true
        @test issuper(a4) == false
        @test isoperket(a4) == false
        @test isoperbra(a4) == false
        @test iscached(a4) == true
        @test isconstant(a4) == true
        @test isunitary(a4) == false
        @test a4.dims == ([100], [10])
        @test isoper(a5) == true
        @test a5.dims == ([2, 3, 4], [5])
        @test_throws DimensionMismatch Qobj(a, dims = 2)
        @test_throws DimensionMismatch Qobj(a4.data, dims = 2)
        @test_throws DimensionMismatch Qobj(a4.data, dims = ((100,), (2,)))
    end

    @testset "OperatorKet and OperatorBra" begin
        H = 0.3 * sigmax() + 0.7 * sigmaz()
        L = liouvillian(H)
        ρ = Qobj(rand(ComplexF64, 2, 2))
        ρ_ket = operator_to_vector(ρ)
        ρ_bra = ρ_ket'
        ρ_vec_data = ρ_ket.data
        @test ρ_bra == Qobj(operator_to_vector(ρ.data)', type = OperatorBra())
        @test ρ == vector_to_operator(ρ_ket)
        @test isket(ρ_ket) == false
        @test isbra(ρ_ket) == false
        @test isoper(ρ_ket) == false
        @test issuper(ρ_ket) == false
        @test isoperket(ρ_ket) == true
        @test isoperbra(ρ_ket) == false
        @test isunitary(ρ_ket) == false
        @test isket(ρ_bra) == false
        @test isbra(ρ_bra) == false
        @test isoper(ρ_bra) == false
        @test issuper(ρ_bra) == false
        @test isoperket(ρ_bra) == false
        @test isoperbra(ρ_bra) == true
        @test isunitary(ρ_bra) == false
        @test ρ_bra.dims == ([1], ([2], [2]))
        @test ρ_ket.dims == (([2], [2]), [1])
        @test ρ_bra == Qobj(ρ_vec_data', type = OperatorBra(), dims = LiouvilleSpace(Dimensions(Space(2), Space(2)))) # also test if `dims = LiouvilleSpace` works
        @test ρ_ket == Qobj(ρ_vec_data, type = OperatorKet(), dims = LiouvilleSpace(Dimensions(Space(2), Space(2)))) # also test if `dims = LiouvilleSpace` works
        @test H * ρ ≈ spre(H) * ρ
        @test ρ * H ≈ spost(H) * ρ
        @test H * ρ * H ≈ sprepost(H, H) * ρ
        @test (L * ρ_ket).dims == (([2], [2]), [1])
        @test L * ρ_ket ≈ -1im * (+(spre(H) * ρ_ket) - spost(H) * ρ_ket)
        @test (ρ_bra * L')' == L * ρ_ket
        @test sum((conj(ρ) .* ρ).data) ≈ dot(ρ_ket, ρ_ket) ≈ ρ_bra * ρ_ket
    end

    @testset "Checks on non-QuantumObjects" begin
        x = 1
        @test isket(x) == false
        @test isbra(x) == false
        @test isoper(x) == false
        @test issuper(x) == false
        @test isoperket(x) == false
        @test isoperbra(x) == false

        x = rand(ComplexF64, 2)
        @test isket(x) == false
        @test isbra(x) == false
        @test isoper(x) == false
        @test issuper(x) == false
        @test isoperket(x) == false
        @test isoperbra(x) == false
    end

    @testset "arithmetic" begin
        a = sprand(ComplexF64, 100, 100, 0.1)
        b = rand(ComplexF64, 100)
        a2 = Qobj(a)
        b2 = Qobj(b, type = Ket())
        b3 = b2'
        a3 = Qobj(a, type = SuperOperator())
        a4 = to_sparse(a2)
        a4_copy = copy(a4)
        a4_copy[1] = rand(ComplexF64)
        @test isequal(a4, a2) == true
        @test isequal(a4, a3) == false
        @test a4 ≈ a2
        @test a4 != a4_copy

        @test real(a2).data == real(a)
        @test imag(a2).data == imag(a)
        @test +a2 == a2
        @test +b2 == b2
        @test +b3 == b3
        @test -(-a2) == a2
        @test -(-b2) == b2
        @test -(-b3) == b3
        @test a2^3 ≈ a2 * a2 * a2
        @test a2 + 2 == 2 + a2
        @test (a2 + 2).data == a2.data + 2 * I
        @test a2 * 2 == 2 * a2
        @test b2 * 2 == 2 * b2
        @test b3 * 2 == 2 * b3

        zero_like = qzero_like(a2)
        iden_like = qeye_like(a3)
        zero_array = spzeros(ComplexF64, 100, 100)
        iden_array = sparse(1:100, 1:100, ones(ComplexF64, 100))
        @test zero_like == Qobj(zero_array, type = a2.type, dims = a2.dims)
        @test typeof(zero_like.data) == typeof(zero_array)
        @test iden_like == Qobj(iden_array, type = a3.type, dims = a3.dims)
        @test typeof(iden_like.data) == typeof(iden_array)
        @test trans(trans(a2)) == a2
        @test trans(a2).data == transpose(a2.data)
        @test adjoint(a2) ≈ trans(conj(a2))
        @test adjoint(adjoint(a2)) == a2
        @test adjoint(a2).data == adjoint(a2.data)

        N = 10
        a = destroy(N)
        a_d = a'
        X = a + a_d
        Y = 1im * (a - a_d)
        Z = a + trans(a)
        @test isherm(X) == true
        @test isherm(Y) == true
        @test issymmetric(Y) == false
        @test issymmetric(Z) == true

        # diag
        @test diag(a, 1) ≈ [sqrt(i) for i in 1:(N - 1)]
        @test diag(a_d, -1) == [sqrt(i) for i in 1:(N - 1)]
        @test diag(a_d * a) ≈ collect(0:(N - 1))

        @test Y[1, 2] == conj(Y[2, 1])

        # triu and tril
        @test triu(X) == a
        @test tril(X) == a_d

        triu!(X)
        @test X == a
        tril!(X)
        @test nnz(X) == 0

        # Test a more complex dimension case
        O = rand_dm(3) ⊗ rand_dm(3) ⊗ rand_dm(3)
        ψ1 = rand_ket(3) ⊗ rand_ket(3) ⊗ rand_ket(3)
        ψ2 = rand_ket(3) ⊗ rand_ket(3) ⊗ rand_ket(3)
        Π = QuantumObject(hcat(ψ1.data, ψ2.data), dims = ((3, 3, 3), (2,)))

        o = (Π' * O * Π)
        @test o.dimensions == Dimensions(Space(2), Space(2))
        @test isoper(o) == true
    end

    @testset "broadcasting" begin
        a = destroy(20)
        for op in ((+), (-), (*), (^))
            A = broadcast(op, a, a)
            @test A.data == broadcast(op, a.data, a.data) && A.type == a.type && A.dims == a.dims

            A = broadcast(op, 2.1, a)
            @test A.data == broadcast(op, 2.1, a.data) && A.type == a.type && A.dims == a.dims

            A = broadcast(op, a, 2.1)
            @test A.data == broadcast(op, a.data, 2.1) && A.type == a.type && A.dims == a.dims
        end
    end

    @testset "REPL show" begin
        N = 10
        a = destroy(N)
        ψ = fock(N, 3)

        opstring = sprint((t, s) -> show(t, "text/plain", s), a)
        datastring = sprint((t, s) -> show(t, "text/plain", s), a.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), a.dimensions)
        a_dims = a.dims
        a_size = size(a)
        a_isherm = isherm(a)
        @test opstring ==
            "\nQuantum Object:   type=Operator()   dims=$a_dims   size=$a_size   ishermitian=$a_isherm\n$datastring"
        @test dimsensions_string == "Dimensions(Space($N), Space($N))"

        # non-square Dimensions
        Gop = tensor(a, ψ)
        opstring = sprint((t, s) -> show(t, "text/plain", s), Gop)
        datastring = sprint((t, s) -> show(t, "text/plain", s), Gop.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), Gop.dimensions)
        Gop_dims = ([N, N], [N, 1])  # Tuple of vectors for non-square operator
        Gop_size = size(Gop)
        Gop_isherm = isherm(Gop)
        @test opstring ==
            "\nQuantum Object:   type=Operator()   dims=$Gop_dims   size=$Gop_size   ishermitian=$Gop_isherm\n$datastring"
        @test dimsensions_string == "Dimensions(TensorSpace(Space($N), Space($N)), TensorSpace(Space($N), Space(1)))"

        a = spre(a)
        opstring = sprint((t, s) -> show(t, "text/plain", s), a)
        datastring = sprint((t, s) -> show(t, "text/plain", s), a.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), a.dimensions)
        a_dims = a.dims
        a_size = size(a)
        a_isherm = isherm(a)
        @test opstring == "\nQuantum Object:   type=SuperOperator()   dims=$a_dims   size=$a_size\n$datastring"
        @test dimsensions_string == "Dimensions(LiouvilleSpace(Dimensions(Space($N), Space($N))), LiouvilleSpace(Dimensions(Space($N), Space($N))))"

        opstring = sprint((t, s) -> show(t, "text/plain", s), ψ)
        datastring = sprint((t, s) -> show(t, "text/plain", s), ψ.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), ψ.dimensions)
        ψ_dims = ψ.dims
        ψ_size = size(ψ)
        @test opstring == "\nQuantum Object:   type=Ket()   dims=$ψ_dims   size=$ψ_size\n$datastring"
        @test dimsensions_string == "Dimensions(Space($N), Space(1))"

        ψ = ψ'
        opstring = sprint((t, s) -> show(t, "text/plain", s), ψ)
        datastring = sprint((t, s) -> show(t, "text/plain", s), ψ.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), ψ.dimensions)
        ψ_dims = ψ.dims
        ψ_size = size(ψ)
        @test opstring == "\nQuantum Object:   type=Bra()   dims=$ψ_dims   size=$ψ_size\n$datastring"
        @test dimsensions_string == "Dimensions(Space(1), Space($N))"

        ψ2 = Qobj(rand(ComplexF64, 4), type = OperatorKet())
        opstring = sprint((t, s) -> show(t, "text/plain", s), ψ2)
        datastring = sprint((t, s) -> show(t, "text/plain", s), ψ2.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), ψ2.dimensions)
        ψ2_dims = ψ2.dims
        ψ2_size = size(ψ2)
        @test opstring == "\nQuantum Object:   type=OperatorKet()   dims=$ψ2_dims   size=$ψ2_size\n$datastring"
        @test dimsensions_string == "Dimensions(LiouvilleSpace(Dimensions(Space(2), Space(2))), Space(1))"

        ψ2 = ψ2'
        opstring = sprint((t, s) -> show(t, "text/plain", s), ψ2)
        datastring = sprint((t, s) -> show(t, "text/plain", s), ψ2.data)
        dimsensions_string = sprint((t, s) -> show(t, "text/plain", s), ψ2.dimensions)
        ψ2_dims = ψ2.dims
        ψ2_size = size(ψ2)
        @test opstring == "\nQuantum Object:   type=OperatorBra()   dims=$ψ2_dims   size=$ψ2_size\n$datastring"
        @test dimsensions_string == "Dimensions(Space(1), LiouvilleSpace(Dimensions(Space(2), Space(2))))"
    end

    @testset "matrix element" begin
        H = Qobj([1 2; 3 4])
        L = liouvillian(H)
        s0 = Qobj(basis(4, 0).data; type = OperatorKet())
        s1 = Qobj(basis(4, 1).data; type = OperatorKet())
        s_wrong = Qobj(basis(9, 0).data; type = OperatorKet())
        @test matrix_element(basis(2, 0), H, basis(2, 1)) == H[1, 2]
        @test matrix_element(s0, L, s1) == L[1, 2]
        @test_throws DimensionMismatch matrix_element(basis(3, 0), H, basis(2, 1))
        @test_throws DimensionMismatch matrix_element(basis(2, 0), H, basis(3, 1))
        @test_throws DimensionMismatch matrix_element(s0, L, s_wrong)
        @test_throws DimensionMismatch matrix_element(s_wrong, L, s0)
    end

    @testset "element type conversion" begin
        vd = Qobj(Int64[0, 0])
        vs = Qobj(to_sparse(vd))
        Md = Qobj(Int64[0 0; 0 0])
        Ms = Qobj(to_sparse(Md))
        @test typeof(Vector(vd).data) == Vector{Int64}
        @test typeof(Vector(vs).data) == Vector{Int64}
        @test typeof(Vector{ComplexF64}(vd).data) == Vector{ComplexF64}
        @test typeof(Vector{ComplexF64}(vs).data) == Vector{ComplexF64}
        @test typeof(SparseVector(vd).data) == SparseVector{Int64, Int64}
        @test typeof(SparseVector(vs).data) == SparseVector{Int64, Int64}
        @test typeof(SparseVector{ComplexF64}(vs).data) == SparseVector{ComplexF64, Int64}
        @test typeof(Matrix(Md).data) == Matrix{Int64}
        @test typeof(Matrix(Ms).data) == Matrix{Int64}
        @test typeof(Matrix{ComplexF64}(Ms).data) == Matrix{ComplexF64}
        @test typeof(Matrix{ComplexF64}(Md).data) == Matrix{ComplexF64}
        @test typeof(SparseMatrixCSC(Md).data) == SparseMatrixCSC{Int64, Int64}
        @test typeof(SparseMatrixCSC(Ms).data) == SparseMatrixCSC{Int64, Int64}
        @test typeof(SparseMatrixCSC{ComplexF64}(Ms).data) == SparseMatrixCSC{ComplexF64, Int64}

        @testset "Deprecated Warnings" begin
            @test_logs (:warn,) sparse_to_dense(vs)
            @test_logs (:warn,) dense_to_sparse(vd)
        end
    end

    @testset "Type Inference (QuantumObject)" begin
        for T in (ComplexF32, ComplexF64)
            N = 4
            a = rand(T, N)
            @inferred Qobj(a)
            for type in (Ket(), OperatorKet())
                @inferred Qobj(a, type = type)
            end

            UnionType = Union{
                QuantumObject{Bra, Dimensions{Space, Space}, Matrix{T}},
                QuantumObject{Operator, Dimensions{Space, Space}, Matrix{T}},
            }
            a = rand(T, 1, N)
            @inferred UnionType Qobj(a)
            for type in (Bra(), OperatorBra())
                @inferred Qobj(a, type = type)
            end

            a = rand(T, N, N)
            @inferred UnionType Qobj(a)
            @inferred Qobj(a, type = Operator())
            @inferred Qobj(a, type = SuperOperator())
        end

        @testset "Math Operation" begin
            a = destroy(20)
            σx = sigmax()
            @inferred a + a
            @inferred a + a'
            @inferred a + 2
            @inferred 2 * a
            @inferred a / 2
            @inferred a^2
            @inferred a .+ 2
            @inferred a .* 2
            @inferred a ./ 2
            @inferred a .^ 2
            @inferred a * a
            @inferred a * a'
            @inferred kron(a)
            @inferred kron(a, σx)
            @inferred kron(a, eye(2))
        end
    end

    @testset "tensor" begin
        σx = sigmax()
        X3 = kron(σx, σx, σx)
        @test tensor(σx) == kron(σx)
        @test tensor(fill(σx, 3)...) == X3
        X_warn = @test_logs (
            :warn,
            "`tensor(A)` or `kron(A)` with `A` is a `Vector` can hurt performance. Try to use `tensor(A...)` or `kron(A...)` instead.",
        ) tensor(fill(σx, 3))
        @test X_warn == X3
    end

    @testset "projection" begin
        N = 10
        ψ = fock(N, 3)
        @test proj(ψ) ≈ proj(ψ') ≈ to_sparse(ket2dm(ψ)) ≈ projection(N, 3, 3)
        @test isket(ψ') == false
        @test isbra(ψ') == true
        @test shape(ψ) == (N,)
        @test shape(ψ') == (1, N)
        @test norm(ψ) ≈ 1
        @test norm(ψ') ≈ 1

        @testset "Type Inference (proj)" begin
            @inferred proj(ψ)
            @inferred proj(ψ')
        end
    end

    @testset "dot product" begin
        ψ = rand_ket(10)
        @test dot(ψ, ψ) ≈ ψ' * ψ ≈ norm(ψ) ≈ 1.0

        @testset "Type Inference (dot)" begin
            @inferred dot(ψ, ψ)
            @inferred ψ' * ψ
            @inferred norm(ψ)
        end
    end

    @testset "normalization" begin
        # normalize, normalize!, unit
        N = 10
        ψ = Qobj(rand(ComplexF64, N))
        M = ψ * ψ'
        @test (norm(ψ) ≈ 1) == false
        @test (norm(M) ≈ 1) == false
        @test (norm(unit(ψ)) ≈ 1) == true
        @test (norm(unit(M)) ≈ 1) == true
        @test (norm(ψ) ≈ 1) == false # Again, to be sure that it is still non-normalized
        @test (norm(M) ≈ 1) == false # Again, to be sure that it is still non-normalized
        normalize!(ψ)
        normalize!(M)
        @test (norm(ψ) ≈ 1) == true
        @test (norm(M) ≈ 1) == true
        @test M ≈ ψ * ψ'
        @test (unit(qeye(N)) ≈ (qeye(N) / N)) == true

        @testset "Type Inference (normalize)" begin
            ψ = Qobj(rand(ComplexF64, N))
            M = ket2dm(ψ)
            @inferred normalize(ψ)
            @inferred normalize(M)
        end
    end

    @testset "expectation value" begin
        # expect and variance
        N = 10
        a = destroy(N)
        ψ = rand_ket(N)
        @test expect(a, ψ) ≈ expect(a, ψ')
        @test variance(a, ψ) ≈ expect(a^2, ψ) - expect(a, ψ)^2

        ψ = fock(N, 3)
        @test norm(ψ' * a) ≈ 2
        @test expect(a' * a, ψ' * a) ≈ 16

        ρ = rand_dm(N)
        @test expect(a, ρ) ≈ tr(a * ρ)
        @test variance(a, ρ) ≈ tr(a^2 * ρ) - tr(a * ρ)^2

        # when input is a vector of states
        xlist = [1.0, 1.0im, -1.0, -1.0im]
        ψlist = [normalize!(basis(N, 4) + x * basis(N, 3)) for x in xlist]
        @test all(expect(a', ψlist) .≈ xlist)

        # when input is a vector of observables
        ρlist = Hermitian.(ket2dm.(ψlist)) # an alternative way to calculate expectation values for a list of density matrices
        Olist1 = [a' * a, a' + a, a]
        Olist2 = [Hermitian(a' * a), Hermitian(a' + a)]
        exp_val_1 = expect(Olist1, ψlist)
        exp_val_2 = expect(Olist2, ψlist)
        @test size(exp_val_1) == (3, 4)
        @test size(exp_val_2) == (2, 4)
        @test all(exp_val_1[1, :] .≈ exp_val_2[1, :] .≈ expect(ρlist, a' * a))
        @test all(exp_val_1[2, :] .≈ exp_val_2[2, :] .≈ expect(ρlist, a' + a))
        @test all(exp_val_1[3, :] .≈ expect(a, ρlist))

        @testset "Type Inference (expect)" begin
            @inferred expect(a, ψ)
            @inferred expect(a, ψ')
            @inferred variance(a, ψ)
            @inferred variance(a, ψ')
            @inferred expect(a, ρ)
            @inferred variance(a, ρ)
            @inferred expect(a, ψlist)
            @inferred variance(a, ψlist)
            @inferred expect(ρlist, a)
            @inferred expect(Olist1, ψ)
            @inferred expect(Olist1, ψ')
            @inferred expect(Olist1, ρ)
            @inferred expect(Olist1, ψlist)
            @inferred expect(Olist2, ψlist)
        end
    end

    @testset "get coherence" begin
        ψ = coherent(30, 3)
        α, δψ = get_coherence(ψ)
        @test isapprox(abs(α), 3, atol = 1.0e-5) && abs2(δψ[1]) > 0.999
        ρ = ket2dm(ψ)
        α, δρ = get_coherence(ρ)
        @test isapprox(abs(α), 3, atol = 1.0e-5) && abs2(δρ[1, 1]) > 0.999

        @testset "Type Inference (get_coherence)" begin
            @inferred get_coherence(ψ)
            @inferred get_coherence(ρ)
        end
    end

    @testset "SVD and Schatten p-norm" begin
        vd = Qobj(rand(ComplexF64, 10))
        vs = Qobj(sprand(ComplexF64, 100, 0.1))
        Md = Qobj(rand(ComplexF64, 10, 10))
        Ms = Qobj(sprand(ComplexF64, 10, 10, 0.5))
        @test svdvals(vd)[1] ≈ √(vd' * vd)
        @test svdvals(vs)[1] ≈ √(vs' * vs)
        @test norm(Md, 1) ≈ sum(sqrt, abs.(eigenenergies(Md' * Md))) atol = 1.0e-6
        @test norm(Ms, 1) ≈ sum(sqrt, abs.(eigenenergies(Ms' * Ms))) atol = 1.0e-6

        @testset "Type Inference (SVD and Schatten p-norm)" begin
            @inferred svdvals(vd)
            @inferred svdvals(vs)
            @inferred norm(Md, 1)
            @inferred norm(Ms, 1)
        end
    end

    @testset "purity" begin
        N = 10
        ψ = rand_ket(N)
        ψd = ψ'
        ρ1 = ψ * ψ'
        M2 = rand_dm(N)
        ρ2 = normalize!(Qobj(M2 * M2'))
        @test purity(ψ) ≈ norm(ψ)^2 ≈ 1.0
        @test purity(ψd) ≈ norm(ψd)^2 ≈ 1.0
        @test purity(ρ1) ≈ 1.0
        @test (1.0 / N) <= purity(ρ2) <= 1.0

        @testset "Type Inference (purity)" begin
            @inferred purity(ψ)
            @inferred purity(ψd)
            @inferred purity(ρ1)
            @inferred purity(ρ2)
        end
    end

    @testset "sqrt, log, exp, sinm, cosm" begin
        M0 = rand(ComplexF64, 4, 4)
        Md = Qobj(M0 * M0')
        Ms = to_sparse(Md)
        e_p = expm(1im * Md)
        e_m = expm(-1im * Md)
        @test sqrtm(Md) ≈ sqrtm(Ms)
        @test logm(expm(Ms)) ≈ expm(logm(Md))
        @test cosm(Ms) ≈ (e_p + e_m) / 2
        @test sinm(Ms) ≈ (e_p - e_m) / 2im

        @testset "Type Inference" begin
            @inferred sqrtm(Md)
            @inferred sqrtm(Ms)
            @inferred expm(Md)
            @inferred expm(Ms)
            @inferred logm(Md)
            @inferred logm(Ms)
            @inferred sinm(Md)
            @inferred sinm(Ms)
            @inferred cosm(Md)
            @inferred cosm(Ms)
        end
    end

    @testset "tidyup" begin
        N = 20
        tol = 0.5
        ## Vector{Float64} with in-place tidyup
        ψ1 = Qobj(rand(Float64, N))
        ψ2 = to_sparse(ψ1)
        @test tidyup!(ψ2, tol) == ψ2 != ψ1
        @test to_sparse(tidyup!(ψ1, tol)) == ψ2

        ## Vector{Float64} with normal tidyup
        ψ1 = Qobj(rand(Float64, N))
        ψ2 = to_sparse(ψ1)
        @test tidyup(ψ2, tol) != ψ2
        @test to_sparse(tidyup(ψ1, tol)) == tidyup(ψ2, tol)

        ## Matrix{ComplexF64} with in-place tidyup
        tol = 0.1
        ρ1 = rand_dm(N)
        ρ2 = to_sparse(ρ1)
        @test tidyup!(ρ2, tol) == ρ2 != ρ1
        @test to_sparse(tidyup!(ρ1, tol)) == ρ2

        ## Matrix{ComplexF64} with normal tidyup
        ρ1 = rand_dm(N)
        ρ2 = to_sparse(ρ1)
        @test tidyup(ρ2, tol) != ρ2
        @test to_sparse(tidyup(ρ1, tol)) == tidyup(ρ2, tol)

        @testset "Type Inference (tidyup)" begin
            @inferred tidyup(ψ1, tol)
            @inferred tidyup(ρ1, tol)
            @inferred tidyup(ψ2, tol)
            @inferred tidyup(ρ2, tol)
        end
    end

    @testset "ptrace" begin
        # Special cases for single-subsystem (N=1) where TensorSpace collapses to Space
        ψ0 = rand_ket(2)
        ρ0 = ket2dm(ψ0)
        empty_sel = SVector{0, Int}()
        @test ptrace(ψ0, empty_sel) ≈ 1
        @test ptrace(ψ0', empty_sel) ≈ 1
        @test ptrace(ρ0, empty_sel) ≈ 1
        @test ptrace(ψ0, 1) ≈ ρ0
        @test ptrace(ψ0', 1) ≈ ρ0
        @test ptrace(ρ0, 1) == ρ0
        @test_throws ArgumentError ptrace(ψ0, 0)
        @test_throws ArgumentError ptrace(ψ0, (1, 1))

        g = fock(2, 1)
        e = fock(2, 0)
        α = sqrt(0.7)
        β = sqrt(0.3) * 1im
        ψ = α * kron(g, e) + β * kron(e, g)

        ρ1 = ptrace(ψ, 1)
        ρ2 = ptrace(ψ, 2)
        @test ρ1.data ≈ [0.3 0.0; 0.0 0.7] atol = 1.0e-10
        @test ρ2.data ≈ [0.7 0.0; 0.0 0.3] atol = 1.0e-10

        ψ_d = ψ'

        ρ1 = ptrace(ψ_d, 1)
        ρ2 = ptrace(ψ_d, 2)
        @test ρ1.data ≈ [0.3 0.0; 0.0 0.7] atol = 1.0e-10
        @test ρ2.data ≈ [0.7 0.0; 0.0 0.3] atol = 1.0e-10

        ρ = ket2dm(ψ)
        ρ1 = ptrace(ρ, 1)
        ρ2 = ptrace(ρ, 2)
        @test ρ1.data ≈ [0.3 0.0; 0.0 0.7] atol = 1.0e-10
        @test ρ2.data ≈ [0.7 0.0; 0.0 0.3] atol = 1.0e-10

        ψ1 = normalize(g + 1im * e)
        ψ2 = normalize(g + e)
        ρ1 = ket2dm(ψ1)
        ρ2 = ket2dm(ψ2)
        ρ = kron(ρ1, ρ2)
        ρ1_ptr = ptrace(ρ, 1)
        ρ2_ptr = ptrace(ρ, 2)

        # use non-square Dimensions to do partial trace
        ρ1_compound = Qobj(zeros(ComplexF64, 2, 2), dims = ((2, 1), (2, 1)))
        II = qeye(2)
        basis_list = [basis(2, i) for i in 0:1]
        for b in basis_list
            ρ1_compound += tensor(II, b') * ρ * tensor(II, b)
        end
        ρ2_compound = Qobj(zeros(ComplexF64, 2, 2), dims = ((1, 2), (1, 2)))
        for b in basis_list
            ρ2_compound += tensor(b', II) * ρ * tensor(b, II)
        end
        @test ρ1.data ≈ ρ1_ptr.data ≈ ρ1_compound.data
        @test ρ2.data ≈ ρ2_ptr.data ≈ ρ2_compound.data
        @test ρ1.dims != ρ1_compound.dims
        @test ρ2.dims != ρ2_compound.dims
        ρ1_compound = ptrace(ρ1_compound, 1)
        ρ2_compound = ptrace(ρ2_compound, 2)
        @test ρ1.dims == ρ1_compound.dims
        @test ρ2.dims == ρ2_compound.dims

        ψlist = [rand_ket(2), rand_ket(3), rand_ket(4), rand_ket(5)]
        ρlist = [rand_dm(2), rand_dm(3), rand_dm(4), rand_dm(5)]
        ψtotal = tensor(ψlist...)
        ρtotal = tensor(ρlist...)
        sel_tests = [
            SVector{0, Int}(),
            1,
            2,
            3,
            4,
            (1, 2),
            (1, 3),
            (1, 4),
            (2, 3),
            (2, 4),
            (3, 4),
            (1, 2, 3),
            (1, 2, 4),
            (1, 3, 4),
            (2, 3, 4),
            (1, 2, 3, 4),
        ]
        for sel in sel_tests
            if length(sel) == 0
                @test ptrace(ψtotal, sel) ≈ 1.0
                @test ptrace(ρtotal, sel) ≈ 1.0
            else
                @test ptrace(ψtotal, sel) ≈ tensor([ket2dm(ψlist[i]) for i in sel]...)
                @test ptrace(ρtotal, sel) ≈ tensor([ρlist[i] for i in sel]...)
            end
        end
        @test ptrace(ψtotal, (1, 3, 4)) ≈ ptrace(ψtotal, (4, 3, 1)) # check sort of sel
        @test ptrace(ρtotal, (1, 3, 4)) ≈ ptrace(ρtotal, (3, 1, 4)) # check sort of sel
        @test_logs (
            :warn,
            "The argument sel should be a Tuple or a StaticVector for better performance. Try to use `sel = (1, 2)` instead of `sel = [1, 2]`. Alternatively, you can do `import QuantumToolbox: SVector` and use `sel = SVector(1, 2)`.",
        ) ptrace(ψtotal, [1, 2])
        @test_logs (
            :warn,
            "The argument sel should be a Tuple or a StaticVector for better performance. Try to use `sel = (1, 2)` instead of `sel = [1, 2]`. Alternatively, you can do `import QuantumToolbox: SVector` and use `sel = SVector(1, 2)`.",
        ) ptrace(ρtotal, [1, 2])
        @test_throws ArgumentError ptrace(ψtotal, 0)
        @test_throws ArgumentError ptrace(ψtotal, 5)
        @test_throws ArgumentError ptrace(ψtotal, (0, 2))
        @test_throws ArgumentError ptrace(ψtotal, (2, 5))
        @test_throws ArgumentError ptrace(ψtotal, (2, 2, 3))
        @test_throws ArgumentError ptrace(ρtotal, 0)
        @test_throws ArgumentError ptrace(ρtotal, 5)
        @test_throws ArgumentError ptrace(ρtotal, (0, 2))
        @test_throws ArgumentError ptrace(ρtotal, (2, 5))
        @test_throws ArgumentError ptrace(ρtotal, (2, 2, 3))
        @test_throws ArgumentError ptrace(tensor(Qobj(zeros(ComplexF64, 3, 2)), Qobj(zeros(ComplexF64, 2, 3))), 1) # invalid non-square Dimensions

        @testset "Type Inference (ptrace)" begin
            @inferred ptrace(ρ, 1)
            @inferred ptrace(ρ, 2)
            @inferred ptrace(ψ_d, 1)
            @inferred ptrace(ψ_d, 2)
            @inferred ptrace(ψ, 1)
            @inferred ptrace(ψ, 2)
        end
    end

    @testset "permute" begin
        # standard Dimensions
        ket_a = Qobj(rand(ComplexF64, 2))
        ket_b = Qobj(rand(ComplexF64, 3))
        ket_c = Qobj(rand(ComplexF64, 4))
        ket_d = Qobj(rand(ComplexF64, 5))
        ket_bdca = permute(tensor(ket_a, ket_b, ket_c, ket_d), (2, 4, 3, 1))
        bra_a = ket_a'
        bra_b = ket_b'
        bra_c = ket_c'
        bra_d = ket_d'
        bra_bdca = permute(tensor(bra_a, bra_b, bra_c, bra_d), (2, 4, 3, 1))
        op_a = Qobj(rand(ComplexF64, 2, 2))
        op_b = Qobj(rand(ComplexF64, 3, 3))
        op_c = Qobj(rand(ComplexF64, 4, 4))
        op_d = Qobj(rand(ComplexF64, 5, 5))
        op_bdca = permute(tensor(op_a, op_b, op_c, op_d), (2, 4, 3, 1))
        correct_dims = [3, 5, 4, 2]
        wrong_order1 = (1,)
        wrong_order2 = (2, 3, 4, 5)
        wrong_state = Qobj(rand(2 * 3 * 1, 4 * 5), dims = ((2, 3, 1), (4, 5)))
        @test ket_bdca ≈ tensor(ket_b, ket_d, ket_c, ket_a)
        @test bra_bdca ≈ tensor(bra_b, bra_d, bra_c, bra_a)
        @test op_bdca ≈ tensor(op_b, op_d, op_c, op_a)
        @test ket_bdca.dims == (correct_dims, [1])
        @test bra_bdca.dims == ([1], correct_dims)
        @test op_bdca.dims == (correct_dims, correct_dims)
        @test isket(ket_bdca)
        @test isbra(bra_bdca)
        @test isoper(op_bdca)
        @test_throws ArgumentError permute(ket_bdca, wrong_order1)
        @test_throws ArgumentError permute(ket_bdca, wrong_order2)
        @test_throws ArgumentError permute(bra_bdca, wrong_order1)
        @test_throws ArgumentError permute(bra_bdca, wrong_order2)
        @test_throws ArgumentError permute(op_bdca, wrong_order1)
        @test_throws ArgumentError permute(op_bdca, wrong_order2)
        @test_throws ArgumentError permute(wrong_state, (2, 1, 3))
        @test_throws ArgumentError permute(wrong_state, (2, 1))

        # non-square Dimensions
        Gop_d = Qobj(rand(ComplexF64, 5, 6))
        compound_bdca = permute(tensor(ket_a, op_b, bra_c, Gop_d), (2, 4, 3, 1))
        compound_dacb = permute(tensor(ket_a, op_b, bra_c, Gop_d), (4, 1, 3, 2))
        @test compound_bdca ≈ tensor(op_b, Gop_d, bra_c, ket_a)
        @test compound_dacb ≈ tensor(Gop_d, ket_a, bra_c, op_b)
        @test compound_bdca.dims == ([3, 5, 1, 2], [3, 6, 4, 1])
        @test compound_dacb.dims == ([5, 2, 1, 3], [6, 1, 4, 3])
        @test isoper(compound_bdca)
        @test isoper(compound_dacb)

        @testset "Type Inference (permute)" begin
            @inferred permute(ket_bdca, (2, 4, 3, 1))
            @inferred permute(bra_bdca, (2, 4, 3, 1))
            @inferred permute(op_bdca, (2, 4, 3, 1))
            @inferred permute(compound_bdca, (2, 4, 3, 1))
        end
    end
end

export plot_bloch, Bloch, render
export add_points!, add_vectors!, add_line!, add_arc!, clear!, add_states!

@doc raw"""
    Bloch(kwargs...)

A structure representing a Bloch sphere visualization for quantum states. Available keyword arguments are listed in the following fields.

# Fields:

## Data storage
- `points::Vector{Matrix{Float64}}`: Points to plot on the Bloch sphere (3D coordinates)
- `vectors::Vector{Vector{Float64}}}`: Vectors to plot on the Bloch sphere
- `lines::Vector{Tuple{Vector{Vector{Float64}},String}}`: Lines to draw on the sphere with each line given as `([start_pt, end_pt], line_format)`
- `arcs::Vector{Vector{Vector{Float64}}}}`: Arcs to draw on the sphere

## Style properties

- `font_color::String`: Color of axis labels and text. Default: `"black"`
- `font_size::Int`: Font size for labels. Default: `20`
- `frame_alpha::Float64`: Transparency of the wire frame. Default: `0.2`
- `frame_color::String`: Color of the wire frame. Default: `"gray"`
- `frame_width::Float64` : Width of wire frame. Default: `1.0`

## Point properties

- `point_default_color::Vector{String}}`: Default color cycle for points. Default: `["blue", "red", "green", "#CC6600"]`
- `point_color::Vector{String}}`: List of colors for Bloch point markers to cycle through. Default: `Union{Nothing,String}[]`
- `point_marker::Vector{Symbol}}`: List of point marker shapes to cycle through. Default: `[:circle, :rect, :diamond, :utriangle]`
- `point_size::Vector{Int}}`: List of point marker sizes (not all markers look the same size when plotted). Default: `[5.5, 6.2, 6.5, 7.5]`
- `point_style::Vector{Symbol}}`: List of marker styles. Default: `Symbol[]`
- `point_alpha::Vector{Float64}}`: List of marker transparencies. Default: `Float64[]`

## Sphere properties

- `sphere_color::String`: Color of Bloch sphere surface. Default: `"#FFDDDD"`
- `sphere_alpha::Float64`: Transparency of sphere surface. Default: `0.2`

## Vector properties

- `vector_color::Vector{String}`: Colors for vectors. Default: `["green", "#CC6600", "blue", "red"]`
- `vector_width::Float64`: Width of vectors. Default: `0.02`
- `vector_tiplength::Float64`: Length of vector arrow head. Default: `0.08`
- `vector_tipradius::Float64`: Radius of vector arrow head. Default: `0.05`

## Layout properties

- `view::Vector{Int}`: Azimuthal and elevation viewing angles in degrees. Default: `[30, 30]`

## Label properties

- `xlabel::Vector{AbstractString}`: Labels for x-axis. Default: `[L"x", ""]`
- `xlpos::Vector{Float64}`: Positions of x-axis labels. Default: `[1.2, -1.2]`
- `ylabel::Vector{AbstractString}`: Labels for y-axis. Default: `[L"y", ""]`
- `ylpos::Vector{Float64}`: Positions of y-axis labels. Default: `[1.2, -1.2]`
- `zlabel::Vector{AbstractString}`: Labels for z-axis. Default: `[L"|0\rangle", L"|1\rangle"]`
- `zlpos::Vector{Float64}`: Positions of z-axis labels. Default: `[1.2, -1.2]`
"""
@kwdef mutable struct Bloch
    points::Vector{Matrix{Float64}} = Vector{Matrix{Float64}}()
    vectors::Vector{Vector{Float64}} = Vector{Vector{Float64}}()
    lines::Vector{Tuple{Vector{Vector{Float64}}, String}} = Vector{Tuple{Vector{Vector{Float64}}, String}}()
    arcs::Vector{Vector{Vector{Float64}}} = Vector{Vector{Vector{Float64}}}()
    font_color::String = "black"
    font_size::Int = 20
    frame_alpha::Float64 = 0.2
    frame_color::String = "gray"
    frame_width::Float64 = 1.0
    point_default_color::Vector{String} = ["blue", "red", "green", "#CC6600"]
    point_color::Vector{Union{Nothing, String}} = Union{Nothing, String}[]
    point_marker::Vector{Symbol} = [:circle, :rect, :diamond, :utriangle]
    point_size::Vector{Float64} = [5.5, 6.2, 6.5, 7.5]
    point_style::Vector{Symbol} = Symbol[]
    point_alpha::Vector{Float64} = Float64[]
    sphere_alpha::Float64 = 0.2
    sphere_color::String = "#FFDDDD"
    vector_color::Vector{String} = ["green", "#CC6600", "blue", "red"]
    vector_width::Float64 = 0.02
    vector_tiplength::Float64 = 0.08
    vector_tipradius::Float64 = 0.05
    view::Vector{Int} = [30, 30]
    xlabel::Vector{AbstractString} = [L"x", ""]
    xlpos::Vector{Float64} = [1.2, -1.2]
    ylabel::Vector{AbstractString} = [L"y", ""]
    ylpos::Vector{Float64} = [1.2, -1.2]
    zlabel::Vector{AbstractString} = [L"|0\rangle", L"|1\rangle"]
    zlpos::Vector{Float64} = [1.2, -1.2]
end

const BLOCH_DATA_FIELDS = (:points, :vectors, :lines, :arcs)
function Base.show(io::IO, b::Bloch)
    # Align the output and make it easier to read
    # we use rpad `17` and `maxLen` for Bloch sphere data and properties, respectively
    # 17 is the length of string: `Number of vectors`
    # maxLen is the maximum length among all field names
    maxLen = maximum(length ∘ String, fieldnames(Bloch))

    println(io, "Bloch Sphere\n")
    println(io, "data:")
    println(io, "-----")
    map(n -> println(io, rpad("Number of $n", 17, " "), " = ", length(getfield(b, n))), BLOCH_DATA_FIELDS)
    println(io, "")
    println(io, "properties:")
    println(io, "-----------")
    map(
        n -> (n ∉ BLOCH_DATA_FIELDS) && (println(io, rpad("$n", maxLen, " "), " = ", getfield(b, n))),
        fieldnames(Bloch),
    )
    return nothing
end

@doc raw"""
    add_vectors!(b::Bloch, vec::Vector{<:Real})

Add a single normalized vector to the Bloch sphere visualization.

# Arguments
- `b::Bloch`: The Bloch sphere object to modify
- `vec::Vector{<:Real}`: A 3D vector to add (will be normalized)
- `vecs::Vector{<:Vector{<:Real}}}`: List of 3D vectors to add (each will be normalized)

# Example
```jldoctest
julia> b = Bloch();

julia> add_vectors!(b, [1, 0, 0])
1-element Vector{Vector{Float64}}:
 [1.0, 0.0, 0.0]
```

We can also add multiple normalized vectors to the Bloch sphere visualization.

```jldoctest
julia> b = Bloch();

julia> add_vectors!(b, [[1, 0, 0], [0, 1, 0]])
2-element Vector{Vector{Float64}}:
 [1.0, 0.0, 0.0]
 [0.0, 1.0, 0.0]
```
"""
add_vectors!(b::Bloch, vec::Vector{<:Real}) = push!(b.vectors, convert(Vector{Float64}, vec))
add_vectors!(b::Bloch, vecs::Vector{<:Vector{<:Real}}) = append!(b.vectors, [convert(Vector{Float64}, v) for v in vecs])

@doc raw"""
    add_points!(b::Bloch, pnt::Vector{<:Real}; meth::Symbol = :s, color = "blue", alpha = 1.0)

Add a single point to the Bloch sphere visualization.

# Arguments
- `b::Bloch`: The Bloch sphere object to modify
- `pnt::Vector{<:Real}`: A 3D point to add
- `meth::Symbol=:s`: Display method (`:s` for single point, `:m` for multiple, `:l` for line)
- `color`: Color of the point (defaults to first default color if nothing)
- `alpha=1.0`: Transparency (`1.0` means opaque and `0.0` means transparent)
"""
function add_points!(b::Bloch, pnt::Vector{<:Real}; meth::Symbol = :s, color = nothing, alpha = 1.0)
    return add_points!(b, reshape(pnt, 3, 1); meth, color, alpha)
end
function add_points!(b::Bloch, pnts::Vector{<:Vector{<:Real}}; meth::Symbol = :s, color = nothing, alpha = 1.0)
    return add_points!(b, Matrix(hcat(pnts...)'); meth, color, alpha)
end

@doc raw"""
    add_points!(b::Bloch, pnts::Matrix{<:Real}; meth::Symbol = :s, color = nothing, alpha = 1.0)

Add multiple points to the Bloch sphere visualization.

# Arguments

- `b::Bloch`: The Bloch sphere object to modify
- `pnts::Matrix{<:Real}`: `3×N` matrix of points (each column is a point)
- `meth::Symbol=:s`: Display method (`:s` for single point, `:m` for multiple, `:l` for line)
- `color`: Color of the points (defaults to first default color if `nothing`)
- `alpha=1.0`: Transparency (`1.0` means opaque and `0.0` means transparent)
```
"""
function add_points!(
        b::Bloch,
        pnts::AbstractMatrix{<:Real};
        meth::Symbol = :s,
        color::Union{Nothing, String} = nothing,
        alpha::Float64 = 1.0,
    )
    (size(pnts, 1) == 3) || throw(ArgumentError("Points must be a 3×N matrix where each column is [x; y; z]"))
    (meth in (:s, :m, :l)) || throw(ArgumentError("`meth` must be :s, :m, or :l"))

    push!(b.points, convert(Matrix{Float64}, pnts))
    push!(b.point_style, meth)
    push!(b.point_alpha, alpha)
    push!(b.point_color, color)
    return nothing
end

@doc raw"""
    add_line!(b::Bloch, p1::Vector{<:Real}, p2::Vector{<:Real}; fmt = "k", kwargs...)

Add a line between two points on the Bloch sphere.

# Arguments
- `b::Bloch`: The Bloch sphere object to modify
- `p1::Vector{<:Real}`: First 3D point
- `p2::Vector{<:Real}`: Second 3D point
- `fmt="k"`: Line format string (matplotlib style)
"""
function add_line!(b::Bloch, p1::Vector{<:Real}, p2::Vector{<:Real}; fmt = "k")
    (length(p1) != 3 || length(p2) != 3) && throw(ArgumentError("Points must be 3D vectors"))
    x = [p1[1], p2[1]]
    y = [p1[2], p2[2]]
    z = [p1[3], p2[3]]
    push!(b.lines, ([x, y, z], fmt))
    return b
end

@doc raw"""
    add_line!(
        b::Bloch,
        start_point::QuantumObject,
        end_point::QuantumObject;
        fmt = "k"
    )

Add a line between two quantum states on the Bloch sphere visualization.

# Arguments

- `b::Bloch`: The Bloch sphere object to modify.
- `start_point::QuantumObject`: The starting quantum state. Can be a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `end_point::QuantumObject`: The ending quantum state. Can be a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `fmt::String="k"`: (optional) A format string specifying the line style and color (default is black `"k"`).

# Description

This function converts the given quantum states into their Bloch vector representations and adds a line between these two points on the Bloch sphere visualization. 

# Example

```julia
b = Bloch()
ψ₁ = normalize(basis(2, 0) + basis(2, 1))
ψ₂ = normalize(basis(2, 0) - im * basis(2, 1))
add_line!(b, ψ₁, ψ₂; fmt = "r--")
```
"""
function add_line!(
        b::Bloch,
        start_point::QuantumObject{OpType1},
        end_point::QuantumObject{OpType2};
        fmt = "k",
    ) where {OpType1 <: Union{Ket, Bra, Operator}, OpType2 <: Union{Ket, Bra, Operator}}
    coords1 = _state_to_bloch(start_point)
    coords2 = _state_to_bloch(end_point)
    return add_line!(b, coords1, coords2; fmt = fmt)
end

@doc raw"""
    add_arc!(b::Bloch, p1::Vector{<:Real}, p2::Vector{<:Real}, p3::Vector{<:Real})

Add a circular arc through three points on the Bloch sphere.

# Arguments

- `b::Bloch`: The Bloch sphere object to modify
- `p1::Vector{<:Real}`: Starting 3D point
- `p2::Vector{<:Real}`: [Optional] Middle 3D point
- `p3::Vector{<:Real}`: Ending 3D point

# Examples

```jldoctest
julia> b = Bloch();

julia> add_arc!(b, [1, 0, 0], [0, 1, 0], [0, 0, 1])
1-element Vector{Vector{Vector{Float64}}}:
 [[1.0, 0.0, 0.0], [0.0, 1.0, 0.0], [0.0, 0.0, 1.0]]
```
"""
function add_arc!(b::Bloch, p1::Vector{<:Real}, p2::Vector{<:Real})
    (length(p1) != 3 || length(p2) != 3) && throw(ArgumentError("Points must be 3D vectors"))
    return push!(b.arcs, [convert(Vector{Float64}, p1), convert(Vector{Float64}, p2)])
end
function add_arc!(b::Bloch, p1::Vector{<:Real}, p2::Vector{<:Real}, p3::Vector{<:Real})
    (length(p1) != 3 || length(p2) != 3 || length(p3) != 3) && throw(ArgumentError("Points must be 3D vectors"))
    return push!(b.arcs, [convert(Vector{Float64}, p1), convert(Vector{Float64}, p2), convert(Vector{Float64}, p3)])
end

@doc raw"""
    add_arc!(
        b::Bloch,
        start_point::QuantumObject,
        middle_point::QuantumObject,
        end_point::QuantumObject
    )

Add a circular arc through three points on the Bloch sphere.

# Arguments

- `b::Bloch`: The Bloch sphere object to modify.
- `start_point::QuantumObject`: The starting quantum state. Can be a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `middle_point::QuantumObject`: [Optional] The middle quantum state. Can be a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `end_point::QuantumObject`: The ending quantum state. Can be a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).

# Description

This function converts the given quantum states into their Bloch vector representations and adds a arc between these two (or three) points on the Bloch sphere visualization. 
"""
function add_arc!(
        b::Bloch,
        start_point::QuantumObject{OpType1},
        end_point::QuantumObject{OpType2},
    ) where {OpType1 <: Union{Ket, Bra, Operator}, OpType2 <: Union{Ket, Bra, Operator}}
    coords1 = _state_to_bloch(start_point)
    coords2 = _state_to_bloch(end_point)
    return add_arc!(b, coords1, coords2)
end
function add_arc!(
        b::Bloch,
        start_point::QuantumObject{OpType1},
        middle_point::QuantumObject{OpType2},
        end_point::QuantumObject{OpType3},
    ) where {OpType1 <: Union{Ket, Bra, Operator}, OpType2 <: Union{Ket, Bra, Operator}, OpType3 <: Union{Ket, Bra, Operator}}
    coords1 = _state_to_bloch(start_point)
    coords2 = _state_to_bloch(middle_point)
    coords3 = _state_to_bloch(end_point)
    return add_arc!(b, coords1, coords2, coords3)
end

@doc raw"""
    add_states!(b::Bloch, states::Vector{QuantumObject}; kind::Symbol = :vector, kwargs...)

Add one or more quantum states to the Bloch sphere visualization by converting them into Bloch vectors.

# Arguments
- `b::Bloch`: The Bloch sphere object to modify
- `states::Vector{QuantumObject}`: One or more quantum states ([`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref))
- `kind::Symbol`: Type of object to plot (can be either `:vector` or `:point`). Default: `:vector`

# Example

```julia
x = basis(2, 0) + basis(2, 1);
y = basis(2, 0) + im * basis(2, 1);
z = basis(2, 0);
b = Bloch();
add_states!(b, [x, y, z])
```
"""
function add_states!(b::Bloch, states::Vector{<:QuantumObject}; kind::Symbol = :vector, kwargs...)
    vecs = map(state -> _state_to_bloch(state), states)
    if kind == :vector
        add_vectors!(b, vecs)
    elseif kind == :point
        add_points!(b, hcat(vecs...); kwargs...)
    else
        throw(ArgumentError("Invalid kind = :$kind"))
    end
    return nothing
end
add_states!(b::Bloch, state::QuantumObject; kind::Symbol = :vector, kwargs...) =
    add_states!(b, [state], kind = kind, kwargs...)

_state_to_bloch(state::QuantumObject{Ket}) = _ket_to_bloch(state)
_state_to_bloch(state::QuantumObject{Bra}) = _ket_to_bloch(state')
_state_to_bloch(state::QuantumObject{Operator}) = _dm_to_bloch(state)

raw"""
    _ket_to_bloch(state::QuantumObject{Ket}) -> Vector{Float64}

Convert a pure qubit state (`Ket`) to its Bloch vector representation.

If the state is not normalized, it is automatically normalized before conversion.

# Arguments
- `state`: A `Ket` representing a pure quantum state.

# Returns
A 3-element `Vector{Float64}` representing the Bloch vector `[x, y, z]`.

# Throws
- `ArgumentError` if the state dimension is not 2.
"""
function _ket_to_bloch(state::QuantumObject{Ket})
    (size(state) == (2,)) ||
        throw(ArgumentError("Bloch sphere visualization is only supported for qubit states (2-level systems)"))

    state_norm = norm(state)
    if !isapprox(state_norm, 1.0, atol = 1.0e-6)
        @warn "State is not normalized. Normalizing before Bloch vector conversion."
        ψ = state.data / state_norm
    else
        ψ = state.data
    end

    c = conj(ψ[1]) * ψ[2]
    x = 2 * real(c)
    y = 2 * imag(c)
    z = abs2(ψ[1]) - abs2(ψ[2])
    return [x, y, z]
end

raw"""
    _dm_to_bloch(ρ::QuantumObject{Operator}) -> Vector{Float64}

Convert a qubit density matrix (`Operator`) to its Bloch vector representation.

This function assumes the input is Hermitian. If the density matrix is not Hermitian, a warning is issued.

# Arguments
- `ρ`: A density matrix (`Operator`) representing a mixed or pure quantum state.

# Returns
A 3-element `Vector{Float64}` representing the Bloch vector `[x, y, z]`.

# Throws
- `ArgumentError` if the matrix dimension is not 2.
"""
function _dm_to_bloch(ρ::QuantumObject{Operator})
    (size(ρ) == (2, 2)) ||
        throw(ArgumentError("Bloch sphere visualization is only supported for qubit states (2-level systems)"))

    ishermitian(ρ) || (@warn "Density matrix is not Hermitian. Results may not be meaningful.")

    state_norm = norm(ρ)
    if !isapprox(state_norm, 1.0, atol = 1.0e-6)
        @warn "State is not normalized. Normalizing before Bloch vector conversion."
        ρ2 = ρ / state_norm
    else
        ρ2 = ρ
    end
    x = real(ρ2[1, 2] + ρ2[2, 1])
    y = imag(ρ2[2, 1] - ρ2[1, 2])
    z = real(ρ2[1, 1] - ρ2[2, 2])
    return [x, y, z]
end

@doc raw"""
    clear!(b::Bloch)

Clear all graphical elements (points, vectors, lines, arcs) from the given [`Bloch`](@ref) sphere object `b`.

# Arguments

- `b::Bloch`: The Bloch sphere instance whose contents will be cleared.

# Returns

- The updated `Bloch` object `b` with all points, vectors, lines, and arcs removed.
"""
function clear!(b::Bloch)
    empty!(b.points)
    empty!(b.point_color)
    empty!(b.point_style)
    empty!(b.point_alpha)
    empty!(b.vectors)
    empty!(b.lines)
    empty!(b.arcs)
    return b
end

@doc raw"""
    render(b::Bloch; location=nothing)

Render the Bloch sphere visualization from the given [`Bloch`](@ref) object `b`.

# Arguments

- `b::Bloch`: The Bloch sphere object containing states, vectors, and settings to visualize.
- `location::Union{GridPosition,Nothing}`: The location of the plot in the layout. If `nothing`, the plot is created in a new figure. Default is `nothing`.

# Returns

- A tuple `(fig, lscene)` where `fig` is the figure object and `lscene` is the `LScene` object used for plotting. These can be further manipulated or saved by the user.
"""
function render end

@doc raw"""
    plot_bloch(
        state::QuantumObject;
        library::Union{Symbol, Val} = :Makie,
        kwargs...
    )

Plot the state of a two-level quantum system on the Bloch sphere.

The `library` keyword argument specifies the plotting backend to use. The default is `:Makie`, which uses the [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) plotting library. This function internally dispatches to a type-stable version based on `Val(:Makie)` or other plotting backends.

# Arguments
- `state::QuantumObject`: The quantum state to be visualized. Can be a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `library::Union{Val,Symbol}`: The plotting library to use. Default is `Val(:Makie)`.
- `kwargs...`: Additional keyword arguments passed to the specific plotting implementation.

!!! note "Import library first"
    The plotting backend library must be imported before use.

!!! warning "Beware of type-stability!"
    For improved performance and type-stability, prefer passing `Val(:Makie)` instead of `:Makie`. See [Performance Tips](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) for details.
"""
plot_bloch(
    state::QuantumObject{OpType};
    library::Union{Symbol, Val} = Val(:Makie),
    kwargs...,
) where {OpType <: Union{Ket, Bra, Operator}} = plot_bloch(makeVal(library), state; kwargs...)
plot_bloch(::Val{T}, state::QuantumObject{OpType}; kwargs...) where {T, OpType <: Union{Ket, Bra, Operator}} =
    throw(ArgumentError("The specified plotting library $T is not available. Try running `using $T` first."))

@testset "CUDA Extension" verbose = true begin
    # Test that scalar indexing is disallowed
    @test_throws ErrorException CUDA.rand(1)[1]

    ψdi = Qobj(Int64[1, 0])
    ψdf = Qobj(Float64[1, 0])
    ψdc = Qobj(ComplexF64[1, 0])
    ψsi = to_sparse(ψdi)
    ψsf = to_sparse(ψdf)
    ψsc = to_sparse(ψdc)

    Xdi = Qobj(Int64[0 1; 1 0])
    Xdf = Qobj(Float64[0 1; 1 0])
    Xdc = Qobj(ComplexF64[0 1; 1 0])
    Xsi = to_sparse(Xdi)
    Xsf = to_sparse(Xdf)
    Xsc = to_sparse(Xdc)

    @test_throws DomainError cu(ψdi; word_size = 16)

    # type conversion of CUDA dense arrays
    @test typeof(cu(ψdi; word_size = 64).data) == typeof(CuArray(ψdi).data) <: CuArray{Int64, 1}
    @test typeof(cu(ψdi; word_size = 32).data) == typeof(CuArray{Int32}(ψdi).data) <: CuArray{Int32, 1}
    @test typeof(cu(ψdf; word_size = 64).data) == typeof(CuArray(ψdf).data) <: CuArray{Float64, 1}
    @test typeof(cu(ψdf; word_size = 32).data) == typeof(CuArray{Float32}(ψdf).data) <: CuArray{Float32, 1}
    @test typeof(cu(ψdc; word_size = 64).data) == typeof(CuArray(ψdc).data) <: CuArray{ComplexF64, 1}
    @test typeof(cu(ψdc; word_size = 32).data) == typeof(CuArray{ComplexF32}(ψdc).data) <: CuArray{ComplexF32, 1}
    @test typeof(cu(Xdi; word_size = 64).data) == typeof(CuArray(Xdi).data) <: CuArray{Int64, 2}
    @test typeof(cu(Xdi; word_size = 32).data) == typeof(CuArray{Int32}(Xdi).data) <: CuArray{Int32, 2}
    @test typeof(cu(Xdf; word_size = 64).data) == typeof(CuArray(Xdf).data) <: CuArray{Float64, 2}
    @test typeof(cu(Xdf; word_size = 32).data) == typeof(CuArray{Float32}(Xdf).data) <: CuArray{Float32, 2}
    @test typeof(cu(Xdc; word_size = 64).data) == typeof(CuArray(Xdc).data) <: CuArray{ComplexF64, 2}
    @test typeof(cu(Xdc; word_size = 32).data) == typeof(CuArray{ComplexF32}(Xdc).data) <: CuArray{ComplexF32, 2}

    # type conversion of CUDA sparse arrays
    @test typeof(cu(ψsi; word_size = 64).data) == typeof(CuSparseVector(ψsi).data) == CuSparseVector{Int64, Int32}
    @test typeof(cu(ψsi; word_size = 32).data) == typeof(CuSparseVector{Int32}(ψsi).data) == CuSparseVector{Int32, Int32}
    @test typeof(cu(ψsf; word_size = 64).data) == typeof(CuSparseVector(ψsf).data) == CuSparseVector{Float64, Int32}
    @test typeof(cu(ψsf; word_size = 32).data) ==
        typeof(CuSparseVector{Float32}(ψsf).data) ==
        CuSparseVector{Float32, Int32}
    @test typeof(cu(ψsc; word_size = 64).data) == typeof(CuSparseVector(ψsc).data) == CuSparseVector{ComplexF64, Int32}
    @test typeof(cu(ψsc; word_size = 32).data) ==
        typeof(CuSparseVector{ComplexF32}(ψsc).data) ==
        CuSparseVector{ComplexF32, Int32}
    @test typeof(cu(Xsi; word_size = 64).data) == typeof(CuSparseMatrixCSC(Xsi).data) == CuSparseMatrixCSC{Int64, Int32}
    @test typeof(cu(Xsi; word_size = 32).data) ==
        typeof(CuSparseMatrixCSC{Int32}(Xsi).data) ==
        CuSparseMatrixCSC{Int32, Int32}
    @test typeof(cu(Xsf; word_size = 64).data) ==
        typeof(CuSparseMatrixCSC(Xsf).data) ==
        CuSparseMatrixCSC{Float64, Int32}
    @test typeof(cu(Xsf; word_size = 32).data) ==
        typeof(CuSparseMatrixCSC{Float32}(Xsf).data) ==
        CuSparseMatrixCSC{Float32, Int32}
    @test typeof(cu(Xsc; word_size = 64).data) ==
        typeof(CuSparseMatrixCSC(Xsc).data) ==
        CuSparseMatrixCSC{ComplexF64, Int32}
    @test typeof(cu(Xsc; word_size = 32).data) ==
        typeof(CuSparseMatrixCSC{ComplexF32}(Xsc).data) ==
        CuSparseMatrixCSC{ComplexF32, Int32}
    @test typeof(CuSparseMatrixCSR(Xsi).data) == CuSparseMatrixCSR{Int64, Int32}
    @test typeof(CuSparseMatrixCSR{Int32}(Xsi).data) == CuSparseMatrixCSR{Int32, Int32}
    @test typeof(CuSparseMatrixCSR(Xsf).data) == CuSparseMatrixCSR{Float64, Int32}
    @test typeof(CuSparseMatrixCSR{Float32}(Xsf).data) == CuSparseMatrixCSR{Float32, Int32}
    @test typeof(CuSparseMatrixCSR(Xsc).data) == CuSparseMatrixCSR{ComplexF64, Int32}
    @test typeof(CuSparseMatrixCSR{ComplexF32}(Xsc).data) == CuSparseMatrixCSR{ComplexF32, Int32}

    # type conversion of CUDA Diagonal arrays
    @test cu(qeye(10), word_size = Val(32)).data isa Diagonal{ComplexF32, <:CuVector{ComplexF32}}
    @test cu(qeye(10), word_size = Val(64)).data isa Diagonal{ComplexF64, <:CuVector{ComplexF64}}

    # Sparse To Dense
    # @test to_dense(cu(ψsi; word_size = 64)).data isa CuVector{Int64} # TODO: Fix this in CUDA.jl
    @test to_dense(cu(ψsf; word_size = 64)).data isa CuVector{Float64}
    @test to_dense(cu(ψsc; word_size = 64)).data isa CuVector{ComplexF64}
    # @test to_dense(cu(Xsi; word_size = 64)).data isa CuMatrix{Int64} # TODO: Fix this in CUDA.jl
    @test to_dense(cu(Xsf; word_size = 64)).data isa CuMatrix{Float64}
    @test to_dense(cu(Xsc; word_size = 64)).data isa CuMatrix{ComplexF64}

    # @test to_dense(Int32, cu(ψsf; word_size = 64)).data isa CuVector{Int32} # TODO: Fix this in CUDA.jl
    # @test to_dense(Float32, cu(ψsf; word_size = 64)).data isa CuVector{Float32} # TODO: Fix this in CUDA.jl
    # @test to_dense(ComplexF32, cu(ψsf; word_size = 64)).data isa CuVector{ComplexF32} # TODO: Fix this in CUDA.jl
    # @test to_dense(Int64, cu(Xsf; word_size = 32)).data isa CuMatrix{Int64} # TODO: Fix this in CUDA.jl
    # @test to_dense(Float64, cu(Xsf; word_size = 32)).data isa CuMatrix{Float64} # TODO: Fix this in CUDA.jl
    # @test to_dense(ComplexF64, cu(Xsf; word_size = 32)).data isa CuMatrix{ComplexF64} # TODO: Fix this in CUDA.jl

    # brief example in README and documentation
    N = 20
    ω64 = 1.0    # Float64
    ω32 = 1.0f0  # Float32
    γ64 = 0.1    # Float64
    γ32 = 0.1f0  # Float32
    tlist = range(0, 10, 100)

    ## calculate by CPU (with 64-bit)
    a_cpu64 = destroy(N)
    ψ0_cpu64 = fock(N, 3)
    H_cpu64 = ω64 * a_cpu64' * a_cpu64
    c_ops_cpu64 = [sqrt(γ64) * a_cpu64]
    sol_cpu64 = mesolve(H_cpu64, ψ0_cpu64, tlist, c_ops_cpu64, e_ops = [a_cpu64' * a_cpu64], progress_bar = Val(false))

    ## calculate by CPU (with 32-bit)
    a_cpu32 = destroy(ComplexF32, N)
    ψ0_cpu32 = fock(ComplexF32, N, 3)
    H_cpu32 = ω32 * a_cpu32' * a_cpu32
    c_ops_cpu32 = [sqrt(γ32) * a_cpu32]
    sol_cpu32 = mesolve(H_cpu32, ψ0_cpu32, tlist, c_ops_cpu32, e_ops = [a_cpu32' * a_cpu32], progress_bar = Val(false))

    ## calculate by GPU (with 64-bit)
    a_gpu64 = cu(destroy(N))
    ψ0_gpu64 = cu(fock(N, 3))
    H_gpu64 = ω64 * a_gpu64' * a_gpu64
    c_ops_gpu64 = [sqrt(γ64) * a_gpu64]
    sol_gpu64 = mesolve(H_gpu64, ψ0_gpu64, tlist, c_ops_gpu64, e_ops = [a_gpu64' * a_gpu64], progress_bar = Val(false))

    ## calculate by GPU (with 32-bit)
    a_gpu32 = cu(destroy(N), word_size = 32)
    ψ0_gpu32 = cu(fock(N, 3), word_size = 32)
    H_gpu32 = ω32 * a_gpu32' * a_gpu32
    c_ops_gpu32 = [sqrt(γ32) * a_gpu32]
    sol_gpu32 = mesolve(H_gpu32, ψ0_gpu32, tlist, c_ops_gpu32, e_ops = [a_gpu32' * a_gpu32], progress_bar = Val(false))

    L_cpu64 = liouvillian(H_cpu64, c_ops_cpu64)
    L_gpu64 = liouvillian(H_gpu64, c_ops_gpu64)

    @test SparseMatrixCSC(L_gpu64.data) ≈ L_cpu64.data

    @test all([isapprox(sol_cpu64.expect[i], sol_gpu64.expect[i]) for i in 1:length(tlist)])
    @test all([isapprox(sol_cpu32.expect[i], sol_gpu32.expect[i]; atol = 1.0f-6) for i in 1:length(tlist)])
end

@testset "CUDA steadystate" begin
    N = 50
    Δ = 0.01
    F = 0.1
    γ = 0.1
    nth = 2

    a = destroy(N)
    H = Δ * a' * a + F * (a + a')
    c_ops = [sqrt(γ * (nth + 1)) * a, sqrt(γ * nth) * a']

    ρ_ss_cpu = steadystate(H, c_ops)

    H_gpu_csc = cu(H)
    c_ops_gpu_csc = [cu(c_op) for c_op in c_ops]
    ρ_ss_gpu_csc = steadystate(H_gpu_csc, c_ops_gpu_csc, solver = SteadyStateLinearSolver())

    H_gpu_csr = CuSparseMatrixCSR(H_gpu_csc)
    c_ops_gpu_csr = [CuSparseMatrixCSR(c_op) for c_op in c_ops_gpu_csc]
    ρ_ss_gpu_csr = steadystate(H_gpu_csr, c_ops_gpu_csr, solver = SteadyStateLinearSolver())

    @test ρ_ss_cpu.data ≈ Array(ρ_ss_gpu_csc.data) atol = 1.0e-8 * length(ρ_ss_cpu)
    @test ρ_ss_cpu.data ≈ Array(ρ_ss_gpu_csr.data) atol = 1.0e-8 * length(ρ_ss_cpu)
end

@testset "CUDA spectrum" begin
    N = 10
    a = cu(destroy(N))
    H = a' * a
    c_ops = [sqrt(0.1 * (0.01 + 1)) * a, sqrt(0.1 * (0.01)) * a']
    solver = Lanczos(steadystate_solver = SteadyStateLinearSolver())

    ω_l = range(0, 3, length = 1000)
    spec = spectrum(H, ω_l, c_ops, a', a; solver = solver)

    spec = collect(spec)
    spec = spec ./ maximum(spec)

    test_func = maximum(real.(spec)) * (0.1 / 2)^2 ./ ((ω_l .- 1) .^ 2 .+ (0.1 / 2)^2)
    idxs = test_func .> 0.05
    @test sum(abs2.(spec[idxs] .- test_func[idxs])) / sum(abs2.(test_func[idxs])) < 0.01

    # TODO: Fix this
    # @testset "Type Inference spectrum" begin
    #     @inferred spectrum(H, ω_l, c_ops, a', a; solver = solver)
    # end
end

@testset "CUDA ptrace" begin
    g = fock(2, 1)
    e = fock(2, 0)
    α = sqrt(0.7)
    β = sqrt(0.3) * 1im
    ψ = α * kron(g, e) + β * kron(e, g) |> cu

    ρ1 = ptrace(ψ, 1)
    ρ2 = ptrace(ψ, 2)
    @test ρ1.data isa CuArray
    @test ρ2.data isa CuArray
    @test Array(ρ1.data) ≈ [0.3 0.0; 0.0 0.7] atol = 1.0e-10
    @test Array(ρ2.data) ≈ [0.7 0.0; 0.0 0.3] atol = 1.0e-10

    ψ_d = ψ'

    ρ1 = ptrace(ψ_d, 1)
    ρ2 = ptrace(ψ_d, 2)
    @test ρ1.data isa CuArray
    @test ρ2.data isa CuArray
    @test Array(ρ1.data) ≈ [0.3 0.0; 0.0 0.7] atol = 1.0e-10
    @test Array(ρ2.data) ≈ [0.7 0.0; 0.0 0.3] atol = 1.0e-10

    ρ = ket2dm(ψ)
    ρ1 = ptrace(ρ, 1)
    ρ2 = ptrace(ρ, 2)
    @test ρ.data isa CuArray
    @test ρ1.data isa CuArray
    @test ρ2.data isa CuArray
    @test Array(ρ1.data) ≈ [0.3 0.0; 0.0 0.7] atol = 1.0e-10
    @test Array(ρ2.data) ≈ [0.7 0.0; 0.0 0.3] atol = 1.0e-10

    ψ1 = normalize(g + 1im * e)
    ψ2 = normalize(g + e)
    ρ1 = ket2dm(ψ1)
    ρ2 = ket2dm(ψ2)
    ρ = kron(ρ1, ρ2) |> cu
    ρ1_ptr = ptrace(ρ, 1)
    ρ2_ptr = ptrace(ρ, 2)
    @test ρ1_ptr.data isa CuArray
    @test ρ2_ptr.data isa CuArray
    @test ρ1.data ≈ Array(ρ1_ptr.data) atol = 1.0e-10
    @test ρ2.data ≈ Array(ρ2_ptr.data) atol = 1.0e-10

    ψlist = [rand_ket(2), rand_ket(3), rand_ket(4), rand_ket(5)]
    ρlist = [rand_dm(2), rand_dm(3), rand_dm(4), rand_dm(5)]
    ψtotal = tensor(ψlist...) |> cu
    ρtotal = tensor(ρlist...) |> cu
    sel_tests = (
        1,
        2,
        3,
        4,
        (1, 2),
        (1, 3),
        (1, 4),
        (2, 3),
        (2, 4),
        (3, 4),
        (1, 2, 3),
        (1, 2, 4),
        (1, 3, 4),
        (2, 3, 4),
        (1, 2, 3, 4),
    )
    for sel in sel_tests
        if length(sel) == 0
            @test ptrace(ψtotal, sel) ≈ 1.0
            @test ptrace(ρtotal, sel) ≈ 1.0
        else
            @test ptrace(ψtotal, sel) ≈ cu(tensor([ket2dm(ψlist[i]) for i in sel]...))
            @test ptrace(ρtotal, sel) ≈ cu(tensor([ρlist[i] for i in sel]...))
        end
    end
    @test ptrace(ψtotal, (1, 3, 4)) ≈ ptrace(ψtotal, (4, 3, 1)) # check sort of sel
    @test ptrace(ρtotal, (1, 3, 4)) ≈ ptrace(ρtotal, (3, 1, 4)) # check sort of sel

    @testset "Type Inference (ptrace)" begin
        @inferred ptrace(ρ, 1)
        @inferred ptrace(ρ, 2)
        @inferred ptrace(ψ_d, 1)
        @inferred ptrace(ψ_d, 2)
        @inferred ptrace(ψ, 1)
        @inferred ptrace(ψ, 2)
    end
end

@testset "CUDA eigsolve" begin
    N = 30
    Δ = 0.5
    U = 0.1
    κ = 0.1
    F = 0.5

    a = destroy(N)
    H = Δ * a' * a + U / 2 * a' * a' * a * a + F * (a + a')
    H_gpu = cu(H)

    c_ops = [sqrt(κ) * a]

    L = liouvillian(H, c_ops)
    L_gpu = CuSparseMatrixCSR(L)

    # Dense eigen solver for Hamiltonian
    vals_H_cpu, vecs_H_cpu = eigenstates(H)
    vals_H_gpu, vecs_H_gpu = eigenstates(H_gpu)

    @test vals_H_cpu ≈ Array(vals_H_gpu) atol = 1.0e-8
    @test all(zip(vecs_H_cpu, vecs_H_gpu)) do (v_cpu, v_gpu)
        return isapprox(abs(dot(v_cpu.data, Array(v_gpu.data))), 1; atol = 1.0e-8)
    end

    # Sparse eigen solver for Liouvillian
    vals_cpu, vecs_cpu = eigenstates(L; sparse = Val(true), sigma = 0.01, eigvals = 4, krylovdim = 30)
    vals_gpu, vecs_gpu = eigenstates(
        L_gpu;
        sparse = Val(true),
        sigma = 0.01,
        eigvals = 4,
        krylovdim = 30,
        solver = LUFactorization(),
        v0 = normalize!(CUDA.rand(ComplexF64, size(L_gpu, 1))),
    )

    @test vals_cpu ≈ vals_gpu atol = 1.0e-8
    @test all(zip(vecs_cpu, vecs_gpu)) do (v_cpu, v_gpu)
        return isapprox(abs(dot(v_cpu.data, Array(v_gpu.data))), 1; atol = 1.0e-8)
    end

    # Arnoldi-Lindblad eigen solver for Liouvillian
    vals_al_cpu, vecs_al_cpu = eigsolve_al(L, 1 \ (30 * κ); eigvals = 4, liouvillian_eigs = Val(false))
    vals_al_gpu, vecs_al_gpu = eigsolve_al(
        L_gpu,
        1 \ (30 * κ);
        eigvals = 4,
        liouvillian_eigs = Val(false),
        ρ0 = cu(operator_to_vector(rand_dm(N))),
    )

    sort_func = x -> (round(abs(x), digits = 6), round(real(x), digits = 6), round(imag(x), digits = 6))

    idxs_al_cpu = sortperm(vals_al_cpu, by = sort_func, rev = false)
    idxs_al_gpu = sortperm(vals_al_gpu, by = sort_func, rev = false)
    vals_al_cpu = vals_al_cpu[idxs_al_cpu]
    vecs_al_cpu = vecs_al_cpu[idxs_al_cpu]
    vals_al_gpu = vals_al_gpu[idxs_al_gpu]
    vecs_al_gpu = vecs_al_gpu[idxs_al_gpu]

    @test vals_al_cpu ≈ vals_al_gpu atol = 1.0e-7
    @test all(zip(vecs_al_cpu, vecs_al_gpu)) do (v_cpu, v_gpu)
        return isapprox(abs(dot(v_cpu.data, Array(v_gpu.data))), 1; atol = 1.0e-8)
    end
end

@testitem "Excitation number restricted state space" begin
    using StaticArraysCore
    using SparseArrays

    @testset "EnrSpace" begin
        s_enr = EnrSpace((2, 2, 3), 3)

        # check if the idx2state is the same as qutip
        qutip_idx2state = Dict(
            1 => SVector{3}(0, 0, 0),
            2 => SVector{3}(0, 0, 1),
            3 => SVector{3}(0, 0, 2),
            4 => SVector{3}(0, 1, 0),
            5 => SVector{3}(0, 1, 1),
            6 => SVector{3}(0, 1, 2),
            7 => SVector{3}(1, 0, 0),
            8 => SVector{3}(1, 0, 1),
            9 => SVector{3}(1, 0, 2),
            10 => SVector{3}(1, 1, 0),
            11 => SVector{3}(1, 1, 1),
        )
        @test s_enr.idx2state == qutip_idx2state
    end

    @testset "Element type" begin
        s_enr = EnrSpace((2, 2, 3), 3)
        float_type_list = [Float32, BigFloat]
        for FT in float_type_list
            CT = Complex{FT}
            @test CT == eltype(enr_fock(CT, s_enr, zeros(Int, 3)))
            @test FT == eltype(enr_thermal_dm(s_enr, rand(FT); sparse = Val(true)))
            @test FT == eltype(enr_thermal_dm(s_enr, rand(FT, 3); sparse = Val(false)))
            @test all(==(CT), eltype.(enr_destroy(CT, s_enr)))
            @test CT == eltype(enr_identity(CT, s_enr))
        end
    end

    @testset "kron" begin
        # normal HilbertSpace
        D1 = 4
        D2 = 5
        dims_s = (D1, D2)
        ρ_s = rand_dm(dims_s)
        I_s = qeye(D1) ⊗ qeye(D2)
        size_s = prod(dims_s)
        space_s = (HilbertSpace(D1), HilbertSpace(D2))

        # EnrSpace
        dims_enr = (2, 3, 2)
        excitations = 4
        space_enr = EnrSpace(dims_enr, excitations)
        I_enr = enr_identity(space_enr)
        size_enr = space_enr.size

        # enr_thermal_dm (extreme cases)
        ρTd0 = enr_thermal_dm(space_enr, 0.0)
        ρTs0 = enr_thermal_dm(space_enr, 0.0; sparse = Val(true))
        ρTd∞ = enr_thermal_dm(space_enr, Inf)
        ρTs∞ = enr_thermal_dm(space_enr, Inf; sparse = Val(true))
        @test tr(ρTd0) ≈ tr(ρTs0) ≈ tr(ρTd∞) ≈ tr(ρTs∞) ≈ 1.0
        @test ρTd0.data ≈ ρTs0.data ≈ fock_dm(size_enr, 0).data
        @test ρTd∞.data ≈ ρTs∞.data ≈ maximally_mixed_dm(size_enr).data

        # general case (also test Int and BigFloat)
        nvec = BigFloat[0.123, 0.456, 0.789]
        ρTI = enr_thermal_dm(space_enr, Int64[1, 2, 3]; sparse = Val(false))
        ρTd = enr_thermal_dm(space_enr, nvec)
        ρTs = enr_thermal_dm(space_enr, nvec; sparse = Val(true))
        @test eltype(ρTI.data) == Float64
        @test isoper(ρTd)
        @test tr(ρTd) ≈ tr(ρTs) ≈ 1.0
        @test diag(ρTd) ≈ Float64[
            0.44317797863426783,
            0.19545412249437527,
            0.13879749880303996,
            0.06121365374823841,
            0.0434695463284246,
            0.019171309140931812,
            0.04854041974355738,
            0.021407708875163092,
            0.015202219370235007,
            0.006704612120243388,
            0.004761134637930744,
            0.0020997961035927096,
        ]
        @test ρTs.data isa AbstractSparseMatrix
        @test ρTd ≈ ρTs

        # tensor between normal and ENR space
        ρ_enr = enr_thermal_dm(space_enr, rand(3))
        ρ_tot = tensor(ρ_s, ρ_enr)
        opstring = sprint((t, s) -> show(t, "text/plain", s), ρ_tot)
        datastring = sprint((t, s) -> show(t, "text/plain", s), ρ_tot.data)
        ρ_tot_dims = ρ_tot.dims  # Now returns tuple format
        ρ_tot_size = size_s * size_enr
        ρ_tot_isherm = isherm(ρ_tot)
        @test opstring ==
            "\nQuantum Object:   type=Operator()   dims=$ρ_tot_dims   size=$((ρ_tot_size, ρ_tot_size))   ishermitian=$ρ_tot_isherm\n$datastring"

        # use non-square ProductDimensions to do partial trace
        new_dims1 = ProductDimensions(
            (HilbertSpace(1), HilbertSpace(1), space_enr),
            (HilbertSpace(1), HilbertSpace(1), space_enr),
        )
        ρ_enr_compound = Qobj(zeros(ComplexF64, size_enr, size_enr), dims = new_dims1)
        basis_list = [tensor(basis(D1, i), basis(D2, j)) for i in 0:(D1 - 1) for j in 0:(D2 - 1)]
        for b in basis_list
            ρ_enr_compound += tensor(b', I_enr) * ρ_tot * tensor(b, I_enr)
        end
        new_dims2 = ProductDimensions(
            (space_s..., HilbertSpace(1), HilbertSpace(1), HilbertSpace(1)),
            (space_s..., HilbertSpace(1), HilbertSpace(1), HilbertSpace(1)),
        )
        ρ_s_compound = Qobj(zeros(ComplexF64, size_s, size_s), dims = new_dims2)
        basis_list = [enr_fock(space_enr, space_enr.idx2state[idx]) for idx in 1:space_enr.size]
        for b in basis_list
            ρ_s_compound += tensor(I_s, b') * ρ_tot * tensor(I_s, b)
        end
        @test ρ_enr.data ≈ ρ_enr_compound.data
        @test ρ_s.data ≈ ρ_s_compound.data
    end

    @testset "mesolve, steadystate, and eigenstates" begin
        ε = 2π
        ωc = 2π
        g = 0.1ωc
        γ = 0.01ωc
        tlist = range(0, 20, 100)
        N_cut = 2

        # normal mesolve and steadystate
        sz = sigmaz() ⊗ qeye(N_cut)
        sm = sigmam() ⊗ qeye(N_cut)
        a = qeye(2) ⊗ destroy(N_cut)
        H_JC = 0.5ε * sz + ωc * a' * a + g * (sm' * a + a' * sm)
        c_ops_JC = (√γ * a,)
        ψ0_JC = basis(2, 0) ⊗ fock(N_cut, 0)
        sol_JC = mesolve(H_JC, ψ0_JC, tlist, c_ops_JC; e_ops = [sz], progress_bar = Val(false))
        ρ_ss_JC = steadystate(H_JC, c_ops_JC)

        # ENR mesolve and steadystate
        N_exc = 1
        dims = (2, N_cut)
        sm_enr, a_enr = enr_destroy(dims, N_exc)
        sz_enr = 2 * sm_enr' * sm_enr - 1
        ψ0_enr = enr_fock(dims, N_exc, [1, 0])
        H_enr = ε * sm_enr' * sm_enr + ωc * a_enr' * a_enr + g * (sm_enr' * a_enr + a_enr' * sm_enr)
        c_ops_enr = (√γ * a_enr,)
        sol_enr = mesolve(H_enr, ψ0_enr, tlist, c_ops_enr; e_ops = [sz_enr], progress_bar = Val(false))
        ρ_ss_enr = steadystate(H_enr, c_ops_enr)

        # check mesolve result
        @test all(isapprox.(sol_JC.expect, sol_enr.expect, atol = 1.0e-4))

        # check steadystate result
        @test expect(sz, ρ_ss_JC) ≈ expect(sz_enr, ρ_ss_enr) atol = 1.0e-4

        # check eigenstates
        λ, v = eigenstates(H_enr)
        @test all([H_enr * v[k] ≈ λ[k] * v[k] for k in eachindex(λ)])
    end

    @testset "Type Inference" begin
        N = 3
        dims = (2, 2, 3)
        excitations = 3
        @inferred enr_identity(dims, excitations)
        @inferred enr_fock(dims, excitations, zeros(Int, N))
        @inferred enr_destroy(dims, excitations)
        @inferred enr_thermal_dm(dims, excitations, rand(N))
    end
end

#=
This file defines the QuantumObjectEvolution (QobjEvo) structure.
=#

export QuantumObjectEvolution

@doc raw"""
    struct QuantumObjectEvolution{ObjType<:QuantumObjectType,DimType<:Dimensions,DataType<:AbstractSciMLOperator} <: AbstractQuantumObject{ObjType,DimType,DataType}
        data::DataType
        type::ObjType
        dimensions::DimType
    end

Julia struct representing any time-dependent quantum object. The `data` field is a `AbstractSciMLOperator` object that represents the time-dependent quantum object. It can be seen as

```math
\hat{O}(t) = \sum_{i} c_i(p, t) \hat{O}_i
```

where ``c_i(p, t)`` is a function that depends on the parameters `p` and time `t`, and ``\hat{O}_i`` are the operators that form the quantum object. 

For time-independent cases, see [`QuantumObject`](@ref), and for more information about `AbstractSciMLOperator`, see the [SciML](https://docs.sciml.ai/SciMLOperators/stable/) documentation.

!!! note "`dims` property"
    For a given `H::QuantumObjectEvolution`, `H.dims` or `getproperty(H, :dims)` returns its `dimensions` in the type of integer-vector.

# Examples
This operator can be initialized in the same way as the QuTiP `QobjEvo` object. For example
```jldoctest qobjevo
julia> a = tensor(destroy(10), qeye(2))

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 18 stored entries:
⎡⠀⠑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠀⠑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠀⠑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠑⎦

julia> coef1(p, t) = exp(-1im * t)
coef1 (generic function with 1 method)

julia> op = QobjEvo(a, coef1)

Quantum Object Evo.:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=true   isconstant=false
ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20)
```

If there are more than 2 operators, we need to put each set of operator and coefficient function into a two-element `Tuple`, and put all these `Tuple`s together in a larger `Tuple`:

```jldoctest qobjevo
julia> σm = tensor(qeye(10), sigmam())

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 10 stored entries:
⎡⠂⡀⠀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠂⡀⠀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠂⡀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠂⡀⠀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠂⡀⎦

julia> coef2(p, t) = sin(t)
coef2 (generic function with 1 method)

julia> op1 = QobjEvo(((a, coef1), (σm, coef2)))

Quantum Object Evo.:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=true   isconstant=false
(ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20) + ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20))
```

We can also concretize the operator at a specific time `t`
```jldoctest qobjevo
julia> op1(0.1)

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 28 stored entries:
⎡⠂⡑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠂⡑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠂⡑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠂⡑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠂⡑⎦
```

It also supports parameter-dependent time evolution
```jldoctest qobjevo
julia> coef1(p, t) = exp(-1im * p.ω1 * t)
coef1 (generic function with 1 method)

julia> coef2(p, t) = sin(p.ω2 * t)
coef2 (generic function with 1 method)

julia> op1 = QobjEvo(((a, coef1), (σm, coef2)))

Quantum Object Evo.:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=true   isconstant=false
(ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20) + ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20))

julia> p = (ω1 = 1.0, ω2 = 0.5)
(ω1 = 1.0, ω2 = 0.5)

julia> op1(p, 0.1)

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 28 stored entries:
⎡⠂⡑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠂⡑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠂⡑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠂⡑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠂⡑⎦
```
"""
struct QuantumObjectEvolution{
        ObjType <: Union{Operator, SuperOperator},
        DimType <: Dimensions,
        DataType <: AbstractSciMLOperator,
    } <: AbstractQuantumObject{ObjType, DimType, DataType}
    data::DataType
    type::ObjType
    dimensions::DimType

    function QuantumObjectEvolution(data::DT, type, dims) where {DT <: AbstractSciMLOperator}
        ObjType = _check_type(type)
        (type isa Operator || type isa SuperOperator) ||
            throw(ArgumentError("The type $type is not supported for QuantumObjectEvolution."))

        dimensions = _gen_dimensions(type, dims)

        _check_QuantumObject(type, dimensions, size(data))

        return new{ObjType, typeof(dimensions), DT}(data, type, dimensions)
    end
end

function Base.show(io::IO, QO::QuantumObjectEvolution)
    op_data = QO.data
    println(
        io,
        "\nQuantum Object Evo.:   type=",
        QO.type,
        "   dims=",
        _get_dims_string(QO.dimensions),
        "   size=",
        size(op_data),
        "   ishermitian=",
        ishermitian(op_data),
        "   isconstant=",
        isconstant(op_data),
    )
    return show(io, MIME("text/plain"), op_data)
end

@doc raw"""
    QobjEvo(data::AbstractSciMLOperator; type = Operator(), dims = nothing)
    QuantumObjectEvolution(data::AbstractSciMLOperator; type = Operator(), dims = nothing)

Generate a [`QuantumObjectEvolution`](@ref) object from a [`SciMLOperator`](https://github.com/SciML/SciMLOperators.jl), in the same way as [`QuantumObject`](@ref) for `AbstractArray` inputs.

Note that `QobjEvo` is a synonym of `QuantumObjectEvolution`
"""
function QuantumObjectEvolution(data::AbstractSciMLOperator; type = Operator(), dims = nothing)
    _check_type(type)

    if dims isa Nothing
        if type isa Operator
            dims = ((size(data, 1),), (size(data, 2),))
        elseif type isa SuperOperator
            sm = isqrt(size(data, 1))
            sn = isqrt(size(data, 2))
            dims = (((sm,), (sm,)), ((sn,), (sn,)))
        end
    end

    return QuantumObjectEvolution(data, type, dims)
end

@doc raw"""
    QobjEvo(op_func_list::Union{Tuple,AbstractQuantumObject}; type=nothing)
    QuantumObjectEvolution(op_func_list::Union{Tuple,AbstractQuantumObject}; type=nothing)

Generate [`QuantumObjectEvolution`](@ref).

# Arguments
- `op_func_list::Union{Tuple,AbstractQuantumObject}`: A tuple of tuples or operators.

!!! warning "Beware of type-stability!"
    Please note that, unlike QuTiP, this function doesn't support `op_func_list` as `Vector` type. This is related to the type-stability issue. See the Section [The Importance of Type-Stability](@ref doc:Type-Stability) for more details.

The `type` parameter is used to specify the type of the [`QuantumObject`](@ref), either `Operator` or `SuperOperator`.

!!! note
    `QobjEvo` is a synonym of `QuantumObjectEvolution`.

# Examples
This operator can be initialized in the same way as the QuTiP `QobjEvo` object. For example
```jldoctest qobjevo
julia> a = tensor(destroy(10), qeye(2))

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 18 stored entries:
⎡⠀⠑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠀⠑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠀⠑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠑⎦

julia> σm = tensor(qeye(10), sigmam())

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 10 stored entries:
⎡⠂⡀⠀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠂⡀⠀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠂⡀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠂⡀⠀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠂⡀⎦

julia> coef1(p, t) = exp(-1im * t)
coef1 (generic function with 1 method)

julia> coef2(p, t) = sin(t)
coef2 (generic function with 1 method)

julia> op1 = QobjEvo(((a, coef1), (σm, coef2)))

Quantum Object Evo.:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=true   isconstant=false
(ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20) + ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20))
```

We can also concretize the operator at a specific time `t`
```jldoctest qobjevo
julia> op1(0.1)

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 28 stored entries:
⎡⠂⡑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠂⡑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠂⡑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠂⡑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠂⡑⎦
```

It also supports parameter-dependent time evolution
```jldoctest qobjevo
julia> coef1(p, t) = exp(-1im * p.ω1 * t)
coef1 (generic function with 1 method)

julia> coef2(p, t) = sin(p.ω2 * t)
coef2 (generic function with 1 method)

julia> op1 = QobjEvo(((a, coef1), (σm, coef2)))

Quantum Object Evo.:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=true   isconstant=false
(ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20) + ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20))

julia> p = (ω1 = 1.0, ω2 = 0.5)
(ω1 = 1.0, ω2 = 0.5)

julia> op1(p, 0.1)

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 28 stored entries:
⎡⠂⡑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠂⡑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠂⡑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠂⡑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠂⡑⎦
```
"""
function QuantumObjectEvolution(op_func_list::Tuple; type = nothing)
    op, data = _QobjEvo_generate_data(op_func_list)
    dims = op.dimensions
    _check_type(type)

    if type isa Nothing
        type = op.type
    end

    # Preallocate the SciMLOperator cache using a dense vector as a reference
    v0 = to_dense(similar(op.data, size(op, 1)))
    data = cache_operator(data, v0)

    return QuantumObjectEvolution(data, type, dims)
end

# this is a extra method if user accidentally specify `QuantumObjectEvolution( (op, func) )` or `QuantumObjectEvolution( ((op, func)) )`
QuantumObjectEvolution(op_func::Tuple{<:QuantumObject, <:Function}; type = nothing) =
    QuantumObjectEvolution((op_func,); type = type)

@doc raw"""
    QuantumObjectEvolution(op::QuantumObject, f::Function; type = nothing)
    QobjEvo(op::QuantumObject, f::Function; type = nothing)

Generate [`QuantumObjectEvolution`](@ref).

# Notes
- The `f` parameter is time-dependent coefficient that multiplies the operator. The `type` parameter is used to specify the type of the [`QuantumObject`](@ref), either `Operator` or `SuperOperator`.
- `QobjEvo` is a synonym of `QuantumObjectEvolution`.

# Examples
```jldoctest
julia> a = tensor(destroy(10), qeye(2))

Quantum Object:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 18 stored entries:
⎡⠀⠑⢄⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠀⠑⢄⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠑⢄⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠀⠑⢄⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠀⠑⎦

julia> coef(p, t) = exp(-1im * t)
coef (generic function with 1 method)

julia> op = QobjEvo(a, coef)

Quantum Object Evo.:   type=Operator()   dims=([10, 2], [10, 2])   size=(20, 20)   ishermitian=true   isconstant=false
ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20)
```
"""
QuantumObjectEvolution(op::QuantumObject, f::Function; type = nothing) = QuantumObjectEvolution(((op, f),); type = type)

function QuantumObjectEvolution(op::QuantumObject; type = nothing)
    _check_type(type)
    if type isa Nothing
        type = op.type
    end
    return QuantumObjectEvolution(_make_SciMLOperator(op), type, op.dimensions)
end

function QuantumObjectEvolution(op::QuantumObjectEvolution; type = nothing)
    _check_type(type)
    if type isa Nothing
        type = op.type
    elseif type != op.type
        throw(
            ArgumentError(
                "The type of the QuantumObjectEvolution object cannot be changed when using another QuantumObjectEvolution object as input.",
            ),
        )
    end
    return QuantumObjectEvolution(op.data, type, op.dimensions)
end

#=
    _QobjEvo_generate_data(op_func_list::Tuple)

Parse the `op_func_list` and generate the data for the `QuantumObjectEvolution` object. The `op_func_list` is a tuple of tuples or operators. Each element of the tuple can be a tuple with two elements (operator, function) or an operator. The function is used to generate the time-dependent coefficients for the operators. During the parsing, the dimensions of the operators are checked to be the same, and all the constant operators are summed together.

# Arguments
- `op_func_list::Tuple`: A tuple of tuples or operators.
=#
function _QobjEvo_generate_data(op_func_list::Tuple)
    first_op = _QobjEvo_get_first_op(op_func_list[1])

    ops_constant = filter(op_func_list) do x
        if x isa QuantumObject
            x.type == first_op.type || throw(ArgumentError("The types of the operators must be the same."))
            x.dimensions == first_op.dimensions ||
                throw(ArgumentError("The dimensions of the operators must be the same."))
            return true
        elseif x isa Tuple
            return false
        else
            throw(ArgumentError("Each element of the tuple must be either a QuantumObject or a Tuple."))
        end
    end

    ops_time_dep = filter(op_func_list) do x
        if x isa Tuple
            _QobjEvo_check_op_func(x)
            op = x[1]
            _QobjEvo_check_op(op)
            op.type == first_op.type || throw(ArgumentError("The types of the operators must be the same."))
            op.dimensions == first_op.dimensions ||
                throw(ArgumentError("The dimensions of the operators must be the same."))
            return true
        elseif x isa QuantumObject
            return false
        else
            throw(ArgumentError("Each element of the tuple must be either a QuantumObject or a Tuple."))
        end
    end

    data_const = isempty(ops_constant) ? zero(eltype(first_op)) : _make_SciMLOperator(sum(ops_constant))
    data_td =
        length(ops_time_dep) == 1 ? _make_SciMLOperator(ops_time_dep[1]) :
        AddedOperator(map(_make_SciMLOperator, ops_time_dep))
    data = data_const + data_td

    return first_op, data
end

function _QobjEvo_check_op(op::AbstractQuantumObject)
    (isoper(op) || issuper(op)) || throw(ArgumentError("The element must be a Operator or SuperOperator."))
    return nothing
end

function _QobjEvo_check_op_func(op_func::Tuple)
    length(op_func) == 2 || throw(ArgumentError("The tuple must have two elements."))
    _QobjEvo_check_op(op_func[1])
    (op_func[2] isa Function) || throw(ArgumentError("The second element must be a function."))
    methods(op_func[2], (Any, Real)) |> length == 0 && throw(
        ArgumentError(
            "The following function must only accept two arguments: `$(nameof(op_func[2]))(p, t)` with t<:Real",
        ),
    )
    return nothing
end

_QobjEvo_get_first_op(op_func_list_1::Union{Tuple, AbstractQuantumObject}) =
if op_func_list_1 isa Tuple
    _QobjEvo_check_op_func(op_func_list_1)
    op = op_func_list_1[1]
    _QobjEvo_check_op(op)
    return op
else
    op = op_func_list_1
    _QobjEvo_check_op(op)
    return op
end

function _make_SciMLOperator(op_func::Tuple)
    op, coef = op_func
    T = eltype(op)
    update_func = (a, u, p, t) -> coef(p, t)
    return ScalarOperator(zero(T), update_func) * _promote_to_scimloperator(op.data)
end
_make_SciMLOperator(op::AbstractQuantumObject) = _promote_to_scimloperator(op.data)

_promote_to_scimloperator(data::AbstractMatrix) = MatrixOperator(data)
_promote_to_scimloperator(data::AbstractSciMLOperator) = data

@doc raw"""
    (A::QuantumObjectEvolution)(ψout, ψin, p, t)

Apply the time-dependent [`QuantumObjectEvolution`](@ref) object `A` to the input state `ψin` at time `t` with parameters `p`. The output state is stored in `ψout`. This function mimics the behavior of a `AbstractSciMLOperator` object.

# Arguments
- `ψout::QuantumObject`: The output state. It must have the same type as `ψin`.
- `ψin::QuantumObject`: The input state. It must be either a [`Ket`](@ref) or a [`OperatorKet`](@ref).
- `p`: The parameters of the time-dependent coefficients.
- `t`: The time at which the coefficients are evaluated.

# Returns
- `ψout::QuantumObject`: The output state.

# Examples
```jldoctest
julia> a = destroy(20)

Quantum Object:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 19 stored entries:
⎡⠈⠢⡀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠈⠢⡀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠈⠢⡀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠈⠢⡀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠈⠢⎦

julia> coef1(p, t) = sin(t)
coef1 (generic function with 1 method)

julia> coef2(p, t) = cos(t)
coef2 (generic function with 1 method)

julia> A = QobjEvo(((a, coef1), (a', coef2)))

Quantum Object Evo.:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=true   isconstant=false
(ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20) + ScalarOperator(0.0 + 0.0im) * MatrixOperator(20 × 20))

julia> ψ1 = fock(20, 3);

julia> ψ2 = zero_ket(20);

julia> A(ψ2, ψ1, nothing, 0.1) ≈ A(0.1) * ψ1
true
```
"""
function (A::QuantumObjectEvolution)(
        ψout::QuantumObject{QobjType},
        ψin::QuantumObject{QobjType},
        p,
        t,
    ) where {QobjType <: Union{Ket, OperatorKet}}
    if isoper(A) && isoperket(ψin)
        throw(ArgumentError("The input state must be a Ket if the QuantumObjectEvolution object is an Operator."))
    elseif issuper(A) && isket(ψin)
        throw(
            ArgumentError(
                "The input state must be an OperatorKet if the QuantumObjectEvolution object is a SuperOperator.",
            ),
        )
    end
    check_mul_dimensions(A, ψin)
    check_dimensions(ψout, ψin)

    A.data(ψout.data, ψin.data, nothing, p, t)

    return ψout
end

@doc raw"""
    (A::QuantumObjectEvolution)(ψ, p, t)

Apply the time-dependent [`QuantumObjectEvolution`](@ref) object `A` to the input state `ψ` at time `t` with parameters `p`. Out-of-place version of [`(A::QuantumObjectEvolution)(ψout, ψin, p, t)`](@ref). The output state is stored in a new [`QuantumObject`](@ref) object. This function mimics the behavior of a `AbstractSciMLOperator` object.
"""
function (A::QuantumObjectEvolution)(ψ::QuantumObject{QobjType}, p, t) where {QobjType <: Union{Ket, OperatorKet}}
    ψout = QuantumObject(similar(ψ.data), ψ.type, ψ.dimensions)
    return A(ψout, ψ, p, t)
end

@doc raw"""
    (A::QuantumObjectEvolution)(p, t)

Calculate the time-dependent [`QuantumObjectEvolution`](@ref) object `A` at time `t` with parameters `p`.

# Arguments
- `p`: The parameters of the time-dependent coefficients.
- `t`: The time at which the coefficients are evaluated.

# Returns
- `A::QuantumObject`: The output state.
"""
function (A::QuantumObjectEvolution)(p, t)
    # We put 0 in the place of `u` because the time-dependence doesn't depend on the state
    update_coefficients!(A.data, 0, p, t)
    return QuantumObject(concretize(A.data), A.type, A.dimensions)
end

(A::QuantumObjectEvolution)(t) = A(nothing, t)

#=
`promote_type` should be applied on types. Here I define `promote_op_type` because it is applied to operators.
=#
promote_op_type(A::QuantumObjectEvolution, B::QuantumObjectEvolution) = get_typename_wrapper(A)
promote_op_type(A::QuantumObjectEvolution, B::QuantumObject) = get_typename_wrapper(A)
promote_op_type(A::QuantumObject, B::QuantumObjectEvolution) = get_typename_wrapper(B)
promote_op_type(A::QuantumObject, B::QuantumObject) = get_typename_wrapper(A)

#=
Utilities:
    internal (or external) functions which will be used throughout the entire package
=#

export gaussian, n_thermal
export PhysicalConstants, convert_unit
export row_major_reshape, meshgrid

@doc raw"""
    row_major_reshape(Q::AbstractArray, shapes...)

Reshapes `Q` in the row-major order, as numpy.
"""
row_major_reshape(Q::AbstractArray{T}, shapes...) where {T} =
    PermutedDimsArray(reshape(Q, reverse(shapes)...), (length(shapes):-1:1))

@doc raw"""
    meshgrid(x::AbstractVector, y::AbstractVector)

Equivalent to [numpy meshgrid](https://numpy.org/doc/stable/reference/generated/numpy.meshgrid.html).
"""
function meshgrid(x::AbstractVector{T}, y::AbstractVector{T}) where {T}
    X = reshape(repeat(x, inner = length(y)), length(y), length(x))
    Y = repeat(y, outer = (1, length(x)))
    return X, Y
end

@doc raw"""
    gaussian(x::Number, μ::Number, σ::Number)

Returns the gaussian function ``\exp \left[- \frac{(x - \mu)^2}{2 \sigma^2} \right]``,
where ``\mu`` and ``\sigma^2`` are the mean and the variance respectively.
"""
gaussian(x::Number, μ::Number, σ::Number) = exp(-(x - μ)^2 / (2 * σ^2))

@doc raw"""
    n_thermal(ω::Real, ω_th::Real)

Return the number of photons in thermal equilibrium for an harmonic oscillator mode with frequency ``\omega``, at the temperature described by ``\omega_{\textrm{th}} \equiv k_B T / \hbar``:
```math
n(\omega, \omega_{\textrm{th}}) = \frac{1}{e^{\omega/\omega_{\textrm{th}}} - 1},
```
where ``\hbar`` is the reduced Planck constant, and ``k_B`` is the Boltzmann constant.
"""
function n_thermal(ω::T1, ω_th::T2) where {T1 <: Real, T2 <: Real}
    x = exp(ω / ω_th)
    n = ((x != 1) && (ω_th > 0)) ? 1 / (x - 1) : 0
    return _float_type(promote_type(T1, T2))(n)
end

@doc raw"""
    const PhysicalConstants

A `NamedTuple` which stores some constant values listed in [*CODATA recommended values of the fundamental physical constants: 2022*](https://physics.nist.gov/cuu/pdf/wall_2022.pdf)

The current stored constants are:
- `c` : (exact) speed of light in vacuum with unit ``[\textrm{m}\cdot\textrm{s}^{-1}]``
- `G` : Newtonian constant of gravitation with unit ``[\textrm{m}^3\cdot\textrm{kg}^{−1}\cdot\textrm{s}^{−2}]``
- `h` : (exact) Planck constant with unit ``[\textrm{J}\cdot\textrm{s}]``
- `ħ` : reduced Planck constant with unit ``[\textrm{J}\cdot\textrm{s}]``
- `e` : (exact) elementary charge with unit ``[\textrm{C}]``
- `μ0` : vacuum magnetic permeability with unit ``[\textrm{N}\cdot\textrm{A}^{-2}]``
- `ϵ0` : vacuum electric permittivity with unit ``[\textrm{F}\cdot\textrm{m}^{-1}]``
- `k` : (exact) Boltzmann constant with unit ``[\textrm{J}\cdot\textrm{K}^{-1}]``
- `NA` : (exact) Avogadro constant with unit ``[\textrm{mol}^{-1}]``

# Examples

```jldoctest
julia> PhysicalConstants.ħ
1.0545718176461565e-34
```
"""
const PhysicalConstants = (
    c = 299792458.0,
    G = 6.6743e-11,
    h = 6.62607015e-34,
    ħ = 6.62607015e-34 / (2 * π),
    e = 1.602176634e-19,
    μ0 = 1.25663706127e-6,
    ϵ0 = 8.8541878188e-12,
    k = 1.380649e-23,
    NA = 6.02214076e23,
)

# common energy units (the values below are all in the unit of Joule)
const _energy_units::Dict{Symbol, Float64} = Dict(
    :J => 1.0,
    :eV => PhysicalConstants.e,
    :meV => 1.0e-3 * PhysicalConstants.e,
    :MHz => 1.0e6 * PhysicalConstants.h,
    :GHz => 1.0e9 * PhysicalConstants.h,
    :K => PhysicalConstants.k,
    :mK => 1.0e-3 * PhysicalConstants.k,
)

@doc raw"""
    convert_unit(value::Real, unit1::Symbol, unit2::Symbol)

Convert the energy `value` from `unit1` to `unit2`. The `unit1` and `unit2` can be either the following `Symbol`:
- `:J` : Joule
- `:eV` : electron volt
- `:meV` : milli-electron volt
- `:MHz` : Mega-Hertz multiplied by Planck constant ``h``
- `:GHz` : Giga-Hertz multiplied by Planck constant ``h``
- `:K` : Kelvin multiplied by Boltzmann constant ``k``
- `:mK` : milli-Kelvin multiplied by Boltzmann constant ``k``

Note that we use the values stored in [`PhysicalConstants`](@ref) to do the conversion.

# Examples

```jldoctest
julia> convert_unit(1, :eV, :J)
1.602176634e-19

julia> convert_unit(1, :GHz, :J)
6.62607015e-25

julia> round(convert_unit(1, :meV, :mK), digits=4)
11604.5181
```
"""
function convert_unit(value::T, unit1::Symbol, unit2::Symbol) where {T <: Real}
    !haskey(_energy_units, unit1) && throw(ArgumentError("Invalid unit :$(unit1)"))
    !haskey(_energy_units, unit2) && throw(ArgumentError("Invalid unit :$(unit2)"))
    return _float_type(T)(value * (_energy_units[unit1] / _energy_units[unit2]))
end

get_typename_wrapper(A) = Base.typename(typeof(A)).wrapper

_dense_similar(A::AbstractArray, args...) = similar(A, args...)
_dense_similar(A::AbstractSparseMatrix, args...) = similar(nonzeros(A), args...)

_sparse_similar(A::AbstractArray, args...) = sparse(args...)

_Ginibre_ensemble(rng::AbstractRNG, ::Type{T}, n::Int, rank::Int = n) where {T <: Complex} = randn(rng, T, n, rank) / sqrt(T(n))

_Boltzmann_weight(β::T, E::Int) where {T <: Real} = (E != 0 || isfinite(β)) ? exp(-β * E) : one(T)

makeVal(x::Val{T}) where {T} = x
makeVal(x) = Val(x)

getVal(x::Val{T}) where {T} = T
getVal(x) = x # getVal for any other type

_non_static_array_warning(argname, arg::Tuple{}) =
    throw(ArgumentError("The argument $argname must be a Tuple or a StaticVector of non-zero length."))
_non_static_array_warning(argname, arg::Union{SVector{N, T}, MVector{N, T}, NTuple{N, T}}) where {N, T} = nothing
_non_static_array_warning(argname, arg::AbstractVector{T}) where {T} =
    @warn "The argument $argname should be a Tuple or a StaticVector for better performance. Try to use `$argname = $(Tuple(arg))` instead of `$argname = $arg`. " *
    "Alternatively, you can do `import QuantumToolbox: SVector` " *
    "and use `$argname = SVector(" *
    join(arg, ", ") *
    ")`." maxlog = 1

# lazy tensor warning
for AType in (:AbstractArray, :AbstractSciMLOperator)
    for BType in (:AbstractArray, :AbstractSciMLOperator)
        if AType == BType == :AbstractArray
            @eval begin
                _lazy_tensor_warning(::$AType, ::$BType) = nothing
            end
        else
            @eval begin
                _lazy_tensor_warning(A::$AType, B::$BType) =
                    @warn "using lazy tensor (which can hurt performance) between data types: $(get_typename_wrapper(A)) and $(get_typename_wrapper(B))"
            end
        end
    end
end

# alias of abstract types
const FloatOrComplex = Union{AbstractFloat, Complex}

# functions for getting Float or Complex element type
_float_type(::AbstractArray{T}) where {T <: Number} = _float_type(T)
_float_type(::AbstractSciMLOperator{T}) where {T <: Number} = _float_type(T)
_float_type(::Type{Int32}) = Float32
_float_type(::Type{Int64}) = Float64
_float_type(::Type{Complex{Int32}}) = Float32
_float_type(::Type{Complex{Int64}}) = Float64
_float_type(::Type{Complex{T}}) where {T <: Real} = T
_float_type(T::Type{<:AbstractFloat}) = T # Allow other untracked Real types, like ForwardDiff.Dual
_complex_float_type(::AbstractArray{T}) where {T <: Number} = _complex_float_type(T)
_complex_float_type(::AbstractSciMLOperator{T}) where {T <: Number} = _complex_float_type(T)
_complex_float_type(::Type{Int32}) = ComplexF32
_complex_float_type(::Type{Int64}) = ComplexF64
_complex_float_type(::Type{Float32}) = ComplexF32
_complex_float_type(::Type{Float64}) = ComplexF64
_complex_float_type(::Type{Complex{Int32}}) = ComplexF32
_complex_float_type(::Type{Complex{Int64}}) = ComplexF64
_complex_float_type(::Type{Complex{Float32}}) = ComplexF32
_complex_float_type(::Type{Complex{Float64}}) = ComplexF64
_complex_float_type(T::Type{<:AbstractFloat}) = Complex{T} # Allow other untracked Complex types, like ForwardDiff.Dual
_complex_float_type(T::Type{<:Complex}) = T       # Allow other untracked Complex types, like ForwardDiff.Dual

_convert_eltype_wordsize(::Type{T}, ::Val{64}) where {T <: Int} = Int64
_convert_eltype_wordsize(::Type{T}, ::Val{32}) where {T <: Int} = Int32
_convert_eltype_wordsize(::Type{T}, ::Val{64}) where {T <: AbstractFloat} = Float64
_convert_eltype_wordsize(::Type{T}, ::Val{32}) where {T <: AbstractFloat} = Float32
_convert_eltype_wordsize(::Type{Complex{T}}, ::Val{64}) where {T <: Union{Int, AbstractFloat}} = ComplexF64
_convert_eltype_wordsize(::Type{Complex{T}}, ::Val{32}) where {T <: Union{Int, AbstractFloat}} = ComplexF32

@testitem "Correlations and Spectrum" begin
    N = 10
    Id = qeye(N)
    a = destroy(N)
    H = a' * a
    c_ops = [sqrt(0.1 * (0.01 + 1)) * a, sqrt(0.1 * (0.01)) * a']

    t_l = range(0, 333 * π, length = 1000)
    corr1 = correlation_2op_1t(H, nothing, t_l, c_ops, a', a; progress_bar = Val(false))
    corr2 = correlation_3op_1t(H, nothing, t_l, c_ops, Id, a', a; progress_bar = Val(false))
    ω_l1, spec1 = spectrum_correlation_fft(t_l, corr1)

    ω_l2 = range(0, 3, length = 1000)
    spec2 = spectrum(H, ω_l2, c_ops, a', a)
    spec3 = spectrum(H, ω_l2, c_ops, a', a; solver = PseudoInverse())
    spec4 = spectrum(H, ω_l2, c_ops, a', a; solver = Lanczos())

    spec1 = spec1 ./ maximum(spec1)
    spec2 = spec2 ./ maximum(spec2)
    spec3 = spec3 ./ maximum(spec3)
    spec4 = spec4 ./ maximum(spec4)

    test_func1 = maximum(real.(spec1)) * (0.1 / 2)^2 ./ ((ω_l1 .- 1) .^ 2 .+ (0.1 / 2)^2)
    test_func2 = maximum(real.(spec2)) * (0.1 / 2)^2 ./ ((ω_l2 .- 1) .^ 2 .+ (0.1 / 2)^2)
    idxs1 = test_func1 .> 0.05
    idxs2 = test_func2 .> 0.05
    @test sum(abs2.(spec1[idxs1] .- test_func1[idxs1])) / sum(abs2.(test_func1[idxs1])) < 0.01
    @test sum(abs2.(spec2[idxs2] .- test_func2[idxs2])) / sum(abs2.(test_func2[idxs2])) < 0.01
    @test all(corr1 .≈ corr2)
    @test all(spec2 .≈ spec3)
    @test all(spec2 .≈ spec4)

    if VERSION >= v"1.11" # eigen is type unstable on v1.10
        @testset "Type Inference spectrum" begin
            @inferred correlation_2op_1t(H, nothing, t_l, c_ops, a', a; progress_bar = Val(false))
            @inferred spectrum_correlation_fft(t_l, corr1)
            @inferred spectrum(H, ω_l2, c_ops, a', a)
            @inferred spectrum(H, ω_l2, c_ops, a', a; solver = PseudoInverse())
            @inferred spectrum(H, ω_l2, c_ops, a', a; solver = Lanczos())
        end
    end

    @testset "Verbose mode Lanczos" begin
        cout = stdout
        r, w = redirect_stdout()
        nout = @async read(r, String)
        spectrum(H, ω_l2, c_ops, a', a; solver = Lanczos(verbose = 2, maxiter = 2, tol = 1.0e-16))
        redirect_stdout(cout)
        close(w)
        out = fetch(nout)
        outlines = split(out, '\n', keepempty = false)
        @test last(outlines) == "spectrum(): Consider increasing maxiter and/or tol"
    end

    @testset "Orthogonal input vectors Lanczos" begin
        @test_throws AssertionError spectrum(H, ω_l2, [c_ops[1]], a', a; solver = Lanczos())
    end

    # tlist and τlist checks
    t_fft_wrong = [0, 1, 10]
    t_wrong1 = [1, 2, 3]
    t_wrong2 = [-1, 0, 1]
    @test_throws ArgumentError spectrum_correlation_fft(t_fft_wrong, corr1)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_l, t_wrong1, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_l, t_wrong2, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_wrong1, t_l, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_wrong2, t_l, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_wrong1, t_wrong1, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_wrong1, t_wrong2, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_wrong2, t_wrong1, c_ops, Id, a', a)
    @test_throws ArgumentError correlation_3op_2t(H, nothing, t_wrong2, t_wrong2, c_ops, Id, a', a)

    @testset "Deprecated Errors and Warnings" begin
        ρ0 = rand_dm(N)
        t_l = [0.0, 1.0] # make time list shorter
        @test_throws ErrorException FFTCorrelation()
        @test_logs (:warn,) correlation_3op_2t(H, ρ0, t_l, t_l, a, a', a, c_ops; progress_bar = Val(false))
        @test_logs (:warn,) correlation_3op_1t(H, ρ0, t_l, a, a', a, c_ops; progress_bar = Val(false))
        @test_logs (:warn,) correlation_2op_2t(H, ρ0, t_l, t_l, a', a, c_ops; progress_bar = Val(false))
        @test_logs (:warn,) correlation_2op_1t(H, ρ0, t_l, a', a, c_ops; progress_bar = Val(false))
    end
end

export spectrum, spectrum_correlation_fft
export SpectrumSolver, ExponentialSeries, PseudoInverse, Lanczos

abstract type SpectrumSolver end

@doc raw"""
    ExponentialSeries(; tol = 1e-14, calc_steadystate = false)

A solver which solves [`spectrum`](@ref) by finding the eigen decomposition of the Liouvillian [`SuperOperator`](@ref) and calculate the exponential series.
"""
struct ExponentialSeries{T <: Real, CALC_SS} <: SpectrumSolver
    tol::T
    ExponentialSeries(tol::T, calc_steadystate::Bool = false) where {T} = new{T, calc_steadystate}(tol)
end

ExponentialSeries(; tol = 1.0e-14, calc_steadystate = false) = ExponentialSeries(tol, calc_steadystate)

@doc raw"""
    PseudoInverse(; alg::SciMLLinearSolveAlgorithm = KrylovJL_GMRES())

A solver which solves [`spectrum`](@ref) by finding the inverse of Liouvillian [`SuperOperator`](@ref) using the `alg`orithms given in [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/).
"""
struct PseudoInverse{MT <: SciMLLinearSolveAlgorithm} <: SpectrumSolver
    alg::MT
end

PseudoInverse(; alg::SciMLLinearSolveAlgorithm = KrylovJL_GMRES()) = PseudoInverse(alg)

@doc raw"""
    Lanczos(; tol = 1e-8, maxiter = 5000, verbose = 0)

A solver which solves [`spectrum`](@ref) by using a non-symmetric Lanczos variant of the algorithm in [Koch2011](https://www.cond-mat.de/events/correl11/manuscripts/koch.pdf).
The nonsymmetric Lanczos algorithm is adapted from Algorithm 6.6 in [Saad2011](https://www-users.cse.umn.edu/~saad/eig_book_2ndEd.pdf).
The running estimate is updated via a [Wallis-Euler recursion](https://en.wikipedia.org/wiki/Continued_fraction).
"""
Base.@kwdef struct Lanczos{T <: Real, SS <: Union{Nothing, <:SteadyStateSolver}} <: SpectrumSolver
    tol::T = 1.0e-8
    maxiter::Int = 5000
    verbose::Int = 0
    steadystate_solver::SS = nothing
end

@doc raw"""
    spectrum(H::QuantumObject,
        ωlist::AbstractVector,
        c_ops::Union{Nothing,AbstractVector,Tuple},
        A::QuantumObject{Operator},
        B::QuantumObject{Operator};
        solver::SpectrumSolver=ExponentialSeries(),
        kwargs...)

Calculate the spectrum of the correlation function

```math
S(\omega) = \int_{-\infty}^\infty \lim_{t \rightarrow \infty} \left\langle \hat{A}(t + \tau) \hat{B}(t) \right\rangle e^{-i \omega \tau} d \tau
```

See also the following list for `SpectrumSolver` docstrings:
- [`ExponentialSeries`](@ref)
- [`PseudoInverse`](@ref)
- [`Lanczos`](@ref)
"""
function spectrum(
        H::QuantumObject{HOpType},
        ωlist::AbstractVector,
        c_ops::Union{Nothing, AbstractVector, Tuple},
        A::QuantumObject{Operator},
        B::QuantumObject{Operator};
        solver::SpectrumSolver = ExponentialSeries(),
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}}
    return _spectrum(liouvillian(H, c_ops), ωlist, A, B, solver; kwargs...)
end

function _spectrum_get_rates_vecs_ss(L, solver::ExponentialSeries{T, true}) where {T}
    result = eigen(L)
    rates, vecs = result.values, result.vectors

    return rates, vecs, steadystate(L).data
end

function _spectrum_get_rates_vecs_ss(L, solver::ExponentialSeries{T, false}) where {T}
    result = eigen(L)
    rates, vecs = result.values, result.vectors

    ss_idx = findmin(abs2, rates)[2]
    ρss = vec2mat(@view(vecs[:, ss_idx]))
    ρss = (ρss + ρss') / 2
    ρss ./= tr(ρss)

    return rates, vecs, ρss
end

function _spectrum(
        L::QuantumObject{SuperOperator},
        ωlist::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        solver::ExponentialSeries;
        kwargs...,
    )
    check_dimensions(L, A, B)

    rates, vecs, ρss = _spectrum_get_rates_vecs_ss(L, solver)

    ρ0 = B.data * ρss
    v = vecs \ mat2vec(ρ0)

    amps = map(i -> v[i] * tr(A.data * vec2mat(@view(vecs[:, i]))), eachindex(rates))
    idxs = findall(x -> abs(x) > solver.tol, amps)
    amps, rates = amps[idxs], rates[idxs]

    amps_rates = zip(amps, complex.(rates))
    spec = map(ω -> 2 * real(sum(x -> x[1] / (1im * ω - x[2]), amps_rates)), ωlist)

    return spec
end

function _spectrum(
        L::QuantumObject{SuperOperator},
        ωlist::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        solver::PseudoInverse;
        kwargs...,
    )
    check_dimensions(L, A, B)

    ωList = convert(Vector{_float_type(L)}, ωlist) # Convert it to support GPUs and avoid type instabilities
    Length = length(ωList)
    spec = Vector{_float_type(L)}(undef, Length)

    # calculate vectorized steadystate, multiply by operator B on the left (spre)
    ρss = mat2vec(steadystate(L))
    b = (spre(B) * ρss).data

    # multiply by operator A on the left (spre) and then perform trace operation
    D = get_hilbert_size(L.dimensions)[1]
    _tr = SparseVector(D^2, [1 + n * (D + 1) for n in 0:(D - 1)], ones(_complex_float_type(L), D)) # same as vec(system_identity_matrix)
    _tr_A = transpose(_tr) * spre(A).data

    Id = Eye(D^2)

    # DO the idx = 1 case
    ω = ωList[1]
    cache = init(LinearProblem(L.data - 1im * ω * Id, b), solver.alg, kwargs...)
    sol = solve!(cache)
    spec[1] = -2 * real(dot(_tr_A, sol.u))
    popfirst!(ωList)
    for (idx, ω) in enumerate(ωList)
        cache.A = L.data - 1im * ω * Id
        sol = solve!(cache)

        # trace over the Hilbert space of system (expectation value)
        spec[idx + 1] = -2 * real(dot(_tr_A, sol.u))
    end

    return spec
end

function _spectrum(
        L::QuantumObject{SuperOperator},
        ωlist::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        solver::Lanczos,
    )
    check_dimensions(L, A, B)

    # Define type shortcuts
    fT = _float_type(L)
    cT = _complex_float_type(L)

    # Calculate |v₁> = B|ρss>
    ρss =
        isnothing(solver.steadystate_solver) ? mat2vec(steadystate(L)) :
        mat2vec(steadystate(L; solver = solver.steadystate_solver))
    vₖ = (spre(B) * ρss).data

    # Define (possibly GPU) vector type
    vT = typeof(vₖ)

    # Calculate <w₁| = <I|A
    D = get_hilbert_size(L.dimensions)[1]
    Ivec = SparseVector(D^2, [1 + n * (D + 1) for n in 0:(D - 1)], ones(cT, D)) # same as vec(system_identity_matrix)
    wₖ = spre(A).data' * vT(Ivec)

    # Store the normalization factor for the Green's function before renormalizing |v₁> and <w₁|
    gfNorm = dot(wₖ, vₖ)
    if gfNorm ≈ 0.0
        throw(AssertionError("⟨w₀|v₀⟩ = 0, please check your A and B operators."))
    end
    scalingF = sqrt(abs(gfNorm))
    vₖ ./= scalingF
    wₖ ./= conj(gfNorm / scalingF)

    # Handle input frequency range
    ωList = vT(convert(Vector{fT}, ωlist))  # Make sure they're real frequencies and potentially on GPU
    Length = length(ωList)

    # Current and previous estimates of the spectrum
    lanczosFactor = vT(zeros(cT, Length))
    lanczosFactor₋₁ = vT(zeros(cT, Length))

    # Tridiagonal matrix elements
    αₖ = cT(0)
    βₖ = cT(-1)
    δₖ = fT(+1)
    βₖδₖ = βₖ * δₖ

    # Current and up to second-to-last A and B Euler sequences
    A₋₂ = vT(ones(cT, Length))
    A₋₁ = vT(zeros(cT, Length))
    Aₖ = vT(zeros(cT, Length))
    B₋₂ = vT(zeros(cT, Length))
    B₋₁ = vT(ones(cT, Length))
    Bₖ = vT(zeros(cT, Length))

    # Maximum norm and residue
    maxNorm = vT(zeros(cT, length(ωList)))
    maxResidue = fT(0.0)

    # Previous and next left/right Krylov vectors
    v₋₁ = vT(zeros(cT, D^2))
    v₊₁ = vT(zeros(cT, D^2))
    w₋₁ = vT(zeros(cT, D^2))
    w₊₁ = vT(zeros(cT, D^2))

    # Frequency of renormalization
    renormFrequency = 1

    # Loop over the Krylov subspace(s)
    for k in 1:solver.maxiter
        # k-th diagonal element
        mul!(w₊₁, L.data', wₖ)
        αₖ = dot(w₊₁, vₖ)

        # Update A(k), B(k) and continuous fraction; normalization avoids overflow
        Aₖ .= (-1im .* ωList .+ αₖ) .* A₋₁ .- βₖδₖ .* A₋₂
        Bₖ .= (-1im .* ωList .+ αₖ) .* B₋₁ .- βₖδₖ .* B₋₂
        lanczosFactor₋₁ .= lanczosFactor
        lanczosFactor .= Aₖ ./ Bₖ

        # Renormalize Euler sequences to avoid overflow
        if k % renormFrequency == 0
            map!((x, y) -> max(abs(x), abs(y)), maxNorm, Aₖ, Bₖ)
            Aₖ ./= maxNorm
            Bₖ ./= maxNorm
            A₋₁ ./= maxNorm
            B₋₁ ./= maxNorm
        end

        # Check for convergence

        residueNorm = max(maximum(abs, lanczosFactor), maximum(abs, lanczosFactor₋₁))
        lanczosFactor₋₁ .-= lanczosFactor
        maxResidue = maximum(abs, lanczosFactor₋₁) / residueNorm
        if maxResidue <= solver.tol
            if solver.verbose > 1
                println("spectrum(): solver::Lanczos converged after $(k) iterations")
            end
            break
        end

        # (k+1)-th left/right vectors, orthogonal to previous ones
        mul!(v₊₁, L.data, vₖ)
        v₊₁ .= v₊₁ .- αₖ .* vₖ .- βₖ .* v₋₁
        w₊₁ .= w₊₁ .- conj(αₖ) .* wₖ .- conj(δₖ) .* w₋₁
        v₋₁, vₖ = vₖ, v₋₁
        vₖ, v₊₁ = v₊₁, vₖ
        w₋₁, wₖ = wₖ, w₋₁
        wₖ, w₊₁ = w₊₁, wₖ

        # k-th off-diagonal elements
        βₖδₖ = dot(wₖ, vₖ)
        if βₖδₖ ≈ 0.0
            if solver.verbose > 0
                @warn "spectrum(): solver::Lanczos experienced orthogonality breakdown after $(k) iterations"
                @warn "spectrum(): βₖδₖ = $(βₖδₖ)"
            end
            break
        end
        δₖ = sqrt(abs(βₖδₖ))
        βₖ = βₖδₖ / δₖ

        # Normalize (k+1)-th left/right vectors
        vₖ ./= δₖ
        wₖ ./= conj(βₖ)

        # Update everything for the next cycle
        A₋₂, A₋₁ = A₋₁, A₋₂
        A₋₁, Aₖ = Aₖ, A₋₁
        B₋₂, B₋₁ = B₋₁, B₋₂
        B₋₁, Bₖ = Bₖ, B₋₁
    end

    if solver.verbose > 0 && maxResidue > solver.tol
        println("spectrum(): maxiter = $(solver.maxiter) reached before convergence!")
        println("spectrum(): Max residue = $maxResidue")
        println("spectrum(): Consider increasing maxiter and/or tol")
    end

    # Restore the norm
    lanczosFactor .= gfNorm .* lanczosFactor

    return -2 .* real(lanczosFactor)
end

@doc raw"""
    spectrum_correlation_fft(tlist, corr; inverse=false)

Calculate the power spectrum corresponding to a two-time correlation function using fast Fourier transform (FFT).

# Parameters
- `tlist::AbstractVector`: List of time points at which the two-time correlation function is given.
- `corr::AbstractVector`: List of two-time correlations corresponding to the given time point in `tlist`.
- `inverse::Bool`: Whether to use the inverse Fourier transform or not. Default to `false`.

# Returns
- `ωlist`: the list of angular frequencies ``\omega``.
- `Slist`: the list of the power spectrum corresponding to the angular frequencies in `ωlist`.
"""
function spectrum_correlation_fft(tlist::AbstractVector, corr::AbstractVector; inverse::Bool = false)
    N = length(tlist)
    dt_list = diff(tlist)
    dt = dt_list[1]

    all(≈(dt), dt_list) || throw(ArgumentError("tlist must be equally spaced for FFT."))

    # power spectrum list
    F = inverse ? N * ifft(corr) : fft(corr)
    Slist = 2 * dt * real(fftshift(F))

    # angular frequency list
    ωlist = 2 * π * fftshift(fftfreq(N, 1 / dt))

    return ωlist, Slist
end

# Use harmonic oscillator system for both sesolve and mesolve
const N_ad = 20
const a_ad = destroy(N_ad)
const ψ0_ad = fock(N_ad, 0)
const tlist_ad = range(0, 40, 100)
const ad_a = a_ad' * a_ad

# ---- SESOLVE ----
# For direct Forward differentiation
function my_f_sesolve_direct(p)
    H = p[1] * a_ad' * a_ad + p[2] * (a_ad + a_ad')
    sol = sesolve(H, ψ0_ad, tlist_ad, progress_bar = Val(false))
    return real(expect(ad_a, sol.states[end]))
end

# For SciMLSensitivity.jl (reverse mode with Mooncake and Enzyme)
coef_Δ(p, t) = p[1]
coef_F(p, t) = p[2]
const H_evo = QobjEvo(a_ad' * a_ad, coef_Δ) + QobjEvo(a_ad + a_ad', coef_F)

function my_f_sesolve(p, sensealg)
    sol = sesolve(
        H_evo,
        ψ0_ad,
        tlist_ad,
        progress_bar = Val(false),
        params = p,
        sensealg = sensealg,
    )
    return real(expect(ad_a, sol.states[end]))
end
const my_f_sesolve_bsa_enzyme = Base.Fix{2}(my_f_sesolve, BacksolveAdjoint(autojacvec = EnzymeVJP()))
const my_f_sesolve_bsa_mooncake = Base.Fix{2}(my_f_sesolve, BacksolveAdjoint(autojacvec = MooncakeVJP()))

# ---- MESOLVE ----
# For direct Forward differentiation
function my_f_mesolve_direct(p)
    H = p[1] * a_ad' * a_ad + p[2] * (a_ad + a_ad')
    c_ops = [sqrt(p[3]) * a_ad]
    sol = mesolve(H, ψ0_ad, tlist_ad, c_ops, progress_bar = Val(false))
    return real(expect(ad_a, sol.states[end]))
end

# For SciMLSensitivity.jl (reverse mode with Mooncake and Enzyme)
coef_γ(p, t) = sqrt(p[3])
const c_ops_ad = [QobjEvo(a_ad, coef_γ)]
const L_ad = liouvillian(H_evo, c_ops_ad)

function my_f_mesolve(p, sensealg)
    sol = mesolve(
        L_ad,
        ψ0_ad,
        tlist_ad,
        progress_bar = Val(false),
        params = p,
        sensealg = sensealg,
    )
    return real(expect(ad_a, sol.states[end]))
end
const my_f_mesolve_bsa_enzyme = Base.Fix{2}(my_f_mesolve, BacksolveAdjoint(autojacvec = EnzymeVJP()))
const my_f_mesolve_bsa_mooncake = Base.Fix{2}(my_f_mesolve, BacksolveAdjoint(autojacvec = MooncakeVJP()))

# Parameters for benchmarks
const params_sesolve = [1.0, 1.0]
const params_mesolve = [1.0, 1.0, 1.0]

function benchmark_autodiff!(SUITE)
    # Benchmark sesolve - Forward
    SUITE["Autodiff"]["sesolve"]["Forward"] = @benchmarkable ForwardDiff.gradient($my_f_sesolve_direct, $params_sesolve)

    # Benchmark sesolve - Reverse (Enzyme)
    SUITE["Autodiff"]["sesolve"]["Reverse (Enzyme)"] = @benchmarkable Enzyme.autodiff(
        Enzyme.set_runtime_activity(Enzyme.Reverse),
        Const($my_f_sesolve_bsa_enzyme),
        Active,
        Duplicated($params_sesolve, dparams_sesolve),
    ) setup = (dparams_sesolve = Enzyme.make_zero($params_sesolve))

    # Benchmark sesolve - Reverse (Mooncake)
    cache_sesolve_mooncake = Mooncake.prepare_gradient_cache(my_f_sesolve_bsa_mooncake, params_sesolve)
    SUITE["Autodiff"]["sesolve"]["Reverse (Mooncake)"] = @benchmarkable Mooncake.value_and_gradient!!(grad_cache1, $my_f_sesolve_bsa_mooncake, $params_sesolve) setup = (grad_cache1 = $cache_sesolve_mooncake)

    # Benchmark mesolve - Forward
    SUITE["Autodiff"]["mesolve"]["Forward"] = @benchmarkable ForwardDiff.gradient($my_f_mesolve_direct, $params_mesolve)

    # Benchmark mesolve - Reverse (Enzyme)
    SUITE["Autodiff"]["mesolve"]["Reverse (Enzyme)"] = @benchmarkable Enzyme.autodiff(
        Enzyme.set_runtime_activity(Enzyme.Reverse),
        Const($my_f_mesolve_bsa_enzyme),
        Active,
        Duplicated($params_mesolve, dparams_mesolve),
    ) setup = (dparams_mesolve = Enzyme.make_zero($params_mesolve))

    # Benchmark mesolve - Reverse (Mooncake)
    cache_mesolve_mooncake = Mooncake.prepare_gradient_cache(my_f_mesolve_bsa_mooncake, params_mesolve)
    SUITE["Autodiff"]["mesolve"]["Reverse (Mooncake)"] = @benchmarkable Mooncake.value_and_gradient!!(grad_cache2, $my_f_mesolve_bsa_mooncake, $params_mesolve) setup = (grad_cache2 = $cache_mesolve_mooncake)

    return nothing
end

function benchmark_steadystate!(SUITE)
    N = 50
    Δ = 0.1
    F = 2
    γ = 1
    nth = 5

    a = destroy(N)
    H = Δ * a' * a + F * (a + a')
    c_ops = [sqrt(γ * (nth + 1)) * a, sqrt(γ * nth) * a']

    SUITE["Steadystate"]["Direct"] = @benchmarkable steadystate($H, $c_ops)

    SUITE["Steadystate"]["Iterative"] = @benchmarkable steadystate($H, $c_ops; solver = SteadyStateLinearSolver())

    SUITE["Steadystate"]["ODE"] = @benchmarkable steadystate($H, $c_ops; solver = SteadyStateODESolver())

    return nothing
end

export steadystate, steadystate_fourier, steadystate_floquet
export SteadyStateSolver,
    SteadyStateDirectSolver,
    SteadyStateEigenSolver,
    SteadyStateLinearSolver,
    SteadyStateODESolver,
    SSFloquetEffectiveLiouvillian

abstract type SteadyStateSolver end

@doc raw"""
    SteadyStateDirectSolver(
        factorization = lu
    )

A solver which solves [`steadystate`](@ref) by finding the inverse of Liouvillian [`SuperOperator`](@ref) using the standard method given in `LinearAlgebra`.

# Arguments
- `factorization::Function=lu`: The factorization method to use for solving the linear system. The default is `lu`, which performs LU factorization.
"""
Base.@kwdef struct SteadyStateDirectSolver{FT <: Function} <: SteadyStateSolver
    factorization::FT = lu
end

@doc raw"""
    SteadyStateEigenSolver()

A solver which solves [`steadystate`](@ref) by finding the zero (or lowest) eigenvalue of Liouvillian [`SuperOperator`](@ref) using [`eigsolve`](@ref).
"""
struct SteadyStateEigenSolver <: SteadyStateSolver end

@doc raw"""
    SteadyStateLinearSolver(
        alg = KrylovJL_GMRES(; precs = (A, p) -> A isa SparseMatrixCSC ? (ilu(A, τ = 0.01), I) : (I, I))
    )

A solver which solves [`steadystate`](@ref) by finding the inverse of Liouvillian [`SuperOperator`](@ref) using the `alg`orithms given in [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/).

# Arguments
- `alg::SciMLLinearSolveAlgorithm=KrylovJL_GMRES()`: algorithms given in [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/)

# Note
Refer to [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/) for more details about the available algorithms. For example, the preconditioners can be defined directly in the solver like: `SteadyStateLinearSolver(alg = KrylovJL_GMRES(; precs = (A, p) -> (I, Diagonal(A))))`.
"""
Base.@kwdef struct SteadyStateLinearSolver{MT <: Union{SciMLLinearSolveAlgorithm, Nothing}} <: SteadyStateSolver
    alg::MT = KrylovJL_GMRES(; precs = (A, p) -> A isa SparseMatrixCSC ? (ilu(A, τ = 0.01), I) : (I, I))
end

@doc raw"""
    SteadyStateODESolver(
        alg = DP5(),
        ρ0 = nothing,
        tmax = Inf,
        terminate_reltol = 1e-4,
        terminate_abstol = 1e-6
    )

An ordinary differential equation (ODE) solver for solving [`steadystate`](@ref). It solves the stationary state based on [`mesolve`](@ref) with a termination condition.

The termination condition of the stationary state ``|\rho\rangle\!\rangle`` is that either the following condition is `true`:

```math
\lVert\frac{\partial |\hat{\rho}\rangle\!\rangle}{\partial t}\rVert \leq \textrm{reltol} \times\lVert\frac{\partial |\hat{\rho}\rangle\!\rangle}{\partial t}+|\hat{\rho}\rangle\!\rangle\rVert
```

or

```math
\lVert\frac{\partial |\hat{\rho}\rangle\!\rangle}{\partial t}\rVert \leq \textrm{abstol}
```

# Arguments
- `alg::AbstractODEAlgorithm=DP5()`: The algorithm to solve the ODE.
- `ρ0::Union{Nothing,QuantumObject}=nothing`: The initial state of the system. If not specified, a random density matrix state will be generated.
- `tmax::Real=Inf`: The final time step for the steady state problem.
- `terminate_reltol` = The relative tolerance for stationary state terminate condition. Default to `1e-4`.
- `terminate_abstol` = The absolute tolerance for stationary state terminate condition. Default to `1e-6`.

!!! warning "Tolerances for terminate condition"
    The terminate condition tolerances `terminate_reltol` and `terminate_abstol` should be larger than `reltol` and `abstol` of [`mesolve`](@ref), respectively.

For more details about the solving `alg`orithms, please refer to [`OrdinaryDiffEq.jl`](https://docs.sciml.ai/OrdinaryDiffEq/stable/).
"""
Base.@kwdef struct SteadyStateODESolver{
        MT <: AbstractODEAlgorithm,
        ST <: Union{Nothing, QuantumObject},
        TT <: Real,
        RT <: Real,
        AT <: Real,
    } <: SteadyStateSolver
    alg::MT = DP5()
    ρ0::ST = nothing
    tmax::TT = Inf
    terminate_reltol::RT = 1.0e-4
    terminate_abstol::AT = 1.0e-6
end

@doc raw"""
    SSFloquetEffectiveLiouvillian(steadystate_solver = SteadyStateDirectSolver())

A solver which solves [`steadystate_fourier`](@ref) by first extracting an effective time-independent Liouvillian and then using the `steadystate_solver` to extract the steadystate..

# Parameters
- `steadystate_solver::SteadyStateSolver=SteadyStateDirectSolver()`: The solver to use for the effective Liouvillian.

!!! note
    This solver is only available for [`steadystate_fourier`](@ref).
"""
Base.@kwdef struct SSFloquetEffectiveLiouvillian{SSST <: SteadyStateSolver} <: SteadyStateSolver
    steadystate_solver::SSST = SteadyStateDirectSolver()
end

@doc raw"""
    steadystate(
        H::AbstractQuantumObject{OpType},
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing;
        solver::SteadyStateSolver = SteadyStateDirectSolver(),
        kwargs...,
    )

Solve the stationary state based on different solvers.

# Parameters
- `H`: The Hamiltonian or the Liouvillian of the system.
- `c_ops`: The list of the collapse operators.
- `solver`: see documentation [Solving for Steady-State Solutions](@ref doc:Solving-for-Steady-State-Solutions) for different solvers.
- `kwargs`: The keyword arguments for the solver.
"""
function steadystate(
        H::AbstractQuantumObject{OpType},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        solver::SteadyStateSolver = SteadyStateDirectSolver(),
        kwargs...,
    ) where {OpType <: Union{Operator, SuperOperator}}
    solver isa SSFloquetEffectiveLiouvillian && throw(
        ArgumentError(
            "The solver `SSFloquetEffectiveLiouvillian` is only available for the `steadystate_fourier` function.",
        ),
    )

    !isendomorphic(H.dimensions) && _non_endomorphic_dims_error("Hamiltonian or Liouvillian for steadystate", H.dimensions)

    L = liouvillian(H, c_ops)

    return _steadystate(L, solver; kwargs...)
end

function _steadystate(L::QuantumObject{SuperOperator}, solver::SteadyStateLinearSolver; kwargs...)
    L_tmp = L.data
    state_dimensions = L.dimensions.to.op_dims
    N = get_size(state_dimensions)[1]
    weight = norm(L_tmp, 1) / length(L_tmp)

    v0 = _dense_similar(L_tmp, N^2)
    fill!(v0, 0)
    allowed_setindex!(v0, weight, 1) # Because scalar indexing is not allowed on GPU arrays

    idx_range = collect(1:N)
    rows = _dense_similar(L_tmp, N)
    cols = _dense_similar(L_tmp, N)
    vals = _dense_similar(L_tmp, N)
    fill!(rows, 1)
    copyto!(cols, N .* (idx_range .- 1) .+ idx_range)
    fill!(vals, weight)
    Tn = _sparse_similar(L_tmp, rows, cols, vals, N^2, N^2)
    L_tmp = L_tmp + Tn

    (haskey(kwargs, :Pl) || haskey(kwargs, :Pr)) && error("The use of preconditioners must be defined in the solver.")

    prob = LinearProblem{true}(L_tmp, v0)
    ρss_vec = solve(prob, solver.alg; kwargs...).u

    ρss = reshape(ρss_vec, N, N)
    ρss = (ρss + ρss') / 2 # Hermitianize
    return QuantumObject(ρss, Operator(), state_dimensions)
end

function _steadystate(L::QuantumObject{SuperOperator}, solver::SteadyStateEigenSolver; kwargs...)
    state_dimensions = L.dimensions.to.op_dims
    N = get_size(state_dimensions)[1]

    kwargs = merge((sigma = 1.0e-8, eigvals = 1), (; kwargs...))

    ρss_vec = eigsolve(L; kwargs...).vectors[:, 1]
    ρss = reshape(ρss_vec, N, N)
    ρss /= tr(ρss)
    ρss = (ρss + ρss') / 2 # Hermitianize
    return QuantumObject(ρss, Operator(), state_dimensions)
end

function _steadystate(L::QuantumObject{SuperOperator}, solver::SteadyStateDirectSolver)
    L_tmp = L.data
    state_dimensions = L.dimensions.to.op_dims
    N = get_size(state_dimensions)[1]
    weight = norm(L_tmp, 1) / length(L_tmp)

    v0 = _dense_similar(L_tmp, N^2)
    fill!(v0, 0)
    allowed_setindex!(v0, weight, 1) # Because scalar indexing is not allowed on GPU arrays

    idx_range = collect(1:N)
    rows = _dense_similar(L_tmp, N)
    cols = _dense_similar(L_tmp, N)
    vals = _dense_similar(L_tmp, N)
    fill!(rows, 1)
    copyto!(cols, N .* (idx_range .- 1) .+ idx_range)
    fill!(vals, weight)
    Tn = _sparse_similar(L_tmp, rows, cols, vals, N^2, N^2)
    L_tmp = L_tmp + Tn

    F = solver.factorization(L_tmp)
    ρss_vec = F \ v0 # This is still not supported on GPU, yet
    ρss = reshape(ρss_vec, N, N)
    ρss = (ρss + ρss') / 2 # Hermitianize
    return QuantumObject(ρss, Operator(), state_dimensions)
end

function _steadystate(L::AbstractQuantumObject{SuperOperator}, solver::SteadyStateODESolver; kwargs...)
    ρ0 = isnothing(solver.ρ0) ? rand_dm(eltype(L), L.dimensions.to.op_dims) : solver.ρ0 # the validity of L and ρ0 will be checked in mesolve
    ftype = _float_type(ρ0)
    tlist = [ftype(0), ftype(solver.tmax)]

    # overwrite some kwargs and throw warning message to tell the users that we are ignoring these settings
    haskey(kwargs, :progress_bar) && @warn "Ignore keyword argument 'progress_bar' for SteadyStateODESolver"
    haskey(kwargs, :save_everystep) && @warn "Ignore keyword argument 'save_everystep' for SteadyStateODESolver"
    haskey(kwargs, :saveat) && @warn "Ignore keyword argument 'saveat' for SteadyStateODESolver"
    kwargs2 = merge(
        NamedTuple(kwargs), # we convert to NamedTuple just in case if kwargs is empty
        (progress_bar = Val(false), save_everystep = false, saveat = ftype[]),
    )

    # add terminate condition (callback)
    cb = TerminateSteadyState(
        solver.terminate_abstol,
        solver.terminate_reltol,
        SteadyStateODECondition(similar(mat2vec(ket2dm(ρ0)).data)),
    )
    kwargs3 = _merge_kwargs_with_callback(kwargs2, cb)

    sol = mesolve(L, ρ0, tlist; kwargs3...)
    ρss = sol.states[end]
    return ρss
end

_steadystate(
    L::QuantumObjectEvolution{SuperOperator},
    solver::T;
    kwargs...,
) where {T <: Union{SteadyStateDirectSolver, SteadyStateEigenSolver, SteadyStateLinearSolver}} =
    throw(ArgumentError("$(get_typename_wrapper(solver)) does not support QobjEvo."))

struct SteadyStateODECondition{CT <: AbstractArray}
    cache::CT
end

function (f::SteadyStateODECondition)(integrator, abstol, reltol, min_t)
    # this condition is same as DiffEqBase.NormTerminationMode

    f.cache .= (integrator.u .- integrator.uprev) ./ integrator.dt
    norm_du_dt = norm(f.cache)
    f.cache .+= integrator.u
    if norm_du_dt <= reltol * norm(f.cache) || norm_du_dt <= abstol
        return true
    else
        return false
    end
end

@doc raw"""
    steadystate_fourier(
        H_0::QuantumObject,
        H_p::QuantumObject,
        H_m::QuantumObject,
        ωd::Number,
        c_ops::Union{Nothing,AbstractVector,Tuple} = nothing;
        n_max::Integer = 2,
        tol::R = 1e-8,
        solver::FSolver = SteadyStateLinearSolver(),
        kwargs...,
    )

Calculates the steady state of a periodically driven system.
Here `H_0` is the Hamiltonian or the Liouvillian of the undriven system.
Considering a monochromatic drive at frequency ``\omega_d``, we divide it into two parts,
`H_p` and `H_m`, where `H_p` oscillates
as ``e^{i \omega t}`` and `H_m` oscillates as ``e^{-i \omega t}``.
There are two solvers available for this function:
- `SteadyStateLinearSolver`: Solves the linear system of equations.
- `SSFloquetEffectiveLiouvillian`: Solves the effective Liouvillian.
For both cases, `n_max` is the number of Fourier components to consider, and `tol` is the tolerance for the solver.

In the case of `SteadyStateLinearSolver`, the full linear system is solved at once:

```math
( \mathcal{L}_0 - i n \omega_d ) \hat{\rho}_n + \mathcal{L}_1 \hat{\rho}_{n-1} + \mathcal{L}_{-1} \hat{\rho}_{n+1} = 0
```

This is a tridiagonal linear system of the form

```math
\mathbf{A} \cdot \mathbf{b} = 0
```

where

```math
\mathbf{A} = \begin{pmatrix}
\mathcal{L}_0 - i (-n_{\textrm{max}}) \omega_{\textrm{d}} & \mathcal{L}_{-1} & 0 & \cdots & 0 \\
\mathcal{L}_1 & \mathcal{L}_0 - i (-n_{\textrm{max}}+1) \omega_{\textrm{d}} & \mathcal{L}_{-1} & \cdots & 0 \\
0 & \mathcal{L}_1 & \mathcal{L}_0 - i (-n_{\textrm{max}}+2) \omega_{\textrm{d}} & \cdots & 0 \\
\vdots & \vdots & \vdots & \ddots & \vdots \\
0 & 0 & 0 & \cdots & \mathcal{L}_0 - i n_{\textrm{max}} \omega_{\textrm{d}}
\end{pmatrix}
```

and

```math
\mathbf{b} = \begin{pmatrix}
\hat{\rho}_{-n_{\textrm{max}}} \\
\hat{\rho}_{-n_{\textrm{max}}+1} \\
\vdots \\
\hat{\rho}_{0} \\
\vdots \\
\hat{\rho}_{n_{\textrm{max}}-1} \\
\hat{\rho}_{n_{\textrm{max}}}
\end{pmatrix}
```

This will allow to simultaneously obtain all the ``\hat{\rho}_n``.

In the case of `SSFloquetEffectiveLiouvillian`, instead, the effective Liouvillian is calculated using the matrix continued fraction method.

!!! note "different return"
    The two solvers returns different objects. The `SteadyStateLinearSolver` returns a list of [`QuantumObject`](@ref), containing the density matrices for each Fourier component (``\hat{\rho}_{-n}``, with ``n`` from ``0`` to ``n_\textrm{max}``), while the `SSFloquetEffectiveLiouvillian` returns only ``\hat{\rho}_0``. 

!!! note
    `steadystate_floquet` is a synonym of `steadystate_fourier`.

## Arguments
- `H_0::QuantumObject`: The Hamiltonian or the Liouvillian of the undriven system.
- `H_p::QuantumObject`: The Hamiltonian or the Liouvillian of the part of the drive that oscillates as ``e^{i \omega t}``.
- `H_m::QuantumObject`: The Hamiltonian or the Liouvillian of the part of the drive that oscillates as ``e^{-i \omega t}``.
- `ωd::Number`: The frequency of the drive.
- `c_ops::Union{Nothing,AbstractVector} = nothing`: The optional collapse operators.
- `n_max::Integer = 2`: The number of Fourier components to consider.
- `tol::R = 1e-8`: The tolerance for the solver.
- `solver::FSolver = SteadyStateLinearSolver`: The solver to use.
- `kwargs...`: Additional keyword arguments to be passed to the solver.
"""
function steadystate_fourier(
        H_0::QuantumObject{OpType1},
        H_p::QuantumObject{OpType2},
        H_m::QuantumObject{OpType3},
        ωd::Number,
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        n_max::Integer = 2,
        tol::R = 1.0e-8,
        solver::FSolver = SteadyStateLinearSolver(),
        kwargs...,
    ) where {
        OpType1 <: Union{Operator, SuperOperator},
        OpType2 <: Union{Operator, SuperOperator},
        OpType3 <: Union{Operator, SuperOperator},
        R <: Real,
        FSolver <: SteadyStateSolver,
    }
    !isendomorphic(H_0.dimensions) && _non_endomorphic_dims_error("Hamiltonian or Liouvillian for steadystate_fourier", H_0.dimensions)
    check_dimensions(H_0, H_p, H_m)

    L_0 = liouvillian(H_0, c_ops)
    (L_0 isa QuantumObject) || throw(ArgumentError("steadystate_fourier only supports (time-independent) QuantumObject in c_ops"))

    L_p = liouvillian(H_p)
    L_m = liouvillian(H_m)
    return _steadystate_fourier(L_0, L_p, L_m, ωd, solver; n_max = n_max, tol = tol, kwargs...)
end

function _steadystate_fourier(
        L_0::QuantumObject{SuperOperator},
        L_p::QuantumObject{SuperOperator},
        L_m::QuantumObject{SuperOperator},
        ωd::Number,
        solver::SteadyStateLinearSolver;
        n_max::Integer = 1,
        tol::R = 1.0e-8,
        kwargs...,
    ) where {R <: Real}
    T1 = eltype(L_0)
    T2 = eltype(L_p)
    T3 = eltype(L_m)
    T = promote_type(T1, T2, T3)

    L_0_mat = get_data(L_0)
    L_p_mat = get_data(L_p)
    L_m_mat = get_data(L_m)

    state_dimensions = L_0.dimensions.to.op_dims
    N = size(L_0_mat, 1)
    Ns = get_size(state_dimensions)[1]
    n_fourier = 2 * n_max + 1
    n_list = (-n_max):n_max

    weight = 1
    Mn = sparse(ones(Ns), [Ns * (j - 1) + j for j in 1:Ns], fill(weight, Ns), N, N)
    L = L_0_mat + Mn

    M = spzeros(T, n_fourier * N, n_fourier * N)
    M += kron(spdiagm(1 => ones(n_fourier - 1)), L_m_mat)
    M += kron(spdiagm(-1 => ones(n_fourier - 1)), L_p_mat)
    for i in 1:n_fourier
        n = n_list[i]
        M += kron(sparse([i], [i], one(T), n_fourier, n_fourier), L - 1im * ωd * n * I)
    end

    v0 = zeros(T, n_fourier * N)
    v0[n_max * N + 1] = weight

    (haskey(kwargs, :Pl) || haskey(kwargs, :Pr)) && error("The use of preconditioners must be defined in the solver.")
    !haskey(kwargs, :abstol) && (kwargs = merge((; kwargs...), (abstol = tol,)))
    !haskey(kwargs, :reltol) && (kwargs = merge((; kwargs...), (reltol = tol,)))

    prob = LinearProblem{true}(M, v0)
    ρtot = solve(prob, solver.alg; kwargs...).u

    offset1 = n_max * N
    offset2 = (n_max + 1) * N
    ρ0 = reshape(ρtot[(offset1 + 1):offset2], Ns, Ns)
    ρ0_tr = tr(ρ0)
    ρ0 = ρ0 / ρ0_tr
    ρ0 = QuantumObject((ρ0 + ρ0') / 2, type = Operator(), dims = state_dimensions)
    ρtot = ρtot / ρ0_tr

    ρ_list = [ρ0]
    for i in 0:(n_max - 1)
        ρi_m = reshape(ρtot[(offset1 - (i + 1) * N + 1):(offset1 - i * N)], Ns, Ns)
        ρi_m = QuantumObject(ρi_m, type = Operator(), dims = state_dimensions)
        push!(ρ_list, ρi_m)
    end

    return ρ_list
end

function _steadystate_fourier(
        L_0::QuantumObject{SuperOperator},
        L_p::QuantumObject{SuperOperator},
        L_m::QuantumObject{SuperOperator},
        ωd::Number,
        solver::SSFloquetEffectiveLiouvillian;
        n_max::Integer = 1,
        tol::R = 1.0e-8,
        kwargs...,
    ) where {R <: Real}
    L_eff = liouvillian_floquet(L_0, L_p, L_m, ωd; n_max = n_max, tol = tol)

    return steadystate(L_eff; solver = solver.steadystate_solver, kwargs...)
end

# TODO: Synonym to align with QuTiP. Track https://github.com/qutip/qutip/issues/2632 when this can be removed.
const steadystate_floquet = steadystate_fourier

export liouvillian_dressed_nonsecular

@doc raw"""
    liouvillian_dressed_nonsecular(
        H::QuantumObject{Operator},
        fields::Vector,
        T_list::Vector{<:Real};
        N_trunc::Union{Int,Nothing}=nothing,
        tol::Real=1e-12,
        σ_filter::Union{Nothing,Real}=nothing,
    )

Build the generalized Liouvillian for a system coupled to multiple bosonic baths when the system subparts are highly coupled. The Hamiltonian `H` is diagonalized, the system-bath operators in `fields` are projected into the eigenbasis, and thermal jump operators are assembled for each temperature in `T_list`.

# Arguments
- `H::QuantumObject{Operator}`: System Hamiltonian.
- `fields::Vector`: Coupling operators that mediate the interaction with each bath; must match the length of `T_list`.
- `T_list::Vector{<:Real}`: Bath temperatures ordered consistently with `fields`.

# Keyword Arguments
- `N_trunc::Union{Int,Nothing}`: If provided, truncate the eigenbasis to the first `N_trunc` levels; otherwise use the full dimension of `H`.
- `tol::Real`: Tolerance passed to sparsification utilities when constructing the filters and dissipators.
- `σ_filter::Union{Nothing,Real}`: Width of the Gaussian frequency filter. If `nothing`, a heuristic value proportional to the coupling strengths is used.

# Returns
- `E`: Eigenenergies of `H` (truncated if `N_trunc` is provided).
- `U`: Eigenvectors of `H` as a [`QuantumObject`](@ref) mapping to the truncated basis.
- `L`: Generalized Liouvillian [`SuperOperator`](@ref) including the frequency-filtered dissipators.

# References
- [Settineri2018](@cite)
"""
function liouvillian_dressed_nonsecular(
        H::QuantumObject{Operator},
        fields::Vector,
        T_list::Vector{<:Real};
        N_trunc::Union{Int, Nothing} = nothing,
        tol::Real = 1.0e-12,
        σ_filter::Union{Nothing, Real} = nothing,
    )
    (length(fields) == length(T_list)) || throw(DimensionMismatch("The number of fields and T_list must be the same."))

    dims = isnothing(N_trunc) ? H.dimensions : Dimensions(N_trunc)
    final_size = get_size(dims)[1]
    # U is a non-square transformation matrix from original basis to truncated eigenbasis
    final_dims = isnothing(N_trunc) ? H.dimensions : Dimensions(H.dimensions.to, Space(N_trunc))
    result = eigen(H)
    E = real.(result.values[1:final_size])
    U = QuantumObject(result.vectors[:, 1:final_size], result.type, final_dims)

    H_d = QuantumObject(Diagonal(complex(E)), type = Operator(), dims = dims)

    Ω = E' .- E
    Ωp = triu(to_sparse(Ω, tol), 1)

    # Filter width
    σ = isnothing(σ_filter) ? 500 * maximum([norm(field) / length(field) for field in fields]) : σ_filter

    L = liouvillian(H_d) + sum(eachindex(fields)) do i
        # The operator that couples the system to the bath in the eigenbasis
        X_op = to_sparse((U' * fields[i] * U).data, tol)
        if ishermitian(fields[i])
            X_op = (X_op + X_op') / 2 # Make sure it's hermitian
        end

        # Ohmic reservoir
        N_th = n_thermal.(Ωp, T_list[i])
        Sp₀ = QuantumObject(triu(X_op, 1), type = Operator(), dims = dims)
        Sp₁ = QuantumObject(droptol!((@. Ωp * N_th * Sp₀.data), tol), type = Operator(), dims = dims)
        Sp₂ = QuantumObject(droptol!((@. Ωp * (1 + N_th) * Sp₀.data), tol), type = Operator(), dims = dims)
        # S0 = QuantumObject( spdiagm(diag(X_op)), dims=dims )

        # Build the dissipator contribution with filtered spre, spost, sprepost to avoid large intermediate kron allocations.
        D₁ = (
            _filtered_sprepost(Sp₁', Sp₀, E, σ, tol) +
                _filtered_sprepost(Sp₀', Sp₁, E, σ, tol) -
                _filtered_spre(Sp₀ * Sp₁', E, σ, tol) -
                _filtered_spost(Sp₁ * Sp₀', E, σ, tol)
        ) / 2
        D₂ = (
            _filtered_sprepost(Sp₂, Sp₀', E, σ, tol) +
                _filtered_sprepost(Sp₀, Sp₂', E, σ, tol) -
                _filtered_spre(Sp₀' * Sp₂, E, σ, tol) -
                _filtered_spost(Sp₂' * Sp₀, E, σ, tol)
        ) / 2

        D₁ + D₂
    end

    settings.auto_tidyup && (L isa QuantumObject) && tidyup!(L) # tidyup! only supports QuantumObject

    return E, U, L
end

function _filtered_sprepost(
        A::AbstractQuantumObject{Operator},
        B::AbstractQuantumObject{Operator},
        E::AbstractVector,
        σ::Real,
        tol::Real,
    )
    isinf(σ) && return sprepost(A, B)

    check_dimensions(A, B)
    data = _filtered_kron(transpose(B.data), A.data, E, σ, tol)
    return promote_op_type(A, B)(data, SuperOperator(), LiouvilleSpace(A.dimensions))
end

function _filtered_spre(
        A::AbstractQuantumObject{Operator},
        E::AbstractVector,
        σ::Real,
        tol::Real,
    )
    isinf(σ) && return spre(A)

    T = eltype(A)
    data = _filtered_kron(Eye{T}(size(A, 1)), A.data, E, σ, tol)
    return get_typename_wrapper(A)(data, SuperOperator(), LiouvilleSpace(A.dimensions))
end

function _filtered_spost(
        A::AbstractQuantumObject{Operator},
        E::AbstractVector,
        σ::Real,
        tol::Real,
    )
    isinf(σ) && return spost(A)

    T = eltype(A)
    data = _filtered_kron(transpose(A.data), Eye{T}(size(A, 1)), E, σ, tol)
    return get_typename_wrapper(A)(data, SuperOperator(), LiouvilleSpace(A.dimensions))
end

function _filtered_kron(A, B, E, σ, tol)
    N = length(E)
    (size(A, 1) == N && size(A, 2) == N && size(B, 1) == N && size(B, 2) == N) ||
        throw(DimensionMismatch("Matrix sizes do not match energy list; expected $(N)×$(N) matrices."))

    I_A, J_A, V_A = _findnz(A)
    I_B, J_B, V_B = _findnz(B)

    nnzA = length(V_A)
    nnzB = length(V_B)

    T = Base.promote_eltype(V_A, V_B, E, σ)
    I_out = Int[]
    J_out = Int[]
    V_out = Vector{T}()

    (nnzA == 0 || nnzB == 0) && return sparse(I_out, J_out, V_out, N^2, N^2)

    sizehint!(I_out, max(nnzA, nnzB))
    sizehint!(J_out, max(nnzA, nnzB))
    sizehint!(V_out, max(nnzA, nnzB))

    @inbounds for idxA in eachindex(V_A)
        iA = I_A[idxA]
        jA = J_A[idxA]
        vA = V_A[idxA]
        for idxB in eachindex(V_B)
            iT = I_B[idxB]
            jT = J_B[idxB]
            vB = V_B[idxB]
            Ωdiff = (E[iA] - E[jA]) - (E[iT] - E[jT])
            v = vA * vB * gaussian(Ωdiff, 0, σ)
            if abs(v) > tol
                push!(I_out, iA + (iT - 1) * N)
                push!(J_out, jA + (jT - 1) * N)
                push!(V_out, v)
            end
        end
    end

    return sparse(I_out, J_out, V_out, N^2, N^2)
end
function _filtered_kron(A::Transpose{T, <:Adjoint}, B, E, σ, tol) where {T}
    return _filtered_kron(conj(parent(parent(A))), B, E, σ, tol)
end

_findnz(A::AbstractSparseMatrix) = findnz(A)
function _findnz(A::Diagonal{T}) where {T}
    V = diag(A)
    I = similar(V, Int)
    I .= 1:length(V)
    J = I
    return I, J, V
end
function _findnz(A::Transpose{T, <:AbstractMatrix}) where {T}
    I, J, V = findnz(parent(A))

    return J, I, V
end
function _findnz(A::Adjoint{T, <:AbstractMatrix}) where {T}
    I, J, V = findnz(parent(A))

    return J, I, conj.(V)
end

using BenchmarkTools
using LinearAlgebra
using SparseArrays
using QuantumToolbox
using SciMLBase: EnsembleSerial, EnsembleThreads
using ForwardDiff
using Mooncake
using Enzyme: Enzyme, Const, Active, Duplicated
using SciMLSensitivity: BacksolveAdjoint, EnzymeVJP, MooncakeVJP

BLAS.set_num_threads(1)

const SUITE = BenchmarkGroup()

include("correlations_and_spectrum.jl")
include("dynamical_fock_dimension.jl")
include("dynamical_shifted_fock.jl")
include("eigenvalues.jl")
include("steadystate.jl")
include("timeevolution.jl")
include("autodiff.jl")

benchmark_correlations_and_spectrum!(SUITE)
benchmark_dfd!(SUITE)
benchmark_dsf!(SUITE)
benchmark_eigenvalues!(SUITE)
benchmark_steadystate!(SUITE)
benchmark_timeevolution!(SUITE)
benchmark_autodiff!(SUITE)

BenchmarkTools.tune!(SUITE)
results = BenchmarkTools.run(SUITE, verbose = true)
display(median(results))

BenchmarkTools.save("benchmarks_output.json", median(results))

#=
Helper functions for the smesolve callbacks. Almost equal to the mesolve case, but with an additional possibility to store the measurement operators expectation values. 
=#

struct SaveFuncSMESolve{
        SM,
        TE,
        TE2,
        PT <: Union{Nothing, Progress},
        IT,
        TEXPV <: Union{Nothing, AbstractMatrix},
        TMEXPV <: Union{Nothing, AbstractMatrix},
        TLT <: AbstractVector,
        CT <: AbstractVector,
    } <: AbstractSaveFunc
    store_measurement::Val{SM}
    e_ops::TE
    m_ops::TE2
    progr::PT
    iter::IT
    expvals::TEXPV
    m_expvals::TMEXPV
    tlist::TLT
    dWdt_cache::CT
end

(f::SaveFuncSMESolve)(u, t, integrator) =
    _save_func_smesolve(u, integrator, f.e_ops, f.m_ops, f.progr, f.iter, f.expvals, f.m_expvals, f.tlist, f.dWdt_cache)
(f::SaveFuncSMESolve{false, Nothing})(u, t, integrator) = _save_func(integrator, f.progr) # Common for both all solvers

_get_e_ops_data(e_ops, ::Type{SaveFuncSMESolve}) = _get_e_ops_data(e_ops, SaveFuncMESolve)
_get_m_ops_data(sc_ops, ::Type{SaveFuncSMESolve}) =
    map(op -> _generate_mesolve_e_op(op) + _generate_mesolve_e_op(op'), sc_ops)

##

# When e_ops is a list of operators
function _save_func_smesolve(u, integrator, e_ops, m_ops, progr, iter, expvals, m_expvals, tlist, dWdt_cache)
    # This is equivalent to tr(op * ρ), when both are matrices.
    # The advantage of using this convention is that We don't need
    # to reshape u to make it a matrix, but we reshape the e_ops once.

    ρ = u

    _expect = op -> dot(op, ρ)

    if !isnothing(e_ops)
        @. expvals[:, iter[]] = _expect(e_ops)
    end

    if !isnothing(m_expvals) && iter[] > 1
        _homodyne_dWdt!(dWdt_cache, integrator, tlist, iter)
        @. m_expvals[:, iter[] - 1] = real(_expect(m_ops)) + dWdt_cache
    end

    iter[] += 1

    return _save_func(integrator, progr)
end

#=
This file gathers all the deprecated names (structures, functions, or variables) which will be removed in the future major release.

- Before the major release, the deprecated names will show warnings or just throw errors when they are called.
- If the deprecated names were once exported, we will still export them here until next major release.
- If we decide to push a major release, cleanup this file.

Example 1 [throw errors if the deprecation is fundamental, and there is no replacement for it]:
```
export deprecated_foo
deprecated_foo(args...; kwargs...) = error("`deprecated_foo` is deprecated and will be removed in next major release.")
```

Example 2 ["force" show warning and tell the users that there is a replacement for the deprecated function]:

```
export deprecated_foo
function deprecated_foo(args...; kwargs...)
    Base.depwarn("`deprecated_foo` is deprecated and will be removed in next major release, use `new_foo` instead.", :deprecated_foo, force = true)
    new_foo(args...; kwargs...)
end
```
=#

export FFTCorrelation
FFTCorrelation() = error(
    "`FFTCorrelation` is deprecated and will be removed in next major release, use `spectrum_correlation_fft` to calculate the spectrum with FFT method instead.",
)

export sparse_to_dense
function sparse_to_dense(args...)
    Base.depwarn(
        "`sparse_to_dense` is deprecated and will be removed in next major release, use `to_dense` instead.",
        :sparse_to_dense,
        force = true,
    )
    return to_dense(args...)
end

export dense_to_sparse
function dense_to_sparse(args...)
    Base.depwarn(
        "`dense_to_sparse` is deprecated and will be removed in next major release, use `to_sparse` instead.",
        :dense_to_sparse,
        force = true,
    )
    return to_sparse(args...)
end

function correlation_3op_2t(
        H::QuantumObject{HOpType},
        ψ0::QuantumObject{StateOpType},
        t_l::AbstractVector,
        τ_l::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        C::QuantumObject{Operator},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    Base.depwarn(
        "The argument order of `correlation_3op_2t(H, ψ0, t_l, τ_l, A, B, C, c_ops)` is changed to `correlation_3op_2t(H, ψ0, t_l, τ_l, c_ops, A, B, C)`, use `?correlation_3op_2t` to check the updated docstring.",
        :correlation_3op_2t,
        force = true,
    )
    return correlation_3op_2t(H, ψ0, t_l, τ_l, c_ops, A, B, C; kwargs...)
end

function correlation_3op_1t(
        H::QuantumObject{HOpType},
        ψ0::QuantumObject{StateOpType},
        τ_l::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        C::QuantumObject{Operator},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    Base.depwarn(
        "The argument order of `correlation_3op_1t(H, ψ0, τ_l, A, B, C, c_ops)` is changed to `correlation_3op_1t(H, ψ0, τ_l, c_ops, A, B, C)`, use `?correlation_3op_1t` to check the updated docstring.",
        :correlation_3op_1t,
        force = true,
    )
    return correlation_3op_1t(H, ψ0, τ_l, c_ops, A, B, C; kwargs...)
end

function correlation_2op_2t(
        H::QuantumObject{HOpType},
        ψ0::QuantumObject{StateOpType},
        t_l::AbstractVector,
        τ_l::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        reverse::Bool = false,
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    Base.depwarn(
        "The argument order of `correlation_2op_2t(H, ψ0, t_l, τ_l, A, B, c_ops)` is changed to `correlation_2op_2t(H, ψ0, t_l, τ_l, c_ops, A, B)`, use `?correlation_2op_2t` to check the updated docstring.",
        :correlation_2op_2t,
        force = true,
    )
    return correlation_2op_2t(H, ψ0, t_l, τ_l, c_ops, A, B; reverse = reverse, kwargs...)
end

function correlation_2op_1t(
        H::QuantumObject{HOpType},
        ψ0::QuantumObject{StateOpType},
        τ_l::AbstractVector,
        A::QuantumObject{Operator},
        B::QuantumObject{Operator},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        reverse::Bool = false,
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}, StateOpType <: Union{Ket, Operator}}
    Base.depwarn(
        "The argument order of `correlation_2op_1t(H, ψ0, τ_l, A, B, c_ops)` is changed to `correlation_2op_1t(H, ψ0, τ_l, c_ops, A, B)`, use `?correlation_2op_1t` to check the updated docstring.",
        :correlation_2op_1t,
        force = true,
    )
    return correlation_2op_1t(H, ψ0, τ_l, c_ops, A, B; reverse = reverse, kwargs...)
end

export MultiSiteOperator
function MultiSiteOperator(args...)
    Base.depwarn(
        "`MultiSiteOperator` is deprecated and will be removed in next major release, use `multisite_operator` instead.",
        :MultiSiteOperator,
        force = true,
    )
    return multisite_operator(args...)
end

export ProgressBar
function ProgressBar(args...; kwargs...)
    # Use error instead of depwarn, since ProgressBar and Progress have different arguments
    return error(
        "`ProgressBar` is deprecated and will be removed in next major release. Use `Progress` from `ProgressMeter.jl` instead.",
    )
end

function spre(A::AbstractQuantumObject{Operator}, Id_cache)
    Base.depwarn(
        "The argument `Id_cache` for `spre` is now deprecated, as we now internally use FillArrays.jl, which preserves the same efficiency without requiring this parameter.",
        :spre,
        force = true,
    )
    return spre(A)
end

function spost(A::AbstractQuantumObject{Operator}, Id_cache)
    Base.depwarn(
        "The argument `Id_cache` for `spost` is now deprecated, as we now internally use FillArrays.jl, which preserves the same efficiency without requiring this parameter.",
        :spost,
        force = true,
    )
    return spost(A)
end

function lindblad_dissipator(C::QuantumObject{Operator}, Id_cache)
    Base.depwarn(
        "The argument `Id_cache` for `lindblad_dissipator` is now deprecated, as we now internally use FillArrays.jl, which preserves the same efficiency without requiring this parameter.",
        :lindblad_dissipator,
        force = true,
    )
    return lindblad_dissipator(C)
end

function liouvillian(
        H::QuantumObject{HOpType},
        c_ops::AbstractVector,
        Id_cache;
        kwargs...,
    ) where {HOpType <: Union{Operator, SuperOperator}}
    Base.depwarn(
        "The argument `Id_cache` for `liouvillian` is now deprecated, as we now internally use FillArrays.jl, which preserves the same efficiency without requiring this parameter.",
        :liouvillian,
        force = true,
    )
    return liouvillian(H, c_ops; kwargs...)
end

export liouvillian_generalized
function liouvillian_generalized(args...; kwargs...)
    Base.depwarn(
        "`liouvillian_generalized` is deprecated and will be removed in next major release, use `liouvillian_dressed_nonsecular` instead.",
        :liouvillian_generalized,
        force = true,
    )
    return liouvillian_dressed_nonsecular(args...; kwargs...)
end

#=
Functions for generating (common) quantum operators.
=#

export rand_unitary
export jmat, spin_Jx, spin_Jy, spin_Jz, spin_Jm, spin_Jp, spin_J_set
export sigmam, sigmap, sigmax, sigmay, sigmaz
export destroy, create, eye, projection
export displace, squeeze, num, phase
export fdestroy, fcreate
export commutator
export tunneling
export qft

@doc raw"""
    rand_unitary([T::Type=ComplexF64,] dimensions, distribution=Val(:haar))

Returns a random unitary [`QuantumObject`](@ref) with element type `T = ComplexF64` (default).

The `dimensions` can be either the following types:
- `dimensions::Int`: Number of basis states in the Hilbert space.
- `dimensions::Union{ProductDimensions,AbstractVector{Int},Tuple}`: list of dimensions representing the each number of basis in the subsystems.

The `distribution` specifies which of the method used to obtain the unitary matrix:
- `:haar`: Haar random unitary matrix using the algorithm from reference 1
- `:exp`: Uses ``\exp(-i\hat{H})``, where ``\hat{H}`` is a randomly generated Hermitian operator.

# References
1. [F. Mezzadri, How to generate random matrices from the classical compact groups, arXiv:math-ph/0609050 (2007)](https://arxiv.org/abs/math-ph/0609050)

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `rand_unitary(dimensions, Val(distribution))` instead of `rand_unitary(dimensions, distribution)`. Also, put `dimensions` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl). See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
rand_unitary(::Type{T}, dimensions::Int, distribution::Union{Symbol, Val} = Val(:haar)) where {T <: FloatOrComplex} =
    rand_unitary(T, SVector(dimensions), makeVal(distribution))
rand_unitary(
    ::Type{T},
    dimensions::Union{ProductDimensions, AbstractVector{Int}, Tuple},
    distribution::Union{Symbol, Val} = Val(:haar),
) where {T <: FloatOrComplex} = rand_unitary(T, dimensions, makeVal(distribution))
function rand_unitary(::Type{T}, dimensions::Union{ProductDimensions, AbstractVector{Int}, Tuple}, ::Val{:haar}) where {T <: FloatOrComplex}
    N = get_hilbert_size(dimensions)[1]

    # generate N x N matrix Z of complex standard normal random variates
    Z = randn(T, N, N)

    # find QR decomposition: Z = Q ⋅ R
    Q, R = LinearAlgebra.qr(Z)

    # Create a diagonal matrix Λ by rescaling the diagonal elements of R.
    # Because inv(Λ) ⋅ R has real and strictly positive elements, Q · Λ is therefore Haar distributed.
    Λ = diag(R) # take the diagonal elements of R
    Λ ./= abs.(Λ) # rescaling the elements
    return QuantumObject(to_dense(Q * Diagonal(Λ)); type = Operator(), dims = dimensions)
end
function rand_unitary(::Type{T}, dimensions::Union{ProductDimensions, AbstractVector{Int}, Tuple}, ::Val{:exp}) where {T <: FloatOrComplex}
    N = get_hilbert_size(dimensions)[1]

    # generate N x N matrix Z of complex standard normal random variates
    Z = randn(T, N, N)

    # generate Hermitian matrix
    # make it a Qobj first, cause we need Qobj-ver. of exp() for special case in _rand_unitary_exp later
    H = QuantumObject((Z + Z') / 2; type = Operator(), dims = dimensions)
    return to_dense(_rand_unitary_exp(H))
end
rand_unitary(::Type{T}, dimensions::Union{ProductDimensions, AbstractVector{Int}, Tuple}, ::Val{Td}) where {T <: FloatOrComplex, Td} =
    throw(ArgumentError("Invalid distribution: $(Td)"))
rand_unitary(dimensions::Union{Int, ProductDimensions, AbstractVector{Int}, Tuple}, distribution::Union{Symbol, Val} = Val(:haar)) = rand_unitary(ComplexF64, dimensions, distribution)

# we make H sparse here because the following method currently does not exist : exp(::Matrix{Complex{BigFloat}})
_rand_unitary_exp(H::QuantumObject{Operator, <:AbstractDimensions, Matrix{Complex{BigFloat}}}) = exp(-im * to_sparse(H))
_rand_unitary_exp(H::QuantumObject{Operator, <:AbstractDimensions, <:AbstractArray}) = exp(-im * H)

@doc raw"""
    commutator(A::QuantumObject, B::QuantumObject; anti::Bool=false)

Return the commutator (or `anti`-commutator) of the two [`QuantumObject`](@ref):
- commutator (`anti=false`): ``\hat{A}\hat{B}-\hat{B}\hat{A}``
- anticommutator (`anti=true`): ``\hat{A}\hat{B}+\hat{B}\hat{A}``

Note that `A` and `B` must be [`Operator`](@ref)
"""
commutator(A::QuantumObject{Operator}, B::QuantumObject{Operator}; anti::Bool = false) = A * B - (-1)^anti * B * A

@doc raw"""
    destroy([T::Type=ComplexF64,] N::Int)

Bosonic annihilation operator with Hilbert space cutoff `N` and element type `T = ComplexF64` (default).

This operator acts on a fock state as ``\hat{a} \ket{n} = \sqrt{n} \ket{n-1}``.

# Examples

```jldoctest
julia> a = destroy(20)

Quantum Object:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 19 stored entries:
⎡⠈⠢⡀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠀⠈⠢⡀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠈⠢⡀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠀⠈⠢⡀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠀⠈⠢⎦

julia> fock(20, 3)' * a * fock(20, 4)
2.0 + 0.0im
```
"""
destroy(::Type{T}, N::Int) where {T <: FloatOrComplex} = QuantumObject(spdiagm(1 => T[sqrt(T(val)) for val in 1:(N - 1)]), Operator(), N)
destroy(N::Int) = destroy(ComplexF64, N)

@doc raw"""
    create([T::Type=ComplexF64,] N::Int)

Bosonic creation operator with Hilbert space cutoff `N` and element type `T = ComplexF64` (default).

This operator acts on a fock state as ``\hat{a}^\dagger \ket{n} = \sqrt{n+1} \ket{n+1}``.

# Examples

```jldoctest
julia> a_d = create(20)

Quantum Object:   type=Operator()   dims=([20], [20])   size=(20, 20)   ishermitian=false
20×20 SparseMatrixCSC{ComplexF64, Int64} with 19 stored entries:
⎡⠢⡀⠀⠀⠀⠀⠀⠀⠀⠀⎤
⎢⠀⠈⠢⡀⠀⠀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠈⠢⡀⠀⠀⠀⠀⎥
⎢⠀⠀⠀⠀⠀⠈⠢⡀⠀⠀⎥
⎣⠀⠀⠀⠀⠀⠀⠀⠈⠢⡀⎦

julia> fock(20, 4)' * a_d * fock(20, 3)
2.0 + 0.0im
```
"""
create(::Type{T}, N::Int) where {T <: FloatOrComplex} = QuantumObject(spdiagm(-1 => T[sqrt(T(val)) for val in 1:(N - 1)]), Operator(), N)
create(N::Int) = create(ComplexF64, N)

@doc raw"""
    displace(N::Int, α::Number)

Generate a [displacement operator](https://en.wikipedia.org/wiki/Displacement_operator) with element precision same as `α`:

```math
\hat{D}(\alpha)=\exp\left( \alpha \hat{a}^\dagger - \alpha^* \hat{a} \right),
```

where ``\hat{a}`` is the bosonic annihilation operator, and ``\alpha`` is the amount of displacement in optical phase space.
"""
function displace(N::Int, α::T) where {T <: Number}
    a = destroy(_float_type(T), N) # use float type to handle integer α
    return exp(α * a' - conj(α) * a) # the return eltype will be promoted to complex if α is complex
end

@doc raw"""
    squeeze(N::Int, z::Number)

Generate a single-mode [squeeze operator](https://en.wikipedia.org/wiki/Squeeze_operator) with element precision same as `z`:

```math
\hat{S}(z)=\exp\left( \frac{1}{2} (z^* \hat{a}^2 - z(\hat{a}^\dagger)^2) \right),
```

where ``\hat{a}`` is the bosonic annihilation operator.
"""
function squeeze(N::Int, z::T) where {T <: Number}
    a_sq = destroy(_float_type(T), N)^2 # use float type to handle integer z
    return exp((conj(z) * a_sq - z * a_sq') / 2) # the return eltype will be promoted to complex if z is complex
end

@doc raw"""
    num([T::Type=ComplexF64,] N::Int)

Bosonic number operator with Hilbert space cutoff `N` and element type `T = ComplexF64` (default). 

This operator is defined as ``\hat{N}=\hat{a}^\dagger \hat{a}``, where ``\hat{a}`` is the bosonic annihilation operator.
"""
num(::Type{T}, N::Int) where {T <: Number} = QuantumObject(spdiagm(0 => Array{T}(0:(N - 1))), Operator(), N)
num(N::Int) = num(ComplexF64, N)

@doc raw"""
    position([T::Type=ComplexF64,] N::Int)

Position operator with Hilbert space cutoff `N` and element type `T = ComplexF64` (default).

This operator is defined as ``\hat{x}=\frac{1}{\sqrt{2}} (\hat{a}^\dagger + \hat{a})``, where ``\hat{a}`` is the bosonic annihilation operator.
"""
function position(::Type{T}, N::Int) where {T <: FloatOrComplex}
    a = destroy(T, N)
    return (a' + a) / sqrt(T(2))
end
position(N::Int) = position(ComplexF64, N)

@doc raw"""
    momentum([T::Type=ComplexF64,] N::Int)

Momentum operator with Hilbert space cutoff `N` and element type `T = ComplexF64` (default).

This operator is defined as ``\hat{p}= \frac{i}{\sqrt{2}} (\hat{a}^\dagger - \hat{a})``, where ``\hat{a}`` is the bosonic annihilation operator.
"""
function momentum(::Type{T}, N::Int) where {T <: Complex}
    a = destroy(T, N)
    return (a - a') / (im * sqrt(T(2)))
end
momentum(N::Int) = momentum(ComplexF64, N)

@doc raw"""
    phase(N::Int, ϕ0::Real=0)

Single-mode Pegg-Barnett phase operator with Hilbert space cutoff ``N``, the reference phase ``\phi_0``, and element precision same as `ϕ0`.

This operator is defined as

```math
\hat{\phi} = \sum_{m=0}^{N-1} \phi_m |\phi_m\rangle \langle\phi_m|,
```

where

```math
\phi_m = \phi_0 + \frac{2m\pi}{N},
```

and

```math
|\phi_m\rangle = \frac{1}{\sqrt{N}} \sum_{n=0}^{N-1} \exp(i n \phi_m) |n\rangle.
```

# Reference
- [Michael Martin Nieto, QUANTUM PHASE AND QUANTUM PHASE OPERATORS: Some Physics and Some History, arXiv:hep-th/9304036](https://arxiv.org/abs/hep-th/9304036), Equation (30-32).
"""
function phase(N::Int, ϕ0::T = 0) where {T <: Real}
    N_list = collect(0:(N - 1))
    ϕ = ϕ0 .+ (2 * _float_type(T)(π) / N) .* N_list # _float_type(T) can deal with T = Int and BigFloat
    states = [exp.(im * ϕ[m] .* N_list) ./ sqrt(T(N)) for m in 1:N] # here promotes element type to complex
    return QuantumObject(sum([ϕ[m] * states[m] * states[m]' for m in 1:N]); type = Operator(), dims = N)
end

@doc raw"""
    jmat([T::Type=ComplexF64,] j::Real, which::Union{Symbol,Val})

Generate higher-order Spin-`j` operators with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

The parameter `which` specifies which of the following operator to return.
- `:x`: ``\hat{S}_x``
- `:y`: ``\hat{S}_y``
- `:z`: ``\hat{S}_z``
- `:+`: ``\hat{S}_+``
- `:-`: ``\hat{S}_-``

Note that if the parameter `which` is not specified, returns a set of Spin-`j` operators: ``(\hat{S}_x, \hat{S}_y, \hat{S}_z)``

# Examples
```jldoctest
julia> jmat(0.5, :x)

Quantum Object:   type=Operator()   dims=([2], [2])   size=(2, 2)   ishermitian=true
2×2 SparseMatrixCSC{ComplexF64, Int64} with 2 stored entries:
     ⋅      0.5+0.0im
 0.5+0.0im      ⋅

julia> jmat(0.5, Val(:-))

Quantum Object:   type=Operator()   dims=([2], [2])   size=(2, 2)   ishermitian=false
2×2 SparseMatrixCSC{ComplexF64, Int64} with 1 stored entry:
     ⋅          ⋅    
 1.0+0.0im      ⋅

julia> jmat(1.5, Val(:z))

Quantum Object:   type=Operator()   dims=([4], [4])   size=(4, 4)   ishermitian=true
4×4 SparseMatrixCSC{ComplexF64, Int64} with 4 stored entries:
 1.5+0.0im      ⋅           ⋅           ⋅    
     ⋅      0.5+0.0im       ⋅           ⋅    
     ⋅          ⋅      -0.5+0.0im       ⋅    
     ⋅          ⋅           ⋅      -1.5+0.0im
```

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `jmat(j, Val(which))` instead of `jmat(j, which)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
jmat(::Type{T}, j::Real, which::Symbol) where {T <: FloatOrComplex} = jmat(T, j, Val(which))
jmat(::Type{T}, j::Real) where {T <: FloatOrComplex} = (jmat(T, j, Val(:x)), jmat(T, j, Val(:y)), jmat(T, j, Val(:z)))
function jmat(::Type{T}, j::Real, ::Val{:x}) where {T <: FloatOrComplex}
    J = 2 * j + 1
    ((floor(J) != J) || (j < 0)) &&
        throw(ArgumentError("The spin quantum number (j) must be a non-negative integer or half-integer."))

    σ = _jm(T, j)
    return QuantumObject((σ' + σ) / 2, Operator(), Int(J))
end
function jmat(::Type{T}, j::Real, ::Val{:y}) where {T <: FloatOrComplex}
    J = 2 * j + 1
    ((floor(J) != J) || (j < 0)) &&
        throw(ArgumentError("The spin quantum number (j) must be a non-negative integer or half-integer."))

    σ = _jm(T, j)
    return QuantumObject((σ' - σ) / 2im, Operator(), Int(J))
end
function jmat(::Type{T}, j::Real, ::Val{:z}) where {T <: FloatOrComplex}
    J = 2 * j + 1
    ((floor(J) != J) || (j < 0)) &&
        throw(ArgumentError("The spin quantum number (j) must be a non-negative integer or half-integer."))

    return QuantumObject(_jz(T, j), Operator(), Int(J))
end
function jmat(::Type{T}, j::Real, ::Val{:+}) where {T <: FloatOrComplex}
    J = 2 * j + 1
    ((floor(J) != J) || (j < 0)) &&
        throw(ArgumentError("The spin quantum number (j) must be a non-negative integer or half-integer."))

    return QuantumObject(adjoint(_jm(T, j)), Operator(), Int(J))
end
function jmat(::Type{T}, j::Real, ::Val{:-}) where {T <: FloatOrComplex}
    J = 2 * j + 1
    ((floor(J) != J) || (j < 0)) &&
        throw(ArgumentError("The spin quantum number (j) must be a non-negative integer or half-integer."))

    return QuantumObject(_jm(T, j), Operator(), Int(J))
end
jmat(::Type{T}, j::Real, ::Val{T2}) where {T <: FloatOrComplex, T2} = throw(ArgumentError("Invalid spin operator: $(T2)"))
jmat(j::Real, which::Union{Symbol, Val}) = jmat(ComplexF64, j, which)
jmat(j::Real) = jmat(ComplexF64, j)

function _jm(::Type{T}, j::Real) where {T <: FloatOrComplex}
    m = T.(j:(-1):(-j))
    data = @. sqrt(T(j * (j + 1)) - m * (m - 1))
    return spdiagm(-1 => data[1:(end - 1)])
end
function _jz(::Type{T}, j::Real) where {T <: FloatOrComplex}
    data = @. T(j) - (0:Int(2 * j))
    return spdiagm(0 => data)
end

@doc raw"""
    spin_Jx([T::Type=ComplexF64,] j::Real)

``\hat{S}_x`` operator for Spin-`j` with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

See also [`jmat`](@ref).
"""
spin_Jx(::Type{T}, j::Real) where {T <: FloatOrComplex} = jmat(T, j, Val(:x))
spin_Jx(j::Real) = spin_Jx(ComplexF64, j)

@doc raw"""
    spin_Jy([T::Type=ComplexF64,] j::Real)

``\hat{S}_y`` operator for Spin-`j` with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

See also [`jmat`](@ref).
"""
spin_Jy(::Type{T}, j::Real) where {T <: FloatOrComplex} = jmat(T, j, Val(:y))
spin_Jy(j::Real) = spin_Jy(ComplexF64, j)

@doc raw"""
    spin_Jz([T::Type=ComplexF64,] j::Real)

``\hat{S}_z`` operator for Spin-`j` with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

See also [`jmat`](@ref).
"""
spin_Jz(::Type{T}, j::Real) where {T <: FloatOrComplex} = jmat(T, j, Val(:z))
spin_Jz(j::Real) = spin_Jz(ComplexF64, j)

@doc raw"""
    spin_Jm([T::Type=ComplexF64,] j::Real)

``\hat{S}_-`` operator for Spin-`j` with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

See also [`jmat`](@ref).
"""
spin_Jm(::Type{T}, j::Real) where {T <: FloatOrComplex} = jmat(T, j, Val(:-))
spin_Jm(j::Real) = spin_Jm(ComplexF64, j)

@doc raw"""
    spin_Jp([T::Type=ComplexF64,] j::Real)

``\hat{S}_+`` operator for Spin-`j` with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

See also [`jmat`](@ref).
"""
spin_Jp(::Type{T}, j::Real) where {T <: FloatOrComplex} = jmat(T, j, Val(:+))
spin_Jp(j::Real) = spin_Jp(ComplexF64, j)

@doc raw"""
    spin_J_set([T::Type=ComplexF64,] j::Real)

A set of Spin-`j` operators ``(\hat{S}_x, \hat{S}_y, \hat{S}_z)`` with element type `T = ComplexF64` (default). `j` is the spin quantum number and can be a non-negative integer or half-integer.

Note that this functions is same as `jmat(j)`. See also [`jmat`](@ref).
"""
spin_J_set(::Type{T}, j::Real) where {T <: FloatOrComplex} = jmat(T, j)
spin_J_set(j::Real) = spin_J_set(ComplexF64, j)

@doc raw"""
    sigmap([T::Type=ComplexF64])

Pauli ladder operator ``\hat{\sigma}_+ = (\hat{\sigma}_x + i \hat{\sigma}_y) / 2`` with element type `T = ComplexF64` (default).

See also [`jmat`](@ref).
"""
sigmap(::Type{T}) where {T <: FloatOrComplex} = jmat(T, 0.5, Val(:+))
sigmap() = sigmap(ComplexF64)

@doc raw"""
    sigmam([T::Type=ComplexF64])

Pauli ladder operator ``\hat{\sigma}_- = (\hat{\sigma}_x - i \hat{\sigma}_y) / 2`` with element type `T = ComplexF64` (default).

See also [`jmat`](@ref).
"""
sigmam(::Type{T}) where {T <: FloatOrComplex} = jmat(T, 0.5, Val(:-))
sigmam() = sigmam(ComplexF64)

@doc raw"""
    sigmax([T::Type=ComplexF64])

Pauli operator ``\hat{\sigma}_x = \hat{\sigma}_- + \hat{\sigma}_+`` with element type `T = ComplexF64` (default).

See also [`jmat`](@ref).
"""
sigmax(::Type{T}) where {T <: FloatOrComplex} = rmul!(jmat(T, 0.5, Val(:x)), 2)
sigmax() = sigmax(ComplexF64)

@doc raw"""
    sigmay([T::Type=ComplexF64])

Pauli operator ``\hat{\sigma}_y = i \left( \hat{\sigma}_- - \hat{\sigma}_+ \right)`` with element type `T = ComplexF64` (default).

See also [`jmat`](@ref).
"""
sigmay(::Type{T}) where {T <: FloatOrComplex} = rmul!(jmat(T, 0.5, Val(:y)), 2)
sigmay() = sigmay(ComplexF64)

@doc raw"""
    sigmaz([T::Type=ComplexF64])

Pauli operator ``\hat{\sigma}_z = \left[ \hat{\sigma}_+ , \hat{\sigma}_- \right]`` with element type `T = ComplexF64` (default).

See also [`jmat`](@ref).
"""
sigmaz(::Type{T}) where {T <: FloatOrComplex} = rmul!(jmat(T, 0.5, Val(:z)), 2)
sigmaz() = sigmaz(ComplexF64)

@doc raw"""
    eye([T::Type=ComplexF64,] N::Int; type=Operator, dims=nothing)
    qeye([T::Type=ComplexF64,] N::Int; type=Operator, dims=nothing)

Identity operator ``\hat{\mathbb{1}}`` with size `N` and element type `T = ComplexF64` (default).

It is also possible to specify the list of Hilbert dimensions `dims` if different subsystems are present.

Note that `type` can only be either [`Operator`](@ref) or [`SuperOperator`](@ref)

!!! note
    `qeye` is a synonym of `eye`.
"""
function eye(::Type{T}, N::Int; type = Operator(), dims = nothing) where {T <: Number}
    if dims isa Nothing
        dims = isa(type, Operator) ? N : isqrt(N)
    end
    return QuantumObject(Diagonal(ones(T, N)); type, dims)
end
eye(N::Int; type = Operator(), dims = nothing) = eye(ComplexF64, N; type, dims)

@doc raw"""
    fdestroy([T::Type=ComplexF64,] N::Union{Int,Val}, j::Int)

Construct a fermionic destruction operator [with element type `T = ComplexF64` (default)] acting on the `j`-th site, where the fock space has totally `N`-sites:

Here, we use the [Jordan-Wigner transformation](https://en.wikipedia.org/wiki/Jordan%E2%80%93Wigner_transformation), namely
```math
\hat{d}_j = \hat{\sigma}_z^{\otimes j-1} \otimes \hat{\sigma}_{+} \otimes \hat{\mathbb{1}}^{\otimes N-j}
```

The site index `j` should satisfy: `1 ≤ j ≤ N`.

Note that we put ``\hat{\sigma}_{+} = \begin{pmatrix} 0 & 1 \\ 0 & 0 \end{pmatrix}`` here because we consider ``|0\rangle = \begin{pmatrix} 1 \\ 0 \end{pmatrix}`` to be ground (vacant) state, and ``|1\rangle = \begin{pmatrix} 0 \\ 1 \end{pmatrix}`` to be excited (occupied) state.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `fdestroy(Val(N), j)` instead of `fdestroy(N, j)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
fdestroy(::Type{T}, N::Union{Int, Val}, j::Int) where {T <: FloatOrComplex} = _Jordan_Wigner(T, N, j, sigmap(T))
fdestroy(N::Union{Int, Val}, j::Int) = fdestroy(ComplexF64, N, j)

@doc raw"""
    fcreate([T::Type=ComplexF64,] N::Union{Int,Val}, j::Int)

Construct a fermionic creation operator [with element type `T = ComplexF64` (default)] acting on the `j`-th site, where the fock space has totally `N`-sites:

Here, we use the [Jordan-Wigner transformation](https://en.wikipedia.org/wiki/Jordan%E2%80%93Wigner_transformation), namely
```math
\hat{d}^\dagger_j = \hat{\sigma}_z^{\otimes j-1} \otimes \hat{\sigma}_{-} \otimes \hat{\mathbb{1}}^{\otimes N-j}
```

The site index `j` should satisfy: `1 ≤ j ≤ N`.

Note that we put ``\hat{\sigma}_{-} = \begin{pmatrix} 0 & 0 \\ 1 & 0 \end{pmatrix}`` here because we consider ``|0\rangle = \begin{pmatrix} 1 \\ 0 \end{pmatrix}`` to be ground (vacant) state, and ``|1\rangle = \begin{pmatrix} 0 \\ 1 \end{pmatrix}`` to be excited (occupied) state.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `fcreate(Val(N), j)` instead of `fcreate(N, j)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
fcreate(::Type{T}, N::Union{Int, Val}, j::Int) where {T <: FloatOrComplex} = _Jordan_Wigner(T, N, j, sigmam(T))
fcreate(N::Union{Int, Val}, j::Int) = fcreate(ComplexF64, N, j)

_Jordan_Wigner(::Type{T}, N::Int, j::Int, op::QuantumObject{Operator}) where {T <: FloatOrComplex} = _Jordan_Wigner(T, Val(N), j, op)

function _Jordan_Wigner(::Type{T}, ::Val{N}, j::Int, op::QuantumObject{Operator}) where {T <: FloatOrComplex, N}
    (N < 1) && throw(ArgumentError("The total number of sites (N) cannot be less than 1"))
    (1 <= j <= N) || throw(ArgumentError("The site index (j) should satisfy: 1 ≤ j ≤ N"))

    σz = sigmaz(T).data
    Z_tensor = kron(one(T), one(T), fill(σz, j - 1)...)

    S = 2^(N - j)
    I_tensor = sparse(one(T) * LinearAlgebra.I, S, S)

    return QuantumObject(kron(Z_tensor, op.data, I_tensor); type = Operator(), dims = ntuple(i -> 2, Val(N)))
end

@doc raw"""
    projection([T::Type=ComplexF64,] N::Int, i::Int, j::Int)

Generates the projection operator ``\hat{O} = |i \rangle\langle j|`` with Hilbert space dimension `N` and element type `T = ComplexF64` (default).
"""
function projection(::Type{T}, N::Int, i::Int, j::Int) where {T <: Number}
    (0 <= i < N) || throw(ArgumentError("Invalid argument i, must satisfy: 0 ≤ i ≤ N-1"))
    (0 <= j < N) || throw(ArgumentError("Invalid argument j, must satisfy: 0 ≤ j ≤ N-1"))

    return QuantumObject(sparse([i + 1], [j + 1], [one(T)], N, N), type = Operator(), dims = N)
end
projection(N::Int, i::Int, j::Int) = projection(ComplexF64, N, i, j)

@doc raw"""
    tunneling([T::Type=ComplexF64,] N::Int, m::Int=1; sparse::Union{Bool,Val{<:Bool}}=Val(false))

Generate a tunneling operator with element type `T = ComplexF64` (default), defined as:

```math
\sum_{n=0}^{N-m} | n \rangle\langle n+m | + | n+m \rangle\langle n |,
```

where ``N`` is the number of basis states in the Hilbert space, and ``m`` is the number of excitations in tunneling event.

If `sparse=true`, the operator is returned as a sparse matrix, otherwise a dense matrix is returned.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `tunneling(N, m, Val(sparse))` instead of `tunneling(N, m, sparse)`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
function tunneling(::Type{T}, N::Int, m::Int = 1; sparse::Union{Bool, Val} = Val(false)) where {T <: Number}
    (m < 1) && throw(ArgumentError("The number of excitations (m) cannot be less than 1"))

    data = ones(T, N - m)
    if getVal(sparse)
        return QuantumObject(spdiagm(m => data, -m => data); type = Operator(), dims = N)
    else
        return QuantumObject(diagm(m => data, -m => data); type = Operator(), dims = N)
    end
end
tunneling(N::Int, m::Int = 1; sparse::Union{Bool, Val} = Val(false)) = tunneling(ComplexF64, N, m; sparse)

@doc raw"""
    qft([T::Type=ComplexF64,] dimensions)

Generates a discrete Fourier transform matrix ``\hat{F}_N`` for [Quantum Fourier Transform (QFT)](https://en.wikipedia.org/wiki/Quantum_Fourier_transform) with given argument `dimensions` and element type `T = ComplexF64` (default).

The `dimensions` can be either the following types:
- `dimensions::Int`: Number of basis states in the Hilbert space.
- `dimensions::Union{ProductDimensions,AbstractVector{Int},Tuple}`: list of dimensions representing the each number of basis in the subsystems.

``N`` represents the total dimension, and therefore the matrix is defined as

```math
\hat{F}_N = \frac{1}{\sqrt{N}}\begin{bmatrix}
1 & 1 & 1 & 1 & \cdots & 1\\
1 & \omega & \omega^2 & \omega^3 & \cdots & \omega^{N-1}\\
1 & \omega^2 & \omega^4 & \omega^6 & \cdots & \omega^{2(N-1)}\\
1 & \omega^3 & \omega^6 & \omega^9 & \cdots & \omega^{3(N-1)}\\
\vdots & \vdots & \vdots & \vdots & \ddots & \vdots\\
1 & \omega^{N-1} & \omega^{2(N-1)} & \omega^{3(N-1)} & \cdots & \omega^{(N-1)(N-1)}
\end{bmatrix},
```

where ``\omega = \exp(\frac{2 \pi i}{N})``.

!!! warning "Beware of type-stability!"
    It is highly recommended to use `qft(dimensions)` with `dimensions` as `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) to keep type stability. See the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
qft(::Type{T}, dimensions::Int) where {T <: Complex} = QuantumObject(_qft_op(T, dimensions), Operator(), dimensions)
qft(::Type{T}, dimensions::Union{ProductDimensions, AbstractVector{Int}, Tuple}) where {T <: Complex} =
    QuantumObject(_qft_op(T, get_hilbert_size(dimensions)[1]), Operator(), dimensions)
qft(dimensions::Union{Int, ProductDimensions, AbstractVector{Int}, Tuple}) = qft(ComplexF64, dimensions)

function _qft_op(::Type{T}, N::Int) where {T <: Complex}
    N_T = T(N)
    ω = exp(2 * im * T(π) / N_T)
    arr = 0:(N - 1)
    L, M = meshgrid(arr, arr)
    return ω .^ (L .* M) / sqrt(N_T)
end

export WignerSolver, WignerClenshaw, WignerLaguerre, wigner

abstract type WignerSolver end

struct WignerClenshaw <: WignerSolver end

struct WignerLaguerre <: WignerSolver
    parallel::Bool
    tol::Float64
end

WignerLaguerre(; parallel = false, tol = 1.0e-14) = WignerLaguerre(parallel, tol)

@doc raw"""
    wigner(
        state::QuantumObject{OpType},
        xvec::AbstractVector,
        yvec::AbstractVector;
        g::Real = √2,
        method::WignerSolver = WignerClenshaw(),
    )

Generates the [Wigner quasipropability distribution](https://en.wikipedia.org/wiki/Wigner_quasiprobability_distribution) of `state` at points `xvec + 1im * yvec` in phase space. The `g` parameter is a scaling factor related to the value of ``\hbar`` in the commutation relation ``[x, y] = i \hbar`` via ``\hbar=2/g^2`` giving the default value ``\hbar=1``.

The `method` parameter can be either `WignerLaguerre()` or `WignerClenshaw()`. The former uses the Laguerre polynomial expansion of the Wigner function, while the latter uses the Clenshaw algorithm. The Laguerre expansion is faster for sparse matrices, while the Clenshaw algorithm is faster for dense matrices. The `WignerLaguerre` method has an optional `parallel` parameter which defaults to `true` and uses multithreading to speed up the calculation.

# Arguments
- `state::QuantumObject`: The quantum state for which the Wigner function is calculated. It can be either a [`Ket`](@ref), [`Bra`](@ref), or [`Operator`](@ref).
- `xvec::AbstractVector`: The x-coordinates of the phase space grid.
- `yvec::AbstractVector`: The y-coordinates of the phase space grid.
- `g::Real`: The scaling factor related to the value of ``\hbar`` in the commutation relation ``[x, y] = i \hbar`` via ``\hbar=2/g^2``.
- `method::WignerSolver`: The method used to calculate the Wigner function. It can be either `WignerLaguerre()` or `WignerClenshaw()`, with `WignerClenshaw()` as default. The `WignerLaguerre` method has the optional `parallel` and `tol` parameters, with default values `true` and `1e-14`, respectively.

# Returns
- `W::Matrix`: The Wigner function of the state at the points `xvec + 1im * yvec` in phase space.

# Example
```jldoctest wigner
julia> ψ = fock(10, 0) + fock(10, 1) |> normalize

Quantum Object:   type=Ket()   dims=([10], [1])   size=(10,)
10-element Vector{ComplexF64}:
 0.7071067811865475 + 0.0im
 0.7071067811865475 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im

julia> xvec = range(-5, 5, 200)
-5.0:0.05025125628140704:5.0

julia> wig = wigner(ψ, xvec, xvec);
```

or taking advantage of the parallel computation of the `WignerLaguerre` method

```jldoctest wigner
julia> ρ = ket2dm(ψ) |> to_sparse;

julia> wig = wigner(ρ, xvec, xvec, method=WignerLaguerre(parallel=true));

```
"""
function wigner(
        state::QuantumObject{OpType},
        xvec::AbstractVector,
        yvec::AbstractVector;
        g::Real = √2,
        method::WignerSolver = WignerClenshaw(),
    ) where {OpType <: Union{Bra, Ket, Operator}}
    ρ = ket2dm(state).data

    return _wigner(ρ, xvec, yvec, g, method)
end

function _wigner(
        ρ::AbstractArray,
        xvec::AbstractVector{T},
        yvec::AbstractVector{T},
        g::Real,
        method::WignerLaguerre,
    ) where {T <: Number}
    g = convert(T, g)
    X, Y = meshgrid(xvec, yvec)
    A = g / 2 * (X + 1im * Y)
    W = similar(A, T)
    W .= 0

    return _wigner_laguerre(ρ, A, W, g, method)
end

function _wigner(
        ρ::AbstractArray{T1},
        xvec::AbstractVector{T},
        yvec::AbstractVector{T},
        g::Real,
        method::WignerClenshaw,
    ) where {T1 <: Number, T <: Number}
    g = convert(T, g)
    M = size(ρ, 1)
    X, Y = meshgrid(xvec, yvec)
    A = g * (X + 1im * Y)

    B = abs.(A)
    B .*= B
    W = similar(A)
    W .= 2 * ρ[1, end]
    L = M - 1

    y0 = similar(B, T1)
    y1 = similar(B, T1)
    y0_old = copy(y0)
    res = similar(y0)

    while L > 0
        L -= 1
        ρdiag = _wig_laguerre_clenshaw!(res, L, B, lmul!(1 + Int(L != 0), diag(ρ, L)), y0, y1, y0_old)
        @. W = ρdiag + W * A / √(L + 1)
    end

    return @. real(W) * exp(-B / 2) * g^2 / 2 / π
end

function _wigner_laguerre(ρ::AbstractSparseArray, A::AbstractArray, W::AbstractArray, g::Real, method::WignerLaguerre)
    rows, cols, vals = findnz(ρ)
    B = @. 4 * abs2(A)

    if method.parallel
        iter = filter(x -> x[2] >= x[1], collect(zip(rows, cols, vals)))
        Wtot = similar(B, size(B)..., length(iter))
        Threads.@threads for i in eachindex(iter)
            m, n, ρmn = iter[i]
            m, n = m - 1, n - 1
            # Γ_mn = (1 + Int(m!=n)) * sqrt(gamma(m+1) / gamma(n+1))
            Γ_mn = (1 + Int(m != n)) * sqrt(exp(loggamma(m + 1) - loggamma(n + 1))) # Is this a good trick?
            Γ_mn = check_inf(Γ_mn)

            @. Wtot[:, :, i] = real(ρmn * (-1)^m * (2 * A)^(n - m) * Γ_mn * _genlaguerre(m, n - m, B))
        end
        W .= dropdims(sum(Wtot, dims = 3), dims = 3)
    else
        for i in Iterators.filter(x -> x[2] >= x[1], zip(rows, cols, vals))
            m, n, ρmn = i
            m, n = m - 1, n - 1
            # Γ_mn = (1 + Int(m!=n)) * sqrt(gamma(m+1) / gamma(n+1))
            Γ_mn = (1 + Int(m != n)) * sqrt(exp(loggamma(m + 1) - loggamma(n + 1))) # Is this a good trick?
            Γ_mn = check_inf(Γ_mn)

            @. W += real(ρmn * (-1)^m * (2 * A)^(n - m) * Γ_mn * _genlaguerre(m, n - m, B))
        end
    end

    return @. W * g^2 * exp(-B / 2) / 2 / π
end

function _wigner_laguerre(ρ::AbstractArray, A::AbstractArray, W::AbstractArray, g::Real, method::WignerLaguerre)
    tol = method.tol
    M = size(ρ, 1)
    B = @. 4 * abs2(A)

    if method.parallel
        throw(ArgumentError("Parallel version is not implemented for dense matrices"))
    else
        for m in 0:(M - 1)
            ρmn = ρ[m + 1, m + 1]
            abs(ρmn) > tol && (@. W += real(ρmn * (-1)^m * _genlaguerre(m, 0, B)))
            for n in (m + 1):(M - 1)
                ρmn = ρ[m + 1, n + 1]
                # Γ_mn = sqrt(gamma(m+1) / gamma(n+1))
                Γ_mn = sqrt(exp(loggamma(m + 1) - loggamma(n + 1))) # Is this a good trick?
                Γ_mn = check_inf(Γ_mn)

                abs(ρmn) > tol && (@. W += 2 * real(ρmn * (-1)^m * (2 * A)^(n - m) * Γ_mn * _genlaguerre(m, n - m, B)))
            end
        end
    end

    return @. W * g^2 * exp(-B / 2) / 2 / π
end

# function _genlaguerre(n::Int, α::Int, x::T) where {T<:Number}
#     t = binomial(n+α,n)
#     L = t
#     for k = 1:n
#         t *= (-x) * (n-k+1) /  (k * (k+α))
#         L += t
#     end
#     return L
# end
# This is a little bit slower, but it supports GPU
function _genlaguerre(n::Int, α::Number, x::T) where {T <: Number}
    α = convert(T, α)
    p0, p1 = one(T), -x + (α + 1)
    n == 0 && return p0
    for k in 1:(n - 1)
        p1, p0 = ((2k + α + 1) / (k + 1) - x / (k + 1)) * p1 - (k + α) / (k + 1) * p0, p1
    end
    return p1
end

check_inf(x::T) where {T} =
if isinf(x)
    return x > zero(T) ? floatmax(T) : -floatmax(T)
else
    return x
end

function _wig_laguerre_clenshaw!(res, L::Int, x, c, y0, y1, y0_old)
    length(c) == 1 && return c[1]
    length(c) == 2 && return @. c[1] - c[2] * (L + 1 - x) / sqrt(L + 1)

    y0 .= c[end - 1]
    y1 .= c[end]

    k = length(c)
    for i in range(3, length(c), step = 1)
        k -= 1
        copyto!(y0_old, y0)
        @. y0 = c[end + 1 - i] - y1 * sqrt((k - 1) * (L + k - 1) / ((L + k) * k))
        @. y1 = y0_old - y1 * ((L + 2 * k - 1) - x) / sqrt((L + k) * k)
    end

    @. res = y0 - y1 * (L + 1 - x) / sqrt(L + 1)

    return res
end

function benchmark_eigenvalues!(SUITE)
    N = 5
    a = tensor(destroy(N), qeye(N))
    a_d = a'
    b = tensor(qeye(N), destroy(N))
    b_d = b'

    ωc = 1
    ωb = 1
    g = 0.2
    κ = 0.01
    n_th = 0.1

    H = ωc * a_d * a + ωb * b_d * b + g * (a + a_d) * (b + b_d)
    c_ops = [√((1 + n_th) * κ) * a, √κ * b, √(n_th * κ) * a_d]
    L = liouvillian(H, c_ops)

    SUITE["Eigenvalues"]["eigenstates"]["dense"] = @benchmarkable eigenstates($L)
    SUITE["Eigenvalues"]["eigenstates"]["sparse"] =
        @benchmarkable eigenstates($L, sparse = Val(true), sigma = 0.01, eigvals = 5)

    return nothing
end

export ssesolveProblem, ssesolveEnsembleProblem, ssesolve

# TODO: Implement the three-argument dot function for SciMLOperators.jl
# Currently, we are assuming a time-independent MatrixOperator
function _ssesolve_update_coeff(u, p, t, op)
    normalize!(u)
    return real(dot(u, op.A, u)) #this is en/2: <Sn + Sn'>/2 = Re<Sn>
end

_ScalarOperator_e(op, f = +) = ScalarOperator(one(eltype(op)), (a, u, p, t) -> f(_ssesolve_update_coeff(u, p, t, op)))

_ScalarOperator_e2_2(op, f = +) =
    ScalarOperator(one(eltype(op)), (a, u, p, t) -> f(_ssesolve_update_coeff(u, p, t, op)^2 / 2))

@doc raw"""
    ssesolveProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        sc_ops::Union{Nothing,AbstractVector,Tuple,AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        progress_bar::Union{Val,Bool} = Val(true),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    )

Generate the SDEProblem for the Stochastic Schrödinger time evolution of a quantum system. This is defined by the following stochastic differential equation:
    
```math
d|\psi(t)\rangle = -i \hat{K} |\psi(t)\rangle dt + \sum_n \hat{M}_n |\psi(t)\rangle dW_n(t)
```

where 
    
```math
\hat{K} = \hat{H} + i \sum_n \left(\frac{e_n}{2} \hat{S}_n - \frac{1}{2} \hat{S}_n^\dagger \hat{S}_n - \frac{e_n^2}{8}\right),
```
```math
\hat{M}_n = \hat{S}_n - \frac{e_n}{2},
```
and
```math
e_n = \langle \hat{S}_n + \hat{S}_n^\dagger \rangle.
```

Above, ``\hat{S}_n`` are the stochastic collapse operators and ``dW_n(t)`` is the real Wiener increment associated to ``\hat{S}_n``. See [Wiseman2009Quantum](@cite) for more details.

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``.
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `sc_ops`: List of stochastic collapse operators ``\{\hat{S}_n\}_n``. It can be either a `Vector`, a `Tuple` or a [`AbstractQuantumObject`](@ref). It is recommended to use the last case when only one operator is provided.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: `NullParameters` of parameters to pass to the solver.
- `rng`: Random number generator for reproducibility.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `store_measurement`: Whether to store the measurement results. Default is `Val(false)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-2` and `abstol=1e-2`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

!!! tip "Performance Tip"
    When `sc_ops` contains only a single operator, it is recommended to pass only that operator as the argument. This ensures that the stochastic noise is diagonal, making the simulation faster.

# Returns

- `prob`: The `SDEProblem` for the Stochastic Schrödinger time evolution of the system.
"""
function ssesolveProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        sc_ops::Union{Nothing, AbstractVector, Tuple, AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        progress_bar::Union{Val, Bool} = Val(true),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    )
    haskey(kwargs, :save_idxs) &&
        throw(ArgumentError("The keyword argument \"save_idxs\" is not supported in QuantumToolbox."))

    sc_ops isa Nothing &&
        throw(ArgumentError("The list of stochastic collapse operators must be provided. Use sesolveProblem instead."))
    sc_ops_list = _make_c_ops_list(sc_ops) # If it is an AbstractQuantumObject but we need to iterate
    sc_ops_isa_Qobj = sc_ops isa AbstractQuantumObject # We can avoid using non-diagonal noise if sc_ops is just an AbstractQuantumObject

    H_eff_evo = _mcsolve_make_Heff_QobjEvo(H, sc_ops_list)
    isoper(H_eff_evo) || throw(ArgumentError("The Hamiltonian must be an Operator."))

    # Convert initial state to dense vector with complex element type (T) and check dimensions
    T, ψ0, states_type, dimensions = _handle_init_state_and_sol_type_dims(H_eff_evo, ψ0)

    sc_ops_evo_data = Tuple(map(get_data ∘ QobjEvo, sc_ops_list))

    # Here the coefficients depend on the state, so this is a non-linear operator, which should be implemented with FunctionOperator instead. However, the nonlinearity is only on the coefficients, and it should be safe.
    K_l = sum(
        op ->
        _ScalarOperator_e(op, +) * op + _ScalarOperator_e2_2(op, -) * IdentityOperator(size(H_eff_evo, 1)),
        sc_ops_evo_data,
    )

    K = cache_operator(get_data(-1im * QuantumObjectEvolution(H_eff_evo)) + K_l, ψ0)

    D_l = map(op -> op + _ScalarOperator_e(op, -) * IdentityOperator(size(H_eff_evo, 1)), sc_ops_evo_data)
    D = DiffusionOperator(D_l)

    tlist = _check_tlist(tlist, _float_type(T))

    kwargs2 = _merge_saveat(tlist, e_ops, default_sde_solver_options(T); kwargs...)
    kwargs3 = _merge_tstops(kwargs2, isconstant(K), tlist)
    kwargs4 = _generate_stochastic_kwargs(
        e_ops,
        sc_ops_list,
        makeVal(progress_bar),
        tlist,
        makeVal(store_measurement),
        kwargs3,
        SaveFuncSSESolve,
    )

    tspan = (tlist[1], tlist[end])
    noise = _make_noise(tspan[1], sc_ops, makeVal(store_measurement), rng)
    noise_rate_prototype = sc_ops_isa_Qobj ? nothing : similar(ψ0, length(ψ0), length(sc_ops_list))
    prob = SDEProblem{true}(
        K,
        D,
        ψ0,
        tspan,
        params;
        noise_rate_prototype = noise_rate_prototype,
        noise = noise,
        kwargs4...,
    )

    return TimeEvolutionProblem(prob, tlist, states_type, dimensions)
end

@doc raw"""
    ssesolveEnsembleProblem(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        sc_ops::Union{Nothing,AbstractVector,Tuple,AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple,Nothing} = nothing,
        progress_bar::Union{Val,Bool} = Val(true),
        store_measurement::Union{Val,Bool} = Val(false),
        kwargs...,
    )

Generate the SDE EnsembleProblem for the Stochastic Schrödinger time evolution of a quantum system. This is defined by the following stochastic differential equation:
    
```math
d|\psi(t)\rangle = -i \hat{K} |\psi(t)\rangle dt + \sum_n \hat{M}_n |\psi(t)\rangle dW_n(t)
```

where 
    
```math
\hat{K} = \hat{H} + i \sum_n \left(\frac{e_n}{2} \hat{S}_n - \frac{1}{2} \hat{S}_n^\dagger \hat{S}_n - \frac{e_n^2}{8}\right),
```
```math
\hat{M}_n = \hat{S}_n - \frac{e_n}{2},
```
and
```math
e_n = \langle \hat{S}_n + \hat{S}_n^\dagger \rangle.
```

Above, ``\hat{S}_n`` are the stochastic collapse operators and  ``dW_n(t)`` is the real Wiener increment associated to ``\hat{S}_n``. See [Wiseman2009Quantum](@cite) for more details.

# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``.
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `sc_ops`: List of stochastic collapse operators ``\{\hat{S}_n\}_n``. It can be either a `Vector`, a `Tuple` or a [`AbstractQuantumObject`](@ref). It is recommended to use the last case when only one operator is provided.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: `NullParameters` of parameters to pass to the solver.
- `rng`: Random number generator for reproducibility.
- `ntraj`: Number of trajectories to use. Default is `500`.
- `ensemblealg`: Ensemble method to use. Default to `EnsembleThreads()`.
- `jump_callback`: The Jump Callback type: Discrete or Continuous. The default is `ContinuousLindbladJumpCallback()`, which is more precise.
- `prob_func`: Function to use for generating the SDEProblem.
- `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `store_measurement`: Whether to store the measurement results. Default is `Val(false)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-2` and `abstol=1e-2`.
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

!!! tip "Performance Tip"
    When `sc_ops` contains only a single operator, it is recommended to pass only that operator as the argument. This ensures that the stochastic noise is diagonal, making the simulation faster.

# Returns

- `prob::EnsembleProblem with SDEProblem`: The Ensemble SDEProblem for the Stochastic Shrödinger time evolution.
"""
function ssesolveEnsembleProblem(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        sc_ops::Union{Nothing, AbstractVector, Tuple, AbstractQuantumObject} = nothing;
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        progress_bar::Union{Val, Bool} = Val(true),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    )
    _prob_func =
        isnothing(prob_func) ?
        _ensemble_dispatch_prob_func(
            rng,
            ntraj,
            tlist,
            _stochastic_prob_func;
            sc_ops = sc_ops,
            store_measurement = makeVal(store_measurement),
        ) : prob_func
    _output_func =
        output_func isa Nothing ?
        _ensemble_dispatch_output_func(
            ensemblealg,
            progress_bar,
            ntraj,
            _standard_output_func;
            progr_desc = "[ssesolve] ",
        ) : output_func

    prob_sme = ssesolveProblem(
        H,
        ψ0,
        tlist,
        sc_ops;
        e_ops = e_ops,
        params = params,
        rng = rng,
        progress_bar = Val(false),
        store_measurement = makeVal(store_measurement),
        kwargs...,
    )

    ensemble_prob = TimeEvolutionProblem(
        EnsembleProblem(prob_sme, prob_func = _prob_func, output_func = _output_func[1], safetycopy = true),
        prob_sme.times,
        prob_sme.states_type,
        prob_sme.dimensions,
        (progr = _output_func[2], channel = _output_func[3]),
    )

    return ensemble_prob
end

@doc raw"""
    ssesolve(
        H::Union{AbstractQuantumObject{Operator},Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        sc_ops::Union{Nothing,AbstractVector,Tuple,AbstractQuantumObject} = nothing;
        alg::Union{Nothing,AbstractSDEAlgorithm} = nothing,
        e_ops::Union{Nothing,AbstractVector,Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple,Nothing} = nothing,
        progress_bar::Union{Val,Bool} = Val(true),
        keep_runs_results::Union{Val,Bool} = Val(false),
        store_measurement::Union{Val,Bool} = Val(false),
        kwargs...,
    )


Stochastic Schrödinger equation evolution of a quantum system given the system Hamiltonian ``\hat{H}`` and a list of stochastic collapse (jump) operators ``\{\hat{S}_n\}_n``.
The stochastic evolution of the state ``|\psi(t)\rangle`` is defined by:
    
```math
d|\psi(t)\rangle = -i \hat{K} |\psi(t)\rangle dt + \sum_n \hat{M}_n |\psi(t)\rangle dW_n(t)
```

where 
    
```math
\hat{K} = \hat{H} + i \sum_n \left(\frac{e_n}{2} \hat{S}_n - \frac{1}{2} \hat{S}_n^\dagger \hat{S}_n - \frac{e_n^2}{8}\right),
```
```math
\hat{M}_n = \hat{S}_n - \frac{e_n}{2},
```
and
```math
e_n = \langle \hat{S}_n + \hat{S}_n^\dagger \rangle.
```

Above, ``\hat{S}_n`` are the stochastic collapse operators and ``dW_n(t)`` is the real Wiener increment associated to ``\hat{S}_n``. See [Wiseman2009Quantum](@cite) for more details.


# Arguments

- `H`: Hamiltonian of the system ``\hat{H}``. It can be either a [`QuantumObject`](@ref), a [`QuantumObjectEvolution`](@ref), or a `Tuple` of operator-function pairs.
- `ψ0`: Initial state of the system ``|\psi(0)\rangle``.
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `sc_ops`: List of stochastic collapse operators ``\{\hat{S}_n\}_n``. It can be either a `Vector`, a `Tuple` or a [`AbstractQuantumObject`](@ref). It is recommended to use the last case when only one operator is provided.
- `alg`: The algorithm to use for the stochastic differential equation. Default is `SRIW1()` if `sc_ops` is an [`AbstractQuantumObject`](@ref) (diagonal noise), and `SRA2()` otherwise (non-diagonal noise).
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `params`: `NullParameters` of parameters to pass to the solver.
- `rng`: Random number generator for reproducibility.
- `ntraj`: Number of trajectories to use. Default is `500`.
- `ensemblealg`: Ensemble method to use. Default to `EnsembleThreads()`.
- `prob_func`: Function to use for generating the SDEProblem.
- `output_func`: a `Tuple` containing the `Function` to use for generating the output of a single trajectory, the (optional) `Progress` object, and the (optional) `RemoteChannel` object.
- `progress_bar`: Whether to show the progress bar. Using non-`Val` types might lead to type instabilities.
- `keep_runs_results`: Whether to save the results of each trajectory. Default to `Val(false)`.
- `store_measurement`: Whether to store the measurement results. Default is `Val(false)`.
- `kwargs`: The keyword arguments for the ODEProblem.

# Notes

- The states will be saved depend on the keyword argument `saveat` in `kwargs`.
- If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). You can also specify `e_ops` and `saveat` separately.
- The default tolerances in `kwargs` are given as `reltol=1e-2` and `abstol=1e-2`.
- For more details about `alg` please refer to [`DifferentialEquations.jl` (SDE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)
- For more details about `kwargs` please refer to [`DifferentialEquations.jl` (Keyword Arguments)](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)

!!! tip "Performance Tip"
    When `sc_ops` contains only a single operator, it is recommended to pass only that operator as the argument. This ensures that the stochastic noise is diagonal, making the simulation faster.

# Returns

- `sol::TimeEvolutionStochasticSol`: The solution of the time evolution. See [`TimeEvolutionStochasticSol`](@ref).
"""
function ssesolve(
        H::Union{AbstractQuantumObject{Operator}, Tuple},
        ψ0::QuantumObject{Ket},
        tlist::AbstractVector,
        sc_ops::Union{Nothing, AbstractVector, Tuple, AbstractQuantumObject} = nothing;
        alg::Union{Nothing, AbstractSDEAlgorithm} = nothing,
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        params = NullParameters(),
        rng::AbstractRNG = default_rng(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        prob_func::Union{Function, Nothing} = nothing,
        output_func::Union{Tuple, Nothing} = nothing,
        progress_bar::Union{Val, Bool} = Val(true),
        keep_runs_results::Union{Val, Bool} = Val(false),
        store_measurement::Union{Val, Bool} = Val(false),
        kwargs...,
    )
    ens_prob = ssesolveEnsembleProblem(
        H,
        ψ0,
        tlist,
        sc_ops;
        e_ops = e_ops,
        params = params,
        rng = rng,
        ntraj = ntraj,
        ensemblealg = ensemblealg,
        prob_func = prob_func,
        output_func = output_func,
        progress_bar = progress_bar,
        store_measurement = makeVal(store_measurement),
        kwargs...,
    )

    sc_ops_isa_Qobj = sc_ops isa AbstractQuantumObject # We can avoid using non-diagonal noise if sc_ops is just an AbstractQuantumObject

    if isnothing(alg)
        alg = sc_ops_isa_Qobj ? SRIW1() : SRA2()
    end

    return ssesolve(ens_prob, alg, ntraj, ensemblealg, makeVal(keep_runs_results))
end

function ssesolve(
        ens_prob::TimeEvolutionProblem,
        alg::AbstractSDEAlgorithm = SRA2(),
        ntraj::Int = 500,
        ensemblealg::EnsembleAlgorithm = EnsembleThreads(),
        keep_runs_results = Val(false),
    )
    sol = _ensemble_dispatch_solve(ens_prob, alg, ensemblealg, ntraj)

    _sol_1 = sol[:, 1]
    _expvals_sol_1 = _get_expvals(_sol_1, SaveFuncSSESolve)
    _m_expvals_sol_1 = _get_m_expvals(_sol_1, SaveFuncSSESolve)

    normalize_states = Val(false)
    dimensions = ens_prob.dimensions
    _expvals_all =
        _expvals_sol_1 isa Nothing ? nothing : map(i -> _get_expvals(sol[:, i], SaveFuncSSESolve), eachindex(sol))
    expvals_all = _expvals_all isa Nothing ? nothing : stack(_expvals_all, dims = 2) # Stack on dimension 2 to align with QuTiP

    # stack to transform Vector{Vector{QuantumObject}} -> Matrix{QuantumObject}
    states_all = stack(map(i -> _normalize_state!.(sol[:, i].u, Ref(dimensions), normalize_states), eachindex(sol)), dims = 1)

    _m_expvals =
        _m_expvals_sol_1 isa Nothing ? nothing : map(i -> _get_m_expvals(sol[:, i], SaveFuncSSESolve), eachindex(sol))
    m_expvals = _m_expvals isa Nothing ? nothing : stack(_m_expvals, dims = 2)

    kwargs = NamedTuple(_sol_1.prob.kwargs) # Convert to NamedTuple for Zygote.jl compatibility

    return TimeEvolutionStochasticSol(
        ntraj,
        ens_prob.times,
        _sol_1.t,
        _store_multitraj_states(states_all, keep_runs_results),
        _store_multitraj_expect(expvals_all, keep_runs_results),
        m_expvals, # Measurement expectation values
        sol.converged,
        _sol_1.alg,
        kwargs.abstol,
        kwargs.reltol,
    )
end

function _calculate_fft_spectrum(H, tlist, c_ops, A, B)
    corr = correlation_2op_1t(H, nothing, tlist, c_ops, A, B; progress_bar = Val(false))
    ωlist, spec = spectrum_correlation_fft(tlist, corr)
    return nothing
end

function benchmark_correlations_and_spectrum!(SUITE)
    N = 15
    ω = 1
    γ = 0.1
    nth = 0.02

    a = destroy(N)
    H = ω * a' * a
    c_ops = [sqrt(γ * (nth + 1)) * a, sqrt(γ * nth) * a']

    ω_l = range(0, 3, length = 1000)
    t_l = range(0, 333 * π, length = 1000)

    PI_solver = PseudoInverse()

    L_solver = Lanczos()

    SUITE["Correlations and Spectrum"]["FFT Correlation"] =
        @benchmarkable _calculate_fft_spectrum($H, $t_l, $c_ops, $(a'), $a)

    SUITE["Correlations and Spectrum"]["Spectrum"]["Exponential Series"] =
        @benchmarkable spectrum($H, $ω_l, $c_ops, $(a'), $a)

    SUITE["Correlations and Spectrum"]["Spectrum"]["Pseudo Inverse"] =
        @benchmarkable spectrum($H, $ω_l, $c_ops, $(a'), $a, solver = $PI_solver)

    SUITE["Correlations and Spectrum"]["Spectrum"]["Lanczos"] =
        @benchmarkable spectrum($H, $ω_l, $c_ops, $(a'), $a, solver = $L_solver)

    return nothing
end

export ArnoldiSpace, arnoldi, arnoldi!, arnoldi_init!, arnoldi_step!
export expv!, expv

struct ArnoldiSpace{VT <: AbstractMatrix{<:Number}, HT <: AbstractMatrix{<:Number}, mT <: Integer}
    V::VT
    H::HT
    Hcopy::HT
    m::mT
end

function Base.copy(AS::ArnoldiSpace{<:AbstractMatrix{T1}, <:AbstractMatrix{T1}}) where {T1 <: Number}
    return ArnoldiSpace(copy(AS.V), copy(AS.H), copy(AS.Hcopy), AS.m)
end

function Base.deepcopy(AS::ArnoldiSpace{<:AbstractMatrix{T1}, <:AbstractMatrix{T1}}) where {T1 <: Number}
    return ArnoldiSpace(deepcopy(AS.V), deepcopy(AS.H), deepcopy(AS.Hcopy), AS.m)
end

function arnoldi_init!(A, b::AbstractVector{T}, V::AbstractMatrix{T}, H::AbstractMatrix{T}) where {T <: Number}
    v₁ = view(V, :, 1)
    v₂ = view(V, :, 2)
    v₁ .= b
    normalize!(v₁)

    mul!(v₂, A, v₁)
    H[1, 1] = dot(v₁, v₂)
    axpy!(-H[1, 1], v₁, v₂)
    H[2, 1] = norm(v₂)
    return v₂ ./= H[2, 1]
end

function arnoldi_step!(A, V::AbstractMatrix{T}, H::AbstractMatrix{T}, i::TI) where {T <: Number, TI <: Integer}
    vᵢ = view(V, :, i)
    vᵢ₊₁ = view(V, :, i + 1)
    mul!(vᵢ₊₁, A, vᵢ)
    for j in 1:i
        vⱼ = view(V, :, j)
        H[j, i] = dot(vⱼ, vᵢ₊₁)
        axpy!(-H[j, i], vⱼ, vᵢ₊₁)
    end
    β = H[i + 1, i] = norm(vᵢ₊₁)
    vᵢ₊₁ ./= H[i + 1, i]
    return β
end

function arnoldi!(
        AS::ArnoldiSpace{<:AbstractMatrix{T1}, <:AbstractMatrix{T1}},
        A,
        b::AbstractVector{T2},
    ) where {T1 <: Number, T2 <: Number}
    n = size(A, 2)
    V = AS.V
    H = AS.H
    m = AS.m

    n == size(V, 1) || throw(DimensionMismatch())
    n == length(b) || throw(DimensionMismatch())

    arnoldi_init!(A, b, V, H)
    for i in 2:m
        arnoldi_step!(A, V, H, i)
    end
    return AS
end

function arnoldi(A, b::AbstractVector{T}, m::Integer) where {T <: Number}
    n = size(A, 2)
    V = similar(b, n, m + 1)
    H = zeros(T, m + 1, m)
    AS = ArnoldiSpace(V, H, copy(H), m)
    return arnoldi!(AS, A, b)
end

### EXPV TOOLS ###

function expv!(
        x::AbstractVector{T1},
        AS::ArnoldiSpace{<:AbstractMatrix{T1}, <:AbstractMatrix{T1}},
        t::T2,
        b::AbstractVector{T1},
    ) where {T1 <: Number, T2 <: Union{Number, Integer}}
    H = AS.H
    Hcopy = AS.Hcopy
    V = AS.V
    m = AS.m

    Hm = view(H, 1:m, 1:m)
    Vm = view(V, :, 1:m)
    lmul!(t, Hm)

    Hcopym = view(Hcopy, 1:m, 1:m)
    copyto!(Hcopym, Hm)
    expH = LinearAlgebra.exp!(Hcopym)
    # expH = exp(Hm)

    β = norm(b)
    expHe = expH[:, 1] # the view doesn't work when using copyto! with CUDA
    cache = similar(x, m)
    copyto!(cache, expHe) # just in case expHe is different from cache (e.g., with CUDA)
    mul!(x, Vm, cache)
    lmul!(β, x)

    return x
end

function expv!(
        x::AbstractVector{T1},
        A,
        t::T2,
        b::AbstractVector{T1};
        m::Int = min(30, cld(2 * length(b), 3)),
    ) where {T1 <: Number, T2 <: Union{Number, Integer}}
    AS = arnoldi(A, b, m)
    return expv!(x, AS, t, b)
end

function expv(A, t::T1, b::AbstractVector{T2}; m::Int = min(30, cld(2 * length(b), 3))) where {T1 <: Number, T2 <: Number}
    x = similar(b)
    return expv!(x, A, t, b, m = m)
end

@testitem "Dressed Nonsecular Master Equation" begin
    using LinearAlgebra
    using SparseArrays

    function dressed_liouvillian(H, fields; tol = 1.0e-12)
        vals, vecs = eigenstates(H)
        N_tot = size(H, 1)

        H_d = QuantumObject(spdiagm(0 => complex.(vals)), type = Operator())

        L = liouvillian(H_d)

        iter = Iterators.product(1:N_tot, 1:N_tot)
        iter_filtered = Iterators.filter(x -> x[2] > x[1], iter)
        foreach(iter_filtered) do idx
            i, j = idx
            Γ_ij = sum(eachindex(fields)) do k
                (vals[j] - vals[i]) * abs2(matrix_element(vecs[i], fields[k], vecs[j]))
            end
            if Γ_ij > tol
                L += Γ_ij * lindblad_dissipator(projection(N_tot, i - 1, j - 1))
            end
        end

        return L
    end

    N_c = 30
    N_trunc = 10
    tol = 1.0e-6

    a = kron(destroy(N_c), qeye(2))
    sm = kron(qeye(N_c), sigmam())
    sp = sm'
    sx = sm + sp
    sz = sp * sm - sm * sp

    H = 1 * a' * a + 1 * sz / 2 + 0.5 * (a + a') * sx

    fields = [sqrt(0.01) * (a + a'), sqrt(0.01) * sx]
    Tlist = [0, 0.0]

    E, U, L1 = liouvillian_dressed_nonsecular(H, fields, Tlist, N_trunc = N_trunc, tol = tol)
    Ω = to_sparse((E' .- E)[1:N_trunc, 1:N_trunc], tol)

    H_d = U' * H * U
    Xp = QuantumObject(Ω .* triu(U' * (a + a') * U, 1).data, type = Operator())
    a2 = U' * a * U
    sm2 = U' * sm * U

    # Standard liouvillian case
    c_ops = [sqrt(0.01) * a2, sqrt(0.01) * sm2]
    L2 = liouvillian(H_d, c_ops)

    @test (expect(Hermitian(Xp' * Xp), steadystate(L1)) < 1.0e-10 && expect(Hermitian(Xp' * Xp), steadystate(L2)) > 1.0e-3)

    # Test that in the limit of σ_filter → 0, we recover the dressed master equation as in https://doi.org/10.1103/PhysRevA.84.043832
    L_gme_0 = liouvillian_dressed_nonsecular(H, fields, Tlist, tol = tol, σ_filter = 1.0e-14)[3]
    L_dr = dressed_liouvillian(H, fields, tol = tol)
    @test norm(L_gme_0.data - L_dr.data) / size(L_gme_0.data, 1) < 1.0e-8

    H = 1 * a' * a + 1 * sz / 2 + 1.0e-5 * (a * sp + a' * sm)

    Tlist = [0.2, 0.0]

    E, U, L1 = liouvillian_dressed_nonsecular(H, fields, Tlist, N_trunc = N_trunc, tol = tol)
    Ω = to_sparse((E' .- E)[1:N_trunc, 1:N_trunc], tol)

    H_d = U' * H * U
    Xp = QuantumObject(Ω .* triu(U' * (a + a') * U, 1).data, type = Operator())
    a2 = U' * a * U
    sm2 = U' * sm * U

    @test abs(expect(Xp' * Xp, steadystate(L1)) - n_thermal(1, Tlist[1])) / n_thermal(1, Tlist[1]) < 1.0e-4

    if VERSION >= v"1.11" # eigen is type unstable on v1.10
        @testset "Type Inference (liouvillian_dressed_nonsecular)" begin
            N_c = 30
            N_trunc = 10
            tol = 1.0e-14

            a = kron(destroy(N_c), qeye(2))
            sm = kron(qeye(N_c), sigmam())
            sp = sm'
            sx = sm + sp
            sz = sp * sm - sm * sp

            H = 1 * a' * a + 1 * sz / 2 + 0.5 * (a + a') * sx

            fields = [sqrt(0.01) * (a + a'), sqrt(0.01) * sx]
            Tlist = [0, 0.01]

            @inferred liouvillian_dressed_nonsecular(H, fields, Tlist, N_trunc = N_trunc, tol = tol)
        end
    end
end

@testitem "Steady State" begin
    N = 10
    a = destroy(N)
    a_d = a'
    H = a_d * a + 0.1 * (a + a_d)
    Ht = QobjEvo(H, (p, t) -> 1) # for test throw
    c_ops = [sqrt(0.1) * a]
    e_ops = [a_d * a]
    psi0 = fock(N, 3)
    t_l = LinRange(0, 200, 1000)
    sol_me = mesolve(H, psi0, t_l, c_ops, e_ops = e_ops, progress_bar = Val(false))
    rho_me = sol_me.states[end]

    solver = SteadyStateODESolver()
    ρ_ss = steadystate(H, c_ops, solver = solver)
    @test tracedist(rho_me, ρ_ss) < 1.0e-4

    solver = SteadyStateDirectSolver()
    ρ_ss = steadystate(H, c_ops, solver = solver)
    @test tracedist(rho_me, ρ_ss) < 1.0e-4
    @test_throws ArgumentError steadystate(Ht, c_ops, solver = solver)

    solver = SteadyStateLinearSolver()
    ρ_ss = steadystate(H, c_ops, solver = solver)
    @test tracedist(rho_me, ρ_ss) < 1.0e-4
    @test_throws ArgumentError steadystate(Ht, c_ops, solver = solver)

    solver = SteadyStateEigenSolver()
    ρ_ss = steadystate(H, c_ops, solver = solver)
    @test tracedist(rho_me, ρ_ss) < 1.0e-4
    @test_throws ArgumentError steadystate(Ht, c_ops, solver = solver)

    @testset "Type Inference (steadystate)" begin
        L = liouvillian(H, c_ops)

        solver = SteadyStateODESolver(tmax = t_l[end])
        @inferred steadystate(H, c_ops, solver = solver)
        @inferred steadystate(L, solver = solver)

        solver = SteadyStateDirectSolver()
        @inferred steadystate(H, c_ops, solver = solver)
        @inferred steadystate(L, solver = solver)

        solver = SteadyStateLinearSolver()
        @inferred steadystate(H, c_ops, solver = solver)
        @inferred steadystate(L, solver = solver)

        solver = SteadyStateEigenSolver()
        @inferred steadystate(H, c_ops, solver = solver)
        @inferred steadystate(L, solver = solver)

        @inferred steadystate(H, c_ops)
        @inferred steadystate(L)
    end

    H = a_d * a
    H_t = 0.1 * (a + a_d)
    c_ops = [sqrt(0.1) * a]
    e_ops = [a_d * a]
    psi0 = fock(N, 3)
    t_l = LinRange(0, 100 * 2π, 1000)

    coeff(p, t) = sin(t)
    H_td = (H, (H_t, coeff))

    sol_me = mesolve(H_td, psi0, t_l, c_ops, e_ops = e_ops, progress_bar = Val(false))
    ρ_ss1 = steadystate_fourier(H, -1im * 0.5 * H_t, 1im * 0.5 * H_t, 1, c_ops, solver = SteadyStateLinearSolver())[1]
    ρ_ss2 =
        steadystate_fourier(H, -1im * 0.5 * H_t, 1im * 0.5 * H_t, 1, c_ops, solver = SSFloquetEffectiveLiouvillian())

    @test abs(sum(sol_me.expect[1, (end - 100):end]) / 101 - expect(e_ops[1], ρ_ss1)) < 1.0e-3
    @test abs(sum(sol_me.expect[1, (end - 100):end]) / 101 - expect(e_ops[1], ρ_ss2)) < 1.0e-3

    @testset "Type Inference (steadystate_fourier)" begin
        @inferred steadystate_fourier(
            H,
            -1im * 0.5 * H_t,
            1im * 0.5 * H_t,
            1,
            c_ops,
            solver = SteadyStateLinearSolver(),
        )
        @inferred steadystate_fourier(
            H,
            -1im * 0.5 * H_t,
            1im * 0.5 * H_t,
            1,
            c_ops,
            solver = SSFloquetEffectiveLiouvillian(),
        )
    end
end

#=
Helper functions for the ssesolve callbacks. Almost equal to the sesolve case, but with an additional possibility to store the measurement operators expectation values. Also, this callback is not the first one, but the second one, due to the presence of the normalization callback.
=#

struct SaveFuncSSESolve{
        SM,
        TE,
        TE2,
        PT <: Union{Nothing, Progress},
        IT,
        TEXPV <: Union{Nothing, AbstractMatrix},
        TMEXPV <: Union{Nothing, AbstractMatrix},
        TLT <: AbstractVector,
        CT <: AbstractVector,
    } <: AbstractSaveFunc
    store_measurement::Val{SM}
    e_ops::TE
    m_ops::TE2
    progr::PT
    iter::IT
    expvals::TEXPV
    m_expvals::TMEXPV
    tlist::TLT
    dWdt_cache::CT
end

(f::SaveFuncSSESolve)(u, t, integrator) =
    _save_func_ssesolve(u, integrator, f.e_ops, f.m_ops, f.progr, f.iter, f.expvals, f.m_expvals, f.tlist, f.dWdt_cache)
(f::SaveFuncSSESolve{false, Nothing})(u, t, integrator) = _save_func(integrator, f.progr) # Common for both all solvers

_get_e_ops_data(e_ops, ::Type{SaveFuncSSESolve}) = get_data.(e_ops)
_get_m_ops_data(sc_ops, ::Type{SaveFuncSSESolve}) = map(op -> Hermitian(get_data(op) + get_data(op)'), sc_ops)

_get_save_callback_idx(cb, ::Type{SaveFuncSSESolve}) = 2 # The first one is the normalization callback

##

# When e_ops is a list of operators
function _save_func_ssesolve(u, integrator, e_ops, m_ops, progr, iter, expvals, m_expvals, tlist, dWdt_cache)
    ψ = u

    _expect = op -> dot(ψ, op, ψ)

    if !isnothing(e_ops)
        @. expvals[:, iter[]] = _expect(e_ops)
    end

    if !isnothing(m_expvals) && iter[] > 1
        _homodyne_dWdt!(dWdt_cache, integrator, tlist, iter)
        @. m_expvals[:, iter[] - 1] = real(_expect(m_ops)) + dWdt_cache
    end

    iter[] += 1

    return _save_func(integrator, progr)
end

##

#=
    This function generates the normalization callback. It is needed to stabilize the integration when using the ssesolve method.
=#
function _ssesolve_generate_normalize_cb()
    _condition = (u, t, integrator) -> true
    _affect! = (integrator) -> normalize!(integrator.u)
    cb = DiscreteCallback(_condition, _affect!; save_positions = (false, false))

    return cb
end

Base.@kwdef mutable struct Settings
    tidyup_tol::Float64 = 1.0e-14
    auto_tidyup::Bool = true
    ProgressMeterKWARGS::NamedTuple = (showspeed = true, printed = true)
end

function Base.show(io::IO, s::Settings)
    # get maximum field name to align the output and make it easier to read
    maxLen = maximum(length ∘ String, fieldnames(Settings))

    println(io, "QuantumToolbox.jl Settings")
    println(io, "--------------------------")
    map(n -> println(io, rpad("$n", maxLen, " "), " = ", getfield(s, n)), fieldnames(Settings))
    return nothing
end

@doc raw"""
    QuantumToolbox.settings

Contains all the default global settings of QuantumToolbox.jl.

# List of settings

- `tidyup_tol::Float64 = 1.0e-14` : tolerance for [`tidyup`](@ref), [`tidyup!`](@ref) and [`to_sparse`](@ref).
- `auto_tidyup::Bool = true` : Automatically tidyup.
- `ProgressMeterKWARGS::NamedTuple = (showspeed = true, printed = true)` : Default keyword arguments for progress bar in [`ProgressMeter.jl`](https://github.com/timholy/ProgressMeter.jl). This allows the customization of progress bar.

For detailed explanation of each settings, see our documentation [here](https://qutip.org/QuantumToolbox.jl/stable/users_guide/settings).

# Change default settings

One can overwrite the default global settings by

```julia
using QuantumToolbox

QuantumToolbox.settings.tidyup_tol = 1e-10
QuantumToolbox.settings.auto_tidyup = false
```
"""
const settings = Settings()

setprecision(128) # Instead of 256. This speeds up the tests.

using QuantumToolbox
using LinearAlgebra
using SparseArrays
using Sparspak
using GenericSchur

QuantumToolbox.about()

@testset "Arbitrary Precision" verbose = true begin
    N = 20
    Δ = 1.0
    U = 0.1
    F = 0.1
    κ = 0.1

    a = destroy(N)
    ψ0 = fock(N, 1)
    H = Δ * a' * a + U / 2 * a' * a' * a * a + F * (a + a')

    c_ops = [sqrt(κ) * a]

    tlist = range(0, 40, 100)

    a_big = destroy(Complex{BigFloat}, N)
    ψ0_big = fock(Complex{BigFloat}, N, 1)
    H_big = Δ * a_big' * a_big + U / 2 * a_big' * a_big' * a_big * a_big + F * (a_big + a_big')

    c_ops_big = [sqrt(BigFloat(κ)) * a_big]

    @testset "Arbitrary Precision (sesolve)" begin
        sol = sesolve(H, ψ0, tlist; progress_bar = Val(false))
        sol_big = sesolve(H_big, ψ0_big, tlist; progress_bar = Val(false))

        @test eltype(sol_big.states[1]) == Complex{BigFloat}

        # Test all fidelities are close to 1
        @test all((x) -> isapprox(fidelity(x[1], x[2]), 1; atol = 1.0e-7), zip(sol.states, sol_big.states))

        @inferred sesolve(H_big, ψ0_big, tlist; progress_bar = Val(false))
    end

    @testset "Arbitrary Precision (mesolve)" begin
        sol = mesolve(H, ψ0, tlist, c_ops; progress_bar = Val(false))
        sol_big = mesolve(H_big, ψ0_big, tlist, c_ops_big; progress_bar = Val(false))

        @test eltype(sol_big.states[1]) == Complex{BigFloat}

        # Test all fidelities are close to 1
        @test all((x) -> isapprox(hilbert_dist(x[1], x[2]), 0; atol = 1.0e-10), zip(sol.states, sol_big.states))

        @inferred mesolve(H_big, ψ0_big, tlist, c_ops_big; progress_bar = Val(false))
    end

    @testset "Arbitrary Precision (eigenvalues)" begin
        L = liouvillian(H, c_ops)
        L_big = liouvillian(H_big, c_ops_big)

        vals, vecs = eigenstates(L; sparse = Val(true), sigma = 0.01, eigvals = 7, krylovdim = 30)
        vals_big, vecs_big = eigenstates(L_big; sparse = Val(true), sigma = 0.01, eigvals = 7, krylovdim = 30)

        vals_al, vecs_al = eigsolve_al(L, 1 \ (50 * κ), eigvals = 7, krylovdim = 30)
        vals_big_al, vecs_big_al = eigsolve_al(
            L_big,
            1 \ (50 * BigFloat(κ)),
            eigvals = 7,
            krylovdim = 30,
            maxiter = 3,
        )

        # Align eigenvalues
        idxs = [findmin(abs.(vals_big .- val))[2] for val in vals]
        idxs_al = [findmin(abs.(vals_big_al .- val))[2] for val in vals_al]

        @test eltype(vals_big) == Complex{BigFloat}

        @test vals ≈ vals_big[idxs] atol = 1.0e-7
        @test all(zip(vecs, vecs_big[idxs])) do (v, v_big)
            return isapprox(abs(dot(v.data, v_big.data)), 1; atol = 1.0e-7)
        end

        @test vals_al[1:(end - 1)] ≈ vals_big_al[idxs_al][1:(end - 1)] atol = 1.0e-6
        @test all(zip(vecs_al[1:(end - 1)], vecs_big_al[idxs_al][1:(end - 1)])) do (v, v_big)
            return isapprox(abs(dot(v.data, v_big.data)), 1; atol = 1.0e-6)
        end
    end
end

#=
Helper functions for the sesolve callbacks.
=#

struct SaveFuncSESolve{TE, PT <: Union{Nothing, Progress}, IT, TEXPV <: Union{Nothing, AbstractMatrix}} <: AbstractSaveFunc
    e_ops::TE
    progr::PT
    iter::IT
    expvals::TEXPV
end

(f::SaveFuncSESolve)(u, t, integrator) = _save_func_sesolve(u, integrator, f.e_ops, f.progr, f.iter, f.expvals)
(f::SaveFuncSESolve{Nothing})(u, t, integrator) = _save_func(integrator, f.progr) # Common for both mesolve and sesolve

_get_e_ops_data(e_ops, ::Type{SaveFuncSESolve}) = get_data.(e_ops)

_get_progress_desc(::Type{SaveFuncSESolve}) = "[sesolve] "

##

# When e_ops is a list of operators
function _save_func_sesolve(u, integrator, e_ops, progr, iter, expvals)
    ψ = u
    _expect = op -> dot(ψ, op, ψ)
    @. expvals[:, iter[]] = _expect(e_ops)
    iter[] += 1

    return _save_func(integrator, progr)
end

export matrix_heatmap, matrix_histogram

@doc raw"""
    matrix_heatmap(
        M::Union{QuantumObject,AbstractMatrix};
        library::Union{Val, Symbol} = Val(:Makie),
        method::Union{Symbol,Val} = Val(:real),
        kwargs...
    )

Plot a heatmap for the elements of matrix `M`.

The `library` keyword argument specifies the plotting library to use, defaulting to [`Makie`](https://github.com/MakieOrg/Makie.jl). 

# Arguments
- `M::Union{QuantumObject,AbstractMatrix}`: The [`QuantumObject`](@ref) or `AbstractMatrix` for which to be plotted. If it is a [`QuantumObject`](@ref), tt can be either a [`Operator`](@ref) or [`SuperOperator`](@ref).
- `library::Union{Val,Symbol}`: The plotting library to use. Default is `Val(:Makie)`.
- `method::Union{Symbol,Val}`: Method to use for plotting the matrix elements. Can be either `:real`, `:imag`, `:abs`, or `:angle`. Default is `Val(:real)`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function. See the documentation for the specific plotting library for more information.

!!! note "Import library first"
    The plotting libraries must first be imported before using them with this function.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `Val(:Makie)` instead of `:Makie` as the plotting library. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
matrix_heatmap(
    M::Union{QuantumObject{QT}, AbstractMatrix{MT}};
    library::Union{Val, Symbol} = Val(:Makie),
    method::Union{Symbol, Val} = Val(:real),
    kwargs...,
) where {QT <: Union{Operator, SuperOperator}, MT <: Number} =
    matrix_heatmap(makeVal(library), M; method = makeVal(method), kwargs...)

matrix_heatmap(::Val{T}, M; kwargs...) where {T} =
    throw(ArgumentError("The specified plotting library $T is not available. Try running `using $T` first."))

@doc raw"""
    matrix_histogram(
        M::Union{QuantumObject,AbstractMatrix};
        library::Union{Val, Symbol} = Val(:Makie),
        method::Union{Symbol,Val} = Val(:real),
        kwargs...
    )

Plot a 3D histogram for the elements of matrix `M`.

The `library` keyword argument specifies the plotting library to use, defaulting to [`Makie`](https://github.com/MakieOrg/Makie.jl). 

# Arguments
- `M::Union{QuantumObject,AbstractMatrix}`: The [`QuantumObject`](@ref) or `AbstractMatrix` for which to be plotted. If it is a [`QuantumObject`](@ref), tt can be either a [`Operator`](@ref) or [`SuperOperator`](@ref).
- `library::Union{Val,Symbol}`: The plotting library to use. Default is `Val(:Makie)`.
- `method::Union{Symbol,Val}`: Method to use for plotting the matrix elements. Can be either `:real`, `:imag`, `:abs`, or `:angle`. Default is `Val(:real)`.
- `kwargs...`: Additional keyword arguments to pass to the plotting function. See the documentation for the specific plotting library for more information.

!!! note "Import library first"
    The plotting libraries must first be imported before using them with this function.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `Val(:Makie)` instead of `:Makie` as the plotting library. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.
"""
matrix_histogram(
    M::Union{QuantumObject{QT}, AbstractMatrix{MT}};
    library::Union{Val, Symbol} = Val(:Makie),
    method::Union{Symbol, Val} = Val(:real),
    kwargs...,
) where {QT <: Union{Operator, SuperOperator}, MT <: Number} =
    matrix_histogram(makeVal(library), M; method = makeVal(method), kwargs...)

matrix_histogram(::Val{T}, M; kwargs...) where {T} =
    throw(ArgumentError("The specified plotting library $T is not available. Try running `using $T` first."))

#################################################################
# the following functions will be used in all plotting backends
_handle_matrix_plot_data(M::QuantumObject{T}, method::Val) where {T <: Union{Operator, SuperOperator}} =
    _handle_matrix_plot_data(M.data, method)
_handle_matrix_plot_data(M::AbstractMatrix{T}, ::Val{:real}) where {T <: Number} = real(transpose(M))
_handle_matrix_plot_data(M::AbstractMatrix{T}, ::Val{:imag}) where {T <: Number} = imag(transpose(M))
_handle_matrix_plot_data(M::AbstractMatrix{T}, ::Val{:abs}) where {T <: Number} = abs.(transpose(M))
_handle_matrix_plot_data(M::AbstractMatrix{T}, ::Val{:angle}) where {T <: Number} = angle.(transpose(M))
_handle_matrix_plot_data(::AbstractMatrix{T}, method::Val) where {T <: Number} =
    throw(ArgumentError("Invalid keyword argument method = $(method), should be either: :real, :imag, :abs, or :angle"))

# for y-axis ticks
_gen_default_ket_labels(::QuantumObject{SuperOperator}, ydata) = map(y -> L"|%$(y)\rangle\!\rangle", ydata)
_gen_default_ket_labels(::Union{QuantumObject{Operator}, AbstractMatrix{T}}, ydata) where {T <: Number} =
    map(y -> L"|%$(y)\rangle", ydata)

# for x-axis ticks
_gen_default_bra_labels(::QuantumObject{SuperOperator}, xdata) = map(x -> L"\langle\!\langle%$(x)|", xdata)
_gen_default_bra_labels(::Union{QuantumObject{Operator}, AbstractMatrix{T}}, xdata) where {T <: Number} =
    map(x -> L"\langle%$(x)|", xdata)

@testitem "Low Rank Dynamics" begin
    using LinearAlgebra

    # Define lattice
    Nx, Ny = 2, 3
    latt = Lattice(Nx = Nx, Ny = Ny)
    ##
    N_cut = 2         # Number of states of each mode
    N_modes = latt.N  # Number of modes
    N = N_cut^N_modes # Total number of states
    M = latt.N + 1       # Number of states in the LR basis

    # Define initial state
    ϕ = Vector{QuantumObject{Ket, Dimensions{TensorSpace{M - 1, NTuple{M - 1, Space}}, Space}, Vector{ComplexF64}}}(undef, M)
    ϕ[1] = kron(fill(basis(2, 1), N_modes)...)

    i = 1
    for j in 1:N_modes
        global i += 1
        i <= M && (ϕ[i] = multisite_operator(latt, j => sigmap()) * ϕ[1])
    end
    for k in 1:(N_modes - 1)
        for l in (k + 1):N_modes
            global i += 1
            i <= M && (ϕ[i] = multisite_operator(latt, k => sigmap(), l => sigmap()) * ϕ[1])
        end
    end
    for i in (i + 1):M
        ϕ[i] = QuantumObject(rand(ComplexF64, size(ϕ[1])[1]), dims = ϕ[1].dims)
        normalize!(ϕ[i])
    end

    z = hcat(get_data.(ϕ)...)
    B = Matrix(Diagonal([1 + 0im; zeros(M - 1)]))
    S = z' * z # Overlap matrix
    B = B / tr(S * B) # Normalize B
    ρ = Qobj(z * B * z', dims = ntuple(i -> N_cut, Val(N_modes))) # Full density matrix

    # Define Hamiltonian and collapse operators
    Jx = 0.9
    Jy = 1.04
    Jz = 1.0
    hx = 0.0
    hy = 0.0
    hz = 0.0
    γ = 1

    Sx = mapreduce(i -> multisite_operator(latt, i => sigmax()), +, 1:latt.N)
    Sy = mapreduce(i -> multisite_operator(latt, i => sigmay()), +, 1:latt.N)
    Sz = mapreduce(i -> multisite_operator(latt, i => sigmaz()), +, 1:latt.N)
    SFxx = mapreduce(
        x -> multisite_operator(latt, x[1] => sigmax(), x[2] => sigmax()),
        +,
        Iterators.product(1:latt.N, 1:latt.N),
    )

    H, c_ops = DissipativeIsing(Jx, Jy, Jz, hx, hy, hz, γ, latt; boundary_condition = Val(:periodic_bc), order = 1)
    e_ops = (Sz,)

    tl = range(0, 10, 100)

    # Full solution
    sol_me = mesolve(H, ρ, tl, c_ops; e_ops = [e_ops...], progress_bar = Val(false))
    Strue = entropy_vn(sol_me.states[end], base = 2) / latt.N

    # Low rank solution
    function f_entropy(p, z, B)
        C = p.A0
        σ = p.Bi

        mul!(C, z, sqrt(B))
        mul!(σ, C', C)
        return entropy_vn(Qobj(Hermitian(σ), type = Operator()), base = 2)
    end

    opt = (err_max = 1.0e-3, p0 = 0.0, atol_inv = 1.0e-6, adj_condition = "variational", Δt = 0.0, progress = false)

    sol_lr = lr_mesolve(H, z, B, tl, c_ops; e_ops = e_ops, f_ops = (f_entropy,), opt = opt)

    # Test
    S_lr = real(sol_lr.fexpect[1, end]) / latt.N

    @test real(sol_me.expect[1, :]) ≈ real(sol_lr.expect[1, :]) atol = 1.0e-1
    @test S_lr ≈ Strue atol = 1.0e-1

    @test_logs (:warn,) MultiSiteOperator(latt, 1 => sigmax()) # deprecated warning
end

export bloch_redfield_tensor, brterm, brmesolve

@doc raw"""
    bloch_redfield_tensor(
        H::QuantumObject{Operator},
        a_ops::Union{AbstractVector, Tuple, Nothing},
        c_ops::Union{AbstractVector, Tuple, Nothing}=nothing;
        sec_cutoff::Real=0.1,
        fock_basis::Union{Val,Bool}=Val(false)
    )

Calculates the Bloch-Redfield tensor ([`SuperOperator`](@ref)) for a system given a set of operators and corresponding spectral functions that describes the system's coupling to its environment.

## Arguments

- `H`: The system Hamiltonian. Must be an [`Operator`](@ref)
- `a_ops`: Nested list with each element is a `Tuple` of operator-function pairs `(a_op, spectra)`, and the coupling [`Operator`](@ref) `a_op` must be hermitian with corresponding `spectra` being a `Function` of transition energy
- `c_ops`: List of collapse operators corresponding to Lindblad dissipators
- `sec_cutoff`: Cutoff for secular approximation. Use `-1` if secular approximation is not used when evaluating bath-coupling terms.
- `fock_basis`: Whether to return the tensor in the input (fock) basis or the diagonalized (eigen) basis.

## Return

The return depends on `fock_basis`.

- `fock_basis=Val(true)`: return the Bloch-Redfield tensor (in the fock basis) only.
- `fock_basis=Val(false)`: return the Bloch-Redfield tensor (in the eigen basis) along with the transformation matrix from eigen to fock basis.
"""
function bloch_redfield_tensor(
        H::QuantumObject{Operator},
        a_ops::Union{Nothing, AbstractVector, Tuple},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        sec_cutoff::Real = 0.1,
        fock_basis::Union{Val, Bool} = Val(false),
    )
    rst = eigenstates(H)
    U = QuantumObject(rst.vectors, Operator(), H.dimensions)
    sec_cutoff = float(sec_cutoff)

    H_new = getVal(fock_basis) ? H : QuantumObject(Diagonal(rst.values), Operator(), H.dimensions)
    c_ops_new = isnothing(c_ops) ? nothing : (getVal(fock_basis) ? c_ops : map(x -> to_sparse_if_needed(Val(issparse(x)), U' * x * U), c_ops))
    L0 = liouvillian(H_new, c_ops_new)

    # Check whether we can rotate the terms to the eigenbasis directly in the Hamiltonian space
    fock_basis_hamiltonian = getVal(fock_basis) && sec_cutoff == -1

    R =
        (isnothing(a_ops) || isempty(a_ops)) ? 0 :
        sum(x -> _brterm(rst, x[1], x[2], sec_cutoff, fock_basis_hamiltonian), a_ops)

    # If in fock basis, we need to transform the terms back to the fock basis
    # Note: we can transform the terms in the Hamiltonian space only if sec_cutoff is -1
    # otherwise, we need to use the SU superoperator below to transform the entire Liouvillian
    # at the end, due to the action of M_cut
    if getVal(fock_basis)
        if fock_basis_hamiltonian
            return L0 + R # Already rotated in the Hamiltonian space
        else
            U_sp = to_sparse(U)
            SU = sprepost(U_sp, U_sp')
            return L0 + SU * R * SU'
        end
    else
        return L0 + R, U
    end
end

@doc raw"""
    brterm(
        H::QuantumObject{Operator},
        a_op::QuantumObject{Operator}, 
        spectra::Function;
        sec_cutoff::Real=0.1, 
        fock_basis::Union{Bool, Val}=Val(false)
    )

Calculates the contribution of one coupling operator to the Bloch-Redfield tensor.

## Argument

- `H`: The system Hamiltonian. Must be an [`Operator`](@ref)
- `a_op`: The operator coupling to the environment. Must be hermitian.
- `spectra`: The corresponding environment spectra as a `Function` of transition energy.
- `sec_cutoff`: Cutoff for secular approximation. Use `-1` if secular approximation is not used when evaluating bath-coupling terms.
- `fock_basis`: Whether to return the tensor in the input (fock) basis or the diagonalized (eigen) basis.

## Return

The return depends on `fock_basis`.

- `fock_basis=Val(true)`: return the Bloch-Redfield term (in the fock basis) only.
- `fock_basis=Val(false)`: return the Bloch-Redfield term (in the eigen basis) along with the transformation matrix from eigen to fock basis.
"""
function brterm(
        H::QuantumObject{Operator},
        a_op::QuantumObject{Operator},
        spectra::Function;
        sec_cutoff::Real = 0.1,
        fock_basis::Union{Bool, Val} = Val(false),
    )
    rst = eigenstates(H)
    U = QuantumObject(rst.vectors, Operator(), H.dimensions)

    # Check whether we can rotate the terms to the eigenbasis directly in the Hamiltonian space
    fock_basis_hamiltonian = getVal(fock_basis) && sec_cutoff == -1

    term = _brterm(rst, a_op, spectra, sec_cutoff, fock_basis_hamiltonian)
    if getVal(fock_basis)
        if fock_basis_hamiltonian
            return term # Already rotated in the Hamiltonian space
        else
            U_sp = to_sparse(U)
            SU = sprepost(U_sp, U_sp')
            return SU * term * SU'
        end
    else
        return term, U
    end
end

function _brterm(
        rst::EigsolveResult{T1, T2, Operator, DimType},
        a_op::Ta,
        spectra::F,
        sec_cutoff::Real,
        fock_basis_hamiltonian::Union{Bool, Val},
    ) where {T1, T2, DimType <: Dimensions, Ta <: QuantumObject{Operator}, F <: Function}
    _check_br_spectra(spectra)

    U = rst.vectors

    skew = @. rst.values - rst.values' |> real
    spectrum = spectra.(skew)

    A_mat = to_sparse_if_needed(Val(issparse(a_op.data)), U' * a_op.data * U)
    A_mat_spec = A_mat .* spectrum
    A_mat_spec_t = A_mat .* transpose(spectrum)

    ac_term = A_mat_spec * A_mat
    bd_term = A_mat * A_mat_spec_t

    if sec_cutoff != -1
        m_cut = map(x -> abs(x) < sec_cutoff, skew)
        ac_term .*= m_cut
        bd_term .*= m_cut
    end

    # Rotate the terms to the eigenbasis if possible
    if getVal(fock_basis_hamiltonian)
        A_mat = to_sparse_if_needed(Val(issparse(A_mat)), U * A_mat * U')
        A_mat_spec = to_sparse_if_needed(Val(issparse(A_mat_spec)), U * A_mat_spec * U')
        A_mat_spec_t = to_sparse_if_needed(Val(issparse(A_mat_spec_t)), U * A_mat_spec_t * U')
        ac_term = to_sparse_if_needed(Val(issparse(ac_term)), U * ac_term * U')
        bd_term = to_sparse_if_needed(Val(issparse(bd_term)), U * bd_term * U')
    end

    # Remove small values before passing in the Liouville space
    if settings.auto_tidyup
        tidyup!(A_mat)
        tidyup!(A_mat_spec)
        tidyup!(A_mat_spec_t)
        tidyup!(ac_term)
        tidyup!(bd_term)
    end

    out = (_sprepost(A_mat_spec_t, A_mat) + _sprepost(A_mat, A_mat_spec) - _spost(ac_term) - _spre(bd_term)) / 2

    if (sec_cutoff != -1)
        vec_skew = vec(skew)
        M_cut = @. abs(vec_skew - vec_skew') < sec_cutoff

        out .*= M_cut
    end

    lspace = LiouvilleSpace(rst.dimensions)
    return QuantumObject(out, SuperOperator(), Dimensions(lspace, lspace))
end

@doc raw"""
    brmesolve(
        H::QuantumObject{Operator}, 
        ψ0::QuantumObject,
        tlist::AbstractVector, 
        a_ops::Union{Nothing, AbstractVector, Tuple}, 
        c_ops::Union{Nothing, AbstractVector, Tuple}=nothing;
        sec_cutoff::Real=0.1,
        e_ops::Union{Nothing, AbstractVector}=nothing,
        kwargs...,
    )

Solves for the dynamics of a system using the Bloch-Redfield master equation, given an input Hamiltonian, Hermitian bath-coupling terms and their associated spectral functions, as well as possible Lindblad collapse operators.

## Arguments

- `H`: The system Hamiltonian. Must be an [`Operator`](@ref)
- `ψ0`:  Initial state of the system $|\psi(0)\rangle$. It can be either a [`Ket`](@ref), [`Operator`](@ref) or [`OperatorKet`](@ref).
- `tlist`: List of time points at which to save either the state or the expectation values of the system.
- `a_ops`: Nested list with each element is a `Tuple` of operator-function pairs `(a_op, spectra)`, and the coupling [`Operator`](@ref) `a_op` must be hermitian with corresponding `spectra` being a `Function` of transition energy
- `c_ops`: List of collapse operators corresponding to Lindblad dissipators
- `sec_cutoff`: Cutoff for secular approximation. Use `-1` if secular approximation is not used when evaluating bath-coupling terms.
- `e_ops`: List of operators for which to calculate expectation values. It can be either a `Vector` or a `Tuple`.
- `kwargs`: Keyword arguments for [`mesolve`](@ref).

## Notes

- This function will automatically generate the [`bloch_redfield_tensor`](@ref) and solve the time evolution with [`mesolve`](@ref).

# Returns

- `sol::TimeEvolutionSol`: The solution of the time evolution. See also [`TimeEvolutionSol`](@ref)
"""
function brmesolve(
        H::QuantumObject{Operator},
        ψ0::QuantumObject,
        tlist::AbstractVector,
        a_ops::Union{Nothing, AbstractVector, Tuple},
        c_ops::Union{Nothing, AbstractVector, Tuple} = nothing;
        sec_cutoff::Real = 0.1,
        e_ops::Union{Nothing, AbstractVector, Tuple} = nothing,
        kwargs...,
    )
    R = bloch_redfield_tensor(H, a_ops, c_ops; sec_cutoff = sec_cutoff, fock_basis = Val(true))

    return mesolve(R, ψ0, tlist, nothing; e_ops = e_ops, kwargs...)
end

function _check_br_spectra(f::Function)
    length(methods(f, [Real]).ms) == 0 &&
        throw(ArgumentError("The following function must only accept one argument: `$(nameof(f))(ω)` with ω<:Real"))
    return nothing
end

module QuantumToolboxMakieExt

using QuantumToolbox
import QuantumToolbox:
    makeVal, getVal, _state_to_bloch, _handle_matrix_plot_data, _gen_default_ket_labels, _gen_default_bra_labels

import LinearAlgebra: cross, deg2rad, normalize, size
import Makie:
    Axis,
    Axis3,
    LScene,
    Colorbar,
    Figure,
    GridLayout,
    heatmap!,
    surface!,
    barplot!,
    GridPosition,
    @L_str,
    Reverse,
    ylims!,
    RGBAf,
    Sphere,
    lines!,
    scatter!,
    arrows3d!,
    text!,
    mesh!,
    meshscatter!,
    RGBf,
    Point3f,
    Rect3f,
    Vec3f,
    NoShading,
    cameracontrols,
    update_cam!,
    cam3d!,
    translate!

include("MakieExt/utils.jl")

include("MakieExt/bloch_sphere.jl")
include("MakieExt/fock_distribution.jl")
include("MakieExt/matrix.jl")
include("MakieExt/wigner.jl")

end

@testitem "Eigenvalues" begin
    σx = sigmax()
    result = eigenstates(σx, sparse = Val(false))
    vals_pauli_dense, vecs_pauli_dense, mat_pauli_dense = result
    resstring = sprint((t, s) -> show(t, "text/plain", s), result)
    valstring = sprint((t, s) -> show(t, "text/plain", s), result.values)
    vecsstring = sprint((t, s) -> show(t, "text/plain", s), result.vectors)
    vals_pauli_sparse, vecs_pauli_sparse, mat_pauli_sparse =
        eigenstates(σx, sparse = Val(true), eigvals = 2)

    @test all([ψ.type isa Ket for ψ in vecs_pauli_dense])
    @test mat_pauli_dense isa AbstractMatrix
    @test mat_pauli_sparse isa AbstractMatrix
    @test sort(eigenenergies(σx, sparse = Val(false)); by = real) ≈ sort(vals_pauli_dense; by = real)
    @test sort(eigenenergies(σx, sparse = Val(true), eigvals = 2); by = real) ≈ sort(vals_pauli_sparse; by = real)
    @test resstring ==
        "EigsolveResult:   type=$(Operator())   dims=$(result.dims)\nvalues:\n$(valstring)\nvectors:\n$vecsstring"

    N = 30
    a = kron(destroy(N), qeye(2))
    a_d = a'

    sm = kron(qeye(N), sigmam())
    sp = sm'
    sx = kron(qeye(N), sigmax())
    sy = kron(qeye(N), sigmay())
    sz = kron(qeye(N), sigmaz())

    η = 0.2
    H_d = a_d * a + 0.5 * sz - 1im * η * (a - a_d) * sx + η^2
    H_c = a_d * a + 0.5 * (sz * cosm(2 * η * (a + a_d)) + sy * sinm(2 * η * (a + a_d)))

    vals_disp_dense, vecs_disp_dense, _ = eigenstates(H_d)
    vals_disp_cosine, vecs_disp_cosine, _ = eigenstates(H_c)
    vals_disp_sparse, vecs_disp_sparse, _ =
        eigenstates(H_d, sparse = Val(true), sigma = -0.9, eigvals = 10, krylovdim = 30, by = real)

    @test real.(vals_disp_dense[1:20]) ≈ real.(vals_disp_cosine[1:20])
    @test real.(vals_disp_dense[1:10]) ≈ real.(vals_disp_sparse[1:10])

    N = 5
    a = kron(destroy(N), qeye(N))
    a_d = a'
    b = kron(qeye(N), destroy(N))
    b_d = b'

    ωc = 1
    ωb = 1
    g = 0.01
    κ = 0.1
    n_th = 0.01

    H = ωc * a_d * a + ωb * b_d * b + g * (a + a_d) * (b + b_d)
    c_ops = [√((1 + n_th) * κ) * a, √κ * b, √(n_th * κ) * a_d]
    L = liouvillian(H, c_ops)

    # eigen solve for general matrices
    vals_liou_dense, _, vecs_liou_dense = eigsolve(L.data, sigma = 0.01, eigvals = 10, krylovdim = 50)
    vals_liou_sparse, _, vecs_liou_sparse = eigenstates(L; sortby = abs)
    vals_liou_sparse = vals_liou_sparse[1:10]
    vecs_liou_sparse = vecs_liou_sparse[:, 1:10]
    vals_liou_al, states_liou_al, vecs_liou_al =
        eigsolve_al(L, 1 \ (10 * κ), eigvals = 10, krylovdim = 50, liouvillian_eigs = Val(true))

    # We now sort the eigenvalues and eigenvectors to make sure they are in the same order.
    # The Arnoldi-Lindblad takes the values closest to the unit circle, not to the origin,
    # so, we only pick those also captured by the standard shift-invert method
    sort_func = x -> (round(abs(x), digits = 6), round(real(x), digits = 6), round(imag(x), digits = 6))
    idxs_dense = sortperm(vals_liou_dense, by = sort_func, rev = false)
    idxs_sparse = sortperm(vals_liou_sparse, by = sort_func, rev = false)
    idxs_al = sortperm(vals_liou_al, by = sort_func, rev = false)
    vals_liou_dense = vals_liou_dense[idxs_dense]
    vecs_liou_dense = vecs_liou_dense[:, idxs_dense]
    vals_liou_sparse = vals_liou_sparse[idxs_sparse]
    vecs_liou_sparse = vecs_liou_sparse[:, idxs_sparse]
    vals_liou_al = vals_liou_al[idxs_al]
    states_liou_al = states_liou_al[idxs_al]
    vecs_liou_al = vecs_liou_al[:, idxs_al]

    @test vals_liou_dense ≈ vals_liou_sparse
    @test vals_liou_sparse[1] ≈ vals_liou_al[1] atol = 1.0e-6
    @test vec2mat(vecs_liou_dense[:, 1]) * exp(-1im * angle(vecs_liou_dense[1, 1])) ≈
        vec2mat(vecs_liou_sparse[:, 1]) * exp(-1im * angle(vecs_liou_sparse[1, 1])) atol = 1.0e-7
    @test vec2mat(vecs_liou_dense[:, 1]) * exp(-1im * angle(vecs_liou_dense[1, 1])) ≈
        vec2mat(vecs_liou_al[:, 1]) * exp(-1im * angle(vecs_liou_al[1, 1])) atol = 1.0e-5

    # eigen solve for QuantumObject
    result_sparse = eigenstates(L, sparse = Val(true), sigma = 0.01, eigvals = 10, krylovdim = 50)
    vals_sparse_qobj, vecs_sparse_qobj = result_sparse
    resstring = sprint((t, s) -> show(t, "text/plain", s), result_sparse)
    valstring = sprint((t, s) -> show(t, "text/plain", s), result_sparse.values)
    vecsstring = sprint((t, s) -> show(t, "text/plain", s), result_sparse.vectors)
    @test resstring ==
        "EigsolveResult:   type=$(SuperOperator())   dims=$(result_sparse.dims)\nvalues:\n$(valstring)\nvectors:\n$vecsstring"

    vals_qobj_sorted, vecs_qobj_sorted = eigenstates(L, sortby = abs)
    vals_qobj_sorted = vals_qobj_sorted[1:10]
    vecs_qobj_sorted = vecs_qobj_sorted[1:10]

    ρss_dense = vector_to_operator(vecs_sparse_qobj[1])
    ρss_qobj = vector_to_operator(vecs_qobj_sorted[1])
    ρss_al = vector_to_operator(states_liou_al[1])
    ρss_dense /= tr(ρss_dense)
    ρss_qobj /= tr(ρss_qobj)
    ρss_al /= tr(ρss_al)

    @test result_sparse.type isa SuperOperator
    @test result_sparse.dims == L.dims
    @test all([v.type isa OperatorKet for v in vecs_sparse_qobj])
    @test result_sparse.vectors isa AbstractMatrix
    @test sum(abs2, vals_sparse_qobj) ≈ sum(abs2, vals_qobj_sorted)
    @test vals_qobj_sorted[1] ≈ vals_liou_al[1] atol = 1.0e-6
    @test fidelity(ρss_dense, ρss_qobj) ≈ 1
    @test fidelity(ρss_dense, ρss_al) ≈ 1

    @testset "Type Inference (eigen)" begin
        UnionType = Union{
            EigsolveResult{
                Vector{ComplexF64},
                Matrix{ComplexF64},
                Operator,
                Dimensions{TensorSpace{2, Tuple{Space, Space}}, TensorSpace{2, Tuple{Space, Space}}},
            },
            EigsolveResult{
                Vector{Float64},
                Matrix{ComplexF64},
                Operator,
                Dimensions{TensorSpace{2, Tuple{Space, Space}}, TensorSpace{2, Tuple{Space, Space}}},
            },
        }

        @inferred UnionType eigenstates(H, sparse = Val(false))
        @inferred eigenstates(H, sparse = Val(true))
        @inferred eigenstates(L, sparse = Val(true))
        @inferred eigsolve_al(L, 1 \ (10 * κ), eigvals = 10, liouvillian_eigs = Val(true))
    end
end

#=
This file defines the Dimensions structure and also the following space structures:
    - Space
    - TensorSpace
    - LiouvilleSpace
=#

export Dimensions, get_size
export AbstractSpace, Space, TensorSpace
export AbstractSuperSpace, LiouvilleSpace

@doc raw"""
    abstract type AbstractSpace

Abstract type for all space structures.
"""
abstract type AbstractSpace end

@doc raw"""
    abstract type AbstractSuperSpace

Abstract type of space structures for different SuperOperator representation.
"""
abstract type AbstractSuperSpace <: AbstractSpace end

##########################################
# Dimensions

@doc raw"""
    struct Dimensions{T1 <: AbstractSpace, T2 <: AbstractSpace}
        to::T1
        from::T2
    end

A structure that embodies the left-hand side (`to`) and right-hand side (`from`) [`AbstractSpace`](@ref) of a quantum object.

The fields `to` and `from` are related to the left (row) and right (column) dimensions, respectively.

# Constructors

- `Dimensions(to, from)`: Create `Dimensions` with explicit `to` and `from` [`AbstractSpace`](@ref)
- `Dimensions(dims)`: Create `Dimensions` where `to == from`
- `Dimensions((to_dims, from_dims))`: Create `Dimensions` from a 2-element tuple of integer tuple/vectors

# Examples

```jldoctest
julia> Dimensions(3)  # Single 3-dimensional Hilbert space
Dimensions(Space(3), Space(3))

julia> Dimensions((2, 3))  # Composite 2⊗3 Hilbert space (square)
Dimensions(TensorSpace(Space(2), Space(3)), TensorSpace(Space(2), Space(3)))

julia> Dimensions(((2, 3), (4,)))  # Non-square: maps from 4-dim to 2⊗3=6-dim
Dimensions(TensorSpace(Space(2), Space(3)), Space(4))
```
"""
struct Dimensions{T1 <: AbstractSpace, T2 <: AbstractSpace}
    to::T1   # space acting on the left (rows)
    from::T2 # space acting on the right (columns)
end

# by defining alias type, it is easier to represent the nested dims structure:
const DimsListType{T1, T2} = Tuple{<:AbstractVecOrTuple{T1}, <:AbstractVecOrTuple{T2}}

function _list_to_tensor_space(dims::AbstractVecOrTuple{T}, argname::String) where {T <: Integer}
    _non_static_array_warning(argname, dims)
    return TensorSpace(Tuple(Space.(dims)))
end

# endomorphic dimensions from integer tuple/vector
function Dimensions(dims::AbstractVecOrTuple{T}) where {T <: Integer}
    L = length(dims)
    (L > 0) || throw(DomainError(dims, "The argument dims must be of non-zero length"))

    return Dimensions(_list_to_tensor_space(dims, "dims"))
end

# endomorphic dimensions from single integer
Dimensions(dims::Int) = Dimensions(Space(dims))

# endomorphic dimensions from single AbstractSpace
Dimensions(dims::AbstractSpace) = Dimensions(dims, dims)

# Non-endomorphic dimensions from 2-element tuple of integer vectors/tuples
function Dimensions(dims::DimsListType{T, T}) where {T <: Integer}
    (length(dims) != 2) && throw(ArgumentError("Invalid dims = $dims"))

    L1 = length(dims[1])
    L2 = length(dims[2])
    (L1 > 0) || throw(DomainError(L1, "The length of `dims[1]` must be larger or equal to 1."))
    (L2 > 0) || throw(DomainError(L2, "The length of `dims[2]` must be larger or equal to 1."))

    return Dimensions(_list_to_tensor_space(dims[1], "dims[1]"), _list_to_tensor_space(dims[2], "dims[2]"))
end

# LiouvilleSpace dimensions for OperatorKet/OperatorBra/SuperOperator from 3-level nested tuple/vector of integers
Dimensions(dims::DimsListType{T1, T2}) where {T1 <: AbstractVecOrTuple, T2 <: Integer} = Dimensions(LiouvilleSpace(Dimensions(dims[1])), _list_to_tensor_space(dims[2], "dims[2]"))
Dimensions(dims::DimsListType{T1, T2}) where {T1 <: Integer, T2 <: AbstractVecOrTuple} = Dimensions(_list_to_tensor_space(dims[1], "dims[1]"), LiouvilleSpace(Dimensions(dims[2])))
Dimensions(dims::DimsListType{T1, T2}) where {T1 <: AbstractVecOrTuple, T2 <: AbstractVecOrTuple} = Dimensions(LiouvilleSpace(Dimensions(dims[1])), LiouvilleSpace(Dimensions(dims[2])))

# Error for invalid input
Dimensions(dims::Any) = throw(
    ArgumentError(
        """
        \nThe argument `dims` must be one of the following:
          • a positive integer (single-system Hilbert space),
          • a `Tuple` or `AbstractVector` of positive integers (multipartite Hilbert space),
          • a `AbstractSpace`,
          • a 2-element `Tuple` combining the above, or
          • directly specify the `Dimensions` structure.
        """
    ),
)

function Base.show(io::IO, d::Dimensions)
    print(io, "Dimensions($(d.to), $(d.from))")
    return nothing
end

# Check if Dimensions is endomorphic (to == from)
isendomorphic(dimensions::Dimensions) = dimensions.to == dimensions.from
_non_endomorphic_dims_error(op_description::String, dimensions::Dimensions) = throw(ArgumentError("The $op_description must be endomorphic (same `to` and `from`), got: dims = $(_get_dims_string(dimensions))"))

# obtain dims in the type of SVector with integers
function dimensions_to_dims(dimensions::Dimensions)
    to_dims = dimensions_to_dims(dimensions.to)
    from_dims = dimensions_to_dims(dimensions.from)
    return (to_dims, from_dims)
end

dimensions_to_dims(::Nothing) = nothing # for EigsolveResult.dimensions = nothing

@doc raw"""
    get_size(dimensions::Dimensions)

Returns the matrix dimensions `(m, n)` of a given [`Dimensions`](@ref).

Returns `(m, n)` where `m` is the product of the `dimensions.to`, and `n` is the product of the `dimensions.from`.

If `dimensions` is an `Integer` or a vector/tuple of `Integer`s, it is automatically treated as `Dimensions(dimensions, dimensions)`.
"""
get_size(dimensions::Dimensions) = (get_size(dimensions.to), get_size(dimensions.from))
get_size(dimensions::Union{T, AbstractVecOrTuple{T}}) where {T <: Integer} = get_size(Dimensions(dimensions))

Base.transpose(dimensions::Dimensions) = Dimensions(dimensions.from, dimensions.to) # switch `to` and `from`
Base.adjoint(dimensions::Dimensions) = transpose(dimensions)

# this is used to show `dims` for Qobj and QobjEvo
function _get_dims_string(dimensions::Dimensions)
    dims = dimensions_to_dims(dimensions)
    return "($(string(dims[1])), $(string(dims[2])))"
end
_get_dims_string(::Nothing) = "nothing" # for EigsolveResult.dimensions = nothing

Base.:(==)(dim1::Dimensions, dim2::Dimensions) = (dim1.to == dim2.to) && (dim1.from == dim2.from)

##########################################
# Space

@doc raw"""
    struct Space <: AbstractSpace
        size::Int
    end

A structure that describes a single space with size equals to `size`.
"""
struct Space <: AbstractSpace
    size::Int

    function Space(size::Int)
        (size < 1) && throw(DomainError(size, "The size of `Space` must be positive integer (≥ 1)."))
        return new(size)
    end
end

function Base.show(io::IO, s::Space)
    print(io, "Space($(s.size))")
    return nothing
end

Base.length(s::Space) = 1

get_size(s::Space) = s.size

dimensions_to_dims(s::Space) = SVector{1, Int}(s.size)

##########################################
# TensorSpace

@doc raw"""
    struct TensorSpace{N, T <: NTuple{N, AbstractSpace}} <: AbstractSpace
        spaces::T
    end

A structure that describes a tensor product of `N` spaces, where each space is an element of the tuple `spaces`.
"""
struct TensorSpace{N, T <: NTuple{N, AbstractSpace}} <: AbstractSpace
    spaces::T # a tuple which all elements should be <: AbstractSpace

    function TensorSpace(spaces::T) where {N, T <: NTuple{N, AbstractSpace}}
        if N < 1
            throw(DomainError(N, "The number of spaces in `TensorSpace` must be larger or equal to 1."))
        elseif N == 1
            return spaces[1] # don't wrap with TensorSpace if there is only one space
        else
            return new{N, T}(spaces)
        end
    end
end
TensorSpace(spaces::AbstractSpace) = spaces # don't wrap with TensorSpace if there is only one space
TensorSpace(s::AbstractSpace...) = TensorSpace(s) # this allows convenient function call: TensorSpace(s1, s2, ...)

function Base.show(io::IO, s::TensorSpace)
    print(io, "TensorSpace(")
    join(io, s.spaces, ", ")
    print(io, ")")
    return nothing
end

# allow iteration over subspaces in TensorSpace
Base.iterate(s::TensorSpace) = iterate(s.spaces)
Base.iterate(s::TensorSpace, state) = iterate(s.spaces, state)

Base.getindex(s::TensorSpace, idx::Union{T, AbstractVector{T}}) where {T <: Integer} = TensorSpace(s.spaces[idx]) # indexing for `permute`

Base.length(::TensorSpace{N}) where {N} = N

get_size(s::TensorSpace) = prod(get_size, s.spaces)

Base.kron(s1::TensorSpace, s2::TensorSpace) = TensorSpace(s1.spaces..., s2.spaces...)
Base.kron(s1::TensorSpace, s2::AbstractSpace) = TensorSpace(s1.spaces..., s2)
Base.kron(s1::AbstractSpace, s2::TensorSpace) = TensorSpace(s1, s2.spaces...)
Base.kron(s1::AbstractSpace, s2::AbstractSpace) = TensorSpace(s1, s2)

dimensions_to_dims(s::TensorSpace) = vcat(map(dimensions_to_dims, s.spaces)...)

##########################################
# LiouvilleSpace

@doc raw"""
    LiouvilleSpace{T <: Dimensions} <: AbstractSuperSpace
        op_dims::T
    end

A structure that describes the Liouville space which is equivalent (isometrically isomorphic) to the tensor product of the original `oper` with its dual.
"""
struct LiouvilleSpace{DT <: Dimensions} <: AbstractSuperSpace
    op_dims::DT # original operator dimensions
end

function Base.show(io::IO, s::LiouvilleSpace)
    print(io, "LiouvilleSpace(", s.op_dims, ")")
    return nothing
end

Base.length(::LiouvilleSpace) = 1

# we somehow need to define :(==) for LiouvilleSpace, otherwise, it doesn't work with EnrSpace
Base.:(==)(s1::LiouvilleSpace, s2::LiouvilleSpace) = s1.op_dims == s2.op_dims

get_size(s::LiouvilleSpace) = prod(get_size(s.op_dims)) # get_size(Dimensions.to) × get_size(Dimensions.from)

dimensions_to_dims(s::LiouvilleSpace) = dimensions_to_dims(s.op_dims)

#=
This file contains helper functions for callbacks. The affect! function are defined taking advantage of the Julia struct, which allows to store some cache exclusively for the callback.
=#

##

abstract type AbstractSaveFunc end

function _merge_tstops(kwargs, prob_is_const::Bool, tlist)
    if prob_is_const
        return kwargs
    else
        tstops = haskey(kwargs, :tstops) ? unique!(sort!(vcat(tlist, kwargs.tstops))) : tlist
        return merge(kwargs, (tstops = tstops,))
    end
end

# Multiple dispatch depending on the progress_bar and e_ops types
function _generate_se_me_kwargs(e_ops, progress_bar, tlist, kwargs, method)
    cb = _generate_save_callback(e_ops, tlist, progress_bar, method)
    return _merge_kwargs_with_callback(kwargs, cb)
end
_generate_se_me_kwargs(e_ops::Nothing, progress_bar::Val{false}, tlist, kwargs, method) = kwargs

function _generate_stochastic_kwargs(
        e_ops,
        sc_ops,
        progress_bar,
        tlist,
        store_measurement,
        kwargs,
        method::Type{SF},
    ) where {SF <: AbstractSaveFunc}
    cb_save = _generate_stochastic_save_callback(e_ops, sc_ops, tlist, store_measurement, progress_bar, method)

    # Ensure that the noise is stored in tlist. # TODO: Fix this directly in DiffEqNoiseProcess.jl
    # See https://github.com/SciML/DiffEqNoiseProcess.jl/issues/214 for example
    kwargs2 = _merge_tstops(kwargs, false, tlist) # set 'prob_is_const = false' to force add 'tstops = tlist'

    if SF === SaveFuncSSESolve
        cb_normalize = _ssesolve_generate_normalize_cb()
        return _merge_kwargs_with_callback(kwargs2, CallbackSet(cb_normalize, cb_save))
    end

    return _merge_kwargs_with_callback(kwargs2, cb_save)
end
_generate_stochastic_kwargs(
    e_ops::Nothing,
    sc_ops,
    progress_bar::Val{false},
    tlist,
    store_measurement::Val{false},
    kwargs,
    method::Type{SF},
) where {SF <: AbstractSaveFunc} = kwargs

function _merge_kwargs_with_callback(kwargs, cb)
    kwargs2 =
        haskey(kwargs, :callback) ? merge(kwargs, (callback = CallbackSet(cb, kwargs.callback),)) :
        merge(kwargs, (callback = cb,))

    return kwargs2
end

function _generate_save_callback(e_ops, tlist, progress_bar, method)
    e_ops_data = e_ops isa Nothing ? nothing : _get_e_ops_data(e_ops, method)

    progr =
        getVal(progress_bar) ?
        Progress(
            length(tlist);
            enabled = getVal(progress_bar),
            desc = _get_progress_desc(method),
            settings.ProgressMeterKWARGS...,
        ) : nothing

    expvals = e_ops isa Nothing ? nothing : Array{ComplexF64}(undef, length(e_ops), length(tlist))

    _save_func = method(e_ops_data, progr, Ref(1), expvals)
    return FunctionCallingCallback(_save_func, funcat = tlist)
end

function _generate_stochastic_save_callback(e_ops, sc_ops, tlist, store_measurement, progress_bar, method)
    e_ops_data = e_ops isa Nothing ? nothing : _get_e_ops_data(e_ops, method)
    m_ops_data = _get_m_ops_data(sc_ops, method)

    progr =
        getVal(progress_bar) ?
        Progress(length(tlist); enabled = getVal(progress_bar), settings.ProgressMeterKWARGS...) : nothing

    expvals = e_ops isa Nothing ? nothing : Array{ComplexF64}(undef, length(e_ops), length(tlist))
    m_expvals = getVal(store_measurement) ? Array{Float64}(undef, length(sc_ops), length(tlist) - 1) : nothing

    _save_func_cache = Array{Float64}(undef, length(sc_ops))
    _save_func =
        method(store_measurement, e_ops_data, m_ops_data, progr, Ref(1), expvals, m_expvals, tlist, _save_func_cache)
    return FunctionCallingCallback(_save_func, funcat = tlist)
end

##

# When e_ops is Nothing. Common for all solvers
function _save_func(integrator, progr)
    next!(progr)
    u_modified!(integrator, false)
    return nothing
end

# When progr is Nothing. Common for all solvers
function _save_func(integrator, progr::Nothing)
    u_modified!(integrator, false)
    return nothing
end

##

#=
    To extract the measurement outcomes of a stochastic solver
=#
function _get_m_expvals(integrator::AbstractODESolution, method::Type{SF}) where {SF <: AbstractSaveFunc}
    cb = _get_save_callback(integrator, method)
    if cb isa Nothing
        return nothing
    else
        return cb.affect!.func.m_expvals
    end
end

#=
    With this function we extract the e_ops from the SaveFuncMCSolve `affect!` function of the callback of the integrator.
    This callback can only be a FunctionCallingCallback (DiscreteCallback).
=#
function _get_e_ops(integrator::AbstractODEIntegrator, method::Type{SF}) where {SF <: AbstractSaveFunc}
    cb = _get_save_callback(integrator, method)
    if cb isa Nothing
        return nothing
    else
        return cb.affect!.func.e_ops
    end
end

# Get the e_ops from a given AbstractODESolution. Valid for `sesolve`, `mesolve` and `ssesolve`.
function _get_expvals(sol::AbstractODESolution, method::Type{SF}) where {SF <: AbstractSaveFunc}
    cb = _get_save_callback(sol, method)
    if cb isa Nothing
        return nothing
    else
        return cb.affect!.func.expvals
    end
end

#=
    _get_save_callback

Return the Callback that is responsible for saving the expectation values of the system.
=#
function _get_save_callback(sol::AbstractODESolution, method::Type{SF}) where {SF <: AbstractSaveFunc}
    kwargs = NamedTuple(sol.prob.kwargs) # Convert to NamedTuple to support Zygote.jl
    if hasproperty(kwargs, :callback) && !isnothing(kwargs.callback)
        return _get_save_callback(kwargs.callback, method)
    else
        return nothing
    end
end
_get_save_callback(integrator::AbstractODEIntegrator, method::Type{SF}) where {SF <: AbstractSaveFunc} =
    _get_save_callback(integrator.opts.callback, method)
function _get_save_callback(cb::CallbackSet, method::Type{SF}) where {SF <: AbstractSaveFunc}
    cbs_discrete = cb.discrete_callbacks
    if length(cbs_discrete) > 0
        idx = _get_save_callback_idx(cb, method)
        _cb = cb.discrete_callbacks[idx]
        return _get_save_callback(_cb, method)
    else
        return nothing
    end
end
function _get_save_callback(cb::DiscreteCallback, ::Type{SF}) where {SF <: AbstractSaveFunc}
    if typeof(cb.affect!) <: FunctionCallingAffect && typeof(cb.affect!.func) <: AbstractSaveFunc
        return cb
    end
    return nothing
end
_get_save_callback(cb::ContinuousCallback, ::Type{SF}) where {SF <: AbstractSaveFunc} = nothing

_get_save_callback_idx(cb, method) = 1

# %% ------------ Noise Measurement Helpers ------------ %%

# TODO: To improve. See https://github.com/SciML/DiffEqNoiseProcess.jl/issues/214
function _homodyne_dWdt!(dWdt_cache, integrator, tlist, iter)
    idx = findfirst(>=(tlist[iter[] - 1]), integrator.W.t)

    # We are assuming that the last element is tlist[iter[]]
    @inbounds dWdt_cache .= (integrator.W.u[end] .- integrator.W.u[idx]) ./ (integrator.W.t[end] - integrator.W.t[idx])

    return nothing
end

@testitem "Quantum Objects Evolution" begin
    using LinearAlgebra
    using SparseArrays
    using StaticArraysCore
    using SciMLOperators
    import SciMLOperators: AddedOperator

    # DomainError: incompatible between size of array and type
    @testset "Thrown Errors" begin
        a = MatrixOperator(rand(ComplexF64, 3, 2))
        # SuperOperator requires sqrt-able dimensions
        @test_throws DimensionMismatch QobjEvo(a, type = SuperOperator())

        a = MatrixOperator(rand(ComplexF64, 3, 2))
        for t in (Ket(), Bra(), OperatorKet(), OperatorBra())
            @test_throws ArgumentError QobjEvo(a, type = t)
        end

        a = QobjEvo(destroy(20))
        @test_throws ArgumentError QobjEvo(a, type = SuperOperator())

        a = MatrixOperator(rand(ComplexF64, 5, 5))
        @test_throws DimensionMismatch QobjEvo(a, type = SuperOperator())

        ψ = fock(10, 3)
        @test_throws MethodError QobjEvo(ψ)
    end

    # unsupported type of dims
    @testset "unsupported dims" begin
        a = MatrixOperator(rand(2, 2))
        @test_throws ArgumentError QobjEvo(a, dims = 2.0)
        @test_throws ArgumentError QobjEvo(a, dims = 2.0 + 0.0im)
        @test_throws DomainError QobjEvo(a, dims = 0)
        @test_throws DomainError QobjEvo(a, dims = (2, -2))
        @test_logs (
            :warn,
            "The argument dims should be a Tuple or a StaticVector for better performance. Try to use `dims = (2, 2)` instead of `dims = [2, 2]`. Alternatively, you can do `import QuantumToolbox: SVector` and use `dims = SVector(2, 2)`.",
        ) QobjEvo(MatrixOperator(rand(4, 4)), dims = [2, 2])
    end

    @testset "Operator and SuperOperator" begin
        a = MatrixOperator(sprand(ComplexF64, 100, 100, 0.1))
        a2 = QobjEvo(a)
        a3 = QobjEvo(a, type = SuperOperator())

        @test isket(a2) == false
        @test isbra(a2) == false
        @test isoper(a2) == true
        @test issuper(a2) == false
        @test isoperket(a2) == false
        @test isoperbra(a2) == false
        @test isket(a3) == false
        @test isbra(a3) == false
        @test isoper(a3) == false
        @test issuper(a3) == true
        @test isoperket(a3) == false
        @test isoperbra(a3) == false
        @test_throws DimensionMismatch QobjEvo(a, dims = 2)

        a = MatrixOperator(rand(ComplexF64, 4, 4))
        @test QobjEvo(a, type = SuperOperator(), dims = ((2,), (2,))).dimensions.to == (HilbertSpace(2),)
    end

    @testset "Promote Operators Type" begin
        a = destroy(20)
        A = QobjEvo(a)
        @test QuantumToolbox.promote_op_type(a, A) == QuantumObjectEvolution
        @test QuantumToolbox.promote_op_type(A, a) == QuantumObjectEvolution
        @test QuantumToolbox.promote_op_type(A, A) == QuantumObjectEvolution
        @test QuantumToolbox.promote_op_type(a, a) == QuantumObject
    end

    @testset "arithmetic" begin
        a = MatrixOperator(sprand(ComplexF64, 100, 100, 0.1))
        a2 = QobjEvo(a)
        a3 = QobjEvo(a, type = SuperOperator())

        @test +a2 == a2
        @test -(-a2) == a2
        @test a2 + 2 == 2 + a2
        @test (a2 + 2).data == a2.data + 2 * I
        @test a2 * 2 == 2 * a2

        zero_like = qzero_like(a2)
        iden_like = qeye_like(a3)
        zero_array = NullOperator(100)
        iden_array = IdentityOperator(100)
        @test zero_like == QobjEvo(zero_array, type = a2.type, dims = a2.dims)
        @test typeof(zero_like.data) == typeof(zero_array)
        @test iden_like == QobjEvo(iden_array, type = a3.type, dims = a3.dims)
        @test typeof(iden_like.data) == typeof(iden_array)
        @test trans(trans(a2)) == a2
        @test trans(a2).data == transpose(a2.data)
        # @test adjoint(a2) ≈ trans(conj(a2)) # Currently doesn't work
        @test adjoint(adjoint(a2)) == a2
        @test adjoint(a2).data == adjoint(a2.data)

        N = 10
        # We use MatrixOperator instead of directly using a Qobj to increase coverage
        a = QobjEvo(MatrixOperator(sprand(ComplexF64, N, N, 5 / N)), Operator(), N)
        a_d = a'
        X = a + a_d
        # Y = 1im * (a - a_d) # Currently doesn't work. Fix in SciMLOperators.jl
        Z = a + trans(a)
        @test isherm(X) == true
        # @test isherm(Y) == true
        # @test issymmetric(Y) == false
        @test issymmetric(Z) == true
    end

    @testset "REPL show" begin
        N = 10
        a = destroy(N)
        coef(p, t) = exp(-1im * t)
        H = QobjEvo((a' * a, (a, coef)))

        opstring = sprint((t, s) -> show(t, "text/plain", s), H)
        datastring = sprint((t, s) -> show(t, "text/plain", s), H.data)
        H_dims = H.dims
        H_size = size(H)
        H_isherm = isherm(H)
        H_isconst = isconstant(H)
        @test opstring ==
            "\nQuantum Object Evo.:   type=Operator()   dims=$H_dims   size=$H_size   ishermitian=$H_isherm   isconstant=$H_isconst\n$datastring"

        L = QobjEvo(spre(a))
        opstring = sprint((t, s) -> show(t, "text/plain", s), L)
        datastring = sprint((t, s) -> show(t, "text/plain", s), L.data)
        L_dims = L.dims
        L_size = size(L)
        L_isherm = isherm(L)
        L_isconst = isconstant(L)
        @test opstring ==
            "\nQuantum Object Evo.:   type=SuperOperator()   dims=$L_dims   size=$L_size   ishermitian=$L_isherm   isconstant=$L_isconst\n$datastring"
    end

    @testset "Type Inference (QobjEvo)" begin
        N = 4
        for T in [ComplexF32, ComplexF64]
            a = MatrixOperator(rand(T, N, N))
            @inferred QobjEvo(a)
            @inferred QobjEvo(a, type = Operator())
            @inferred QobjEvo(a, type = SuperOperator())
        end

        a = destroy(N)
        coef1(p, t) = exp(-t)
        coef2(p::Vector, t) = sin(p[1] * t)
        coef3(p::NamedTuple, t) = cos(p.ω * t)
        @inferred QobjEvo(a, coef1)
        @inferred QobjEvo((a', coef2))
        @inferred QobjEvo((a' * a, (a, coef1), (a', coef2), (a + a', coef3)))

        @testset "Math Operation" begin
            a = QobjEvo(destroy(20))
            σx = QobjEvo(sigmax())
            @inferred a + a
            @inferred a + a'
            # @inferred a + 2 # TODO fix in SciMLOperators.jl
            @inferred 2 * a
            @inferred a / 2
            @inferred a * a
            @inferred a * a'

            @inferred kron(a)
            @test_logs (:warn,) @inferred kron(a, σx)
            @test_logs (:warn,) @inferred kron(a, eye(2))
            @test_logs (:warn,) (:warn,) @inferred kron(a, eye(2), eye(2))
        end
    end

    @testset "tensor" begin
        σx = QobjEvo(sigmax())
        X3 = @test_logs (:warn,) (:warn,) tensor(σx, σx, σx)
        X_warn = @test_logs (:warn,) (:warn,) (:warn,) tensor(fill(σx, 3))
        @test X_warn(0) == X3(0) == tensor(sigmax(), sigmax(), sigmax())
    end

    @testset "Time Dependent Operators and SuperOperators" begin
        N = 10
        a = destroy(N)
        coef1(p, t) = exp(-p.γ * t)
        coef2(p, t) = cos(p.ω1 * t)
        coef3(p, t) = sin(p.ω2 * t)
        t = rand()
        p = (γ = rand(), ω1 = rand(), ω2 = rand())

        # Operator
        H_td = QobjEvo(((a + a', coef1), a' * a, (-1im * (a - a'), coef2))) # a Hermitian Hamiltonian
        H_ti = coef1(p, t) * (a + a') + a' * a - 1im * coef2(p, t) * (a - a')
        ψ = rand_ket(N)
        @test H_td(p, t) ≈ H_ti
        @test iscached(H_td) == true
        H_td = cache_operator(H_td, ψ)
        @test iscached(H_td) == true
        @test H_td(ψ, p, t) ≈ H_ti * ψ
        @test isconstant(a) == true
        @test isconstant(H_td) == false
        @test isconstant(QobjEvo(a)) == true
        @test isoper(H_td) == true
        @test QobjEvo(a, coef1) == QobjEvo((a, coef1))

        # SuperOperator
        X = a * a'
        c_op1 = QobjEvo(a', coef1)
        c_op2 = QobjEvo(((a, coef2), (X, coef3)))
        c_ops = (c_op1, c_op2)
        D1_ti = abs2(coef1(p, t)) * lindblad_dissipator(a')
        D2_ti =
            abs2(coef2(p, t)) * lindblad_dissipator(a) + # normal dissipator for first  element in c_op2
            abs2(coef3(p, t)) * lindblad_dissipator(X) + # normal dissipator for second element in c_op2
            coef2(p, t) * conj(coef3(p, t)) * (spre(a) * spost(X') - 0.5 * spre(X' * a) - 0.5 * spost(X' * a)) + # cross terms
            conj(coef2(p, t)) * coef3(p, t) * (spre(X) * spost(a') - 0.5 * spre(a' * X) - 0.5 * spost(a' * X))   # cross terms
        L_ti = liouvillian(H_ti) + D1_ti + D2_ti
        L_td = @test_logs liouvillian(H_td, c_ops) # Test there are no warnings from lazy tensor
        ρvec = mat2vec(rand_dm(N))
        @test L_td(p, t) ≈ L_ti
        @test iscached(L_td) == false
        L_td = cache_operator(L_td, ρvec)
        @test iscached(L_td) == true
        @test L_td(ρvec, p, t) ≈ L_ti * ρvec
        @test isconstant(L_td) == false
        @test issuper(L_td) == true

        # test number of lazy operators and assume_hermitian = Val(false)
        L_td_assume_herm = liouvillian(H_td)
        L_td_assume_not_herm = liouvillian(H_td, assume_hermitian = Val(false))
        @test L_td_assume_herm.data isa AddedOperator
        @test L_td_assume_not_herm.data isa AddedOperator
        @test length(L_td_assume_herm.data.ops) == 3 # 1-time-indep. + 2-time-dep.
        @test length(L_td_assume_not_herm.data.ops) == 5 # 1-time-indep. + 2 x 2-time-dep.
        @test L_td_assume_herm(p, t) ≈ L_td_assume_not_herm(p, t) # check the matrix since H_td is itself Hermitian

        coef_wrong1(t) = nothing
        coef_wrong2(p, t::ComplexF64) = nothing
        @test_logs liouvillian(H_td * H_td) # Check there are no warnings from lazy tensor
        @test_throws ArgumentError QobjEvo(a, coef_wrong1)
        @test_throws ArgumentError QobjEvo(a, coef_wrong2)
        @test_throws MethodError QobjEvo([[a, coef1], a' * a, [a', coef2]])
        @test_throws ArgumentError H_td(ρvec, p, t)
        @test_throws ArgumentError cache_operator(H_td, ρvec)
        @test_throws ArgumentError L_td(ψ, p, t)
        @test_throws ArgumentError cache_operator(L_td, ψ)

        @testset "Type Inference" begin
            H_td2 = H_td + QobjEvo(a + a', coef3)
            c_ops1 = (a, a')
            c_ops2 = (a, QobjEvo(a', coef1))

            @inferred liouvillian(H_td, c_ops1)
            @inferred liouvillian(H_td, c_ops2)
            @inferred liouvillian(H_td2, c_ops1)
            @inferred liouvillian(H_td2, c_ops2)
            @inferred liouvillian(H_td2, c_ops2, assume_hermitian = Val(false))
        end
    end
end

#=
Synonyms of the functions for QuantumObject
=#

export Qobj, QobjEvo, shape, isherm
export trans, dag, matrix_element, unit
export basis
export tensor, ⊗
export qeye, qeye_like, qzero_like
export vector_to_operator, operator_to_vector
export sqrtm, logm, expm, sinm, cosm

@doc raw"""
    Qobj(A; kwargs...)

!!! note
    `Qobj` is a synonym for generating [`QuantumObject`](@ref). See the docstring of [`QuantumObject`](@ref) for more details.
"""
const Qobj = QuantumObject # we need the docstring here, otherwise the docstring won't be found because QuantumObject is not a public symbol

@doc raw"""
    QobjEvo(args...; kwargs...)

!!! note
    `QobjEvo` is a synonym for generating [`QuantumObjectEvolution`](@ref). See the docstrings of [`QuantumObjectEvolution`](@ref) for more details.
"""
const QobjEvo = QuantumObjectEvolution # we need the docstring here, otherwise the docstring won't be found because QuantumObjectEvolution is not a public symbol

const shape = size

const isherm = ishermitian

const trans = transpose

const dag = adjoint

const basis = fock

@doc raw"""
    matrix_element(i::QuantumObject, A::QuantumObject, j::QuantumObject)

Compute the generalized dot product `dot(i, A*j)` between three [`QuantumObject`](@ref): ``\langle i | \hat{A} | j \rangle``

Note that this function is same as `dot(i, A, j)`

Supports the following inputs:
- `A` is in the type of [`Operator`](@ref), with `i` and `j` are both [`Ket`](@ref).
- `A` is in the type of [`SuperOperator`](@ref), with `i` and `j` are both [`OperatorKet`](@ref)
"""
matrix_element(i, A, j) = dot(i, A, j)

const unit = normalize

const tensor = kron
const ⊗ = kron

const qeye = eye

const vector_to_operator = vec2mat
const operator_to_vector = mat2vec

@doc raw"""
    sqrtm(A::QuantumObject)

Matrix square root of [`Operator`](@ref) type of [`QuantumObject`](@ref)

Note that for other types of [`QuantumObject`](@ref) use `sqrt(A)` instead.
"""
sqrtm(A::QuantumObject{Operator}) = sqrt(A)

@doc raw"""
    logm(A::QuantumObject)

Matrix logarithm of [`QuantumObject`](@ref)

Note that this function is same as `log(A)` and only supports for [`Operator`](@ref) and [`SuperOperator`](@ref).
"""
logm(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} = log(A)

@doc raw"""
    expm(A::QuantumObject)

Matrix exponential of [`QuantumObject`](@ref)

Note that this function is same as `exp(A)` and only supports for [`Operator`](@ref) and [`SuperOperator`](@ref).
"""
expm(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} = exp(A)

@doc raw"""
    sinm(A::QuantumObject)

Matrix sine of [`QuantumObject`](@ref), defined as

``\sin \left( \hat{A} \right) = \frac{e^{i \hat{A}} - e^{-i \hat{A}}}{2 i}``

Note that this function is same as `sin(A)` and only supports for [`Operator`](@ref) and [`SuperOperator`](@ref).
"""
sinm(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} = sin(A)

@doc raw"""
    cosm(A::QuantumObject)

Matrix cosine of [`QuantumObject`](@ref), defined as

``\cos \left( \hat{A} \right) = \frac{e^{i \hat{A}} + e^{-i \hat{A}}}{2}``

Note that this function is same as `cos(A)` and only supports for [`Operator`](@ref) and [`SuperOperator`](@ref).
"""
cosm(A::QuantumObject{ObjType}) where {ObjType <: Union{Operator, SuperOperator}} = cos(A)

@doc raw"""
    qeye_like(A::AbstractQuantumObject)

Return a similar [`AbstractQuantumObject`](@ref) with `dims` and `type` are same as `A`, but `data` is an identity matrix.

Note that this function is same as `one(A)` and only supports for [`Operator`](@ref) and [`SuperOperator`](@ref).
"""
qeye_like(A::AbstractQuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} = one(A)

@doc raw"""
    qzero_like(A::AbstractQuantumObject)

Return a similar [`AbstractQuantumObject`](@ref) with `dims` and `type` are same as `A`, but `data` is a zero-array.

Note that this function is same as `zero(A)` and only supports for [`Operator`](@ref) and [`SuperOperator`](@ref).
"""
qzero_like(A::AbstractQuantumObject{OpType}) where {OpType <: Union{Operator, SuperOperator}} = zero(A)

@testitem "Negativity and Partial Transpose" begin
    @testset "negativity" begin
        rho1 = (1 / 40) * Qobj(
            [
                15 1 1 15
                1 5 -3 1
                1 -3 5 1
                15 1 1 15
            ];
            dims = (2, 2),
        )
        Neg1 = negativity(rho1, 1)
        @test Neg1 ≈ 0.25
        @test negativity(rho1, 2) ≈ Neg1
        @test negativity(rho1, 1; logarithmic = true) ≈ log2(2 * Neg1 + 1)
        @test_throws ArgumentError negativity(rho1, 3)

        # a maximally entanglment state with subsystem dimension (3, 2):
        # (|1,0⟩ - i|2,1⟩) / √2
        rho2_d = ket2dm((tensor(basis(3, 1), basis(2, 0)) - 1im * tensor(basis(3, 2), basis(2, 1))) / √2)
        rho2_s = to_sparse(rho2_d)
        @test negativity(rho2_d, 1) ≈ 0.5
        @test negativity(rho2_d, 2) ≈ 0.5
        @test negativity(rho2_s, 1) ≈ 0.5
        @test negativity(rho2_s, 2) ≈ 0.5

        # a separable state with subsystem dimension (3, 2)
        rho3_d = tensor(rand_dm(3), rand_dm(2))
        rho3_s = to_sparse(rho3_d)
        @test abs(negativity(rho3_d, 1)) < 1.0e-10
        @test abs(negativity(rho3_d, 2)) < 1.0e-10
        @test abs(negativity(rho3_s, 1)) < 1.0e-10
        @test abs(negativity(rho3_s, 2)) < 1.0e-10

        @testset "Type Inference (negativity)" begin
            @inferred negativity(rho1, 1)
            @inferred negativity(rho1, 1; logarithmic = true)
        end
    end

    @testset "partial_transpose" begin
        # A (24 * 24)-matrix which contains number 1 ~ 576
        A_dense = Qobj(reshape(1:(24^2), (24, 24)), dims = (2, 3, 4))
        A_sparse = to_sparse(A_dense)
        PT = (true, false)
        for s1 in PT
            for s2 in PT
                for s3 in PT
                    mask = [s1, s2, s3]
                    @test partial_transpose(A_dense, mask) == partial_transpose(A_sparse, mask)
                end
            end
        end
        Q0 = Qobj(zeros(ComplexF64, 3, 2))
        @test_throws ArgumentError partial_transpose(A_dense, [true])
        @test_throws ArgumentError partial_transpose(Q0, [true]) # invalid Dimensions (not TensorSpace)
        @test_throws ArgumentError partial_transpose(tensor(Q0, Q0), [true, false]) # invalid Dimensions (not endomorphic)

        @testset "Type Inference (partial_transpose)" begin
            @inferred partial_transpose(A_dense, [true, false, true])
            @inferred partial_transpose(A_sparse, [true, false, true])
        end
    end
end

### DYNAMICAL FOCK DIMENSION ###
@testitem "Dynamical Fock Dimension" begin
    F, Δ, κ = 5, 0.25, 1
    t_l = range(0, 15, length = 100)

    N0 = 140
    a0 = destroy(N0)
    H0 = Δ * a0' * a0 + F * (a0 + a0')
    c_ops0 = [√κ * a0]
    e_ops0 = [a0' * a0]
    ψ00 = fock(N0, 0)
    sol0 = mesolve(H0, ψ00, t_l, c_ops0, e_ops = e_ops0, progress_bar = Val(false))

    function H_dfd0(dims, p)
        Δ = p.Δ
        F = p.F
        a = destroy(dims[1])
        return Δ * a' * a + F * (a + a')
    end
    function c_ops_dfd0(dims, p)
        κ = p.κ
        a = destroy(dims[1])
        return [√κ * a]
    end
    function e_ops_dfd0(dims, p)
        a = destroy(dims[1])
        return [a' * a]
    end
    maxdims = [150]
    ψ0 = fock(3, 0)
    dfd_params = (Δ = Δ, F = F, κ = κ)
    sol = dfd_mesolve(
        H_dfd0,
        ψ0,
        t_l,
        c_ops_dfd0,
        maxdims,
        dfd_params,
        e_ops = e_ops_dfd0,
        progress_bar = Val(false),
        saveat = t_l,
    )

    @test sum(abs.((sol.expect[1, :] .- sol0.expect[1, :]) ./ (sol0.expect[1, :] .+ 1.0e-16))) < 0.01
    @test length(sol.states) == length(t_l)
    @test all(
        diff(getindex.(QuantumToolbox.dimensions_to_dims.(getfield.(getfield.(sol.states, :dimensions), :to)), 1)) .>= 0,
    )

    ######################

    F = 0
    H0 = Δ * a0' * a0 + F * (a0 + a0')
    c_ops0 = [√κ * a0]
    e_ops0 = [a0' * a0]
    ψ00 = fock(N0, 50)
    sol0 = mesolve(H0, ψ00, t_l, c_ops0, e_ops = e_ops0, progress_bar = Val(false))

    function H_dfd1(dims, p)
        Δ = p.Δ
        F = p.F
        a = destroy(dims[1])
        return Δ * a' * a + F * (a + a')
    end
    function c_ops_dfd1(dims, p)
        κ = p.κ
        a = destroy(dims[1])
        return [√κ * a]
    end
    function e_ops_dfd1(dims, p)
        a = destroy(dims[1])
        return [a' * a]
    end
    maxdims = [150]
    ψ0 = fock(70, 50)
    dfd_params = (Δ = Δ, F = F, κ = κ)
    sol = dfd_mesolve(H_dfd1, ψ0, t_l, c_ops_dfd1, maxdims, dfd_params, e_ops = e_ops_dfd1, progress_bar = Val(false))

    @test sum(abs.((sol.expect[1, :] .- sol0.expect[1, :]) ./ (sol0.expect[1, :] .+ 1.0e-16))) < 0.01

    ######################

    F, Δ, κ, J = 1.5, 0.25, 1, 0.05
    N0 = 25
    N1 = 20
    a0 = kron(destroy(N0), qeye(N1))
    a1 = kron(qeye(N0), destroy(N1))
    H0 = Δ * a0' * a0 + F * (a0 + a0') + Δ * a1' * a1 + J * (a0' * a1 + a0 * a1')
    c_ops0 = [√κ * a0, √κ * a1]
    e_ops0 = [a0' * a0, a1' * a1]
    ψ00 = kron(fock(N0, 0), fock(N1, 15))
    sol0 = mesolve(H0, ψ00, t_l, c_ops0, e_ops = e_ops0, progress_bar = Val(false))

    function H_dfd2(dims, p)
        Δ = p.Δ
        F = p.F
        J = p.J
        a = kron(destroy(dims[1]), qeye(dims[2]))
        b = kron(qeye(dims[1]), destroy(dims[2]))
        return Δ * a' * a + F * (a + a') + Δ * b' * b + J * (a' * b + a * b')
    end
    function c_ops_dfd2(dims, p)
        κ = p.κ
        a = kron(destroy(dims[1]), qeye(dims[2]))
        b = kron(qeye(dims[1]), destroy(dims[2]))
        return [√κ * a, √κ * b]
    end
    function e_ops_dfd2(dims, p)
        a = kron(destroy(dims[1]), qeye(dims[2]))
        b = kron(qeye(dims[1]), destroy(dims[2]))
        return [a' * a, b' * b]
    end
    maxdims = [50, 50]
    ψ0 = kron(fock(3, 0), fock(20, 15))
    dfd_params = (Δ = Δ, F = F, κ = κ, J = J)
    sol = dfd_mesolve(H_dfd2, ψ0, t_l, c_ops_dfd2, maxdims, dfd_params, e_ops = e_ops_dfd2, progress_bar = Val(false))

    @test sum(abs.((sol.expect[1, :] .- sol0.expect[1, :]) ./ (sol0.expect[1, :] .+ 1.0e-16))) +
        sum(abs.((sol.expect[2, :] .- sol0.expect[2, :]) ./ (sol0.expect[2, :] .+ 1.0e-16))) < 0.01
end

module QuantumToolboxCUDAExt

using QuantumToolbox
using QuantumToolbox: makeVal, getVal
import QuantumToolbox: _sparse_similar, _convert_eltype_wordsize
import CUDA: cu, CuArray, allowscalar
import CUDA.CUSPARSE: CuSparseVector, CuSparseMatrixCSC, CuSparseMatrixCSR
import SparseArrays: SparseVector, SparseMatrixCSC, sparse
import CUDA.Adapt: adapt

allowscalar(false)

@doc raw"""
    CuArray(A::QuantumObject)

If `A.data` is a dense array, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CuArray` for gpu calculations.
"""
CuArray(A::QuantumObject) = QuantumObject(CuArray(A.data), A.type, A.dimensions)

@doc raw"""
    CuArray{T}(A::QuantumObject)

If `A.data` is a dense array, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CuArray` with element type `T` for gpu calculations.
"""
CuArray{T}(A::QuantumObject) where {T} = QuantumObject(CuArray{T}(A.data), A.type, A.dimensions)

@doc raw"""
    CuSparseVector(A::QuantumObject)

If `A.data` is a sparse vector, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CUSPARSE.CuSparseVector` for gpu calculations.
"""
CuSparseVector(A::QuantumObject) = QuantumObject(CuSparseVector(A.data), A.type, A.dimensions)

@doc raw"""
    CuSparseVector{T}(A::QuantumObject)

If `A.data` is a sparse vector, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CUSPARSE.CuSparseVector` with element type `T` for gpu calculations.
"""
CuSparseVector{T}(A::QuantumObject) where {T} = QuantumObject(CuSparseVector{T}(A.data), A.type, A.dimensions)

@doc raw"""
    CuSparseMatrixCSC(A::QuantumObject)

If `A.data` is in the type of `SparseMatrixCSC`, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CUSPARSE.CuSparseMatrixCSC` for gpu calculations.
"""
CuSparseMatrixCSC(A::QuantumObject) = QuantumObject(CuSparseMatrixCSC(A.data), A.type, A.dimensions)

@doc raw"""
    CuSparseMatrixCSC{T}(A::QuantumObject)

If `A.data` is in the type of `SparseMatrixCSC`, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CUSPARSE.CuSparseMatrixCSC` with element type `T` for gpu calculations.
"""
CuSparseMatrixCSC{T}(A::QuantumObject) where {T} = QuantumObject(CuSparseMatrixCSC{T}(A.data), A.type, A.dimensions)

@doc raw"""
    CuSparseMatrixCSR(A::QuantumObject)

If `A.data` is in the type of `SparseMatrixCSC`, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CUSPARSE.CuSparseMatrixCSR` for gpu calculations.
"""
CuSparseMatrixCSR(A::QuantumObject) = QuantumObject(CuSparseMatrixCSR(A.data), A.type, A.dimensions)

@doc raw"""
    CuSparseMatrixCSR(A::QuantumObject)

If `A.data` is in the type of `SparseMatrixCSC`, return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA.CUSPARSE.CuSparseMatrixCSR` with element type `T` for gpu calculations.
"""
CuSparseMatrixCSR{T}(A::QuantumObject) where {T} = QuantumObject(CuSparseMatrixCSR{T}(A.data), A.type, A.dimensions)

@doc raw"""
    cu(A::QuantumObject; word_size::Int=64)

Return a new [`QuantumObject`](@ref) where `A.data` is in the type of `CUDA` arrays for gpu calculations.

# Arguments
- `A::QuantumObject`: The [`QuantumObject`](@ref)
- `word_size::Int`: The word size of the element type of `A`, can be either `32` or `64`. Default to `64`.
"""
function cu(A::QuantumObject; word_size::Union{Val, Int} = Val(64))
    _word_size = getVal(makeVal(word_size))

    ((_word_size == 64) || (_word_size == 32)) || throw(DomainError(_word_size, "The word size should be 32 or 64."))

    return cu(A, makeVal(word_size))
end
cu(A::QuantumObject, word_size::Union{Val{32}, Val{64}}) =
    QuantumObject(adapt(CuArray{_convert_eltype_wordsize(eltype(A), word_size)}, A.data), A.type, A.dimensions)
function cu(
        A::QuantumObject{ObjType, DimsType, <:SparseVector},
        word_size::Union{Val{32}, Val{64}},
    ) where {ObjType <: QuantumObjectType, DimsType <: Dimensions}
    return CuSparseVector{_convert_eltype_wordsize(eltype(A), word_size)}(A)
end
function cu(
        A::QuantumObject{ObjType, DimsType, <:SparseMatrixCSC},
        word_size::Union{Val{32}, Val{64}},
    ) where {ObjType <: QuantumObjectType, DimsType <: Dimensions}
    return CuSparseMatrixCSC{_convert_eltype_wordsize(eltype(A), word_size)}(A)
end

QuantumToolbox._sparse_similar(A::CuSparseMatrixCSC, args...) = sparse(args..., fmt = :csc)
QuantumToolbox._sparse_similar(A::CuSparseMatrixCSR, args...) = sparse(args..., fmt = :csr)

end

module QuantumToolboxGPUArraysExt

using QuantumToolbox

import GPUArrays: AbstractGPUArray, AbstractGPUSparseArray, dense_array_type
import KernelAbstractions
import KernelAbstractions: @kernel, @Const, @index, get_backend, synchronize

QuantumToolbox.to_dense(::Type{T1}, A::AbstractGPUArray{T2}) where {T1 <: Number, T2 <: Number} = T1.(A)
QuantumToolbox.to_dense(A::AbstractGPUSparseArray) = dense_array_type(typeof(A))(A)
QuantumToolbox.to_dense(::Type{T}, A::AbstractGPUSparseArray) where {T <: Number} = dense_array_type(typeof(A)){T}(A)

@kernel function tr_kernel!(B, @Const(A))
    # i, j, k = @index(Global, NTuple)
    # Atomix.@atomic B[i, j] += A[i, j, k, k] # TODO: use Atomix when it will support Complex types

    i, j = @index(Global, NTuple)
    @inbounds B[i, j] = 0
    @inbounds for k in 1:size(A, 3)
        B[i, j] += A[i, j, k, k]
    end
end

function QuantumToolbox._map_trace(A::AbstractGPUArray{T, 4}) where {T}
    B = similar(A, size(A, 1), size(A, 2))
    fill!(B, 0)

    backend = get_backend(A)
    kernel! = tr_kernel!(backend)

    kernel!(B, A, ndrange = size(A)[1:2])
    KernelAbstractions.synchronize(backend)

    return B
end

end

using Test
using TestItemRunner
using Pkg

const testdir = dirname(@__FILE__)

# Define the paths to the extension tests
const EXTENSION_PATHS = Dict(
    "AutoDiff_Ext" => joinpath(testdir, "ext-test", "cpu", "autodiff"),
    "Makie_Ext" => joinpath(testdir, "ext-test", "cpu", "makie"),
    "CUDA_Ext" => joinpath(testdir, "ext-test", "gpu"),
    "Arbitrary-Precision" => joinpath(testdir, "ext-test", "cpu", "arbitrary_precision"),
)
const EXTENSION_LIST = collect(keys(EXTENSION_PATHS))

# Handle the GROUP environment variable to determine which tests to run
const GROUP = get(ENV, "GROUP", "All")
const GROUP_LIST = String[
    "All",
    "Core",
    "Code-Quality",
    EXTENSION_LIST...,
]
(GROUP in GROUP_LIST) || throw(ArgumentError("Unknown GROUP = $GROUP\nThe allowed groups are: $GROUP_LIST\n"))

# function to set up the environment for subtests
function setup_subtest_env(path::String)
    Pkg.activate(path)
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.update()
    return nothing
end

######################################
# Core tests (use TestItemRunner.jl) #
######################################
if (GROUP == "All") || (GROUP == "Core")
    import QuantumToolbox

    QuantumToolbox.about()

    println("\nStart running Core tests...\n")
    @run_package_tests verbose = true
end

########################################################################
# Use traditional Test.jl instead of TestItemRunner.jl for other tests #
########################################################################

# Code Quality tests
if (GROUP == "All") || (GROUP == "Code-Quality")
    path = joinpath(testdir, "core-test", "code-quality")
    setup_subtest_env(path)

    using QuantumToolbox
    using Aqua, JET

    (GROUP == "Code-Quality") && QuantumToolbox.about() # print version info. for code quality CI in GitHub

    include(joinpath(path, "code_quality.jl"))
end

# Extension tests
if GROUP ∈ EXTENSION_LIST
    path = EXTENSION_PATHS[GROUP]
    setup_subtest_env(path)

    if GROUP == "AutoDiff_Ext"
        println(Pkg.status())
        include(joinpath(path, "autodiff.jl"))
    elseif GROUP == "Makie_Ext"
        include(joinpath(path, "makie_ext.jl"))
    elseif GROUP == "CUDA_Ext"
        include(joinpath(path, "cuda_ext.jl"))
    elseif GROUP == "Arbitrary-Precision"
        include(joinpath(path, "arbitrary_precision.jl"))
    end
end

# ---- SESOLVE ----
const ψ0_sesolve = fock(2, 1)
t_max = 10
const tlist_sesolve = range(0, t_max, 100)

# For direct Forward differentiation
function my_f_sesolve_direct(p)
    H = p[1] * sigmax()
    sol = sesolve(H, ψ0_sesolve, tlist_sesolve, progress_bar = Val(false))

    return real(expect(projection(2, 0, 0), sol.states[end]))
end

# For SciMLSensitivity.jl
coef_Ω(p, t) = p[1]
const H_evo = QobjEvo(sigmax(), coef_Ω)

function my_f_sesolve(p, sensealg)
    sol = sesolve(
        H_evo,
        ψ0_sesolve,
        tlist_sesolve,
        progress_bar = Val(false),
        params = p,
        sensealg = sensealg,
    )

    return real(expect(projection(2, 0, 0), sol.states[end]))
end
const my_f_sesolve_bsa_enzyme = Base.Fix{2}(my_f_sesolve, BacksolveAdjoint(autojacvec = EnzymeVJP()))
const my_f_sesolve_bsa_mooncake = Base.Fix{2}(my_f_sesolve, BacksolveAdjoint(autojacvec = MooncakeVJP()))

# Analytical solution
my_f_analytic(Ω) = abs2(sin(Ω * t_max))
my_f_analytic_deriv(Ω) = 2 * t_max * sin(Ω * t_max) * cos(Ω * t_max)

# ---- MESOLVE ----
const N = 20
const a = destroy(N)
const ψ0_mesolve = fock(N, 0)
const tlist_mesolve = range(0, 40, 100)
const ad_a = a' * a

# For direct Forward differentiation
function my_f_mesolve_direct(p)
    H = p[1] * a' * a + p[2] * (a + a')
    c_ops = [sqrt(p[3]) * a]
    sol = mesolve(H, ψ0_mesolve, tlist_mesolve, c_ops, progress_bar = Val(false))
    return real(expect(ad_a, sol.states[end]))
end

# For SciMLSensitivity.jl
coef_Δ(p, t) = p[1]
coef_F(p, t) = p[2]
coef_γ(p, t) = sqrt(p[3])
H = QobjEvo(a' * a, coef_Δ) + QobjEvo(a + a', coef_F)
c_ops = [QobjEvo(a, coef_γ)]
const L = liouvillian(H, c_ops)
const L_assume_non_herm = liouvillian(H, c_ops, assume_hermitian = Val(false))

function my_f_mesolve(p, sensealg)
    sol = mesolve(
        L,
        ψ0_mesolve,
        tlist_mesolve,
        progress_bar = Val(false),
        params = p,
        sensealg = sensealg,
    )

    return real(expect(ad_a, sol.states[end]))
end
const my_f_mesolve_bsa_enzyme = Base.Fix{2}(my_f_mesolve, BacksolveAdjoint(autojacvec = EnzymeVJP()))
const my_f_mesolve_bsa_mooncake = Base.Fix{2}(my_f_mesolve, BacksolveAdjoint(autojacvec = MooncakeVJP()))

function my_f_mesolve_assume_non_herm(p, sensealg)
    sol = mesolve(
        L_assume_non_herm,
        ψ0_mesolve,
        tlist_mesolve,
        progress_bar = Val(false),
        params = p,
        sensealg = sensealg,
    )

    return real(expect(ad_a, sol.states[end]))
end
const my_f_mesolve_assume_non_herm_bsa_enzyme = Base.Fix{2}(my_f_mesolve_assume_non_herm, BacksolveAdjoint(autojacvec = EnzymeVJP()))
const my_f_mesolve_assume_non_herm_bsa_mooncake = Base.Fix{2}(my_f_mesolve_assume_non_herm, BacksolveAdjoint(autojacvec = MooncakeVJP()))


# Analytical solution
n_ss(Δ, F, γ) = abs2(F / (Δ + 1im * γ / 2))

@testset "Autodiff" verbose = true begin
    @testset "ForwardDiff for thermal_dm" begin
        N = 100  # dimension of the system
        N_op = num(N) # number operator

        function N_expect(p) # p = [n]
            ρT = thermal_dm(N, p[1]; sparse = Val(true))
            return real(expect(N_op, ρT))
        end

        # Average photon number for thermal state
        n = rand(Float64)
        p = [n]

        # Use ForwardDiff.gradient to compute the gradient
        grad = ForwardDiff.gradient(N_expect, p)[1]

        # Compare the result
        @test isapprox(grad, 1.0; atol = 1.0e-6)
    end

    @testset "sesolve" verbose = true begin
        Ω = 1.0
        params = [Ω]

        my_f_sesolve_direct(params)
        my_f_sesolve_bsa_enzyme(params)
        my_f_sesolve_bsa_mooncake(params)

        grad_exact = [my_f_analytic_deriv(params[1])]

        @testset "ForwardDiff.jl" begin
            grad_qt = ForwardDiff.gradient(my_f_sesolve_direct, params)

            @test grad_qt ≈ grad_exact atol = 1.0e-6
        end

        @testset "Mooncake.jl" begin
            grad_cache = Mooncake.prepare_gradient_cache(my_f_sesolve_bsa_mooncake, params)
            _, grad_mooncake = Mooncake.value_and_gradient!!(grad_cache, my_f_sesolve_bsa_mooncake, params)
            @test grad_mooncake[2] ≈ grad_exact atol = 1.0e-6
        end

        @testset "Enzyme.jl" begin
            dparams = Enzyme.make_zero(params)
            Enzyme.autodiff(
                Enzyme.set_runtime_activity(Enzyme.Reverse),
                my_f_sesolve_bsa_enzyme,
                Active,
                Duplicated(params, dparams),
            )[1]

            @test dparams ≈ grad_exact atol = 1.0e-6
        end
    end

    @testset "mesolve" verbose = true begin
        Δ = 1.0
        F = 1.0
        γ = 1.0
        params = [Δ, F, γ]

        my_f_mesolve_direct(params)
        my_f_mesolve_bsa_enzyme(params)
        my_f_mesolve_bsa_mooncake(params)
        my_f_mesolve_assume_non_herm_bsa_enzyme(params)
        my_f_mesolve_assume_non_herm_bsa_mooncake(params)

        grad_exact_cache = Mooncake.prepare_gradient_cache(splat(n_ss), params)
        grad_exact = Mooncake.value_and_gradient!!(grad_exact_cache, splat(n_ss), params)[2][2]

        @testset "ForwardDiff.jl" begin
            grad_qt = ForwardDiff.gradient(my_f_mesolve_direct, params)
            @test grad_qt ≈ grad_exact atol = 1.0e-6
        end

        @testset "Mooncake.jl" begin
            grad_cache1 = Mooncake.prepare_gradient_cache(my_f_mesolve_bsa_mooncake, params)
            grad_cache2 = Mooncake.prepare_gradient_cache(my_f_mesolve_assume_non_herm_bsa_mooncake, params)
            _, grad_mooncake1 = Mooncake.value_and_gradient!!(grad_cache1, my_f_mesolve_bsa_mooncake, params)
            @test grad_mooncake1[2] ≈ grad_exact atol = 1.0e-6
            _, grad_mooncake2 = Mooncake.value_and_gradient!!(grad_cache2, my_f_mesolve_assume_non_herm_bsa_mooncake, params)
            @test grad_mooncake2[2] ≈ grad_exact atol = 1.0e-6
        end

        @testset "Enzyme.jl" begin
            dparams1 = Enzyme.make_zero(params)
            Enzyme.autodiff(
                Enzyme.set_runtime_activity(Enzyme.Reverse),
                my_f_mesolve_bsa_enzyme,
                Active,
                Duplicated(params, dparams1),
            )[1]

            # It doesn't work yet when assume_hermitian = Val(false)
            # dparams2 = Enzyme.make_zero(params)
            # Enzyme.autodiff(
            #     Enzyme.set_runtime_activity(Enzyme.Reverse),
            #     my_f_mesolve_assume_non_herm,
            #     Active,
            #     Duplicated(params, dparams2),
            # )[1]

            @test dparams1 ≈ grad_exact atol = 1.0e-6
            # @test dparams2 ≈ grad_exact atol = 1.0e-6
        end
    end
end

export AbstractLinearMap

@doc raw"""
    AbstractLinearMap{T, TS}

Represents a general linear map with element type `T` and size `TS`.

## Overview

A **linear map** is a transformation `L` that satisfies:

- **Additivity**: 
    ```math
    L(u + v) = L(u) + L(v)
    ```
- **Homogeneity**: 
    ```math
    L(cu) = cL(u)
    ```

It is typically represented as a matrix with dimensions given by `size`, and this abstract type helps to define this map when the matrix is not explicitly available.

## Methods

- `Base.eltype(A)`: Returns the element type `T`.
- `Base.size(A)`: Returns the size `A.size`.
- `Base.size(A, i)`: Returns the `i`-th dimension.

## Example

As an example, we now define the linear map used in the [`eigsolve_al`](@ref) function for Arnoldi-Lindblad eigenvalue solver:

```julia
struct ArnoldiLindbladIntegratorMap{T,TS,TI} <: AbstractLinearMap{T,TS}
    elty::Type{T}
    size::TS
    integrator::TI
end

function LinearAlgebra.mul!(y::AbstractVector, A::ArnoldiLindbladIntegratorMap, x::AbstractVector)
    reinit!(A.integrator, x)
    solve!(A.integrator)
    return copyto!(y, A.integrator.u)
end
```

where `integrator` is the ODE integrator for the time-evolution. In this way, we can diagonalize this linear map using the [`eigsolve`](@ref) function.
"""
abstract type AbstractLinearMap{T, TS} end

Base.eltype(A::AbstractLinearMap{T}) where {T} = T

Base.size(A::AbstractLinearMap) = A.size
Base.size(A::AbstractLinearMap, i::Int) = A.size[i]

# Contributing to QuantumToolbox.jl Development

You are most welcome to contribute to `QuantumToolbox.jl` development by forking this repository and sending pull requests (PRs), or filing bug reports at the issues page.

Contributors and users for `QuantumToolbox.jl` are invited to [![Zulip](https://img.shields.io/badge/Zulip%20Chat-join-6f73af.svg)](https://quantumtoolbox-jl.zulipchat.com/#narrow/stream/General) for questions, development discussions, and community updates.

You can also help out with users' questions, or discuss proposed changes for the entire QuTiP organization in the [![QuTiP-discussion](https://img.shields.io/badge/QuTiP%20discussion%20group-join-6f73af.svg)](https://groups.google.com/g/qutip).

For more information about contribution, including technical advice, please see the [![Doc-ColGuide](https://img.shields.io/badge/docs-Contributor's%20Guide-blue)](https://qutip.org/QuantumToolbox.jl/stable/resources/contributing).

# [Lindblad Master Equation Solver](@id doc-TE:Lindblad-Master-Equation-Solver)

```@setup mesolve
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

## [Von Neumann equation](@id doc-TE:Von-Neumann-equation)

While the evolution of the state vector in a closed quantum system is deterministic (as we discussed in the previous section: [Schrödinger Equation Solver](@ref doc-TE:Schrödinger-Equation-Solver)), open quantum systems are stochastic in nature. The effect of an environment on the system of interest is to induce stochastic transitions between energy levels, and to introduce uncertainty in the phase difference between states of the system. The state of an open quantum system is therefore described in terms of ensemble averaged states using the density matrix formalism. A density matrix ``\hat{\rho}`` describes a probability distribution of quantum states ``|\psi_n\rangle`` in a matrix representation, namely

```math
\hat{\rho} = \sum_n p_n |\psi_n\rangle\langle\psi_n|,
```

where ``p_n`` is the classical probability that the system is in the quantum state ``|\psi_n\rangle``. The time evolution of a density matrix ``\hat{\rho}`` is the topic of the remaining portions of this section.

The time evolution of the density matrix ``\hat{\rho}(t)`` under closed system dynamics is governed by the von Neumann equation: 

```math
\begin{equation}
\frac{d}{dt}\hat{\rho}(t) = -\frac{i}{\hbar}\left[\hat{H}, \hat{\rho}(t)\right],
\end{equation}
```

where ``[\cdot, \cdot]`` represents the commutator. The above equation is equivalent to the Schrödinger equation described in the [previous section](@ref doc-TE:Schrödinger-Equation-Solver) under the density matrix formalism.

In `QuantumToolbox`, given a Hamiltonian, we can calculate the unitary (non-dissipative) time-evolution of an arbitrary initial state using the `QuantumToolbox` time evolution problem [`mesolveProblem`](@ref) or directly call the function [`mesolve`](@ref). It evolves the density matrix ``\hat{\rho}(t)`` and evaluates the expectation values for a set of operators `e_ops` at each given time points, using an ordinary differential equation solver provided by the powerful julia package [`DifferentialEquation.jl`](https://docs.sciml.ai/DiffEqDocs/stable/).

```@example mesolve
H = 0.5 * sigmax()
state0 = basis(2, 0) # state vector
tlist = LinRange(0.0, 10.0, 20)

sol = mesolve(H, state0, tlist, e_ops = [sigmaz()])
```

!!! note "Use sesolve for improved efficiency"
    Here, if the Hamiltonian `H` is given as an [`Operator`](@ref), and the initial state `state0` is given as a state vector ``|\psi(0)\rangle`` (in the type of [`Ket`](@ref)), it will automatically call [`sesolve`](@ref) for improved efficiency.

The function returns [`TimeEvolutionSol`](@ref), as described in the previous section [Time Evolution Solutions](@ref doc-TE:Time-Evolution-Solutions).

```@example mesolve
sol.states
```

Here, only the final state is stored because the `states` will be saved depend on the keyword argument `saveat` in `kwargs`. If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). 

One can also specify `e_ops` and `saveat` separately:

```@example mesolve
tlist = [0, 5, 10]
state0 = ket2dm(basis(2, 0))  # density matrix
sol = mesolve(H, state0, tlist, e_ops = [sigmay()], saveat = tlist)
```

```@example mesolve
sol.expect
```

```@example mesolve
sol.states
```

Note that when the initial state `state0` is given as a density matrix ``|\psi(0)\rangle\langle\psi(0)|`` (in the type of [`Operator`](@ref)), the stored `states` will also be in the type of [`Operator`](@ref) (density matrix).

## [The Lindblad master equation](@id doc-TE:The-Lindblad-master-equation)

The standard approach for deriving the equations of motion for a system interacting with its environment is to expand the scope of the system to include the environment. The combined quantum system is then closed, and its evolution is also governed by the von Neumann equation

```math
\begin{equation}
\frac{d}{dt}\hat{\rho}_{\textrm{tot}}(t) = -\frac{i}{\hbar}\left[\hat{H}_{\textrm{tot}}, \hat{\rho}_{\textrm{tot}}(t)\right].
\end{equation}
```

Here, the total Hamiltonian

```math
\hat{H}_{\textrm{tot}} = \hat{H}_{\textrm{sys}} + \hat{H}_{\textrm{env}} + \hat{H}_{\textrm{int}},
```

includes the original system Hamiltonian ``\hat{H}_{\textrm{sys}}``, the Hamiltonian for the environment ``\hat{H}_{\textrm{env}}``, and a term representing the interaction between the system and its environment ``\hat{H}_{\textrm{int}}``. Since we are only interested in the dynamics of the system, we can, perform a partial trace over the environmental degrees of freedom, and thereby obtain a master equation for the motion of the original system density matrix ``\hat{\rho}_{\textrm{sys}}(t)=\textrm{Tr}_{\textrm{env}}[\hat{\rho}_{\textrm{tot}}(t)]``. The most general trace-preserving and completely positive form of this evolution is the Lindblad master equation for the reduced density matrix, namely

```math
\begin{equation}
\frac{d}{dt}\hat{\rho}_{\textrm{sys}}(t) = -\frac{i}{\hbar}\left[\hat{H}_{\textrm{sys}}, \hat{\rho}_{\textrm{sys}}(t)\right] + \sum_n \hat{C}_n \hat{\rho}_{\textrm{sys}}(t) \hat{C}_n^\dagger - \frac{1}{2} \hat{C}_n^\dagger \hat{C}_n \hat{\rho}_{\textrm{sys}}(t) - \frac{1}{2} \hat{\rho}_{\textrm{sys}}(t) \hat{C}_n^\dagger \hat{C}_n
\end{equation}
```

where ``\hat{C}_n \equiv \sqrt{\gamma_n}\hat{A}_n`` are the collapse operators, ``\hat{A}_n`` are the operators acting on the system in ``\hat{H}_{\textrm{int}}`` which describes the system-environment interaction, and ``\gamma_n`` are the corresponding rates. The derivation of Lindblad master equation may be found in several sources, and will not be reproduced here. Instead, we emphasize the approximations that are required to arrive at the above Lindblad master equation from physical arguments, and hence perform a calculation in `QuantumToolbox`:

- **Separability:** At ``t = 0``, there are no correlations between the system and environment, such that the total density matrix can be written as a tensor product, namely ``\hat{\rho}_{\textrm{tot}}(0)=\hat{\rho}_{\textrm{sys}}(0)\otimes\hat{\rho}_{\textrm{env}}(0)``.
- **Born approximation:** Requires: (i) the state of the environment does not significantly change as a result of the interaction with the system; (ii) the system and the environment remain separable throughout the evolution. These assumptions are justified if the interaction is weak, and if the environment is much larger than the system. In summary, ``\hat{\rho}_{\textrm{tot}}(t)\approx\hat{\rho}_{\textrm{sys}}(t)\otimes\hat{\rho}_{\textrm{env}}(0)``.
- **Markov approximation:** The time-scale of decay for the environment ``\tau_{\textrm{env}}`` is much shorter than the smallest time-scale of the system dynamics, i.e., ``\tau_{\textrm{sys}}\gg\tau_{\textrm{env}}``. This approximation is often deemed a “short-memory environment” as it requires the environmental correlation functions decay in a fast time-scale compared to those of the system.
- **Secular approximation:** Stipulates that elements in the master equation corresponding to transition frequencies satisfy ``|\omega_{ab}-\omega_{cd}| \ll 1/\tau_{\textrm{sys}}``, i.e., all fast rotating terms in the interaction picture can be neglected. It also ignores terms that lead to a small renormalization of the system energy levels. This approximation is not strictly necessary for all master-equation formalisms (e.g., the Block-Redfield master equation), but it is required for arriving at the Lindblad form in the above equation which is used in [`mesolve`](@ref).

For systems with environments satisfying the conditions outlined above, the Lindblad master equation governs the time-evolution of the system density matrix, giving an ensemble average of the system dynamics. In order to ensure that these approximations are not violated, it is important that the decay rates ``\gamma_n`` be smaller than the minimum energy splitting in the system Hamiltonian. Situations that demand special attention therefore include, for example, systems strongly coupled to their environment, and systems with degenerate or nearly degenerate energy levels.

What is new in the master equation compared to the Schrödinger equation (or von Neumann equation) are processes that describe dissipation in the quantum system due to its interaction with an environment. For example, evolution that includes incoherent processes such as relaxation and dephasing. These environmental interactions are defined by the operators ``\hat{A}_n`` through which the system couples to the environment, and rates ``\gamma_n`` that describe the strength of the processes.

In `QuantumToolbox`, the function [`mesolve`](@ref) can also be used for solving the master equation. This is done by passing a list of collapse operators (`c_ops`) as the fourth argument of the [`mesolve`](@ref) function in order to define the dissipation processes of the Lindblad master equation. As we mentioned above, each collapse operator ``\hat{C}_n`` is the product of ``\sqrt{\gamma_n}`` (the square root of the rate) and ``\hat{A}_n`` (operator which describes the dissipation process). 

Furthermore, `QuantumToolbox` solves the master equation in the [`SuperOperator`](@ref) formalism. That is, a Liouvillian [`SuperOperator`](@ref) will be generated internally in [`mesolve`](@ref) by the input system Hamiltonian ``\hat{H}_{\textrm{sys}}`` and the collapse operators ``\hat{C}_n``. One can also generate the Liouvillian [`SuperOperator`](@ref) manually for special purposes, and pass it as the first argument of the [`mesolve`](@ref) function. To do so, it is useful to read the section [Superoperators and Vectorized Operators](@ref doc:Superoperators-and-Vectorized-Operators), and also the docstrings of the following functions:
- [`spre`](@ref)
- [`spost`](@ref)
- [`sprepost`](@ref)
- [`liouvillian`](@ref)
- [`lindblad_dissipator`](@ref)

## [Example: Dissipative Spin dynamics](@id doc-TE:Example:Dissipative-Spin-dynamics)

Using the example with the dynamics of spin-``\frac{1}{2}`` from the previous section ([Schrödinger Equation Solver](@ref doc-TE:Schrödinger-Equation-Solver)), we can easily add a relaxation process (describing the dissipation of energy from the spin to the environment), by adding `[sqrt(γ) * sigmax()]` in the fourth parameter of the [`mesolve`](@ref) function.

```@example mesolve
H = 2 * π * 0.1 * sigmax()
ψ0 = basis(2, 0) # spin-up
tlist = LinRange(0.0, 10.0, 100)

γ = 0.05
c_ops = [sqrt(γ) * sigmax()]

sol = mesolve(H, ψ0, tlist, c_ops, e_ops = [sigmaz(), sigmay()])
```

We can therefore plot the expectation values:

```@example mesolve
expt_z = real(sol.expect[1,:])
expt_y = real(sol.expect[2,:])

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = "Time", ylabel = "Expectation values")
lines!(ax, tlist, expt_z, label = L"\langle\hat{\sigma}_z\rangle", linestyle = :solid)
lines!(ax, tlist, expt_y, label = L"\langle\hat{\sigma}_y\rangle", linestyle = :dash)

axislegend(ax, position = :rt)

fig
```

## [Example: Harmonic oscillator in thermal bath](@id doc-TE:Example:Harmonic-oscillator-in-thermal-bath)

Consider a harmonic oscillator (single-mode cavity) couples to a thermal bath. If the single-mode cavity initially is in a `10`-photon [`fock`](@ref) state, the dynamics is calculated with the following code:

```@example mesolve
# Define parameters
N = 20  # number of basis states to consider
a = destroy(N)
H = a' * a
ψ0 = fock(N, 10)  # initial state
κ = 0.1  # coupling to oscillator
n_th = 2 # temperature with average of 2 excitations
tlist = LinRange(0, 50, 100)

# collapse operators 
c_ops = [
    sqrt(κ * (n_th + 1)) * a, # emission
    sqrt(κ *  n_th     ) * a' # absorption
]

# find expectation value for particle number
e_ops = [a' * a]

sol = mesolve(H, ψ0, tlist, c_ops, e_ops=e_ops)
Num = real(sol.expect[1, :])

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], 
    title = L"Decay of Fock state $|10\rangle$ in a thermal environment with $\langle n\rangle=2$",
    xlabel = "Time", 
    ylabel = "Number of excitations",
)
lines!(ax, tlist, Num)

fig
```

## [Example: Two-level atom coupled to dissipative single-mode cavity](@id doc-TE:Example:Two-level-atom-coupled-to-dissipative-single-mode-cavity)

Consider a two-level atom coupled to a dissipative single-mode cavity through a dipole-type interaction, which supports a coherent exchange of quanta between the two systems. If the atom initially is in its ground state and the cavity in a `5`-photon [`fock`](@ref) state, the dynamics is calculated with the following code:

!!! note "Generate Liouviilian superoperator manually"
    In this example, we demonstrate how to generate the Liouvillian [`SuperOperator`](@ref) manually and pass it as the first argument of the [`mesolve`](@ref) function.

```@example mesolve
# two-level atom
σm = tensor(destroy(2), qeye(10))
H_a = 2 * π * σm' * σm

# dissipative single-mode cavity
γ = 0.1 # dissipation rate
a  = tensor(qeye(2), destroy(10))
H_c = 2 * π * a' * a
c_ops = [sqrt(γ) * a]

# coupling between two-level atom and single-mode cavity
g = 0.25 # coupling strength
H_I = 2 * π * g * (σm * a' + σm' * a)

ψ0 = tensor(basis(2,0), fock(10, 5)) # initial state
tlist = LinRange(0.0, 10.0, 200)

# generate Liouvillian superoperator manually
L = liouvillian(H_a + H_c + H_I, c_ops)
sol = mesolve(L, ψ0, tlist, e_ops=[σm' * σm, a' * a])

# expectation value of Number operator
N_atom   = real(sol.expect[1,:])
N_cavity = real(sol.expect[2,:])

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = "Time", ylabel = "Expectation values")
lines!(ax, tlist, N_atom, label = "atom excitation probability", linestyle = :solid)
lines!(ax, tlist, N_cavity, label = "cavity photon number", linestyle = :dash)

axislegend(ax, position = :rt)

fig
```

```@meta
CurrentModule = QuantumToolbox
```

# Brief Example

We now provide a brief example to demonstrate the similarity between [`QuantumToolbox.jl`](https://github.com/qutip/QuantumToolbox.jl) and [`QuTiP`](https://github.com/qutip/qutip).

## CPU Computation

Let's consider a quantum harmonic oscillator with a Hamiltonian given by:

```math
\hat{H} = \omega \hat{a}^\dagger \hat{a}
```

where ``\hat{a}`` and ``\hat{a}^\dagger`` are the annihilation and creation operators, respectively. We can define the Hamiltonian as follows:

```julia
using QuantumToolbox

N = 20 # cutoff of the Hilbert space dimension
ω = 1.0 # frequency of the harmonic oscillator

a = destroy(N) # annihilation operator

H = ω * a' * a
```

We now introduce some losses in a thermal environment, described by the Lindblad master equation:

```math
\frac{d \hat{\rho}}{dt} = -i [\hat{H}, \hat{\rho}] + \gamma \mathcal{D}[\hat{a}] \hat{\rho}
```

where ``\hat{\rho}`` is the density matrix, ``\gamma`` is the damping rate, and ``\mathcal{D}[\hat{a}]`` is the Lindblad dissipator, defined as:

```math
\mathcal{D}[\hat{a}]\hat{\rho} = \hat{a}\hat{\rho}\hat{a}^\dagger - \frac{1}{2}\hat{a}^\dagger\hat{a}\hat{\rho} - \frac{1}{2}\hat{\rho}\hat{a}^\dagger\hat{a}
```

!!! note "Lindblad master equation"
    See [here](@ref doc-TE:Lindblad-Master-Equation-Solver) for more details about Lindblad master equation.

We now compute the time evolution of the system using the [`mesolve`](@ref) function, starting from the initial state ``\ket{\psi (0)} = \ket{3}``:

```julia
γ = 0.1 # damping rate

ψ0 = fock(N, 3) # initial state

tlist = range(0, 10, 100) # time list

c_ops = [sqrt(γ) * a]
e_ops = [a' * a]

sol = mesolve(H, ψ0, tlist, c_ops, e_ops = e_ops)
```

We can extract the expectation value of the number operator ``\hat{a}^\dagger \hat{a}`` with the command `sol.expect`, and the states with the command `sol.states`.

## GPU Computation

!!! note "Extension for CUDA.jl"
    `QuantumToolbox.jl` provides an extension to support GPU computation. To trigger the extension, you need to install and import [`CUDA.jl`](https://github.com/JuliaGPU/CUDA.jl) together with `QuantumToolbox.jl`. See [here](@ref doc:CUDA) for more details.

```julia
using QuantumToolbox
using CUDA
CUDA.allowscalar(false) # Avoid unexpected scalar indexing
```

We can easily pass the computation to the GPU, by simply passing all the [`QuantumObject`](@ref)s to the GPU:

```julia
a_gpu = cu(destroy(N)) # The only difference in the code is the cu() function

H_gpu = ω * a_gpu' * a_gpu

ψ0_gpu = cu(fock(N, 3))

c_ops = [sqrt(γ) * a_gpu]
e_ops = [a_gpu' * a_gpu]

sol = mesolve(H_gpu, ψ0_gpu, tlist, c_ops, e_ops = e_ops)
```

# [Plotting on the Bloch Sphere](@id doc:Plotting-on-the-Bloch-Sphere)

```@setup Bloch_sphere_rendering
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

## Introduction

When studying the dynamics of a two-level system, it's often convenient to visualize the state of the system by plotting the state vector or density matrix on the Bloch sphere.

In [`QuantumToolbox`](https://qutip.org/QuantumToolbox.jl/), this can be done using the [`Bloch`](@ref) or [`plot_bloch`](@ref) methods that provide same syntax as [QuTiP](https://qutip.readthedocs.io/en/stable/guide/guide-bloch.html).

## Create a Bloch Sphere

In [`QuantumToolbox`](https://qutip.org/QuantumToolbox.jl/), creating a [`Bloch`](@ref) sphere is accomplished by calling either:

!!! note "Import plotting libraries"
    Remember to import plotting libraries first. Here, we demonstrate the functionalities with [`CairoMakie.jl`](https://docs.makie.org/stable/explanations/backends/cairomakie.html).

```@example Bloch_sphere_rendering
b = Bloch()
```

which will load an instance of [`Bloch`](@ref). Before getting into the details of these objects, we can simply plot the blank [`Bloch`](@ref) sphere associated with these instances via:

```@example Bloch_sphere_rendering
fig, _ = render(b)
fig
```

See the [API documentation for Bloch sphere](@ref doc-API:Bloch-Sphere) for a full list of other available functions.

## Add a single data point

As an example, we can add a single data point via [`add_points!`](@ref):

```@example Bloch_sphere_rendering
pnt = [1 / sqrt(3), 1 / sqrt(3), 1 / sqrt(3)]
add_points!(b, pnt)
fig, _ = render(b)
fig
```

## Add a single vector

Add a single vector via  [`add_vectors!`](@ref):

```@example Bloch_sphere_rendering
vec = [0, 1, 0]
add_vectors!(b, vec)
fig, _ = render(b)
fig
```

## Add a single quantum state

Add another vector corresponding to the ``|0\rangle`` state:

```@example Bloch_sphere_rendering
z0 = basis(2, 0)
add_states!(b, z0)
fig, _ = render(b)
fig
```

## Add multiple data

We can also plot multiple points, vectors, and states at the same time by passing arrays instead of individual elements via [`add_points!`](@ref), [`add_vectors!`](@ref), and [`add_states!`](@ref), respectively. Before giving an example, we can use [`clear!`](@ref) to remove the current data from our [`Bloch`](@ref) sphere instead of creating a new instance:

```@example Bloch_sphere_rendering
clear!(b)
fig, _ = render(b)
fig
```

Now on the same [`Bloch`](@ref) sphere, we can plot the three states via [`add_states!`](@ref) associated with the `x`, `y`, and `z` directions:

```@example Bloch_sphere_rendering
x = basis(2, 0) + basis(2, 1)
y = basis(2, 0) + im * basis(2, 1)
z = basis(2, 0)
add_states!(b, [x, y, z])
fig, _ = render(b)
fig
```

!!! note "State normalization"
    The function [`add_states!`](@ref) will automatically normalize the given quantum state(s), while [`add_vectors!`](@ref) does not normalize the given vectors.

A similar method works for adding vectors:

```@example Bloch_sphere_rendering
clear!(b)
vecs = [[1, 0, 0], [0, 1, 0], [0, 0, 1]]
add_vectors!(b, vecs)
fig, _ = render(b)
fig
```

# Add lines and arcs

You can also add lines and arcs via [`add_line!`](@ref) and [`add_arc!`](@ref) respectively:

```@example Bloch_sphere_rendering
add_line!(b, x, y)
add_arc!(b, y, z)
fig, _ = render(b)
fig
```

## Add multiple points

Adding multiple points to the [`Bloch`](@ref) sphere works slightly differently than adding multiple states or vectors. For example, lets add a set of `20` points around the equator (after calling [`clear!`](@ref)):

```@example Bloch_sphere_rendering
clear!(b)

th = LinRange(0, 2π, 20)
xp = cos.(th)
yp = sin.(th)
zp = zeros(20)
pnts = [xp, yp, zp]
add_points!(b, pnts)
fig, lscene = render(b)
fig
```

Notice that, in contrast to states or vectors, each point remains the same color as the initial point. This is because adding multiple data points using [`add_points!`](@ref) is interpreted, by default, to correspond to a single data point (single qubit state) plotted at different times. This is very useful when visualizing the dynamics of a qubit. If we want to plot additional qubit states we can call additional [`add_points!`](@ref) function:

```@example Bloch_sphere_rendering
xz = zeros(20)
yz = sin.(th)
zz = cos.(th)
add_points!(b, [xz, yz, zz])
fig, lscene = render(b)
fig
```

The color and shape of the data points is varied automatically by [`Bloch`](@ref). Notice how the color and point markers change for each set of data. Again, we have had to call [`add_points!`](@ref) twice because adding more than one set of multiple data points is not supported by the [`add_points!`](@ref) function.

What if we want to vary the color of our points. We can tell [`Bloch`](@ref) to vary the color of each point according to the colors listed in the `point_color` field (see [Configuring the Bloch sphere](@ref doc:Configuring-the-Bloch-sphere) below). Again, after [`clear!`](@ref):

```@example Bloch_sphere_rendering
clear!(b)

xp = cos.(th)
yp = sin.(th)
zp = zeros(20)
pnts = [xp, yp, zp]
add_points!(b, pnts, meth=:m) # add `meth=:m` to signify 'multi' colored points
fig, lscene = render(b)
fig
```

Now, the data points cycle through a variety of predefined colors. Now lets add another set of points, but this time we want the set to be a single color, representing say a qubit going from the ``|0\rangle`` state to the ``|1\rangle`` state in the `y-z` plane:

```@example Bloch_sphere_rendering
pnts = [xz, yz, zz]
add_points!(b, pnts) # no `meth=:m`
fig, lscene = render(b)
fig
```

## [Configuring the Bloch sphere](@id doc:Configuring-the-Bloch-sphere)

At the end of the last section we saw that the colors and marker shapes of the data plotted on the Bloch sphere are automatically varied according to the number of points and vectors added. But what if you want a different choice of color, or you want your sphere to be purple with different axes labels? Well then you are in luck as the [`Bloch`](@ref) structure has many fields which one can control. Assuming `b = Bloch()`:

### Data storage

| **Field** | **Description** | **Default setting** |
|:----------|:----------------|:--------------------|
| `b.points` | Points to plot on the Bloch sphere (3D coordinates) | `Vector{Matrix{Float64}}()` (empty) |
| `b.vectors` | Vectors to plot on the Bloch sphere | `Vector{Vector{Float64}}()` (empty) |
| `b.lines` | Lines to draw on the sphere with each line given as `([start_pt, end_pt], line_format)` | `Vector{Tuple{Vector{Vector{Float64}},String}}()` (empty) |
| `b.arcs` | Arcs to draw on the sphere | `Vector{Vector{Vector{Float64}}}()` (empty) |

### Properties

| **Field** | **Description** | **Default setting** |
|:----------|:----------------|:--------------------|
| `b.font_color` | Color of axis labels and text | `"black"` |
| `b.font_size` | Font size for labels | `20` |
| `b.frame_alpha` | Transparency of the wire frame | `0.2` |
| `b.frame_color` | Color of the wire frame | `"gray"` |
| `b.frame_width` | Width of wire frame | `1.0` |
| `b.point_default_color` | Default color cycle for points | `["blue", "red", "green", "#CC6600"]` |
| `b.point_color` | List of colors for Bloch point markers to cycle through | `Union{Nothing,String}[]` |
| `b.point_marker` | List of point marker shapes to cycle through | `[:circle, :rect, :diamond, :utriangle]` |
| `b.point_size` | List of point marker sizes (not all markers look the same size when plotted) | `[5.5, 6.2, 6.5, 7.5]` |
| `b.point_style` | List of marker styles | `Symbol[]` |
| `b.point_alpha` | List of marker transparencies | `Float64[]` |
| `b.sphere_color` | Color of Bloch sphere surface | `0.2` |
| `b.sphere_alpha` | Transparency of sphere surface | `"#FFDDDD"` |
| `b.vector_color` | Colors for vectors | `["green", "#CC6600", "blue", "red"]` |
| `b.vector_width` | Width of vectors | `0.02` |
| `b.vector_tiplength` | Length of vector arrow head | `0.08` |
| `b.vector_tipradius` | Radius of vector arrow head | `0.05` |
| `b.view` | Azimuthal and elevation viewing angles in degrees | `[30, 30]` |
| `b.xlabel` | Labels for x-axis | `[L"x", ""]` (``+x`` and ``-x``) |
| `b.xlpos` | Positions of x-axis labels | `[1.2, -1.2]` |
| `b.ylabel` | Labels for y-axis | `[L"y", ""]` (``+y`` and ``-y``) |
| `b.ylpos` | Positions of y-axis labels | `[1.2, -1.2]` |
| `b.zlabel` | Labels for z-axis | `[L"\|0\rangle", L"\|1\rangle]"` (``+z`` and ``-z``) |
| `b.zlpos` | Positions of z-axis labels | `[1.2, -1.2]` |

These properties can also be accessed via the `print` command:

```@example Bloch_sphere_rendering
b = Bloch()
print(b)
```

## Animating with the Bloch sphere

The [`Bloch`](@ref) structure was designed from the outset to generate animations. To animate a set of vectors or data points, the basic idea is: plot the data at time ``t_1``, save the sphere, clear the sphere, plot data at ``t_2``, and so on. The easiest way to animate data on the Bloch sphere is to use the `record` function provided by [`Makie.jl`](https://docs.makie.org/stable/). We will demonstrate this functionality with the following example: the decay of a qubit on the Bloch sphere.

```@example Bloch_sphere_rendering
# system parameters
ω = 2π
θ = 0.2π
n_th = 0.5 # temperature
γ1 = 0.5
γ2 = 0.2

# operators and the Hamiltonian
sx = sigmax()
sy = sigmay()
sz = sigmaz()
sm = sigmam()
H = ω * (cos(θ) * sz + sin(θ) * sx)

# collapse operators
c_op_list = (
    √(γ1 * (n_th + 1)) * sm,
    √(γ1 * n_th) * sm',
    √γ2 * sz
)

# solving evolution
ψ0 = basis(2, 0)
tlist = LinRange(0, 4, 250)
sol = mesolve(H, ψ0, tlist, c_op_list, e_ops = (sx, sy, sz), progress_bar = Val(false))
```

To animate a set of vectors or data points, we use the `record` function provided by [`Makie.jl`](https://docs.makie.org/stable/):

```@example Bloch_sphere_rendering
# expectation values
x = real(sol.expect[1,:])
y = real(sol.expect[2,:])
z = real(sol.expect[3,:])

# create Bloch sphere
b = Bloch()
b.view = [50,30]
fig, lscene = render(b)

# save animation
record(fig, "qubit_decay.mp4", eachindex(tlist), framerate = 20) do idx
    clear!(b)
    add_vectors!(b, [sin(θ), 0, cos(θ)])
    add_points!(b, [x[1:idx], y[1:idx], z[1:idx]])
    render(b, location = lscene)
end
nothing # hide
```

```@raw html
<video autoplay loop muted playsinline controls src="./qubit_decay.mp4" />
```

!!! note
    Here, we set the keyword argument `location = lscene` in the last `render` function to update the existing Bloch sphere without creating new `Figure` and `LScene`. This is efficient when drawing animations.

```@meta
CurrentModule = QuantumToolbox

DocTestSetup = quote
    using LinearAlgebra
    using SparseArrays
    using QuantumToolbox
end
```

# [API](@id doc-API)

**Table of contents**

[[toc]] <!-- the level setting is in ".vitepress/config.mts" -->

## [Quantum object (Qobj) and type](@id doc-API:Quantum-object-and-type)

```@docs
Dimensions
AbstractSpace
AbstractSuperSpace
Space
TensorSpace
LiouvilleSpace
EnrSpace
AbstractQuantumObject
Bra
Ket
Operator
OperatorBra
OperatorKet
SuperOperator
QuantumObject
QuantumObjectEvolution
Base.size
Base.eltype
Base.length
SciMLOperators.cache_operator
```

## [Qobj boolean functions](@id doc-API:Qobj-boolean-functions)

```@docs
isbra
isket
isoper
isoperbra
isoperket
issuper
LinearAlgebra.ishermitian
LinearAlgebra.issymmetric
LinearAlgebra.isposdef
isunitary
SparseArrays.issparse
SciMLOperators.iscached
SciMLOperators.isconstant
```

## [Qobj arithmetic and attributes](@id doc-API:Qobj-arithmetic-and-attributes)

```@docs
Base.zero
Base.one
Base.conj
LinearAlgebra.transpose
LinearAlgebra.adjoint
LinearAlgebra.dot
LinearAlgebra.sqrt
LinearAlgebra.log
LinearAlgebra.exp
LinearAlgebra.sin
LinearAlgebra.cos
LinearAlgebra.tr
LinearAlgebra.svdvals
LinearAlgebra.norm
LinearAlgebra.normalize
LinearAlgebra.normalize!
LinearAlgebra.inv
LinearAlgebra.diag
proj
ptrace
purity
SparseArrays.permute
tidyup
tidyup!
get_data
get_coherence
partial_transpose
```

## [Qobj eigenvalues and eigenvectors](@id doc-API:Qobj-eigenvalues-and-eigenvectors)

```@docs
EigsolveResult
eigenenergies
eigenstates
LinearAlgebra.eigen
LinearAlgebra.eigvals
eigsolve
eigsolve_al
```

## [Qobj manipulation](@id doc-API:Qobj-manipulation)

```@docs
ket2dm
expect
variance
LinearAlgebra.kron
to_dense
to_sparse
vec2mat
mat2vec
```

## [Generate states and operators](@id doc-API:Generate-states-and-operators)

```@docs
zero_ket
fock
basis
coherent
rand_ket
fock_dm
coherent_dm
thermal_dm
maximally_mixed_dm
rand_dm
enr_fock
enr_thermal_dm
spin_state
spin_coherent
bell_state
singlet_state
triplet_states
w_state
ghz_state
rand_unitary
sigmap
sigmam
sigmax
sigmay
sigmaz
jmat
spin_Jx
spin_Jy
spin_Jz
spin_Jm
spin_Jp
spin_J_set
destroy
create
displace
squeeze
num
QuantumToolbox.position
QuantumToolbox.momentum
phase
fdestroy
fcreate
enr_destroy
enr_identity
tunneling
qft
eye
projection
commutator
spre
spost
sprepost
lindblad_dissipator
```

## [Synonyms of functions for Qobj](@id doc-API:Synonyms-of-functions-for-Qobj)
```@docs
Qobj
QobjEvo
shape
isherm
trans
dag
matrix_element
unit
tensor
⊗
qeye
vector_to_operator
operator_to_vector
sqrtm
logm
expm
sinm
cosm
qeye_like
qzero_like
```

## [Time evolution](@id doc-API:Time-evolution)

```@docs
TimeEvolutionProblem
TimeEvolutionSol
TimeEvolutionMCSol
TimeEvolutionStochasticSol
average_states
average_expect
std_expect
sesolveProblem
mesolveProblem
mcsolveProblem
mcsolveEnsembleProblem
ssesolveProblem
ssesolveEnsembleProblem
smesolveProblem
smesolveEnsembleProblem
sesolve
mesolve
mcsolve
ssesolve
smesolve
sesolve_map
mesolve_map
dfd_mesolve
liouvillian
liouvillian_dressed_nonsecular
bloch_redfield_tensor
brterm
brmesolve
```

### [Steady State Solvers](@id doc-API:Steady-State-Solvers)

```@docs
steadystate
steadystate_fourier
SteadyStateDirectSolver
SteadyStateEigenSolver
SteadyStateLinearSolver
SteadyStateODESolver
SSFloquetEffectiveLiouvillian
```

### [Dynamical Shifted Fock method](@id doc-API:Dynamical-Shifted-Fock-method)

```@docs
dsf_mesolve
dsf_mcsolve
```

### [Low-rank time evolution](@id doc-API:Low-rank-time-evolution)

```@docs
TimeEvolutionLRSol
lr_mesolveProblem
lr_mesolve
```

## [Correlations and Spectrum](@id doc-API:Correlations-and-Spectrum)

```@docs
correlation_3op_2t
correlation_3op_1t
correlation_2op_2t
correlation_2op_1t
spectrum_correlation_fft
spectrum
ExponentialSeries
PseudoInverse
Lanczos
```

## [Entropy and Metrics](@id doc-API:Entropy-and-Metrics)

```@docs
entropy_vn
entropy_relative
entropy_linear
entropy_mutual
entropy_conditional
entanglement
concurrence
negativity
fidelity
tracedist
hilbert_dist
hellinger_dist
bures_dist
bures_angle
```

## [Spin Lattice](@id doc-API:Spin-Lattice)

```@docs
Lattice
multisite_operator
DissipativeIsing
```

## [Symmetries and Block Diagonalization](@id doc-API:Symmetries-and-Block-Diagonalization)

```@docs
block_diagonal_form
BlockDiagonalForm
```

## [Miscellaneous](@id doc-API:Miscellaneous)

```@docs
wigner
```

## [Linear Maps](@id doc-API:Linear-Maps)

```@docs
AbstractLinearMap
```

## [Utility functions](@id doc-API:Utility-functions)

```@docs
QuantumToolbox.settings
QuantumToolbox.versioninfo
QuantumToolbox.about
QuantumToolbox.pkginfo
QuantumToolbox.sysinfo
QuantumToolbox.cite
gaussian
n_thermal
PhysicalConstants
convert_unit
row_major_reshape
get_size
meshgrid
enr_state_dictionaries
```

## [Visualization](@id doc-API:Visualization)

```@docs
plot_wigner
plot_fock_distribution
matrix_heatmap
matrix_histogram
```

### [Bloch Sphere](@id doc-API:Bloch-Sphere)

```@docs
Bloch
plot_bloch
render
add_points!
add_vectors!
add_line!
add_arc!
add_states!
clear!
```

# [Acknowledgements](@id doc:Acknowledgements)

## [Fundings](@id doc:Fundings)

`QuantumToolbox.jl` is supported by the [Unitary Fund](https://unitary.fund), a grant program for quantum technology projects.

```@raw html
<div align="center">
  <a href="https://unitary.fund" target="about:blank">
    <img src="https://raw.githubusercontent.com/unitaryfund/unitary.fund/refs/heads/main/src/assets/svg/logo.svg" alt="Unitary Fund logo" width="200">
  </a>
</div>
```

`QuantumToolbox.jl` is partially supported by

```@raw html
<div align="center">
  <a href="https://www.epfl.ch" target="about:blank"><img src="/org-logo/EPFL.svg" style="margin:5px;" alt="EPFL logo" width="200"></a> 
  <a href="https://www.epfl.ch/research/domains/quantum-center" target="about:blank"><img src="/org-logo/EPFL-QSE.svg" style="margin:5px;" alt="EPFL QSE logo" width="200"></a> 

  <a href="https://www.ncku.edu.tw" target="about:blank"><img src="/org-logo/NCKU.png" style="margin:5px;" alt="NCKU logo" width="250"></a> 
  <a href="https://qfort.ncku.edu.tw" target="about:blank"><img src="/org-logo/QFort.png" style="margin:5px;" alt="QFort logo" width="250"></a> 
  <a href="https://www.nstc.gov.tw" target="about:blank"><img src="/org-logo/NSTC.png" style="margin:5px;" alt="NSTC logo" width="250"></a> 

  <a href="https://dml.riken.jp" target="about:blank"><img src="/org-logo/RIKEN.png" style="margin:5px;" alt="RIKEN logo" width="200"></a> 
  <a href="https://rqc.riken.jp" target="about:blank"><img src="/org-logo/RIKEN-RQC.svg" style="margin:5px;" alt="RIKEN RQC logo" width="200"></a>
  <a href="https://www.jst.go.jp/moonshot" target="about:blank"><img src="/org-logo/JST-Moonshot.png" style="margin:5px;" alt="JST Moonshot logo" width="200"></a>
</div>
```

## [Other Acknowledgements](@id doc:Other-Acknowledgements)

We are also grateful to the [Zulip](https://zulip.com) team for providing a free chat service for open-source projects.

```@raw html
<div align="center">
  <a href="https://zulip.com" target="about:blank">
    <img src="https://zulip.com/static/images/logo/zulip-org-logo.svg" alt="Zulip logo" width="200">
  </a>
</div>
```

# [Manipulating States and Operators](@id doc:Manipulating-States-and-Operators)

## Introduction
In the previous guide section [Basic Operations on Quantum Objects](@ref doc:Qobj), we saw how to create states and operators, using the functions built into `QuantumToolbox`. In this portion of the guide, we will look at performing basic operations with states and operators. For more detailed demonstrations on how to use and manipulate these objects, see the examples given in the tutorial section.

```@setup states_and_operators
using QuantumToolbox
```

## [State Vectors (kets or bras)](@id doc:State-vectors)
Here we begin by creating a Fock [`basis`](@ref) (or [`fock`](@ref)) vacuum state vector ``|0\rangle`` with in a Hilbert space with `5` number states, from `0` to `4`:

```@example states_and_operators
vac = basis(5, 0)
```

and then create a lowering operator ``\hat{a}`` corresponding to `5` number states using the [`destroy`](@ref) function:

```@example states_and_operators
a = destroy(5)
```

Now lets apply the lowering operator ``\hat{a}`` to our vacuum state `vac`:

```@example states_and_operators
a * vac
```

We see that, as expected, the vacuum is transformed to the zero vector. A more interesting example comes from using the `adjoint` of the lowering operator ``\hat{a}``, the raising operator ``\hat{a}^\dagger``:

```@example states_and_operators
a' * vac
```

The raising operator has in indeed raised the state `vac` from the vacuum to the ``|1\rangle`` state. Instead of using the `adjoint` method to raise the state, we could have also used the built-in [`create`](@ref) function to make a raising operator:

```@example states_and_operators
ad = create(5)
ad * vac
```

which does the same thing. We can raise the vacuum state more than once by successively apply the raising operator:

```@example states_and_operators
ad * ad * vac
```

or just taking the square of the raising operator ``\left(\hat{a}^\dagger\right)^2``:

```@example states_and_operators
ad^2 * vac
```

Applying the raising operator twice gives the expected ``\sqrt{n+1}`` dependence. We can use the product of ``\hat{a}^\dagger \hat{a}`` to also apply the number operator to the state vector `vac`:

```@example states_and_operators
ad * a * vac
```

or on the ``|1\rangle`` state:

```@example states_and_operators
ad * a * (ad * vac)
```

or on the ``|2\rangle`` state:

```@example states_and_operators
ad * a * (ad^2 * vac)
```

Notice how in this last example, application of the number operator does not give the expected value ``n=2``, but rather ``2\sqrt{2}``. This is because this last state is not normalized to unity as ``\hat{a}^\dagger|n\rangle=\sqrt{n+1}|n+1\rangle``. Therefore, we should [`normalize`](@ref) (or use [`unit`](@ref)) our vector first:

```@example states_and_operators
ad * a * normalize(ad^2 * vac)
```

Since we are giving a demonstration of using states and operators, we have done a lot more work than we should have. For example, we do not need to operate on the vacuum state to generate a higher number Fock state. Instead we can use the [`basis`](@ref) (or [`fock`](@ref)) function to directly obtain the required state:

```@example states_and_operators
ket = basis(5, 2)
```

Notice how it is automatically normalized. We can also use the built in number operator [`num`](@ref):

```@example states_and_operators
n = num(5)
```

Therefore, instead of `ad * a * normalize(ad^2 * vac)`, we have:

```@example states_and_operators
n * ket
```

We can also create superpositions of states:

```@example states_and_operators
ket = normalize(basis(5, 0) + basis(5, 1))
```

where we have used the `normalize` function again to normalize the state. Apply the number operator again:

```@example states_and_operators
n * ket
```

We can also create coherent states and squeezed states by applying the [`displace`](@ref) and [`squeeze`](@ref) functions to the vacuum state:

```@example states_and_operators
vac = basis(5, 0)

d = displace(5, 1im)

s = squeeze(5, 0.25 + 0.25im)

d * vac
```

```@example states_and_operators
d * s * vac
```

Of course, displacing the vacuum gives a coherent state, which can also be generated using the built in [`coherent`](@ref) function.

## [Density matrices](@id doc:Density-matrices)

One of the main purpose of `QuantumToolbox` is to explore the dynamics of open quantum systems, where the most general state of a system is no longer a state vector, but rather a density matrix. Since operations on density matrices operate identically to those of vectors, we will just briefly highlight creating and using these structures.

The simplest density matrix is created by forming the outer-product ``|\psi\rangle\langle\psi|`` of a ket vector:

```@example states_and_operators
ket = basis(5, 2)
ket * ket'
```

A similar task can also be accomplished via the [`fock_dm`](@ref) or [`ket2dm`](@ref) functions:

```@example states_and_operators
fock_dm(5, 2)
```

```@example states_and_operators
ket2dm(ket)
```

If we want to create a density matrix with equal classical probability of being found in the ``|2\rangle`` or ``|4\rangle`` number states, we can do the following:

```@example states_and_operators
0.5 * fock_dm(5, 2) + 0.5 * fock_dm(5, 4) # with fock_dm
0.5 * ket2dm(basis(5, 2)) + 0.5 * ket2dm(basis(5, 4)) # with ket2dm
```

There are also several other built-in functions for creating predefined density matrices, for example [`coherent_dm`](@ref) and [`thermal_dm`](@ref) which create coherent state and thermal state density matrices, respectively.

```@example states_and_operators
coherent_dm(5, 1.25)
```

```@example states_and_operators
thermal_dm(5, 1.25)
```

`QuantumToolbox` also provides a set of distance metrics for determining how close two density matrix distributions are to each other. For example, [`fidelity`](@ref), and trace distance ([`tracedist`](@ref)) are included. For more metric functions, see section [Entropy and Metrics](@ref doc-API:Entropy-and-Metrics) in the API page.

```@example states_and_operators
x = coherent_dm(5, 1.25)

y = coherent_dm(5, 1.25im)

z = thermal_dm(5, 0.125)

fidelity(x, y)
```
Note that the definition of [`fidelity`](@ref) here is from [Nielsen-Chuang2011](@citet). It is the square root of the fidelity defined in [Jozsa1994](@citet). We also know that for two pure states, the trace distance (``T``) and the fidelity (``F``) are related by ``T = \sqrt{1-F^2}``:

```@example states_and_operators
tracedist(x, y) ≈ sqrt(1 - (fidelity(x, y))^2)
```

For a pure state and a mixed state, ``1 - F \leq T`` which can also be verified:

```@example states_and_operators
1 - fidelity(x, z) < tracedist(x, z)
```

## [Two-level systems (Qubits)](@id doc:Two-level-systems)

Having spent a fair amount of time on basis states that represent harmonic oscillator states, we now move on to qubit, or two-level quantum systems (for example a spin-``1/2``). To create a state vector corresponding to a qubit system, we use the same basis, or fock, function with only two levels:

```@example states_and_operators
spin = basis(2, 0)
```

Now at this point one may ask how this state is different than that of a harmonic oscillator in the vacuum state truncated to two energy levels?

```@example states_and_operators
vac = basis(2, 0)
```

At this stage, there is no difference. This should not be surprising as we called the exact same function twice. The difference between the two comes from the action of the spin operators [`sigmax`](@ref), [`sigmay`](@ref), [`sigmaz`](@ref), [`sigmap`](@ref), and [`sigmam`](@ref) on these two-level states. For example, if `vac` corresponds to the vacuum state of a harmonic oscillator, then, as we have already seen, we can use the raising operator ([`create`](@ref)) to get the ``|1\rangle`` state:

```@example states_and_operators
create(2) * vac
```

For a spin system, the operator analogous to the raising operator is the ``\hat{\sigma}_+`` operator [`sigmap`](@ref). Applying on the spin state gives:

```@example states_and_operators
sigmap() * spin
```

Now we see the difference! The [`sigmap`](@ref) operator acting on the spin state returns the zero vector. Why is this? To see what happened, let us use the ``\hat{\sigma}_z`` ([`sigmaz`](@ref)) operator:

```@example states_and_operators
sigmaz()
```

```@example states_and_operators
sigmaz() * spin
```

```@example states_and_operators
spin2 = basis(2, 1)
```

```@example states_and_operators
sigmaz() * spin2
```

The answer is now apparent. Since the `QuantumToolbox` [`sigmaz`](@ref) function uses the standard ``Z``-basis representation of the ``\hat{\sigma}_z`` spin operator, the `spin` state corresponds to the ``|\uparrow\rangle`` state of a two-level spin system while `spin2` gives the ``|\downarrow\rangle`` state. Therefore, in our previous example `sigmap() * spin`, we raised the qubit state out of the truncated two-level Hilbert space resulting in the zero state.

While at first glance this convention might seem somewhat odd, it is in fact quite handy. For one, the spin operators remain in the conventional form. Second, this corresponds nicely with the quantum information definitions of qubit states, where the excited ``|\uparrow\rangle`` state is label as ``|0\rangle``, and the ``|\downarrow\rangle`` state by ``|1\rangle``.

If one wants to create spin operators for higher spin systems, then the [`jmat`](@ref) function comes in handy.

## [Expectation values](@id doc:Expectation-values)

Some of the most important information about quantum systems comes from calculating the expectation value of operators, both Hermitian and non-Hermitian, as the state or density matrix of the system varies in time. Therefore, in this section we demonstrate the use of the [`expect`](@ref) function. To begin:

```@example states_and_operators
vac = basis(5, 0)

one = basis(5, 1)

c = create(5)

N = num(5)

coh = coherent_dm(5, 1.0im)

cat = normalize(basis(5, 4) + 1.0im * basis(5, 3))

println(expect(N, vac) ≈ 0)
println(expect(N, one) ≈ 1)
println(expect(N, coh) ≈ 0.9970555745806597)
println(expect(c, cat) ≈ 1im)
```

The [`expect`](@ref) function also accepts lists or arrays of state vectors or density matrices for the second input:

```@example states_and_operators
states = [normalize(c^k * vac) for k in 0:4]

expect(N, states)
```

```@example states_and_operators
cat_list = [normalize(basis(5, 4) + x * basis(5, 3)) for x in [0, 1.0im, -1.0, -1.0im]]

expect(c, cat_list)
```

Notice how in this last example, all of the return values are complex numbers. This is because the expect function looks to see whether the operator is Hermitian or not. If the operator is Hermitian, then the output will always be real. In the case of non-Hermitian operators, the return values may be complex. Therefore, the expect function will return an array of complex values for non-Hermitian operators when the input is a list/array of states or density matrices.

Of course, the expect function works for spin states and operators:

```@example states_and_operators
up = basis(2, 0)

dn = basis(2, 1)

println(expect(sigmaz(), up) ≈ 1)
println(expect(sigmaz(), dn) ≈ -1)
```

as well as the composite objects discussed in the next section [Tensor Products and Partial Traces](@ref doc:Tensor-products-and-Partial-Traces):

```@example states_and_operators
spin1 = basis(2, 0)

spin2 = basis(2, 1)

two_spins = tensor(spin1, spin2)

sz1 = tensor(sigmaz(), qeye(2))

sz2 = tensor(qeye(2), sigmaz())

println(expect(sz1, two_spins) ≈ 1)
println(expect(sz2, two_spins) ≈ -1)
```

## [Superoperators and Vectorized Operators](@id doc:Superoperators-and-Vectorized-Operators)

In addition to state vectors and density operators, `QuantumToolbox` allows for representing maps that act linearly on density operators using the Liouville supermatrix formalisms.

This support is based on the correspondence between linear operators acting on a Hilbert space, and vectors in two copies of that Hilbert space (which is also called the Fock-Liouville space), 
```math
\textrm{vec} : \mathcal{L}(\mathcal{H}) \rightarrow \mathcal{H}\otimes\mathcal{H}.
```
Therefore, a given density matrix ``\hat{\rho}`` can then be vectorized, denoted as 
```math
|\hat{\rho}\rangle\!\rangle = \textrm{vec}(\hat{\rho}).
```

`QuantumToolbox` uses the column-stacking convention for the isomorphism between ``\mathcal{L}(\mathcal{H})`` and ``\mathcal{H}\otimes\mathcal{H}``. This isomorphism is implemented by the functions [`mat2vec`](@ref) (or [`operator_to_vector`](@ref)) and [`vec2mat`](@ref) (or [`vector_to_operator`](@ref)):

```@example states_and_operators
rho = Qobj([1 2; 3 4])
```

```@example states_and_operators
vec_rho = mat2vec(rho)
```

```@example states_and_operators
rho2 = vec2mat(vec_rho)
```

The `QuantumObject.type` attribute indicates whether a quantum object is a vector corresponding to an [`OperatorKet`](@ref), or its Hermitian conjugate [`OperatorBra`](@ref). One can also use [`isoper`](@ref), [`isoperket`](@ref), and [`isoperbra`](@ref) to check the type:

```@example states_and_operators
println(isoper(vec_rho))
println(isoperket(vec_rho))
println(isoperbra(vec_rho))
println(isoper(vec_rho'))
println(isoperket(vec_rho'))
println(isoperbra(vec_rho'))
```

Because `Julia` is a column-oriented languages (like `Fortran` and `MATLAB`), in `QuantumToolbox`, we define the [`spre`](@ref) (left), [`spost`](@ref) (right), and [`sprepost`](@ref) (left-and-right) multiplication superoperators as follows:

```math
\begin{align}
\hat{A}\hat{\rho}~~~ &\rightarrow \textrm{spre}(\hat{A}) * \textrm{vec}(\hat{\rho}) = \hat{\mathbb{1}}\otimes \hat{A} ~ |\hat{\rho}\rangle\!\rangle,\notag\\
\hat{\rho} \hat{B} &\rightarrow \textrm{spost}(\hat{B}) * \textrm{vec}(\hat{\rho}) = \hat{B}^T\otimes \hat{\mathbb{1}} ~ |\hat{\rho}\rangle\!\rangle,\notag\\
\hat{A} \hat{\rho} \hat{B} &\rightarrow \textrm{sprepost}(\hat{A},\hat{B}) * \textrm{vec}(\hat{\rho}) = \hat{B}^T\otimes \hat{A} ~ |\hat{\rho}\rangle\!\rangle,\notag
\end{align}
```
where ``\hat{\mathbb{1}}`` represents the identity operator with Hilbert space dimension equal to ``\hat{\rho}``.

```@example states_and_operators
A = Qobj([1 2; 3 4])
S_A = spre(A)
```

```@example states_and_operators
B = Qobj([5 6; 7 8])
S_B = spost(B)
```

```@example states_and_operators
S_AB = sprepost(A, B)
```

```@example states_and_operators
S_AB ≈ S_A * S_B ≈ S_B * S_A
```

One can also use [`issuper`](@ref) to check the type:

```@example states_and_operators
println(isoper(S_AB))
println(issuper(S_AB))
```

With the above definitions, the following equalities hold in `Julia`:

```math
\textrm{vec}(\hat{A} \hat{\rho} \hat{B}) = \textrm{spre}(\hat{A}) * \textrm{spost}(\hat{B}) * \textrm{vec}(\hat{\rho}) = \textrm{sprepost}(\hat{A},\hat{B}) * \textrm{vec}(\hat{\rho}) ~~\forall~~\hat{A}, \hat{B}, \hat{\rho}
```

```@example states_and_operators
N  = 10
A = Qobj(rand(ComplexF64, N, N))
B = Qobj(rand(ComplexF64, N, N))
ρ = rand_dm(N) # random density matrix
mat2vec(A * ρ * B) ≈ spre(A) * spost(B) * mat2vec(ρ) ≈ sprepost(A, B) * mat2vec(ρ)
```

In addition, dynamical generators on this extended space, often called Liouvillian superoperators, can be created using the [`liouvillian`](@ref) function. Each of these takes a Hamiltonian along with a list of collapse operators, and returns a [`QuantumObject`](@ref) of type [`SuperOperator`](@ref) that can be exponentiated to find the superoperator for that evolution.

```@example states_and_operators
H = 10 * sigmaz()

c = destroy(2)

L = liouvillian(H, [c])
```

```@example states_and_operators
t = 0.8
exp(L * t)
```

See the section [Lindblad Master Equation Solver](@ref doc-TE:Lindblad-Master-Equation-Solver) for more details.

# [Computing propagators](@id doc-TE:Computing-propagators)

```@setup propagator
using QuantumToolbox
```

## Using a solver to compute a propagator

Many solvers accept an identity matrix as the initial state. When such [`QuantumObject`](@ref) is passed as the initial state, the propagator is computed. This can be used to compute a propagator for [`sesolve`](@ref), [`mesolve`](@ref), [`brmesolve`](@ref), etc. For example, 

```@example propagator
ϵ0 = 1.0 * 2π
Ω = 0.8 * 2π
Δt = π/5
H = (ϵ0/2) * sigmaz() + (Ω/2) * sigmax()
```

The propagator ``\hat{U}`` for the [Schrodinger equation](@ref doc-TE:Schrödinger-Equation-Solver) with a small time step ``\Delta t`` can be used as

```math
|\psi(t + \Delta t)\rangle = \hat{U}(\Delta t) |\psi(t)\rangle
```

For a Hamiltonian `H`, the corresponding propagator ``\hat{U}(\Delta t)`` can be generated by using [`sesolve`](@ref) with the initial state given as `qeye_like(H)`, which is an identity [`Operator`](@ref) (same as `H.type`), namely

```@example propagator
U_se = sesolve(H, qeye_like(H), [0, Δt]; progress_bar = Val(false)).states[end]
```

Thus, the state at time ``t = n \Delta t`` can be computed by applying the propagator ``\hat{U}(\Delta t)`` repeatedly ``n`` times on the initial state ``|\psi(0)\rangle``:

```@example propagator
n = 10
ψ0 = basis(2, 0)

ψt = U_se^n * ψ0
```

Similarly, the propagator ``\mathcal{U}`` for [Lindblad master equation](@ref doc-TE:Lindblad-Master-Equation-Solver) with a small time step ``\Delta t`` can be used as

```math
|\hat{\rho}(t + \Delta t)\rangle\!\rangle = \mathcal{U}(\Delta t) |\hat{\rho}(t)\rangle\!\rangle,
```

where ``|\hat{\rho}(t)\rangle\!\rangle`` is the [vectorized density operator](@ref doc:Superoperators-and-Vectorized-Operators).

For a Liouvillian superoperator `L`, the corresponding propagator ``\mathcal{U}(\Delta t)`` can be generated by using [`mesolve`](@ref) with the initial state given as `qeye_like(L)`, which is an identity [`SuperOperator`](@ref) (same as `L.type`), namely

```@example propagator
L = liouvillian(H)
U_me = mesolve(L, qeye_like(L), [0, Δt]; progress_bar = Val(false)).states[end]
```

Thus, the state at time ``t = n \Delta t`` can be computed by applying the propagator ``\mathcal{U}(\Delta t)`` repeatedly ``n`` times on the initial [vectorized density operator](@ref doc:Superoperators-and-Vectorized-Operators) ``|\hat{\rho}(0)\rangle\!\rangle``:

```@example propagator
n = 10
ρ0_vec = mat2vec(ket2dm(basis(2, 0))) # type=OperatorKet()

ρt_vec = U_me^n * ρ0_vec
```

# [Schrödinger Equation Solver](@id doc-TE:Schrödinger-Equation-Solver)

## [Unitary evolution](@id doc-TE:Unitary-evolution)

The dynamics of a closed (pure) quantum system is governed by the Schrödinger equation

```math
i\hbar\frac{\partial}{\partial t}\Psi(\vec{x}, t) = \hat{H}\Psi(\vec{x}, t),
```

where ``\Psi(\vec{x}, t)`` is the wave function, ``\hat{H}`` is the Hamiltonian, and ``\hbar`` is reduced Planck constant. In general, the Schrödinger equation is a partial differential equation (PDE) where both 
``\Psi`` and ``\hat{H}`` are functions of space ``\vec{x}`` and time ``t``. For computational purposes it is useful to expand the PDE in a set of basis functions that span the Hilbert space of the Hamiltonian, and to write the equation in matrix and vector form, namely

```math
i\hbar\frac{d}{dt}|\psi(t)\rangle = \hat{H}|\psi(t)\rangle,
```

where ``|\psi(t)\rangle`` is the state vector, and the Hamiltonian ``\hat{H}`` is now under matrix representation. This matrix equation can, in principle, be solved by diagonalizing the Hamiltonian matrix ``\hat{H}``. In practice, however, it is difficult to perform this diagonalization unless the size of the Hilbert space (dimension of the matrix ``\hat{H}``) is small. Analytically, it is a formidable task to calculate the dynamics for systems with more than two states. If, in addition, we consider dissipation due to the inevitable interaction with a surrounding environment, the computational complexity grows even larger, and we have to resort to numerical calculations in all realistic situations. This illustrates the importance of numerical calculations in describing the dynamics of open quantum systems, and the need for efficient and accessible tools for this task.

The Schrödinger equation, which governs the time-evolution of closed quantum systems, is defined by its Hamiltonian and state vector. In the previous sections, [Manipulating States and Operators](@ref doc:Manipulating-States-and-Operators) and [Tensor Products and Partial Traces](@ref doc:Tensor-products-and-Partial-Traces), we showed how Hamiltonians and state vectors are constructed in `QuantumToolbox.jl`. Given a Hamiltonian, we can calculate the unitary (non-dissipative) time-evolution of an arbitrary initial state vector ``|\psi(0)\rangle`` using the `QuantumToolbox` time evolution problem [`sesolveProblem`](@ref) or directly call the function [`sesolve`](@ref). It evolves the state vector ``|\psi(t)\rangle`` and evaluates the expectation values for a set of operators `e_ops` at each given time points, using an ordinary differential equation solver provided by the powerful julia package [`DifferentialEquation.jl`](https://docs.sciml.ai/DiffEqDocs/stable/).

## [Example: Spin dynamics](@id doc-TE:Example:Spin-dynamics)

```@setup sesolve
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

For example, the time evolution of a quantum spin-``\frac{1}{2}`` system (initialized in spin-``\uparrow``) with tunneling rate ``0.1`` is calculated, and the expectation values of the Pauli-Z operator ``\hat{\sigma}_z`` is also evaluated, with the following code

```@example sesolve
H = 2 * π * 0.1 * sigmax()
ψ0 = basis(2, 0) # spin-up
tlist = LinRange(0.0, 10.0, 20)

prob = sesolveProblem(H, ψ0, tlist, e_ops = [sigmaz()], progress_bar = Val(false))
sol = sesolve(prob)
```

!!! note "Note"
    Here, we generate the time evolution problem by [`sesolveProblem`](@ref) first and then put it into the function [`sesolve`](@ref). One can also directly call [`sesolve`](@ref), which we also demonstrates in below.

The function returns [`TimeEvolutionSol`](@ref), as described in the previous section [Time Evolution Solutions](@ref doc-TE:Time-Evolution-Solutions). The attribute `expect` in `sol`ution is a list of expectation values for the operator(s) that are passed to the `e_ops` keyword argument. 

```@example sesolve
sol.expect
```

Passing multiple operators to `e_ops` as a `Vector` results in the expectation values for each operators at each time points.

```@example sesolve
tlist = LinRange(0.0, 10.0, 100)
sol = sesolve(H, ψ0, tlist, e_ops = [sigmaz(), sigmay()])
```

!!! note "Note"
    Here, we call [`sesolve`](@ref) directly instead of pre-defining [`sesolveProblem`](@ref) first (as shown previously).

```@example sesolve
println(size(sol.times)) # time points corresponds to stored expectation values 
println(size(sol.times_states)) # time points corresponds to stored states
```

```@example sesolve
expt = sol.expect
print(size(expt))
```

We can therefore plot the expectation values:

```@example sesolve
expt_z = real(expt[1,:])
expt_y = real(expt[2,:])

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = "Time", ylabel = "Expectation values")
lines!(ax, tlist, expt_z, label = L"\langle\hat{\sigma}_z\rangle", linestyle = :solid)
lines!(ax, tlist, expt_y, label = L"\langle\hat{\sigma}_y\rangle", linestyle = :dash)

axislegend(ax, position = :rb)

fig
```

If the keyword argument `e_ops` is not specified (or given as an empty `Vector`), the [`sesolve`](@ref) and functions return a [`TimeEvolutionSol`](@ref) that contains a list of state vectors which corresponds to the time points specified in `tlist`:

```@example sesolve
tlist = [0, 10]
sol = sesolve(H, ψ0, tlist) # or specify: e_ops = []

println(size(sol.times))
println(size(sol.times_states))
```

```@example sesolve
sol.states
```

This is because the `states` will be saved depend on the keyword argument `saveat` in `kwargs`. If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). 

One can also specify `e_ops` and `saveat` separately:

```@example sesolve
tlist = [0, 5, 10]
sol = sesolve(H, ψ0, tlist, e_ops = [sigmay()], saveat = tlist)
```

```@example sesolve
print(size(sol.times))
```

```@example sesolve
sol.expect
```

```@example sesolve
print(size(sol.times_states))
```

```@example sesolve
sol.states
```

# [Extension for CUDA.jl](@id doc:CUDA)

## Introduction

This is an extension to support `QuantumObject.data` conversion from standard dense and sparse CPU arrays to GPU ([`CUDA.jl`](https://github.com/JuliaGPU/CUDA.jl)) arrays.

This extension will be automatically loaded if user imports both `QuantumToolbox.jl` and [`CUDA.jl`](https://github.com/JuliaGPU/CUDA.jl):

```julia
using QuantumToolbox
using CUDA
using CUDA.CUSPARSE
CUDA.allowscalar(false) # Avoid unexpected scalar indexing
```

We wrapped several functions in `CUDA` and `CUDA.CUSPARSE` in order to not only converting `QuantumObject.data` into GPU arrays, but also changing the element type and word size (`32` and `64`) since some of the GPUs perform better in `32`-bit. The functions are listed as follows (where input `A` is a [`QuantumObject`](@ref)):

- `cu(A; word_size=64)`: return a new [`QuantumObject`](@ref) with `CUDA` arrays and specified `word_size`.
- `CuArray(A)`: If `A.data` is a dense array, return a new [`QuantumObject`](@ref) with `CUDA.CuArray`.
- `CuArray{T}(A)`: If `A.data` is a dense array, return a new [`QuantumObject`](@ref) with `CUDA.CuArray` under element type `T`.
- `CuSparseVector(A)`: If `A.data` is a sparse vector, return a new [`QuantumObject`](@ref) with `CUDA.CUSPARSE.CuSparseVector`.
- `CuSparseVector{T}(A)`: If `A.data` is a sparse vector, return a new [`QuantumObject`](@ref) with `CUDA.CUSPARSE.CuSparseVector` under element type `T`.
- `CuSparseMatrixCSC(A)`: If `A.data` is a sparse matrix, return a new [`QuantumObject`](@ref) with `CUDA.CUSPARSE.CuSparseMatrixCSC`.
- `CuSparseMatrixCSC{T}(A)`: If `A.data` is a sparse matrix, return a new [`QuantumObject`](@ref) with `CUDA.CUSPARSE.CuSparseMatrixCSC` under element type `T`.
- `CuSparseMatrixCSR(A)`: If `A.data` is a sparse matrix, return a new [`QuantumObject`](@ref) with `CUDA.CUSPARSE.CuSparseMatrixCSR`.
- `CuSparseMatrixCSR{T}(A)`: If `A.data` is a sparse matrix, return a new [`QuantumObject`](@ref) with `CUDA.CUSPARSE.CuSparseMatrixCSR` under element type `T`.

We suggest to convert the arrays from CPU to GPU memory by using the function `cu` because it allows different `data`-types of input [`QuantumObject`](@ref).

Here are some examples:

## Converting dense arrays

```julia
V = fock(2, 0) # CPU dense vector
```

```
Quantum Object:   type=Ket()   dims=[2]   size=(2,)
2-element Vector{ComplexF64}:
 1.0 + 0.0im
 0.0 + 0.0im
```

```julia
cu(V)
```

```
Quantum Object:   type=Ket()   dims=[2]   size=(2,)
2-element CuArray{ComplexF64, 1, CUDA.DeviceMemory}:
 1.0 + 0.0im
 0.0 + 0.0im
```

```julia
cu(V; word_size = 32)
```

```
Quantum Object:   type=Ket()   dims=[2]   size=(2,)
2-element CuArray{ComplexF32, 1, CUDA.DeviceMemory}:
 1.0 + 0.0im
 0.0 + 0.0im
```

```julia
M = Qobj([1 2; 3 4]) # CPU dense matrix
```

```
Quantum Object:   type=Operator()   dims=[2]   size=(2, 2)   ishermitian=false
2×2 Matrix{Int64}:
 1  2
 3  4
```

```julia
cu(M)
```

```
Quantum Object:   type=Operator()   dims=[2]   size=(2, 2)   ishermitian=false
2×2 CuArray{Int64, 2, CUDA.DeviceMemory}:
 1  2
 3  4
```

```julia
cu(M; word_size = 32)
```

```
Quantum Object:   type=Operator()   dims=[2]   size=(2, 2)   ishermitian=false
2×2 CuArray{Int32, 2, CUDA.DeviceMemory}:
 1  2
 3  4
```

## Converting sparse arrays

```julia
V = fock(2, 0; sparse=true) # CPU sparse vector
```

```
Quantum Object:   type=Ket()   dims=[2]   size=(2,)
2-element SparseVector{ComplexF64, Int64} with 1 stored entry:
  [1]  =  1.0+0.0im
```

```julia
cu(V)
```

```
Quantum Object:   type=Ket()   dims=[2]   size=(2,)
2-element CuSparseVector{ComplexF64, Int32} with 1 stored entry:
  [1]  =  1.0+0.0im
```

```julia
cu(V; word_size = 32)
```

```
Quantum Object:   type=Ket()   dims=[2]   size=(2,)
2-element CuSparseVector{ComplexF32, Int32} with 1 stored entry:
  [1]  =  1.0+0.0im
```

```julia
M = sigmax() # CPU sparse matrix
```

```
Quantum Object:   type=Operator()   dims=[2]   size=(2, 2)   ishermitian=true
2×2 SparseMatrixCSC{ComplexF64, Int64} with 2 stored entries:
     ⋅      1.0+0.0im
 1.0+0.0im      ⋅    
```

```julia
cu(M)
```

```
Quantum Object:   type=Operator()   dims=[2]   size=(2, 2)   ishermitian=true
2×2 CuSparseMatrixCSC{ComplexF64, Int32} with 2 stored entries:
     ⋅      1.0+0.0im
 1.0+0.0im      ⋅    
```

```julia
cu(M; word_size = 32)
```

```
Quantum Object:   type=Operator()   dims=[2]   size=(2, 2)   ishermitian=true
2×2 CuSparseMatrixCSC{ComplexF32, Int32} with 2 stored entries:
     ⋅      1.0+0.0im
 1.0+0.0im      ⋅    
```

# [Bibliography](@id doc-Bibliography)

```@meta
CurrentModule = QuantumToolbox
```

This page is generated by [`DocumenterCitations.jl` with author-year style](https://juliadocs.org/DocumenterCitations.jl/stable/gallery/#author_year_style).

```@bibliography
```

# [Monte Carlo Solver](@id doc-TE:Monte-Carlo-Solver)

## [Monte Carlo wave-function](@id doc-TE:Monte-Carlo-wave-function)

Where as the density matrix formalism describes the ensemble average over many identical realizations of a quantum system, the Monte Carlo (MC), or quantum-jump approach to wave function evolution, allows for simulating an individual realization of the system dynamics. Here, the environment is continuously monitored, resulting in a series of quantum jumps in the system wave function, conditioned on the increase in information gained about the state of the system via the environmental measurements. In general, this evolution is governed by the Schrödinger equation with a non-Hermitian effective Hamiltonian

```math
\hat{H}_{\textrm{eff}} = \hat{H} - \frac{i}{2} \sum_{n=1}^N \hat{C}_n^\dagger \hat{C}_n.
```

where ``\hat{H}`` is the system Hamiltonian and ``\hat{C}_n`` are collapse (jump) operators (assume ``N`` is the total number of collapse operators). Each collapse operator corresponds to a separate irreversible process with rate ``\gamma_n``. Here, the strictly negative non-Hermitian portion of the above equation gives rise to a reduction in the norm of the wave function, that to first-order in a small time ``\delta t``, is given by

```math
\langle \psi(t + \delta t) | \psi(t + \delta t) \rangle = 1 - \delta p,
```

where

```math
\delta p = \delta t \sum_{n=1}^N \langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle,
```

and ``\delta t`` is such that ``\delta p \ll 1``. With a probability of remaining in the state ``| \psi(t + \delta t) \rangle`` given by ``1 - \delta p``, the corresponding quantum jump probability is thus ``\delta p``. If the environmental measurements register a quantum jump, say via the emission of a photon into the environment, or a change in the spin of a quantum dot, the wave function undergoes a jump into a state defined by projecting ``| \psi(t) \rangle`` using the collapse operator ``\hat{C}_n`` corresponding to the measurement

```math
| \psi(t+\delta t) \rangle = \frac{\hat{C}_n |\psi(t)\rangle}{ \sqrt{\langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle} }.
```

If more than a single collapse operator is present in ``\hat{H}_{\textrm{eff}}``, the probability of collapse due to the ``n``-th operator ``\hat{C}_n`` is given by

```math
P_n(t) = \frac{1}{\delta p}\langle \psi(t) | \hat{C}_n^\dagger \hat{C}_n | \psi(t) \rangle.
```

Note that the probability of all collapses should be normalized to unity for all time ``t``, namely

```math
\sum_{n=1}^N P_n(t) = 1 ~~~\forall~~t.
```

Evaluating the MC evolution to first-order in time is quite tedious. Instead, `QuantumToolbox.jl` provides the function [`mcsolve`](@ref) which uses the following algorithm to simulate a single realization of a quantum system. Starting from a pure state ``| \psi(0) \rangle``:

1. Choose two random numbers (``r_1`` and ``r_2``) between 0 and 1, where ``r_1`` represents the probability that a quantum jump occurs and  ``r_2`` is used to select which collapse operator was responsible for the jump.
1. Integrate the Schrödinger equation with respect to the effective Hamiltonian ``\hat{H}_{\textrm{eff}}`` until a time ``\tau`` such that the norm of the wave function satisfies ``\langle \psi(\tau) | \psi(\tau) \rangle = r_1``, at which point a jump occurs
1. The resultant jump projects the system at time ``\tau`` into one of the renormalized states ``| \psi(\tau + \delta t) \rangle``. The corresponding collapse operator ``\hat{C}_n`` is chosen such that ``\tilde{n} \leq N`` is the smallest integer satisfying ``\sum_{n=1}^{\tilde{n}} P_n(\tau) \geq r_2``.
1. Using the renormalized state from previous step as the new initial condition at time ``\tau`` and repeat the above procedure until the final simulation time is reached.

## [Example: Two-level atom coupled to dissipative single-mode cavity (MC)](@id doc-TE:Example:Two-level-atom-coupled-to-dissipative-single-mode-cavity-(MC))

In `QuantumToolbox.jl`, Monte Carlo evolution is implemented with the [`mcsolve`](@ref) function. It takes nearly the same arguments as the [`mesolve`](@ref) function for [Lindblad master equation evolution](@ref doc-TE:Lindblad-Master-Equation-Solver), except that the initial state must be a [`Ket`](@ref) vector, as oppose to a density matrix, and there is an optional keyword argument `ntraj` that defines the number of stochastic trajectories to be simulated. By default, `ntraj=500` indicating that `500` Monte Carlo trajectories will be performed.

To illustrate the use of the Monte Carlo evolution of quantum systems in `QuantumToolbox.jl`, let’s again consider the case of a two-level atom coupled to a leaky cavity. The only differences to the master equation treatment is that in this case we invoke the [`mcsolve`](@ref) function instead of [`mesolve`](@ref)

```@setup mcsolve
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

```@example mcsolve
tlist = LinRange(0.0, 10.0, 200)

ψ0 = tensor(fock(2, 0), fock(10, 8))
a  = tensor(qeye(2), destroy(10))
σm = tensor(destroy(2), qeye(10))
H = 2 * π * a' * a + 2 * π * σm' * σm + 2 * π * 0.25 * (σm * a' + σm' * a)

c_ops = [sqrt(0.1) * a]
e_ops = [a' * a, σm' * σm]

sol_500 = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops)

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1],
    xlabel = "Time",
    ylabel = "Expectation values",
    title = "Monte Carlo time evolution (500 trajectories)",
)
lines!(ax, tlist, real(sol_500.expect[1,:]), label = "cavity photon number", linestyle = :solid)
lines!(ax, tlist, real(sol_500.expect[2,:]), label = "atom excitation probability", linestyle = :dash)

axislegend(ax, position = :rt)

fig
```

The advantage of the Monte Carlo method over the master equation approach is that only the state vector ([`Ket`](@ref)) is required to be kept in the computers memory, as opposed to the entire density matrix. For large quantum system this becomes a significant advantage, and the Monte Carlo solver is therefore generally recommended for such systems. However, for small systems, the added overhead of averaging a large number of stochastic trajectories to obtain the open system dynamics, as well as starting the multiprocessing functionality, outweighs the benefit of the minor (in this case) memory saving. Master equation methods are therefore generally more efficient when Hilbert space sizes are on the order of a couple of hundred states or smaller.

We can also change the number of trajectories (`ntraj`). This can be used to explore the convergence of the Monte Carlo solver. For example, the following code plots the expectation values for `1`, `10` and `100` trajectories:

```@example mcsolve
e_ops = [a' * a]

sol_1   = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj = 1)
sol_10  = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj = 10)
sol_100 = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj = 100)

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1],
    xlabel = "Time",
    ylabel = "Expectation values",
    title = "Monte Carlo time evolution",
)
lines!(ax, tlist, real(sol_1.expect[1,:]), label = "1 trajectory", linestyle = :dashdot)
lines!(ax, tlist, real(sol_10.expect[1,:]), label = "10 trajectories", linestyle = :dash)
lines!(ax, tlist, real(sol_100.expect[1,:]), label = "100 trajectories", linestyle = :solid)

axislegend(ax, position = :rt)

fig
```

## [Running trajectories in parallel](@id doc-TE:Running-trajectories-in-parallel)

Monte Carlo evolutions often need hundreds of trajectories to obtain sufficient statistics. Since all trajectories are independent of each other, they can be computed in parallel. The keyword argument `ensemblealg` can specify how the multiple trajectories are handled. The common ensemble methods are:

- `EnsembleSerial()`: No parallelism
- `EnsembleThreads()`: **The default.** This uses multithreading.
- `EnsembleDistributed()`: This uses as many processors as you have Julia processes.
- `EnsembleSplitThreads()`: This uses multithreading on each process.

!!! note "Other Ensemble Algorithms"
    See the [documentation of `DifferentialEquations.jl`](https://docs.sciml.ai/DiffEqDocs/stable/features/ensemble/) for more details. Also, see Julia's documentation for more details about multithreading and adding more processes.

```julia
sol_serial   = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ensemblealg=EnsembleSerial())
sol_parallel = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ensemblealg=EnsembleThreads());
```

!!! tip "Parallelization on a Cluster"
    See the section [Intensive parallelization on a Cluster](@ref doc:Intensive-parallelization-on-a-Cluster) for more details.

# [Automatic Differentiation](@id doc:autodiff)  

Automatic differentiation (AD) has emerged as a key technique in computational science, enabling exact and efficient computation of derivatives for functions defined by code. Unlike symbolic differentiation, which may produce complex and inefficient expressions, or finite-difference methods, which suffer from numerical instability and poor scalability, AD leverages the chain rule at the level of elementary operations to provide machine-precision gradients with minimal overhead.

In `QuantumToolbox.jl`, we have introduced preliminary support for automatic differentiation. Many of the core functions are compatible with AD engines such as [`Zygote.jl`](https://github.com/FluxML/Zygote.jl), [`Enzyme.jl`](https://github.com/EnzymeAD/Enzyme.jl), [`Mooncake.jl`](https://github.com/chalk-lab/Mooncake.jl), or [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl), allowing users to compute gradients of observables or cost functionals involving the time evolution of open quantum systems. Although `QuantumToolbox.jl` was not originally designed with AD in mind, its architecture—rooted in Julia’s multiple dispatch and generic programming model—facilitated the integration of AD capabilities. Many core functions were already compatible with AD engines out of the box.

!!! warning "Experimental Functionality"
    At present, this functionality is considered experimental and not all parts of the library are AD-compatible. Here we provide a brief overview of the current state of AD support in `QuantumToolbox.jl` and how to use it.


## [Forward versus Reverse Mode AD](@id doc:autodiff:forward-versus-reverse) 

Automatic differentiation can be broadly categorized into two modes: forward mode and reverse mode. The choice between these modes depends on the nature of the function being differentiated and the number of inputs and outputs:

- **Forward Mode AD**: This mode is particularly efficient for functions with many outputs and few inputs. It works by propagating derivatives from the inputs through the computational graph to the outputs. Forward mode is often preferred when the number of input variables is small, as it computes the derivative of each output with respect to each input in a single pass.

- **Reverse Mode AD**: In contrast, reverse mode is more efficient for functions with many inputs and few outputs. It operates by first computing the function's output and then propagating derivatives backward through the computational graph. This mode is commonly used in machine learning and optimization applications, where the loss function (output) depends on a large number of parameters (inputs).

Understanding the differences between these two modes can help users choose the most appropriate approach for their specific use case in `QuantumToolbox.jl`.

## [Differentiate the master equation](@id doc:autodiff:master-equation)

One of the primary use cases for automatic differentiation in `QuantumToolbox.jl` is the differentiation of the master equation. The master equation describes the time evolution of a quantum system's density matrix under the influence of non-unitary dynamics, such as dissipation and decoherence. Let's consider a set of parameters $\mathbf{p} = (p_1, p_2, \ldots, p_n)$ that influence the system's dynamics. The Hamiltonian and the dissipators will depend on these parameters

```math
\hat{H} = \hat{H}(\mathbf{p}), \qquad \hat{L}_j = \hat{L}_j(\mathbf{p}),
```

Hence, the density matrix will evolve according to the master equation

```@raw html
<span id="eq:master-equation"></span>
```
```math
\begin{align}
\frac{d \hat{\rho}(\mathbf{p}, t)}{dt} =& -i[\hat{H}(\mathbf{p}), \hat{\rho}(\mathbf{p}, t)] \\
&+ \sum_j \hat{L}_j(\mathbf{p}) \hat{\rho}(\mathbf{p}, t) \hat{L}_j(\mathbf{p})^\dagger - \frac{1}{2} \left\{ \hat{L}_j(\mathbf{p})^\dagger \hat{L}_j(\mathbf{p}), \hat{\rho}(\mathbf{p}, t) \right\} \, , 
\end{align} \tag{1}
```

which depends on the parameters $\mathbf{p}$ and time $t$. 

We now want to compute the expectation value of an observable $\hat{O}$ at time $t$:

```math
\langle \hat{O}(\mathbf{p}, t) \rangle = \text{Tr}[\hat{O} \hat{\rho}(\mathbf{p}, t)] \, ,
```

which will also depend on the parameters $\mathbf{p}$ and time $t$.

Our goal is to compute the derivative of the expectation value with respect to the parameters:

```math
\frac{\partial \langle \hat{O}(\mathbf{p}, t) \rangle}{\partial p_j} = \frac{\partial}{\partial p_j} \text{Tr}[\hat{O} \hat{\rho}(\mathbf{p}, t)] \, ,
```

and to achieve this, we can use an AD engine like [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl) (forward mode) or [`Mooncake.jl`](https://github.com/chalk-lab/Mooncake.jl) (reverse mode).

Let's apply this to a simple example of a driven-dissipative quantum harmonic oscillator. The Hamiltonian in the drive frame is given by

```math
\hat{H} = \Delta \hat{a}^\dagger \hat{a} + F \left( \hat{a} + \hat{a}^\dagger \right) \, ,
```

where $\Delta = \omega_0 - \omega_d$ is the cavity-drive detuning, $F$ is the drive strength, and $\hat{a}$ and $\hat{a}^\dagger$ are the annihilation and creation operators, respectively. The system is subject to a single dissipative channel with a Lindblad operator $\hat{L} = \sqrt{\gamma} \hat{a}$, where $\gamma$ is the dissipation rate. If we start from the ground state $\hat{\rho}(0) = \vert 0 \rangle \langle 0 \vert$, the systems evolves according to the master equation in [Eq. (1)](#eq:master-equation).

We now want to study the number of photons at the steady state, and how it varies with $\mathbf{p} = (\Delta, F, \gamma)$, namely $\nabla_\mathbf{p} \langle \hat{a}^\dagger \hat{a} \rangle (\mathbf{p}, t \to \infty)$. We can extract an analytical expression, in order to verify the correctness of the AD implementation:

```math
\langle \hat{a}^\dagger \hat{a} \rangle_\mathrm{ss} = \frac{F^2}{\Delta^2 + \frac{\gamma^2}{4}} \, ,
```

with the gradient given by

```math
\nabla_\mathbf{p} \langle \hat{a}^\dagger \hat{a} \rangle_\mathrm{ss} =
\begin{pmatrix}
\frac{-2 F^2 \Delta}{(\Delta^2 + \frac{\gamma^2}{4})^2} \\
\frac{2 F}{\Delta^2 + \frac{\gamma^2}{4}} \\
\frac{-F^2 \gamma}{2 (\Delta^2 + \frac{\gamma^2}{4})^2}
\end{pmatrix} \, .
```

Although `QuantumToolbox.jl` has the [`steadystate`](@ref) function to directly compute the steady state without explicitly solving the master equation, here we use the [`mesolve`](@ref) function to integrate up to a long time $t_\mathrm{max}$, and then compute the expectation value of the number operator. We will demonstrate how to compute the gradient using both [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl) and [`Mooncake.jl`](https://github.com/chalk-lab/Mooncake.jl).

### [Forward Mode AD with ForwardDiff.jl](@id doc:autodiff:forward)

```@setup autodiff
using QuantumToolbox
```

We start by importing [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl) and defining the parameters and operators:

```@example autodiff
using ForwardDiff

const N = 20
const a = destroy(N)
const ψ0 = fock(N, 0)
const t_max = 40
const tlist = range(0, t_max, 100)
```

Then, we define a function that take the parameters `p` as an input and returns the expectation value of the number operator at `t_max`. We also define the analytical solution of the steady state photon number and its gradient for comparison:

```@example autodiff
function my_f_mesolve_direct(p)
    H = p[1] * a' * a + p[2] * (a + a')
    c_ops = [sqrt(p[3]) * a]
    sol = mesolve(H, ψ0, tlist, c_ops, progress_bar = Val(false))
    return real(expect(a' * a, sol.states[end]))
end

# Analytical solution
function my_f_analytical(p)
    Δ, F, γ = p
    return F^2 / (Δ^2 + γ^2 / 4)
end
function my_grad_analytical(p)
    Δ, F, γ = p
    return [
        -2 * F^2 * Δ / (Δ^2 + γ^2 / 4)^2,
         2 * F / (Δ^2 + γ^2 / 4),
        -F^2 * γ / (2 * (Δ^2 + γ^2 / 4)^2)
    ]
end
```

The gradient can be computed using `ForwardDiff.gradient`:

```@example autodiff
Δ = 1.5
F = 1.5
γ = 1.5
params = [Δ, F, γ]

grad_exact = my_grad_analytical(params)
grad_fd = ForwardDiff.gradient(my_f_mesolve_direct, params)
```

and test if the results match:

```@example autodiff
isapprox(grad_exact, grad_fd; atol = 1e-5)
```

### [Reverse Mode AD with Mooncake.jl](@id doc:autodiff:reverse)

Reverse-mode differentiation is significantly more challenging than forward-mode when dealing ODEs, as the complexity arises from the need to propagate gradients backward through the entire time evolution of the quantum state.

`QuantumToolbox.jl` leverages the advanced capabilities of [`SciMLSensitivity.jl`](https://github.com/SciML/SciMLSensitivity.jl) to handle this complexity. [`SciMLSensitivity.jl`](https://github.com/SciML/SciMLSensitivity.jl) implements sophisticated methods for computing gradients of ODE solutions, such as the adjoint method, which computes gradients by solving an additional "adjoint" ODE backward in time. For more details on the adjoint method and other sensitivity analysis techniques, please refer to the [`SciMLSensitivity.jl` documentation](https://docs.sciml.ai/SciMLSensitivity/stable/).

In order to reverse-differentiate the master equation, we need to define the operators as [`QuantumObjectEvolution`](@ref) objects, which use [`SciMLOperators.jl`](https://github.com/SciML/SciMLOperators.jl) to represent parameter-dependent operators.

```@example autodiff
using Mooncake
using SciMLSensitivity
using SciMLSensitivity: MooncakeVJP

# For SciMLSensitivity.jl
coef_Δ(p, t) = p[1]
coef_F(p, t) = p[2]
coef_γ(p, t) = sqrt(p[3])
H = QobjEvo(a' * a, coef_Δ) + QobjEvo(a + a', coef_F)
c_ops = [QobjEvo(a, coef_γ)]
const L = liouvillian(H, c_ops)

function my_f_mesolve(p)
    sol = mesolve(
        L,
        ψ0,
        tlist,
        progress_bar = Val(false),
        params = p,
        sensealg = BacksolveAdjoint(autojacvec = MooncakeVJP()),
    )

    return real(expect(a' * a, sol.states[end]))
end
```

And the gradient can be computed with:

```@example autodiff
grad_cache = Mooncake.prepare_gradient_cache(my_f_mesolve, params)
_, grad_mooncake = Mooncake.value_and_gradient!!(grad_cache, my_f_mesolve, params)
```

Finally, we can compare the results from [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl) and [`Mooncake.jl`](https://github.com/chalk-lab/Mooncake.jl):

```@example autodiff
isapprox(grad_fd, grad_mooncake[2]; atol = 1e-5)
```

## [Conclusion](@id doc:autodiff:conclusion)

In this section, we have explored the integration of automatic differentiation into `QuantumToolbox.jl`, enabling users to compute gradients of observables and cost functionals involving the time evolution of open quantum systems. We demonstrated how to differentiate the master equation using both forward mode with [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl) and reverse mode with [`Mooncake.jl`](https://github.com/chalk-lab/Mooncake.jl), showcasing the flexibility and power of automatic differentiation in quantum computing applications. AD can be applied to other functions in `QuantumToolbox.jl`, although the support is still experimental and not all functions are guaranteed to be compatible. We encourage users to experiment with AD in their quantum simulations and contribute to the ongoing development of this feature.

# [Time Evolution Solutions](@id doc-TE:Time-Evolution-Solutions)

```@setup TE-solution
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

## [Solution](@id doc-TE:Solution)
`QuantumToolbox` utilizes the powerful [`DifferentialEquation.jl`](https://docs.sciml.ai/DiffEqDocs/stable/) to simulate different kinds of quantum system dynamics. Thus, we will first look at the data structure used for returning the solution (`sol`) from [`DifferentialEquation.jl`](https://docs.sciml.ai/DiffEqDocs/stable/). The solution stores all the crucial data needed for analyzing and plotting the results of a simulation. A generic structure [`TimeEvolutionSol`](@ref) contains the following properties for storing simulation data:

| **Fields (Attributes)** | **Description** |
|:------------------------|:----------------|
| `sol.times` | The list of time points at which the expectation values are calculated during the evolution. |
| `sol.times_states` | The list of time points at which the states are stored during the evolution. |
| `sol.states` | The list of result states corresponding to each time point in `sol.times_states`. |
| `sol.expect` | The expectation values corresponding to each time point in `sol.times`. |
| `sol.alg` | The algorithm which is used during the solving process. |
| `sol.abstol` | The absolute tolerance which is used during the solving process. |
| `sol.reltol` | The relative tolerance which is used during the solving process. |
| `sol.retcode` (or `sol.converged`) | The returned status from the solver. |

## [Accessing data in solutions](@id doc-TE:Accessing-data-in-solutions)

To understand how to access the data in solution, we will use an example as a guide, although we do not worry about the simulation details at this stage. The Schrödinger equation solver ([`sesolve`](@ref)) used in this example returns [`TimeEvolutionSol`](@ref):

```@example TE-solution
H = 0.5 * sigmay()
ψ0 = basis(2, 0)
e_ops = [
    proj(basis(2, 0)),
    proj(basis(2, 1)),
    basis(2, 0) * basis(2, 1)'
]
tlist = LinRange(0, 10, 100)
sol = sesolve(H, ψ0, tlist, e_ops = e_ops, progress_bar = Val(false))
nothing # hide
```

To see what is contained inside the solution, we can use the `print` function:

```@example TE-solution
print(sol)
```

It tells us the number of expectation values are computed and the number of states are stored. Now we have all the information needed to analyze the simulation results. To access the data for the three expectation values, one can do:

```@example TE-solution
expt1 = real(sol.expect[1,:])
expt2 = real(sol.expect[2,:])
expt3 = real(sol.expect[3,:])
nothing # hide
```

Recall that `Julia` uses `Fortran`-style indexing that begins with one (i.e., `[1,:]` represents the 1-st observable, where `:` represents all values corresponding to `tlist`).

Together with the list of time points at which these expectation values are calculated:

```@example TE-solution
times = sol.times
nothing # hide
```

we can plot the resulting expectation values:

```@example TE-solution
# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = L"t")
lines!(ax, times, expt1, label = L"\langle 0 | \rho(t) | 0 \rangle")
lines!(ax, times, expt2, label = L"\langle 1 | \rho(t) | 1 \rangle")
lines!(ax, times, expt3, label = L"\langle 0 | \rho(t) | 1 \rangle")

ylims!(ax, (-0.5, 1.0))
axislegend(ax, position = :lb)

fig
```

State vectors, or density matrices, are accessed in a similar manner:

```@example TE-solution
sol.states
```

Together with the list of time points at which these states are stored:

```@example TE-solution
times = sol.times_states
nothing # hide
```

Here, the solution contains only one (final) state. Because the `states` will be saved depend on the keyword argument `saveat` in `kwargs`. If `e_ops` is empty, the default value of `saveat=tlist` (saving the states corresponding to `tlist`), otherwise, `saveat=[tlist[end]]` (only save the final state). One can also specify `e_ops` and `saveat` separately.

Some other solvers can have other output.

## [Multiple trajectories solution](@id doc-TE:Multiple-trajectories-solution)

The solutions are different for solvers which compute multiple trajectories, such as the [`TimeEvolutionMCSol`](@ref) (Monte Carlo) or the [`TimeEvolutionStochasticSol`](@ref) (stochastic methods). The storage of expectation values and states depends on the keyword argument `keep_runs_results`, which determines whether the results of all trajectories are stored in the solution.

When the keyword argument `keep_runs_results` is passed as `Val(false)` to a multi-trajectory solver, the `states` and `expect` fields store only the average results (averaged over all trajectories). The results can be accessed by the following index-order:

```julia
sol.states[time_idx]
sol.expect[e_op,time_idx]
```

For example:

```@example TE-solution
tlist = LinRange(0, 1, 11)
c_ops = (destroy(2),)
e_ops = (num(2),)

sol_mc1 = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj=25, keep_runs_results=Val(false), progress_bar=Val(false))

size(sol_mc1.expect)
```

If the keyword argument `keep_runs_results = Val(true)`, the results for each trajectory and each time are stored, and the index-order of the elements in fields `states` and `expect` are:


```julia
sol.states[trajectory,time_idx]
sol.expect[e_op,trajectory,time_idx]
```

For example:

```@example TE-solution
sol_mc2 = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj=25, keep_runs_results=Val(true), progress_bar=Val(false))

size(sol_mc2.expect)
```

We also provide the following functions for statistical analysis of multi-trajectory `sol`utions:

| **Functions** | **Description** |
|:------------|:----------------|
| [`average_states(sol)`](@ref average_states) | Return the trajectory-averaged result states (as density [`Operator`](@ref)) at each time point. |
| [`average_expect(sol)`](@ref average_expect) | Return the trajectory-averaged expectation values at each time point. |
| [`std_expect(sol)`](@ref std_expect) | Return the trajectory-wise standard deviation of the expectation values at each time point. |

# [Visualization of quantum states and operators](@id doc:Visualization-of-quantum-states-and-operators)

Visualization is often an important complement to the simulation of a quantum mechanical system. The first method of visualization that comes to mind might be to plot the expectation values of a few selected operators. But on top of that, it can often be instructive to visualize for example the state vectors, density matrices, Hamiltonian, or Liouvillian. In this section, we demonstrate how `QuantumToolbox.jl` and [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) can be used to perform several types of visualizations that often can provide additional understanding of quantum system.

```@example visualization
using CairoMakie
```

```@setup visualization
using QuantumToolbox
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

!!! note "Import plotting libraries"
    Remember to import plotting libraries first.

## Fock-basis probability distribution

In quantum mechanics, probability distributions plays an important role, and as in statistics, the expectation values computed from a probability distribution do not reveal the full story. For example, consider an quantum harmonic oscillator mode with Hamiltonian ``\hat{H}=\hbar\omega\hat{a}^\dagger\hat{a}``, which is in a state described by its density matrix ``\hat{\rho}``, and which on average is occupied by two photons, ``\textrm{Tr}[\hat{a}^\dagger\hat{a}\hat{\rho}] = 2``. Given this information we cannot say whether the oscillator is in a Fock state, a thermal state, a coherent state, etc. By visualizing the photon distribution in the Fock state basis important clues about the underlying state can be obtained.

One convenient way to visualize a probability distribution is to use histograms. Consider the following histogram visualization of the number-basis probability distribution, which can be obtained from the diagonal of the density matrix, for a few possible oscillator states with on average occupation of two photons.

First we generate the density matrices for the coherent, thermal and Fock states.

```@example visualization
N = 20

ρ_coherent = coherent_dm(N, sqrt(2))
ρ_thermal = thermal_dm(N, 2)
ρ_fock = fock_dm(N, 2)
nothing # hide
```

`QuantumToolbox.jl` provides a convenient function [`plot_fock_distribution`](@ref) to visualize the Fock-distribution:

```@example visualization
fig = Figure(size = (600, 350))

# only show several x-labels
fock_numbers = [
    "0", "", "", "", "", "5", "", "", "", "",
    "10", "", "", "", "", "15", "", "", "", "19",
]

_, ax1, _ = plot_fock_distribution(ρ_coherent; location=fig[1,1], fock_numbers=fock_numbers)
ax1.title = "Coherent state"

_, ax2, _ =plot_fock_distribution(ρ_thermal; location=fig[1,2], fock_numbers=fock_numbers)
ax2.title = "Thermal state"

_, ax3, _ =plot_fock_distribution(ρ_fock; location=fig[1,3], fock_numbers=fock_numbers)
ax3.title = "Fock state"

fig
```

## Quasi-probability distributions

The probability distribution in the number (Fock) basis only describes the occupation probabilities for a discrete set of states. A more complete phase-space probability-distribution-like function for harmonic modes are the Wigner and Husimi Q-functions, which provide full descriptions of the quantum state (equivalent to the density matrix). These are called quasi-distribution functions because unlike real probability distribution functions they can for example be negative. In addition to being more complete descriptions of a state (compared to only the occupation probabilities plotted above), these distributions are also great for demonstrating if a quantum state is quantum mechanical, since for example a negative Wigner function is a definite indicator that a state is distinctly nonclassical.

### Wigner function

In `QuantumToolbox.jl`, the Wigner function for a harmonic mode can be calculated with the function [`wigner`](@ref). It takes a ket or a density matrix as input, together with arrays that define the ranges of the phase-space coordinates (in the ``x``-``y`` plane).

In the following example, the Wigner functions are calculated and plotted for the same three states as in the previous section by calling the function [`plot_wigner`](@ref):

```@example visualization
fig = Figure(size = (600, 200))

xvec = LinRange(-5, 5, 200)

_, ax1, _ = plot_wigner(ρ_coherent; xvec=xvec, yvec=xvec, location=fig[1,1])
ax1.title = "Coherent state"
ax1.aspect = 1 # make plot as square-size

_, ax2, _ = plot_wigner(ρ_thermal; xvec=xvec, yvec=xvec, location=fig[1,2])
ax2.title = "Thermal state"
ax2.aspect = 1 # make plot as square-size

_, ax3, _ = plot_wigner(ρ_fock; xvec=xvec, yvec=xvec, location=fig[1,3])
ax3.title = "Fock state"
ax3.aspect = 1 # make plot as square-size

fig
```

## Visualizing operators

Sometimes, it may also be useful to directly visualizing the underlying matrix representation of an operator. The density matrix, for example, is an operator whose elements can give insights about the state it represents, but one might also be interesting in plotting the matrix of an Hamiltonian to inspect the structure and relative importance of various elements.

`QuantumToolbox.jl` offers a few functions for quickly visualizing matrix data in the form of 2D heatmap ([`matrix_heatmap`](@ref)) and 3D histogram ([`matrix_histogram`](@ref)).

For example, to illustrate the use of these functions, let’s visualize the Jaynes-Cummings Hamiltonian:

```@example visualization
N = 5
a = tensor(destroy(N), qeye(2))
σm = tensor(qeye(N), destroy(2))
sx = tensor(qeye(N), sigmax())
H = a' * a + sx - 0.5 * (a * σm' + a' * σm)

fig = Figure(size = (500, 350))
matrix_heatmap(H; location = fig[1,1])

fig
```

We can also handle the matrix elements with different `method` (keyword argument) before plotting them: 

- `method = Val(:real)`: the real part of each element
- `method = Val(:imag)`: the imaginary part of each element
- `method = Val(:abs)`: the absolute value of each element
- `method = Val(:angle)`: the (complex) phase angle in radians of each element

For example, the `real` and `imag`inary parts of [`steadystate`](@ref) can be visualized by:

```@example visualization
# collapse operators
c_ops = (
    sqrt(0.01) * σm,
    sqrt(0.01) * a,
)
ρss = steadystate(H, c_ops)

fig = Figure(size = (350, 500))

matrix_heatmap(ρss; method = Val(:real), location = fig[1,1])
matrix_heatmap(ρss; method = Val(:imag), location = fig[2,1])

fig
```

Similarly, we can use the function [`matrix_histogram`](@ref) to visualize the above Hamiltonian in a 3D histogram:

!!! warning "Backend"
    `CairoMakie` is not the best backend for handling 3D shading, we suggest to use `GLMakie` for [`matrix_histogram`](@ref).

```julia
using GLMakie # requires OpenGL: a backend better for 3D shading

fig = Figure(size = (500, 350))

matrix_histogram(H; location = fig[1,1])

fig
```

![](../assets/demo/matrix_histogram.png)

```@raw html
---
# https://vitepress.dev/reference/default-theme-home-page
layout: home

hero:
  name: "QuantumToolbox.jl"
  tagline: A pure Julia framework designed for high-performance quantum physics simulations
  image:
    src: /logo.png
    alt: QuantumToolbox
  actions:
    - theme: brand
      text: Getting Started
      link: /getting_started/brief_example
    - theme: alt
      text: Users Guide
      link: /users_guide/QuantumObject/QuantumObject
    - theme: alt
      text: Tutorials
      link: https://qutip.org/qutip-julia-tutorials/
    - theme: alt
      text: API
      link: /resources/api
    - theme: alt
      text: Cite us
      link: /getting_started/cite
    - theme: alt
      text: View on Github
      link: https://github.com/qutip/QuantumToolbox.jl
    - theme: alt
      text: Visit QuTiP.org
      link: https://qutip.org/


features:
  - icon: <img width="64" height="64" src="https://docs.sciml.ai/DiffEqDocs/stable/assets/logo.png" alt="markdown"/>
    title: Dynamical Evolution
    details: Advanced solvers for time evolution of quantum systems, thanks to the powerful DifferentialEquations.jl package.
    link: /users_guide/time_evolution/intro
  - icon: <img width="64" height="64" src="https://cuda.juliagpu.org/stable/assets/logo.png" />
    title: GPU Computing
    details: Leverage GPU resources for high-performance computing. Simulate quantum dynamics directly on the GPU with the same syntax as the CPU case.
    link: /users_guide/extensions/cuda
  - icon: <img width="64" height="64" src="https://img.icons8.com/?size=100&id=1W4Bkj363ov0&format=png&color=000000" />
    title: Distributed Computing
    details: Distribute the computation over multiple nodes (e.g., a cluster). Simulate hundreds of quantum trajectories in parallel on a cluster, with, again, the same syntax as the simple case.
    link: /users_guide/cluster
  - icon: <img width="64" height="64" src="https://raw.githubusercontent.com/JuliaDiff/DifferentiationInterface.jl/main/DifferentiationInterface/docs/src/assets/logo.svg" />
    title: Differentiable Programming
    details: Enable gradient-based optimization for quantum algorithms. Compute gradients of quantum dynamics with respect to their parameters using automatic differentiation.
    link: /users_guide/autodiff
---
```

# [Introduction](@id doc:Introduction)

[`QuantumToolbox.jl`](https://github.com/qutip/QuantumToolbox.jl) is a cutting-edge [`Julia`](https://julialang.org/) package designed for quantum physics simulations, closely emulating the popular [`Python QuTiP`](https://github.com/qutip/qutip) package. It uniquely combines the simplicity and power of Julia with advanced features like GPU acceleration and distributed computing, making simulation of quantum systems more accessible and efficient. Taking advantage of the [`Julia`](https://julialang.org/) language features (like multiple dispatch and metaprogramming), [`QuantumToolbox.jl`](https://github.com/qutip/QuantumToolbox.jl) is designed to be easily extendable, allowing users to build upon the existing functionalities.

*__With this package, moving from Python to Julia for quantum physics simulations has never been easier__*, due to the similar syntax and functionalities.

# [Installation](@id doc:Installation)

!!! note "Requirements"
    `QuantumToolbox.jl` requires `Julia 1.10+`.

To install `QuantumToolbox.jl`, run the following commands inside Julia's interactive session (also known as REPL):
```julia
using Pkg
Pkg.add("QuantumToolbox")
```
Alternatively, this can also be done in `Julia`'s [Pkg REPL](https://julialang.github.io/Pkg.jl/v1/getting-started/) by pressing the key `]` in the REPL to use the package mode, and then type the following command:
```julia-repl
(1.10) pkg> add QuantumToolbox
```
More information about `Julia`'s package manager can be found at [`Pkg.jl`](https://julialang.github.io/Pkg.jl/v1/).

To load the package and check the version information, use either [`QuantumToolbox.versioninfo()`](@ref) or [`QuantumToolbox.about()`](@ref), namely
```julia
using QuantumToolbox
QuantumToolbox.versioninfo()
QuantumToolbox.about()
```

# [Other Useful Packages](@id doc:Other-Useful-Packages)

In order to get a better experience and take full advantage of `QuantumToolbox`, we recommend the following external packages:

- Standard `Julia` Libraries: (recommended to also `using` with `QuantumToolbox.jl`)
  - [`LinearAlgebra.jl`](https://github.com/JuliaLang/LinearAlgebra.jl)
  - [`SparseArrays.jl`](https://github.com/JuliaSparse/SparseArrays.jl)
- Solver `alg`orithms:
  - [`DifferentialEquations.jl`](https://github.com/SciML/DifferentialEquations.jl) or [`OrdinaryDiffEq.jl`](https://github.com/SciML/OrdinaryDiffEq.jl)
  - [`LinearSolve.jl`](https://github.com/SciML/LinearSolve.jl)
- GPU support:
  - [`CUDA.jl`](https://github.com/JuliaGPU/CUDA.jl)
- Distributed Computing support:
  - [`Distributed.jl`](https://github.com/JuliaLang/Distributed.jl)
  - [`SlurmClusterManager.jl`](https://github.com/JuliaParallel/SlurmClusterManager.jl)
- Plotting Libraries:
  - [`Makie.jl`](https://github.com/MakieOrg/Makie.jl)
- Automatic Differentiation:
  - [`SciMLSensitivity.jl`](https://github.com/SciML/SciMLSensitivity.jl)
  - [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl)
  - [`Enzyme.jl`](https://github.com/EnzymeAD/Enzyme.jl)
  - [`Mooncake.jl`](https://github.com/chalk-lab/Mooncake.jl)
  - [`Zygote.jl`](https://github.com/FluxML/Zygote.jl)
- Progress Bars:
  - [`ProgressMeter.jl`](https://github.com/timholy/ProgressMeter.jl)
- Packages for other advanced usage:
  - [`StaticArrays.jl`](https://github.com/JuliaArrays/StaticArrays.jl)
  - [`SciMLOperators.jl`](https://github.com/SciML/SciMLOperators.jl)
  - [`DiffEqCallbacks.jl`](https://github.com/SciML/DiffEqCallbacks.jl)

# [Quantum Objects (Qobj)](@id doc:Qobj)

## Introduction
The key difference between classical and quantum mechanics is the use of operators instead of numbers as variables. Moreover, we need to specify state vectors and their properties. Therefore, in computing the dynamics of quantum systems, we need a data structure that encapsulates the properties of a quantum operator and ket/bra vectors. The quantum object structure, [`QuantumObject`](@ref), accomplishes this using array representation.

[`QuantumObject`](@ref) supports general `Julia` arrays (`Base.AbstractArray`). For example, it can be:
- `Base.Vector` (dense vector)
- `Base.Matrix` (dense matrix)
- `SparseArrays.SparseVector` (sparse vector)
- `SparseArrays.SparseMatrixCSC` (sparse matrix)
- `CUDA.CuArray` (dense GPU vector / matrix)
- `CUDA.CUSPARSE.CuSparseVector` (sparse GPU vector)
- `CUDA.CUSPARSE.CuSparseMatrixCSC` (sparse GPU matrix)
- `CUDA.CUSPARSE.CuSparseMatrixCSR` (sparse GPU matrix)
- and even more ...

!!! note "Support for GPU arrays"
    See [CUDA extension](@ref doc:CUDA) for more details.

We can create a [`QuantumObject`](@ref) with a user defined data set by passing an array of data into the [`QuantumObject`](@ref):

```@setup Qobj
using QuantumToolbox
```

```@example Qobj
QuantumObject([1, 2, 3, 4, 5])
```

We can also use the same function [`Qobj`](@ref) in [`QuTiP` (`Python`)](https://github.com/qutip/qutip):

```@example Qobj
Qobj([1, 2, 3, 4, 5])
```

```@example Qobj
Qobj([1 2 3 4 5])
```

```@example Qobj
Qobj(rand(4, 4))
```

```@example Qobj
M = rand(ComplexF64, 4, 4)
Qobj(M, dims = [2, 2])  # dims as Vector
Qobj(M, dims = (2, 2))  # dims as Tuple (recommended)

import QuantumToolbox: SVector # or using StaticArrays
Qobj(M, dims = SVector(2, 2)) # dims as StaticArrays.SVector (recommended)
```

!!! warning "Beware of type-stability!"
    Please note that here we put the `dims` as a tuple `(2, 2)`. Although it supports also `Vector` type (`dims = [2, 2]`), it is recommended to use `Tuple` or `SVector` from [`StaticArrays.jl`](https://github.com/JuliaArrays/StaticArrays.jl) to improve performance. For a brief explanation on the impact of the type of `dims`, see the Section [The Importance of Type-Stability](@ref doc:Type-Stability).

```@example Qobj
Qobj(rand(4, 4), type = SuperOperator())
```

!!! note "Difference between `dims` and `size`"
    Notice that `type`, `dims`, and `size` will change according to the input `data`. Although `dims` and `size` appear to be the same, `dims` keep tracking the dimension of individual Hilbert spaces of a multipartite system, while `size` does not. We refer the reader to the section [Tensor Products and Partial Traces](@ref doc:Tensor-products-and-Partial-Traces) for more information.

## States and operators

Manually specifying the data for each quantum object is inefficient. Even more so when most objects correspond to commonly used types such as the ladder operators of a harmonic oscillator, the Pauli spin operators for a two-level system, or state vectors such as Fock states. Therefore, `QuantumToolbox` includes predefined functions to construct variety of states and operators (you can click the function links and see the corresponding docstring):

### States
- [`zero_ket`](@ref): zero ket vector
- [`fock`](@ref) or [`basis`](@ref): Fock state ket vector
- [`fock_dm`](@ref): density matrix of a Fock state
- [`coherent`](@ref): coherent state ket vector 
- [`rand_ket`](@ref): random ket vector
- [`coherent_dm`](@ref): density matrix of a coherent state
- [`thermal_dm`](@ref): density matrix of a thermal state
- [`maximally_mixed_dm`](@ref): density matrix of a maximally mixed state
- [`rand_dm`](@ref): random density matrix
- [`enr_fock`](@ref): Fock state in the excitation number restricted (ENR) space
- [`enr_thermal_dm`](@ref): thermal state in the excitation number restricted (ENR) space
- [`spin_state`](@ref): spin state
- [`spin_coherent`](@ref): coherent spin state
- [`bell_state`](@ref): Bell state
- [`singlet_state`](@ref): two particle singlet state
- [`triplet_states`](@ref): list of the two particle triplet states
- [`w_state`](@ref): `n`-qubit W-state
- [`ghz_state`](@ref): `n`-qudit GHZ state

### Operators
- [`eye`](@ref) or [`qeye`](@ref): identity operator
- [`destroy`](@ref): lowering (destruction) operator
- [`create`](@ref): raising (creation) operator
- [`projection`](@ref): projection operator
- [`displace`](@ref): displacement operator
- [`squeeze`](@ref): single-mode squeeze operator
- [`num`](@ref): bosonic number operator
- [`phase`](@ref): single-mode Pegg-Barnett phase operator
- [`QuantumToolbox.position`](@ref): position operator
- [`QuantumToolbox.momentum`](@ref): momentum operator
- [`rand_unitary`](@ref): random unitary operator
- [`sigmax`](@ref): Pauli-``X`` operator
- [`sigmay`](@ref): Pauli-``Y`` operator
- [`sigmaz`](@ref): Pauli-``Z`` operator
- [`sigmap`](@ref): Pauli ladder (``\sigma_+``) operator
- [`sigmam`](@ref): Pauli ladder (``\sigma_-``) operator
- [`jmat`](@ref): high-order Spin-`j` operator
- [`spin_Jx`](@ref): ``S_x`` operator for Spin-`j`
- [`spin_Jy`](@ref): ``S_y`` operator for Spin-`j`
- [`spin_Jz`](@ref): ``S_z`` operator for Spin-`j`
- [`spin_Jm`](@ref): ``S_-`` operator for Spin-`j`
- [`spin_Jp`](@ref): ``S_+`` operator for Spin-`j`
- [`spin_J_set`](@ref): a set of Spin-`j` operators ``(S_x, S_y, S_z)``
- [`fdestroy`](@ref): fermion destruction operator
- [`fcreate`](@ref): fermion creation operator
- [`enr_destroy`](@ref): destruction operator in the excitation number restricted (ENR) space
- [`enr_identity`](@ref): identity operator in the excitation number restricted (ENR) space
- [`commutator`](@ref): commutator or anti-commutator
- [`tunneling`](@ref): tunneling operator
- [`qft`](@ref): discrete quantum Fourier transform matrix

As an example, we give the output for a few of these functions:

```@example Qobj
basis(5, 3)
```

```@example Qobj
coherent(5, 0.5 - 0.5im)
```

```@example Qobj
destroy(4)
```

```@example Qobj
sigmaz()
```

## Qobj fields (attributes)

We have seen that a structure [`QuantumObject`](@ref) has several fields (attributes), such as `data`, `type` and `dims`. These can be accessed in the following way:

```@example Qobj
a = destroy(4)
a.data
```

```@example Qobj
a[2, 3] # the indexing in Julia starts from `1`
```

```@example Qobj
a.type
```

```@example Qobj
a.dims
```

In general, the properties of a [`QuantumObject`](@ref) can be retrieved using several functions with inputting [`QuantumObject`](@ref):

```@example Qobj
size(a)
```

```@example Qobj
shape(a) # synonym of size(a)
```

```@example Qobj
length(a)
```

```@example Qobj
eltype(a) # element type
```

```@example Qobj
println(isket(a)) # ket
println(isbra(a)) # bra
println(isoper(a)) # operator
println(isoperket(a)) # operator-ket
println(isoperbra(a)) # operator-bra
println(issuper(a)) # super operator
println(isconstant(a)) # time-independent or not
println(ishermitian(a)) # Hermitian
println(isherm(a)) # synonym of ishermitian(a)
println(issymmetric(a)) # symmetric
println(isposdef(a)) # positive definite (and Hermitian)
println(isunitary(a)) # unitary
```

### `data` conversions

As we mentioned above, `QuantumObject.data` supports general `Julia` arrays. The conversion between different type of `QuantumObject.data` is done using the standard type-conversion for arrays in `Julia`:

```@example Qobj
v_d = basis(2, 0)
```

```@example Qobj
Vector{Int64}(v_d)
```

```@example Qobj
using SparseArrays

v_s = SparseVector(v_d)
```

```@example Qobj
SparseVector{Float64}(v_s)
```

```@example Qobj
x_s = sigmax()
```

```@example Qobj
SparseMatrixCSC{Int64}(x_s)
```

```@example Qobj
Matrix{Float64}(x_s)
```

To convert between dense and sparse arrays, one can also use [`to_sparse`](@ref) and [`to_dense`](@ref):

```@example Qobj
x_d = to_dense(x_s)
```

```@example Qobj
to_sparse(x_d)
```

!!! note "Convert to GPU arrays"
    See [CUDA extension](@ref doc:CUDA) for more details.

`QuantumToolbox` will do conversion when needed to keep everything working in any format. However these conversions could slow down computation and it is recommended to keep to one format family where possible.

## Qobj math

The rules for mathematical operations on [`QuantumObject`](@ref) are similar to the standard scalar, vector, and matrix arithmetic:

```@example Qobj
a = destroy(4)
```

```@example Qobj
a' # synonym of adjoint(a)
```

```@example Qobj
a + 5
```

```@example Qobj
a' * a
```

```@example Qobj
a ^ 3
```

```@example Qobj
x = sigmax()
```

```@example Qobj
x / sqrt(2)
```

```@example Qobj
x ^ 3 == x
```

```@example Qobj
# type \approx + <TAB> to get symbol ≈
x ^ 3 ≈ x 
```

Of course, like matrices, multiplying two objects of incompatible `dims` or `size` throws an error:
```@repl Qobj
a * x
```

Note that there is a special case for multiplying [`Ket`](@ref) and [`Bra`](@ref), which results in outer product ``|u\rangle \otimes \langle v|``:

```@example Qobj
u = Qobj([1, 2, 3])
```

```@example Qobj
v = Qobj([4, 5, 6])
v'
```

```@example Qobj
u * v'
```

Of course, if you switch the order of multiplication, it becomes inner product ``\langle v | u \rangle``:
```@example Qobj
v' * u
```

# [Functions operating on Qobj](@id doc:Functions-operating-on-Qobj)

`QuantumToolbox` also provide functions (methods) that operates on [`QuantumObject`](@ref).

You can click the function links and see the corresponding docstring for more information.

## Linear algebra and attributes

Here is a table that summarizes all the supported linear algebra functions and attribute functions operating on a given [`QuantumObject`](@ref) `Q`:

| **Description** | **Function call** | **Synonyms** |
|:----------------|:------------------|:-------------|
| zero-like array | [`zero(Q)`](@ref zero) | [`qzero_like(Q)`](@ref qzero_like) |
| identity-like matrix | [`one(Q)`](@ref one) | [`qeye_like(Q)`](@ref qeye_like) |
| conjugate | [`conj(Q)`](@ref conj) | - |
| transpose | [`transpose(Q)`](@ref transpose) | [`trans(Q)`](@ref trans) |
| conjugate transposition | [`adjoint(Q)`](@ref adjoint) | [`Q'`](@ref adjoint), [`dag(Q)`](@ref dag) |
| partial transpose | [`partial_transpose(Q, mask)`](@ref partial_transpose) | - |
| dot product | [`dot(Q1, Q2)`](@ref dot) | - |
| generalized dot product | [`dot(Q1, Q2, Q3)`](@ref dot) | [`matrix_element(Q1, Q2, Q3)`](@ref matrix_element) |
| trace | [`tr(Q)`](@ref tr) | - |
| partial trace | [`ptrace(Q, sel)`](@ref ptrace) | - |
| singular values | [`svdvals(Q)`](@ref svdvals) | - |
| standard vector `p`-norm or [Schatten](https://en.wikipedia.org/wiki/Schatten_norm) `p`-norm | [`norm(Q, p)`](@ref norm) | - |
| normalization | [`normalize(Q, p)`](@ref normalize) | [`unit(Q, p)`](@ref unit) |
| normalization (in-place) | [`normalize!(Q, p)`](@ref normalize!) | - |
| matrix inverse | [`inv(Q)`](@ref inv) | - |
| matrix square root | [`sqrt(Q)`](@ref sqrt) | [`√(Q)`](@ref sqrt), [`sqrtm(Q)`](@ref sqrtm) |
| matrix logarithm | [`log(Q)`](@ref log) | [`logm(Q)`](@ref logm) |
| matrix exponential | [`exp(Q)`](@ref exp) | [`expm(Q)`](@ref expm) |
| matrix sine | [`sin(Q)`](@ref sin) | [`sinm(Q)`](@ref sinm) |
| matrix cosine | [`cos(Q)`](@ref cos) | [`cosm(Q)`](@ref cosm) |
| diagonal elements | [`diag(Q)`](@ref diag) | - |
| projector  | [`proj(Q)`](@ref proj) | - |
| purity | [`purity(Q)`](@ref purity) | - |
| permute | [`permute(Q, order)`](@ref permute) | - |
| remove small elements | [`tidyup(Q, tol)`](@ref tidyup) | - |
| remove small elements (in-place) | [`tidyup!(Q, tol)`](@ref tidyup!) | - |
| get data | [`get_data(Q)`](@ref get_data) | - |
| get coherence | [`get_coherence(Q)`](@ref get_coherence) | - |

## Eigenvalue decomposition

- [`eigenenergies`](@ref): return eigenenergies (eigenvalues)
- [`eigenstates`](@ref): return [`EigsolveResult`](@ref) (contains eigenvalues and eigenvectors)
- [`eigsolve`](@ref): using sparse eigen solver and return [`EigsolveResult`](@ref) (contains eigenvalues and eigenvectors)
- [`eigsolve_al`](@ref): using the Arnoldi-Lindblad eigen solver and return [`EigsolveResult`](@ref) (contains eigenvalues and eigenvectors)

## Examples

```@setup Qobj_Function
using QuantumToolbox
```

```@example Qobj_Function
ψ = normalize(basis(4, 1) + basis(4, 2))
```

```@example Qobj_Function
ψ'
```

```@example Qobj_Function
ρ = coherent_dm(5, 1)
```

```@example Qobj_Function
diag(ρ)
```

```@example Qobj_Function
get_data(ρ)
```

```@example Qobj_Function
norm(ρ)
```

```@example Qobj_Function
sqrtm(ρ)
```

```@example Qobj_Function
tr(ρ)
```

```@example Qobj_Function
eigenenergies(ρ)
```

```@example Qobj_Function
result = eigenstates(ρ)
```

```@example Qobj_Function
λ, ψ = result
λ # eigenvalues
```

```@example Qobj_Function
ψ # eigenvectors
```

```@example Qobj_Function
λ, ψ, T = result
T # transformation matrix
```

# [Two-time Correlation Functions](@id doc:Two-time-Correlation-Functions)

## Introduction

With the `QuantumToolbox.jl` time-evolution function [`mesolve`](@ref), a state vector ([`Ket`](@ref)) or density matrix ([`Operator`](@ref)) can be evolved from an initial state at ``t_0`` to an arbitrary time ``t``, namely

```math
\hat{\rho}(t) = \mathcal{G}(t, t_0)\{\hat{\rho}(t_0)\},
```
where ``\mathcal{G}(t, t_0)\{\cdot\}`` is the propagator defined by the equation of motion. The resulting density matrix can then be used to evaluate the expectation values of arbitrary combinations of same-time operators.

To calculate two-time correlation functions on the form ``\left\langle \hat{A}(t+\tau) \hat{B}(t) \right\rangle``, we can use the quantum regression theorem [see, e.g., [Gardiner-Zoller2004](@citet)] to write

```math
\left\langle \hat{A}(t+\tau) \hat{B}(t) \right\rangle = \textrm{Tr} \left[\hat{A} \mathcal{G}(t+\tau, t)\{\hat{B}\hat{\rho}(t)\} \right] = \textrm{Tr} \left[\hat{A} \mathcal{G}(t+\tau, t)\{\hat{B} \mathcal{G}(t, 0)\{\hat{\rho}(0)\}\} \right],
```

We therefore first calculate ``\hat{\rho}(t) = \mathcal{G}(t, 0)\{\hat{\rho}(0)\}`` using [`mesolve`](@ref) with ``\hat{\rho}(0)`` as initial state, and then again use [`mesolve`](@ref) to calculate ``\mathcal{G}(t+\tau, t)\{\hat{B}\hat{\rho}(t)\}`` using ``\hat{B}\hat{\rho}(t)`` as initial state.

Note that if the initial state is the steady state, then ``\hat{\rho}(t) = \mathcal{G}(t, 0)\{\hat{\rho}_{\textrm{ss}}\} = \hat{\rho}_{\textrm{ss}}`` and

```math
\left\langle \hat{A}(t+\tau) \hat{B}(t) \right\rangle = \textrm{Tr} \left[\hat{A} \mathcal{G}(t+\tau, t)\{\hat{B}\hat{\rho}_{\textrm{ss}}\} \right] = \textrm{Tr} \left[\hat{A} \mathcal{G}(\tau, 0)\{\hat{B} \hat{\rho}_{\textrm{ss}}\} \right] = \left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle,
```
which is independent of ``t``, so that we only have one time coordinate ``\tau``.

`QuantumToolbox.jl` provides a family of functions that assists in the process of calculating two-time correlation functions. The available functions and their usage is shown in the table below.

| **Function call** | **Correlation function** |
|:------------------|:-------------------------|
| [`correlation_2op_2t`](@ref) | ``\left\langle \hat{A}(t + \tau) \hat{B}(t) \right\rangle`` or ``\left\langle \hat{A}(t) \hat{B}(t + \tau) \right\rangle`` |
| [`correlation_2op_1t`](@ref) | ``\left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle`` or ``\left\langle \hat{A}(0) \hat{B}(\tau) \right\rangle`` |
| [`correlation_3op_1t`](@ref) | ``\left\langle \hat{A}(0) \hat{B}(\tau) \hat{C}(0) \right\rangle`` |
| [`correlation_3op_2t`](@ref) | ``\left\langle \hat{A}(t) \hat{B}(t + \tau) \hat{C}(t) \right\rangle`` |

The most common used case is to calculate the two time correlation function ``\left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle``, which can be done by [`correlation_2op_1t`](@ref).

```@setup correlation_and_spectrum
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

## Steadystate correlation function

The following code demonstrates how to calculate the ``\langle \hat{x}(t) \hat{x}(0)\rangle`` correlation for a leaky cavity with three different relaxation rates ``\gamma``.

```@example correlation_and_spectrum
tlist = LinRange(0, 10, 200)
a = destroy(10)
x = a' + a
H = a' * a

# if the initial state is specified as `nothing`, the steady state will be calculated and used as the initial state.
corr1 = correlation_2op_1t(H, nothing, tlist, [sqrt(0.5) * a], x, x)
corr2 = correlation_2op_1t(H, nothing, tlist, [sqrt(1.0) * a], x, x)
corr3 = correlation_2op_1t(H, nothing, tlist, [sqrt(2.0) * a], x, x)

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = L"Time $t$", ylabel = L"\langle \hat{x}(t) \hat{x}(0) \rangle")
lines!(ax, tlist, real(corr1), label = L"\gamma = 0.5", linestyle = :solid)
lines!(ax, tlist, real(corr2), label = L"\gamma = 1.0", linestyle = :dash)
lines!(ax, tlist, real(corr3), label = L"\gamma = 2.0", linestyle = :dashdot)

axislegend(ax, position = :rt)

fig
```

## Emission spectrum

Given a correlation function ``\left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle``, we can define the corresponding power spectrum as

```math
S(\omega) = \int_{-\infty}^\infty \left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle e^{-i \omega \tau} d \tau
```

In `QuantumToolbox.jl`, we can calculate ``S(\omega)`` using either [`spectrum`](@ref), which provides several solvers to perform the Fourier transform semi-analytically, or we can use the function [`spectrum_correlation_fft`](@ref) to numerically calculate the fast Fourier transform (FFT) of a given correlation data.

The following example demonstrates how these methods can be used to obtain the emission (``\hat{A} = \hat{a}^\dagger`` and ``\hat{B} = \hat{a}``) power spectrum.

```@example correlation_and_spectrum
N = 4             # number of cavity fock states
ωc = 1.0 * 2 * π  # cavity frequency
ωa = 1.0 * 2 * π  # atom frequency
g  = 0.1 * 2 * π  # coupling strength
κ  = 0.75         # cavity dissipation rate
γ  = 0.25         # atom dissipation rate

# Jaynes-Cummings Hamiltonian
a  = tensor(destroy(N), qeye(2))
sm = tensor(qeye(N), destroy(2))
H = ωc * a' * a + ωa * sm' * sm + g * (a' * sm + a * sm')

# collapse operators
n_th = 0.25
c_ops = [
    sqrt(κ * (1 + n_th)) * a,
    sqrt(κ *      n_th)  * a',
    sqrt(γ)              * sm,
];

# calculate the correlation function using mesolve, and then FFT to obtain the spectrum. 
# Here we need to make sure to evaluate the correlation function for a sufficient long time and 
# sufficiently high sampling rate so that FFT captures all the features in the resulting spectrum.
tlist = LinRange(0, 100, 5000)
corr = correlation_2op_1t(H, nothing, tlist, c_ops, a', a; progress_bar = Val(false))
ωlist1, spec1 = spectrum_correlation_fft(tlist, corr)

# calculate the power spectrum using spectrum
# using Exponential Series (default) method
ωlist2 = LinRange(0.25, 1.75, 200) * 2 * π
spec2 = spectrum(H, ωlist2, c_ops, a', a; solver = ExponentialSeries())

# calculate the power spectrum using spectrum
# using Pseudo-Inverse method
spec3 = spectrum(H, ωlist2, c_ops, a', a; solver = PseudoInverse())

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], title = "Vacuum Rabi splitting", xlabel = "Frequency", ylabel = "Emission power spectrum")
lines!(ax, ωlist1 / (2 * π), spec1, label = "mesolve + FFT", linestyle = :solid)
lines!(ax, ωlist2 / (2 * π), spec2, label = "Exponential Series", linestyle = :dash)
lines!(ax, ωlist2 / (2 * π), spec3, label = "Pseudo-Inverse", linestyle = :dashdot)

xlims!(ax, ωlist2[1] / (2 * π), ωlist2[end] / (2 * π))
axislegend(ax, position = :rt)

fig
```

## Non-steadystate correlation function

More generally, we can also calculate correlation functions of the kind ``\left\langle \hat{A}(t_1 + t_2) \hat{B}(t_1) \right\rangle``, i.e., the correlation function of a system that is not in its steady state. In `QuantumToolbox.jl`, we can evaluate such correlation functions using the function [`correlation_2op_2t`](@ref). The default behavior of this function is to return a matrix with the correlations as a function of the two time coordinates (``t_1`` and ``t_2``).

```@example correlation_and_spectrum
t1_list = LinRange(0, 10.0, 200)
t2_list = LinRange(0, 10.0, 200)

N = 10
a = destroy(N)
x = a' + a
H = a' * a

c_ops = [sqrt(0.25) * a]

α = 2.5
ρ0 = coherent_dm(N, α)

corr = correlation_2op_2t(H, ρ0, t1_list, t2_list, c_ops, x, x; progress_bar = Val(false))

# plot by CairoMakie.jl
fig = Figure(size = (500, 400))

ax = Axis(fig[1, 1], title = L"\langle \hat{x}(t_1 + t_2) \hat{x}(t_1) \rangle", xlabel = L"Time $t_1$", ylabel = L"Time $t_2$")

heatmap!(ax, t1_list, t2_list, real(corr))

fig
```

### Example: first-order optical coherence function

This example demonstrates how to calculate a correlation function on the form ``\left\langle \hat{A}(\tau) \hat{B}(0) \right\rangle`` for a non-steady initial state. Consider an oscillator that is interacting with a thermal environment. If the oscillator initially is in a coherent state, it will gradually decay to a thermal (incoherent) state. The amount of coherence can be quantified using the first-order optical coherence function

```math
g^{(1)}(\tau) = \frac{\left\langle \hat{a}^\dagger(\tau) \hat{a}(0) \right\rangle}{\sqrt{\left\langle \hat{a}^\dagger(\tau) \hat{a}(\tau) \right\rangle \left\langle \hat{a}^\dagger(0) \hat{a}(0)\right\rangle}}.
```
For a coherent state ``\vert g^{(1)}(\tau) \vert = 1``, and for a completely incoherent (thermal) state ``g^{(1)}(\tau) = 0``. The following code calculates and plots ``g^{(1)}(\tau)`` as a function of ``\tau``:

```@example correlation_and_spectrum
τlist = LinRange(0, 10, 200)

# Hamiltonian
N = 15
a = destroy(N)
H = 2 * π * a' * a

# collapse operator
G1 = 0.75
n_th = 2.00  # bath temperature in terms of excitation number
c_ops = [
    sqrt(G1 * (1 + n_th)) * a,
    sqrt(G1 *      n_th)  * a'
]

# start with a coherent state of α = 2.0
ρ0 = coherent_dm(N, 2.0)

# first calculate the occupation number as a function of time
n = mesolve(H, ρ0, τlist, c_ops, e_ops = [a' * a], progress_bar = Val(false)).expect[1,:]
n0 = n[1] # occupation number at τ = 0

# calculate the correlation function G1 and normalize with n to obtain g1
g1 = correlation_2op_1t(H, ρ0, τlist, c_ops, a', a, progress_bar = Val(false))
g1 = g1 ./ sqrt.(n .* n0)

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], title = "Decay of a coherent state to an incoherent (thermal) state", xlabel = L"Time $\tau$")
lines!(ax, τlist, real(g1), label = L"g^{(1)}(\tau)", linestyle = :solid)
lines!(ax, τlist, real(n), label = L"n(\tau)", linestyle = :dash)

axislegend(ax, position = :rt)

fig
```

### Example: second-order optical coherence function

The second-order optical coherence function, with time-delay ``\tau``, is defined as

```math
g^{(2)}(\tau) = \frac{\left\langle \hat{a}^\dagger(0) \hat{a}^\dagger(\tau) \hat{a}(\tau) \hat{a}(0) \right\rangle}{\left\langle \hat{a}^\dagger(0) \hat{a}(0) \right\rangle^2}.
```

For a coherent state ``g^{(2)}(\tau) = 1``, for a thermal state ``g^{(2)}(\tau = 0) = 2`` and it decreases as a function of time (bunched photons, they tend to appear together), and for a Fock state with ``n``-photons ``g^{(2)}(\tau = 0) = n(n-1)/n^2 < 1`` and it increases with time (anti-bunched photons, more likely to arrive separated in time).

To calculate this type of correlation function with `QuantumToolbox.jl`, we can use [`correlation_3op_1t`](@ref), which computes a correlation function on the form ``\left\langle \hat{A}(0) \hat{B}(\tau) \hat{C}(0) \right\rangle`` (three operators and one delay-time vector). We first have to combine the central two operators into one single one as they are evaluated at the same time, e.g. here we do ``\hat{B}(\tau) = \hat{a}^\dagger(\tau) \hat{a}(\tau) = (\hat{a}^\dagger\hat{a})(\tau)``.

The following code calculates and plots ``g^{(2)}(\tau)`` as a function of ``\tau`` for a coherent, thermal and Fock state:

```@example correlation_and_spectrum
τlist = LinRange(0, 25, 200)

# Hamiltonian
N = 25
a = destroy(N)
H = 2 * π * a' * a

κ = 0.25
n_th = 2.0  # bath temperature in terms of excitation number
c_ops = [
    sqrt(κ * (1 + n_th)) * a,
    sqrt(κ *      n_th)  * a'
]

cases = [
    Dict("state" => coherent_dm(N, sqrt(2)), "label" => "coherent state", "lstyle" => :solid),
    Dict("state" => thermal_dm(N, 2), "label" => "thermal state", "lstyle" => :dash),
    Dict("state" => fock_dm(N, 2), "label" => "Fock state", "lstyle" => :dashdot),
]

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = L"Time $\tau$", ylabel = L"g^{(2)}(\tau)")

for case in cases
    ρ0 = case["state"]

    # calculate the occupation number at τ = 0
    n0 = expect(a' * a, ρ0)

    # calculate the correlation function g2
    g2 = correlation_3op_1t(H, ρ0, τlist, c_ops, a', a' * a, a, progress_bar = Val(false))
    g2 = g2 ./ n0^2

    lines!(ax, τlist, real(g2), label = case["label"], linestyle = case["lstyle"])
end

axislegend(ax, position = :rt)

fig
```

# [Tensor Products and Partial Traces](@id doc:Tensor-products-and-Partial-Traces)

```@setup tensor_products
using QuantumToolbox
```

## [Tensor products](@id doc:Tensor-products)

To describe the states of multipartite quantum systems (such as two coupled qubits, a qubit coupled to an oscillator, etc.) we need to expand the Hilbert space by taking the tensor product of the state vectors for each of the system components. Similarly, the operators acting on the state vectors in the combined Hilbert space (describing the coupled system) are formed by taking the tensor product of the individual operators.

In `QuantumToolbox`, the function [`tensor`](@ref) (or [`kron`](@ref)) is used to accomplish this task. This function takes a collection of [`Ket`](@ref) or [`Operator`](@ref) as argument and returns a composite [`QuantumObject`](@ref) for the combined Hilbert space. The function accepts an arbitrary number of [`QuantumObject`](@ref) as argument. The `type` of returned [`QuantumObject`](@ref) is the same as that of the input(s).

A collection of [`QuantumObject`](@ref):
```@example tensor_products
tensor(sigmax(), sigmax(), sigmax())
```

or a `Vector{QuantumObject}`:

```@example tensor_products
op_list = fill(sigmax(), 3)
tensor(op_list)
```

!!! warning "Beware of type-stability!"
    Please note that `tensor(op_list)` or `kron(op_list)` with `op_list` is a `Vector` is type-instable and can hurt performance. It is recommended to use `tensor(op_list...)` or `kron(op_list...)` instead. See the Section [The Importance of Type-Stability](@ref doc:Type-Stability) for more details.

For example, the state vector describing two qubits in their ground states is formed by taking the tensor product of the two single-qubit ground state vectors:

```@example tensor_products
tensor(basis(2, 0), basis(2, 0))
```

One can generalize to more qubits by adding more component state vectors in the argument list to the [`tensor`](@ref) (or [`kron`](@ref)) function, as illustrated in the following example:

```@example tensor_products
states = QuantumObject[
    normalize(basis(2, 0) + basis(2, 1)),
    normalize(basis(2, 0) + basis(2, 1)),
    basis(2, 0)
]
tensor(states...)
```
This state is slightly more complicated, describing two qubits in a superposition between the up and down states, while the third qubit is in its ground state.

To construct operators that act on an extended Hilbert space of a combined system, we similarly pass a list of operators for each component system to the [`tensor`](@ref) (or [`kron`](@ref)) function. For example, to form the operator that represents the simultaneous action of the ``\hat{\sigma}_x`` operator on two qubits:

```@example tensor_products
tensor(sigmax(), sigmax())
```

To create operators in a combined Hilbert space that only act on a single component, we take the tensor product of the operator acting on the subspace of interest, with the identity operators corresponding to the components that are to be unchanged. For example, the operator that represents ``\hat{\sigma}_z`` on the first qubit in a two-qubit system, while leaving the second qubit unaffected:

```@example tensor_products
tensor(sigmaz(), qeye(2))
```

## Example: Constructing composite Hamiltonians

The [`tensor`](@ref) (or [`kron`](@ref)) function is extensively used when constructing Hamiltonians for composite systems. Here we’ll look at some simple examples.

### Two coupled qubits

First, let’s consider a system of two coupled qubits. Assume that both the qubits have equal energy splitting, and that the qubits are coupled through a ``\hat{\sigma}_x \otimes \hat{\sigma}_x`` interaction with strength ``g = 0.05`` (in units where the bare qubit energy splitting is unity). The Hamiltonian describing this system is:

```@example tensor_products
H = tensor(sigmaz(), qeye(2)) + 
    tensor(qeye(2), sigmaz()) + 
    0.05 * tensor(sigmax(), sigmax())
```

### Three coupled qubits

The two-qubit example is easily generalized to three coupled qubits:

```@example tensor_products
H = tensor(sigmaz(), qeye(2), qeye(2)) + 
    tensor(qeye(2), sigmaz(), qeye(2)) + 
    tensor(qeye(2), qeye(2), sigmaz()) + 
    0.5  * tensor(sigmax(), sigmax(), qeye(2)) + 
    0.25 * tensor(qeye(2), sigmax(), sigmax())
```

### A two-level system coupled to a cavity: The Jaynes-Cummings model

The simplest possible quantum mechanical description for light-matter interaction is encapsulated in the Jaynes-Cummings model, which describes the coupling between a two-level atom and a single-mode electromagnetic field (a cavity mode). Denoting the energy splitting of the atom and cavity ``\omega_a`` and ``\omega_c``, respectively, and the atom-cavity interaction strength ``g``, the Jaynes-Cummings Hamiltonian can be constructed as:

```math
H = \frac{\omega_a}{2}\hat{\sigma}_z + \omega_c \hat{a}^\dagger \hat{a} + g (\hat{a}^\dagger \hat{\sigma}_- + \hat{a} \hat{\sigma}_+)
```

```@example tensor_products
N = 6     # cavity fock space truncation
ωc = 1.25 # frequency of cavity
ωa = 1.0  # frequency of two-level atom
g = 0.75  # interaction strength

a = tensor(qeye(2), destroy(N)) # cavity annihilation operator

# two-level atom operators
σm = tensor(destroy(2), qeye(N))
σz = tensor(sigmaz(), qeye(N))

H = 0.5 * ωa * σz + ωc * a' * a + g * (a' * σm + a * σm')
```

## [Partial trace](@id doc:Partial-trace)

The partial trace is an operation that reduces the dimension of a Hilbert space by eliminating some degrees of freedom by averaging (tracing). In this sense it is therefore the converse of the tensor product. It is useful when one is interested in only a part of a coupled quantum system. For open quantum systems, this typically involves tracing over the environment leaving only the system of interest. In `QuantumToolbox` the function [`ptrace`](@ref) is used to take partial traces. [`ptrace`](@ref) takes one [`QuantumObject`](@ref) as an input, and also one argument `sel`, which marks the component systems that should be kept, and all the other components are traced out. 

Remember that the index of `Julia` starts from `1`, and all the elements in `sel` should be positive `Integer`. Therefore, the type of `sel` can be either `Integer`, `Tuple`, `SVector` ([StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl)), or `Vector`.

!!! warning "Beware of type-stability!"
    Although it supports also `Vector` type, it is recommended to use `Tuple` or `SVector` from [`StaticArrays.jl`](https://github.com/JuliaArrays/StaticArrays.jl) to improve performance. For a brief explanation on the impact of the type of `sel`, see the section [The Importance of Type-Stability](@ref doc:Type-Stability).

For example, the density matrix describing a single qubit obtained from a coupled two-qubit system is obtained via:

```@example tensor_products
ψ = tensor(
    basis(2, 0), 
    basis(2, 1), 
    normalize(basis(2, 0) + basis(2, 1))
)
```

```@example tensor_products
ptrace(ψ, 1) # trace out 2nd and 3rd systems
```

```@example tensor_products
ptrace(ψ, (1, 3)) # trace out 2nd system
```

Note that the partial trace always results in a [`Operator`](@ref) (density matrix), regardless of whether the composite system is a pure state (described by a [`Ket`](@ref)) or a mixed state (described by a [`Operator`](@ref)):

```@example tensor_products
ψ1 = normalize(basis(2, 0) + basis(2, 1))
ψ2 = basis(2, 0)
ψT = tensor(ψ1, ψ2)
```

```@example tensor_products
ptrace(ψT, 1)
```

```@example tensor_products
ρT = tensor(ket2dm(ψ1), ket2dm(ψ1))
```

```@example tensor_products
ptrace(ρT, 1)
```

# [Extension for the Makie.jl ecosystem](@id doc:Makie)

This is an extension to support visualization (plotting functions) using [`Makie.jl`](https://github.com/MakieOrg/Makie.jl) library.

This extension will be automatically loaded if user imports both `QuantumToolbox.jl` and [`Makie.jl`](https://github.com/MakieOrg/Makie.jl). It is worth noting that the `Makie.jl` package provides only the engine for plotting, and the user has to import the specific backend. Here we demonstrate the usage of [`CairoMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/CairoMakie), which will automatically import `Makie.jl`.

```julia
using QuantumToolbox
using CairoMakie
```

To plot with [`CairoMakie.jl`](https://github.com/MakieOrg/Makie.jl/tree/master/CairoMakie) library, specify the keyword argument `library = Val(:Makie)` for the plotting functions.

!!! warning "Beware of type-stability!"
    If you want to keep type stability, it is recommended to use `Val(:Makie)` instead of `:Makie`. See [this link](https://docs.julialang.org/en/v1/manual/performance-tips/#man-performance-value-type) and the [related Section](@ref doc:Type-Stability) about type stability for more details.

The supported plotting functions are listed as follows:

| **Plotting Function** | **Description** |
|:----------------------|:----------------|
| [`plot_wigner`](@ref) | [Wigner quasipropability distribution](https://en.wikipedia.org/wiki/Wigner_quasiprobability_distribution) |
| [`plot_fock_distribution`](@ref) | [Fock state](https://en.wikipedia.org/wiki/Fock_state) distribution |
| [`plot_bloch`](@ref) | [Plotting on the Bloch Sphere](@ref doc:Plotting-on-the-Bloch-Sphere) |
| [`matrix_heatmap`](@ref) | Plot a heatmap for the elements of a matrix |
| [`matrix_histogram`](@ref) | Plot a 3D histogram for the elements of a matrix |

# [Contributing to Quantum Toolbox in Julia](@id doc-Contribute)
[![Zulip](https://img.shields.io/badge/Zulip%20Chat-join-6f73af.svg)](https://quantumtoolbox-jl.zulipchat.com/#narrow/stream/General)

## [Quick Start](@id doc-Contribute:Quick-Start)

### [Git Tutorial](@id doc-Contribute:Git-Tutorial)

`QuantumToolbox.jl` is developed using the [`git`](https://git-scm.com/) version-control system, with the [main repository](https://github.com/qutip/QuantumToolbox.jl) hosted in the [qutip organisation on GitHub](https://github.com/qutip). You will need to be familiar with [`git`](https://git-scm.com/) as a tool, and the [GitHub Flow](https://docs.github.com/en/get-started/quickstart/github-flow) workflow for branching and making pull requests. The exact details of environment set-up, build process, and runtests vary by repository are discussed below. In overview, the steps to contribute are:

- Consider creating an issue on the GitHub page of the relevant repository, describing the change you think should be made and why, so we can discuss details with you and make sure it is appropriate.
- *__If this is your first contribution__*, make a fork of the relevant repository on GitHub (which will be called as `origin`) and clone it to your local computer. Also add our copy as a remote (let's call it `qutip` here): `git remote add qutip https://github.com/qutip/<repo-name>`.
- Start from the `main` branch in your local computer (`git checkout main`), and pull all the changes from the remote (`qutip`) repository (on GitHub) to make sure you have an up-to-date copy: `git pull qutip main`.
- Switch to a new `git` branch in your local computer: `git checkout -b <branch-name>`.
- Make the changes you want.
- Go through the following build processes (if the changes you made relates to any of them) locally in your computer to build the final result so you can check your changes work sensibly:
    - Write and make sure all the runtests pass. See [here](@ref doc-Contribute:Runtests) for more details.
    - Make sure all the changes match the `Julia` code format (style). See [here](@ref doc-Contribute:Julia-Code-Format) for more details.
    - Improve and make sure the documentation can be built successfully. See [here](@ref doc-Contribute:Documentation) for more details.
    - Update changelog. See [here](@ref doc-Contribute:ChangeLog) for more details.
- Add the changed files to the `git` staging area `git add <file1> <file2> ...`, and then create some commits with short-but-descriptive names: `git commit`.
- Push the changes to your fork (`origin`): `git push -u origin <branch-name>`. You won’t be able to push to the remote (`qutip`) repositories directly.
- Go to the GitHub website for the repository you are contributing to, click on the “Pull Requests” tab, click the “New Pull Request” button, and follow the instructions there.

Once the pull request (PR) is created, some members of the QuTiP admin team will review the code to make sure it is suitable for inclusion in the library, to check the programming, and to ensure everything meets our standards. For some repositories, several automated CI pipelines will run whenever you create or modify a PR. In general, these will basically be the same ones which you can run locally, and all CI pipelines are required to pass online before your changes are merged to the remote `main` branch. There might be some feedbacks and requested changes. You can add more commits to address these, and push them to the branch (`<branch-name>`) of your fork (`origin`) to update the PR.

### [Make Command](@id doc-Contribute:Make-Command)

!!! note "Install `make` in Windows"
    The `make` command is not available by default on Windows. You will need to install a compatible version of `make` (for example via Git-for-Windows, MSYS2, or similar tools). A helpful reference for setting this up can be found here: https://stackoverflow.com/questions/66525016/how-to-run-make-command-in-gitbash-in-windows

To simplify common developer tasks, `QuantumToolbox.jl` provides a set of predefined `make` commands. These commands are defined in the repository’s file called `Makefile` and offer a convenient interface for running documentation builds, tests, formatting, and other maintenance routines.

If you are contributing for the first time, or have installed a fresh `julia` version, you should begin with:

```shell
make setup
```

to install necessary dependencies. Here are several other common commands:

```shell
make test      # run the tests
make format    # format codes with Runic
make docs      # instantiate and build the documentation
make changelog # generate changelog
make help      # view all commands
```

Each command may accept additional options or environment variables to customize its behavior. The following sections describe these commands in detail and explain the available configuration options.

## [Programming Standards](@id doc-Contribute:Programming-Standards)

The rest of this document covers programming standards for `QuantumToolbox.jl`.

### [Runtests](@id doc-Contribute:Runtests)

All the test scripts should be located in the folder `test` in the repository. To run the test, use the following command under the *__root directory of the repository__* you are working on:

```shell
make test
```

This command will automatically rebuild `Julia` and run the script located in `test/runtests.jl` (should cover both the original tests and the new test(s) you add).

The tests are divided into several test groups, where the group names are defined in the file `test/runtests.jl` with a variable `GROUP`. One can also run the test scripts just for a certain test group by adding an argument `GROUP=<test-group-name>` to the `make test` command. For example, to run the tests for group `Core`, one can use the following command:

```shell
make GROUP=Core test
```

#### [Test Item Framework for Core tests](@id doc-Contribute:Test-Item-Framework-for-Core-tests)

The tests in `GROUP=Core` are provided using the [Test Item Framework](https://www.julia-vscode.org/docs/stable/userguide/testitems/), which structures the test codes into `@testitems` and makes it easier to run individually.

The [VS Code](https://code.visualstudio.com/) and its [Julia extension](https://www.julia-vscode.org/) provides us with options to run individual `@testitems`. It is much easier to find the specific core test that failed since the [Julia extension](https://www.julia-vscode.org/) in [VS Code](https://code.visualstudio.com/) will collect all core test failures and then display them in a structured way, directly at the place in the code where a specific core test failed. See [here](https://www.julia-vscode.org/docs/stable/userguide/testitems/) for more details.

### [Julia Code Format](@id doc-Contribute:Julia-Code-Format)

We use [`Runic.jl`](https://github.com/fredrikekre/Runic.jl) to format all the source codes.

To format the changed codes, use the following command under the *__root directory of the repository__* you are working on:

!!! note "Requirements"
    If this is your first time running `make` command in the local repository you are working on or you just had reinstalled `Julia`, you should run `make setup` first.

```shell
make format
```

### [Documentation](@id doc-Contribute:Documentation)

All the documentation source files [in markdown (`.md`) format] and build scripts should be located in the folder `docs` in the repository.

The document pages will be generated in the folder `docs/build/1/` (which is ignored by `git`) in the repository.

To instantiate and build the documentation, run the following command under the *__root directory of the repository__* you are working on:

!!! note "Requirements"
    You need to install `Node.js` and `npm` first.

```shell
make docs
```

This command will automatically rebuild `Julia` and run the script located in `docs/make.jl` (should be able to build the necessary files for the documentation).

One can also skip several processes in documentation build by adding arguments to the `make docs` command. For example,

```shell
make docs DOCTEST=false # skip doc tests
make docs DRAFT=true    # disable cell evaluation
```

To read the documentation in a browser, you can run the following command:

```shell
make vitepress
```

This will start a local Vitepress site of documentation at `http://localhost:5173` in your computer.

### [ChangeLog](@id doc-Contribute:ChangeLog)

The changelog is written in the file `CHANGELOG.md` in the repository. If you add some changes to the repository and made a PR, you should also add some messages or release notes together with the related PRs/issues entries to `CHANGELOG.md`. For example, add a new line in `CHANGELOG.md`:

```markdown
- some messages to describe the changes. ([#issue-ID], [#PR-ID])
```

See also the [ChangeLog page](@ref ChangeLog) for more examples.

After that, you can run the following command under the *__root directory of the repository__* you are working on:

!!! note "Requirements"
    If this is your first time running `make` command in the local repository you are working on or you just had reinstalled `Julia`, you should run `make setup` first.

```shell
make changelog
```

This will automatically generate the full URLs for the references to PRs/issues by utilizing [`Changelog.jl`](https://github.com/JuliaDocs/Changelog.jl).

If the changes you made are not necessary to be recorded in `CHANGELOG.md`, you can add the label `[Skip ChangeLog]` to the PR you made in the GitHub repository.

# [Intensive parallelization on a Cluster](@id doc:Intensive-parallelization-on-a-Cluster)

## Introduction

In this example, we will demonstrate how to seamlessly perform intensive parallelization on a cluster using the **QuantumToolbox.jl** package. Indeed, thanks to the [**Distributed.jl**](https://docs.julialang.org/en/v1/manual/distributed-computing/) and [**ClusterManagers.jl**](https://github.com/JuliaParallel/ClusterManagers.jl) packages, it is possible to parallelize on a cluster with minimal effort. The following examples are applied to a cluster with the [SLURM](https://slurm.schedmd.com/documentation.html) workload manager, but the same principles can be applied to other workload managers, as the [**ClusterManagers.jl**](https://github.com/JuliaParallel/ClusterManagers.jl) package is very versatile.

## SLURM batch script

To submit a batch script to [SLURM](https://slurm.schedmd.com/documentation.html), we start by creating a file named `run.batch` with the following content:

```bash
#!/bin/bash
#SBATCH --job-name=example
#SBATCH --output=output.out
#SBATCH --account=your_account
#SBATCH --nodes=10
#SBATCH --ntasks-per-node=1
#SBATCH --cpus-per-task=72
#SBATCH --mem=128GB
#SBATCH --time=0:10:00
#SBATCH --qos=parallel

# Set PATH to include the directory of your custom Julia installation
export PATH=/home/username/.juliaup/bin:$PATH

# Now run Julia
julia --project script.jl
```

where we have to replace `your_account` with the name of your account. This script will be used to submit the job to the cluster by using the following command in terminal:

```shell
sbatch run.batch
```

Here, we are requesting `10` nodes with `72` threads each (`720` parallel jobs). The `--time` flag specifies the maximum time that the job can run. To see all the available options, you can check the [SLURM documentation](https://slurm.schedmd.com/documentation.html). We also export the path to the custom Julia installation, which is necessary to run the script (replace `username` with your username). Finally, we run the script `script.jl` with the command `julia --project script.jl`.

In the following, we will consider two examples:

1. **Parallelization of a Monte Carlo quantum trajectories**
2. **Parallelization of a Master Equation by sweeping over parameters**

## Monte Carlo Quantum Trajectories

Let's consider a `2`-dimensional transverse field Ising model with `4x3` spins. The Hamiltonian is given by

```math
\hat{H} = \frac{J_z}{2} \sum_{\langle i,j \rangle} \hat{\sigma}_i^z \hat{\sigma}_j^z + h_x \sum_i \hat{\sigma}_i^x \, ,
```

where the sums are over nearest neighbors, and the collapse operators are given by 

```math
\hat{c}_i = \sqrt{\gamma} \hat{\sigma}_i^- \, .
```

In this case, the `script.jl` contains the following content:

```julia
using Distributed
using ClusterManagers

const SLURM_NUM_TASKS = parse(Int, ENV["SLURM_NTASKS"])
const SLURM_CPUS_PER_TASK = parse(Int, ENV["SLURM_CPUS_PER_TASK"])

exeflags = ["--project=.", "-t $SLURM_CPUS_PER_TASK"]
addprocs(SlurmManager(SLURM_NUM_TASKS); exeflags=exeflags, topology=:master_worker)


println("################")
println("Hello! You have $(nworkers()) workers with $(remotecall_fetch(Threads.nthreads, 2)) threads each.")

println("----------------")


println("################")

flush(stdout)

@everywhere begin
    using QuantumToolbox
    using OrdinaryDiffEq

    BLAS.set_num_threads(1)
end

# Define lattice

Nx = 4
Ny = 3
latt = Lattice(Nx = Nx, Ny = Ny)

# Define Hamiltonian and collapse operators
Jx = 0.0
Jy = 0.0
Jz = 1.0
hx = 0.2
hy = 0.0
hz = 0.0
γ = 1

Sx = mapreduce(i -> multisite_operator(latt, i=>sigmax()), +, 1:latt.N)
Sy = mapreduce(i -> multisite_operator(latt, i=>sigmay()), +, 1:latt.N)
Sz = mapreduce(i -> multisite_operator(latt, i=>sigmaz()), +, 1:latt.N)

H, c_ops = DissipativeIsing(Jx, Jy, Jz, hx, hy, hz, γ, latt; boundary_condition = Val(:periodic_bc), order = 1)
e_ops = [Sx, Sy, Sz]

# Time Evolution

ψ0 = fock(2^latt.N, 0, dims = ntuple(i->2, Val(latt.N)))

tlist = range(0, 10, 100)

sol_mc = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj=5000, ensemblealg=EnsembleSplitThreads())

##

println("FINISH!")

rmprocs(workers())
```

In this script, we first load the necessary packages for distributed computing on the cluster (`Distributed.jl` and `ClusterManagers.jl`). Thanks to the environment variables (previously defined in the SLURM script), we can define the number of tasks and the number of CPUs per task. Then, we initialize the distributed network with the `addprocs(SlurmManager(SLURM_NUM_TASKS); exeflags=exeflags, topology=:master_worker)` command. We then import the packages with the `@everywhere` macro, meaning to load them in all the workers. Moreover, in order to avoid conflicts between the multithreading of the BLAS library and the native Julia multithreading, we set the number of threads of the BLAS library to 1 with the `BLAS.set_num_threads(1)` command. More information about this can be found [here](https://docs.julialang.org/en/v1/manual/performance-tips/#man-multithreading-linear-algebra).

With the

```julia
println("Hello! You have $(nworkers()) workers with $(remotecall_fetch(Threads.nthreads, 2)) threads each.")
```

command, we test that the distributed network is correctly initialized. The `remotecall_fetch(Threads.nthreads, 2)` command returns the number of threads of the worker with ID `2`.

We then write the main part of the script, where we define the lattice through the [`Lattice`](@ref) function. We set the parameters and define the Hamiltonian and collapse operators with the [`DissipativeIsing`](@ref) function. We also define the expectation operators `e_ops` and the initial state `ψ0`. Finally, we perform the Monte Carlo quantum trajectories with the [`mcsolve`](@ref) function. The `ensemblealg=EnsembleSplitThreads()` argument is used to parallelize the Monte Carlo quantum trajectories, by splitting the ensemble of trajectories among the workers. For a more detailed explanation of the different ensemble methods, you can check the [official documentation](https://docs.sciml.ai/DiffEqDocs/stable/features/ensemble/) of the [**DifferentialEquations.jl**](https://github.com/SciML/DifferentialEquations.jl/) package. Finally, the `rmprocs(workers())` command is used to remove the workers after the computation is finished.

The output of the script will be printed in the `output.out` file, which contains an output similar to the following:

```
################
Hello! You have 10 workers with 72 threads each.
----------------
################

Progress: [==============================] 100.0% --- Elapsed Time: 0h 00m 21s (ETA: 0h 00m 00s)

FINISH!
```

where we can see that the computation **lasted only 21 seconds**.

## Master Equation by Sweeping Over Parameters

In this example, we will consider a driven Jaynes-Cummings model, describing a two-level atom interacting with a driven cavity mode. The Hamiltonian is given by

```math
\hat{H} = \omega_c \hat{a}^\dagger \hat{a} + \frac{\omega_q}{2} \hat{\sigma}_z + g (\hat{a} \hat{\sigma}_+ + \hat{a}^\dagger \hat{\sigma}_-) + F \cos(\omega_d t) (\hat{a} + \hat{a}^\dagger) \, ,
```

and the collapse operators are given by

```math
\hat{c}_1 = \sqrt{\gamma} \hat{a} \, , \quad \hat{c}_2 = \sqrt{\gamma} \hat{\sigma}_- \, .
```

The SLURM batch script file is the same as before, but the `script.jl` file now contains the following content:

```julia
using Distributed
using ClusterManagers

const SLURM_NUM_TASKS = parse(Int, ENV["SLURM_NTASKS"])
const SLURM_CPUS_PER_TASK = parse(Int, ENV["SLURM_CPUS_PER_TASK"])

exeflags = ["--project=.", "-t $SLURM_CPUS_PER_TASK"]
addprocs(SlurmManager(SLURM_NUM_TASKS); exeflags=exeflags, topology=:master_worker)


println("################")
println("Hello! You have $(nworkers()) workers with $(remotecall_fetch(Threads.nthreads, 2)) threads each.")

println("----------------")


println("################")

flush(stdout)

@everywhere begin
    using QuantumToolbox
    using OrdinaryDiffEq

    BLAS.set_num_threads(1)
end

@everywhere begin
    Nc = 20
    ωc = 1.0
    g = 0.05
    γ = 0.01
    F = 0.01

    a = tensor(destroy(Nc), qeye(2))

    σm = tensor(qeye(Nc), sigmam())
    σp = tensor(qeye(Nc), sigmap())
    σz = tensor(qeye(Nc), sigmaz())

    ωq_fun(p, t) = p[1] # ωq
    drive_fun(p, t) = p[3] * cos(p[2] * t) # F cos(ωd t)

    H = ωc * a' * a + QobjEvo(σz / 2, ωq_fun) + g * (a' * σm + a * σp) + QobjEvo(a + a', drive_fun)

    c_ops = [sqrt(γ) * a, sqrt(γ) * σm]
    e_ops = [a' * a]
end

ωq_list = range(ωc - 3*g, ωc + 3*g, 100)
ωd_list = range(ωc - 3*g, ωc + 3*g, 100)
F_list = [F]

ψ_list = [
    tensor(fock(Nc, 0), basis(2, 0)),
    tensor(fock(Nc, 0), basis(2, 1))
]
tlist = range(0, 20 / γ, 1000)

sol = mesolve_map(H, ψ_list, tlist, c_ops; e_ops = e_ops, params = (ωq_list, ωd_list, F_list), ensemblealg = EnsembleSplitThreads())
```

Notice that we are using the [`mesolve_map`](@ref) function, which internally uses the `SciMLBase.EnsembleProblem` function to parallelize the computation of [`mesolveProblem`](@ref). The result is an `Array` of [`TimeEvolutionSol`](@ref), where each element corresponds to a specific combination of initial states and parameters. One can access the solution for a specific combination of initial states and parameters using indexing. For example,

```julia
sol[i,j,k,l].expect
```

this will give the expectation values for the case of `ψ_list[i]`, `ωq_list[j]`, `ωd_list[k]`, and `F_list[l]`.

# [QuantumToolbox Settings](@id doc:QuantumToolbox-Settings)

In this section, we introduce the default global settings used throughout the package and show how to modify them.

All settings are stored in [`QuantumToolbox.settings`](@ref).

!!! warning "Differences from QuTiP"
    Due to the differences in programming languages, solving algorithms, and many other reasons, these global settings (including their default values and usage) may be very different from those in `Python QuTiP`.

## List of settings

Here, we list out each setting along with the specific functions that will use it.

- `tidyup_tol::Float64 = 1.0e-14` : tolerance for [`tidyup`](@ref), [`tidyup!`](@ref) and [`to_sparse`](@ref).
- `auto_tidyup::Bool = true` : Automatically tidyup during the following situations:
    * Solving for eigenstates, including [`eigenstates`](@ref), [`eigsolve`](@ref), [`eigsolve_al`](@ref)
    * Creating [`bloch_redfield_tensor`](@ref) or [`brterm`](@ref), and solving [`brmesolve`](@ref).
- `ProgressMeterKWARGS::NamedTuple = (showspeed = true, printed = true)` : Default keyword arguments for progress bar in [`ProgressMeter.jl`](https://github.com/timholy/ProgressMeter.jl). This allows the customization of progress bar.
- (to be announced)

## Change default settings

First, we can check the current [`QuantumToolbox.settings`](@ref):

```@example settings
using QuantumToolbox

QuantumToolbox.settings
```

Next, one can overwrite the default settings by

```@example settings
QuantumToolbox.settings.tidyup_tol = 1e-10
QuantumToolbox.settings.auto_tidyup = false

QuantumToolbox.settings
```

# [Stochastic Solver](@id doc-TE:Stochastic-Solver)

When a quantum system is subjected to continuous measurement, through homodyne detection for example, it is possible to simulate the conditional quantum state using stochastic Schrödinger and master equations. The solution of these stochastic equations are quantum trajectories, which represent the conditioned evolution of the system given a specific measurement record.

## [Stochastic Schrödinger equation](@id doc-TE:Stochastic-Schrödinger-equation)

The stochastic Schrödinger time evolution of a quantum system is defined by the following stochastic differential equation [Wiseman2009Quantum; section 4.4](@cite):

```math
d|\psi(t)\rangle = -i \hat{K} |\psi(t)\rangle dt + \sum_n \hat{M}_n |\psi(t)\rangle dW_n(t)
```

where 

```math
\hat{K} = \hat{H} + i \sum_n \left(\frac{e_n}{2} \hat{S}_n - \frac{1}{2} \hat{S}_n^\dagger \hat{S}_n - \frac{e_n^2}{8}\right),
```
```math
\hat{M}_n = \hat{S}_n - \frac{e_n}{2},
```
and
```math
e_n = \langle \psi(t) | \hat{S}_n + \hat{S}_n^\dagger | \psi(t) \rangle.
```

Above, ``\hat{H}`` is the Hamiltonian, ``\hat{S}_n`` are the stochastic collapse operators, and  ``dW_n(t)`` is the real Wiener increment (associated to ``\hat{S}_n``) which has the expectation values of ``E[dW_n]=0`` and ``E[dW_n^2]=dt``.

The solver [`ssesolve`](@ref) will construct the operators ``\hat{K}`` and ``\hat{M}_n``. Once the user passes the Hamiltonian (``\hat{H}``) and the stochastic collapse operators list (`sc_ops`; ``\{\hat{S}_n\}_n``). As with the [`mcsolve`](@ref), the number of trajectories and the random number generator for the noise realization can be fixed using the arguments: `ntraj` and `rng`, respectively.

## [Stochastic master equation](@id doc-TE:Stochastic-master-equation)

When the initial state of the system is a density matrix ``\rho(0)``, or when additional loss channels are included, the stochastic master equation solver [`smesolve`](@ref) must be used. The stochastic master equation is given by [Wiseman2009Quantum; section 4.4](@cite):

```math
d \rho (t) = -i [\hat{H}, \rho(t)] dt + \sum_i \mathcal{D}[\hat{C}_i] \rho(t) dt + \sum_n \mathcal{D}[\hat{S}_n] \rho(t) dt + \sum_n \mathcal{H}[\hat{S}_n] \rho(t) dW_n(t),
```

where

```math
\mathcal{D}[\hat{O}] \rho = \hat{O} \rho \hat{O}^\dagger - \frac{1}{2} \{\hat{O}^\dagger \hat{O}, \rho\},
```

is the Lindblad superoperator, and

```math
\mathcal{H}[\hat{O}] \rho = \hat{O} \rho + \rho \hat{O}^\dagger - \mathrm{Tr}[\hat{O} \rho + \rho \hat{O}^\dagger] \rho,
```

The above implementation takes into account 2 types of collapse operators. ``\hat{C}_i`` (`c_ops`) represent the collapse operators related to pure dissipation, while ``\hat{S}_n`` (`sc_ops`) are the stochastic collapse operators. The first three terms on the right-hand side of the above equation is the deterministic part of the evolution which takes into account all operators ``\hat{C}_i`` and ``\hat{S}_n``. The last term (``\mathcal{H}[\hat{S}_n] \rho(t)``) is the stochastic part given solely by the operators ``\hat{S}_n``.


## [Example: Homodyne detection](@id doc-TE:Example:Homodyne-detection)

First, we solve the dynamics for an optical cavity at absolute zero (``0K``) whose output is monitored using homodyne detection. The cavity decay rate is given by ``\kappa`` and the ``\Delta`` is the cavity detuning with respect to the driving field. The homodyne current ``J_x`` is calculated using

```math
J_x = \langle \hat{x} \rangle + dW/dt,
```

where ``\hat{x}`` is the operator build from the `sc_ops` as

```math
\hat{x} = \hat{S} + \hat{S}^\dagger
```

```@setup stochastic-solve
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

```@example stochastic-solve
# parameters
N = 20         # Fock space dimension
Δ = 5 * 2 * π  # cavity detuning
κ = 2          # cavity decay rate
α = 4          # intensity of initial state
ntraj = 500    # number of trajectories

tlist = 0:0.0025:1

# operators
a = destroy(N)
x = a + a'
H = Δ * a' * a

# initial state
ψ0 = coherent(N, √α)

# temperature with average of 0 excitations (absolute zero)
n_th = 0
# c_ops  = [√(κ * n_th) * a'] -> nothing
sc_ops = [√(κ * (n_th + 1)) * a]
```

In this case, there is no additional dissipation (`c_ops = nothing`), and thus, we can use the [`ssesolve`](@ref):

```@example stochastic-solve
sse_sol = ssesolve(
    H,
    ψ0,
    tlist,
    sc_ops,
    e_ops = [x],
    ntraj = ntraj,
    store_measurement = Val(true),
)

measurement_avg = sum(sse_sol.measurement, dims=2) / size(sse_sol.measurement, 2)
measurement_avg = dropdims(measurement_avg, dims=2)

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = "Time")
lines!(ax, tlist[1:end-1], real(measurement_avg[1,:]), label = L"J_x", color = :red, linestyle = :solid)
lines!(ax, tlist, real(sse_sol.expect[1,:]),  label = L"\langle x \rangle", color = :black, linestyle = :solid)

axislegend(ax, position = :rt)

fig
```

Next, we consider the same model but at a finite temperature to demonstrate [`smesolve`](@ref):

```@example stochastic-solve
# temperature with average of 1 excitations
n_th = 1
c_ops  = [√(κ * n_th) * a']
sc_ops = [√(κ * (n_th + 1)) * a]

sme_sol = smesolve(
    H,
    ψ0,
    tlist,
    c_ops,
    sc_ops,
    e_ops = [x],
    ntraj = ntraj,
    store_measurement = Val(true),
)

measurement_avg = sum(sme_sol.measurement, dims=2) / size(sme_sol.measurement, 2)
measurement_avg = dropdims(measurement_avg, dims=2)

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = "Time")
lines!(ax, tlist[1:end-1], real(measurement_avg[1,:]), label = L"J_x", color = :red, linestyle = :solid)
lines!(ax, tlist, real(sme_sol.expect[1,:]),  label = L"\langle x \rangle", color = :black, linestyle = :solid)

axislegend(ax, position = :rt)

fig
```

# [Bloch-Redfield master equation](@id doc-TE:Bloch-Redfield-master-equation)

The [Lindblad master equation](@ref doc-TE:Lindblad-Master-Equation-Solver) introduced earlier is constructed so that it describes a physical evolution of the density matrix (i.e., trace and positivity preserving), but it does not provide a connection to any underlying microscopic physical model. The Lindblad operators (collapse operators) describe phenomenological processes, such as for example dephasing and spin flips, and the rates of these processes are arbitrary parameters in the model. In many situations the collapse operators and their corresponding rates have clear physical interpretation, such as dephasing and relaxation rates, and in those cases the Lindblad master equation is usually the method of choice.

However, in some cases, for example systems with varying energy biases and eigenstates and that couple to an environment in some well-defined manner (through a physically motivated system-environment interaction operator), it is often desirable to derive the master equation from more fundamental physical principles, and relate it to for example the noise-power spectrum of the environment.

The Bloch-Redfield formalism is one such approach to derive a master equation from a microscopic system. It starts from a combined system-environment perspective, and derives a perturbative master equation for the system alone, under the assumption of weak system-environment coupling. One advantage of this approach is that the dissipation processes and rates are obtained directly from the properties of the environment. On the downside, it does not intrinsically guarantee that the resulting master equation unconditionally preserves the physical properties of the density matrix (because it is a perturbative method). The Bloch-Redfield master equation must therefore be used with care, and the assumptions made in the derivation must be honored. (The Lindblad master equation is in a sense more robust -- it always results in a physical density matrix -- although some collapse operators might not be physically justified). For a full derivation of the Bloch Redfield master equation, see e.g. [Cohen_Tannoudji_atomphoton](@citet) or [breuer2002](@citet). Here we present only a brief version of the derivation, with the intention of introducing the notation and how it relates to the implementation in `QuantumToolbox.jl`.


## [Brief Derivation and Definitions](@id doc-TE:Brief-Derivation-and-Definitions)

The starting point of the Bloch-Redfield formalism is the total Hamiltonian for the system and the environment (bath): ``\hat{H} = \hat{H}_{\rm S} + \hat{H}_{\rm B} + \hat{H}_{\rm I}``, where ``\hat{H}`` is the total system+bath Hamiltonian, ``\hat{H}_{\rm S}`` and ``\hat{H}_{\rm B}`` are the system and bath Hamiltonians, respectively, and ``\hat{H}_{\rm I}`` is the interaction Hamiltonian.

The most general form of a master equation for the system dynamics is obtained by tracing out the bath from the von-Neumann equation of motion for the combined system (``\frac{d}{dt}\hat{\rho} = -i\hbar^{-1}[\hat{H}, \hat{\rho}]``). In the interaction picture the result is

```math
    \frac{d}{dt}\hat{\rho}_{\textrm{S}}(t) = - \hbar^{-2}\int_0^t d\tau\;  \textrm{Tr}_{\textrm{B}} [\hat{H}_{\textrm{I}}(t), [\hat{H}_{\textrm{I}}(\tau), \hat{\rho}_{\textrm{S}}(\tau)\otimes\hat{\rho}_{\textrm{B}}]],
```

where the additional assumption that the total system-bath density matrix can be factorized as ``\hat{\rho}(t) \approx \hat{\rho}_{\textrm{S}}(t) \otimes \hat{\rho}_{\textrm{B}}``. This assumption is known as the Born approximation, and it implies that there never is any entanglement between the system and the bath, neither in the initial state nor at any time during the evolution. *It is justified for weak system-bath interaction.*

The master equation above is non-Markovian, i.e., the change in the density matrix at a time ``t`` depends on states at all times ``\tau < t``, making it intractable to solve both theoretically and numerically. To make progress towards a manageable master equation, we now introduce the Markovian approximation, in which ``\hat{\rho}_{\textrm{S}}(\tau)`` is replaced by ``\hat{\rho}_{\textrm{S}}(t)``. The result is the Redfield equation

```math
    \frac{d}{dt}\hat{\rho}_{\textrm{S}}(t) = - \hbar^{-2}\int_0^t d\tau\; \textrm{Tr}_{\textrm{B}} [\hat{H}_{\textrm{I}}(t), [\hat{H}_{\textrm{I}}(\tau), \hat{\rho}_{\textrm{S}}(t)\otimes\hat{\rho}_{\textrm{B}}]],
```

which is local in time with respect the density matrix, but still not Markovian since it contains an implicit dependence on the initial state. By extending the integration to infinity and substituting ``\tau \rightarrow t-\tau``, a fully Markovian master equation is obtained:

```math
    \frac{d}{dt}\hat{\rho}_{\textrm{S}}(t) = - \hbar^{-2}\int_0^\infty d\tau\; \textrm{Tr}_{\textrm{B}} [\hat{H}_{\textrm{I}}(t), [\hat{H}_{\textrm{I}}(t-\tau), \hat{\rho}_{\textrm{S}}(t)\otimes\hat{\rho}_{\textrm{B}}]].
```

The two Markovian approximations introduced above are valid if the time-scale with which the system dynamics changes is large compared to the time-scale with which correlations in the bath decays (corresponding to a "short-memory" bath, which results in Markovian system dynamics).

The Markovian master equation above is still on a too general form to be suitable for numerical implementation. We therefore assume that the system-bath interaction takes the form ``\hat{H}_{\textrm{I}} = \sum_\alpha \hat{A}_\alpha \otimes \hat{B}_\alpha`` and where ``\hat{A}_\alpha`` are system operators and ``\hat{B}_\alpha`` are bath operators. This allows us to write master equation in terms of system operators and bath correlation functions:

```math
\begin{split}\frac{d}{dt}\hat{\rho}_{\textrm{S}}(t) =
-\hbar^{-2}
\sum_{\alpha\beta}
\int_0^\infty d\tau\;
\left\{
g_{\alpha\beta}(\tau) \left[\hat{A}_\alpha(t)\hat{A}_\beta(t-\tau)\hat{\rho}_{\textrm{S}}(t) - \hat{A}_\beta(t-\tau)\hat{\rho}_{\textrm{S}}(t)\hat{A}_\alpha(t)\right]
\right. \nonumber\\
\left.
+ g_{\alpha\beta}(-\tau) \left[\hat{\rho}_{\textrm{S}}(t)\hat{A}_\alpha(t-\tau)\hat{A}_\beta(t) - \hat{A}_\beta(t)\hat{\rho}_{\textrm{S}}(t)\hat{A}_\beta(t-\alpha)\right]
\right\},\end{split}
```

where ``g_{\alpha\beta}(\tau) = \textrm{Tr}_{\textrm{B}}\left[\hat{B}_\alpha(t)\hat{B}_\beta(t-\tau)\hat{\rho}_{\textrm{B}}\right] = \langle\hat{B}_\alpha(\tau)\hat{B}_\beta(0)\rangle``, since the bath state ``\hat{\rho}_{\textrm{B}}`` is a steady state.

In the eigenbasis of the system Hamiltonian, where ``A_{mn}(t) = A_{mn} e^{i\omega_{mn}t}``, ``\omega_{mn} = \omega_m - \omega_n`` and ``\omega_m`` are the eigenfrequencies corresponding to the eigenstate ``|m\rangle``, we obtain in matrix form in the Schrödinger picture

```math
\begin{aligned}
    \frac{d}{dt} \rho_{ab}(t) = & -i\omega_{ab}\rho_{ab}(t)\\
    &-\hbar^{-2} \sum_{\alpha,\beta} \sum_{c,d}^{\textrm{sec}} \int_0^\infty d\tau\;
    \left\{
    g_{\alpha\beta}(\tau)
    \left[\delta_{bd}\sum_nA^\alpha_{an}A^\beta_{nc}e^{i\omega_{cn}\tau}
    -
    A^\beta_{ac} A^\alpha_{db} e^{i\omega_{ca}\tau}
    \right]
    \right. \\
    &+
    \left.
    g_{\alpha\beta}(-\tau)
    \left[\delta_{ac}\sum_n A^\alpha_{dn}A^\beta_{nb} e^{i\omega_{nd}\tau}
    -
    A^\beta_{ac}A^\alpha_{db}e^{i\omega_{bd}\tau}
    \right]
    \right\} \rho_{cd}(t),
\end{aligned}
```

where the "sec" above the summation symbol indicate summation of the secular terms which satisfy ``|\omega_{ab}-\omega_{cd}| \ll \tau_ {\rm decay}``. This is an almost-useful form of the master equation. The final step before arriving at the form of the Bloch-Redfield master equation that is implemented in `QuantumToolbox.jl`, involves rewriting the bath correlation function ``g(\tau)`` in terms of the noise-power spectrum of the environment ``S(\omega) = \int_{-\infty}^\infty d\tau e^{i\omega\tau} g(\tau)``:

```math
    \int_0^\infty d\tau\; g_{\alpha\beta}(\tau) e^{i\omega\tau} = \frac{1}{2}S_{\alpha\beta}(\omega) + i\lambda_{\alpha\beta}(\omega),
```

where ``\lambda_{ab}(\omega)`` is an energy shift that is neglected here. The final form of the Bloch-Redfield master equation is

```math
    \frac{d}{dt}\rho_{ab}(t)
    =
    -i\omega_{ab}\rho_{ab}(t)
    +
    \sum_{c,d}^{\textrm{sec}}R_{abcd}\rho_{cd}(t),
```

where

```math
\begin{aligned}
    R_{abcd} =  -\frac{\hbar^{-2}}{2} \sum_{\alpha,\beta}
    \left\{
    \delta_{bd}\sum_nA^\alpha_{an}A^\beta_{nc}S_{\alpha\beta}(\omega_{cn})
    -
    A^\beta_{ac} A^\alpha_{db} S_{\alpha\beta}(\omega_{ca})
    \right. \nonumber\\
    +
    \left.
    \delta_{ac}\sum_n A^\alpha_{dn}A^\beta_{nb} S_{\alpha\beta}(\omega_{dn})
    -
    A^\beta_{ac}A^\alpha_{db} S_{\alpha\beta}(\omega_{db})
    \right\},
\end{aligned}
```

is the Bloch-Redfield tensor.

The Bloch-Redfield master equation in this form is suitable for numerical implementation. The input parameters are the system Hamiltonian ``\hat{H}_{\textrm{S}}``, the system operators through which the environment couples to the system ``\hat{A}_\alpha``, and the noise-power spectrum ``S_{\alpha\beta}(\omega)`` associated with each system-environment interaction term.

To simplify the numerical implementation we often assume that ``\hat{A}_\alpha`` are Hermitian and that cross-correlations between different environment operators vanish, resulting in

```math
\begin{aligned}
    R_{abcd} =  -\frac{\hbar^{-2}}{2} \sum_{\alpha}
    \left\{
    \delta_{bd}\sum_nA^\alpha_{an}A^\alpha_{nc}S_{\alpha}(\omega_{cn})
    -
    A^\alpha_{ac} A^\alpha_{db} S_{\alpha}(\omega_{ca})
    \right. \nonumber\\
    +
    \left.
    \delta_{ac}\sum_n A^\alpha_{dn}A^\alpha_{nb} S_{\alpha}(\omega_{dn})
    -
    A^\alpha_{ac}A^\alpha_{db} S_{\alpha}(\omega_{db})
    \right\}.
\end{aligned}
```

## [Bloch-Redfield master equation in `QuantumToolbox.jl`](@id Bloch-Redfield-master-equation-in-QuantumToolbox-jl)

### Preparing the Bloch-Redfield tensor

In `QuantumToolbox.jl`, the Bloch-redfield master equation can be calculated using the function [`bloch_redfield_tensor`](@ref). It takes two mandatory arguments: The system Hamiltonian ``\hat{H}`` and a nested list `a_ops` consist of tuples as `(A, spec)` with `A::QuantumObject` being the [`Operator`](@ref) ``\hat{A}_\alpha`` and `spec::Function` being the spectral density function ``S_\alpha(\omega)``.

It is possible to also get the ``\alpha``-th term for the bath directly using [`brterm`](@ref). This function takes only one Hermitian coupling operator ``\hat{A}_\alpha`` and spectral response function ``S_\alpha(\omega)``.

To illustrate how to calculate the Bloch-Redfield tensor, let's consider a two-level atom

```math
    \hat{H}_{\textrm{S}} = -\frac{1}{2}\Delta\hat{\sigma}_x - \frac{1}{2}\varepsilon_0\hat{\sigma}_z
```

```@setup brmesolve
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

```@example brmesolve
Δ  = 0.2 * 2π
ε0 = 1.0 * 2π
γ1 = 0.5

H = -Δ/2.0 * sigmax() - ε0/2 * sigmaz()

ohmic_spectrum(ω) = (ω == 0.0) ? γ1 : γ1 / 2 * (ω / (2 * π)) * (ω > 0.0)

R, U = bloch_redfield_tensor(H, ((sigmax(), ohmic_spectrum), ))

R
```

Note that it is also possible to add Lindblad dissipation superoperators in the Bloch-Refield tensor by passing the operators via the third argument `c_ops` like you would in the [`mesolve`](@ref) or [`mcsolve`](@ref) functions. For convenience, when the keyword argument `fock_basis = false`, the function [`bloch_redfield_tensor`](@ref) also returns the basis transformation operator `U`, the eigen vector matrix, since they are calculated in the process of generating the Bloch-Redfield tensor `R`, and the `U` are usually needed again later when transforming operators between the laboratory basis and the eigen basis. The tensor can be obtained in the laboratory basis by setting `fock_basis = true`, in that case, the transformation operator `U` is not returned.

### Time evolution

The evolution of a wave function or density matrix, according to the Bloch-Redfield master equation, can be calculated using the function [`mesolve`](@ref) with Bloch-Refield tensor `R` in the laboratory basis instead of a [`liouvillian`](@ref). For example, to evaluate the expectation values of the ``\hat{\sigma}_x``, ``\hat{\sigma}_y``, and ``\hat{\sigma}_z`` operators for the example above, we can use the following code:

```@example brmesolve
Δ = 0.2 * 2 * π
ϵ0 = 1.0 * 2 * π
γ1 = 0.5

H = - Δ/2.0 * sigmax() - ϵ0/2.0 * sigmaz()

ohmic_spectrum(ω) = (ω == 0.0) ? γ1 : γ1 / 2 * (ω / (2 * π)) * (ω > 0.0)

a_ops = ((sigmax(), ohmic_spectrum),)
R = bloch_redfield_tensor(H, a_ops; fock_basis = Val(true))

e_ops = [sigmax(), sigmay(), sigmaz()]

# same initial random ket state in QuTiP doc 
ψ0 = Qobj([
    0.05014193+0.66000276im,
    0.67231376+0.33147603im
])

tlist = LinRange(0, 15.0, 1000)
sol = mesolve(R, ψ0, tlist, e_ops=e_ops)
expt_list = real(sol.expect)

# plot the evolution of state on Bloch sphere
sphere = Bloch()
add_points!(sphere, [expt_list[1,:], expt_list[2,:], expt_list[3,:]])
sphere.vector_color = ["red"]

add_vectors!(sphere, [Δ, 0, ϵ0] / √(Δ^2 + ϵ0^2))

fig, _ = render(sphere)
fig
```

The two steps of calculating the Bloch-Redfield tensor `R` and evolving according to the corresponding master equation can be combined into one by using the function [`brmesolve`](@ref), in addition to the same arguments as [`mesolve`](@ref) and [`mcsolve`](@ref), the nested list of operator-spectrum tuple should be given under `a_ops`.

```@example brmesolve
sol = brmesolve(H, ψ0, tlist, ((sigmax(),ohmic_spectrum),); e_ops=e_ops)
```

The resulting `sol` is of the `struct` [`TimeEvolutionSol`](@ref) as [`mesolve`](@ref).

!!! note "Secular cutoff"
    While the code example simulates the Bloch-Redfield equation in the secular approximation, `QuantumToolbox`'s implementation allows the user to simulate the non-secular version of the Bloch-Redfield equation by setting `sec_cutoff=-1`, as well as do a partial secular approximation by setting it to a `Float64` , this float number will become the cutoff for the summation (``\sum_{c,d}^{\textrm{sec}}``) in the previous equations, meaning that terms with ``\omega_{ab} - \omega_{cd}`` greater than the `sec_cutoff` will be neglected. Its default value is `0.1` which corresponds to the secular approximation. 
    
For example, the command

```julia
sol = brmesolve(H, ψ0, tlist, ((sigmax(),ohmic_spectrum),); e_ops=e_ops, sec_cutoff=-1)
```

will simulate the same example as above without the secular approximation.

!!! warning "Secular cutoff"
    Using the non-secular version may lead to negativity issues.

# [Time Evolution and Quantum System Dynamics](@id doc:Time-Evolution-and-Quantum-System-Dynamics)

**Table of contents**

- [Introduction](@ref doc-TE:Introduction)
- [Time Evolution Solutions](@ref doc-TE:Time-Evolution-Solutions)
    - [Solution](@ref doc-TE:Solution)
    - [Accessing data in solutions](@ref doc-TE:Accessing-data-in-solutions)
    - [Multiple trajectories solution](@ref doc-TE:Multiple-trajectories-solution)
- [Schrödinger Equation Solver](@ref doc-TE:Schrödinger-Equation-Solver)
    - [Unitary evolution](@ref doc-TE:Unitary-evolution)
    - [Example: Spin dynamics](@ref doc-TE:Example:Spin-dynamics)
- [Lindblad Master Equation Solver](@ref doc-TE:Lindblad-Master-Equation-Solver)
    - [Von Neumann equation](@ref doc-TE:Von-Neumann-equation)
    - [The Lindblad master equation](@ref doc-TE:The-Lindblad-master-equation)
    - [Example: Dissipative Spin dynamics](@ref doc-TE:Example:Dissipative-Spin-dynamics)
    - [Example: Harmonic oscillator in thermal bath](@ref doc-TE:Example:Harmonic-oscillator-in-thermal-bath)
    - [Example: Two-level atom coupled to dissipative single-mode cavity](@ref doc-TE:Example:Two-level-atom-coupled-to-dissipative-single-mode-cavity)
- [Monte Carlo Solver](@ref doc-TE:Monte-Carlo-Solver)
    - [Monte Carlo wave-function](@ref doc-TE:Monte-Carlo-wave-function)
    - [Example: Two-level atom coupled to dissipative single-mode cavity (MC)](@ref doc-TE:Example:Two-level-atom-coupled-to-dissipative-single-mode-cavity-(MC))
    - [Running trajectories in parallel](@ref doc-TE:Running-trajectories-in-parallel)
- [Stochastic Solver](@ref doc-TE:Stochastic-Solver)
    - [Stochastic Schrödinger equation](@ref doc-TE:Stochastic-Schrödinger-equation)
    - [Stochastic master equation](@ref doc-TE:Stochastic-master-equation)
    - [Example: Homodyne detection](@ref doc-TE:Example:Homodyne-detection)
- [Solving Problems with Time-dependent Hamiltonians](@ref doc-TE:Solving-Problems-with-Time-dependent-Hamiltonians)
    - [Generate QobjEvo](@ref doc-TE:Generate-QobjEvo)
    - [QobjEvo fields (attributes)](@ref doc-TE:QobjEvo-fields-(attributes))
    - [Using parameters](@ref doc-TE:Using-parameters)
- [Bloch-Redfield master equation](@ref doc-TE:Bloch-Redfield-master-equation)
    - [Brief Derivation and Definitions](@ref doc-TE:Brief-Derivation-and-Definitions)
    - [Bloch-Redfield master equation in `QuantumToolbox.jl`](@ref Bloch-Redfield-master-equation-in-QuantumToolbox-jl)
- [Computing propagators](@ref doc-TE:Computing-propagators)


# [Introduction](@id doc-TE:Introduction)

Although in some cases, we want to find the stationary states of a quantum system, often we are interested in the dynamics: how the state of a system or an ensemble of systems evolves with time. `QuantumToolbox` provides many ways to model dynamics.

There are two kinds of quantum systems: open systems that interact with a larger environment and closed systems that do not. In a closed system, the state can be described by a state vector. When we are modeling an open system, or an ensemble of systems, the use of the density matrix is mandatory.

The following table lists the solvers provided by `QuantumToolbox` for dynamic quantum systems and the corresponding type of solution returned by the solver:

| **Equation** | **Function Call** | **Problem** | **Returned Solution** |
|:-------------|:------------------|:------------|:----------------------|
| Unitary evolution, Schrödinger equation | [`sesolve`](@ref) | [`sesolveProblem`](@ref) | [`TimeEvolutionSol`](@ref) |
| Lindblad master eqn. or Von Neuman eqn.| [`mesolve`](@ref) | [`mesolveProblem`](@ref) | [`TimeEvolutionSol`](@ref) |
| Monte Carlo evolution | [`mcsolve`](@ref) | [`mcsolveProblem`](@ref) [`mcsolveEnsembleProblem`](@ref) | [`TimeEvolutionMCSol`](@ref) |
| Stochastic Schrödinger equation | [`ssesolve`](@ref) | [`ssesolveProblem`](@ref) [`ssesolveEnsembleProblem`](@ref) | [`TimeEvolutionStochasticSol`](@ref) |
| Stochastic master equation | [`smesolve`](@ref) | [`smesolveProblem`](@ref) [`smesolveEnsembleProblem`](@ref) | [`TimeEvolutionStochasticSol`](@ref) |
| Bloch-Redfield master equation | [`brmesolve`](@ref) | - | [`TimeEvolutionSol`](@ref) |

!!! note "Solving dynamics with pre-defined problems"
    `QuantumToolbox` provides two different methods to solve the dynamics. One can use the function calls listed above by either taking all the operators (like Hamiltonian and collapse operators, etc.) as inputs directly, or generating the `prob`lems by yourself and take it as an input of the function call, e.g., `sesolve(prob)`.

# [Example: Create QuantumToolbox.jl logo](@id doc:Create-QuantumToolbox.jl-logo)

## Introduction

In this example, we will demonstrate how to create the logo for the **QuantumToolbox.jl** package. The logo represents the Wigner function of the triangular cat state, which is a linear superposition of three coherent states. The resulting Wigner function has a triangular shape that resembles the Julia logo. We will also define a custom colormap that varies based on the value of the Wigner function and the spatial coordinates, such that the three blobs corresponding to the coherent states have different colors (matching the colors of the Julia logo).

### Triangular Cat State

A cat state, often referred to as a Schrödinger cat state, is a quantum state that is a superposition of two coherent states with opposite phases:

```math
| \psi_{\text{cat}} \rangle = \frac{1}{\sqrt{2}} \left( | \alpha \rangle + | -\alpha \rangle \right)
```

where ``| \alpha \rangle`` is a coherent state with amplitude ``\alpha``.

The triangular cat state is a generalization of the standard cat state. It is a superposition of three coherent states with phases ``\theta_0, \theta_1, \theta_2`` separated by ``120^\circ`` (or ``2\pi/3``radians):

```math
| \psi_{\text{tri-cat}} \rangle = \frac{1}{\sqrt{3}} \left( | \alpha_0 \rangle + | \alpha_1 \rangle + | \alpha_2 \rangle \right)
```

where ``\alpha_j = \rho e^{i\theta_j}`` with ``\theta_j = \frac{\pi}{2} + \frac{2\pi j}{3}`` and ``j = 0, 1, 2``.

### Wigner Function

The Wigner function ``W(x, p)`` is a quasi-probability distribution used in quantum mechanics to represent quantum states in phase space. It is defined as:

```math
W(x, p) = \frac{1}{\pi \hbar} \int_{-\infty}^{\infty} \psi^*(x + y) \psi(x - y) e^{2ipy / \hbar} \, dy
```

where ``\psi(x)`` is the wave function of the quantum state, ``x`` is the position, ``p`` is the momentum, and ``\hbar`` is the reduced Planck constant. Unlike classical probability distributions, the Wigner function can take negative values, which indicates non-classical behavior.

## Generating the Logo

First, let's load the required packages:

```@example logo
using QuantumToolbox
using CairoMakie
CairoMakie.activate!(type = "svg", pt_per_unit = 1)
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

### Parameters

Here we define the parameters for the triangular cat state:

```@example logo
N = 30  # Cutoff of the Hilbert space for the harmonic oscillator
ρ = 2.5  # Amplitude of the coherent state
θ1 = π / 2
θ2 = π / 2 + 2π / 3
θ3 = π / 2 + 4π / 3
α1 = ρ * exp(im * θ1)
α2 = ρ * exp(im * θ2)
α3 = ρ * exp(im * θ3)
```

### Constructing the State

Next, we construct the triangular cat state as a normalized superposition of three coherent states:

```@example logo
ψ = coherent(N, α1) + coherent(N, α2) + coherent(N, α3)
normalize!(ψ)
```

### Defining the Grid and plotting the Wigner function

We define the grid for the Wigner function and plot it using the [`plot_wigner`](@ref) function. This, internally calls the [`wigner`](@ref) function for the computation. We shift the grid in the imaginary direction to ensure that the Wigner function is centered around the origin of the figure. The [`wigner`](@ref) function also supports the `g` scaling factor, which we put here equal to ``2``.

```@example logo
xvec = range(-ρ, ρ, 500) .* 1.5
yvec = xvec .+ (abs(imag(α1)) - abs(imag(α2))) / 2

fig = Figure(size = (250, 250), figure_padding = 0)
fig, ax, hm = plot_wigner(ψ, xvec = xvec, yvec = yvec, g = 2, library = Val(:Makie), location = fig[1,1])
hidespines!(ax)
hidexdecorations!(ax)
hideydecorations!(ax)
fig
```

#### Introducing some decoherence

The figure obtained above coulb be already a potential logo for the package. However, we see that the fringe patterns are more intense than the three coherent gaussian amplitudes. We can introduce some decoherence to reduce this effect. Thus, we evolve the system under the evolution of a damped quantum harmonic oscillator, which is described by the Lindblad master equation:

```math
\frac{d \hat{\rho}}{dt} = -i [\hat{H}, \hat{\rho}] + \gamma \left( 2 \hat{a} \hat{\rho} \hat{a}^\dagger - \hat{a}^\dagger \hat{a} \hat{\rho} - \hat{\rho} \hat{a}^\dagger \hat{a} \right)
```

where ``\hat{\rho}`` is the density matrix, ``\hat{H} = \omega \hat{a}^\dagger \hat{a}`` is the Hamiltonian of the harmonic oscillator (``\hbar = 1``), ``\hat{a}`` and ``\hat{a}^\dagger`` are the annihilation and creation operators, and ``\gamma`` is the damping rate. Thus, we initialize the system in the triangular cat state and evolve it under the [Lindblad master equation](@ref doc-TE:Lindblad-Master-Equation-Solver), using the [`mesolve`](@ref) function.

```@example logo
γ = 0.012

a = destroy(N)
H = a' * a
c_ops = [sqrt(γ) * a]

tlist = range(0, 2π, 100)

sol = mesolve(H, ψ, tlist, c_ops, progress_bar = Val(false))
nothing # hide
```

And the Wigner function becomes more uniform:

```@example logo
fig = Figure(size = (250, 250), figure_padding = 0)
fig, ax, hm = plot_wigner(sol.states[end], xvec = xvec, yvec = yvec, g = 2, library = Val(:Makie), location = fig[1,1])
hidespines!(ax)
hidexdecorations!(ax)
hideydecorations!(ax)

fig
```

At this stage, we have finished to use the `QuantumToolbox` package. From now on, we will use the `CairoMakie` package to define custom colormaps and plot the Wigner function in a Julia logo style.

### Custom Colormap

We define a custom colormap that changes depending on the Wigner function and spatial coordinates. Indeed, we want the three different colormaps, in the regions corresponding to the three coherent states, to match the colors of the Julia logo. We also want the colormap change to be smooth, so we use a Gaussian function to blend the colors. We introduce also a Wigner function dependent transparency to make the logo more appealing. In order to do so, we are going to need the value of the wigner function at each point of the grid, rather than its plot. We will thus call the [`wigner`](@ref) function directly.

```@example logo
function set_color_julia(x, y, wig::T, α1, α2, α3, cmap1, cmap2, cmap3, δ) where {T}
    amp1 = gaussian(x, real(α1), δ) * gaussian(y, imag(α1), δ)
    amp2 = gaussian(x, real(α2), δ) * gaussian(y, imag(α2), δ)
    amp3 = gaussian(x, real(α3), δ) * gaussian(y, imag(α3), δ)

    c1 = get(cmap1, wig)
    c2 = get(cmap2, wig)
    c3 = get(cmap3, wig)

    c_tot = (amp1 * c1 + amp2 * c2 + amp3 * c3) / (amp1 + amp2 + amp3)

    wig_abs = abs(2 * (wig - 1 / 2))
    # We introduce some non-linearity to increase the contrast
    alpha = 2 * (1 / (1 + exp(-5 * wig_abs)) - 1 / 2)

    return RGBAf(c_tot.r, c_tot.g, c_tot.b, alpha)
end

wig = wigner(sol.states[end], xvec, yvec, g = 2)
X, Y = meshgrid(xvec, yvec)
δ = 1.25 # Smoothing parameter for the Gaussian functions
```

#### Colormaps from the Julia colors

We define the colormaps for the three coherent states using the colors of the Julia logo. We use the `cgrad` function from the `CairoMakie` package to create the colormaps.

```@example logo
julia_red = RGBAf(0.796, 0.235, 0.2, 1.0)
julia_green = RGBAf(0.22, 0.596, 0.149, 1.0)
julia_blue = RGBAf(0.251, 0.388, 0.847, 1.0)
julia_purple = RGBAf(0.584, 0.345, 0.698, 1.0)
n_repeats = 2

cmap1 = cgrad(vcat(fill(julia_blue, n_repeats), fill(julia_green, n_repeats)))
cmap2 = cgrad(vcat(fill(julia_blue, n_repeats), fill(julia_red, n_repeats)))
cmap3 = cgrad(vcat(fill(julia_blue, n_repeats), fill(julia_purple, n_repeats)))
```

### Normalizing the Wigner function and applying the custom colormap

The colormaps require the input to be in the range ``[0, 1]``. We normalize the Wigner function such that the maximum value is ``1`` and the zeros are set to ``0.5``.

```@example logo
vmax = maximum(wig)
wig_normalized = wig ./ (vmax * 2) .+ 1 / 2
nothing # hide
```

And we now apply this custom colormap to make an image (a `Matrix{RGBAf}`).

```@example logo
img = set_color_julia.(X, Y, wig_normalized, α1, α2, α3, Ref(cmap1), Ref(cmap2), Ref(cmap3), δ)
```

### Final Plot

Finally, we plot the Wigner function with the custom colormap.

```@example logo
fig = Figure(size = (250, 250), figure_padding = 0, backgroundcolor = :transparent)
ax = Axis(fig[1, 1], backgroundcolor = :transparent)
image!(ax, img', rasterize = 1)
hidespines!(ax)
hidexdecorations!(ax)
hideydecorations!(ax)
fig
```

## Conclusion

This example demonstrates how to generate the [QuantumToolbox.jl](https://github.com/qutip/QuantumToolbox.jl) logo using the package itself and [Makie.jl](https://github.com/MakieOrg/Makie.jl) for visualization. The logo is a visualization of the Wigner function of a triangular cat state, with a custom colormap that highlights the different coherent states with colors matching the Julia logo.

# [Solving Problems with Time-dependent Hamiltonians](@id doc-TE:Solving-Problems-with-Time-dependent-Hamiltonians)

```@setup QobjEvo
using QuantumToolbox

using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())
```

## [Generate QobjEvo](@id doc-TE:Generate-QobjEvo)

In the previous examples of solving time evolution, we assumed that the systems under consideration were described by time-independent Hamiltonians. However, many systems have explicit time dependence in either the Hamiltonian, or the collapse operators (`c_ops`) describing coupling to the environment, and sometimes both components might depend on time. The time evolution solvers such as [`sesolve`](@ref), [`mesolve`](@ref), etc., are all capable of handling time-dependent Hamiltonians and collapse operators.

`QuantumToolbox.jl` uses [`QuantumObjectEvolution`](@ref) (or the abbreviated synonym: [`QobjEvo`](@ref)) to represent time-dependent quantum operators, and its `data` field (attribute) takes advantage of [`SciMLOperators.jl`](https://docs.sciml.ai/SciMLOperators/stable/).

To generate a time-dependent operator [`QobjEvo`](@ref), one needs to specify a time-independent [`Qobj`](@ref) together with a time-dependent coefficient function with the form `coef(p, t)`, namely

```@example QobjEvo
coef(p, t) = sin(t)

H_t = QobjEvo(sigmax(), coef)
```

!!! warning "The inputs of coefficient function"
    Please note that although we didn't use the argument `p` in the definition of `coef`, we still need to put a dummy input `p` (in front of `t`) in the declaration of `coef`. We will describe how to use the parameter `p` in the section [Using parameters](@ref doc-TE:Using-parameters).

The [`QobjEvo`](@ref) can also be generated by specifying many pairs of time-independent [`Qobj`](@ref) and time-dependent coefficient function. For instance, we will look at a case with the total Hamiltonian ``\hat{H}(t)`` can be separate into time-independent part (``\hat{H}_0``) and a summation of many time-dependent operators, which takes the form:

```math
\hat{H}(t) = \hat{H}_0 + \sum_j f_j(t) \hat{H}_j.
```

The following code sets up this problem by using a `Tuple` which contains many time-dependent pairs `(H_j, f_j)`, namely

```@example QobjEvo
H0 = qeye(2)

H1 = sigmax()
f1(p, t) = sin(t)

H2 = sigmay()
f2(p, t) = cos(t)

H3 = sigmaz()
f3(p, t) = 9 * exp(-(t / 5)^2)

H_tuple = (
    H0,
    (H1, f1),
    (H2, f2),
    (H3, f3),
)

H_t = QobjEvo(H_tuple)
```

This is equivalent by generating the [`QobjEvo`](@ref) separately and `+` (or `sum`) them up:

```@example QobjEvo
H_t == H0 + QobjEvo(H1, f1) + QobjEvo(H2, f2) + QobjEvo(H3, f3)
```

Most solvers will accept any format that could be made into a [`QobjEvo`](@ref) for the Hamiltonian. All of the followings are equivalent:

```julia
sol = mesolve(H_t, ...)
sol = mesolve(H_tuple, ...)
```

Collapse operators `c_ops` only accept a list where each element is either a [`Qobj`](@ref) or a [`QobjEvo`](@ref). For example, in the following call:

```julia
γ1 = sqrt(0.1)
γ2(p, t) = sqrt(sin(t))
c_ops = (
    γ1 * sigmaz(),
    QobjEvo(sigmax() + sigmay(), γ2)
)

sol = mesolve(H_t, ..., c_ops, ...)
```

[`mesolve`](@ref) will see `2` collapse operators: ``\sqrt{0.1} \hat{\sigma}_z`` and ``\sqrt{\sin(t)} (\hat{\sigma}_x + \hat{\sigma}_y)``.

As an example, we will look at a case with a time-dependent Hamiltonian of the form ``\hat{H}(t) = \hat{H}_0 + f_1(t) \hat{H}_1``, where ``f_1(t) = A \exp \left[ -(t / \sigma)^2 \right]`` is the time-dependent driving strength. The following code sets up the problem

```@example QobjEvo
N = 2 # Set where to truncate Fock state for cavity

# basis states for Atom
u = basis(3, 0) #       u state
e = basis(3, 1) # excited state
g = basis(3, 2) #  ground state

# operators
g_e = tensor(qeye(N), g * e')  # |g><e|
u_e = tensor(qeye(N), u * e')  # |u><e|
u_u = tensor(qeye(N), u * u')  # |u><u|
g_g = tensor(qeye(N), g * g')  # |g><g|
a = tensor(destroy(N), qeye(3))

# Hamiltonian
g = 5  # coupling strength
H0 = -g * (g_e' * a + a' * g_e)
H1 = u_e' + u_e
f1(p, t) = 9 * exp(-(t / 5)^2)
H_t = QobjEvo(
    (
        H0,
        (H1, f1)
    )
)

# Build collapse operators
κ = 1.5 # Cavity decay rate
γ0 = 6   # Atomic decay rate
c_ops = [
    sqrt(κ) * a,
    sqrt(4 * γ0 / 9) * g_e, # Use Rb branching ratio of 4/9 e -> g
    sqrt(5 * γ0 / 9) * u_e  # 5/9 e -> u
]

tlist = LinRange(0, 4, 200) # Define time vector
ψ0 = tensor(basis(N, 0), u) # Define initial state

# Build observables
e_ops = [
    a' * a,
    u_u,
    g_g
]

# solve dynamics 
exp_me = mesolve(H_t, ψ0, tlist, c_ops; e_ops = e_ops, progress_bar = Val(false)).expect
exp_mc = mcsolve(H_t, ψ0, tlist, c_ops; e_ops = e_ops, ntraj = 100, progress_bar = Val(false)).expect

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = L"Time $t$", ylabel = "expectation value")
lines!(ax, tlist, real(exp_me[1,:]), label = L"$\hat{a}^\dagger \hat{a}$ (mesolve)", color = :red, linestyle = :solid)
lines!(ax, tlist, real(exp_mc[1,:]), label = L"$\hat{a}^\dagger \hat{a}$ (mcsolve)", color = :red, linestyle = :dash)
lines!(ax, tlist, real(exp_me[2,:]), label = L"$|u \rangle\langle u|$ (mesolve)", color = :green, linestyle = :solid)
lines!(ax, tlist, real(exp_mc[2,:]), label = L"$|u \rangle\langle u|$ (mcsolve)", color = :green, linestyle = :dash)
lines!(ax, tlist, real(exp_me[3,:]), label = L"$|g \rangle\langle g|$ (mesolve)", color = :blue, linestyle = :solid)
lines!(ax, tlist, real(exp_mc[3,:]), label = L"$|g \rangle\langle g|$ (mcsolve)", color = :blue, linestyle = :dash)

axislegend(ax, position = :rc)

fig
```

The result from [`mesolve`](@ref) is identical to that shown in the examples, the [`mcsolve`](@ref) however will be noticeably off, suggesting we should increase the number of trajectories `ntraj = 100` for this example.

In addition, we can also consider the decay of a simple Harmonic oscillator with time-varying decay rate ``\gamma_1(t)``

```@example QobjEvo
N = 10  # number of basis states
a = destroy(N)
H = a' * a

ψ0 = basis(N, 9)  # initial state

γ0 = 0.5
γ1(p, t) = sqrt(γ0 * exp(-t))
c_ops_ti = [sqrt(γ0) * a]   # time-independent collapse term
c_ops_td = [QobjEvo(a, γ1)] # time-dependent   collapse term

e_ops = [a' * a]

tlist = LinRange(0, 10, 100)
exp_ti = mesolve(H, ψ0, tlist, c_ops_ti, e_ops = e_ops; progress_bar = Val(false)).expect[1,:]
exp_td = mesolve(H, ψ0, tlist, c_ops_td, e_ops = e_ops; progress_bar = Val(false)).expect[1,:]

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], xlabel = L"Time $t$", ylabel = L"\langle \hat{a}^\dagger \hat{a} \rangle")
lines!(ax, tlist, real(exp_ti), label = L"\gamma_0", linestyle = :solid)
lines!(ax, tlist, real(exp_td), label = L"\gamma_1(t) = \gamma_0 e^{-t}", linestyle = :dash)

axislegend(ax, position = :rt)

fig
```

## [QobjEvo fields (attributes)](@id doc-TE:QobjEvo-fields-(attributes))

[`QuantumObjectEvolution`](@ref) as a time-dependent quantum system, as its main functionality creates a [`QuantumObject`](@ref) at a specified time ``t``:

```@example QobjEvo
coef(p, t) = sin(π * t)
Ht = QobjEvo(sigmaz(), coef)

Ht(0.25) # t = 0.25
```

[`QuantumObjectEvolution`](@ref) shares a lot of properties with the [`QuantumObject`](@ref):

```@example QobjEvo
Ht.data
```

```@example QobjEvo
Ht.type
```

```@example QobjEvo
Ht.dims
```

The properties of a [`QuantumObjectEvolution`](@ref) can also be retrieved using several functions with inputting [`QuantumObjectEvolution`](@ref):

```@example QobjEvo
size(Ht)
```

```@example QobjEvo
shape(Ht) # synonym of size(Ht)
```

```@example QobjEvo
length(Ht)
```

```@example QobjEvo
eltype(Ht) # element type
```

```@example QobjEvo
println(isket(Ht)) # ket
println(isbra(Ht)) # bra
println(isoper(Ht)) # operator
println(isoperket(Ht)) # operator-ket
println(isoperbra(Ht)) # operator-bra
println(issuper(Ht)) # super operator
println(isconstant(Ht)) # time-independent or not
println(ishermitian(Ht)) # Hermitian
println(isherm(Ht)) # synonym of ishermitian(Ht)
println(issymmetric(Ht)) # symmetric
println(isposdef(Ht)) # positive definite (and Hermitian)
```

[`QobjEvo`](@ref) follow the same mathematical operations rules as [`Qobj`](@ref). They can be added, subtracted and multiplied with scalar, [`Qobj`](@ref) and [`QobjEvo`](@ref). They also support [`adjoint`](@ref), [`transpose`](@ref), and [`conj`](@ref) methods, and can be used for [`SuperOperator`](@ref) transformation:

```@example QobjEvo
coef(p, t) = sin(π * t)
Ht = QobjEvo(sigmaz(), coef)

coef2(p, t) = exp(-t)
c_op = QobjEvo(destroy(2), coef2)

L1 = -1im * (spre(Ht) - spost(Ht'))
L1 += lindblad_dissipator(c_op)
```

Or equivalently:
```@example QobjEvo
L2 = liouvillian(Ht, [c_op])
```

```@example QobjEvo
t = rand()
L1(t) == L2(t)
```

!!! note "Optimization for superoperator transformation"
    Although the value of `L1` and `L2` here is equivalent, one can observe that the structure of `L2.data` is much simpler than `L1.data`, which means that it will be more efficient to solve the time evolution using `L2` instead of `L1`. Therefore, we recommend to use [`liouvillian`](@ref) or [`lindblad_dissipator`](@ref) to generate time-dependent [`SuperOperator`](@ref) because these functions have been optimized.

## [Using parameters](@id doc-TE:Using-parameters)

Until now, the coefficients were only functions of time `t`. In the definition of ``f_1(t) = A \exp \left[ -(t / \sigma)^2 \right]`` in the previous example, the driving amplitude ``A`` and width of the gaussian driving term ``\sigma`` were hardcoded with their numerical values. This is fine for problems that are specialized, or that we only want to run once. However, in many cases, we would like to study the same problem with a range of parameters and don't have to worry about manually changing the values on each run. `QuantumToolbox.jl` allows you to accomplish this by adding extra parameters `p` to coefficient functions that make the [`QobjEvo`](@ref). For instance, instead of explicitly writing `9` for ``A`` and `5` for ``\sigma``, we can either specify them with `p` as a `Vector` or `NamedTuple`:

```@example QobjEvo
# specify p as a Vector
f1_v(p, t) = p[1] * exp(-(t / p[2])^2)

H_t_v = QobjEvo(sigmaz(), f1_v)

p_v = [9, 5] # 1st element represents A; 2nd element represents σ
t = 1
H_t_v(p_v, t)
```

```@example QobjEvo
# specify p as a NamedTuple
f1_n(p, t) = p.A * exp(-(t / p.σ)^2)

H_t_n = QobjEvo(sigmaz(), f1_n)

p_n = (A = 9, σ = 5)
t = 1
H_t_n(p_n, t)
```

```@example QobjEvo
t = rand()
H_t_v(p_v, t) == H_t_n(p_n, t)
```

!!! note "Custom structure of parameter"
    For more advanced usage, any custom `struct` of parameter `p` can be used.

When solving time evolutions, the solvers take an single keyword argument `params`, which will be directly passed to input `p` of the coefficient functions to build the time dependent Hamiltonian and collapse operators. For example, with `p::Vector`:

```@example QobjEvo
f1(p, t) = p[1] * cos(p[2] * t)
f2(p, t) = p[3] * sin(p[4] * t)
γ(p, t)  = sqrt(p[5] * exp(-p[6] * t))
p_total = [0.1, 0.2, 0.3, 0.4, 0.5, 0.6]

H_t = sigmaz() + QobjEvo(sigmax(), f1) + QobjEvo(sigmay(), f2)

c_ops = [
    QobjEvo(destroy(2), γ)
]

e_ops = [sigmaz()]

ψ0 = basis(2, 0)
tlist = LinRange(0, 10, 20)
sol1 = mesolve(H_t, ψ0, tlist, c_ops, params = p_total, e_ops = e_ops; progress_bar = Val(false))
```

Similarly, with `p::NamedTuple`:

```@example QobjEvo
f1(p, t) = p.A1 * cos(p.ω1 * t)
f2(p, t) = p.A2 * sin(p.ω2 * t)
γ(p, t)  = sqrt(p.A3 * exp(-p.γ0 * t))
p_total = (
    A1 = 0.1,
    ω1 = 0.2,
    A2 = 0.3,
    ω2 = 0.4,
    A3 = 0.5,
    γ0 = 0.6
)

H_t = sigmaz() + QobjEvo(sigmax(), f1) + QobjEvo(sigmay(), f2)

c_ops = [
    QobjEvo(destroy(2), γ)
]

e_ops = [sigmaz()]

ψ0 = basis(2, 0)
tlist = LinRange(0, 10, 20)
sol2 = mesolve(H_t, ψ0, tlist, c_ops, params = p_total, e_ops = e_ops; progress_bar = Val(false))
```

```@example QobjEvo
sol1.expect == sol2.expect
```

# [Solving for Steady-State Solutions](@id doc:Solving-for-Steady-State-Solutions)

## Introduction

For time-independent open quantum systems with decay rates larger than the corresponding excitation rates, the system will tend toward a steady state as ``t\rightarrow\infty`` that satisfies the equation

```math
\frac{d\hat{\rho}_{\textrm{ss}}}{dt} = \mathcal{L}\hat{\rho}_{\textrm{ss}}=0.
```

Although the requirement for time-independence seems quite restrictive, one can often employ a transformation to the interaction picture that yields a time-independent Hamiltonian. For many these systems, solving for the asymptotic density matrix ``\hat{\rho}_{\textrm{ss}}`` can be achieved using direct or iterative solution methods faster than using master equation or Monte-Carlo simulations. Although the steady state equation has a simple mathematical form, the properties of the Liouvillian operator are such that the solutions to this equation are anything but straightforward to find.

## Steady State solvers in `QuantumToolbox.jl`
In `QuantumToolbox.jl`, the steady-state solution for a system Hamiltonian or Liouvillian is given by [`steadystate`](@ref). This function implements a number of different methods for finding the steady state, each with their own pros and cons, where the method used can be chosen using the `solver` keyword argument.

| **Solver** | **Description** |
|:-----------|:----------------|
| [`SteadyStateDirectSolver()`](@ref SteadyStateDirectSolver) | Directly solve ``Ax=b`` using the standard method given in `Julia` `LinearAlgebra` |
| [`SteadyStateLinearSolver()`](@ref SteadyStateLinearSolver) | Directly solve ``Ax=b`` using the algorithms given in [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/) |
| [`SteadyStateEigenSolver()`](@ref SteadyStateEigenSolver) | Find the zero (or lowest) eigenvalue of ``\mathcal{L}`` using [`eigsolve`](@ref) |
| [`SteadyStateODESolver()`](@ref SteadyStateODESolver) | Solving time evolution with algorithms given in [`DifferentialEquations.jl` (ODE Solvers)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/) |

## Using Steady State solvers

The function [`steadystate`](@ref) can take either a Hamiltonian and a list of collapse operators `c_ops` as input, generating internally the corresponding Liouvillian ``\mathcal{L}`` in Lindblad form, or alternatively, a Liouvillian ``\mathcal{L}`` passed by the user.

```julia
ρ_ss = steadystate(H)        # Hamiltonian
ρ_ss = steadystate(H, c_ops) # Hamiltonian and collapse operators
ρ_ss = steadystate(L)        # Liouvillian
```
where `H` is a quantum object representing the system Hamiltonian ([`Operator`](@ref)) or Liouvillian ([`SuperOperator`](@ref)), and `c_ops` (defaults to `nothing`) can be a list of [`QuantumObject`](@ref) for the system collapse operators. The output, labelled as `ρ_ss`, is the steady-state solution for the systems. If no other keywords are passed to the function, the default solver [`SteadyStateDirectSolver()`](@ref SteadyStateDirectSolver) is used.

To change a solver, use the keyword argument `solver`, for example:

```julia
ρ_ss = steadystate(H, c_ops; solver = SteadyStateLinearSolver())
```

Although it is not obvious, the [`SteadyStateDirectSolver()`](@ref SteadyStateDirectSolver) and [`SteadyStateEigenSolver()`](@ref SteadyStateEigenSolver) methods all use an LU decomposition internally and thus can have a large memory overhead. In contrast, for [`SteadyStateLinearSolver()`](@ref SteadyStateLinearSolver), iterative algorithms provided by [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/solvers/solvers/), such as `KrylovJL_GMRES()` and `KrylovJL_BICGSTAB()`, do not factor the matrix and thus take less memory than the LU methods and allow, in principle, for extremely large system sizes. The downside is that these methods can take much longer than the direct method as the condition number of the Liouvillian matrix is large, indicating that these iterative methods require a large number of iterations for convergence. 

To overcome this, preconditioners can be defined directly in the solver algorithm using LinearSolve's precs parameter. For example:
```julia
SteadyStateLinearSolver(alg = KrylovJL_GMRES(; precs = (A, p) -> (ilu(A, τ = 0.01), I)))
```

The use of a preconditioner can actually make these iterative methods faster than the other solution methods. The problem with precondioning is that it is only well defined for Hermitian matrices. Since the Liouvillian is non-Hermitian, the ability to find a good preconditioner is not guaranteed. Moreover, if a preconditioner is found, it is not guaranteed to have a good condition number. 

Furthermore, `QuantiumToolbox` can take advantage of the Intel (Pardiso) LU solver in the Intel Math Kernel library (Intel-MKL) by using [`LinearSolve.jl`](https://docs.sciml.ai/LinearSolve/stable/) and either [`Pardiso.jl`](https://github.com/JuliaSparse/Pardiso.jl) or [`MKL_jll.jl`](https://github.com/JuliaBinaryWrappers/MKL_jll.jl):

```julia
using QuantumToolbox
using LinearSolve # must be loaded

using Pardiso
solver = SteadyStateLinearSolver(alg = MKLPardisoFactorize())

using MKL_jll
solver = SteadyStateLinearSolver(alg = MKLLUFactorization())
```

See [`LinearSolve.jl` Solvers](https://docs.sciml.ai/LinearSolve/stable/solvers/solvers/) for more details.

## Example: Harmonic oscillator in thermal bath

Here, we demonstrate [`steadystate`](@ref) by using the example with the harmonic oscillator in thermal bath from the previous section ([Lindblad Master Equation Solver](@ref doc-TE:Lindblad-Master-Equation-Solver)).

```@example steady_state_example
using QuantumToolbox
using CairoMakie
CairoMakie.enable_only_mime!(MIME"image/svg+xml"())

# Define parameters
N = 20  # number of basis states to consider
a = destroy(N)
H = a' * a
ψ0 = basis(N, 10)  # initial state
κ = 0.1  # coupling to oscillator
n_th = 2 # temperature with average of 2 excitations

# collapse operators 
c_ops = [
    sqrt(κ * (n_th + 1)) * a, # emission
    sqrt(κ *  n_th     ) * a' # absorption
]

# find steady-state solution
ρ_ss = steadystate(H, c_ops)

# find expectation value for particle number in steady state
e_ops = [a' * a]
exp_ss = real(expect(e_ops[1], ρ_ss))

tlist = LinRange(0, 50, 100)

# monte-carlo
sol_mc = mcsolve(H, ψ0, tlist, c_ops, e_ops=e_ops, ntraj=100, progress_bar=false)
exp_mc = real(sol_mc.expect[1, :])

# master eq.
sol_me = mesolve(H, ψ0, tlist, c_ops, e_ops=e_ops, progress_bar=false)
exp_me = real(sol_me.expect[1, :])

# plot by CairoMakie.jl
fig = Figure(size = (500, 350))
ax = Axis(fig[1, 1], 
    title = L"Decay of Fock state $|10\rangle$ in a thermal environment with $\langle n\rangle=2$",
    xlabel = "Time", 
    ylabel = "Number of excitations",
)
lines!(ax, tlist, exp_mc, label = "Monte-Carlo", linewidth = 2, color = :blue)
lines!(ax, tlist, exp_me, label = "Master Equation", linewidth = 2, color = :orange, linestyle = :dash)
lines!(ax, tlist, exp_ss .* ones(length(tlist)), label = "Steady State", linewidth = 2, color = :red)
axislegend(ax, position = :rt)

fig
```

## Calculate steady state for periodically driven systems

See the docstring of [`steadystate_fourier`](@ref) for more details.

# [The Importance of Type-Stability](@id doc:Type-Stability)

You are here because you have probably heard about the excellent performance of Julia compared to other common programming languages like Python. One of the reasons is the Just-In-Time (JIT) compiler of Julia, which is able to generate highly optimized machine code. However, the JIT compiler can only do its job if the code type can be inferred. You can also read the [Performance Tips](https://docs.julialang.org/en/v1/manual/performance-tips/) section in Julia's documentation for more details. Here, we try to explain it briefly, with a focus on the `QuantumToolbox.jl` package.

!!! note
    This page is not a tutorial on `QuantumToolbox.jl`, but rather a general guide to writing Julia code for simulating quantum systems efficiently. If you don't care about the performance of your code, you can skip this page.

## Basics of type stability

Let's have a look at the following example:

```@setup type-stability
using InteractiveUtils
using QuantumToolbox
```

```@example type-stability
function foo(x)
    if x > 0
        return 1
    else
        return -1.0
    end
end
nothing # hide
```

The function `foo` apparently seems to be innocent. It takes an argument `x` and returns either `1` or `-1.0` depending on the sign of `x`. However, the return type of `foo` is not clear. If `x` is positive, the return type is `Int`, otherwise it is `Float64`. This is a problem for the JIT compiler, because it has to determine the return type of `foo` at runtime. This is called type instability (even though it is a weak form) and may lead to a significant performance penalty. To avoid this, always aim for type-stable code. This means that the return type of a function should be clear from the types of its arguments. We can check the inferred return type of `foo` using the `@code_warntype` macro:

```@example type-stability
@code_warntype foo(1)
```

The key point is to ensure the return type of a function is clear from the types of its arguments. There are several ways to achieve this, and the best approach depends on the specific problem. For example, one can use the same return type:

```@example type-stability
function foo(x)
    if x > 0
        return 1.0
    else
        return -1.0
    end
end
nothing # hide
```

Or you can ensure the return type matches the type of the argument:

```@example type-stability
function foo(x::T) where T
    if x > 0
        return T(1)
    else
        return -T(1)
    end
end
nothing # hide
```

The latter example is very important because it takes advantage of Julia's multiple dispatch, which is one of the most powerful features of the language. Depending on the type `T` of the argument `x`, the Julia compiler generates a specialized version of `foo` that is optimized for this type. If the input type is an `Int64`, the return type is `Int64`, if `x` is a `Float64`, the return type is `Float64`, and so on.

```@example type-stability
@show foo(1)
@show foo(-4.4)
@show foo(1//2)
nothing # hide
```

!!! note
    If you didn't know how to make this function type-stable, it is probably a good idea to read the official Julia documentation, and in particular its [Performance Tips](https://docs.julialang.org/en/v1/manual/performance-tips/) section.

## Global variables

Another source of type instability is the use of global variables. In general, it is a good idea to declare global variables as `const` to ensure their type is fixed for the entire program. For example, consider the following function that internally takes a global variable `y`:

```@example type-stability
y = 2.4

function bar(x)
    res = zero(x) # this returns the zero of the same type of x
    for i in 1:1000
        res += y * x
    end
    return res
end
nothing # hide
```

The Julia compiler cannot infer the type of `res` because it depends on the type of `y`, which is a global variable that can change at any time of the program. We can check it using the `@code_warntype` macro:

```@example type-stability
@code_warntype bar(3.2)
```

While in the last example of the `foo` function we got a weak form of type instability, returning a `Union{Int, Float64}`, in this case the return type of `bar` is `Any`, meaning that the compiler doesn't know anything about the return type. Thus, this function has nothing different from a dynamically typed language like Python. We can benchmark the performance of `bar` using the [BenchmarkTools.jl](https://github.com/JuliaCI/BenchmarkTools.jl) package:

```@example type-stability
using BenchmarkTools

@benchmark bar(3.2)
```

Here we see a lot of memory allocations and low performances in general. To fix this, we can declare a `const` (constant) variable instead:

```@example type-stability
const z = 2.4

function bar(x)
    res = zero(x) # this returns the zero of the same type of x
    for i in 1:1000
        res += z * x
    end
    return res
end

@benchmark bar(3.2)
```

And we can see that the performance has improved significantly. Hence, we highly recommend using global variables as `const`, but only when truly necessary. This choice is problem-dependent, but in the case of `QuantumToolbox.jl`, this can be applied for example in the case of defining the Hilbert space dimensions, static parameters, or the system operators.

Although it is always a good practice to avoid such kind of type instabilities, in the actual implementation of `QuantumToolbox.jl` (where we mainly deal with linear algebra operations), the compiler may perform only a few runtime dispatches, and the performance penalty may be negligible compared to the heavy linear algebra operations.

## Vectors vs Tuples vs StaticArrays

Julia has many ways to represent arrays or lists of general objects. The most common are `Vector`s and `Tuple`s. The former is a dynamic array that can change its size at runtime, while the latter is a fixed-size array that is immutable, and where the type of each element is already known at compile time. For example:

```@example type-stability
v1 = [1, 2, 3] # Vector of Int64
v2 = [1.0 + 2.0im, 3.0 + 4.0im] # Vector of ComplexF64
v3 = [1, "ciao", 3.0] # Vector of Any

t1 = (1, 2, 3) # Tuple of {Int64, Int64, Int64}
t2 = (1.0 + 2.0im, 3.0 + 4.0im) # Tuple of {ComplexF64, ComplexF64}
t3 = (1, "ciao", 3.0) # Tuple of {Int64, String, Float64}

@show typeof(v1)
@show typeof(v2)
@show typeof(v3)
@show typeof(t1)
@show typeof(t2)
@show typeof(t3)
nothing # hide
```

Thus, we highly recommend using `Vector` only when we are sure that it contains elements of the same type, and only when we don't need to know its size at compile time. On the other hand, `Tuple`s are less flexible but more efficient in terms of performance. A third option is to use the `SVector` type from the [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) package. This is similar to `Vector`, where the elements should have the same type, but it is fixed-size and immutable. One may ask when it is necessary to know the array size at compile time. A practical example is the case of [`ptrace`](@ref), where it internally reshapes the quantum state into a tensor whose dimensions depend on the number of subsystems. We will see this in more detail in the next section.

## The `QuantumObject` internal structure

Before making a practical example, let's see the internal structure of the [`QuantumObject`](@ref) type. As an example, we consider the case of three qubits, and we study the internal structure of the ``\hat{\sigma}_x^{(2)}`` operator:

```@example type-stability
σx_2 = tensor(qeye(2), sigmax(), qeye(2))
```

and its type is

```@example type-stability
obj_type = typeof(σx_2)
```

This is exactly what the Julia compiler sees: it is a [`QuantumObject`](@ref), composed by a field of type `SparseMatrixCSC{ComplexF64, Int64}` (i.e., the 8x8 matrix containing the Pauli matrix, tensored with the identity matrices of the other two qubits). Then, we can also see that it is a [`Operator`](@ref), with `3` subsystems in total. Hence, just looking at the type of the object, the compiler has all the information it needs to generate a specialized version of the functions.

Let's see more in the details all the internal fields of the [`QuantumObject`](@ref) type:

```@example type-stability
fieldnames(obj_type)
```

```@example type-stability
σx_2.data
```

```@example type-stability
σx_2.type
```


```@example type-stability
σx_2.dims
```

The `dims` field contains the dimensions of the subsystems (in this case, three subsystems with dimension `2` each). We can see that the type of `dims` is `SVector` instead of `Vector`. As we mentioned before, this is very useful in functions like [`ptrace`](@ref). Let's do a simple example of reshaping an operator internally generated from some `dims` input:

```@example type-stability
function reshape_operator_data(dims)
    op = Qobj(randn(get_size(dims)...), type=Operator(), dims=dims)
    op_dims = op.dims
    op_data = op.data
    return reshape(op_data, vcat(op_dims...)...)
end

typeof(reshape_operator_data([2, 2, 2]))
```

Which returns a tensor of size `2x2x2x2x2x2`. Let's check the `@code_warntype`:

```@example type-stability
@code_warntype reshape_operator_data([2, 2, 2])
```

We got a `Any` type, because the compiler doesn't know the size of the `dims` vector. We can fix this by using a `Tuple` (or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl)):

```@example type-stability
typeof(reshape_operator_data((2, 2, 2)))
```

```@example type-stability
@code_warntype reshape_operator_data((2, 2, 2))
```

Finally, let's look at the benchmarks

```@example type-stability
@benchmark reshape_operator_data($[2, 2, 2])
```

```@example type-stability
@benchmark reshape_operator_data($((2, 2, 2)))
```

Which is an innocuous but huge difference in terms of performance. Hence, we highly recommend using `Tuple` or `SVector` from [StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) when defining the dimensions of a user-defined [`QuantumObject`](@ref).

## The use of `Val` in some `QuantumToolbox.jl` functions

In some functions of `QuantumToolbox.jl`, you may find the use of the [`Val`](https://docs.julialang.org/en/v1/base/base/#Base.Val) type in the arguments. This is a trick to pass a value at compile time, and it is very useful to avoid type instabilities. Let's make a very simple example, where we want to create a Fock state ``|j\rangle`` of a given dimension `N`, and we give the possibility to create it as a sparse or dense vector. At first, we can write the function without using `Val`:

```@example type-stability
using SparseArrays

function my_fock(N::Int, j::Int = 0; sparse::Bool = false)
    if sparse
        array = sparsevec([j + 1], [1.0 + 0im], N)
    else
        array = zeros(ComplexF64, N)
        array[j+1] = 1
    end
    return QuantumObject(array; type = Ket())
end
@show my_fock(2, 1)
@show my_fock(2, 1; sparse = true)
nothing # hide
```

But it is immediately clear that the return type of this function is not clear, because it depends on the value of the `sparse` argument. We can check it using the `@code_warntype` macro:

```@example type-stability
@code_warntype my_fock(2, 1)
```

```@example type-stability
@code_warntype my_fock(2, 1; sparse = true)
```

We can fix this by using the `Val` type, where we enable the multiple dispatch of the function:

```@example type-stability
getVal(::Val{N}) where N = N
function my_fock_good(N::Int, j::Int = 0; sparse::Val = Val(false))
    if getVal(sparse)
        array = zeros(ComplexF64, N)
        array[j+1] = 1
    else
        array = sparsevec([j + 1], [1.0 + 0im], N)
    end
    return QuantumObject(array; type = Ket())
end
@show my_fock_good(2, 1)
@show my_fock_good(2, 1; sparse = Val(true))
nothing # hide
```

And now the return type of the function is clear:

```@example type-stability
@code_warntype my_fock_good(2, 1)
```

```@example type-stability
@code_warntype my_fock_good(2, 1; sparse = Val(true))
```

This is exactly how the current [`fock`](@ref) function is implemented in `QuantumToolbox.jl`. There are many other functions that support this feature, and we highly recommend using it when necessary.

## Conclusions

In this page, we have seen the importance of type stability in Julia, and how to write efficient code in the context of `QuantumToolbox.jl`. We have seen that the internal structure of the [`QuantumObject`](@ref) type is already optimized for the compiler, and we have seen some practical examples of how to write efficient code. We have seen that the use of `Vector` should be avoided when the elements don't have the same type, and that the use of `Tuple` or `SVector` is highly recommended when the size of the array is known at compile time. Finally, we have seen the use of `Val` to pass values at compile time, to avoid type instabilities in some functions.
```

# [Hierarchical Equations of Motion](@id doc:Hierarchical-Equations-of-Motion)

The hierarchical equations of motion (HEOM) approach was originally developed by [Tanimura1989](@citet) in the context of physical chemistry to "exactly" solve a quantum system (labeled as ``\textrm{s}``) in contact with a bosonic environment, encapsulated in the following total Hamiltonian:

```math
\hat{H}_{\textrm{total}} = \hat{H}_{\textrm{s}} + \sum_k \omega_k \hat{b}^\dagger_k \hat{b}_k + \hat{V}_{\textrm{s}} \sum_k g_k \left(\hat{b}_k + \hat{b}^\dagger_k\right),
```

where ``\hat{b}_k`` (``\hat{b}^\dagger_k``) is the bosonic annihilation (creation) operator associated to the ``k``th mode (with frequency ``\omega_k``), ``\hat{V}_{\textrm{s}}`` refer to the coupling operator acting on the system's degree of freedom, and ``g_k`` are the coupling strengths.

As in other solutions to this problem, the properties of the bath are encapsulated by its temperature and its spectral density,

```math
J(\omega) = 2 \pi \sum_k g^2_k \delta(\omega - \omega_k).
```

In the HEOM approach, for bosonic baths, one typically chooses a Drude-Lorentz spectral density:

```math
J_{\textrm{DL}}(\omega) = \frac{4 \Delta W \omega}{\omega^2 + W^2},
```

or an under-damped Brownian motion spectral density,

```math
J_{\textrm{U}}(\omega)=\frac{2 \Delta^2 W \omega}{(\omega^2 - \omega_0^2)^2 + \omega^2 W^2}.
```

Here, ``\Delta`` represents the coupling strength between the system and the bosonic bath with band-width ``W`` and resonance frequency ``\omega_0``.

We introduce an efficient `Julia` framework for HEOM approach called [`HierarchicalEOM.jl`](https://github.com/qutip/HierarchicalEOM.jl). This package is built upon `QuantumToolbox.jl` and provides a user-friendly and efficient tool to simulate complex open quantum systems based on HEOM approach. For a detailed explanation of this package, we recommend to read its [documentation](https://qutip.org/HierarchicalEOM.jl/) and also the article [Huang2023](@citet).

Given the spectral density, the HEOM approach requires a decomposition of the bath correlation functions in terms of exponentials. In the [documentation of `HierarchicalEOM.jl`](https://qutip.org/HierarchicalEOM.jl/), we not only describe how this is done for both bosonic and fermionic environments with code examples, but also describe how to solve the time evolution (dynamics), steady-states, and spectra based on HEOM approach.
